// miniprogram/addPages/addTip/index.js
//引用文件
const ability = require('../../utils/classDef/ability')
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "添加设备"
      }
    },
    selected: false,
    leftTabs: [{
      name: '照明',
      key: "light"
    }, {
      name: '面板',
      key: "panel"
    }, {
      name: '窗帘',
      key: "curtain"
    }, {
      name: '传感器',
      key: "sensor"
    },
    // {
    //   name: '灯扇',
    //   key: "fanLight"
    // }, 
    {
      name: '网关(Wi-Fi)',
      key: "gateway"
    },
    // {
    //   name: '中央空调网关',
    //   key: "aircondition"
    // }, 
    {
      name: '通用',
      key: "common"
    }],
    selectTab: 0, // 默认选择
    contents: {}, // 显示的内容
    alreadyStorage: false // 是否已经存在storage
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 默认选中的
    // this.setDataByIndex(this.data.selectTab);
    this.initStorageInfo();
  },
  initStorageInfo () {
    let _str = this.getStorageInfo();
    if (!_str) {
      this.data.alreadyStorage = false;
      return;
    }
    this.data.alreadyStorage = true;
    // 设置选中
    this.setSelected(true);
  },
  getStorageInfo () {
    return app.getStorageByKey("addTip") || '';
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 默认选中的
    this.setDataByIndex(this.data.selectTab);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 已了解按钮点击
  readClick () {
    this.setSelected(!this.data.selected);
  },
  setSelected (value) {
    this.data.selected = value || false;
    this.setData({
      selected: this.data.selected
    })
  },

  // 添加设备按钮点击
  startProb () {
    let _isSelected = this.data.selected;
    // 未选中则不进入下个页面
    if (!_isSelected) {
      return;
    }
    // 是否需要缓存
    if (!this.data.alreadyStorage) {
      app.setBizStorage("addTip", true);
    }
    // 当前选择的第几个
    let _index = this.data.selectTab;
    let {name} = this.data.leftTabs[_index] || {};
    console.log("startProb name, _index = ", name, _index);
    // 跳转网关设置页面
    if ((name || "").indexOf("网关") >= 0) {
      return ability.redirectTo("/addPages/gateway/index")
    }
    // 跳转页面
    ability.navigateTo("/addPages/bleIndex/index")
  },

  // 内容切换
  switchTab (e) {
    let {index} = e.currentTarget.dataset;

    this.setDataByIndex(index);
  },

  setDataByIndex (index) {
    console.log("index = ", index);
    let _index = index || 0;
    this.data.selectTab = _index;
    this.data.contents = this.getContentsByIndex(_index);
    this.setData({
      selectTab: this.data.selectTab,
      contents: this.data.contents
    })
  },
  
  // 根据选择的tab显示对应的文字
  getContentsByIndex (index) {
    let _index = index || 0;
    let {key} = this.data.leftTabs[_index] || {};
    if (!key) {
      return {};
    }
    if (key == "light") {
      return {
        tip: '请使用物理开关进行，断电-通电，即进入蓝牙配置模式。',
        img: '../../static/img/addDevice/addTip/light.png',
        imgMargin: "marginT120",
        imgClass: "lightImg"
      };
    } else if (key == "panel") {
      return {
        tip: '组合按键#1&#4或者#2&#3，长按4s，进入到设备配置模式，所有指示灯常亮，即进入蓝牙配置模式。（请距离设备5米以内）',
        img: '../../static/img/addDevice/addTip/panel.png',
        imgMargin: "marginT80",
        imgClass: "panelImg"
      };
    } else if (key == "curtain") {
      return {
        tip: '请长按窗帘电机顶端的红色按钮10秒，直到电机转动，即进入蓝牙配置模式',
        img: '../../static/img/addDevice/addTip/curtain.png',
        imgMargin: "marginT60",
        imgClass: "curtainImg"
      };
    } else if (key == "sensor") {
      return {
        // tip: '请短按传感器复位键一下后松开，蓝色指示灯长亮。 温湿度传感器设备请将电池重新上电即进入配网状态，状态持续2分钟 （复位方式请以说明书为准）',
        tip: ['请根据说明书提示，长按复位按键5秒后松开，蓝色指示灯快闪。', '温湿度传感器需将电池重新上电，即进入配网状态，状态持续2分钟。'],
        img: '../../static/img/addDevice/addTip/sensor.png',
        imgMargin: "marginT80",
        imgClass: "sensorImg"
      };
    } else if (key == "fanLight") {
      return {
        tip: '请使用物理开关进行，断电-通电10秒，即进入蓝牙配置模式。',
        img: '../../static/img/addDevice/addTip/light.png',
        imgMargin: "marginT120",
        imgClass: "lightImg"
      };
    } else if (key == "gateway") {
      return {
        tips: ['1、请给网关插上电源，长按网关复位键5秒，直到指示蓝灯闪烁。', '2、手机连接同一路由器的WiFi'],
        img: '../../static/img/addDevice/addTip/gateway.png',
        imgMargin: "marginT120",
        imgClass: "gatewayImg"
      };
    } else if (key == "aircondition") {
      return {
        tips: ['1、请给空调网关插上电源，长按网关复位键5秒，直到指示蓝灯闪烁。', '2、手机连接同一路由器的WiFi'],
        img: '../../static/img/addDevice/addTip/curtain.png',
        imgMargin: "marginT120",
        imgClass: "gatewayImg"
      };
    } else {
      return {
        type: "list",
        title: "蓝牙设备通用步骤：",
        tips: ['1.物理开关类设备进行，断电-通电。', '2.电池类设备进行，拔取电池-安装电池。', '3.插座类设备进行，拔取插座-插座上电。', '即进入蓝牙配置模式。'],
        imgs: [{
          img: '../../static/img/addDevice/addTip/light.png',
          name: '物理类开关',
          imgClass: 'light-1',
          imgMargin: "marginT50"
        }, {
          img: '../../static/img/addDevice/addTip/light-2.png',
          name: '电池类',
          imgClass: 'light-2',
          imgMargin: "marginT40"
        }, {
          img: '../../static/img/addDevice/addTip/light-3.png',
          name: '插座类',
          imgClass: 'light-3',
          imgMargin: "marginT40"
        }],
        imgMargin: ''
        // imgClass: 'lightImg'
      };
    }
  }
})
