// miniprogram/addPages/bleIndex/index.js
import bizUtil from "../../utils/bizUtil"
import ability from '../../utils/classDef/ability'
import GROUPS from '../../static/js/jsConfig/groups';
// 获取应用实例
var app = getApp()
Page({
  data: {
    // 渲染的列表数据
    scanResult: {},
    dataList: [],
    //是否显示loadmore
    loadMoreShow: 0,
    //懒加载状态，用于异步不遮罩查询列表时，多次滑到底部
    isBottomLoading: false,

    //是否显示遮罩层
    isSearchViewShow: false,
    // 顶部条
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "搜索设备",
        type: ''
      },
      right: {
        text: ''
      }
    },
    receiveLen: 0,

    ctrls: {}, // 设备控制的状态
    bleUnavailable: false,
    changeInfoIdx: -1, // 选中的更改名称的设备下标 编辑的设备，如果有下次进入onshow需要刷新（可能房间修改）
    allDevs: [], // 所有设备集合

    isGateway: false, // 是否网关配网
    gatewayExist: false, // 是否存在网关设备

    gatewayTimer: null, // 网关

    isFloor: false, // 是否多楼层
    roomJson: {},

    maxCount: 1000, // 设备最大数量
    findDs: [], // 发现设备d集合
    probes: {}, // 设备配网成功集合
    addrs: [], // 设备配网短地址集合

    editIhg: false, // 是否进入ihg配网，防止清空devInfo
    // editIndex: -1, // 编辑的设备，如果有下次进入onshow需要刷新（可能房间修改）

    filterT: [43500], // 43756  43500 配网类型，暂时转成一个t

    ctrlTimer: null, // 控制加个定时器用于提高成功率
    ctrlCount: 3, // 每次开关发2次，从0开始，用于提高成功率
    ctrledD: "", // 控制设备的d
  },
  onLoad(option) {

    let {from} = option || {};
    this.from = from;

    // 判断是否配置网关还是空调
    if (this.isAuxDemo()) {
      this.data.filterT = [43756, 20010, 20933];
    } else {
      this.data.filterT = [43500];
    }

    // 初始化房间信息
    this.initRooms();
    // 查看是否有网关设备
    this.data.gatewayExist = bizUtil.getGatewayInfo(app.globalData.devs);
    // 判断是否网关配网
    this.setGatewayData(option.gateway == 1);
    // 初始化所有设备
    let _array = this.getAllDeviceArray(app.globalData.devs);
    this.data.allDevs = _array;

    // 把当前存在的设备id记住
    this.isGatewayConfig = this.isGatewayConfigs(this.data.filterT);
    // console.log("onLoad this.isGatewayConfig = ", this.isGatewayConfig);
    // if (!this.isGatewayConfig && this.data.isGateway) {
    //   return;
    // }
    this.data.scanResult = this.initExistDevs(_array);
    console.log("onLoad this.data.scanResult = ", this.data.scanResult, app.globalData.devs);
  },
  // 是否aux demo
  isAuxDemo () {
    return app.globalData?.companyInfo?.namespace?.indexOf("aux") >= 0
  },
  // 是否网关配网
  isGatewayConfigs (array) {
    if (!array || array.length == 0) {
      return true;
    }
    return bizUtil.getDevTypeStr(array[0]) == "gateway";
  },
  // 初始化房间
  initRooms () {
    
    // 所有设备
    let _allDevs = app.globalData.devs || {};
    // 当前楼层
    let _floor = app.globalData.familyInfo?.floor || 0;

    // 所有房间数据
    let {roomJson} = bizUtil.getRoomsByDevs(_allDevs);
    this.data.isFloor = (_floor >= 0) && (!!_allDevs[bizUtil.getRoomIdByFloor(_floor)]);
    
    // 左侧返回按钮
    this.data.navObj.left.hander = () => {
      this.goManage();
    };

    this.data.roomJson = roomJson;
    this.setData({
      roomJson: this.data.roomJson,
      isFloor: this.data.isFloor,
      navObj: this.data.navObj
    })
  },
  setGatewayData (value) {
    // 判断是否网关配网
    this.data.isGateway = value || false;
    this.setData({
      isGateway: this.data.isGateway
    })
  },
  initMultip () {
    // 屏幕的宽度 获取px与rpx之间的比列 
    return app.globalData.customPageSize.multip || 2;
  },
  getAllDeviceArray (devs) {
    return bizUtil.getAllDevsFilter(devs);
    // console.log("initAllDevs devs = ", devs);
    // let _result = [];
    // let _devs = devs || {};
    // for (let key in _devs) {
    //   let _item = _devs[key] || {};
    //   _result = _result.concat(_item.devs || []);
    // }
    // console.log("initAllDevs _result = ", _result);
    // return _result;
  },
  onUnload() {
    // 销毁定时器
    this.destoryTimer();

    // 销毁控制定时器
    this.destoryTimer(this.data.ctrlTimer);

    // 数据处理
    if (!this.data.editIhg) {
      app.globalData.devInfo = undefined;
    }
    // 销毁处理
    this.destoryAll();
    // 停止配网
    this.destorySDKConfig();
  },
  destorySDKConfig () {
    // 停止配网
    !!app.globalData.blsdk && (app.globalData.blsdk.destory());
  },
  destoryAll () {
    console.log("addpage onUnload app.globalData.devs = ", app.globalData.devs);
    // 数据处理
    (!this.data.isGateway) && (bizUtil.addDefaultGroupByDevs(app.globalData.devs));
    // 保存设备信息
    app.saveWhenHide();
  },
  onShow: function () {

    this.setCtrlDeviceD();

    // 如果之前是从ihg进入，则立即更新状态
    if (this.data.editIhg) {
      let _receiveLen = this.getFinishedByList(this.data.dataList);
      this.setData({
        dataList: this.data.dataList,
        receiveLen: _receiveLen
      })
    }
    // 非编辑ihg
    this.data.editIhg = false;
    // 如果有修改名称，则更新数据
    this.updateDevInfo(app.globalData.devInfo, this.data.changeInfoIdx);
    // 初始化下标
    this.data.changeInfoIdx = -1;
    // 开始发现设备
    this.startConfig();

    console.log("onShow dataList = ", this.data.dataList);
  },
  onHide () {
    // 判断是否ihg 后面增加
    if (this.data.editIhg) {
      return;
    }
    // 保存信息
    this.destoryAll();
    // 停止配网 不需要删除原先的配网设备 单纯的停止
    app.globalData.blsdk.stopReceiveAndAdvertising(true);
  },

  setCtrlDeviceD (d) {
    // 初始化无设备控制
    this.setData({
      ctrledD: d || ""
    })
  },
  
  // 更新设备信息
  updateDevInfo (devInfo, oldIndex) {
    if (!devInfo || !devInfo.n || oldIndex < 0) {
      return;
    }
    let _item = this.data.dataList[oldIndex];
    if (!_item) {
      return;
    }
    let _newName = devInfo.n;
    _item.n = _newName;
    let _text = 'dataList['+ oldIndex +']';

    // 根据设备did更新设备名称
    bizUtil.updateDevInfoByDid(app.globalData.devs, devInfo);

    this.setData({
      [_text]: devInfo
    });
  },

  // 存在的设备不刷出来
  initExistDevs (arrays) {
    if (!arrays || arrays.length == 0) {
      return {};
    }
    let _exists = {};
    for (let item of arrays) {
      _exists[item.d] = item.a;
    }
    return _exists;
  },

  //下拉刷新
  refesh() {
    console.log("下拉刷新");
    // 停止下拉刷新
    wx.stopPullDownRefresh();
  },

  scrolltoupper () {
    console.log("scrolltoupper");
  },

  //懒加载
  loadMore () {
  },
  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    })
  },
  hideLoading () {
    ability.hideLoading();
  },
  initGatewayTimer () {
    // 初始化之前先销毁
    this.destoryTimer(this.data.setTimeout);
    // 初始化定时器 90s
    this.data.setTimeout = setTimeout(this.checkFinish, 90000);
  },
  destoryTimer (timer) {
    let _timer = timer || this.data.setTimeout;
    if (!_timer) {
      return;
    }
    clearTimeout(_timer);
    _timer = null;
  },
  checkFinish (msg) {
    // 是否有设备配网成功
    let _receiveLen = this.data.receiveLen;
    if (_receiveLen > 0) {
      // 有配置成功，不弹窗
      return;
    }
    // 停止配网
    this.destorySDKConfig();

    // 如果没有配置到网关
    let _content = msg || "设备配网超时，请重新配置";
    let _title = "配网失败";
    if (this.data.dataList.length == 0) {
      _content = "配置超时";
      _title = "";
    }

    // 提示
    wx.showModal({
      title: _title,
      content: _content,
      showCancel: true,
      confirmText: "去配置",
      confirmColor: "#F78D3F",
      cancelText: "取消",
      cancelColor: '#000000'
    }).then(result => {
      let _confirm = result?.confirm;
      if (_confirm) {
        // 去配置，进入输入WiFi密码页面
        this.goBack(1)
      } else {
        // 进入首页
        this.goBack(2)
      }
    })
  },
  getGatewayFindConfig () {
    let _result = {};
    for (let i in this.data.dataList) {
      let _d = this.data.dataList[i]?.d;
      if (!_d) {
        continue
      }
      _result[_d] = i;
    }
    return _result;
  },
  addGateway (roomJson, didArrays, addrs) {
    // 初始化定时器 90s
    this.initGatewayTimer();
    // 配网数据总集合
    let _allFindGateways = this.getGatewayFindConfig();

    console.log("addGateway _allFindGateways = ", _allFindGateways);

    // 配网类型校验
    let _filterT = this.data.filterT || [43500];

    // 是否需要回包
    app.globalData.wifiInfo.nocallback = true;

    // for test tcl config
    // _filterT = [20604];
    // app.globalData.wifiInfo.needEncrypt = true
    // app.globalData.wifiInfo.host = "chn-31a93883.ibroadlink.com";
    // app.globalData.wifiInfo.hostType = "06";
    // app.globalData.wifiInfo.devInfo = undefined;

    // // for test 
    // let _result = [];
    // for (let i = 1; i < 255; i++) {
    //   _result.push(i);
    // }
    // addrs = _result;

    // // // // for test
    // app.globalData.wifiInfo.allowDuplicatesKey = true; // 是否允许重复上报同一设备
    // app.globalData.wifiInfo.interval = 500;

    // console.log(wx.getBluetoothDevices({success: (res) => {
    //   // console.log("getBluetoothDevices res = ", res);
    //   let _res = res.filter(item => {
    //     if (!item || !item.advertisData) {
    //       return false;
    //     }
    //     return new Uint8Array(item?.advertisData).length == 29
    //   })
    //   console.log("getBluetoothDevices _res = ", _res);
    // }}));

    // 这里需要根据集群配网
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    app.globalData.wifiInfo.host = _groupStr;
    console.log("addGateway _groupStr = ", _groupStr);
    // for test
    // app.globalData.wifiInfo.host = "chn-ee08f451.ibroadlink.com";

    // 43756 43500 20604:tcl
    app.globalData.blsdk.startConfigByFilter(_filterT, (res) => {
      console.error("addGateway res = ", res);
      if (!res) {
        // 销毁定时器
        this.destoryTimer();
        // 主动调用配网失败
        this.checkFinish();
        return;
      }
      // 网关设备没有addrs,因为是WiFi类型的，只通过广播发现，所以不需要短地址
      let finds = res.finds || [];
      // console.log("startConfigByFilter res = ", finds);
      // 是否有错误设备 默认不存在
      let _existWrong = "";
      // 是否需要更新
      for (let idx in finds) {
        let _item = finds[idx] || {};
        let _d = _item.d;
        // 如果已经存在数据，则忽略
        if (this.data.scanResult[_d]) {
          return;
        }
        // 数据是否已经存在的标签
        let _index = _allFindGateways[_d]; // 此处获取的是下标
        // 保存是否完成
        let _complete = (_item.state == 5) || (_item.state == 4 && _item.a == 255); // complete;
        // errorCode图片
        if (_item.errCode) {
          _item.stateMsg = this.gatewayCode(_item.errCode);
          // 停止配网
          _existWrong = _item.stateMsg || _item.errCode;
        } else {
          if (_complete) {
            _item.stateMsg = this.gatewayState(5);
          } else {
            _item.stateMsg = this.gatewayState(_item.state);
          }
        }
        // 已经存在的数据不刷出来
        if (_index >= 0) {
          console.log("addGateway _index = ", _index);
          // 原来的数据
          let {complete, k} = this.data.dataList[_index] || {};
          _item.complete = complete;
          // 由于修改了协议，原先5是下发短地址，4是成功，
          _item.k = _item.k || k;
          if (_item.a != undefined && _item.a <= 0) {
            console.error("above item = ", _item);
            _item.above = true;
          }
          
          // 更新的数据
          this.data.dataList[_index] = _item;
          // 成功个数+1 原先没有成功此次成功才需要
          if ((_complete) && !_item.errCode && !complete) {
            this.dealOKGatewayDevice(roomJson, _item, didArrays);
          }
        } else {
          // 新数据 需要排除网关连上网之后还会一直对外广播的case supportAddr字段用于第一次发现网关就是配网包返回
          if (this.isGatewayConfig && _item.state > 3 && !_firstJson.supportAddr) {
            continue;
          }

          // 这里的判断短地址是否分配完
          if (_item.a != undefined && _item.a <= 0) {
            console.error("above item = ", _item);
            _item.above = true;
          }

          // 加入显示
          this.data.dataList.push(_item);
          // 把数据加入显示
          _allFindGateways[_item.d] = this.data.dataList.length - 1;
        }
      }
      // 更新数据
      if (finds.length > 0) {
        let _finishCount = this.getFinishedByList(this.data.dataList);
        // 加入显示
        this.setData({
          dataList: this.data.dataList,
          receiveLen: _finishCount
        });
      }
      // 如果有错误数据，则提示
      if (!_existWrong) {
        return;
      }
      // 提示信息
      this.toastError(_existWrong);
    }, app.globalData.wifiInfo);
    // 更新上一次的数据
    this.updateCacheForConfig(didArrays, addrs);
  },
  getFinishedByList (array) {
    if (!array || array.length == 0) {
      return 0;
    }
    let _filter = array.filter(item => {
      if (this.data.isGateway) {
        // ihg默认为false
        if ((item.state == 4 && item.a == 255) || (item.state == 5 && item.a < 255)) {
          return true;
        }
        return false;
      } else {
        let _isIhg = bizUtil.isIhg(item?.t);
        if (_isIhg) {
          return !!item?.wd;
        }
        return item.complete;
      }
    })
    return _filter.length;
  },
  updateCacheForConfig (didArray, addrArray) {
    console.log("updateCacheForConfig findDs = ", JSON.stringify(this.data.findDs), this.data.addrs);
    // 把didArray合并到this.data.findDs
    let _didArray = didArray || [];
    let _allFindDs = Array.from(new Set(this.data.findDs.concat(_didArray)));
    // 把addrArray合并到this.data.addrs
    let _addrArray = addrArray || [];
    let _allFindAddrs = Array.from(new Set(this.data.addrs.concat(_addrArray)));
    // 这个方法是为了防止配网时跳转到其他页面，返回配网页面时发现的设备重复、分配的短地址重复
    app.globalData.blsdk.updateConfigCache({
      findDs: _allFindDs,
      probes: this.data.probes
    });
    // 设置已经使用的短地址
    app.globalData.blsdk.setExistAddrs(_allFindAddrs);
  },

  toastError (msg) {
    // 判断是否有设备配上，如果没有配上，则提示
    let _receiveLen = this.data.receiveLen;
    if (_receiveLen > 0) {
      return;
    }
    // 停止配网
    this.destorySDKConfig();
    // 销毁计数器
    this.destoryTimer();
    // 提示消息
    this.checkFinish(msg);
  },

  // 下发短地址
  sendDiscResWithDevice (devInfo) {
    app.globalData.blsdk.sendDiscResWithDevice(devInfo);
  },

  startConfig () {
    // 初始化房间
    let _roomJson = bizUtil.arrayToJsonByKey(bizUtil.getOriginRooms(), true);
    // 取得房间所有设备
    let _didArrays = Object.keys(this.data.scanResult) || [];

    // 校验是否达到最大个数
    let _result = this.showMaxDevToast(1);
    console.error("startConfig _result = ", _result);
    if (!_result) {
      return;
    }

    // 传递短地址
    let _addrs = Object.values(this.data.scanResult) || [];

    // 是否网关配网 网关不需要配置短地址
    if (this.data.isGateway) {
      return this.addGateway(_roomJson, _didArrays, _addrs);
    }

    // return this.testOnlyFind(_roomJson, _didArrays, _addrs);

    // this.data.addrs = _addrs;
    // // 设置已经存在的短地址区间
    // app.globalData.blsdk.setExistAddrs(_addrs);
    // 先停止之前的
    app.globalData.blsdk.stopBleReceiveService();
    // 开始发现设备
    console.log("_didArrays, this.data.isGateway, _addrs = ", _didArrays, this.data.isGateway, _addrs);
    app.globalData.blsdk.startBleReceiveWithRoomIdService((res) => {
    // app.globalData.blsdk.startBleReceiveService((res) => {  
      console.error("startBleReceiveWithRoomIdService res = ", res);
      if (!res) {
        return;
      }

      let {finds, addrs} = res;

      // 是否需要更新
      let _newDevice = false;
      for (let idx in finds) {
        let _item = finds[idx];
        // 已经存在的数据不刷出来
        if (this.data.scanResult[_item.d] != undefined) {
          continue;
        }
        // 把数据加入显示
        this.data.scanResult[_item.d] = _item.a;
        // 如果网关数据，则不显示
        let _devTypeKey = bizUtil.getDevTypeStr(_item.t);
        if (_devTypeKey == "gateway") {
          // 如果是ihg设备
          if (bizUtil.isIhg(_item.t)) {
            _item.isIhg = true;
          } else {
            continue;
          }
        }
        // 设备图片
        _item.tStr = _item.tStr || bizUtil.getDevImgByT(_item);
        // 如果和风扇灯和（继电器）面板，则不显示开关按钮
        if (_devTypeKey != 'light') {
          // 没有开关功能，默认有
          _item.pwrDisable = true;
        }
        // 如果是面板，还需要判断几键面板
        if (_devTypeKey == 'panel') {
          let _count = bizUtil.getPanelKeysByPid(_item.t);
          _devTypeKey = _devTypeKey + _count;
        }
        
        // 有新设备
        _newDevice = true;
        // 超出短地址个数
        if (_item.a <= 0) {
          _item.above = true;
        }
        // 加入显示
        this.data.dataList.push(_item);
      }
      // 配对成功列表
      let _needUpdate = this.dealOKDevice(_roomJson, addrs); // , _didArrays
      // 更新数据
      if (_newDevice || _needUpdate) {
        let _finishCount = this.getFinishedByList(this.data.dataList);
        // 加入显示
        this.setData({
          dataList: this.data.dataList,
          receiveLen: _finishCount
        });
      }
    }, _didArrays, this.data.allRoomId = {
      // default: app.globalData.roomInfo?.id || 0, // 暂时屏蔽按照房间添加设备
    });
    // 更新上一次的数据
    this.updateCacheForConfig(_didArrays, _addrs);
  },

  // testOnlyFind (_roomJson, _didArrays, _addrs) {
  //   // 先停止之前的
  //   app.globalData.blsdk.stopReceiveAndAdvertising();
  //   // 开始发现设备
  //   console.log("testOnlyFind _didArrays, _addrs = ", _didArrays, _addrs);
  //   app.globalData.blsdk.startBleReceiveWithRoomIdService((res) => {
  //     console.error("startBleReceiveWithRoomIdService res = ", res);
  //     if (!res) {
  //       return;
  //     }

  //     let {finds} = res;

  //     // 是否需要更新
  //     let _newDevice = false;
  //     for (let idx in finds) {
  //       let _item = finds[idx];
  //       // 已经存在的数据不刷出来
  //       if (this.data.scanResult[_item.d] != undefined) {
  //         continue;
  //       }
  //       // 把数据加入显示
  //       this.data.scanResult[_item.d] = _item.a;
  //       // 如果网关数据，则不显示
  //       let _devTypeKey = bizUtil.getDevTypeStr(_item.t);
  //       if (_devTypeKey == "gateway") {
  //         // 如果是ihg设备
  //         if (bizUtil.isIhg(_item.t)) {
  //           _item.isIhg = true;
  //         } else {
  //           continue;
  //         }
  //       }
  //       // 设备图片
  //       _item.tStr = _item.tStr || bizUtil.getDevImgByT(_item);
  //       // 如果和风扇灯和（继电器）面板，则不显示开关按钮
  //       if (_devTypeKey != 'light') {
  //         // 没有开关功能，默认有
  //         _item.pwrDisable = true;
  //       }
  //       // 如果是面板，还需要判断几键面板
  //       if (_devTypeKey == 'panel') {
  //         let _count = bizUtil.getPanelKeysByPid(_item.t);
  //         _devTypeKey = _devTypeKey + _count;
  //       }
        
  //       // 有新设备
  //       _newDevice = true;
  //       // 超出短地址个数
  //       if (_item.a <= 0) {
  //         _item.above = true;
  //       }
  //       // 加入显示
  //       this.data.dataList.push(_item);
  //     }
  //     // 更新数据
  //     if (_newDevice) {
  //       let _finishCount = this.getFinishedByList(this.data.dataList);
  //       // 加入显示
  //       this.setData({
  //         dataList: this.data.dataList,
  //         receiveLen: _finishCount
  //       });
  //     }
  //   }, _didArrays, this.data.allRoomId = {}, {
  //     step: "onlyfind"
  //   });
  //   // 更新上一次的数据
  //   this.updateCacheForConfig(_didArrays, _addrs);
  // },
  // testSendAddress () {
  //   // 先停止之前的
  //   console.error("testSendAddress");
  //   // 先停止之前的
  //   app.globalData.blsdk.stopReceiveAndAdvertising();
  //   // 开始配对设备
  //   app.globalData.blsdk.configByDevArray(this.data.dataList, {
  //     // setRoomId: 1,
  //     callback: (res) => {
  //       console.error("testSendAddress res = ", res);
  //     },
  //     configs: {
  //       step: "onlyaddress",
  //       // noTimer: true // 不广播使能
  //     }
  //   });
  // },

  // 本地配置成功的设备
  dealOKGatewayDevice (roomJson, devInfo, didArrays) {
    if (!devInfo) {
      return;
    }
    // let _obj = devInfo;
    // did
    let _d = devInfo.d;

    // 如果已经接收到，则返回
    if (devInfo.complete) {
      return;
    }
    // 接收完成
    devInfo.complete = true;
    // 设备在线 默认网关在线，用于首次远程控制
    devInfo.online = true;
    // 设置默认房间 网关为全屋
    devInfo.id = 0;
    // // 网关短地址位255
    // devInfo.a = 255;
    // 房间名称
    devInfo.rn = (roomJson[devInfo.id] || {}).n;
    // 如果数据已经存在，则不加入
    if (!!didArrays && didArrays.indexOf(_d) >= 0) {
      console.error("didArrays = ", didArrays, _d);
    } else {
      // 全屋数据
      let _obj = (app.globalData.devs[0] || {});
      let _allDevs = _obj.devs || [];

      // 如果是aux demo 则判断是否存在相同的d（aux先蓝牙配网，再发送ssid等）
      if (this.isAuxDemo()) {
        let _filter = _allDevs.filter(item => item.d == _d);
        if (_filter.length > 0) {
          return;
        }
      }

      // 排序
      devInfo.sort = _allDevs.length;
      // 增加额外信息
      this.initDefaultByPid(devInfo);
      
      // 校验是否达到最大个数
      let _result = this.showMaxDevToast(1);
      if (!_result || devInfo.a < 0) {
        // 超出个数
        devInfo.above = true;
        // 停止发现设备
        this.destorySDKConfig();
        return;
      }

      // 如果数据存在，则保存数据
      _allDevs.push(this.getDevItems(devInfo));
      
      // 清空网关udp数据
      this.clearGatewayUdpData(devInfo);
      // 分别上报到对应设备的网关私有数据中
      this.updateGatewayPrivate(devInfo);
    }
  },
  // 上报数据到网关的私有数据逻辑
  updateGatewayPrivate (gatewayInfo) {
    if (!gatewayInfo) {
      console.error("updateGatewayPrivate not exist");
      return;
    }
    let _gatewayList = [];
    _gatewayList.push(gatewayInfo);
    // 判断是否有sdid和skey，如果有，则直接上报
    let {sid, skey} = app.globalData.familyInfo;
    if (sid && skey) {
      this.updateGatewayPrivateDetail(_gatewayList);
    } else {
      // 先上报私有数据，再上报网关私有数据
      app.uploadPrivateData((sdid, skey) => {
        if (!sdid || !skey) {
          console.error("updateGatewayPrivate sdid, skey = ", sdid, skey);
          return;
        }
        this.updateGatewayPrivateDetail(_gatewayList, sdid, skey);
      });
    }
  },
  // 上报数据到网关的私有数据中
  updateGatewayPrivateDetail (gatewayList, sdid, skey) {
    if (!gatewayList) {
      return;
    }
    console.error("updateGatewayPrivateDetail");
    let _familyInfo = app.globalData.familyInfo || {};
    let _sdid = sdid || _familyInfo.sid;
    let _skey = skey || _familyInfo.skey;
    // 上报的集群域名
    let _groupStr = GROUPS[Number(_familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    for (let gatewayInfo of gatewayList) {
      app.globalData.blsdk.updatePrivateData({gateways: [gatewayInfo]}, {
        did: _sdid,
        token: _skey,
        upEveryGatewayPrivate: true,
        host: _groupStr // 上报的集群域名
      })
    }
    // app.uploadPrivateData(false, false, false, {
    //   gateways: gatewayList
    // })
  },
  // 取得设备总数
  getAllDevs () {
     // 取得所有设备列表
     let _devs = bizUtil.getAllDevsFilter(app.globalData.devs);
     let _devCount = _devs.length;
     return _devCount;
  },
  // 校验是否大于最大设备数
  checkAboveMaxCount (count) {
    let _devCount = this.getAllDevs();
    let _allCount = _devCount + (Number(count) || 0);
    if (_allCount > this.data.maxCount) {
      return false;
    }
    return true;
  },
  // 校验最大个数以及提示
  showMaxDevToast (count) {
    // 校验是否达到最大个数
    let _result = this.checkAboveMaxCount(count);
    if (!_result) {
      ability.showModal({
        title: "",
        content: "小程序最大支持" + (this.data.maxCount || 0) + "个设备，更多请使用【易控全屋】APP",
        showCancel: false
      }).then(() => {
        this.goBack(2);
      });
    }
    return _result;
  },

  // 设备信息
  getDevItems (info) {
    if (!info) {
      return;
    }
    let {a, d, e, id, sort, t, v, n, oa, or, k, SD, sub, online, ds} = info;
    // 基础数据
    let _basicObj = {
      a, d, e, id, sort, t, v, n, oa, or
    };
    // 在线状态
    if (online != undefined) {
      _basicObj.online = online;
    }
    // 空调网关
    if (sub != undefined) {
      _basicObj.sub = sub;
    }
    // 网关的控制密钥
    if (k != undefined) {
      _basicObj.k = k;
    }
    // 照明设备是否支持默认、自定义还是不支持场景
    if (SD != undefined) {
      _basicObj.SD = SD;
    }
    // 继电器超级面板
    if (ds != undefined) {
      _basicObj.ds = ds;
    }
    // // 排序用
    // if (SD != undefined) {
    //   _basicObj.0aa = SD;
    // }
    return _basicObj;
  },

  // 根据设备pid初始化设备信息
  initDefaultByPid (devInfo) {
    if (!devInfo) {
      return;
    }
    let _isPwrAvalible = bizUtil.isPwrAvalibleDev(devInfo.t);
    if (_isPwrAvalible) {
      // 判断几路开关
      let _num = bizUtil.getPanelKeysByPid(devInfo.t);
      devInfo.e = {
        vGroups: bizUtil.getPanelVGroups(_num)
      };
      // 是否有超级面板属性
      let _dsArray = bizUtil.initMetaPwrKeyBind(devInfo);
      if (_dsArray.length > 0) {
        devInfo.ds = _dsArray;
      }
      // // 判断ability,如果支持超级面板，则增加缓存信息
      // let _vJson = this.getAbilityByV(devInfo.v, devInfo.t) || {};
      // console.error("initDefaultByPid _vJson, devInfo = ", _vJson, devInfo);
      // // 继电器超级面板能力
      // if (_vJson.metapadEnable) {
      //   // 增加配置
      //   devInfo.ds = devInfo.ds || [];
      //   // 判断按键路数
      //   let _count = bizUtil.getPanelKeysByPid(devInfo.t);
      //   console.error("initDefaultByPid _count = ", _count);
      //   // 超级面板的配置
      //   let _metaConfig = bizUtil.getMetaTypeMad();
      //   let _keys = Object.keys(_metaConfig);
      //   let _values = Object.values(_metaConfig);
      //   console.error("initDefaultByPid _keys, _values = ", _keys, _values);
      //   let _index = _values.findIndex(item => item == "switch");
      //   let _realType = _keys[_index];
      //   console.error("initDefaultByPid _index, _realType = ", _index, _realType);
      //   if (_realType == undefined) {
      //     return;
      //   }
      //   for (let i = 0; i < _count; i++) {
      //     devInfo.ds.push({
      //       sid: devInfo.a,
      //       rid: devInfo.id || 0,
      //       type: Number(_realType) || 0,
      //       key: Number(i), // 超级面板的key
      //       cmd: devInfo.d, // 继电器设备d
      //       pwrPanelKey: i // 继电器的第几路 
      //     })
      //   }
      // }
    } else {
      let _typeStr = bizUtil.getDevTypeStr(devInfo.t);
      // console.log("initDefaultByPid _typeStr, devInfo = ", _typeStr, devInfo);
      if (_typeStr == "doorsensor") {
        devInfo.e = {
          vGroups: bizUtil.getDoorVGroups()
        };
      } else if (_typeStr == 'bodysensor') {
        devInfo.e = {
          vGroups: bizUtil.getBodyVGroups()
        };
      } else if (_typeStr == 'watersensor') {
        devInfo.e = {
          vGroups: bizUtil.getWaterVGroups()
        };
      } else if (_typeStr == 'curtain') {
        // 判断是否不需要设置限位 和app保持一致 不需要设置限位的话添加完毕就加上默认值true
        let _needNotSetLimit = bizUtil.neednotSetLimit(devInfo?.t);
        devInfo.e = bizUtil.getCurtainVGroups(_needNotSetLimit);
      } else if (_typeStr == "light" && bizUtil.isXuancai(devInfo.t, devInfo.v)) {
        devInfo.e = {
          lightDazzle: {
            "beads_number": 10, // 灯珠总数
            "beads_sort": 0, // 灯珠排序
            "ic_type": 0, // IC 类型
            "beads_type": 1, // 炫彩模式类型
            "beads_speed": 50, // 炫彩模式变化速度

            "mic_enable": 0, // 默认收音是否开启
            "mic_type": 0, // 默认收音模式
            "mic_speed": 50, // 默认收音灵敏度
          }
        };
      } else if (_typeStr == 'panelsensor') {
        devInfo.e = devInfo.e || {};
        devInfo.e.vGroups = [
          {"name": "从低到高"},
          {"name": "从高到低"},
          {"name": "从低到高"},
          {"name": "从高到低"},
          {"name": "从低到高"},
          {"name": "从高到低"},
          {"name": "从低到高"},
          {"name": "从高到低"},
        ];
        devInfo.e.subs = [
          {"name": "传感器1"},
          {"name": "传感器2"},
          {"name": "传感器3"},
          {"name": "传感器4"},
        ];
      } else {
        devInfo.e = {
          vGroups: {}
        };
      }
    }
    return;
  },
  getAbilityByV (v, t) {
    // 是否支持背光
    let _json = bizUtil.getJsonByAblitys(v, "panel", {t});
    return _json || {};
  },

  getMapInArray (array) {
    let _result = {};
    if (!array || array.length == 0) {
      return _result;
    }
    for (let item of array) {
      _result[item.d] = item;
    }
    return _result;
  },

  // 本地配置成功的设备 , didArrays
  dealOKDevice (roomJson, addrs) {
    // 房间id
    let _roomJson = this.data.allRoomId || {};
    let _needUpdate = false;

    // 取得已经存在的设备列表d集合
    let _json = this.getMapInArray(this.data.dataList);
    let _existDs = Object.keys(_json);
    if (_existDs.length == 0) {
      return _needUpdate;
    }
    // 判断是否为空
    for (let d in addrs) {
      // 如果没有设备被发现则过滤配对成功的设备
      if (_existDs.indexOf(d) < 0) {
        continue;
      } else {
        let _item = _json[d];
        let _obj = addrs[d];

        // 配网数据不存在
        if (!_obj) {
          continue;
        }

        // 判断房间是否相等
        let _realId = (_roomJson[d] != undefined) ? _roomJson[d] : (_roomJson?.default || 0);
        if (_roomJson && _obj?.id != _realId) {
          continue;
        }
        // 如果已经成功
        if (_item.complete) {
          continue;
        }
        // 接收完成
        _item.complete = true;
        // 版本号
        let _v = _obj.v || '';
        _item.v = _v; // 版本号

        // 取得设备品类名称
        let _devTypeStr = bizUtil.getDevTypeStr(_item.t);
        
        // 取得最后的版本号是否大于48，如果小于48，则不支持默认场景
        if (_devTypeStr == "light") {
          // 是否支持默认场景 0; // 支持  -1; // 不支持默认场景 -2; // 不支持场景
          _item.SD = bizUtil.getSupportSceneInfoByV(_v);
        }
        
        // 设置默认房间
        let _id = _obj.id || _item.id || 0;
        if (!roomJson[_id]) {
          _id = 0;
        }
        _item.id = _id;
        // 房间名称
        _item.rn = (roomJson[_item.id] || {}).n;
        // 全屋数据
        let _roomInfo = (app.globalData.devs[_id] || {});
        _roomInfo.devs = _roomInfo.devs || [];
        // 排序
        _item.sort = _roomInfo.devs.length;

        // 增加额外信息
        this.initDefaultByPid(_item);

        // 最终的设备信息
        let _devObj = this.getDevItems(_item);
        let _subArray = [];
        // 如果是空调网关设备，则加入子设备
        let _isAircondition = _devObj.sub > 0;
        if (_isAircondition) {
          _subArray = this.getSubInfoByDevInfo(_item);
        }
        // 校验是否达到最大个数
        let _result = this.showMaxDevToast(_subArray.length + 1);
        if (!_result) {
          // 超出个数
          _item.above = true;
          // 停止发现设备
          this.destorySDKConfig();
          return;
        } else if (_item.a < 0) { // 如果超出范围，则提示
          console.error("above item = ", _item);
          _item.above = true;
          continue;
        }

        // 如果是ihg，则先不加入
        if (_devTypeStr == "gateway") {
          _needUpdate = true;
          continue;
        }
        // 加入到设备中
        _roomInfo.devs.push(_devObj);
        if (_isAircondition) {
          _roomInfo.devs.push(..._subArray);
        }
        // 设置
        _needUpdate = true;
      }
    }
    return _needUpdate;
  },

  // 根据空调主设备信息取得网关子设备信息
  getSubInfoByDevInfo (devInfo) {
    if (!devInfo) {
      return [];
    }
    let {sub, d, n, a, id, v, t, sort} = devInfo;
    if (!sub || sub < 0) {
      return [];
    }
    let _result = [];
    let _totalLength = sub >= 100 ? 3 : (sub >= 10 ? 2 : 1);
    for (let i = 1; i <= sub; i++) {
      let _name = bizUtil.padStart(i.toString(), _totalLength, 0);
      _result.push({
        n: "空调内机_" + _name,
        d: d + "_" + i,
        a: a + i, // 短地址
        id, // 默认与主机相同房间
        v,
        t,
        sort: sort + i
      })
    }
    return _result;
  },

  // ihg配网信息
  ihgConfig (e) {
    // 设备信息
    let {index} = e.currentTarget.dataset;
    let _item = this.data.dataList[index];
    if (_item.wd) {
      // 已经授权的设备不需要授权
      return ability.showToast({
        title: "已授权设备不需要重新授权"
      });
    }
    this.ihgConfigDetail(_item);
  },
  ihgConfigDetail (item) {
    if (!item) {
      return;
    }
    // 保存快照信息
    this.saveConfigData();
    // 停止配网 FOR TEST
    app.globalData.blsdk.clearConfigInterval();
    app.globalData.blsdk.stopAdvertising();
    // this.destorySDKConfig();

    // let _length = 0;
    // wx.getBluetoothDevices({success: (res) => {
    //   _length = res?.length || 0;
    //   ability.navigateTo("../ihg/oauth/index?count=" + _length)
    // }});
    
    // 销毁定时器
    this.destoryTimer();
    // 编辑ihg
    this.data.editIhg = true;
    console.log("ihgConfig item = ", item);
    app.globalData.devInfo = item;
    ability.navigateTo("../ihg/oauth/index")
  },

  // 查询数据
  onPullDownRefresh() {
  },
  goManage () {

    // // for test 
    // return app.globalData.blsdk.destory();

    // return this.testSendAddress();

    // 如果没有设备，则不处理后续
    if (!this.data.dataList?.length) {
      // 返回首页
      this.goBack(1);
      return;
    }

    // ihg是否授权成功
    let _ihgExist = this.data.dataList.filter(item => item.isIhg && item.complete);
    let _ihgLength = _ihgExist.length;
    console.log("goManage _ihgLength = ", _ihgLength);
    if (_ihgLength > 0) {
      // // 取得全屋的配置
      // let {devJson} = bizUtil.getDidMapByConfig(app.globalData.devs, ['devs']);
      // 判断是否全部授权成功
      // let _notAuthList = _ihgExist.filter(item => devJson[item.d] == undefined);
      let _notAuthList = _ihgExist.filter(item => item.wd == undefined);
      let _notAuthLen = _notAuthList.length;
      if (_notAuthLen == 0) {
        // 全部授权成功 啥也不做
      } else {
        wx.showModal({
          title: "",
          content: "未授权设备，该设备将添加失败，是否去授权？",
          showCancel: true,
          confirmColor: "#F78D3F",
          confirmText: "授权",
          cancelText: "取消",
          cancelColor: '#000000'
        }).then(result => {
          if (result?.confirm) {
            if (_notAuthLen > 1) {
            } else {
              this.ihgConfigDetail(_notAuthList[0]);
            }
          } else {
            // 上报一次数据
            app.uploadPrivateData();
            // 返回首页
            this.goBack(2);
          }
        })
        return;
      }
    }

    // 上报一次数据
    app.uploadPrivateData();

    // 判断是否加载完毕
    if (this.data.receiveLen == this.data.dataList.length) {
      return this.dealAfterBtnClick();
    }

    wx.showModal({
      title: "",
      content: "当前设备未加载完毕，是否结束添加设备？",
      showCancel: true,
      confirmText: "是",
      cancelText: "否",
      cancelColor: '#000000'
    }).then(result => {
      result?.confirm && (this.dealAfterBtnClick());
    })
  },
  // 点击完成之后的处理
  dealAfterBtnClick () {
    // 如果是网关配网，且有配置成功的设备，则进入第三方授权页
    if (this.data.isGateway) {
      // 判断是否网关
      if (!this.isGatewayConfig) {
        // 空调网关
        return this.goBack(2);
      }
      if (this.data.receiveLen == 1) {
        // 跳转到第三方语音页面
        let _devInfo = this.data.dataList[0];
        // 跳转到第三方语音页面
        // return ability.redirectTo("/minePages/thirdVoice/index?from=config");
        return ability.redirectTo("/device/gateway/thirdparty/index?from=config&title=" + encodeURIComponent(_devInfo?.n || ""))
      } else {
        // 返回上一页
        return this.goBack(2);
      }
    }
    // 返回上一页
    this.goBack(2);
  },

  pwrClick (e) {
    let _itemIdx = e.currentTarget.dataset.itemindex;
    //保存当前数据
    let _deviceInfo = this.data.dataList[_itemIdx];
    if (!_deviceInfo.complete) {
      return;
    }

    // 控制参数
    let _params = {};

    // 默认关闭
    let _brightness = 0;
    // 判断是否存在设备
    let _isExist = this.data.ctrls[_deviceInfo.d];
    if (_isExist === 0) {
      _brightness = 127;
    }

    // 判断是否照明灯
    let _devTypeStr = bizUtil.getDevTypeStr(_deviceInfo.t);
    if ('fanLight' == _devTypeStr) {
      // 全关
      _params = {
        light: { brightness: _brightness, c: 127, w: 127 },
        fan: {pwr: _brightness ? 0 : 1}
      };
    } else {
      _params = {
        brightness: _brightness
      };
    }

    this.initCtrlTimer(_deviceInfo, _params);

    // // 设置灯的图片
    // this.data.ctrls[_deviceInfo.d] = _brightness;
    // this.setData({
    //   ctrls: this.data.ctrls
    // })
    // // 发送命令
    // app.globalData.blsdk.controlWithDevice(_deviceInfo, _params);
  },

  initCtrlTimer (devInfo, params) {
    if (!devInfo) {
      return;
    }
    // 是否有其他设备在控制中
    if (this.data.ctrledD && (this.data.ctrledD == devInfo.d)) {
      return;
    }
    // 设置控制设备的d
    this.setCtrlDeviceD(devInfo.d);

    if (this.data.ctrlTimer) {
      this.destoryTimer(this.data.ctrlTimer);
    }
    // console.error("initCtrlTimer1 this.data.ctrlCount = ", this.data.ctrlCount);
    let _ctrlIndex = 0; // 第0次发送
    // 这里静态吧 发两次
    this.data.ctrlTimer = setInterval(() => {
      // 判断是否发送成功
      if (_ctrlIndex >= this.data.ctrlCount) {
        // console.error("initCtrlTimer2 _ctrlIndex, this.data.ctrlCount = ", _ctrlIndex, this.data.ctrlCount);
        this.destoryTimer(this.data.ctrlTimer);
        // 清除控制
        this.setCtrlDeviceD();
        // 设置状态
        let _brightness = params?.light?.brightness || params.brightness || 0;
        this.data.ctrls[devInfo.d] = _brightness;
        this.setData({
          ctrls: this.data.ctrls
        });
        return;
      }
      // 发送次数+1
      _ctrlIndex++;
      // 发送命令
      app.globalData.blsdk.controlWithDevice(devInfo, params);
    }, 400);
    // 发送命令
    app.globalData.blsdk.controlWithDevice(devInfo, params);
  },

  goBack (num) {

    // 从设备替换中进入
    if (this.from == "replace") {
      // 返回
      return ability.navigateBack();
    }

    // 如果是网关返回，则返回到首页
    if (this.data.isGateway) {
      return ability.navigateBack(num || 2);
    }
    // 返回
    ability.navigateBack(num || 1);
  },
  jumpDevInfo (e) {
    let _index = e.currentTarget.dataset.itemindex;
    let _devInfo = this.data.dataList[_index];
    if (!_devInfo) {
      return;
    }
    this.data.changeInfoIdx = _index;
    app.globalData.devInfo = _devInfo;
    app.globalData.groupIds = [];
    app.globalData.groupInfo = undefined;
    app.globalData.tgroupId = undefined;

    // 如果是单个设备进入，则清除默认群组的数据
    (!!app.globalData?.tmpData?.roomInfo) && (delete app.globalData.tmpData.roomInfo);

    // 取得设备的ability 确保这里是单个设备
    let _remote = 0;
    console.log("jumpDevInfo _devInfo = ", _devInfo);
    // 如果是温控器，则不判断ability
    if (_devInfo && _devInfo.t > 0 && _devInfo.v != undefined) {
      let _devTypeStr = bizUtil.getDevTypeStr(_devInfo?.t);
      if (_devTypeStr == "thermostat") {
        _remote = 0;
      } else {
        let _abilitys = bizUtil.getJsonByAblitys(_devInfo.v, _devTypeStr, {t: _devInfo.t});
        console.log("jumpDevInfo _abilitys = ", _abilitys);
        _remote = _abilitys?.remote || 0;
      }
    }
    console.log("jumpDevInfo _remote = ", _remote);

    // 保存快照信息
    this.saveConfigData();
    // 保存一下数据
    app.saveAllDevsMap();

    // 跳转到设备编辑页面
    ability.navigateTo("/device/light/devProperty/index?from=add&remote=" + _remote);
  },

  gatewayCode (val) {
    let _json = {
      '-1': '蓝牙配网超时',
      '-2': '模块连接ap超时',
      '-3': '模块连接路由器的password有问题',
      '-4': '模块连接路由器DHCP超时',
      '-5': 'dns解析失败',
      '-6': '激活失败',
      '-7': '服务器列表获取超时',
      '-8': '服务器检查超时',
      '-9': '长连接心跳无返回',
    }
    return _json[val] || val;
  },
  gatewayState (val) {
    let _json = {
      '1': '正在下发信息',
      '2': '正在连接路由',
      '3': '正在连接云端',
      '4': '正在分配短地址',
      '5': '连接成功',
    }
    return _json[val] || _json['1'];
  },
  jumpFaq () {
    // 保存快照信息
    this.saveConfigData();
    // 保存一下数据
    app.saveAllDevsMap();
    // 停止配网
    this.destorySDKConfig();
    // 跳转页面
    ability.navigateTo("../faq/index")
  },

  // 保存设备状态，用于
  saveConfigData () {
    let _blsdk = app.globalData.blsdk;
    if (!_blsdk) {
      return;
    }
    let existAddrs = _blsdk.existAddrs || [];
    let _info = _blsdk.dataClass || {};
    this.data.findDs = Array.from(_info.findDs || []);
    this.data.probes = Object.assign({}, _info.probs || {});
    this.data.addrs = Array.from(existAddrs);
  },
  // 清除网关udp私有数据
  clearGatewayUdpData (devInfo) {
    if (!devInfo) {
      return;
    }
    let _devInfo = devInfo;
    // 上报的集群域名
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    // 清空数据
    app.globalData.blsdk.manageUdpPrivateData({
      type: "add",
      d: _devInfo?.wd || _devInfo?.d,
      t: _devInfo?.t,
      k: _devInfo?.k,
      data: ""
    }, {
      host: _groupStr
    });
  }
})
