// addPages/ihg/oauth/index.js
const ability = require("../../../utils/classDef/ability")
const bizUtil = require("../../../utils/bizUtil")
const app = getApp()

Page({

  /**
   * 页面的初始数据
   */
  data: {
    bleUnavailable: false, // 默认蓝牙可用

    tipList: [{
      imgStr: "/static/img/addDevice/ihg/remote.png",
      title: "远程控制",
      tip: "授权局域网信息，设备可远程控制",
      rightImg: "/static/img/addDevice/ihg/right_black.png"
    }, {
      imgStr: "/static/img/addDevice/ihg/third.png",
      title: "第三方语音授权",
      tip: "使用第三方语音设备进行控制",
      rightImg: "/static/img/addDevice/ihg/right_black.png"
    }]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.count = options?.count || 0;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 下一步
  next () {
    let _type = this.getIhgTypeByDevInfo(app.globalData.devInfo);

    let _extendStr = "&count" + this.count;

    // 判断有线还是无线
    if (_type == 1) {
      // 有线则直接配网
      ability.redirectTo("../config/index?from=ihg" + _extendStr);
    } else {
      // 无线需要配置WiFi等信息
      ability.redirectTo("../../gateway/index?from=ihg");
    }
  },
  // 判断是有线ihg还是无线ihg
  getIhgTypeByDevInfo (devInfo) {
    if (!devInfo) {
      return;
    }
    let {v, t} = devInfo || {};
    let _devTypeStr = bizUtil.getDevTypeStr(t);
    let _isIhg = bizUtil.isIhg(t);
    let {byte0} = bizUtil.getJsonByAblitys(v, _isIhg ? 'ihg' : _devTypeStr, {t});
    console.log("getIhgTypeByDevInfo byte0 = ", byte0);
    if (byte0 == 0x51) {
      // 有线
      return 1;
    } else if (byte0 == 0x52) {
      // 无线
      return 0;
    } else if (byte0 == 0x53) {
      // 有线+无线 认为是无线的
      return 0;
    }
    return -1;
  },
})