// components/popTop/index.js
// const ability = require("../../utils/classDef/ability")
const app = getApp();
Component({
  options: {
    addGlobalClass: true, // 全局样式
  },
  /**
   * 组件的属性列表
   */
  properties: {
    rolenum: {
      type: Number
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    familyId: -1, // 当前家庭

    top: 0 // 距离顶部高度
  },

  observers: {
    'rolenum': function () {
      // 初始化高度
      this.initHeight();
      // 初始化家庭数据
      this.initData();
    }
  },
  // ready () {
  //   console.log("customPop ready");
  // },
  lifetimes: {
    // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
    attached: function () {
      // console.log("customPop lifetimes attached");
    },
    moved: function () { },
    detached: function () {
    },
  },
  pageLifetimes: {
    // 组件所在页面的生命周期函数
    show: function () {
      // console.log("customPop pageLifetimes show");
      // 初始化高度
      this.initHeight();
      // 初始化家庭数据
      this.initData();
    },
    hide: function () {
      console.log("customPop pageLifetimes hide");
    },
    resize: function () { },
  },

  /**
   * 组件的方法列表
   */
  methods: {
    initHeight () {
      let {statusHeight, multip} = app.globalData.customPageSize;
      this.data.top = statusHeight * multip + (246 / 2) + 44;
      // console.log("initHeight this.data.top = ", this.data.top);
      this.setData({
        top: this.data.top
      })
    },
    initData () {
      let _list = [
        {
          n: '添加设备'
        }, 
        {
          n: '添加场景'
        },
        {
          n: '扫码加入'
        },
        {
          n: '创建群组'
        }
      ];
      if (app.globalData.roleNum == 2) {
        // , _list[3]
        this.data.list = [_list[2]];
        // return;
      } else {
        this.data.list = _list || [];
      }
      this.setData({
        list: this.data.list
      })
    },

    // 关闭弹窗
    closePop () {
      console.log("closePop")
      // 触发上报到父组件
      this.triggerEvent('closepop', {})
    },

    // 选中的条目选中
    itemClick (e) {
      let {index} = e.currentTarget.dataset;
      this.triggerEvent("itemclick", {
        index: index
      })
    }
  }
})
