// components/customInput/index.js
const ability = require("../../utils/classDef/ability")
const app = getApp();
Component({
  options: {
    // virtualHost: true,
    addGlobalClass: true // 支持全局
  },
  /**
   * 组件的属性列表
   */
  properties: {
    // 配置信息
    config: {
      type: Object,
      value: {}
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    inputValue: 0
  },

  observers: {
    'config.value': function (value) {
      // 根据换算
      console.log("observers value = ", value);
      this.setValueData(value);
    }
  },

  // lifetimes: {
  //   attached () {
  //     // 更新rpx与px的比
  //     this.data.inputValue = this.data.config?.value || 0;
  //   }
  // },
  // pageLifetimes: {
  //   show () {
  //     console.log("pageLifetimes show");
  //     // 更新rpx与px的比
  //     this.data.inputValue = this.data.config?.value || 0;
  //   }
  // },

  /**
   * 组件的方法列表
   */
  methods: {
    setValueData (value) {
      let {min, max} = this.data.config;
      let _value = value || 0;
      if (!!min && _value < min) {
        _value = min;
      } else if (!!max && _value > max) {
        _value = max;
      }
      this.setData({
        inputValue: _value
      })
    },
    inputChange (e) {
      let _value = e.detail.value;
      this.data.inputValue = _value;
    },
    checkValue (value) {
      let {min, max} = this.data.config;
      if (value < min) {
        ability.showToast({
          title: "最小值为" + min
        })
        return false;
      } else if (value > max) {
        ability.showToast({
          title: "最大值为" + max
        })
        return false;
      }
      return true;
    },
    buttonClick (e) {
      console.log("buttonClick e = ", e);
      let {index} = e.currentTarget.dataset;
      let {key} = (this.data.config?.buttons || [])[index] || {};
      let _value = this.data.inputValue
      if (key == "confirm") {
        let _result = this.checkValue(_value);
        if (!_result) {
          return;
        }
      } else {
        // 重新设置数据，防止
        this.setValueData(this.data.config?.value);
      }
      this.triggerEvent("buttonClick", {
        key: key,
        value: _value
      })
    }
  }
})
