// components/customNav/index.js
const ability = require("../../utils/classDef/ability")
const app = getApp();
Component({
  options: {
    // virtualHost: true,
    addGlobalClass: true // 支持全局
  },
  /**
   * 组件的属性列表
   */
  properties: {
    // 配置信息
    config: {
      type: Object,
      value: {
        show: true,
        // 左侧部分
        left: { // 不传为空
          text: "11",
          // color: "",
          // fontSize: "",
          // handler: () => {} // 不传为默认的返回事件
        },
        center: { // 不传为空
          text: "center",
          centerType: ""
          // color: "",
          // fontSize: ""
          // ,handler: () => {} // 不传为无
        },
        right: { // 不传为空
          text: "",
          // color: "",
          // fontSize: ""
          // ,handler: () => {} // 不传为无
        }
      }
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    show: true, // 是否显示导航
    loading: false,

    back: false, // 是否显示左侧返回，如果为false，则slot有效
    left: "", // 左侧文字
    
    // title: "", // 标题

    right: "", // 右侧文字
    
    color: '#000000',
    background: '#FFFFFF',
    animated: false
  },

  lifetimes: {
    // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
    attached: function () {
      // 取得设置的高度
      let _height = app.globalData.systemInfo.statusBarHeight || 20;
      this.setData({
        statusHeight: _height
      });
    },
    moved: function () { },
    detached: function () { },
  },

  pageLifetimes: {
    show () {
      // console.log("pageLifetimes show this.data.config = ", this.data.config);
      // 根据传入参数动态显示头部
      let _config = this.data.config;
      // console.log("customNav pageLifetimes attached = ", _config);
      if (_config === undefined || _config === null) {
        return;
      }
      this.initNavBar(_config);
      // 没有数据则返回
      if (!_config) {
        return;
      }
      this.initLeft(_config.left);
      this.initCenter(_config.center);
      this.initRight(_config.right);
    }
  },

  /**
   * 组件的方法列表
   */
  methods: {
    // 返回按钮
    bindback () {
      ability.navigateBack();
      // wx.navigateBack();
    },
    // 初始化bar条样式
    initNavBar (obj) {
      this.setData({
        show: !obj ? false : true
      })
    },
    // 初始化左侧部分
    initLeft (obj) {
      let _showLeft = !!(!obj || obj.text !== undefined || obj.type || obj.img !== undefined);
      // console.log("customNav initLeft obj, _showLeft = ", obj, _showLeft);
      this.setData({
        back: !_showLeft
      });
    },
    // 初始化中间侧部分
    initCenter (obj) {
      // console.log("initCenter obj && obj.type = ", obj);
      this.setData({
        // title: !obj ? '' : obj.text,
        centerType: (obj && obj.type || "")
      });
    },
    // 初始化右侧部分
    initRight (obj) {
      this.setData({
        right: !obj ? '' : obj.text
      });
    },
    // 自定义按钮事件
    leftClick () {
      // console.log("customNav leftClick", this.data.config);
      // console.log("customNav leftClick", !!this.data.config.left.hander);
      // 当内容为空时，需要抛出
      if (this.data.config.left.hander) {
        // console.log("this.config.left.handler = ", this.data.config.left.handler);
        this.data.config.left.hander();
      } else {
        this.bindback();
      }
    },
    // 中间区域点击
    midClick () {
      !!this.data.config.center && !!this.data.config.center.hander && (this.data.config.center.hander());
    }
  }
})
