// components/popTop/index.js
// const ability = require("../../utils/classDef/ability")
const app = getApp();
Component({
  options: {
    addGlobalClass: true, // 全局样式
  },
  /**
   * 组件的属性列表
   */
  properties: {

  },

  /**
   * 组件的初始数据
   */
  data: {
    familyId: -1, // 当前家庭
  },

  ready () {
    console.log("customPop ready");
    // 初始化家庭数据
    this.initFamilyData();
    // 初始化家庭数据
    this.initCurrentFamily();
  },
  lifetimes: {
    // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
    attached: function () {
      // console.log("customPop lifetimes attached");
      // 初始化家庭数据
      this.initFamilyData();
      // 初始化家庭数据
      this.initCurrentFamily();
    },
    moved: function () { },
    detached: function () {
    },
  },
  pageLifetimes: {
    // 组件所在页面的生命周期函数
    show: function () {
      console.log("customPop show");
      // 初始化家庭数据
      this.initFamilyData();
      // 初始化家庭数据
      this.initCurrentFamily();
    },
    hide: function () {
      console.log("customPop pageLifetimes hide");
    },
    resize: function () { },
  },

  /**
   * 组件的方法列表
   */
  methods: {
    initCurrentFamily () {
      // 判断当前家庭是否只有一个
      let {id} = app.globalData.familyInfo || {};
      // 如果没有家庭，则不设置
      if (id == undefined || id < 0 || this.data.familys?.length < 2) {
        return;
      }
      this.data.familyId = id;
      this.setData({
        familyId: this.data.familyId
      })
      // return this.data.familys.findIndex(item=>item.id==_familyInfo.id)
    },
    initFamilyData () {
      let _familys = app.globalData.familys || [];
      console.log("pop initFamilyData _familys = ", _familys);
      if (_familys.length == 1) {
        this.data.familyId = _familys[0].id;
        app.globalData.familyInfo = _familys[0];
      }
      this.data.familys = _familys || [];
      this.setData({
        familyList: this.data.familys,
        familyId: this.data.familyId
      })
    },

    // 关闭弹窗
    closePop () {
      // 触发上报到父组件
      this.triggerEvent('closepop', {})
    },
    familyManageClick () {
      // 触发上报到父组件
      this.triggerEvent('familymanage', {})
    },
    familyClick (e) {
      let {index} = e.currentTarget.dataset;
      // 触发上报到父组件
      this.triggerEvent('familyselect', {
        index
      })
    }
  }
})
