// components/popTop/index.js
import bizUtil from "../../utils/bizUtil"
import ability from "../../utils/classDef/ability";
const app = getApp();
Component({
  options: {
    addGlobalClass: true, // 全局样式
  },
  /**
   * 组件的属性列表
   */
  properties: {
    rolenum: {
      type: Number
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    floorId: -1, // 当前家庭
  },

  ready () {
    console.log("customPop ready");
    // 初始化家庭数据
    this.initFloorData();
    // // 初始化家庭数据
    // this.initCurrentFloor();
  },
  lifetimes: {
    // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
    attached: function () {
      // console.log("customPop lifetimes attached");
      // 初始化家庭数据
      this.initFloorData();
      // // 初始化家庭数据
      // this.initCurrentFloor();
    },
    moved: function () { },
    detached: function () {
    },
  },
  pageLifetimes: {
    // 组件所在页面的生命周期函数
    show: function () {
      console.log("customPop show");
      // 初始化家庭数据
      this.initFloorData();
      // // 初始化家庭数据
      // this.initCurrentFloor();
    },
    hide: function () {
      console.log("customPop pageLifetimes hide");
    },
    resize: function () { },
  },

  /**
   * 组件的方法列表
   */
  methods: {
    /* initCurrentFloor () {
      // 判断当前家庭是否只有一个
      let {id, floor} = app.globalData.familyInfo || {};
      // 如果没有家庭，则不设置
      if (floor == undefined || floor < 0 || this.data.floors?.length < 2) {
        return;
      }
      this.data.floorId = floor;
      this.setData({
        floorId: this.data.floorId
      })
    }, */
    initFloorData () {
      // 取得楼层数据
      let _floors = bizUtil.getFloorNames(app.globalData.devs);
      console.log("initFloorData _floors = ", _floors);
      // 筛选出当前楼层数据
      let _filter = _floors.filter(item => bizUtil.getFloorByRoomId(item?.id) == app.globalData.familyInfo?.floor);
      // 如果有数据
      if (_filter?.length > 0) {
        this.data.floorId = _filter[0].id;
      } else {
        this.data.floorId = -1;
      }
      console.log("initFloorData this.data.floorId = ", this.data.floorId, app.globalData.familyInfo?.floor, _filter);
      this.data.floors = _floors || [];
      this.setData({
        floorList: this.data.floors,
        floorId: this.data.floorId
      })
    },

    // 关闭弹窗
    closePop () {
      // 触发上报到父组件
      this.triggerEvent('closepop', {})
    },
    floorManageClick () {
      // 如果管理权限，提示不支持
      if (app.globalData.roleNum == 2) {
        ability.showToast({
          title: "管理权限不允许编辑"
        })
        return;
      }
      // 触发上报到父组件
      this.triggerEvent('floormanage', {})
    },
    floorClick (e) {
      let {index} = e.currentTarget.dataset;
      let _item = this.data.floorList[index];
      // 触发上报到父组件
      this.triggerEvent('floorselect', {
        index,
        id: _item.id
      })
    }
  }
})
