// miniprogram/components/customHeader/index.js
import ability from "../../utils/classDef/ability"
Component({
  options: {
    addGlobalClass: true, // 全局样式
  },
  /**
   * 组件的属性列表
   */
  properties: {
    // 配置信息
    config: {
      type: Object,
      value: {
        show: true,
        // 左侧部分
        left: { // 不传为空
          text: "",
          // color: "",
          // fontSize: "",
          // handler: () => {} // 不传为默认的返回事件
        },
        center: { // 不传为空
          text: "center",
          centerType: ""
          // color: "",
          // fontSize: ""
          // ,handler: () => {} // 不传为无
        },
        right: { // 不传为空
          text: "",
          // color: "",
          // fontSize: ""
          // ,handler: () => {} // 不传为无
        }
      }
    }
  },
  /**
   * 页面的初始数据
   */
  data: {
    supportFloor: false, // 默认不支持楼层
    floorName: ""
  },

  lifetimes: {
    // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
    attached: function () {
    },
    moved: function () { },
    detached: function () { },
  },

  pageLifetimes: {
    show () {
    }
  },

  /**
   * 组件的方法列表
   */
  methods: {
    // 返回按钮
    bindback () {
      ability.navigateBack();
    },
    // 初始化bar条样式
    initNavBar (obj) {
      this.setData({
        show: !obj ? false : true
      })
    },
    // 初始化左侧部分
    initLeft (obj) {
      // console.log("customNav initLeft obj = ", obj);
      if (!obj || obj.text !== undefined || obj.type || obj.img !== undefined) {
        // 无或者有内容，则back为false
        this.setData({
          back: false,
          // left: obj.text
        })
        return;
      }
      this.setData({
        back: true
      });
    },
    // 初始化中间侧部分
    initCenter (obj) {
      // console.log("initCenter obj && obj.type = ", obj && obj.type);
      this.setData({
        title: !obj ? '' : obj.text,
        centerType: (obj && obj.type || "")
      });
    },
    // 初始化右侧部分
    initRight (obj) {
      // console.log("initRight = ", obj);
      this.setData({
        right: obj
      });
    },
    // 自定义按钮事件
    leftTopClick () {
      // console.log("leftTopClick leftClick", this.data.config);
      // console.log("leftTopClick leftClick", !!this.data.config.left.hander);
      // 当内容为空时，需要抛出
      if (this.data.config.left.hander) {
        // console.log("this.config.left.handler = ", this.data.config.left.handler);
        this.data.config.left.hander();
      } else {
        this.bindback();
      }
    },
    // 中间区域点击
    rightTopClick () {
      !!this.data.config.right && !!this.data.config.right.hander && (this.data.config.right.hander());
    },

    // 家庭按钮点击
    leftTextClick () {
      // 触发上报到父组件
      this.triggerEvent('lefttextclick', {})
    },

    // 楼层选择
    selectFloor () {
      console.log("selectFloor");
      // 触发上报到父组件
      this.triggerEvent('floorclick', {})
    },

    // 名称编辑点击
    editAccount () {
      // 触发上报到父组件
      this.triggerEvent('editaccount', {})
    },
    leftIconClick () {
      // 触发上报到父组件
      this.triggerEvent('editaccount', {})
    }
  }
})