// components/rowItem/index.js
Component({
  options: {
    addGlobalClass: true, // 全局样式
  },
  /**
   * 组件的属性列表
   */
  properties: {
    list: {
      type: Object,
      value: []
    },
    config: {
      type: Object,
      value: {}
    }
  },
  // observers: {
  //   'list': function (percent) {
  //     console.log("observers percent = ", percent);
  //     if (this.data.value == this.data.config?.value) {
  //       return;
  //     }
  //     // 根据百分比初始化数据
  //     this.initPositionByPercent(percent / 100);
  //   }
  // },

  /**
   * 组件的初始数据
   */
  data: {

  },

  /**
   * 组件的方法列表
   */
  methods: {
    itemClick (e) {
      let {index} = e.currentTarget.dataset;
      this.triggerEvent("itemclick", {
        index: index
      });
    },

    editClick (e) {
      this.pwrClick(e, 'edit');
    },
    openClick (e) {
      this.pwrClick(e, 'open');
    },
    closeClick (e) {
      this.pwrClick(e, 'close');
    },
    pwrClick (e, typeStr) {
      let {index} = e.currentTarget.dataset;
      this.triggerEvent("funcclick", {
        index: index,
        keyStr: typeStr
      });
    },
    switchChange (e) {
      let {value} = e?.detail || {};
      let {index, key} = e.currentTarget.dataset;
      console.log("switchChange value, index, key = ", value, index, key);
      this.triggerEvent("funcclick", {
        index: index,
        keyStr: key,
        value: value
      });
    }
  }
})
