// 引用broadlink类
import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil"

const app = getApp();

Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "最佳位置设置"
      }
    },
    // 最佳位置
    controlList: [],
    // 选择的最佳位置
    selectIdx: -1,
    // 设置类型下标
    typeIdx: 0,
    // 操作列表
    actionList: [/*{
      text: "最佳位置",
      handle: "setTheBest"
    },*/ {
      text: "全开的位置",
      handle: "setUp"
    }, {
      text: "全关的位置",
      handle: "setDown"
    }],

    from: "", // 是否来自场景中的链接
    
  },
  onLoad (options) {

    // 取得参数
    this.data.from = options.from;
    
    // 初始化数据
    this.initData();
    // 初始化选中值
    this.initTypeIdx();
  },
  onReady: function () {
    //获得dialog组件 
    // this.toastDialog = this.selectComponent("#toastDialog");//此处id和页面的 wxml中的id一致
  },
  initTypeIdx () {
    let {up, down} = bizUtil.getCurtainLimitConfig(app.globalData.devInfo);
    if (up && !down) {
      this.data.typeIdx = 1;
    } else {
      this.data.typeIdx = 0;
    }
    this.setData({
      typeIdx: this.data.typeIdx
    })
  },
  initData () {
    // 设置默认的下标
    this.initList(0);
  },
  initList (index, selected) {
    // 不选择任何数据
    if (!selected) {
      this.data.selectIdx = -1;
    }
    // 三个枚举值
    let _list = [
      {
        imgPath: "/device/img/curtain/on@2x.png",
        text: "开",
        selected: false,
        key: "up"
      }, {
        imgPath: "/device/img/curtain/pause@2x.png",
        text: "暂停",
        selected: false,
        key: "pause"
      }, {
        imgPath: "/device/img/curtain/off@2x.png",
        text: "关",
        selected: false,
        key: "down"
      }
    ];
    if (!!selected && index >= 0 && index < _list.length) {
      let _item = _list[index];
      let _imgPath = _item.imgPath;
      // 选中取反
      // _item.selected = selected;
      _item.imgPath = _imgPath.replace("@2x", "_sel@2x");
      // 选中数据
      this.data.selectIdx = index;
    }
    this.setData({
      controlList: _list
    })
  },
  selectPlace(e) {
    let _index = e.currentTarget.dataset.itemindex;
    console.log('set the best e = ', e, _index);
    let _item = this.data.controlList[_index];
    // 设置数据
    this.initList(_index, !_item.selected);
    // 发送数据
    this.actDev(_item.key);
  },
  setUp () {
    this.actDev({
      limitCtrl: 1,
      percent: 0xff
    })
  },
  setDown () {
    this.actDev({
      limitCtrl: 4,
      percent: 0xff
    })
  },
  setTheBest () {
    // 设置最佳位置
    this.actDev({
      limitCtrl: 5,
      percent: 0xff
    })
  },

  typeClick (e) {
    let _index = e.currentTarget.dataset.itemindex;
    if (_index == this.data.typeIdx) {
      return;
    }
    console.log('set the best e = ', _index);
    // let _item = this.data.actionList[_index];
    this.data.typeIdx = _index;
    let _updateObj = {
      typeIdx: this.data.typeIdx,
    };
    // 判断是否需要更新截图
    if (this.data.selectIdx != -1) {
      this.initList (this.data.selectIdx)
    }
    this.setData(_updateObj)
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || ""
    })
  },
  hideLoading () {
    ability.hideLoading();
  },
  actDev (key) {
    console.log("actDev key = ", key);
    // 取得发送数据
    let _result = app.globalData.blsdk.controlWithDevice(app.globalData.devInfo, key);
    if (!_result) {
      console.error("actDev _result = ", _result);
      return;
    }
    _result.then(() => {
      if (typeof key == "string") {
        return;
      }
      let _name = "";
      let _key = "";
      let _value = key.limitCtrl;
      if (_value == 5) {
        _name = "最佳位置";
      } else if (_value == 4) {
        _name = "下限位";
        _key = "down";
      } else if (_value == 1) {
        _name = "上限位";
        _key = "up";
      }

      // 更新限位
      if (!!_key) {
        bizUtil.setCurtainLimit(app.globalData.devInfo, {
          [_key]: true
        });
      }
      

      // // 保存位置
      // let _limitCtrls = app.globalData.devStatus.limitCtrls || [];
      // if (_limitCtrls.indexOf(_value) < 0) {
      //   // 没有设置过
      //   _limitCtrls.push(_value);
      // }
      ability.showToast({
        title: '已设置当前位置为' + _name
      });
    });
  },
  setVGroup (val) {
    if (!app.globalData.devInfo) {
      return;
    }
    if (val == 1 || val == 4) {
      app.globalData.devInfo.e = app.globalData.devInfo.e || {};
      app.globalData.devInfo.e.curtainLimit = app.globalData.devInfo.e.curtainLimit || {};
      if (val == 1) {
        // 上限位
        app.globalData.devInfo.e.curtainLimit.up = true;
      } else {
        // 下限位
        app.globalData.devInfo.e.curtainLimit.down = true;
      }
    }
  }
  /************** end ***************/
})
