// 引用broadlink类
import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil"
const app = getApp();
Page({
  data: {
    // 显示列表详情
    showDeail: false, 
    // 显示更多的logo
    showMore: true, // 默认显示
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: ""
      }
    },
    // 动态窗帘
    curtainWidth: 74,
    config: {
      max: 237,
      min: 74
    },
    // 设备状态
    devStatus: {},
    // 是否群控
    isGroup: app.globalData.devInfo == undefined,
    // 设备能力集合
    abilitys: {}, // 设备控制的能力

    devType: "open", // 默认open是开合帘 roll是卷帘 dream是梦幻帘
    dreamList: [
      {
        imgPath: "/device/img/curtain/dream/leftBtn.png",
        text: "左旋转",
        tap: "clickDreamLeft"
      }, {
        imgPath: "/device/img/curtain/dream/pause.png",
        text: "暂停",
        tap: "clickDreamPause"
      }, {
        imgPath: "/device/img/curtain/dream/rightBtn.png",
        text: "右旋转",
        tap: "clickDreamRight"
      }
    ],
  },
  onLoad (options) {
    // // 设置标题
    // this.title = options?.title;
    // // 判断页面是否群组，如果是群组，设备列表是否为空
    // let {gid, dids} = app.globalData.groupInfo || {};
    // let _isFixedGroup = this.isGroupCtrl();
    // console.log("onLoad gid, dids, _isFixedGroup = ", gid, dids, _isFixedGroup);
    // if (_isFixedGroup && gid >= 0 && !(dids?.length)) {
    //   // 跳转页面
    //   return ability.navigateTo("/groups/manage/index?remote=" + 0);
    // }
    // 获取设备状态
    this.getDevStatus(true);
    // 初始化设备能力
    let {v, t} = app.globalData.devInfo || {};
    this.data.abilitys = bizUtil.getJsonByAblitys(v, bizUtil.getDevTypeStr(t), {t}) || {};
  },
  onShow () {
    // 初始化controlList
    this.initPageByGroup();
    // 获取设备状态
    this.getDevStatus(false);
    // 提示
    this.checkLimit();
  },
  onUnload () {
    // 页面销毁 如果设置过百分比和最佳位置则保存设备状态
    this.saveDevStatus();
  },
  checkLimit () {
    let _devInfo = app.globalData.devInfo;
    // 如果是批量控制
    if (!_devInfo) {
      return true;
    }
    // 判断
    // let _devTypeStr = bizUtil.getDevTypeStr(_item.t);
    // // 如果是窗帘，判断是否设置了上下限位
    // if (_devTypeStr == "curtain") {
    console.log("checkLimit _devInfo = ", _devInfo);
    let {up, down} = bizUtil.getCurtainLimitConfig(_devInfo);
    if (!up || !down) {
      // 提示没有设置上下限位
      ability.showModal({
        title: "",
        content: "请设置窗帘限位，窗帘比例以及场景控制，才会生效",
        showCancel: true,
        confirmText: "去设置",
        confirmColor: "#F78D3F",
        cancelText: "取消",
        cancelColor: '#000000'
      }).then((res) => {
        console.log("success _item = ", _devInfo);
        if (!res) {
          return;
        }
        // // 设置设备信息
        // app.globalData.devInfo = _devInfo;
        // 跳转设置页面
        ability.navigateTo("/device/curtain/bestLocation/index");
      });
      return false;
    }
    return true;
  },
  // 是否群组控制
  isGroupCtrl () {
    return !!app.globalData.groupInfo && !!app.globalData.tgroupId;
  },
  // 区分群控页面
  initPageByGroup () {
    // 是否群组控制
    let _isGroupCtrl = this.isGroupCtrl();
    // 是否房间的控制
    let _roomCtrl = this.isRoomCtrl();
    // 是否群组的控制
    let _isGroup = (app.globalData.devInfo == undefined);
    this.data.isGroup = _isGroup;

    console.log("initPageByGroup _isGroupCtrl, _isGroup = ", _isGroupCtrl, _isGroup);
    // 是否显示详情
    this.data.showMore = _roomCtrl ? true : (_isGroupCtrl ? true : !_isGroup);
    // 设置标题
    this.setTitle({
      title: this.title,
      isGroupCtrl: _isGroupCtrl,
      isGroup: _isGroup
    });
    
    // 初始化控制列表
    this.data.controlList = this.getControlList(_isGroup);

    // 设置数据
    this.setData({
      controlList: this.data.controlList,
      navObj: this.data.navObj,
      showMore: this.data.showMore
    })
  },
  // 设置标题
  setTitle ({title, isGroupCtrl, isGroup}) {
    // 设置标题
    let _title = "";
    if (app.globalData?.tmpData?.roomInfo) {
      _title = app.globalData.tmpData.roomInfo?.n || "";
    } else if (isGroupCtrl) {
      // 标题
      _title = app.globalData.groupInfo?.n || "";
    } else {
      // 是否批量控制
      let _batch = isGroup ? (app.globalData.groupIds?.length > 0) : false;
      // 标题
      _title = this.getDevName(isGroup, _batch);
    }
    ability.setNavigationBarTitle(_title);
  },
  // 根据数据区分
  getControlList (isGroup) {
    // 控制列表
    let _controlList = [
      {
        imgPath: "/device/img/curtain/on@2x.png",
        text: "开",
        tap: "clickOpen"
      }, {
        imgPath: "/device/img/curtain/pause@2x.png",
        text: "暂停",
        tap: "clickPause"
      }, {
        imgPath: "/device/img/curtain/off@2x.png",
        text: "关",
        tap: "clickClose"
      }
      /* , {
        imgPath: "/device/img/curtain/best@2x.png",
        text: "最佳",
        tap: "clickBestPosition"
      } */
    ];
    return isGroup ? _controlList.slice(0, 3) : _controlList;
  },
  getDevStatus (isFirst) {
    // 取得当前设备的状态
    let _devStatus = {};
    // 第一次
    if (isFirst) {
      // 取得所有设备保存的状态数据
      let _allDevStatus = app.globalData.allDevStatus || {}; // this.getStorageByKey("bles_devStatus") || {};
      // 取得所有设备的状态
      // this.data.allDevStatus = _allDevStatus;
      // 根据设备did+短地址获取设备状态
      let _dev = app.globalData.devInfo;
      // 单个设备才记住设备状态
      !!_dev && (_devStatus = _allDevStatus[_dev.d + "_" + _dev.a]);
    } else {
      _devStatus = app.globalData.devStatus;
    }
    // 取得当前设备的状态
    app.globalData.devStatus = this.data.devStatus = _devStatus || {
      percent: 100, // 开合程度
      limitCtrls: []
    };

    // 第一次保存设备状态
    if (!isFirst) {
      return;
    }
    // 根据devStatus设置初始化数据
    this.initDataByDevStatus(this.data.devStatus);
    console.log("getDevStatus this.data.devStatus = ", this.data.devStatus);
    this.setData({
      devStatus: this.data.devStatus
    });
  },
  // 根据devStatus设置初始化数据
  initDataByDevStatus (devStatus) {
    if (!devStatus) {
      return;
    }
    // 初始化设备状态
    this.initCurtainByPercent(devStatus.percent || 0);
  },
  // 获取是否批量控制
  isBatchCtrl () {
    let _groupIds = app.globalData.groupIds;
    return (_groupIds?.length > 0) && (app.globalData.devInfo == undefined || Object.keys(app.globalData.devInfo).length == 0);
  },
  // 是否房间控制
  isRoomCtrl () {
    return !!app.globalData?.tmpData?.roomInfo;
  },
  // 这里是全屋控制和临时、固定群组控制
  isAllCtrl () {
    let _groupIds = app.globalData.groupIds;
    return (!_groupIds || _groupIds.length == 0) && app.globalData.devInfo == undefined
  },
  // 是否群组控制
  isGroupCtrl () {
    return !!app.globalData.groupInfo && !!app.globalData.tgroupId;
  },
  saveDevStatus () {
    // 保存的设备状态
    let _allDevStatus = app.globalData.allStatus || {};
    // 如果是批量
    if (this.isRoomCtrl()) {
      // 如果是全屋
      _allDevStatus[app.globalData?.tmpData?.roomInfo?.gid || 0] = this.data.devStatus;
    }
    else if (this.isBatchCtrl()) {
      console.log("saveDevStatus batchctrl")
      // 如果是批量
      _allDevStatus["batch"] = this.data.devStatus;
    } else if (this.isGroupCtrl()) {
      // 这里按照目前的逻辑 需要放在this.isAllCtrl判断之前
      console.log("saveDevStatus groupCtrl")
      let {gid} = app.globalData.groupInfo || {};
      // 如果是全屋
      _allDevStatus[gid] = this.data.devStatus;
      console.log("openLightDev gid, this.data.devStatus = ", gid, this.data.devStatus);
    } else if (this.isAllCtrl()) {
      console.log("saveDevStatus allCtrl")
      // 如果是全屋
      _allDevStatus["all"] = this.data.devStatus;
    } else {
      console.log("saveDevStatus singleCtrl")
      let _dev = app.globalData.devInfo;
      // 设备状态
      _allDevStatus[_dev.d + "_" + _dev.a] = this.data.devStatus;
    }
    app.globalData.allStatus = _allDevStatus;
    // 保存到缓存中
    app.setBizStorage("devStatus", _allDevStatus);
  },
  // saveDevStatus () {
  //   // 保存的设备状态
  //   let _dev = app.globalData.devInfo;
  //   if (!_dev) {
  //     return;
  //   }
  //   let _allDevStatus = this.data.allDevStatus || {};
  //   _allDevStatus[_dev.d + "_" + _dev.a] = this.data.devStatus;
  //   // 保存到缓存中
  //   this.setStorageByKey("bles_devStatus", _allDevStatus);
  // },
  getDevName (isGroup, batch) {

    // 补丁
    if (isGroup && app.globalData.tgroupId) {
      // 临时group存在
      return "批量控制"
    }
    return isGroup ? (batch ? "批量控制" : (app.globalData.roomInfo.id ? (app.globalData.roomInfo.n || '房间控制') : (app.globalData.roomInfo.n || "全屋控制"))) : (app.globalData.devInfo || {}).n;

    // return isGroup ? "全屋控制" : (app.globalData.devInfo || {}).n;
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || ""
    })
  },
  hideLoading () {
    ability.hideLoading();
  },
  getWidthConfigByType () {
    let _type = this.data.devType;
    let _result = {};
    if (_type == 'roll') {
      _result = {
        min: 74,
        max: 410,
      };
    } else if (_type == 'dream') {
      _result = {
        min: 110,
        max: 245,
      };
    } else {
      _result = {
        min: 74,
        max: 237,
      };
    }
    _result.mid = (_result.max - _result.min) / 2 + _result.min;
    return _result;
  },
  clickOpen () {
    let {min} = this.getWidthConfigByType();
    this.actDev("up", () => {
      this.setData({
        curtainWidth: min || 0
      })
    });
  },
  clickClose () {
    let {max} = this.getWidthConfigByType();
    this.actDev("down", () => {
      this.setData({
        curtainWidth: max || 0
      })
    });
  },
  clickPause () {
    let {mid} = this.getWidthConfigByType();
    this.actDev("pause", () => {
      this.setData({
        curtainWidth: mid || 0
      })
    });
  },

  // 滑块百分比
  sliderChange (event) {

    // 如果是单个设备控制，才判断是否设置上下限位
    if (app.globalData.devInfo) {
      let {up, down} = bizUtil.getCurtainLimitConfig(app.globalData.devInfo);
      // 新的判断方法：判断是否设置了上线限位和最佳位置
      if (!up || !down) {
        wx.showModal({
          title: "提示",
          // showCancel: true,
          content: "请设置上限位和下限位", // "请在右上角【功能设置】-【最佳位置设置】中设置上下限"
          confirmText: "去设置"
        }).then((result) => {
          if (result?.confirm) {
            ability.navigateTo("../bestLocation/index");
            return;
          }
        });
        return;
      }
    }
    // // 判断是否设置了上线限位和最佳位置
    // let _limitCtrls = app.globalData.devStatus.limitCtrls;
    // if (!this.isAllInArray([1, 4], _limitCtrls)) {
    //   wx.showModal({
    //     title: "提示",
    //     // showCancel: true,
    //     content: "请设置上限位和下限位", // "请在右上角【功能设置】-【最佳位置设置】中设置上下限"
    //     confirmText: "去设置"
    //   }).then((result) => {
    //     if (result?.confirm) {
    //       ability.navigateTo("../bestLocation/index");
    //       return;
    //     }
    //   });
    //   return;
    // }

    let _val = event.detail.value;
    console.log("sliderChange _val = ", _val);
    // 执行
    this.actDev({
      percent: _val
    }, () => {
      this.data.devStatus.percent = _val;
      // 按照百分比
      this.initCurtainByPercent(_val);
      // 设置
      this.setData({
        devStatus: this.data.devStatus
      });
    });
  },

  // 梦幻帘
  clickDreamLeft () {
    this.actDev({
      rotate: "left"
    }, () => {
      this.data.devStatus.rotate = "left";
    });
  },
  clickDreamRight () {
    this.actDev({
      rotate: "right"
    }, () => {
      this.data.devStatus.rotate = "right";
    });
  },
  clickDreamPause () {
    this.actDev({
      rotate: "pause"
    }, () => {
      this.data.devStatus.rotate = "pause";
    });
  },
  // 滑块百分比
  dreamSliderChange (event) {
    let _val = Number(event?.detail?.value) || 0;
    console.log("dreamSliderChange _val = ", _val);
    // 执行
    this.actDev({
      rotatePercent: _val
    }, () => {
      this.data.devStatus.rotatePercent = _val;
    });
  },


  initCurtainByPercent (percent) {
    let {max, min} = this.data.config || {};
    if (max < min || max == 0 || max == undefined || min == undefined) {
      return;
    }
    let _percent = (100 - percent) / 100;
    if (_percent < 0) {
      _percent = 0;
    } else if (_percent > 1) {
      _percent = 1;
    }
    let _val = _percent * (max - min) + min;
    this.setData({
      curtainWidth: _val
    })
  },
  actDev (key, callBack) {

    // 隐藏等待条
    this.hideDetailDialog(false);

    // !!callBack && (callBack());
    // return;

    //保存当前数据
    let _deviceInfo = app.globalData.devInfo;
    // 如果是房间控制
    console.log("actDev key, e = ", key, _deviceInfo);

    let _result = undefined;
    // 如果是临时组控制
    if (!_deviceInfo) {
      if (app.globalData.tgroupId) {
        // 临时group控制
        _result = app.globalData.blsdk.groupControlWithType(43499, app.globalData.tgroupId, key);
      } else {
        // 全屋或者房间控制
        _result = app.globalData.blsdk.groupControlWithType(43499, (app.globalData.roomInfo || {}).id || 0, key);
      }
    } else {
      // 单个设备控制
      _result = app.globalData.blsdk.controlWithDevice(_deviceInfo, key);
    }
    
    // 判断是否正常
    if (!_result || !_result.then) {
      // // 初始化窗帘数据
      // this.initDataByDevStatus(this.data.devStatus);
      console.log("actDev _result = ", _result);
      return;
    }
    _result.then(() => {
      !!callBack && (callBack());
    });
  },
  /************** end ***************/

  clickBestPosition () {
    // 判断是否设置了上线限位和最佳位置
    let _limitCtrls = app.globalData.devStatus.limitCtrls;
    if (!this.isAllInArray([1, 4, 5], _limitCtrls)) {
      wx.showModal({
        title: "提示",
        // showCancel: true,
        content: "请设置上限位、下限位和最佳位置", // "请在右上角【功能设置】-【最佳位置设置】中设置上下限"
        confirmText: "去设置"
      }).then((result) => {
        if (result?.confirm) {
          ability.navigateTo("../bestLocation/index")
        }
      });
      return;
    }
    this.actDev("best", () => {
      // 百分比
      this.data.devStatus.percent = '最佳位置';
      this.data.curtainWidth = 74;
      // 暂时设置到最大
      this.setData({
        curtainWidth: 74,
        devStatus: this.data.devStatus
      })
    });
  },
  // 判断简单不重复数据是否在数组中
  isAllInArray (values, array) {
    if (!array) {
      return false;
    }
    let _typeStr = typeof values;
    if (_typeStr == "string" || _typeStr == "number") {
      return array.indexOf(values) >= 0;
    }
    return array.sort().join('').indexOf(values.sort().join('')) >= 0;
  },

  hideDetailClick () {
    this.hideDetailDialog(false);
  },
  hideDetailDialog (value) {
    this.setData({
      showDeail: value || false
    })
  },

  // 详情按钮
  showDeailBtn() {

    // 如果是群组控制页面
    if (this.isGroupCtrl()) {
      return this.toDevDetail();
      // return this.toGroupManage();
    }

    // 如果是分享权限，则没有功能设置页面
    if (app.globalData.roleNum == 2 || this.isRoomCtrl()) {
      return this.toDevDetail();
    }
    
    let _showDetail = !this.data.showDeail;
    this.hideDetailDialog(_showDetail);
    // this.setData({
    //   showDeail: _showDetail
    // })
  },
  // 功能设置按钮
  toFuncSetting() {
    this.hideDetailDialog(false);
   
    console.log('toFuncSetting')

    ability.navigateTo("/device/curtain/funcSetting/index?devType=curtain")

    // wx.navigateTo({
    //   url: '../funcSetting/index'
    // })
  },
  // 群组管理页面
  toGroupManage () {
    ability.navigateTo("/groups/manage/index")
  },
  // 设备详情
  toDevDetail() {
    this.hideDetailDialog(false);
    console.log('toDevDetail')

    ability.navigateTo("/device/light/devProperty/index?type=curtain&remote=" + (this.data.abilitys?.remote || 0));
  }
})
