import ability from '../../../utils/classDef/ability'
const app = getApp();
Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "名称修改"
      }
    },
    devName: '', // 设备名称
    fromPage: "", // 来源页面
    roomId: 0, // 需要修改的房间的名称

    // 用于家庭管理传入其他家庭用
    familyId: undefined,
    familyInfo: undefined, // 房间信息
    allDevs: undefined // 家庭下所有设备信息
  },
  onLoad (options) {
    // 接收参数
    this.data.roomId = options.roomId || 0;
    this.data.fromPage = options.from;
   // 初始化设备名称
   this.initDevName(options.name);
   // 初始化家庭和家庭下的设备数据
   this.initAllDataByFamily(options.familyId);
  },
  // 根据家庭id取得数据
  initAllDataByFamily (familyId) {
    this.data.familyId = familyId;
    let _devs = undefined;
    let _familyInfo = undefined;
    if (familyId >= 0) {
      let _familyInfos = app.globalData.familys.filter(item=>item.id==familyId);
      _familyInfo = _familyInfos[0];
      _devs = app.globalData.allFamilysMap[familyId];
    }
    this.data.familyInfo = _familyInfo || app.globalData.familyInfo; // 房间信息
    this.data.allDevs = _devs || app.globalData.devs;
  },
  initDevName (name) {
    let _name = decodeURIComponent(name || app.globalData.devInfo.n || "");
    if (_name.length > 16) {
      _name = _name.substr(0, 16);
    }
    this.setNameItem(_name);
  },

  clearName () {
    this.setNameItem("");
  },

  setNameItem (name) {
    this.data.devName = name || "";
    this.setData({
      devName: this.data.devName
    })
  },

  nameInput (e) {
    let _name = e.detail.value;
    if (_name.length > 16) {
      this.showToast("名称长度不能大于16").then((isConfirm) => {
        this.setData({
          devName: _name.substr(0, 16)
        })
      });
      return;
    }
    this.data.devName = _name;
    console.log("nameInput _name = ", _name);
  },
  showToast (str) {
    return wx.showModal({
      showCancel: false,
      content: str || "名称长度不能大于16"
    });
  },
  saveStorage (roomId, name) {
    let _roomId = roomId || 0;
    // 保存名称
    this.data.allDevs[_roomId].n = name;
    
    console.error("curtain saveStorage");
    // 保存设备信息
    app.saveAllDevsMap();
  },
  saveName () {
    let _name = (this.data.devName || '').trim();
    if (_name.length == 0) {
      this.showToast("名称不能为空");
      return;
    } else if (_name.length > 16) {
      this.showToast("名称长度不能大于16");
      return;
    }
    console.log("saveName _name = ", _name, _name.length);
    // 判断是否从房间详细进入的页面
    let _fromPage = this.data.fromPage;
    if (_fromPage == "roomDetail") {
      // 保存
      this.saveStorage(this.data.roomId, _name);
    } else if (_fromPage == "sceneName") {
      app.globalData.sceneInfo.n = _name;
    } else {
      app.globalData.devInfo.n = _name;
      console.error("curtain saveName");
      // 保存设备信息
      app.saveAllDevsMap();
      // app.setBizStorage("devs", app.globalData.devs);
    }

    // 返回
    ability.navigateBack();
  }
})
