// device/fan/timer/index.js
import ability from '../../../utils/classDef/ability'
import bizUtil from '../../../utils/bizUtil'
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    current: [0, 0], // 当前选择时分
    hours: [0,1,2,3], // 时
    minutes: [], // 分

    brightness: 0
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let _devInfo = app.globalData.devInfo;
    this.data.brightness = options.brightness || 127;
    // 判断进入页面的类型 默认是风扇灯（0） 风扇（1）
    this.isFan = this.checkFanTypeByDevInfo(_devInfo);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    this.data.hours = this.initHours();
    console.log("this.data.hours = ", this.data.hours);
    this.data.minutes = this.initMinutes();
    this.setData({
      hours: this.data.hours,
      minutes: this.data.minutes
    })
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  initHours () {
    return this.getArray(0, 24);
  },
  initMinutes () {
    return this.getArray(0, 60);
  },
  getArray (min = 0, max = 60) {
    let _array = [];
    for (let i = min; i < max; i++) {
      _array.push(i);
    }
    return _array
  },
  bindChange(e) {
    // console.log("bindChange e = ", e);
    const vals = e.detail.value;
    this.data.current = vals || [];
    // return;
    // this.setData({
    //   year: this.data.years[val[0]],
    //   month: this.data.months[val[1]],
    //   day: this.data.days[val[2]],
    //   isDaytime: !val[3]
    // })
  },
  saveTimer () {
    console.log("saveTimer = ", this.data.current);
    let _array = this.data.current || [];
    if (_array.length < 2) {
      return;
    }
    let _delayH = _array[0];
    let _delayM = _array[1];
    // 延迟秒数
    let _delay = parseInt(_delayH * 3600 + _delayM * 60);
    // 发送控制命令
    this.actDevDelaySet({
      delay: _delay,        // 延迟时间，单位秒 (最大2个字节)
      start: this.data.brightness,        // 起始亮度 (最大1个字节)
      interval: 0,   // 执行间隔，单位秒(最大1个字节)
      step: -127,        // 步长(正负) (最大1个字节，大于0表示变亮，小与0表示变暗)
      count: 1      // 执行次数(最大1个字节)
    }, () => {
      // 计算出当前的时间戳
      let _timestamp = Date.now() / 1000;
      // 定时的时间戳
      app.globalData.timerInfo.timestamp = _timestamp + _delay;
      console.log("saveTimer _timestamp + _delay = ", _timestamp, _delay, _timestamp + _delay);
      // 返回
      this.back();
    })
  },
  actDevDelaySet (cmd, callback) {
    let _devInfo = app.globalData.devInfo;
    if (this.isFan) {
      return this.delayFanCtrl(_devInfo, cmd, callback);
    }
    // 关闭定时
    return app.globalData.blsdk.delayCtrl(_devInfo, cmd || {}, callback)
  },
  delayFanCtrl (devInfo, cmd, callback) {
    // 单个设备控制
    let _result = app.globalData.blsdk.controlWithDevice(devInfo, {
      timestamp: cmd?.delay || 0
    });
    if (!_result?.then) {
      ability.showToast({
        title: "设置失败"
      })
      return;
    }
    _result.then(res => {
      !!callback && (callback());
    })
  },
  back () {
    ability.navigateBack();
  },
  checkFanTypeByDevInfo (devInfo) {
    let _devTypeStr = bizUtil.getDevTypeStr(devInfo?.t);
    if (_devTypeStr == "fan") {
      return 1;
    }
    return 0;
  }
})