import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil"
import {Utils} from "../../../utils/util"

var app = getApp();
module.exports = Behavior({
  // behaviors: [],
  // data: {
  // },
  // pageLifetimes: {
  //   show (options) {
  //   }
  // },
  // ready () {
  // },
  methods: {
    // 根据时间格式取得执行时间和重复次数
    getRepeatAndTimeByFormat (str) {
      let _result = {
        repeatTip: "仅一次",
        repeat: "",
        hour: 0,
        minute: 0,
      };
      if (!str || str.length == 0) {
        return _result;
      }
      // 0_0_10_*_*_0,4,5_* str的格式 或者 0_11_17_14_10_*_2022
      let _array = str.split("_");
      // 时间和星期
      _result.minute = Number(_array[1]) || 0;
      _result.hour = Number(_array[2]) || 0;
      let _week = _array[5];
      let _year = _array[6];
      if (_year != "*") {
        // 仅一次
      } else if (_week == "*") {
        // 每天
        _result.repeat = "0,1,2,3,4,5,6";
        _result.repeatTip = "每天";
      } else {
        // 星期N集合
        _result.repeat = _week;
        _result.repeatTip = this.getTipByRepeat(_week);
      }
      return _result;
    },
    getHHMMStr (hour, minute) {
      return Utils.formatNumbers(hour || 0) + ":" + Utils.formatNumbers(minute || 0);
    },
    // 循环场景tip
    // getCycleTipByCmdCnt (cmdCnt) {
    //   let _cmdCnt = cmdCnt || 0;
    //   if ()
    // },
    getTipByRepeat (repeatStr) {
      if (!repeatStr) {
        return "仅一次"
      }
      let _weekConfig = {
        0: "周日",
        1: "周一",
        2: "周二",
        3: "周三",
        4: "周四",
        5: "周五",
        6: "周六"
      };
      // 重复数据排序和去重
      let _repeats = repeatStr.split(",").sort();
      let _repeatArray = Array.from(new Set(_repeats));
      let _repeatArrayLen = _repeatArray.length;
      if (_repeatArrayLen == 7) {
        return "每天";
      } else if (_repeatArrayLen == 2) {
        // 周末
        let _arrayStr = _repeatArray.join(",")
        if (_arrayStr == "0,6") {
          return "周末";
        }
      } else if (_repeatArrayLen == 5) {
        // 工作日
        let _arrayStr = _repeatArray.join(",")
        if (_arrayStr == "1,2,3,4,5") {
          return "工作日";
        }
      }
      let _resultArray = _repeatArray.map(item => _weekConfig[item]);
      return _resultArray.join(" ")
    },
    getBase64CmdAndType (base64Str) {
      if (!base64Str || base64Str.length == 0) {
        return '';
      }
      let _json = app.globalData.blsdk.base64ToJson(base64Str);
      console.log("getBase64Cmd _json = ", _json);
      // _cmdType = _json?.type || 0;
      let _buffer = ability.base64ToArrayBuffer(_json?.raw);
      let _cmdArray = Array.prototype.slice.call(new Uint8Array(_buffer));
      console.log("getItems _cmdArray = ", _cmdArray, Utils.ab2hex(_cmdArray));
      // 转hex
      let _hexStr = Utils.ab2hex(_cmdArray);
      console.log("getBase64Cmd _cmdArray, _hexStr = ", _cmdArray, _hexStr);
      return {
        array: _cmdArray,
        hex: _hexStr,
        type: _json?.type || 0
      }
    },
    getTimerByRepeatAndTime ({hour, minute, week}) {
      // 取得当前时间
      if (hour == undefined && minute == undefined) {
        return bizUtil.getTimerByRepeatAndTime(week);
      }
      return bizUtil.getTimerByRepeatAndTime(week, hour + ":" + minute);
    },
    getStatusJsonByCmdArray (array, type) {
      // 取得命令头 4个字节
      let {retryseq, flag: meshFlag} = this.getStatusHeader(array.slice(0, 4));
      console.log("getStatusJsonByCmdArray type, retryseq = ", type, retryseq);
      // type取值很关键 0 - 单控，1 - 群控，2 - 场景触发， 3 - 循环情景
      if (type == 0 || !type) {
        return {
          retryseq: retryseq, // 是否大于255
          meshFlag: meshFlag,
          data: this.getDevStatusByArray(array.slice(4), retryseq, meshFlag)
        }
      } else if (type == 2) {
        return {
          meshFlag: meshFlag,
          data: this.getSceneJsonByArray(array.slice(4), meshFlag)
        }
      } else if (type == 1) {
        return {
          meshFlag: meshFlag,
          data: this.getGroupStatusByArray(array.slice(4), meshFlag)
        }
      }
      return {
        meshFlag: 1,
        data: {}
      };
    },
    getStatusHeader (array) {
      return app.globalData.blsdk.getJsonByBleHead(array);
    },
    // 群组的json数据
    getGroupStatusByArray (array) {
      let _result = {};
      if (!array || array.length == 0) {
        return _result;
      }
      // 取得家庭下全部群组
      let _groupId = array[3];
      let _groupArray = bizUtil.getGroupsByGidInJson(app.globalData.devs, _groupId);
      if (!_groupArray || _groupArray.length == 0) {
        return _result;
      }
      let _groupInfo = _groupArray[0];
      // 设备信息
      _result.device = _groupInfo;
      // 命令指令
      let _cmdArray = array.slice(4);
      // 这里除了面板返回的都是json,面板没法组数据，暂时返回array
      console.log("getGroupStatusByArray _cmdArray, _groupInfo = ", _cmdArray instanceof Array, _groupInfo);
      _result.cmdData = bizUtil.getJsonByCmdAndType(_cmdArray, _groupInfo.t);
      return _result;
    },
    // 场景的json数据
    getSceneJsonByArray (array) {
      let _result = {};
      if (!array) {
        return _result;
      }
      let _rid = array[1] || 0;
      let _type = array[2] || 0;
      let _sid = array[3] || 0;
      // 取得场景信息
      let _sceneArray = app.globalData.devs[_rid]?.scenes || [];
      let _sceneInfoArray = _sceneArray.filter(item => item.sid == _sid);
      if (_sceneInfoArray.length == 0) {
        return _result;
      }
      return _sceneInfoArray[0];
    },
    // 这里不支持群组和场景
    getDevStatusByArray (array, retryseq, meshFlag) {
      console.log("getDevStatusByArray array, retryseq = ", array, retryseq);
      let _result = {};
      if (!array) {
        return _result;
      }
      let _length = (array[0] || 0) & 0x0f;
      let _addr = ((retryseq || 0) << 8) + (array[1] || 0);
      // 取得对应的设备信息
      let _infoMap = this.getAddrDevsMap(app.globalData.devs, "devs", "a");
      console.log("getDevStatusByArray _infoMap, array, _addr = ", _infoMap, array, _addr);
      let _info = _infoMap[_addr];
      if (!_info) {
        console.error("getDevStatusByArray _infoMap, _addr = ", _infoMap, _addr);
        return _result;
      }
      // console.log("getDevStatusByArray _info = ", _info);
      // 设备信息
      _result.device = _info;
      // 这里除了面板返回的都是json,面板没法组数据，暂时返回array
      let _json = bizUtil.getJsonByCmdAndType(array.slice(2), _info.t);
      // 如果是白灯且亮度大于0，则pwr设置为开
      let _devTypeStr = bizUtil.getDevTypeStr(_info.t);
      console.log("getDevStatusByArray _info, _devTypeStr = ", _info, _devTypeStr);
      let _isWhite = bizUtil.getBleCatetoryByPid(_devTypeStr, _info.t);
      console.log("getDevStatusByArray _isWhite, _json = ", _isWhite, _json);
      if (_isWhite == "LIGHT" && _json.brightness > 0) {
        _json.pwr = 1;
      }
      _result.cmdData = _json;

      return _result;
    },
    // 取得短地址的addr集合 key:devs\groups\scenes  devKey:d\sid\gid
    getAddrDevsMap (devs, key, devKey) {
      let _result = {};
      if (!devs) {
        return _result;
      }
      let _key = key || "devs";
      let _devKey = devKey || "d";
      for (let rid in devs) {
        let _devs = (devs[rid] || {})[_key];
        if (!_devs) {
          continue;
        }
        for (let item of _devs) {
          _result[item[_devKey]] = item
        }
      }
      return _result;
    },
    // 判断循环情景还是定时
    checkCycle () {
      return !app.globalData.timerInfo.time;
    },

    cycleManageByIndexAndData (status, params, index) {

      console.log("cycleManageByIndexAndData status, params = ", status, params);

      // 编辑的数据
      let {array, type} = app.globalData.blsdk.getGatewayCycleCmd(status, params);
      // 编辑还是新增
      let _editIndex = index;
      if (_editIndex < 0 || _editIndex == undefined) {
        app.globalData.timerInfo.bodyList.push({
          interval: 0, // 默认5ms
          type: type,
          len: array.length,
          data: array
        });
        app.globalData.timerInfo.headObj.cmd_cnt = app.globalData.timerInfo.bodyList.length;
      } else {
        let _oldTimeObj = app.globalData.timerInfo.bodyList[_editIndex] || {};
        app.globalData.timerInfo.bodyList[_editIndex] = {
          interval: _oldTimeObj.interval || 0,
          type: type,
          len: array.length,
          data: array
        };
      }
    },
    getDefaultTime () {
      // 取得当前时间
      let {hour, minute} = Utils.getDateObj();
      return this.getTimerByRepeatAndTime({
        hour, minute
      });
    },
    getOnceTimeByTimer (timerInfo) {
      console.log("getOnceTimeByTimer timerInfo = ", timerInfo);
      if (!timerInfo) {
        return this.getDefaultTime();
      }
      let {repeat, hour, minute} = this.getRepeatAndTimeByFormat(timerInfo.time);
      // 如果有值则不是执行一次
      if (repeat) {
        return;
      }
      console.log("getOnceTimeByTimer hour, minute = ", hour, minute);
      return this.getTimerByRepeatAndTime({
        hour, minute
      });
    },

    // 仅一次数据转成标准数据 0_11_21_13_10_*_2022 转成标准格式2018/10/07 11:00:00
    getOnceFormatStrByTimer (str) {
      if (!str) {
        return "";
      }
      let _array = str.split("_");
      return bizUtil.padStart(_array[6], 4) + "/" + bizUtil.padStart(_array[4], 2) + "/" + bizUtil.padStart(_array[3], 2) + " " + bizUtil.padStart(_array[2], 2) + ":" + bizUtil.padStart(_array[1], 2) + ":" + bizUtil.padStart(_array[0], 2);
    },
    // 时间格式转成 0_11_21_13_10_*_2022
    getOnceSetTimerByFormat (dataObj) {
      if (!dataObj) {
        return "";
      }
      let {year, month, day, hour, minute, second} = Utils.getDateObj(dataObj);
      return [second, minute, hour, day, month, "*", year].join("_");
      // return bizUtil.padStart(_array[6], 4) + "_" + bizUtil.padStart(_array[4], 2) + "/" + bizUtil.padStart(_array[3], 2) + " " + bizUtil.padStart(_array[2], 2) + ":" + bizUtil.padStart(_array[1], 2) + ":" + bizUtil.padStart(_array[0], 2);
    },

    // 根据设置的时间取得东八区的时间 ios需要2018/10/07 11:00:00这个格式才能转
    getSetTimeByZone (dataStr) {
      let _dateStr = dataStr || "";
      console.log("getSetTimeByZone _dateStr = ", _dateStr);
      let _seperatorMinute = Utils.getSeperatorMinite();
      // 这里注释的是原先从当天0点查到23：59，后面改成查24小时之内
      console.log("getSetTimeByZone _seperatorMinute = ", _seperatorMinute);
      
      let _utcTime = new Date(_dateStr);
      let _utcTimestamp = _utcTime.getTime();
      let _startDate = new Date(_utcTimestamp - _seperatorMinute * 60 * 1000);
      
      return this.getOnceSetTimerByFormat(_startDate);
    },

    // 根据当前时区获取设置的真实时间
    getListByZone (list) {
      if (!list || list.length == 0) {
        return [];
      }
      for (let item of list) {
        let _timeStr = item?.time || "";
        // 保存原始数据
        item.oriTime = _timeStr;
        item.time = this.getTimeByZone(_timeStr);
        console.log("getListByZone originTime, afterTime = ", _timeStr, item.time);
      }
      return list;
    },
    // 仅一次：0_11_17_14_10_*_2022  星期日-六：0_55_18_*_*_0,1,2,3,4,5,6_*
    getTimeByZone (timeStr, typeStr) {
      if (!timeStr) {
        return "";
      }
      // 取得当前时间
      let {year, month, day, hour, minute, second} = Utils.getDateObj();
      // 数据解析 6个长度
      let _array = timeStr.split("_");
      // 时间数据 格式为 2022-10-13_10:34:12
      let _totleStr = "";
      // 判断是否仅一次还是星期几
      let _onlyOnce = _array[5] == "*";
      if (_onlyOnce) {
        // 仅一次
        _totleStr = bizUtil.padStart(_array[6], 4) + "-" + bizUtil.padStart(_array[4], 2) + "-" + bizUtil.padStart(_array[3], 2) + "_" + bizUtil.padStart(_array[2], 2) + ":" + bizUtil.padStart(_array[1], 2) + ":" + bizUtil.padStart(_array[0], 2);
      } else {
        // 星期N集合
        _totleStr = bizUtil.padStart(year + "", 4) + "-" + bizUtil.padStart(month + "", 2) + "-" + bizUtil.padStart(day + "", 2) + "_" + bizUtil.padStart(_array[2], 2) + ":" + bizUtil.padStart(_array[1], 2) + ":" + bizUtil.padStart(_array[0], 2);
      }
      console.log("getTimeByZone _totleStr = ", _totleStr);
      // 当前时区的时间
      let _cData = Utils.getDateByTimezone(_totleStr);
      let {year:cYear, month:cMonth, day:cDay, hour:cHour, minute:cMinute, second:cSecond} = Utils.getDateObj(_cData);
      if (_onlyOnce) {
        return [cSecond, cMinute, cHour, cDay, cMonth, "*", cYear].join("_");
        // 0_11_17_14_10_*_2022
      } else {
        // 如果是每天则返回
        let _weekArray = _array[5]?.split(",") || [];
        console.log("getTimeByZone _weekArray = ", _weekArray);
        if (_weekArray.length == 7) {
          return [cSecond, cMinute, cHour, "*", "*", _array[5], "*"].join("_");
        } else {
          // 需要计算是否前后一天
          // 0_55_18_*_*_0,1,2,3,4,5,6_*
          let _seperatorMinute = (typeStr == "set" ? -1 : 1) * Utils.getSeperatorMinite();
          let _overflowMinute = _seperatorMinute + (Number(_array[1]) || 0) + ((Number(_array[2]) || 0) * 60);
          console.log("getTimeByZone _overflowMinute = ", _overflowMinute);
          let _sortArray = [];
          if (_overflowMinute < 0) {
            // 往前一天
            _sortArray = this.getWeeksArray(_weekArray, -1);
          } else if (_overflowMinute >= (24 * 60)) {
            // 往后一天
            _sortArray = this.getWeeksArray(_weekArray, 1);
          } else {
            _sortArray = _weekArray;
          }
          let _str =_sortArray.join(",");
          console.log("getTimeByZone after _str, _sortArray = ", _str, _sortArray);
          return [cSecond, cMinute, cHour, "*", "*", _str, "*"].join("_");
        }
      }
    },
    // 设置超当天还是前一天 -1：往前一天  +1：往后一天
    getWeeksArray (weekArray, setVal) {
      if (!weekArray) {
        return [];
      }
      let _setVal = Number(setVal) || 0;
      let _sortArray = weekArray.map(item => {
        let _value = (Number(item) || 0) + _setVal;
        if (_value > 6) {
          _value = 0;
        } else if (_value < 0) {
          _value = 6;
        }
        return _value;
      }).sort();
      return _sortArray;
    },
    // 根据设置的时间取得东八区的时间 timeStr：0_55_18_*_*_0,1,2_*
    getWeekZoneTimeByStr (timeStr) {
      if (!timeStr) {
        return "";
      }
      // 取得当前时间
      let {year, month, day, hour, minute, second} = Utils.getDateObj();
      // 数据解析 6个长度
      let _array = timeStr.split("_");
      // 时间数据 格式为 2022-10-13_10:34:12
      let _totleStr = bizUtil.padStart(year + "", 4) + "/" + bizUtil.padStart(month + "", 2) + "/" + bizUtil.padStart(day + "", 2) + " " + bizUtil.padStart(_array[2], 2) + ":" + bizUtil.padStart(_array[1], 2) + ":" + bizUtil.padStart(_array[0], 2);
      // 与东八区的间隔
      let _seperatorMinute = Utils.getSeperatorMinite();
      console.log("getWeekZoneTimeByStr _totleStr = ", _totleStr);
      let _timeStamp = new Date(_totleStr).getTime() - _seperatorMinute * 60 * 1000;
      console.log("getWeekZoneTimeByStr _timeStamp = ", _timeStamp);
      // dataStr：2018/10/07 11:00:00
      let {year:cYear, month:cMonth, day:cDay, hour:cHour, minute:cMinute, second:cSecond} = Utils.getDateObj(new Date(_timeStamp));

      // 如果是每天则返回
      let _weekArray = _array[5]?.split(",") || [];
      // 判断是否提前或者靠后一天
      if (_weekArray.length == 7) {
        return [cSecond, cMinute, cHour, "*", "*", _array[5], "*"].join("_");
      } else {
        // 需要计算是否前后一天
        // 0_55_18_*_*_0,1,2,3,4,5,6_*
        let _overflowMinute = (Number(_array[1]) || 0) + ((Number(_array[2]) || 0) * 60) - _seperatorMinute;
        console.log("getWeekZoneTimeByStr _overflowMinute = ", _overflowMinute);
        let _sortArray = [];
        if (_overflowMinute < 0) {
          // 往前一天
          _sortArray = this.getWeeksArray(_weekArray, -1);
        } else if (_overflowMinute >= (24 * 60)) {
          // 往后一天
          _sortArray = this.getWeeksArray(_weekArray, 1);
        } else {
          _sortArray = _weekArray;
        }
        let _str =_sortArray.join(",");
        console.log("getWeekZoneTimeByStr after _str, _sortArray = ", _str, _sortArray);
        console.log("getWeekZoneTimeByStr cSecond, cMinute, cHour = ", cSecond, cMinute, cHour);
        return [cSecond, cMinute, cHour, "*", "*", _str, "*"].join("_");
      }
    }
  },
})