// device/gateway/cyclescene/delaySet/index.js
import ability from "../../../../utils/classDef/ability"
import bizUtil from "../../../../utils/bizUtil"
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    hours: [],
    minutes: [],
    seconds: [],
    milliseconds: [],
    current: [0, 0, 4]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    console.log("delaySet options = ", options);
    let {index, meshFlag} = options || {};
    this.editIndex = index || 0;
    this.meshFlag = Number(meshFlag) || 0; // 默认是0 关闭
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    // 初始化时间数据
    this.initTimes();
    // 默认选择的数据
    this.initCurrentDateByIndex(this.editIndex);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },

  initTimes (data) {
    // // 初始化小时
    // this.data.hours = this.getArray(0, 24);
    // 初始化分钟
    this.data.minutes = this.getArray(0, 60);
    // 秒
    this.data.seconds = this.getArray(0, 60);
    // 毫秒
    this.data.milliseconds = this.getArray(0, 1000, 100);

    this.setData({
      // hours: this.data.hours,
      minutes: this.data.minutes,
      seconds: this.data.seconds,
      milliseconds: this.data.milliseconds
    })
  },
  getTimeArrayByInterval (interval) {
    if (!interval) {
      return;
    }
    let _interval = interval * 100;
    console.log("getTimeArrayByInterval _interval = ", _interval);
    let _tmpData = parseInt(_interval / 1000);
    let _second = parseInt(_tmpData % 60);
    let _minite = parseInt(_tmpData / 60);
    let _ms = parseInt((_interval % 1000) / 100);
    if (_ms == 0 && _minite == 0 && _second == 0) {
      return;
    }
    return [_minite, _second, _ms];
  },
  initCurrentDateByIndex (index) {
    let _default = [0, 0, 5]; // 默认500ms
    if (index >= 0) {
      let _interval = (app.globalData.timerInfo?.bodyList || [])[index]?.interval;
      _default = this.getTimeArrayByInterval(_interval) || _default;
    }
    // 这里必须要用延迟 如果是在onload周期中
    // setTimeout(() => {
      console.log("initCurrentDate _default = ", _default)
      this.setData({
        current: _default
      })
    // }, 0);
  },
  getArray (min = 0, max = 60, step = 1) {
    let _array = [];
    for (let i = min; i < max; ) {
      _array.push(i);
      
      i += step;
    }
    return _array
  },
  bindChange (e) {
    let _vals = e.detail.value;
    console.log("bindChange _vals = ", _vals);

    this.data.current = _vals;

    // 如果时长选择了0 0 0，则提示用户不可用选择
    // let _current = this.data.current;
    // if (_current.join("") == _vals.join("")) {
    //   // 如果数据选择相等
    // }
  },
  // 取得毫秒数据
  getMilliseconds (array) {
    let _result = 0;
    if (!array || array.length == 0) {
      return _result;
    }
    let _byte0 = array[0] || 0;
    let _byte1 = array[1] || 0;
    let _byte2 = array[2] || 0;
    let _byte3 = array[3] || 0;
    return _byte0
  },

  back () {
    ability.navigateBack();
  },

  getIntervalByCurrent (current) {
    if (!current || current.length == 0) {
      return 1;
    }
    let _byte1 = current[0] || 0;
    let _byte2 = current[1] || 0;
    let _byte3 = current[2] || 0;
    // 默认的单位是100ms 所以需要除以100ms
    return _byte1 * 60 * 10 + _byte2 * 10 + _byte3;
  },

  save () {

    // 网关或者ihg设备信息
    let _devInfo = app.globalData.devInfo || {};

    let _vals = this.getIntervalByCurrent(this.data.current || []);
    console.log("save _vals = ", _vals);
    if (_vals == 0) {
      // 需要更新默认的分钟数
      return ability.showToast({
        title: "请设置循环间隔"
      });
    } else if (this.meshFlag || bizUtil.isIhg(_devInfo.t)) {
      // 如果组网使能打开，则需要大于等于300ms
      // 增加判断如果是ihg则最小间隔必须300
      if (_vals < 3) {
        return ability.showToast({
          title: "组网使能必须大于等于300毫秒"
        });
      }
    }
    // 如果下标小于0，说明是默认间隔设置
    console.log("save this.editIndex, _vals = ", this.editIndex, _vals);
    if (this.editIndex < 0) {
      app.globalData.timerInfo.headObj.interval = _vals;
      return this.back();
    }
    // 循环情景数据
    let _item = (app.globalData.timerInfo?.bodyList || [])[this.editIndex];
    if (!_item) {
      return this.back();
    }
    _item.interval = _vals;
    // 返回上一个页面
    this.back();
  },
  getStrByTimestamp (timestamp) {
    if (timestamp == undefined || timestamp == 0) {
      return "";
    }
    if (timestamp < 60) {
      return "0"
    }
    let _day = parseInt(timestamp / (24 * 3600));
    let _h = parseInt((timestamp - _day * 24 * 3600) / 3600);
    let _m = parseInt((timestamp - _day * 24 * 3600 - _h * 3600) / 60);
    let _str = "";
    (_day) && (_str += _day + '天');
    (_h) && (_str += _h + '小时');
    (_m) && (_str += _m + '分钟');
    return _str;
  },
})