// device/gateway/cyclescene/detail/index.js
import ability from "../../../../utils/classDef/ability"
import bizUtil from "../../../../utils/bizUtil"
const app = getApp();
const timeBehavior = require("../../behavior/time")
Page({
  behaviors: [timeBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    topList: [],
    bottomList: [],
    isEdit: false, // 是否
    bottomBtns: [], // 底部按钮

    showActionsheet: false,
    acts: [{
      text: "仅执行一次",
      value: 1,
      tap: "once"
    }, {
      text: "无限循环",
      value: 0,
      tap: "max"
    }, {
      text: "自定义",
      value: 2,
      tap: "custom"
    }]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    let {title, index} = options || {};
    // 默认间隔
    let {dft} = this.getStatus(app.globalData.devInfo);
    !!app.globalData?.timerInfo?.headObj && (app.globalData.timerInfo.headObj.interval = dft || 5);
    // 是否编辑场景
    this.index = index == undefined ? -1 : index;
    // // 默认组网使能
    // this.meshFlag = this.index < 0 ? 1 : 0;
    // 初始化标题
    this.setNavTitleByIndex(title, this.index);
    // 根据index初始化底部按钮
    this.initBottomBtnsByIndex(this.index);
    // 保存设备信息
    this.devInfo = app.globalData.devInfo;
  },

  setNavTitleByIndex (title, index) {
    let _title = title || "";
    if (!title) {
      _title = index >= 0 ? "编辑循环场景" : "创建循环场景";
    }
    ability.setNavigationBarTitle(decodeURIComponent(_title))
  },

  initBottomBtnsByIndex (index) {
    let _bottomBtns = this.getAllBtns();
    if (index < 0) {
      _bottomBtns = _bottomBtns.filter((item) => item.key != "del");
    }
    this.setData({
      bottomBtns: _bottomBtns
    })
  },
  getAllBtns () {
    return [{
      text: "删除",
      className: "delBtn",
      handle: "delCycle",
      key: "del"
    }, {
      text: "保存",
      className: "saveBtn",
      handle: "saveCycle",
      key: "save"
    }]
  },  

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow () {
    // 保存设备信息
    app.globalData.devInfo = this.devInfo;
    // 清空执行设备
    this.actionDevs = [];
    // 根据定时数据初始化渲染数据
    this.initDataByTimer(app.globalData.timerInfo);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {
    if (!this.devInfo) {
      return;
    }
    // 保存设备信息
    app.globalData.devInfo = this.devInfo;
    // 保存默认间隔
    this.saveStatus(this.devInfo);
  },

  // 取得设备默认间隔
  getStatus (devInfo) {
    if (!devInfo) {
      return {};
    }
    let {a, d} = devInfo || {};
    let _keyStr = d + "_" + a;
    return app.globalData.allStatus[_keyStr] || {};
  },
  // 保存设备默认间隔
  saveStatus (devInfo) {
    if (!devInfo) {
      return;
    }
    let {a, d} = devInfo || {};
    let _keyStr = d + "_" + a;
    app.globalData.allStatus[_keyStr] = {
      dft: app.globalData.timerInfo?.headObj?.interval || 5 // 保存默认时间, 500ms
    };
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  initDataByTimer (timerInfo) {
    if (!timerInfo) {
      return;
    }
    let {headObj, bodyList} = timerInfo;
    console.log("initDataByTimer timerInfo = ", timerInfo);
    // 顶部条目
    this.data.topList = this.getItems(headObj);
    // 执行设备
    let {array: cycleList, meshFlag} = this.getActions(bodyList);
    this.data.bottomList = cycleList || [];
    console.log("initDataByTimer meshFlag, this.meshFlag = ", meshFlag, this.meshFlag);
    // 如果有组网使能
    if (this.data.topList?.length > 0) {
      if (this.meshFlag == undefined) {
        // 默认组网使能
        this.meshFlag = meshFlag || 0;
      }
      let _findIndex = this.data.topList.findIndex(item => item.key == "meshEnable");
      if (_findIndex >= 0) {
        this.data.topList[_findIndex].value = this.meshFlag;
      }
    }
    console.log("initDataByTimer this.data.topList, this.data.bottomList = ", this.data.topList, this.data.bottomList);
    // 渲染数据
    this.setData({
      topList: this.data.topList,
      bottomList: this.data.bottomList
    })
  },
  // 循环场景tip
  getCycleTipByCmdCnt (cmdCnt, array) {
    let _cmdCnt = cmdCnt || 0;
    let _arrayLen = array?.length;
    if (!_arrayLen) {
      return "";
    }
    let _filterArray = [];
    console.log("getCycleTipByCmdCnt _cmdCnt, _arrayLen = ", _cmdCnt, _arrayLen);
    if (_cmdCnt >= _arrayLen) {
      _filterArray = array.slice(-1);
    } else {
      _filterArray = array.filter(item => item.value == _cmdCnt);
    }
    console.log("getCycleTipByCmdCnt _filterArray = ", _filterArray);
    if (_filterArray.length == 0) {
      return "";
    }
    let _tip = _filterArray[0]?.text || "";
    console.log("getCycleTipByCmdCnt _tip, cmdCnt = ", _tip, cmdCnt);
    return cmdCnt > 1 ? (cmdCnt + "次") : _tip;
  },
  getItems ({name, cycle_cnt, interval}) {
    return [{
      title: "循环名称",
      value: name || "",
      key: "name",
      edit: true
    }, {
      title: "重复设置",
      value: this.getCycleTipByCmdCnt(cycle_cnt, this.data.acts),
      key: "repeat",
      edit: true
    }, {
      title: "默认间隔",
      value: !interval ? "未设置" : ((interval * 100) + "毫秒"), // this.getCycleTipByCmdCnt(cycle_cnt, this.data.acts),
      key: "seperator",
      edit: true
    }, {
      title: "组网使能",
      value: 1, // 默认开启组网使能
      key: "meshEnable",
      edit: false,
      type: "pwrswitch"
    }];
  },
  getActions (bodyList) {
    let _result = {
      array: [],
      meshFlag: 1 // 默认使能开
    };
    let _length = bodyList?.length || 0;
    if (_length == 0) {
      return _result;
    }
    // 使能
    // 设备名称
    for (let i = 0; i < _length; i++) {
      let {data, len, interval, type} = bodyList[i] || {};
      
      // device设备信息 cmdData json的数据
      let {meshFlag, data: _json} = this.getStatusJsonByCmdArray(data || [], type);
      // 使能赋值
      _result.meshFlag = meshFlag || 0;
      console.log("getActions _json = ", _json);
      if (type == 2) {
        // 场景
        _result.array.push({
          title: _json?.n || "", // 场景名称
          tip: "",
          delayTip: this.getDelayTipByDelay((interval || 0) * 100), // (i < (_length - 1)) ? () : '' // 这里单位是100毫秒
          tabIndex: type, // 用于addDevice页面显示用
          sid: _json?.sid || 0,
          imgStr: _json?.i >= 0 ? ("/static/img/common/scene/" + (_json.i || 0) + ".png") : "",
          imgClass: "size58",
          imgParentClass: "size68 bgF78D3F radiuHalf marginLR16"
        })
      } else {
        let {device, cmdData} = _json;

        // 特殊处理，因为这里发的是pwr=0,亮度>0,所以
        let _tmpJson = Object.assign({}, cmdData || {});
        if (_tmpJson.brightness > 0) {
          _tmpJson.pwr = 1;
        }

        // 根据json取得tip
        let _tip = bizUtil.getTipByStatus(_tmpJson, device?.t) || "";

        // 临时保存执行设备的信息
        this.actionDevs = this.actionDevs || [];
        this.actionDevs.push(Object.assign({}, device, {
          cmd: cmdData
        }));
        
        _result.array.push({
          title: device?.n || "未知设备", // 设备名称
          tip: _tip,
          delayTip: this.getDelayTipByDelay((interval || 0) * 100), // (i < (_length - 1)) ? () : '' // 这里单位是100毫秒
          devIndex: this.actionDevs.length - 1,
          imgStr: (device?.tStr) ? ("/static/img/common/" + device.tStr + ".png") : ""
        })
      }
    }
    console.log("getActions _result = ", _result);
    return _result;
  },
  // milTimestamp 毫秒的时间戳
  getDelayTipByDelay (msTimestamp) {
    let _tip = "";
    if (!msTimestamp) {
      _tip = "默认间隔";
    } else {
      let _ms = parseInt(msTimestamp % 1000); // 毫秒
      let _second = parseInt(msTimestamp / 1000) % 60; // 秒
      let _minite = parseInt(msTimestamp / 1000 / 60); // 分
      !!_minite && (_tip += (_minite + "分"));
      !!_second && (_tip += (_second + "秒"));
      !!_ms && (_tip += (_ms + "毫秒"));
    }
    console.log("getDelayTipByDelay msTimestamp, _tip = ", msTimestamp, _tip);
    return _tip;
  },

  delaySet (e) {
    let {index} = e.currentTarget.dataset;
    // 组网使能
    let _meshFlag = this.getMeshFlag();
    console.log("delaySet _meshFlag = ", _meshFlag);
    // -1表示默认间隔设置
    ability.navigateTo('../delaySet/index?type=cycle&index=' + index + "&meshFlag=" + _meshFlag);
  },
  addActionDev (e) {
    let _flag = this.getMeshFlag();
    let _index = (typeof e == "number") ? e : -1;
    ability.navigateTo('../../timer/addDevice/index?type=cycle&index=' + _index + '&meshFlag=' + _flag);
  },
  delCycle () {
    ability.showModal({
      title: "",
      content: "是否确认删除该循环场景",
      showCancel: true,
    }).then(res => {
      if (!res) {
        return;
      }
      this.delCycleDetail();
    });
  },
  delCycleDetail () {
    // let _devInfo = app.globalData.devInfo || {};
    let _timeInfo = app.globalData.timerInfo || {};
    let _sceneIndex = _timeInfo?.headObj?.scene_idx;
    console.log("delCycleDetail _timeInfo = ", _timeInfo);
    if (_sceneIndex == undefined) {
      return ability.showToast({
        title: "场景索引为空"
      });
    }
    ability.showLoading({
      title: "删除中"
    });

    // ihg
    let _devInfo = Object.assign({}, app.globalData.devInfo || {});
    _devInfo.d = _devInfo.wd || _devInfo.d;

    app.globalData.blsdk.gatewayCycle(_devInfo, {
      type: "del",
      cscene_idx: _sceneIndex
    }, (res) => {
      ability.hideLoading();
      console.log("saveClick res = ", res);
      let {status} = res || {};
      if (status == 0) {
        this.showToastMsg("删除成功");
        // 删除场景中绑定的循环场景
        this.delCycleInScene(app.globalData.devInfo, _sceneIndex, app.globalData.devs);
        // 返回
        setTimeout(() => {
          this.back();
        }, 1000);
      } else {
        this.showToastMsg("删除失败")
      }
    })
  },
  // 从场景中删除循环场景
  delCycleInScene (devInfo, sceneIndex, allDevs) {
    if (!devInfo || !allDevs || sceneIndex == undefined) {
      return;
    }
    // let {d} = devInfo;
    for (let roomId in allDevs) {
      let _roomDetail = allDevs[roomId] || {};
      let {scenes} = _roomDetail;
      if (!scenes || scenes.length == 0) {
        continue;
      }
      for (let sceneInfo of scenes) {
        let {devs} = sceneInfo || {};
        if (!devs || devs.length == 0) {
          continue;
        }
        sceneInfo.devs = devs.filter(item => {
          let {d, cmd} = item;
          if (d == devInfo.d && (cmd instanceof Array) && cmd[1] == sceneIndex) {
            return false;
          }
          return true;
        })
      }
    }
    // 保存
    app.saveAllDevsMap();
  },
  saveCycle () {
    // let _devInfo = app.globalData.devInfo || {};
    let _timeInfo = app.globalData.timerInfo || {};
    console.log("saveClick _timeInfo = ", _timeInfo);

    // 如果没有执行设备
    if (!_timeInfo.bodyList || _timeInfo.bodyList.length == 0) {
      return ability.showToast({
        title: "请选择执行设备"
      });
    }

    // 等待条
    ability.showLoading({
      title: "保存中"
    });

    let _type = 0;
    let _tipStr = "";
    if (this.index >= 0) {
      // 编辑
      _type = "edit";
      _tipStr = "编辑";
    } else {
      // 新增
      _type = "add";
      _tipStr = "添加";
      // _timeInfo.id = 0; // 新增为0或者为空
    }
    // 这里有个bug:cmd_cnt没有更新导致没有数据 
    _timeInfo.headObj.cmd_cnt = _timeInfo.bodyList?.length || 0;
    console.log("saveClick _type = ", _type);

    // 增加一个处理逻辑
    let _defaultInterval = _timeInfo.headObj?.interval || 0;
    // _timeInfo.bodyList = 
    _timeInfo.bodyList.map(item => {
      item.interval = item.interval || _defaultInterval;
      return item;
    });
    console.log("saveCycle _timeInfo.bodyList = ", _timeInfo.bodyList);

    // ihg
    let _devInfo = Object.assign({}, app.globalData.devInfo || {});
    _devInfo.d = _devInfo.wd || _devInfo.d;

    // 发送
    app.globalData.blsdk.gatewayCycle(_devInfo, {
      type: _type,
      headObj: _timeInfo.headObj,
      bodyList: _timeInfo.bodyList
    }, (res) => {
      ability.hideLoading();

      console.log("saveClick res = ", res);
      let {status} = res || {};
      if (status == 0) {
        this.showToastMsg(_tipStr + "成功");
        setTimeout(() => {
          this.back();
        }, 1000);
      } else {
        this.showToastMsg(_tipStr + "失败")
      }
    })
  },
  // 组网使能
  getMeshFlag () {
    // console.log("getMeshFlag this.data.topList = ", JSON.stringify(this.data.topList), this.meshFlag);
    return this.meshFlag;
    // // 组网使能
    // let _meshFlag = this.data.topList.filter(item => item.key == "")Number([2]?.value) || 0;
    // return _meshFlag;
  },
  back () {
    ability.navigateBack();
  },
  showToastMsg (msg) {
    ability.showToast({
      title: msg
    });
  },
  actionSheetItemClick (e) {
    console.log("actionSheetItemClick e = ", e);
    // let {value} = e.detail;
    let _value = Number(e?.detail?.value) || 0;
    if (_value < 2) {
      app.globalData.timerInfo.headObj.cycle_cnt = _value;
      // 更新数据
      this.setData({
        [`topList[1].value`]: this.getCycleTipByCmdCnt(_value, this.data.acts)
      })
    } else {
      ability.navigateTo("../repeat/index?value=" + app.globalData.timerInfo?.headObj?.cycle_cnt || 0);
    }
    // 隐藏循环条目
    this.setActionSheet(false);
  },
  itemClick (e) {
    console.log("itemClick e = ", e);
    let {index} = e.detail;
    if (index == 0) {
      let {title, value} = this.data.topList[index];
      // 修改循环名称
      ability.navigateTo("../../../light/deviceName/index?from=gatewaycycle&title=" + encodeURIComponent(title) + "&name=" + encodeURIComponent(value));
    } else if (index == 1) {
      // 重复设置
      this.setActionSheet(true);
    } else if (index == 2) {
      // 默认间隔设置
      this.delaySet({
        currentTarget: {
          dataset: {
            index: -1
          }
        }
      });
    }
  },
  // 删除提示
  detailDelClick (e) {
    // ios有个bug, tap长按和tap会重复触发
    let {index} = e.currentTarget.dataset;
    let _item = this.data.bottomList[index];
    ability.showModal({
      title: "",
      content: "是否删除" + (_item?.title || "") + "?",
      showCancel: true,
      // confirmColor: param.confirmColor || "#576B95",
      // confirmText: param.confirmText || "确定",
      // cancelText: param.cancelText || "取消",
      // cancelColor: param.cancelColor || '#000000',
    }).then((res) => {
      if (!res) {
        return;
      }
      // 删除设备
      this.delDevInList(index);
    })
  },
  // 删除循环场景下的设备
  delDevInList (index) {
    let _bodyList = app.globalData.timerInfo?.bodyList || [];
    if (index < 0 || index >= _bodyList.length) {
      return;
    } 
    // 删除设备
    _bodyList.splice(index, 1);
    app.globalData.timerInfo.headObj.cmd_cnt = _bodyList.length;
    // 根据定时数据初始化渲染数据
    this.initDataByTimer(app.globalData.timerInfo);
  },
  // 设备详情
  detailClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.bottomList[index];

    // 取得组网使能
    let _meshFlag = this.getMeshFlag();

    // 判断是否场景
    if (_item.tabIndex != undefined) {
      // 场景
      ability.navigateTo("../../timer/addDevice/index?meshFlag=" + _meshFlag + "&typeIndex=" + _item.tabIndex+ "&did=" + _item.sid + "&index=" + index);
      return;
    }

    console.log("detailClick this.actionDevs = ", this.actionDevs);
    let _devInfo = this.actionDevs[_item.devIndex];
    if (!_devInfo) {
      console.error("_devInfo isnot exist");
      return;
    }

    // 判断是未知设备
    if (!_devInfo?.cmd) {
      // 空设备
      this.addActionDev(Number(index))
      // ability.navigateBack();
      return;
    }

    let _devTypeKey = bizUtil.getDevTypeStr(_devInfo?.t);
    app.globalData.devInfo = _devInfo;
    if (_devTypeKey == "panel" || _devTypeKey == "powerstrip") {
      return ability.navigateTo("../../timer/pwrAvalible/index?index=" + index + "&meshFlag=" + _meshFlag + "&devType=" + _devTypeKey);
    }
    return ability.navigateTo("../../timer/status/index?index=" + index + "&meshFlag=" + _meshFlag);
  },
  setActionSheet (value) {
    this.setData({
      showActionsheet: value || false
    })
  },

  funcClick (e) {
    let {index, keyStr, value} = e?.detail || {};
    console.log("funcClick value = ", value);

    // 判断是否有设备间隔小于300ms 只有组网使能打开的情况下才判断是否有间隔
    if (value) {
      let _bodyList = app.globalData.timerInfo?.bodyList || [];
      let _existUnable = _bodyList.filter(item => item.interval < 3);
      if (_existUnable.length > 0) {
        let _index = this.data.topList.findIndex(item => item.key == "meshEnable");
        if (_index < 0) {
          return;
        }
        this.setData({
          [`topList[${_index}].value`]: 0
        });
        return ability.showToast({
          title: "循环间隔大于等于300毫秒才能打开组网使能"
        })
      }
    }
    
    // 更新状态
    this.meshFlag = Number(value) || 0;
    console.log("funcClick this.meshFlag = ", this.meshFlag);
    // 如果有循环列表，则重新组命令
    this.reGetCmdByList(this.data.bottomList);

    // this.getActions(bodyList)
  },
  // 循环列表重新组命令
  reGetCmdByList (array) {
    if (!array || array.length == 0) {
      return;
    }
    console.log("reGetCmdByList array, app.globalData.timerInfo = ", array, app.globalData.timerInfo);
    // 如果是场景，则不组命令
    for (let index in array) {
      let {sid, tabIndex, } = array[index] || {};
      let {data, interval, len, type} = (app.globalData.timerInfo?.bodyList || [])[index];
      if (!data) {
        continue;
      }
      // device设备信息 cmdData json的数据 retryseq只有设备有
      let {meshFlag, data: _json, retryseq} = this.getStatusJsonByCmdArray(data || [], type);
      console.log("reGetCmdByList meshFlag, _json = ", meshFlag, _json);
      // 判断场景，群组还是单个设备 0 - 单控，1 - 群控，2 - 场景触发
      this.getDevCmd(_json, index);
      // if (type == 0 || type == 1) {
      //   this.getDevCmd(_json, index);
      // } else if (type == 2) {
      //   this.getDevCmd({
      //     cmdData: {
      //       sid: item.sid,
      //       rid: item.rid
      //     }
      //   })
      // }
    }
  },
  // 取得单个设备的拼接
  getDevCmd (json, index) {
    if (!json) {return;}
    let {device, cmdData, sid, rid} = json;
    // 取得选中的设备命令 组网使能
    let _params = {meshFlag: this.meshFlag};
    if (sid >= 0 && rid >= 0) {
      cmdData = {
        sid: sid,
        rid: rid
      };
      _params.scene = 2;
    } else if (device?.gid) {
      // 群组
      _params.group = device?.gid;
      _params.devType = bizUtil.getDevTypeStr(device?.t) == "curtain" ? 43499 : 43050;
    } else {
      _params.device = device;
    }
    // 命令不需要额外补0
    _params.noFillZero = true;
    // 编辑的数据
    this.cycleManageByIndexAndData(cmdData, _params, index)
  }
})