const ability = require("../../../../utils/classDef/ability");
const app = getApp();
// device/gateway/cyclescene/repeat/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    pickRole: [2, 256],
    current: [1], // 当前默认值
    counts: [], // 选择的循环次数
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    console.log("onLoad options = ", options);
    // 设置默认值
    let {value} = options || {};
    this.value = value == undefined ? -1 : (Number(value) || 0);
    // 设置
    this.initCounts();
  },

  initCounts () {
    let _pickRole = this.data.pickRole || [];
    let _startVal = Number(_pickRole[0]) || 0;
    let _endVal = Number(_pickRole[1]) || 0;
    let _counts = this.getArray(_startVal, _endVal);
    this.setData({
      counts: _counts
    });
  },

  setDefaultValue (defaultVal) {
    let _value = 0;
    if (defaultVal > 1) {
      let _pickRole = this.data.pickRole || [];
      let _startVal = Number(_pickRole[0]) || 0;
      _value = (defaultVal - _startVal);
    }
    this.setData({
      current: [_value]
    })
  },
  
  getArray (min = 0, max = 60) {
    let _array = [];
    for (let i = min; i < max; i++) {
      _array.push(i);
    }
    return _array
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {
    // 设置默认值
    this.setDefaultValue(this.value);
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },

  bindChange (e) {
    let _vals = e.detail.value;
    console.log("bindChange _vals = ", _vals);
    this.data.current = _vals || [];
  },

  save () {
    let _index = this.data.current[0] || 0;
    let _value = this.data.counts[_index] || 2;
    console.log("save _index, _value = ", _index, _value);
    app.globalData.timerInfo.headObj.cycle_cnt = _value;
    // 返回
    this.back();
  },
  back () {
    ability.navigateBack();
  }
})