import ability from '../../../utils/classDef/ability'
import bizUtil from '../../../utils/bizUtil'
// import GROUPS from '../../../static/js/jsConfig/groups'
const app = getApp()
// addPages/gateway/code/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: [],

    from: '', // 从哪个页面跳转过来，默认是上一个页面

    devInfo: undefined, // 网关信息
    showDetail: false, // 是否显示详细页面

    roleNum: 0 // 权限
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let {t} = app.globalData.devInfo || {};
    // 权限
    this.data.roleNum = app.globalData.roleNum;
    // 是否显示详细
    this.data.showDetail = options.detail || false;
    // 保存页面从哪边跳转过来
    this.data.from = options.from || "";
    // 设备类型
    this.isIhg = bizUtil.isIhg(t);
    // 初始化平台
    this.data.list = this.getListByPid(this.isIhg);
    this.setData({
      showDetail: this.data.showDetail,
      roleNum: this.data.roleNum,
      from: this.data.from,
      list: this.data.list
    });
  },
  initTitle (title) {
    ability.setNavigationBarTitle(decodeURIComponent(title || ""));
  },
  getListByPid (isIhg) {
    let _format = "/static/img/mine/thirdVoice/";
    let _result = [
      {
        key: 'thirdvoice',
        text: "语音等第三方服务",
        icon: _format + 'sound.png',
        url: 'https://cloud-oauth-chn-8e7bc87a.ibroadlink.com/fastcon_smart_home_skills/tianmao.html'
      }, {
        key: 'timer',
        text: "定时",
        icon: _format + 'time.png',
        url: 'https://cloud-oauth-chn-8e7bc87a.ibroadlink.com/fastcon_smart_home_skills/xiaodu.html'
      },
      {
        key: 'cyclescene',
        text: "循环情景",
        icon: _format + 'cycle.png',
        url: 'https://cloud-oauth-chn-8e7bc87a.ibroadlink.com/fastcon_smart_home_skills/xiaoai.html'
      }
    ];
    // return isIhg ? _result.slice(0, 1) : _result;
    return _result;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let {n} = app.globalData.devInfo || {};
    // 设置标题
    this.initTitle(n || '');
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
  },
  
  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    let {key, text} = this.data.list[index];

    if (key == "thirdvoice") {
      ability.navigateTo("../thirdparty/index")
    } else if (key == "cyclescene") {
      this.clearTimer();
      ability.navigateTo("../timer/list/index?type=cycle&title=" + encodeURIComponent(text))
    } else if (key == "timer") {
      this.clearTimer();
      ability.navigateTo("../timer/list/index?type=time&title=" + encodeURIComponent(text))
    }
  },
  clearTimer () {
    app.globalData.timerList = [];
    app.globalData.timerInfo = {};
  },
  jumpDetail () {
    ability.navigateTo("/device/light/devProperty/index")
  }
})