import ability from '../../../utils/classDef/ability'
import bizUtil from '../../../utils/bizUtil'
import GROUPS from '../../../static/js/jsConfig/groups'
const app = getApp()
// addPages/gateway/code/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    code: "",
    list: [],

    from: '', // 从哪个页面跳转过来，默认是上一个页面
    showCode: false,

    devInfo: undefined, // 网关信息
    showDetail: false, // 是否显示详细页面

    roleNum: 0, // 权限

    configTitle: "语音设备同步配置"
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 权限
    this.data.roleNum = app.globalData.roleNum;
    // 是否显示详细
    this.data.showDetail = options.detail || false;
    // 设备标题
    this.data.title = decodeURIComponent(options.title || "");
    // 保存页面从哪边跳转过来
    this.data.from = options.from || "";

    this.setData({
      showDetail: this.data.showDetail,
      roleNum: this.data.roleNum,
      from: this.data.from
    });

    // 初始化平台
    this.initList();
    
    console.log("onLoad app.globalData.devInfo = ", app.globalData.devInfo);
    let _devInfo = app.globalData.devInfo;
    // 如果有网关设备
    if (_devInfo && (Object.keys(_devInfo).length > 0)) {
      // 判断是否有设备信息，如果有，则显示授权code
      this.initDevInfo(app.globalData.devInfo);
      // 显示code
      this.setShowCode(true);
    } else {
      let _devInfo = this.getGatewayInfo();
      if (!_devInfo) {
        // 不显示code
        this.setShowCode(false);
        // 如果没有网关，则不显示数据
        return;
      }
      // 判断是否有设备信息，如果有，则显示授权code
      this.initDevInfo(_devInfo);
      // 显示code
      this.setShowCode(true);
    }
  },
  // 初始化页面标题
  initTitle (name) {
    // 设置标题 options.title || 
    let _title = name || '';
    ability.setNavigationBarTitle(decodeURIComponent(_title));
  },
  // 取得家庭下的第一个网关设备
  getGatewayInfo () {
    let _devInfo = bizUtil.getGatewayInfo(app.globalData.devs);
    return _devInfo;
  },
  setShowCode (value) {
    this.data.showCode = value || false;
    this.setData({
      showCode: this.data.showCode
    })
  },
  initDevInfo (devInfo) {
    let _devInfo = devInfo;
    if (!_devInfo) {
      console.log("_devInfo is not exist");
      return;
    }
    // 设置设备类型
    let _devTypeStr = bizUtil.getDevTypeStr(_devInfo.t);
    if (_devTypeStr == "gateway") {
      this.getGatewayCode();
    }
  },
  getAllList () {
    var _format = "/static/img/mine/thirdVoice/";
    return [{
      key: 'tmall',
      name: "天猫精灵",
      icon: _format + 'tmall.png',
      url: 'https://cloud-oauth-chn-8e7bc87a.ibroadlink.com/fastcon_smart_home_skills/tianmao.html'
    }, {
      key: 'duer',
      name: "小度",
      icon: _format + 'duer.png',
      url: 'https://cloud-oauth-chn-8e7bc87a.ibroadlink.com/fastcon_smart_home_skills/xiaodu.html'
    }, {
      key: 'xiaoai',
      name: "小爱同学",
      icon: _format + 'xiaoai.png',
      url: 'https://cloud-oauth-chn-8e7bc87a.ibroadlink.com/fastcon_smart_home_skills/xiaoai.html'
    }/*, {
      key: 'google',
      name: "Google Assistant",
      icon: _format + 'google.png'
    }, {
      key: 'alexa',
      name: "Alexa",
      icon: _format + 'alexa.png'
    }*/];
  },
  initList () {
    this.data.list = this.getAllList();
    this.setData({
      list: this.data.list
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let _from = this.data.from;
    if (_from == "config" || _from == "mine" || _from == 'ihgconfig') {
      this.initTitle(this.data.title);
    } else {
      this.initTitle(app.globalData.devInfo?.n);
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
  },

  // 如果是网关设备，取得网关的授权码
  getGatewayCode () {
    // // 取得多网关的信息
    // let {sid, skey} = app.globalData.familyInfo || {};
    // if (!sid || !skey) {
    // 为了防止数据不正确，这里每次上报一次数据
    return app.uploadPrivateData((id, key) => {
      if (id == undefined && key == undefined) {
        this.setData({
          code: "设备已被复位"
        })
        return;
      }
      // 获取网关code
      this.getGatewayCodeDetail(id, key);
    });
    // }
    // console.log("getGatewayCode sid, skey = ", sid, skey);
    // // 获取网关code
    // this.getGatewayCodeDetail(sid, skey);
  },
  getGatewayCodeDetail (sid, skey) {
    // 网关链接的集群
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    
    // 取得网关的code devInfo
    app.globalData.blsdk.getAuthCode({
      d: sid.slice(0, 32),
      k: skey,
      // t: _gatewayT == 10058 ? 10058 : 43719 // ihg用10058 蓝牙网关用43719
    }, _groupStr).then((code) => {
      console.log("getGatewayCode result = ", code);
      this.data.code = code;
      this.setData({
        code: code
      })
    }).catch(e => {
      this.setData({
        code: "设备已被复位"
      })
    });;
  },

  copyClick () {
    console.log("copyClick");
    // 复制按钮点击
    ability.setClipboardData({
      data: this.data.code
    });
  },
  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.list[index];
    ability.navigateTo("/webview/index?from=third&jumpTo=" + encodeURIComponent(_item.url))
  },
  nextStep () {
    if (this.data.from == 'ihgconfig') {
      return ability.navigateBack(3);
    }
    // 如果是从配网进来，则
    if (this.data.from == "config") {
      return ability.navigateBack(2);
    }
    ability.navigateBack();
  },
  jumpDetail () {
    ability.navigateTo("/device/light/devProperty/index")
  },
  // // 跳转语音设备同步配置页面
  // jumpCodeConfig () {
  //   ability.navigateTo("./config/index?title=" + encodeURIComponent(this.data.configTitle))
  // }
})