const ability = require("../../../../utils/classDef/ability")
const app = getApp();
const bizUtil = require("../../../../utils/bizUtil")
const timeBehavior = require("../../behavior/time")
// scene/addDevice/index.js
Page({
  behaviors: [timeBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备选择"
      }
    },
    actionList: [],
    did: "",
    roomChanged: false, // 是否弹出选择房间
    rooms: [],
    roomInfo: {
      id: 0, // 默认全屋
      n: '全屋'
    },

    roomJson: {}, // 所有房间json
    isFloor: false, // 是否多楼层

    from: "", // 页面来源
    devTypeStr: "", // 是否需要进行展示设备的筛查
    // type: 0, // 发送的数据
    key: 0, // 按键序号
    sid: -1, //
    rid: 0, //

    bottomBts: [{ // 默认按钮
      name: "下一步",
      handles: "next",
      classStr: "colorF78D3F"
    }],

    tabIndex: 0, // 默认选中的下标
    tabs: [],
    // hideTab: false, // 是否隐藏tab
    // 分组的设备列表
    groupItemObj: {
      light: {
        text: "照明",
        key: "light",
        selecteds: [],
        list: []
      },
      curtain: {
        text: "窗帘",
        key: "curtain",
        selecteds: [],
        list: []
      },
      // aircondition: {
      //   text: "空调",
      //   key: "aircondition",
      //   selecteds: [],
      //   list: []
      // }
    },
    groupItemSelected: {}, // 分组设备选中的数据
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    // 根据名称初始化底部按钮
    let {typeIndex, devTypeStr, did, index, meshFlag} = options || {};
    // 组网使能
    this.meshFlag = meshFlag;
    // 编辑数据的下标
    this.editIndex = index == undefined ? -1 : (Number(index) || 0);
    // 默认选项
    this.data.tabIndex = Number(typeIndex) || 0;
    // 初始化列表设备的品类
    this.devTypeStr = devTypeStr || "";
    // this.key = Number(key || 0);
    !!did && (this.data.did = did);
    // 初始化房间信息
    let _roomId = (app.globalData.roomInfo || {}).id;
    if (_roomId != this.data.roomInfo.id && _roomId != undefined) {
      let _roomInfo = app.globalData.devs[_roomId] || app.globalData.devs[0];
      this.data.roomInfo.id = _roomInfo.id;
      this.data.roomInfo.n = _roomInfo.n;
    }
    // 初始化房间
    let _allRooms = this.getAllRooms();
    // 取得房间
    let {roomJson, isFloor} = this.getAllRoomJson(); // 初始化roomJSON和多楼层信息

    // 如果是场景，则屏蔽tab选项 且增加底部删除按钮
    let _isSceneEdit = typeIndex == 2 && did != undefined;
    let _tabs = this.getAllTabs();
    // 取得底部按钮
    let _bottomBts = this.getBottomBtsByEdit(_isSceneEdit);

    this.setData({
      rooms: _allRooms,
      roomInfo: this.data.roomInfo,
      did: this.data.did,
      bottomBts: _bottomBts,
      roomJson: roomJson,
      isFloor: isFloor,
      tabIndex: this.data.tabIndex,
      tabs: _tabs,
    })
  },
  getAllTabs () {
    return [{
      text: "设备",
      key: "device"
    }, {
      text: "群组设备",
      key: "group"
    }, {
      text: "场景",
      key: "scene"
    }];
  },
  // 页面来源
  getBottomBtsByEdit (isSceneEdit) {
    let _array = [];
    if (isSceneEdit) {
      _array = [{
        name: "删除",
        handles: "delScene",
        classStr: 'delBtn',
      }, {
        name: "保存",
        handles: "next",
        classStr: 'colorF78D3F borderF78D3F marginL50',
      }];
    } else {
      _array = [{ // 默认按钮
        name: "下一步",
        handles: "next",
        classStr: "colorF78D3F borderF78D3F"
      }];
    }
    return _array;
    // this.setProperValue("bottomBts", _array);
  },
  setProperValue (key, val) {
    if (this.data == undefined) {
      return;
    }
    this.data[key] = val;
    this.setData({
      [key]: val
    })
  },
  getAllRoomJson () {
    // 取得多楼层的json数据
    let {roomJson} = bizUtil.getRoomsByDevs(app.globalData.devs);
    return {
      roomJson: roomJson,
      isFloor: app.globalData.familyInfo?.floor >= 0
    };
  },
  // 初始化房间
  getAllRooms () {
    // 所有设备
    let _allDevs = app.globalData.devs || {};
    // 当前楼层
    let _floor = app.globalData.familyInfo?.floor || 0;
    // 根据多楼层取得数据
    let _devs = bizUtil.getDevsByFloor(_allDevs, _floor);

    let {rooms} = bizUtil.getRoomsByDevs(_devs);
    return rooms;
  },
  getActionDevsByRoomId (roomId) {
    let _roomId = roomId || 0;
    let _result = {};
    if (_roomId == 0) {
      // 如果是全屋 取得所有设备
      let _devs = app.globalData.devs || {};
      let {rooms} = bizUtil.getRoomsByDevs(_devs);
      _result = bizUtil.getAllDevsBySort(rooms, _devs);
    } else if (_roomId % 32 == 0) {
      // 楼层数据
      let _data = this.data.rooms || [];
      _data = _data.filter(item=>((item?.id || 0) % 32 > 0));
      console.log("scrollClick _data = ", _data);
      // 如果是全屋 取得所有设备
      _result = bizUtil.getAllDevsBySort(_data, app.globalData.devs);
    } else {
      _result = app.globalData.devs[_roomId] || {}; 
    }
    return _result;
  },
  
  // 根据房间初始化设备列表
  initListByRoom (roomId, tabIndex) {
    let _roomId = roomId || 0;
    // 根据房间信息取得设备列表和群组信息
    let {devs, groups} = this.getActionDevsByRoomId(_roomId);
    console.log("initListByRoom roomId, devs, groups = ", roomId, devs, groups);
    // 设备列表信息
    let _devShowArray = devs || [];

    // 需要更新的数据内容
    let _updateJson = {};
    // 最终的设备列表数据
    let _resultArray = [];
    // 判断选择类型
    if (tabIndex == 1) {
      // 选择群组
      let _allArray = bizUtil.getDevsOrGroupsByRoomId(_roomId, app.globalData.devs, "groups");
      // 筛选去除默认群组
      let _filterArray = _allArray.filter(item => !bizUtil.isAllRoomCtrl(item));
      // 排序
      _resultArray = bizUtil.sortArrayByKey(_filterArray, "gid");
      console.log("initListByRoom _resultArray = ", _resultArray);
      // 分组
      let _pidJson = bizUtil.getAllPidByArray(_resultArray);
      let _groupItemObj = this.data.groupItemObj;
      console.log("initListByRoom _groupItemObj, _pidJson = ", _groupItemObj, _pidJson);
      for (let key in _groupItemObj) {
        let _array = _pidJson[key] || [];
        _groupItemObj[key].list = _array;
      }
      console.log("initListByRoom _groupItemObj = ", _groupItemObj);
      _updateJson.groupItemObj = _groupItemObj;
    } else if (tabIndex == 2) {
      // 选择场景
      _resultArray = app.globalData.devs[_roomId]?.scenes || [];
      // 排序
      _resultArray = bizUtil.sortArrayByKey(_resultArray, "or");
      _updateJson.actionList = _resultArray;
    } else {
      
      // 按照名称排序
      let _sortArray = bizUtil.sortArrayByChar(_devShowArray, "n");
      // 数据数据，取得执行的设备
      // let {light, curtain, panel, aircondition: showAirconditions} = bizUtil.getAllPidByArray(_sortArray);
      // 分组
      let _pidJson = bizUtil.getAllPidByArray(_sortArray);
      // // 继电器面板
      // let _filterPanels = (_pidJson.panel).filter(item => bizUtil.isPwrAvalibleDev(item.t));
      
      // // 分组
      // let _pidJson = bizUtil.getAllPidByArray(_resultArray);

      // 是否从循环情景中进入
      let _fromCycle = this.checkCycle();

      // 取得分组的配置 执行设备
      let _groupItemObj = bizUtil.getGroupedActionConfig();
      console.log("initListByRoom _groupItemObj, _pidJson = ", _groupItemObj, _pidJson);
      for (let key in _groupItemObj) {
        if (key == "panel") {
          // 继电器面板
          _groupItemObj[key].list = (_pidJson[key] || []).filter(item => bizUtil.isPwrAvalibleDev(item.t));
          continue;
        } else if (key == "aircondition" || key == "thermostat" || key == "fanLight") {
          continue;
        }
        _groupItemObj[key].list = _pidJson[key];
      }
      console.log("initListByRoom _groupItemObj = ", _groupItemObj);
      _updateJson.groupItemObj = _groupItemObj;

      // // 设备列表
      // let _devList = light.concat(curtain);
      // // 所有设备
      // _resultArray = bizUtil.sortArrayByChar(_devList.concat(_filterPanels), "n");

      // 取得所有家庭数据中空调的设备列表 需要特殊处理
      // let _familyAllDevs = bizUtil.getAllDevsFilter(app.globalData.devs);
      // let {aircondition} = bizUtil.getAllPidByArray(_familyAllDevs);
      // console.log("aircondition = ", aircondition);
      // let {parents, subDMap} = bizUtil.getAirconditionMap(aircondition);
      // console.log("parents, subDMap = ", parents, subDMap);
      // // let _airRtMapByD = {};
      // // 遍历所有空调网关 取得空调设备已经存在的场景个数
      // for (let devInfo of parents) {
      //   let {v, d} = devInfo;
      //   // 取得每个设备最大的场景个数
      //   let {sceneLen} = bizUtil.getJsonByAblitys(v);

      //   // 取得网关场景个数以及网关所有内机个数
      //   // 判断是否场景已满
      //   let _count = _devSceneJson[d]?.length || 0;
      //   // 设置内机的sub个数rt
      //   let _subArrays = subDMap[d] || [];
      //   for (let subDev of _subArrays) {
      //     _count += (_devSceneJson[subDev?.d]?.length || 0);
      //   }
      //   // 数据之和
      //   let _isRT = _count >= (sceneLen || 0);
      //   // 设置空调主机的map
      //   _airRtMapByD[d] = _isRT;
      // }
      // // 空调去重
      // let _uniqueAirs = this.fitlerDevsBySceneInfo(showAirconditions, _existDevs);
      // console.log("initListByRoom _uniqueAirs = ", _uniqueAirs);
      // _resultArray = _resultArray.concat(_uniqueAirs);

      _updateJson.actionList = _resultArray;
    }

    // 增加房间显示
    if (_updateJson.groupItemObj) {
      // 是否支持楼层
      let _isFloor = app.globalData.familyInfo.floor >= 0;
      for (let key in _updateJson.groupItemObj) {
        let {list} = _updateJson.groupItemObj[key] || {};
        if (!list || list.length == 0) {
          continue;
        }
        // 增加房间显示
        for (let item of list) {
          item.tip = bizUtil.getRoomName(item, app.globalData.devs, _isFloor);
        }
      }
    }

    // 更新下标
    _updateJson.tabIndex = tabIndex || 0;
    this.setData(_updateJson);
  },

  // 设备去重  其中空调逻辑需要特殊处理一下： 空调网关选择之后不能选择空调内机
  fitlerDevsBySceneInfo (allArray, existArray) {
    if (!allArray || allArray.length == 0) {
      return [];
    } else if (!existArray || existArray.length == 0) {
      return allArray;
    }
    // 去重的设备d集合 这里需要处理空调网关和空调内机的逻辑
    // let _tmps = existArray.map(item => item.d);
    let _existDArray = []; // 存在的真实d集合
    let _existAirGateway = []; // 如果存在子设备，则去除网关
    for (let item of existArray) {
      let _d = item?.d || "";
      _existDArray.push(_d);

      // 这里判断如果是空调内机则需要去除空调网关的数据
      let _didArray = _d.split("_");
      let _didStart = _didArray[0];
      if (_didArray.length > 1 && _existAirGateway.indexOf(_didStart) < 0) {
        // 空调网关子设备
        _existAirGateway.push(_didArray[0]);
      }
    }
    
    // 网关和已经存在的设备集合
    let _allDArray = _existDArray.concat(_existAirGateway);
    console.log("fitlerDevsBySceneInfo allArray, _existDArray, _existAirGateway = ", allArray, _existDArray, _existAirGateway);
    // return allArray.filter(item => _tmps.indexOf(item.d) < 0)
    return allArray.filter(item => {
      let _d = item?.d || "";
      
      // 先判断是否包含相同的did
      let _isExist = _allDArray.indexOf(_d) >= 0;
      if (_isExist) {
        return false;
      }

      // 这里判断如果是空调内机则需要去除空调网关的数据
      let _didArray = _d.split("_");
      // let _isSubAir = _d.indexOf("_") >= 0;
      if (_didArray.length > 1) {
        // 空调网关子设备
        return _existDArray.indexOf(_didArray[0]) < 0;
      }
      return true;
    });
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 初始化设备列表
    this.initListByRoom(this.data.roomInfo?.id, this.data.tabIndex);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  selectDev (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.actionList[index];
    console.log("selectDev _item = ", _item);
    // 选中数据
    let _tabIndex = this.data.tabIndex || 0;
    if (_tabIndex == 2) {
      // 选择的场景
      this.setProperValue("did", _item.sid);
    } else {
      this.setProperValue("did", _item.gid || _item.d);
    }
  },

  chooseRoom (e) {
    let {rid} = e.currentTarget.dataset;
    let _roomInfo = app.globalData.devs[rid || 0];
    this.data.roomInfo.n = _roomInfo.n;
    this.data.roomInfo.id = _roomInfo.id;
    this.setProperValue("roomInfo", this.data.roomInfo);
    // 隐藏
    this.hidePop();
    // 显示对应的房间信息
    this.initListByRoom(this.data.roomInfo?.id, this.data.tabIndex);
  },
  showPop () {
    this.hidePop(true);
  },
  closePop () {
    this.hidePop();
  },
  hidePop (isOpen) {
    this.setProperValue("roomChanged", isOpen || false);
  },

  // 取得选中的值
  getSelectedInfoByTabIndex (tabIndex, array) {
    if (!array || array.length == 0) {
      return [];
    }
    let _did = this.data.did;
    let _tabIndex = tabIndex || 0;
    let _key = this.getKeyByTabIndex(_tabIndex);
    let _filterDevs = array.filter(item => (item[_key] == _did));
    return _filterDevs;
  },
  // 取得条目的key
  getKeyByTabIndex (tabIndex) {
    let _isScene = this.isSceneByTabIndex(tabIndex); // 是否场景
    let _isGroup = this.isGroupByTabIndex(tabIndex); // 是否群组
    // 取得key
    let _key = 'd';
    if (_isScene) {
      _key = 'sid';
    } else if (_isGroup) {
      _key = 'gid';
    }
    return _key;
  },
  // 是否单个设备
  isDevByTabIndex (tabIndex) {
    return tabIndex == 0;
  },
  // 是否群组
  isGroupByTabIndex (tabIndex) {
    return tabIndex == 1;
  },
  // 是否场景
  isSceneByTabIndex (tabIndex) {
    return tabIndex == 2;
  },
  getSelectedInfoInGroup (json) {
    let _selectedInfo = [];
    if (!json) {
      return _selectedInfo;
    }
    for (let key in json) {
      let {selecteds, list} = json[key] || {};
      if (!!list && !!selecteds && selecteds.length > 0) {
        for (let index of selecteds) {
          _selectedInfo.push(list[index]);
        }
      }
    }
    return _selectedInfo;
  },

  // 删除场景
  delScene () {
    ability.showModal({
      title: "",
      content: "确定要删除该执行设备",
      showCancel: true,
      confirmColor: "#576B95",
      confirmText: "确定",
      cancelText: "取消",
      cancelColor: '#000000',
    }).then(res => {
      if (!res) {
        return;
      }
      // 删除
      this.delSceneDetail(this.editIndex);
    })
  },
  delSceneDetail (editIndex) {
    if (this.checkCycle()) {
      let _editIndex = editIndex || 0;
      // 删除循环
      app.globalData.timerInfo.bodyList.splice(_editIndex, 1);
    } else {
      // 删除定时
      delete app.globalData.timerInfo.cmd;
    }
    this.back();
  },

  // 下一步
  next () {
    let _tabIndex = this.data.tabIndex;

    // 是否群组
    let _isGroup = this.isGroupByTabIndex(_tabIndex);
    // 是否单个设备
    let _isDev = this.isDevByTabIndex(_tabIndex);
    // 是否场景
    let _isScene = this.isSceneByTabIndex(_tabIndex);
    // 取得选中的数据
    let _selectedArray = [];
    if (_isGroup || _isDev) {
      // 群组
      _selectedArray = this.getSelectedInfoInGroup(this.data.groupItemObj);
    } else {
      _selectedArray = this.getSelectedInfoByTabIndex(_tabIndex, this.data.actionList);
    }
    console.log("next _selectedArray = ", _selectedArray);
    if (_selectedArray.length == 0) {
      return ability.showToast({
        title: "请选择任一设备、群组或场景"
      });
    }
    // 选中的设备信息
    let item = _selectedArray[0];

    // // 群组信息
    // if (_isGroup) {
    //   app.globalData.devInfo = item;
    //   // 判断类型
    //   let _devTypeStr = bizUtil.getDevTypeStr(item?.t);
    //   if (_devTypeStr == "aircondition") {
    //     ability.navigateTo("../aircondition/index")
    //   }
    //   // 跳转页面
    //   ability.redirectTo("../status/index")
    // }
    // else 
    // 场景信息
    if (_isScene) {
      console.log("next scene item = ", item);
      // 判断定时还是循环情景
      if (this.checkCycle()) {
        // 编辑的数据
        let {array, type} = app.globalData.blsdk.getGatewayCycleCmd({
          sid: item.sid,
          rid: item.rid
        }, {
          scene: 2, // 场景触发
          meshFlag: this.meshFlag // 是否需要组网
        });
        app.globalData.timerInfo.bodyList = app.globalData.timerInfo.bodyList || [];
        // 编辑还是新增
        if (this.editIndex >= 0) {
          // 老的数据
          let {interval} = app.globalData.timerInfo.bodyList[this.editIndex] || {};
          // 编辑
          app.globalData.timerInfo.bodyList[this.editIndex] = {
            interval: interval || 0, // 默认500ms
            type: type,
            len: array.length,
            data: array
          };
        } else {
          app.globalData.timerInfo.bodyList.push({
            interval: 0, // 默认500ms
            type: type,
            len: array.length,
            data: array
          });
        }
      } else {
        // 编辑的数据
        let _cmdBase64 = app.globalData.blsdk.getGatewayTimeHexCmd({
          sid: item.sid,
          rid: item.rid
        }, {
          scene: 2, // 场景触发
        });
        app.globalData.timerInfo.cmd = _cmdBase64;
      }
      
      // 返回
      this.back();
    } else {
      // 单个设备
      app.globalData.devInfo = item;

      // 判断类型
      let _devTypeStr = bizUtil.getDevTypeStr(item?.t);

      // 是否有编辑下标
      let _appendStr = (this.editIndex >= 0) ? ("&edit=true&index=" + this.editIndex) : "";
      _appendStr += "&devType=" + _devTypeStr;

      if (_devTypeStr == "aircondition") {
        // 循环场景不支持空调
        ability.navigateTo("../aircondition/index?meshFlag=" + this.meshFlag + _appendStr)
      } else if (_devTypeStr == "panel") {
        // 开关面板
        ability.navigateTo("../pwrAvalible/index?meshFlag=" + this.meshFlag + _appendStr)
      } else if (_devTypeStr == "powerstrip") {
        // 跳转灯泡设置页面
        ability.navigateTo("../pwrAvalible/index?meshFlag=" + this.meshFlag + _appendStr)
      } else {
        // 跳转灯泡设置页面
        ability.navigateTo("../status/index?meshFlag=" + this.meshFlag + _appendStr)
      }
    }
  },

  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    });
  },
  hideLoading () {
    ability.hideLoading();
  },
  // 超级面板的绑定
  bindDevice (devInfo) {
    let str = "绑定中…";

    // 超级面板信息
    let _metapadInfo = app.globalData.devInfo || {};
    // 绑定按键的第几路
    let _bindKeyVal = this.data.key;

    // 提示等待中
    this.showLoading(str || '');
    // 场景id 设备房间id + 设备类型 + 设备短地址
    let _sceneId = 0;
    // 取得发送的数据
    let _sendType = bizUtil.getTypeByDevTypeStr(this.devTypeStr);
    // 判断选中的是群组还是单个设备
    let _isGroupBind = !!(devInfo?.gid);
    if (_isGroupBind) {
      let {gid} = devInfo || {};
      // 群组
      _sceneId = ((gid || 0) << 16) + (_sendType << 8);
    } else {
      let {a, id} = devInfo || {};
      // 单个设备
      _sceneId = ((id || 0) << 16) + a + (_sendType << 8);
    }

    // 更新场景
    app.globalData.blsdk.metapadBindDev(_metapadInfo.a, _bindKeyVal, _sceneId, (result) => {
      console.log("next result = ", result);
      this.hideLoading();
      let _str = "";
      if (result < 0 || result === false || result == undefined || result.errCode) {
        _str =  '绑定失败';
      } else {
        _str =  '绑定成功';
        // 加入数据
        this.dealAfterSave(_metapadInfo, devInfo, _isGroupBind, _sendType);
        setTimeout(() => {
          this.back();
        }, 1500);
      }
      ability.showToast({
        title: _str
      });
    });
  },
  dealAfterSave (metapadInfo, devInfo, isGroupBind, sendType) {
    if (!metapadInfo || !devInfo) {
      return;
    }
    // 新的数据
    let _key = this.data.key;
    // 超级面板数据
    metapadInfo.ds = metapadInfo?.ds || [];

    // 根据按键删除之前绑定的设备
    bizUtil.delInArrayByKey(metapadInfo.ds, _key, "key");
    // 加入数据
    metapadInfo.ds.push({
      sid: (isGroupBind ? devInfo.gid : devInfo.a),
      rid: isGroupBind ? devInfo.rid : devInfo.id,
      type: sendType || 0, // 发送的品类 数值
      key: _key, // 第几路
      cmd: isGroupBind ? devInfo.gid : devInfo.d  // 如果是设备，则是短地址，如果是群组则为0
    })
  },
  back () {
    ability.navigateBack();
  },

  tabClick (e) {
    let {index} = e.currentTarget.dataset;
    // 初始化数据
    this.initListByRoom (this.data.roomInfo?.id, index);
  },
  groupClick (e) {
    let {index, pIndex} = e.detail;
    console.log("groupClick e = ", e);
    let _groupItemObj = this.data.groupItemObj || {};
    let _currentKeyObj = _groupItemObj[pIndex] || {};
    let _currentKeySelects = _currentKeyObj.selecteds || [];
    let _selectedLen = _currentKeySelects.length; // 当前是否选中 因为现在只能单选，所以只需要判断长度

    // 清空选项 保证只有一项被选中
    for (let key in _groupItemObj) {
      _groupItemObj[key].selecteds = [];
    }
    // 确保只能有一个被选中
    // if (_selectedLen > 0 && _currentKeySelects[0] == index) {
    //   _currentKeyObj.selecteds = [];
    //   // delete _currentKeyObj.selecteds[index];
    // } else {
      _currentKeyObj.selecteds = [index];
    // }
    console.log("groupClick _currentKeyObj, _groupItemObj = ", _currentKeyObj, _groupItemObj);
    // let _key = `groupItemObj.${pIndex}.list[${index}].selected`;
    this.setData({
      groupItemObj: _groupItemObj
    })
  }
})