// device/gateway/timer/pwrAvalible/index.js
import ability from "../../../../utils/classDef/ability"
import bizUtil from "../../../../utils/bizUtil"
const app = getApp();
const timeBehavior = require("../../behavior/time")
Page({
  behaviors: [timeBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    // navObj: {
    //   left: {
    //     type: "img"
    //   },
    //   center: {
    //     text: (app.globalData.panelInfo || {}).n || '按键选择'
    //   }
    // },
    panelList: [],
    selectIds: [0,0,0,0,0,0,0,0], // 按键是否选中列表
    pwrs: [0,0,0,0,0,0,0,0], // 开关是否选中列表
    showSaveDialog: false, // 是否显示保存后的对话框

    oldPanelId: -1,
    
    isPwrAvalible: true, // 默认是继电器面板
    // devTypeStr: "panel", // 默认是面板 
    isEditIndex: -1, // 是否编辑设备

    // 按钮列表
    actions: [],

    // 三个状态 当前 设备状态 例外
    types: [],
    currentType: 0,

    showTotal: false, // 是否展示全开全关按钮
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    let {meshFlag, index, edit, devType} = options;
    // 组网使能
    this.meshFlag = meshFlag;
    // 是否编辑页面
    let _index = index;
    this.data.isEditIndex = _index == undefined ? -1 : Number(_index);
    // 是否编辑
    this.isEdit = edit || false;
    // 初始化面板页面的按键列表
    this.data.panelList = this.getPanelKeyListByType(devType);

    // 初始化默认数据
    if (_index >= 0) {
      this.initDataByTimerInfo(this.data.isEditIndex, devType);
    }
    
    // 初始化按钮列表
    let _actions = this.getActions(this.data.isEditIndex);

    this.setData({
      panelList: this.data.panelList,
      showTotal: devType == "powerstrip",
      actions: _actions
    })
    
    // 设置标题
    this.setNavTitle(app.globalData.devInfo?.n || '');
  },

  initDataByTimerInfo (isEditIndex, devTypeStr) {
    // 判断是循环情景还是定时
    if (this.checkCycle() && devTypeStr != "powerstrip") {
      let {data, type} = app.globalData.timerInfo?.bodyList[isEditIndex] || {};
      if (!data || data.length == 0) {
        return;
      }
      this.initDefaultVal(data, devTypeStr);
    } else {
      let _cmdArray = app.globalData.devInfo?.cmd;
      // 判断类型
      console.log("onLoad _cmdArray = ", _cmdArray);
      // 初始化默认值
      if (!_cmdArray?.length) {
        return;
      }
      // if (devTypeStr == "powerstrip") {
      //   return this.initDefaultVal([_cmdArray[1]], devTypeStr);
      // }
      this.initDefaultVal(_cmdArray, devTypeStr);
    }
  },

  setNavTitle (title) {
    ability.setNavigationBarTitle(title || '');
  },

  initDefaultVal (_cmdArray, devTypeStr) {
    console.log("initDefaultVal _cmdArray, devTypeStr = ", _cmdArray, devTypeStr);
    // 初始化默认的按键
    let _data = this.getPanelSelects(_cmdArray);
    console.log("initDefaultVal _data = ", _data);
    let _defaults = [];
    let _pwrs = [];
    if (!!_data) {
      _defaults = _data.selectIds;
      _pwrs = _data.pwrs;
    }
    // 设置值
    this.setDefaultValue(_defaults, _pwrs);
  },

  // 初始化默认选择的页面
  setDefaultValue (defaultIds, pwrs) {
    let _defaultIds = defaultIds || [];
    let _pwrs = pwrs || [];
    if (_defaultIds.length == 0 || _pwrs.length == 0) {
      return;
    }
    let _minLen = this.data.panelList?.length || 0;
    if (_defaultIds < _minLen) {
      _defaultIds = new Array(_minLen).fill(0);
    }
    if (_pwrs < _minLen) {
      _pwrs = new Array(_minLen).fill(0);
    }
    console.log("initDefaultVal _defaultIds, pwrs = ", _defaultIds, pwrs);
    this.setData({
      selectIds: _defaultIds,
      pwrs: _pwrs
    })
  },

  // initCurTypes (cmdArray) {
  //   // 取得当前选择的type
  //   let _currentType = 0;
  //   if ((cmdArray === '' || cmdArray === undefined)) {
  //     _currentType = this.data.types.length >= 3 ? 2 : 0;
  //   } else if (cmdArray.length == 0) {
  //     _currentType = 1;
  //   } else {
  //     _currentType = 0;
  //   }
  //   console.log("initData _currentType = ", _currentType);
  //   this.data.currentType = _currentType;
  //   this.setData({
  //     currentType: this.data.currentType
  //   })
  // },

  getAllActions () {
    return [{
      n: '删除',
      classStr: 'delBtn',
      handle: "unbindScene"
    }, {
      n: '保存',
      classStr: 'saveBtn marginL49',
      handle: "save"
    }]
  },

  getActions (panelId) {
    let _list = this.getAllActions();
    // 判断是否编辑
    if (panelId >= 0) {
      // 编辑
    } else {
      // 新增
      _list = _list.slice(1);
      _list[0].classStr = _list[0].classStr.replace("marginL49", "");
    }
    return _list;
    // this.data.actions = _list;
    // this.setData({
    //   actions: this.data.actions
    // })
  },

  // 取得继电器面板按位与的数据
  getPanelSelects (cmds) {
    if (!cmds || cmds.length == 0) {
      return false;
    }
    let _byte0 = cmds[0] || 0;
    let _byte1 = cmds[1] || 0;
    // 按位转成2进制并补0
    return {
      selectIds: _byte0.toString(2).padStart(8, 0).split("").reverse().map(i=>parseInt(i)),
      pwrs: _byte1.toString(2).padStart(8, 0).split("").reverse().map(i=>parseInt(i))
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // app.saveAllDevsMap();
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  getPanelKeyListByType (devTypeStr) {
    // 设备信息
    let _devInfo = app.globalData.devInfo || {};
    let _pid = _devInfo.t;
    let _num = bizUtil.getPanelKeysByPid(_pid, devTypeStr);
    console.log("getPanelKeyListByType _num, _pid = ", _num, _pid);

    // 插孔信息
    let _extendJson = devTypeStr == "powerstrip" ? {
      defaultFormat: "插孔"
    } : undefined;

    // 排插
    // if (devTypeStr == "powerstrip") {
      // return [{
      //   n: '全开全关',
      //   id: 0,
      //   value: 0, // 默认关
      //   type: "switch"
      // }]
    // }

    // 取得默认的长度
    let _defaultNames = _devInfo.e?.vGroups || [];
    console.log("getControlList _defaultNames = ", _defaultNames);
    // 如果为空
    if (typeof _defaultNames == "object" && ((_defaultNames.length == 0) || (Object.keys(_defaultNames).length == 0))) {
      _defaultNames = bizUtil.getPanelVGroups(_num, _extendJson);
      app.globalData.devInfo.e = {
        vGroups: _defaultNames
      }
    }
    // // 默认的值
    // let _defaultVals = defaultVals || [];
    // 取得按键名称
    let _keys = [];
    for (let i = 0; i < _num; i++) {
      _keys.push({
        n: _defaultNames[i]?.name || '',
        id: i,
        value: i
      })
    }
    return _keys;
  },

  setShowSaveDialog (value) {
    this.data.showSaveDialog = value || false;
    this.setData({
      showSaveDialog: this.data.showSaveDialog
    })
  },
  setPanelSceneInfo (roomId, did, sceneInfo, key) {
    let _panels = app.globalData.devs[roomId].panels || [];
    let _index = this.getPanelByD(_panels, did);
    if (_index < 0) {
      return false;
    }
    _panels[_index].ds = _panels[_index].ds || [];
    _panels[_index].push({
      sid: sceneInfo.sid,
      rid: sceneInfo.rid,
      t: sceneInfo.t,
      key: key
    })
  },
  getPanelByD (array, did) {
    let _index = -1;
    if (!array || array.length == 0) {
      return _index;
    }
    for (let index of array) {
      let _item = array[index];
      if (_item.d == did) {
        return index;
      }
    }
    return _index;
  },

  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    });
  },
  hideLoading () {
    ability.hideLoading();
  },

  save () {

    // 如果是其他的类型点击，则返回
    let _curType = this.data.currentType;
    if (_curType != 0) {
      // 返回上一页
      return this.back();
    }

    console.log("save this.data.selectIds, this.data.pwrs = ", this.data.selectIds, this.data.pwrs);

    // 命令串
    let _cmd = [];
    // if (this.data.showTotal) {
    //   let _value = this.data.selectIds[0];
    //   _cmd = [0xff, _value ? 0xff : 0];
    // } else {
      let _byte = Number('0b' + (this.data.selectIds.reverse().join('')));
      let _pwrValue = Number('0b' + (this.data.pwrs.reverse().join('')));
      // 如果未选择，则提示
      if (_byte == 0) {
        ability.showToast({
          title: '请选择执行按键'
        });
        return;
      }
      _cmd = [_byte || 0, _pwrValue || 0];
    // }
    console.log("save _cmd = ", _cmd);

    // 提示等待中
    // this.showLoading('设置中…');

    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _timerInfo = app.globalData.timerInfo || {}; // 定时数据

    // 判断循环情景还是定时
    if (this.checkCycle()) {
      // 编辑的数据
      this.cycleManageByIndexAndData(_cmd, {
        device: _devInfo,
        meshFlag: this.meshFlag // 组网使能
      }, this.data.isEditIndex);
    } else {
      let _cmdBase64 = app.globalData.blsdk.getGatewayTimeHexCmd(_cmd, {
        device: _devInfo,
      });
      _timerInfo.cmd = _cmdBase64;
      console.log("save _cmdBase64 = ", _cmdBase64);
    }

    // 返回上一页
    if (this.data.isEditIndex >= 0) {
      if (this.isEdit) {
        this.back(2);
      } else {
        this.back(1);
      }
    } else {
      this.back(2);
    }
  },

  // 删除场景下绑定的执行设备
  unbindScene () {
    console.log("unbindScene");
    if (this.checkCycle() && this.data.showTotal) {
      // 判断是否插座插排
      // 删除循环场景下的插座、插排
      let _index = this.data.isEditIndex;
      let {bodyList} = app.globalData.timerInfo || {};
      if ((bodyList instanceof Array) && bodyList[_index]) {
        app.globalData.timerInfo.bodyList.splice(_index, 1);
      }
    } else {
      // 定时
      app.globalData.timerInfo.cmd = "";
    }
    ability.navigateBack();
  },
  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    let _value = this.data.selectIds[index] || 0;
    let _nowVal = Number(!_value);

    this.data.selectIds[index] = _nowVal;

    // 如果不勾选，则按键也不勾选
    if (!_nowVal) {
      this.data.pwrs[index] = 0;
    }

    this.setData({
      selectIds: this.data.selectIds,
      pwrs: this.data.pwrs
    })
  },
  allSwitchChange (e) {
    let _val = e.detail.value;
    let {index} = e.currentTarget.dataset;

    console.log("allSwitchChange e = ", e);
    let _value = Number(_val);
    this.data.pwrs[index] = _value;
    let _str = `pwrs[${index}]`;
    this.setData({
      [_str]: _value
    });

    // 发送控制命令
    this.sendCtrl(index, _value ? 'open' : 'close');
  },
  switchChange (e) {
    let _val = e.detail.value;
    let {index} = e.currentTarget.dataset;

    // 如果未选中按键，则不可选择
    if (!this.data.selectIds[index]) {
      return;
    }

    console.log("switchChange e = ", e);
    let _value = Number(_val);
    this.data.pwrs[index] = _value;
    let _str = `pwrs[${index}]`;
    this.setData({
      [_str]: _value
    });

    // 发送控制命令
    this.sendCtrl(index, _value ? 'open' : 'close');
  },

  // 发送控制命令
  sendCtrl (index, keyStr) {
    console.log("funcClick index = ", index);
    // 判断发送的数据
    if (keyStr == "open") {
      // todo list 第一个字节为panelId, 第二个字节为开关
      this.actDev([1 << index, 1 << index]);
    } else if (keyStr == "close") {
      // todo list
      this.actDev([1 << index, 0]);
    }
  },
  actDev (cmdKey) {
    let _devInfo = app.globalData.devInfo;
    app.globalData.blsdk.controlWithDevice(_devInfo, cmdKey);
  },

  back (num) {
    // 返回上一页
    ability.navigateBack(num || 1);
  },
})