// device/gateway/timer/repeat/index.js
import ability from "../../../../utils/classDef/ability"
import bizUtil from "../../../../utils/bizUtil"
const app = getApp();
const timeBehavior = require("../../behavior/time")
Page({
  behaviors: [timeBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    weeks: [{
      title: "周日",
      value: 0,
    }, {
      title: "周一",
      value: 1,
    }, {
      title: "周二",
      value: 2,
    }, {
      title: "周三",
      value: 3,
    }, {
      title: "周四",
      value: 4,
    }, {
      title: "周五",
      value: 5,
    }, {
      title: "周六",
      value: 6,
    }],
    selectDays: {}, // 选中的
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad (options) {
    let {time} = app.globalData.timerInfo || {};
    let {repeat, hour, minute} = this.getRepeatAndTimeByFormat(time);
    this.hour = hour;
    this.minute = minute;
    this.data.selectDays = this.getSelectDays(repeat);

    this.setData({
      selectDays: this.data.selectDays
    })
  },

  getSelectDays (repeat) {
    let _result = {};
    if (!repeat) {
      return _result;
    }
    let _repeatArray = repeat.split(",");
    for (let item of _repeatArray) {
      _result[item] = true;
    }
    return _result;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  daySelect (e) {
    let {index} = e.currentTarget.dataset;
    let {value} = this.data.weeks[index];
    if (this.data.selectDays[value]) {
      delete this.data.selectDays[value]
    } else {
      this.data.selectDays[value] = true;
    }
    this.setData({
      selectDays: this.data.selectDays
    })
  },
  save () {
    // 取得重复的数据
    let _selectArray = Object.keys(this.data.selectDays);
    let _repeatStr = _selectArray.join(","); // 逗号分开的星期
    // 取得原先的数据
    app.globalData.timerInfo.time = this.getTimerByRepeatAndTime({
      hour: this.hour,
      minute: this.minute,
      week: _repeatStr
    });
    // 返回
    this.back();
  },
  back () {
    ability.navigateBack();
  }
})