// scene/status/index.js
const ability = require("../../../../utils/classDef/ability")
const app = getApp();
const bizUtil = require("../../../../utils/bizUtil");
const timeBehavior = require("../../behavior/time")
Page({
  behaviors: [timeBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备状态"
      }
    },
    pwrList: [{
      name: '开',
      value: 1
    }, {
      name: '关',
      value: 0
    }],
    statusList: [],
    rgbSliders: {
      bgImg: "../../static/img/common/rgb.png",
      bgClass: "cwImg",
      width: 616, // rpx
      percent: 100, // 百分比
      // labelTxt: "亮度",
      minVal: 0,
      maxVal: 360,
      minPercent: 1, // 最小百分比
      gradient: false // 默认不支持滑动时调节
    },
    // 亮度配置
    brightSliders: {
      leftImg: "../../static/img/common/bright_down.png",
      rightImg: "../../static/img/common/bright_up.png",
      leftClass: "bDown",
      rightClass: "bUp",
      width: 516, // rpx
      percent: 100, // 百分比
      labelTxt: "亮度",
      minVal: 2,
      maxVal: 127,
      minPercent: 1, // 最小百分比
      gradient: false // 默认不支持滑动时调节
    },
    // 色温配置
    cwSliders: {
      leftImg: "",
      rightImg: "",
      bgImg: "../../static/img/common/temp.png",
      leftClass: "cDown",
      rightClass: "cUp",
      bgClass: "cwImg",
      width: 616, // rpx
      percent: 50, // 百分比
      minPercent: 0,
      minVal: 0,
      maxVal: 255,
      gradient: false, // 默认不支持滑动时调节
      upEventWhileMove: true
    },
    status: {
      pwr: 0,
      brightness: 100
    },
    statusKey: '',
    devName: '', // 设备名称

    showCustomToast: false, // 是否显示自定义的提示框
    customToastConfig: {}, // 自定义提示框配置信息

    // 按钮 根据编辑状态动态显示
    actions: [],

    types: [],  // 顶部选项条
    currentType: 0,

    devType: 'light', // 默认灯泡设备

    // 非唤醒的提示
    showLoadingDialog: false,
    loadingConfig: {
      forward: false
    },
    // 定时器
    timer: null,
    // 上一个修改房间方法是否过期
    lastAvalible: false,
    // 修改房间的方法
    // modifyFunc: undefined,

    isGroup: false // 是否群组编辑
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    // 组网使能
    this.meshFlag = options.meshFlag;
    // 是否群组编辑
    this.data.isGroup = this.initIsGroup();
    // 是否编辑状态
    this.data.isEditIndex = (options.index == undefined) ? -1 : Number(options.index);
    // 是否编辑
    this.isEdit = options?.edit || false;
    // // 初始化状态
    // this.initTabByAbility();
    // 初始化设备品类
    this.initDevType();
    // 根据
    // 初始化开关列表
    this.initPwrList();
    // 根据品类初始化滑块
    this.initSliderByDevType();
    // 根据编辑模式初始化按钮
    // this.initActionByMode();
    // 初始化数据
    this.initData();
    // 初始化设备状态
    this.initStatusListByStatus();
    // 初始化默认状态选项
    this.initStatusIndex();
  },
  // 是否群组编辑
  initIsGroup () {
    return app.globalData.devInfo?.gid >= 0;
  },
  // initTabByAbility () {
  //   let _devInfo = app.globalData.devInfo;
  //   console.log("initTabByAbility _devInfo = ", _devInfo);
  //   let _v = _devInfo.v || ""; // 取得版本信息

  //   let _support = false; // 默认不支持
  //   // 如果版本信息不为空
  //   if (_v.length > 0) {
  //     // 版本号信息
  //     let _json = bizUtil.getJsonByAblitys(_v);
  //     _support = _json?.sceneException;
  //     // let _byte = ((_v.split(".")[2] || 0) >> 8) & 0x02; // 第2个ability里面的BIT1
  //     // _support = (_byte == 2);
  //   }

  //   this.data.types = this.getAllTypes(_support);
  //   if (_v == undefined && _devInfo.gid > 0) {
  //     this.data.types = this.data.types.slice(0, 1); // 群组暂时只支持自定义状态
  //     // _support = true; // 如果是场景则默认都支持当前状态
  //   }

  //   this.setData({
  //     types: this.data.types
  //   })
  // },
  // getAllTypes (support) {
  //   let _array = [{
  //     name: "设备状态设置"
  //   }, {
  //     name: "保存当前状态"
  //   }];
  //   if (support) {
  //     _array.push({
  //       name: "不执行场景"
  //     });
  //   }
  //   return _array;
  // },
  // 初始化设备品类
  initDevType () {
    // 取得设备品类
    let _devTypeKey = bizUtil.getDevTypeStr(app.globalData.devInfo.t);
    console.log("initDevType _devTypeKey = ", _devTypeKey, app.globalData.devInfo.t);
    this.data.devType = _devTypeKey;
    this.setData({
      devType: this.data.devType
    })
  },
  initPwrList () {
    // 取得设备品类
    let _devTypeKey = this.data.devType;
    let _openVal = 1, _closeVal = 0;
    if (_devTypeKey == "curtain") {
      _openVal = 1;
      _closeVal = 2;
    }
    this.data.pwrList = [{
      name: '开',
      value: _openVal
    }, {
      name: '关',
      value: _closeVal
    }];
    this.setData({
      pwrList: this.data.pwrList
    })
  },
  initSliderByDevType () {
    let _devType = this.data.devType;
    if ("curtain" == _devType) {
      this.data.brightSliders.leftImg = undefined;
      this.data.brightSliders.rightImg = undefined;
      this.data.brightSliders.leftText = "全关";
      this.data.brightSliders.rightText = "全开";
      this.data.brightSliders.minVal = 0;
      this.data.brightSliders.maxVal = 100;
      this.data.brightSliders.minPercent = 0;
      this.data.brightSliders.labelTxt = "开合程度";
      this.data.brightSliders.percent = 100; // 百分比
      this.data.brightSliders.devType = "curtain"; // 百分比

      this.setData({
        brightSliders: this.data.brightSliders
      })
    } else {
      // 灯泡则使用默认设置
    }
  },
  // 根据编辑模式初始化按钮
  /*initActionByMode () {
    if (this.data.isEditIndex >= 0) {
      // 编辑
      this.data.actions = this.getAllActions();
    } else {
      // 新增
      this.data.actions = [this.getAllActions()[1]];
    }
    console.log("initActionByMode this.data.actions = ", this.data.actions);
    this.setData({
      actions: this.data.actions
    })
  },*/
  getAllActions () {
    return [{
      n: '删除',
      classStr: 'delBtn',
      handle: 'delDev'
    }, {
      n: '保存',
      classStr: 'saveBtn marginL49',
      handle: 'saveInfo'
    }]
  },

  initStatus (cmd) {
    let _cmd = cmd || {};
    this.data.status = _cmd;
    this.setData({
      status: this.data.status
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    // this.initCurrentType();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 取得当前页面控制设备列表数组
  getAllCtrlDevsArray (devInfo) {
    console.log("getAllCtrlDevsArray devInfo = ", devInfo);
    // 是否群组设备
    let {gid, dids} = devInfo || {};
    if (gid) {
      // 固定群组
      // 取得房间下所有的d对应的详细信息
      let _didMaps = bizUtil.getDidMapInJson(app.globalData.devs);
      // 群组设备列表
      let _groupDevs = dids || [];
      // 群组设备列表详细
      return _groupDevs.map(did => _didMaps[did]);
    } else if (devInfo) {
      // 单个设备控制
      return [devInfo];
    }
    return [];
  },
  // 根据品类取得功能集合
  getFuncList (devs) {
    // 被控设备集合
    let _devs = devs || [];
    
    // 最终集合
    let versions = [], minStatus= {}, maxStatus = {};
    // let _minCount = 20, _maxCount = -1;
    // 遍历数据取得集合
    for (let index in _devs) {
      let {t, v} = _devs[index] || {};
      // 如果版本号v不存在，则continue
      if (v == undefined) {
        continue;
      }

      // 如果版本号一致，则continue
      if (versions.indexOf(v) >= 0) {
        continue;
      }
      // 添加版本分支集合
      versions.push(v);
      // 取得能力集
      let _devStatus = bizUtil.getFuncByPid({}, t);
      // 添加最大能力集
      Object.assign(maxStatus, _devStatus);
    }
    console.log("getFuncList maxStatus = ", maxStatus);
    return {
      versions: versions, // 版本能力集合
      maxStatus: maxStatus
    };
  },
  // 是否只包含rgb设备
  checkOnlyRgb (status) {
    if (!status) {
      return false;
    }
    return status.c == undefined && status.w == undefined && status.r != undefined && status.g != undefined && status.b != undefined;
  },
  checkOnlyCW (status) {
    if (!status) {
      return false;
    }
    return status.c != undefined && status.w != undefined && status.r == undefined && status.g == undefined && status.b == undefined;
  },
  initDevFunctions (devInfo) {
    // 初始化设备通用功能
    let _devStatus = {
      pwr: 1,
      brightness: 127
    };
    // 判断设备单个还是批量或者群组
    let _devArray = this.getAllCtrlDevsArray(devInfo);
    console.log("initDevFunctions _devArray = ", _devArray);
    let {maxStatus, versions} = this.getFuncList(_devArray) || {};
    // 赋值给devStatus
    _devStatus = Object.assign({}, maxStatus, _devStatus);
    console.log("initDevFunctions devStatus, maxStatus = ", _devStatus, maxStatus);
    // 是否rgb设备
    this.isOnlyRgb = this.checkOnlyRgb(_devStatus); // _devInfo ? this.isRgbByPid(app.globalData.devInfo.t) : this.checkOnlyRgb();
    this.OnlyCW = this.checkOnlyCW(_devStatus);

    // 保存设备状态
    this.data.devStatus = _devStatus;
    console.log("initDevFunctions devStatus = ", _devStatus);

    // 保存能力集合
    this.data.abilitys = bizUtil.getMaxAbilityByVs(versions) || {};
    console.log("this.data.abilitys, versions = ", this.data.abilitys, versions);
    // 能力集合
    let {gradient: _gradient, minBrightness} = this.data.abilitys;
    // // 更新滑块状态
    // this.data.brightSliders.gradient = _gradient;
    // this.data.cwSliders.gradient = _gradient;
    // console.error("minBrightness = ", minBrightness, this.data.abilitys, this.data.brightSliders);
    // 更新亮度
    !!minBrightness && (this.data.brightSliders.minVal = minBrightness.value, this.data.brightSliders.minPercent = minBrightness.percent);
    this.setData({
      isOnlyRgb: this.isOnlyRgb,
      OnlyCW: this.OnlyCW,
      devStatus: this.data.devStatus,
      brightSliders: this.data.brightSliders,
      cwSliders: this.data.cwSliders
    })
  },

  getStatusJsonByPid (devInfo) {
    console.log("getStatusJsonByPid devInfo, this.data.isGroup = ", devInfo, this.data.isGroup);
    let _status = {};
    // 判断是否群组
    if (this.data.isGroup) {
      this.initDevFunctions(devInfo);
      _status = this.data.devStatus;
    } else {
      // 设备能力集合
      _status = bizUtil.getFuncByPid({
        pwr: 1,
      }, devInfo?.t); // 默认数据
    }
    return _status;
  },

  initData () {
    // 自定义时需要
    let _devInfo = app.globalData.devInfo || {};
    let _devStatus = _devInfo.cmd;
    let _devTypeStr = this.data.devType;

    // // 取得当前选择的type
    // let _currentType = this.getCurrentType(_devStatus);
    // console.log("initData _currentType = ", _currentType);
    // this.data.currentType = _currentType;

    let _status = this.getStatusJsonByPid(_devInfo);
    console.log("initData _status = ", JSON.stringify(_status), _devStatus, _devTypeStr);

    // 如果status是二进制控制命令，则转成对应的json数据 这里其实只有灯泡和窗帘才进入
    if (!!_devStatus && _devStatus.pwr == undefined) {
      _devStatus = bizUtil.getJsonByCmdAndType(_devStatus, _devTypeStr);
      console.log("_devStatus = ", JSON.stringify(_devStatus));
    }
    // 如果存在数据 这里其实没啥用了，因为去除了批量控制
    if (!!_devStatus && Object.keys(_devStatus)?.length > 0) {
      if (_devTypeStr == "light") {
        (_status.pwr != undefined) && (_status.pwr = _devStatus.pwr);

        (_status.brightness != undefined) && (_status.brightness = _devStatus.brightness);
        
        // rgbcw赋值 防止不支持功能加进来
        (_status.r != undefined) && (_status.r = _devStatus.r, _status.g = _devStatus.g, _status.b = _devStatus.b);
        (_status.c != undefined) && (_status.c = _devStatus.c, _status.w = _devStatus.w);
      } else if (_devTypeStr == "curtain") {
        // (_status.pwr != undefined) && (_status.pwr = _devStatus.pwr);
        // (_status.mode != undefined) && (_status.mode = _devStatus.mode);
        (_status.percent != undefined) && (_status.percent = _devStatus.percent);
      }
    }
    console.log("initData _status = ", JSON.stringify(_status), typeof _status);
    this.data.status = _status;
    // 默认亮度
    if (_devTypeStr == "curtain") {
      this.data.brightSliders.percent = parseInt(_status.percent) || 100;
    } else {

      let _percent = bizUtil.getPercentByVal(_status.brightness, this.data.brightSliders) || 100;
      // // 记住上一次的编辑
      // let _index = this.data.isEditIndex;
      // if (_index >= 0) {
      //   let _devInfo = (app.globalData.timerInfo.devs || [])[_index];
      //   if (!!_devInfo && _devInfo.bp >= 0) {
      //     _percent = Number(_devInfo.bp);
      //   }
      // }

      // 默认灯泡
      this.data.brightSliders.percent = _percent; // bizUtil.getPercentByVal(_status.brightness, this.data.brightSliders); // _percent;
      console.log("this.data.brightSliders = ", this.data.brightSliders);
    }

    // 底部按钮特殊处理
    this.dealActions();
    
    // 设备名称
    this.data.devName = _devInfo.n || '';
    this.setData({
      brightSliders: this.data.brightSliders,
      status: this.data.status,
      devName: this.data.devName,
      currentType: this.data.currentType,
      // actions: this.data.actions
    });
  },

  getCurrentType (cmd) {
    let _num = 0;
    if (cmd === '' || cmd === undefined) {
      _num = 2;
    } else if (cmd && cmd.length == 0) {
      _num = 1;
    } else {
      _num = 0;
    }
    let _len = this.data.types?.length || 0;
    if (_num >= _len) {
      // 如果长度大于等于默认的下标
      _num = 0;
    }
    return _num;
  },

  initStatusIndex () {
    
    // 如果是窗帘，则不走
    if (this.data.devType != "light") {
      return;
    }

    console.log("initStatusIndex this.data.status = ", this.data.status)
    // 需要更新的数据
    let _updateObj = {};

    let {r, g, b, c, w} = this.data.status;
    console.log("initStatusIndex = ", r, g, b, c, w);
    if ((r == g && g == b && b == 255) || (c == w && w == 127)) {
      _updateObj.statusKey = "white";

      this.updateTitleByType("", "cw");
    } else if ((r + g + b) > 0 && c == 0 && w == 0) {
      let _percent = bizUtil.getPercentByRgb(r, g, b);
      this.data.rgbSliders.percent = _percent;
      _updateObj.rgbSliders = this.data.rgbSliders;
      _updateObj.statusKey = "rgb";
      
      this.updateTitleByType(`rgb(${r}, ${g}, ${b})`, "rgb");
    } else if (r == g && g == b && (g == 0 || g == undefined) && (c + w) > 0) {
      this.data.cwSliders.percent = w / (c + w) * 100;
      _updateObj.cwSliders = this.data.cwSliders;
      _updateObj.statusKey = "cw";

      this.updateTitleByType(this.data.cwSliders.percent, "cw");
    }
    this.setData(_updateObj)
  },

  initStatusListByStatus () {
    // 如果是窗帘，则不走
    if (this.data.devType == "curtain") {
      return;
    }

    let _array = this.getStatusList();
    // this.data.statusList = _array;
    this.setData({
      statusList: _array
    })
  },
  getStatusList (status) {
    
    // 如果是窗帘，则不走
    if (this.data.devType == "curtain") {
      return;
    }

    let _status = status || this.data.status;
    console.log("getStatusList _status = ", _status);
    let _allList = this.getAllStatusList();
    let _isNotCW = _status.c == undefined;
    let _isNotRGB = _status.r == undefined && _status.g == undefined && _status.b == undefined;
    console.log("getStatusList _isNotCW, _isNotRGB = ", _isNotCW, _isNotRGB);
    // w灯只有亮度和开关
    if (_isNotCW && _isNotRGB) {
      return [];
    } else if (_isNotCW) {
      let _array = _allList.slice(0, 2);
      _array[0].value = 'rgb';
      return _array;
    } else if (_isNotRGB) {
      let _array = [_allList[0], _allList[2]];
      _array[0].value = 'cw';
      return _array;
    }
    return _allList;
  },
  getAllStatusList () {
    return [{
      name: '白光',
      value: '',
      type: "white",
      key: 'white'
    }, {
      name: 'RGB',
      type: "rgb",
      key: 'rgb'
    },{
      name: '色温',
      type: "cw",
      key: 'cw'
    }];
  },

  getStatusJson () {
    // 设备状态
    let _status = this.data.status || {};
    console.log("getStatusJson _status = ", JSON.stringify(_status));
    if (!_status.pwr) {
      _status = {
        pwr: 0
      };
    } else {
      let _statusKey = this.data.statusKey;
      console.log("getStatusJson _statusKey = ", _statusKey);
      // 选中白光
      if (_statusKey == 'white' && this.data.statusList.length > 0) {
        // 白光
        // 这里需要判断是rgb还是cw白 根据每个灯不同的状态值设置不同的值
        // _status.statueKey = "white";
        
        if (this.data.statusList[0].value == 'rgb') {
          _status.r = _status.g = _status.b = 255;
          _status.c = _status.w = 0;
        } else {
          _status.c = _status.w = 127;
          _status.r = _status.g = _status.b = 0;
        }
      } else if (!_statusKey) {
        // 未选择的情况下
        // 判断设备是否支持rgbcw 这里要排除白光
        if (_status.r != undefined || _status.g != undefined || _status.b != undefined || _status.c != undefined || _status.w != undefined) {
          _status.r = _status.g = _status.b = _status.c = _status.w = 0;
        }
        delete _status.statueKey;
      }
    }
    console.log("getStatusJson _status = ", JSON.stringify(_status));
    return _status;
  },
  saveInfo () {
    // 更新状态
    this.data.lastAvalible = false;

    // 取得自定义命令集合
    let _status = this.getStatusJson();
    this.data.status = _status;
    console.log("saveInfo status = ", _status);

    // 非删除
    this.data.isDelete = false;

    this.dealAfterSend();
  },
  dealAfterSend () {

    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _timerInfo = app.globalData.timerInfo || {}; // 定时信息
    let _status = this.getStatusByIndex(this.data.currentType); // 根据选择的
    console.log("dealAfterSend _status, this.data.devType = ", _status, this.data.devType);

    // 取得选中的设备命令
    let _params = {};
    console.log("dealAfterSend this.data.isGroup, _devInfo = ", this.data.isGroup, _devInfo);
    if (this.data.isGroup) {
      let _devTypeStr = bizUtil.getDevTypeStr(_devInfo?.t);
      // 群组
      _params = {
        group: _devInfo?.gid,
        devType: _devTypeStr == "curtain" ? 43499 : 43050
      }
    } else {
      _params = {
        device: _devInfo
      }
    }

    // 判断循环情景还是定时
    if (this.checkCycle()) {
      // 组网使能
      _params.meshFlag = this.meshFlag;
      // 编辑的数据
      console.log("dealAfterSend _status = ", JSON.stringify(_status));

      // 这里需要优化一个点： 如果是白灯，则不传pwr，只有亮度
      let _blecatetory = bizUtil.getBleCatetoryByPid(bizUtil.getDevTypeStr(_devInfo?.t), _devInfo?.t);
      if (_blecatetory == "LIGHT") {
        // 白灯
        _status.pwr = 0; 
      }
      
      // 命令不需要额外补0
      _params.noFillZero = true;
      // 取得命令
      this.cycleManageByIndexAndData(_status, _params, this.data.isEditIndex);
    } else {
      // 编辑的数据
      let _cmdBase64 = app.globalData.blsdk.getGatewayTimeHexCmd(_status, _params);
      console.log("dealAfterSend _cmdBase64 = ", _cmdBase64);
      _timerInfo.cmd = _cmdBase64;
    }
    
    // 返回上一页
    if (this.data.isEditIndex >= 0) {
      if (this.isEdit) {
        this.back(2);
      } else {
        this.back(1);
      }
    } else {
      this.back(2);
    }
  },

  back (num) {
    // 返回上一页
    ability.navigateBack(num || 1);
  },
  
  // 滑块百分比
  sliderChange (event) {
    let _percent = event.detail.percent;
    let _value = event.detail.value;

    // 判断是否窗帘
    if (this.data.devType == "curtain") {
      this.curtainControl(this.data.status.pwr || this.data.pwrList[0].value, _percent);
      return;
    }
    console.log("sliderChange _value, _percent = ", _value, _percent);
    // let _originValue = event.detail.originValue;
    // 增加处理 保存原始的值（精确到小数点 为了防止下次进入亮度不一致）
    this.data.status.brightness = _value;
    // 判断百分比是不是比最大的小
    let _minPercent = this.data.brightSliders?.minPercent || 0;
    if (_percent < _minPercent) {
      _percent = _minPercent;
    }
    this.data.status.brightnessP = _percent;
    // 执行
    let _status = {
      brightness: _value
    };
    this.actDev(_status);
  },

  rgbSliderChange (event) {
    // let _percent = event.detail.percent;
    let _value = event.detail.value;
    console.log("rgbSliderChange _value = ", _value);
    let _rgbs = bizUtil.getRgbByAngle(_value) || [];
    // 增加处理 保存原始的值（精确到小数点 为了防止下次进入亮度不一致）
    this.data.status.r = _rgbs[0];
    this.data.status.g = _rgbs[1];
    this.data.status.b = _rgbs[2];
    this.data.status.c = 0;
    this.data.status.w = 0;

    // 更新标题
    this.updateTitleByType(`rgb(${this.data.status.r}, ${this.data.status.g}, ${this.data.status.b})`, "rgb");

    this.actDev({
      pwr: 1,
      // brightness: this.data.status.brightness || 127,
      r: this.data.status.r,
      g: this.data.status.g,
      b: this.data.status.b
    });
  },
  cwSliderChange (event) {
    let {percent, value: _value, isMoving} = event.detail;
    // let _isMoving = event.detail.isMoving;
    // let _val = event.detail.value;
    // 区间为 1 - 255 默认为0 - 100
    // _val = 1 + parseInt(_val * 2.54);
    console.log("sliderChange _value, percent = ", _value, percent);
    this.data.status.r = 0;
    this.data.status.g = 0;
    this.data.status.b = 0;
    this.data.status.c = 255 - _value;
    this.data.status.w = _value;
    
    // 更新标题
    this.updateTitleByType(percent, "cw");

    if (isMoving) {
      return;
    }

    // 执行
    this.actDev({
      pwr: 1,
      brightness: this.data.status.brightness || 127,
      c: this.data.status.c,
      w: this.data.status.w
    });
  },
  updateTitleByType (percent, type) {
    let _list = this.data.statusList || [];
    let _valStr = "";
    if (type == "cw") {
      _valStr = bizUtil.getCWValueByPercent(percent || 0);
    } else if (type == "rgb") {
      _valStr = percent || "";
    } else if (type == "white") {
      _valStr = percent || "";
    }

    let _statusList = this.setTitleInArray(_list, type, _valStr);

    console.log("updateTitleByType _valStr, _statusList = ", _valStr, _statusList);
    this.setData({
      statusList: _statusList
    });
  },
  setTitleInArray (array, typeStr, value) {
    if (!array) {
      return [];
    }
    for (let item of array) {
      let {name, type} = item || {};
      let _nameFormat = name?.split(" ")[0] || "";
      if (type == typeStr) {
        item.name = _nameFormat + " " + (value || "");
      } else {
        item.name = _nameFormat;
      }
    }
    return array;
  },

  pwrClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.pwrList[index];
    // 发送数据
    this.pwrClickDetail(_item.value || 0);
  },
  pwrClickDetail (value) {
    let _value = value;

    // 如果是窗帘，则走窗帘的控制逻辑
    if (this.data.devType == 'curtain') {
      // let _isOpen = _value == this.data.pwrList[0].value;
      this.curtainControl(_value);
      return;
    }

    this.data.status.pwr = _value;
    console.log("this.data.status.pwr = ", _value);
    this.setData({
      status: this.data.status
    })
    let brightness = _value ? (this.data.status.brightness || 127) : 0;
    // 设备控制
    let _params = {
      brightness: brightness
    };
    if (brightness > 0) {
      _params.pwr = 1;
    }
    this.actDev(_params);
  },
  curtainControl (pwr, percent) {
    // let _pwr = (pwr == undefined ? this.data.status.pwr : pwr) || 0;
    let _percent = Math.round(percent == undefined ? (this.data.status.percent || 0) : (Number(percent) || 0));
    // this.data.status.mode = 1; // 默认开合
    this.data.status.percent = _percent;
    // this.data.status.pwr = _pwr;
    console.log("curtainControl this.data.status = ", this.data.status);
    // let _percent = Math.round((this.data.status.percent || 100));
    // 下发数据
    this.actDev({
      // mode: _pwr,
      percent: _percent
    });
    // 设置数据
    this.setData({
      status: this.data.status
    })
  },

  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    let {key} = this.data.statusList[index];

    let {c, w, brightness} = this.data.status;
    let _params = {
      pwr: 1,
      brightness: brightness || 127,
    };
    // 如果点击的是白光
    if (key == 'white') {

      // 更新标题
      this.updateTitleByType("", key);

      // 单个设备
      if (c == undefined && w == undefined) {
        // 只有rgb
        _params.r = _params.g = _params.b = 255;
        _params.c = _params.w = 0;
      } else {
        _params.r = _params.g = _params.b = 0;
        _params.c = _params.w = 127;
      }
      console.log("itemClick _params = ", _params);
      // 发送白光
      this.actDev(_params);
    } else if (key == 'cw') {
      // 取得cw的百分比
      let {percent} = this.data.cwSliders;
      let _value = bizUtil.getRealValByPercent(percent, this.data.cwSliders);
      _params.r = _params.g = _params.b = 0;
      _params.c = 255 - _value;
      _params.w = _value;
      // 发送色温
      this.actDev(_params);

      // 更新标题
      this.updateTitleByType(percent, key);

    } else if (key == 'rgb') {

      let {c, w, brightness} = this.data.status;
      let {percent} = this.data.rgbSliders;
      let _value = bizUtil.getRealValByPercent(percent, this.data.rgbSliders);
      let _rgbs = bizUtil.getRgbByAngle(_value) || [];
      // 增加处理 保存原始的值（精确到小数点 为了防止下次进入亮度不一致）
      _params.c = _params.w = 0;
      _params.r = _rgbs[0] || 0;
      _params.g = _rgbs[1] || 0;
      _params.b = _rgbs[2] || 0;

      
      // 更新标题
      this.updateTitleByType(`rgb(${_params.r}, ${_params.g}, ${_params.b})`, key);

      // 发送rgb
      this.actDev(_params);
    }

    console.log("itemClick key, this.data.status = ", key, this.data.status);

    this.data.statusKey = key;
    this.setData({
      statusKey: this.data.statusKey
    })
  },
  actDev (key) {
    console.log("actDev key = ", key);
    // 保存设备信息
    if (!!key && this.data.devType == 'light' && (typeof key != "string")) {
      // 如果只有亮度调节成0，则不保存亮度的值
      let _keyArray = Object.keys(key) || [];
      if (_keyArray.length == 1 && key['brightness'] == 0) {
        // 不保存
      } else {
        // 不能assign,会有cw等保存进去
        for (let _k in key) {
          if (this.data.status[_k] != undefined) {
            this.data.status[_k] = key[_k];
          }
        }
      }
    }
    // 单个设备还是群组设备
    if (this.data.isGroup) {
      app.globalData.blsdk.groupControlWithType(0, app.globalData.devInfo?.gid || 0, key);
    } else {
      app.globalData.blsdk.controlWithDevice(app.globalData.devInfo, key);
    }
  },

  // 设置是否显示自定义对话框
  setShowCustomToast (value, type, str, duration) {
    // console.log("setShowCustomToast ability = ", ability);
    if (!value) {
      ability.hideToast();
      // ability.hideLoading()
    } else {
      let _config = {
        title: str || '',
        icon: type || '',
        duration: duration || 1500
      };
      ability.showToast(_config);
    }
  },

  // 删除场景下绑定的执行设备
  delDev () {
    // 很奇怪的问题  使用ability调用showModal不提示了
    wx.showModal({
      title: "",
      content: "是否删除该执行设备"
    }).then((res) => {
      if (!res || !res.confirm) { return; }
      
      // 取得下标
      let _index = this.data.isEditIndex;
      // 判断是循环场景还是定时
      if (this.checkCycle()) {
        let _bodyList = app.globalData.timerInfo?.bodyList || [];
        // 删除设备
        _bodyList.splice(_index, 1);
        app.globalData.timerInfo.headObj.cmd_cnt = _bodyList.length;
      } else {
        // 取得所有设备
        delete app.globalData.timerInfo.cmd;
      }
      // 返回按钮
      this.back();
      // setTimeout(this.back, 500);
    })
  },

  // 设备执行类型设置
  typeItemClick (e) {
    // 设置选中的值
    let {index} = e.currentTarget.dataset;
    this.data.currentType = index || 0;

    // 底部按钮特殊处理
    this.dealActions();
    console.log("typeItemClick this.data.actions = ", this.data.actions);

    this.setData({
      currentType: this.data.currentType,
      // actions: this.data.actions
    });
  },

  // 特殊处理底部按钮
  dealActions () {
    // 所有按钮
    let _actions = this.getAllActions() || [];
    // 设置按钮文字
    // let _actionLen = _actions.length;
    let _currentType = this.data.currentType;
    if (this.data.isEditIndex < 0) {
      // 新增时
      if (_currentType >= 1) {
        _actions = [];
      } else {
        _actions = [_actions[1]];
      }
    } else {
      // 编辑时
      if (_currentType >= 1) {
        _actions[1].n = "返回";
        _actions[1].classStr = "finishBtn marginL49";
      }
      // 默认设备不能删除
      let _isDefault = app.globalData.devInfo?.cmd == "default";
      if (_isDefault) {
        _actions = _actions.filter(item => item.handle != "delDev");
      }
    }
    this.data.actions = _actions;
    this.setData({
      actions: this.data.actions
    })
  },

  // 根据不同的index取得不同的默认数据
  getStatusByIndex (index) {
    let _index = (index == undefined) ? this.data.currentType : index;
    if (_index == 1) {
      return {};
    } else if (_index == 2) {
      return undefined;
    } else {
      return this.data.status; 
    }
  },

  manageLoadingDialog (val) {
    this.data.showLoadingDialog = val || false;
    this.setData({
      showLoadingDialog: this.data.showLoadingDialog
    })
  },
  showLoading (str) {

    // // 如果是需要唤醒的设备
    // if (this.data.devType == 'light') {
    //   this.manageLoadingDialog(true);
    //   // 初始化定时器
    //   this.initTimer();
    // } else {
      ability.showLoading({
        title: str || "",
        mask: true
      });
    // }
  },
  hideLoading () {
    if (this.data.showLoadingDialog) {
      this.manageLoadingDialog(false);

      // 取消进一步提示
      this.data.loadingConfig.forward = false;
      this.setData({
        loadingConfig: this.data.loadingConfig
      })
      return;
    }

    ability.hideLoading();
  },
  initTimer () {
    // 先清除定时器
    this.destoryTimer();
    // 初始化定时器
    this.data.timer = setTimeout(() => {
      // 如果定时器还存在，则退出
      if (!this.data.timer) {
        return;
      }
      // 进一步提示
      this.data.loadingConfig.forward = true;
      this.setData({
        loadingConfig: this.data.loadingConfig
      })
    }, 5000);
  },
  destoryTimer (timer) {
    let _timer = timer || this.data.timer;
    if (!_timer) {
      return
    }
    clearTimeout(_timer);
    _timer = null;
  },
  // 对话框
  dialogClick (e) {
    let {data} = e.detail || {};
    // 是否显示对话框
    let _showLoadingDialog = false;
    if (data == 'retry') {
      // 重试按钮点击 不做
      // // 上一个修改房间方法是否过期
      // this.data.lastAvalible = true;
      // // 修改房间的方法
      // modifyFunc: undefined
    } else if (data == 'cancel') {
      // // 未响应
      // _showLoadingDialog = true;
      // 停掉之前的数据
      app.globalData.blsdk.destory();
      // 去掉接受的参数
      this.data.lastAvalible = true;
    } else if (data == 'confirm') {
      // 设置成功之后
      this.dealAfterSend();
      // 停掉之前的数据
      app.globalData.blsdk.destory();
      // 去掉接受的参数
      this.data.lastAvalible = true;
    }
    // 是否展示
    this.manageLoadingDialog(_showLoadingDialog);
    // 数据提示
    this.data.loadingConfig.forward = false;
    // this.data.showLoadingDialog = _showLoadingDialog;
    this.setData({
      // showLoadingDialog: this.data.showLoadingDialog,
      loadingConfig: this.data.loadingConfig
    })
  },
})