const app = getApp()
module.exports = {
  // 取得设备状态
  getDevStatus () {
    // 第一次
    // if (isFirst) {
    // 取得所有设备保存的状态数据
    let _allDevStatus = app.globalData.allStatus || {};
    // 根据设备did+短地址获取设备状态
    let {d, a} = app.globalData.devInfo || {};
    // 设备状态
    let _devStatus = _allDevStatus[d + "_" + a] || {};
    // }
    // 取得当前设备的状态
    return _devStatus || {};
  },
  // 取得温度的值
  getTempByHistoryJson ({temperature, tempunit}, settedUnit) {
    let _result = {
      temp: 0,
      unit: "℃" // 默认摄氏
    };
    // 温度 这里特殊处理把温度+100，为了保证温度在湿度上面，偷懒用 这里也要判断温度单位
    let _tmpTemp = (Number(temperature) || 0) / 10;

    // 取得默认的温度
    let _currentUnitStr = settedUnit;
    if (!_currentUnitStr) {
      let _defaultObj = this.getDevStatus();
      _currentUnitStr = _defaultObj?.unit || _result.unit;
    }

    // 判断需要设置的温度单位是华氏还是摄氏 未设置默认为摄氏 2为华氏
    let _unit = _currentUnitStr == "°F" ? 2 : 1;
    let _isLastUnitF = tempunit == 2 || tempunit == "°F"; // 是否华氏
    if (_unit == 2) {
      // 需要显示为华氏时
      _result.unit = "°F";
      if (_isLastUnitF) {
        _result.temp = _tmpTemp;
      } else {
        _result.temp = this.turnSheshiToHuaShi(_tmpTemp);
      }
    } else {
      _result.unit = "℃";
      if (_isLastUnitF) {
        // 华氏
        _result.temp = this.turnHuaShiToSheshi(_tmpTemp);
      } else {
        _result.temp = _tmpTemp;
      }
    }
    
    return _result;
  },
  // 华氏转摄氏
  turnHuaShiToSheshi (value) {
    return Number((((value || 0) - 32) / 1.8).toFixed(1)) || 0;
  },
  // 摄氏转华氏
  turnSheshiToHuaShi (value) {
    return 32 + parseInt((value || 0) * 1.8) || 0;
  },
  // 历史数据显示
  getTextByDevTypeAndData (json, devTypeStr) {
    console.log("getTextByDevTypeAndData json, devTypeStr = ", json, devTypeStr);
    let _result = "";
    if (!json) {
      return _result;
    }
    let {occurtime, lowbattery, tamperevident, doorsensor_status, humidity, temperature, sosalarm} = json;
    if (devTypeStr == "sossensor") {
      _result = sosalarm ? "报警" : "取消报警";
    } else if (devTypeStr == "temphumidity") {
      
      // let _humidity = humidity || 0;

      let _tmpArray = [];
      if (temperature != undefined) {
        // 温湿度计
        let {temp, unit} = this.getTempByHistoryJson(json);
        console.log("getTextByDevTypeAndData temp = ", temp);
        _tmpArray.push("温度：" + temp + unit);
      }
      if (humidity != undefined) {
        _tmpArray.push("湿度：" + humidity + "%");
      }
      if (_tmpArray.length > 0) {
        _result = _tmpArray.join("，")
      }
       // _temp + "℃, 湿度 " + _humidity + "%";
    } else {
      // 是否被拆动 > 低电量 > 门磁开关
      if (tamperevident) {
        _result = "有拆动";
      } else if (lowbattery) {
        _result = "低电量";
      } else {
        _result = doorsensor_status ? "门磁开" : "门磁关";
      }
    }
    return _result;
  }
};