import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil"
var app = getApp()
Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "所在房间"
      }
    },
    roomList: [],
    selected: -1,

    bleUnavailable: false,

    // 发送时唤醒文案配置
    showSaveDialog: false,
    sendingConfig: {
      devTypeStr: ''
    },

    // 非唤醒的提示
    showLoadingDialog: false,
    loadingConfig: {
      forward: false
    },
    // 定时器
    timer: null,
    // 保存点击的房间id
    targetRoomId: 0,
    // 上一个修改房间方法是否过期
    lastAvalible: false,
    // 修改房间的方法
    modifyFunc: undefined,

    // 是否多楼层
    isFloor: false,
    floors: [], // 楼层列表
    // 是否显示
    showActionsheet: false,
    // 当前选择的楼层
    floor: {
      id: 0, // 默认全屋
      n: '全屋'
    }
  },
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    let {lowPower} = options || {};
    this.lowPower = Number(lowPower) || 0;
  },
  onUnload () {
    // 清除定时器
    this.destoryTimer(this.data.timer);
  },
  onReady: function () {
    // 是否群组控制
    let _isGroup = this.isGroupCtrl();
    // 取得默认的房间
    this.data.selected = this.initSelectRoomId(_isGroup);
    
    console.log("onReady app.globalData.roomInfo?.id = ", app.globalData.roomInfo?.id);
    // 初始化当前楼层
    let _defaultFloor = app.globalData.familyInfo?.floor;
    console.log("onReady _defaultFloor = ", _defaultFloor, app.globalData.familyInfo);
    let _roomId = 0;
    if (_defaultFloor >= 0) {
      if (_isGroup) {
        _roomId = app.globalData.groupInfo?.rid || app.globalData.groupInfo?.id || 0;
      } else if (app.globalData.devInfo) {
        _roomId = app.globalData.devInfo?.id || 0
      } else {
        _roomId = app.globalData.roomInfo?.id || 0;
      }
      // 此处有个bug，当家庭下只有全屋和2楼时，这里的楼层会显示为空
      let _floorRoomId = bizUtil.getRoomIdByFloor(_defaultFloor);
      if (_defaultFloor > 0 && app.globalData.devs[_floorRoomId]) {
        this.initFloorJson(parseInt(_defaultFloor), 0);
      } else {
        this.initFloorJson(bizUtil.getFloorByRoomId(_roomId), 0);
      }
    } else {
      // if (app.globalData.devInfo) {
      //   _roomId = app.globalData.devInfo?.id || 0
      // } else {
      //   _roomId = app.globalData.roomInfo?.id || 0;
      // }
      this.initFloorJson(undefined, 0);
    }

    // 取得设备类型 设置唤醒文案
    let _devTypeStr = _isGroup ? app.globalData.groupInfo?.t : bizUtil.getDevTypeStr(app.globalData.devInfo?.t);
    this.data.sendingConfig.devTypeStr = _devTypeStr;

    this.setData({
      selected: this.data.selected,
      sendingConfig: this.data.sendingConfig
    })
  },
  // 是否群组控制
  isGroupCtrl () {
    return !!app.globalData.groupInfo && !!app.globalData.tgroupId;
  },
  initSelectRoomId (isGroup) {
    // 是否群组控制
    if (isGroup) {
      return app.globalData.groupInfo?.rid || 0;
    }
    // 设备房间信息
    let _devInfo = app.globalData.devInfo || {};
    let _roomId = _devInfo.id || 0;
    return _roomId;
  },
  // 取得当前所有楼层
  initFloorJson (_floor, defaultFloor) {
    // let _floor = floor;
    console.log("initFloorJson _floor = ", _floor);
    if (_floor >= 0) {
      this.data.isFloor = true;
      // 取得所有的楼层信息
      this.initFloors();
      // 初始化楼层
      this.initRoomByFloor(_floor);

      let _roomId = _floor * 32 + 32;
      if (app.globalData.devs[_roomId]) {
        // 当前楼层
        this.data.floor.id = _floor * 32 + 32;
        this.data.floor.n = app.globalData.devs[this.data.floor.id]?.n || "";
      } else {
        // 当前楼层
        this.data.floor.id = (defaultFloor || 0) * 32 + 32;
        this.data.floor.n = app.globalData.devs[this.data.floor.id]?.n || "";
      }
      
    } else {
      this.data.isFloor = false;
      // 初始化楼层
      this.initRoomByFloor(_floor);
    }
    this.setData({
      isFloor: this.data.isFloor,
      floor: this.data.floor
    })
  },
  initFloors () {
    let _floors = bizUtil.getFloorNames(app.globalData.devs);
    _floors.map(item=>(item.value=item.id,item.text=item.n));
    this.data.floors = _floors;
    // console.log("initFloors this.data.floors = ", this.data.floors);
    this.setData({
      floors: this.data.floors
    })
  },
  initRoomByFloor (floor) {
    console.log("initRoomByFloor floor = ", floor);
    // 所有设备
    let _allDevs = app.globalData.devs || {};
    // 当前楼层
    let _floor = floor || 0;
    // 根据多楼层取得数据
    let _devs = bizUtil.getDevsByFloor(_allDevs, _floor);
    // 取得所有房间数据
    let {rooms} = bizUtil.getRoomsByDevs(_devs);
    // 判断是否群组控制
    let _isGroup = this.isGroupCtrl();
    if (!_isGroup) {
      // 去除楼层
      rooms = rooms.filter(item=>(item.id == 0 || (item.id > 0 && (item.id % 32 != 0)))); 
    }
    this.data.roomList = rooms;
    this.setData({
      roomList: this.data.roomList
    })
  },
  isGroupCtrl () {
    return app.globalData.groupInfo?.gid > 0;
  },
  changeSelectRoom (e) {
    // 设置选中的
    let _idx = e.currentTarget.dataset.index;
    if (_idx == this.data.selected) {
      return;
    }
    let _item = this.data.roomList[_idx];
    if (!_item) {
      return;
    }
    // 初始化
    this.data.lastAvalible = false;
    // 选择的房间id
    let _roomId = _item.id || 0;

    // 保存当前选中的值
    this.data.selected = _roomId;
    this.setData({
      selected: this.data.selected
    });
    // // 重置计数器
    // this.data.sendCount = 0;
    // // 发送命令
    // this.roomIdSet(app.globalData.devInfo, _roomId);
  },
  dealAfterSet (roomId) {
    // 房间id
    let _idx = roomId;
    // 当前数据
    let _devInfo = app.globalData.devInfo;
    // 旧数据
    let _oldRoom = app.globalData.devs[_devInfo.id || 0];
    let _oldDevs = _oldRoom.devs || [];
    // 删除原先的数据，加入到新的房间
    let _roomInfo = app.globalData.devs[_idx] || {};
    
    // 防止没有设备列表数据
    _roomInfo.devs = _roomInfo.devs || [];
    
    let _devs = _roomInfo.devs || [];
    console.log("_devs = ", _devs, _idx);
    
    // 保存新的房间信息
    _devInfo.id = _idx;
    _devInfo.or = _devs.length + 1;

    // 如果是超级面板，则需要清空绑定的数据
    let _devTypeStr = bizUtil.getDevTypeStr(_devInfo.t);
    if (_devTypeStr == "uart") {
      _devInfo.ds = [];
    } else if (bizUtil.isPwrAvalibleDev(_devInfo.t)) {
      // 新增判断如果是支持超级面板的继电器设备则初始化绑定按键信息
      _devInfo.ds = bizUtil.initMetaPwrKeyBind(_devInfo);
    }

    // 取得老数据的下标
    let _oldIdx = this.getIndexById(_oldDevs, _devInfo.d);
    if (_oldIdx >= 0) {
      _oldDevs.splice(_oldIdx, 1);
    }
    // 新数据加入到房间
    _devs.push(_devInfo);

    // 移动房间之后需要删除之前不在房间内的场景
    // 删除对应的场景 增加判断，如果是触发设备，则不清除
    let _isActionDev = bizUtil.isActionDev(_devTypeStr);
    if ((_isActionDev && _devTypeStr != "thermostat")) {
      console.log("dealAfterSet moveDev");
      bizUtil.moveDev(app.globalData.devs, _devInfo, !_idx ? [0] : (_idx % 32 == 0 ? [0, _idx] : [0, _idx, _idx + 32 - (_idx % 32)]));
    }

    // 添加默认群组
    bizUtil.addDefaultGroupByDevs(app.globalData.devs);

    console.log("_idx, app.globalData.devs = ", _idx, app.globalData.devs);
    this.data.selected = _idx;
    this.setData({
      selected: this.data.selected
    });
    // 保存设备 写在这里是因为在这个页面点击物理按键的【重新进入小程序】，不会触发保存方法，所以需要都保存一下,且ios不走app.js的hide方法
    app.saveAllDevsMap(true);

    // 上报数据
    app.uploadPrivateData();
  },

  // saveInfo () {
  //   // 保存设备信息
  //   app.saveAllDevsMap();
  // },

  // 数组中取得相同的数据
  getIndexById (array, d) {
    for (let key in array) {
      let _item = array[key];
      if (d == _item.d) {
        return key;
      }
    }
    return -1;
  },
  addRoom () {
    console.log("addRoom")
    ability.navigateTo("../addRoom/index");
  },
  showLoading (str) {
    // 设备类型
    let _t = app.globalData.devInfo?.t || 0;
    // 如果是需要唤醒的设备
    let _devTypeStr = this.data.sendingConfig.devTypeStr;
    if (this.lowPower || _devTypeStr == "watersensor" ||_devTypeStr == "bodysensor" || _devTypeStr == "doorsensor" || (_devTypeStr == 'panel' && (!bizUtil.isPwrAvalibleDev(_t) && !bizUtil.isNormalPanel(_t)))) {
      this.setData({
        showSaveDialog: true
      })
    } else if (_devTypeStr == 'light') {
      this.setData({
        showLoadingDialog: true
      })
    } else {
      ability.showLoading({
        title: str || "",
        mask: true
      });
    }
  },
  hideLoading () {
    // 如果显示了dialog，则隐藏
    if (this.data.showSaveDialog) {
      this.setData({
        showSaveDialog: false
      })
    }
    if (this.data.showLoadingDialog) {
      this.data.loadingConfig.forward = false;
      this.setData({
        showLoadingDialog: false,
        loadingConfig: this.data.loadingConfig
      })
    }
    // 隐藏等待条
    ability.hideLoading();
  },
  initTimer () {
    // 先清除定时器
    this.destoryTimer();
    // 初始化定时器
    this.data.timer = setTimeout(() => {
      // 如果定时器还存在，则退出
      if (!this.data.timer) {
        return;
      }
      // 进一步提示
      this.data.loadingConfig.forward = true;
      this.setData({
        loadingConfig: this.data.loadingConfig
      })
    }, 5000);
  },
  destoryTimer (timer) {
    let _timer = timer || this.data.timer;
    if (!_timer) {
      return
    }
    clearTimeout(_timer);
    _timer = null;
  },
  // 设置房间id
  roomIdSet (devInfo, roomId) {
    // 显示等待条
    this.showLoading("正在设置中…");
    
    // 修改方面的配置
    let _modifyRoomConfig = {
      // noRemote: true
    };
    // 判断是否灯泡，如果是灯泡，则初始化定时器
    let _devTypeStr = this.data.sendingConfig.devTypeStr;
    if (_devTypeStr == 'light') {
      // 保存点击的房间id
      this.data.targetRoomId = roomId;
      // 初始化定时器
      this.initTimer();
    } else if (_devTypeStr == 'virtualPanel') {
      // 如果是双控修改房间，则不需要心跳回复，固定下发5s即可
      _modifyRoomConfig.noHearbeat = true;
      _modifyRoomConfig.sendSecond = 5000;
    }

    console.log("roomIdSet devInfo, roomId = ", devInfo, roomId);

    app.globalData.blsdk.modefyDevice(devInfo, roomId, this.data.modifyFunc = (newRoomId) => {
      console.log("roomIdSet newRoomId = ", newRoomId);
      // 是否失效
      if (this.data.lastAvalible) {
        return this.toastSuccess();
      }
      // 初始化定时器
      this.destoryTimer();
      // 隐藏等待条
      this.hideLoading();
      // 成功还是失败  这里可能是0
      if (newRoomId === undefined || (typeof newRoomId == "object" && !!newRoomId.errCode)) {
        this.setData({
          bleUnavailable: true
        })
        return;
      } else if (newRoomId === false || newRoomId < 0) {
        ability.showToast({
          title: "请检查设备状态" // 提示信息
        })
        return;
      }
      // 设置成功之后
      this.dealAfterSet(newRoomId);
      // 提示成功，并返回页面
      this.toastSuccess();
    }, _modifyRoomConfig);
  },
  toastSuccess () {
    ability.showToast({
      title: "修改成功",
      icon: "success"
    });
    setTimeout(() => {
      ability.navigateBack();
    }, 1500);
  },
  save () {
    // 设置选中的
    let _newRoomId = this.data.selected;
    // 未选择的场合
    if (_newRoomId == undefined || _newRoomId < 0) {
      return ability.showToast({
        title: "请选择房间"
      })
    }

    // 是否群组更改房间
    let _isGroupCtrl = this.isGroupCtrl();

    // 判断新房间下是否有重复设备名称
    let _name = (_isGroupCtrl ? app.globalData.groupInfo : app.globalData.devInfo)?.n || "";
    let _existArray = bizUtil.getExistNameCountByDevInJson(app.globalData.devs, {
      id: _newRoomId
    }, _name);
    console.log("save _newRoomId, _name, _existArray = ", _newRoomId, _name, _existArray);
    if (_existArray.length > 0) {
      ability.showToast({
        title: "新房间存在重复名称，修改后移动房间"
      })
      return;
    }

    // 判断是否群组控制，如果是，则直接更改房间
    if (_isGroupCtrl) {
      return this.dealGroupAfterChangeRoom(_newRoomId);
    }
    // 旧的房间id
    let _oldRoomId = (_isGroupCtrl ? (app.globalData.groupInfo?.rid || 0) : app.globalData.devInfo?.id);
    if (_newRoomId == _oldRoomId) {
      // 如果选择相同的房间，则返回
      return ability.navigateBack();
    }

    // 初始化
    this.data.lastAvalible = false;
    // 重置计数器
    this.data.sendCount = 0;
    // 发送命令
    this.roomIdSet(app.globalData.devInfo, _newRoomId);
  },
  // 群组改动房间之后的处理
  dealGroupAfterChangeRoom (newRoomId) {
    // 群组信息
    let _groupInfo = app.globalData.groupInfo || {};
    // // 之前的房间id
    // let _oldRoomId = oldRoomId || 0;
    // 新的房间
    let _newRoomId = newRoomId || 0;
    // 房间下的设备详情
    // let _oldDevRoomDetail = app.globalData.devs[_oldRoomId];
    // console.log("dealGroupAfterChangeRoom _oldRoomId, _newRoomId, _groupInfo = ", _oldRoomId, _newRoomId, _groupInfo);
    // 删除之前的群组信息
    bizUtil.delGroupByGidInJson(app.globalData.devs, [_groupInfo.gid]);
    console.log("dealGroupAfterChangeRoom app.globalData.devs = ", app.globalData.devs);
    // this.delGroupByGidInArray(_oldDevRoomDetail?.groups, _groupInfo.gid);
    // console.log("dealGroupAfterChangeRoom _oldDevRoomDetail = ", _oldDevRoomDetail, _newDevRoomDetail);
    // 群组的房间id
    _groupInfo.rid = _newRoomId;
    // 加入新的房间中
    let _newDevRoomDetail = app.globalData.devs[_newRoomId];
    _newDevRoomDetail.groups = _newDevRoomDetail.groups || [];
    _newDevRoomDetail.groups.push(_groupInfo);
    // 保存数据
    app.saveWhenHide();
    // 返回上一页
    this.back();
  },

  // 对话框
  dialogClick (e) {
    let {data} = e.detail || {};
    // 是否显示对话框
    let _showLoadingDialog = false;
    if (data == 'retry') {
      // 重试按钮点击 不做
      // // 上一个修改房间方法是否过期
      // this.data.lastAvalible = true;
      // // 修改房间的方法
      // modifyFunc: undefined
    } else if (data == 'cancel') {
      // // 未响应
      // _showLoadingDialog = true;
      // 停掉之前的数据
      app.globalData.blsdk.destory();
      // 去掉接受的参数
      this.data.lastAvalible = true;
    } else if (data == 'confirm') {
      // 设置成功之后
      this.dealAfterSet(this.data.targetRoomId);
      // 停掉之前的数据
      app.globalData.blsdk.destory();
      // 去掉接受的参数
      this.data.lastAvalible = true;
      // 提示成功，并返回页面
      this.toastSuccess();
    }
    // 数据提示
    this.data.loadingConfig.forward = false;
    this.data.showLoadingDialog = _showLoadingDialog;
    this.setData({
      showLoadingDialog: this.data.showLoadingDialog,
      loadingConfig: this.data.loadingConfig
    })
  },
  showPop () {
    this.manageActionSheet(true);
  },
  hidePop () {
    this.manageActionSheet(false);
  },
  manageActionSheet (val) {
    this.data.showActionsheet = val || false;
    this.setData({
      showActionsheet: this.data.showActionsheet
    })
  },
  actionBtnClick (e) {
    let {value, index} = e.detail || {};
    console.log("actionBtnClick index = ", index, value);
    // 重新设置家庭数据
    this.initFloorJson(bizUtil.getFloorByRoomId(value));
    // 隐藏
    this.hidePop();
  },
  back () {
    ability.navigateBack();
  }
})