// device/light/devProperty/detail/index.js
import ability from '../../../../utils/classDef/ability'
import bizUtil from '../../../../utils/bizUtil'
import GROUPS from '../../../../static/js/jsConfig/groups'
import { Utils } from '../../../../utils/util'
const devBehavior = require("../../../../static/js/behavior/device")
const groupBehavior = require("../../../../static/js/behavior/group")
// const historyCommon = require("../../../jsConfig/history")
var app = getApp()
Page({
  behaviors: [devBehavior, groupBehavior],
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备详情"
      }
    },
    items: [],
    devInfoList: [
      {
        title: '品类',
        value: '',
        key: "t"
      }, {
        title: 'Did',
        value: '',
        key: "d"
      }, {
        title: '地址', // 短
        value: '',
        key: "a"
      }, {
        title: '版本', // 号
        value: '',
        key: "v"
      }
    ],
    bleUnavailable: false,
    fromAddPage: false, // 页面从配网进入
    devTypeStr: '',
  },
  onLoad: function (options) {
    // 新增type字段用于标识后加入全屋设备 只有房间进入才需要传type
    let {remote, from, airhotwind, type} = options || {};
    // 是否支持遥控器
    this.supportRemote = (remote != 0);
    // 判断是否房间控制 兼容 devInfo:单个设备 groupInfo：固定群组 tgroupId：临时群组 tmpData?.tdevs:旧批量设备（5个一包）
    this.data.isRoom = app.globalData?.tmpData?.roomInfo;
    // 是否群组 默认不是群组
    let _isGroup = false;
    if (this.data.isRoom) {
      // 取得后加的默认房间群组信息
      let _defaultGroupInfo = this.getDefaultGroupInfoByType(type);
      if (!_defaultGroupInfo) {
        return ability.showToast({
          title: "数据不存在"
        })
      }
      // 不支持清除遥控器
      this.supportRemote = false;
      // 临时保存房间信息
      this.curInfo = _defaultGroupInfo;
      // 初始化设备信息
      this.initDevInfo(_defaultGroupInfo, true);
    } else {
      // 是否群组
      _isGroup = this.isGroupCtrl();
      // 判断设备
      if (_isGroup) {
        this.curInfo = app.globalData.groupInfo;
        // 群组设备
        let _list = this.getGroupDevInfo(this.curInfo);
        this.setProperValue("devInfoList", _list);
      } else {
        this.curInfo = app.globalData.devInfo;
        // 初始化设备信息
        this.initDevInfo(this.curInfo);
      }
    }
    
    // 同步数据
    this.setData({
      isGroup: _isGroup,
      fromAddPage: from == "add",
      isRoom: this.data.isRoom,
      deviceImg: this.curInfo?.tStr
    });
  },
  // 取得新加入的房间默认群组的数据
  getDefaultGroupInfoByType (type) {
    if (!type) {
      return
    }
    let _roomId = app.globalData.roomInfo?.id || 0;
    let _roomDefaultGroupInfo = (app.globalData.devs[_roomId])?.groups;
    if (!_roomDefaultGroupInfo) {
      return
    }
    let _filterGroups = _roomDefaultGroupInfo.filter(item => (item.gid == _roomId && item.t == type));
    if (_filterGroups.length != 1) {
      return;
    }
    return _filterGroups[0];
  },
  // 是否群组控制
  isGroupCtrl () {
    return !!app.globalData.groupInfo && !!app.globalData.tgroupId;
  },
  
  onShow () {
  },
  onUnload () {
  },
  setProperValue (key, val) {
    if (this.data == undefined) {
      return;
    }
    this.data[key] = val;
    this.setData({
      [key]: val
    })
  },
  // 初始化群组显示的信息
  getGroupDevInfo (groupInfo) {
    let {t, gid} = groupInfo || {};
    return [{
      title: '品类',
      value: t,
      key: "t"
    }, {
      title: '固定群组',
      value: gid,
      key: "gid"
    }];
  },
  // 初始化单个显示的信息
  initDevInfo (devInfo, isRoom) {
    if (!devInfo) {
      console.log("_devInfo is not exist");
      return;
    }
    let _devInfo = devInfo;
    let {t, sub, wd, d, a, v} = _devInfo;
    // 设置设备类型
    let _devTypeStr = bizUtil.getDevTypeStr(t);
    this.data.devTypeStr = _devTypeStr;
    // 是否ihg设备信息
    this.isIhg = bizUtil.isIhg(t);
    // 是否空调内机
    let _airconditionSub = false;
    // 是否空调网关
    let _isGateway = _devTypeStr == "gateway";
    // 是否网关设备
    if (_isGateway) {
      this.getDevVersion(devInfo, (result) => {
        
        console.log("initDevInfo getDevVersion result = ", result);
        // 版本号
        if (!result) {
          // 如果原先有版本号，则显示之前的版本
          if (app.globalData.devInfo?.v) {
            return;
          }
          this.data.devInfoList[3].value = "获取失败";
        } else {
          let _version = result.v;
          this.data.devInfoList[3].value = _version;
          // 保存版本到设备信息中
          !!app.globalData.devInfo && (app.globalData.devInfo.v = _version);
          // 比较版本号
          this.checkVersion(result);
        }
        this.setData({
          devInfoList: this.data.devInfoList
        })
      });
    } else if (_devTypeStr == "aircondition") {
      if (!(sub)) {
        _airconditionSub = true;
      }
    }
    console.log("initDevInfo _airconditionSub = ", _airconditionSub);

    // 如果是ihg 显示
    // if (this.isIhg) {
      // 显示WiFi的mac地址
      this.data.devInfoList.push({
        title: 'WiFi/Mac',
        realTitle: "Mac",
        key: "wd",
        value: this.strToMac(wd || d) || ''
      });
    // }
    
    this.data.devInfoList[0].value = (Number(t) != t) ? bizUtil.getSendPidByType(t) : t;
    // 如果是房间
    if (isRoom) {
      this.data.devInfoList = this.data.devInfoList.slice(0, 1);
    } else {
      this.data.devInfoList[1].value = d?.padStart(32,"0");
      this.data.devInfoList[2].value = a;
      this.data.devInfoList[3].value = (v == undefined && _isGateway) ? '正在获取…' : (v || 0);
    }

    this.setData({
      devInfoList: this.data.devInfoList,
      devTypeStr: this.data.devTypeStr,
      isAirconditionSub: _airconditionSub
    })
  },
  strToMac (str) {
    let _len = str?.length;
    if (!_len) {
      return "";
    }
    let _result = [];
    for (let i = 0; i < _len; ) {
      let _tmp = str.substr(i, 2);
      if (_tmp.length < 2) {
        _tmp = _tmp + "0";
      }
      _result.push(_tmp);
      i += 2;
    }
    return _result.join(":");
  },

  onReady: function () {
  },
  // 如果是网关设备，取得网关的授权码
  getDevVersion (devInfo, callback) {
    if (!devInfo) {
      !!callback && (callback(false));
      return;
    }
    console.log("getDevVersion devInfo = ", devInfo);
    // 网关链接的集群
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    // 设备信息 ihg需要用wd去获取版本号
    let _devInfo = devInfo;
    if (this.isIhg && _devInfo?.wd) {
      _devInfo = Object.assign({}, devInfo, {d: _devInfo.wd});
    };
    // 取得网关的code
    let _result = app.globalData.blsdk.getDeviceVersion(_devInfo, _groupStr);
    if (!_result || !_result.then) {
      console.error("getDevVersion _result = ", _result);
      return;
    }
    _result.then((result) => {
      // 回调函数
      if (!callback) {
        return;
      }
      // 数据
      let _payload = result?.event?.payload;
      // 固件版本
      let _v = _payload?.version;

      // 如果没有版本号
      if (_v == undefined) {
        return callback(false);
      }

      // 服务器版本
      let _sv = _payload?.serverversion?.version;
      // 服务器升级路径
      let _url = _payload?.serverversion?.url;
      console.log("getDevVersion _result = ", _v);
      // 回调函数
      callback({
        v: _v,
        sv: _sv,
        url: _url
      });
    }).catch((e) => {
      console.error("getDevVersion catch e = ", e);
      !!callback && (callback(false));
    });
  },
  copyDevInfo () {
    let _json = this.getDevListJson(this.data.devInfoList);
    console.log("copyDevInfo _json = ", _json);
    ability.setClipboardData({
      data: JSON.stringify(_json)
    });
  },
  getDevListJson (list) {
    let {n, id, rid, gid} = this.curInfo || {};
    let _roomId = rid || id || 0;
    let _result = {
      "设备名称" : n || "",
      "所在房间" : app.globalData.devs[_roomId]?.n || "",
      "房间 Id": _roomId
    };
    if (!list || list.length == 0) {
      return _result;
    }
    for (let item of list) {
      _result[item.realTitle || item.title] = item.value || "";
    }
    return _result;
  },
  upgradeGateway (devInfo, url, callback) {
    if (!devInfo) {
      !!callback && (callback(false));
      return;
    }
    console.log("upgradeGateway devInfo = ", devInfo);
    // 网关链接的集群
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    // 取得网关的code
    let _result = app.globalData.blsdk.upgradeGateway(devInfo, _groupStr, url);
    if (!_result || !_result.then) {
      console.error("getDevVersion _result = ", _result);
      return;
    }
    _result.then((result) => {
      console.log("upgradeGateway result = ", result);
      !!callback && (callback(result));
      // 初始化定时器
      // this.initTimer();
      // // let {event} = result || {};
      // let _version = result?.event?.payload?.version;
      // if (_version == undefined) {
      //   // 如果原先有版本号，则显示之前的版本
      //   if (app.globalData.devInfo?.v) {
      //     return;
      //   }
      //   this.data.devInfoList[3].value = "获取失败";
      // } else {
      //   this.data.devInfoList[3].value = _version;
      //   // 保存版本到设备信息中
      //   !!app.globalData.devInfo && (app.globalData.devInfo.v = _version);
       
      // }
      // this.setData({
      //   devInfoList: this.data.devInfoList
      // })
    }).catch((e) => {
      console.log("upgradeGateway e = ", e);
      !!callback && (callback(false));
      // // 如果原先有版本号，则显示之前的版本
      // if (app.globalData.devInfo?.v) {
      //   return;
      // }
      // this.data.devInfoList[3].value = "获取失败";
      // this.setData({
      //   devInfoList: this.data.devInfoList
      // })
    });
  },

  initTimer () {
    // 初始化次数
    this.data.count = 15;
    // 先销毁定时器
    this.destoryTimer(this.data.timer);
    // 显示定时器
    ability.showLoading({
      title: "升级中…",
      mask: true
    });
    // 初始化定时器
    this.data.timer = setInterval(() => {

      // 如果定时器被销毁
      if (!this.data.timer || this.data.count < 0) {
        return;
      }

      // 次数
      this.data.count--;
      // 获取版本号
      this.getDevVersion(app.globalData.devInfo, (result) => {
        // 版本号等
        let {v, sv} = result || {};
        if (v == undefined || v < sv) {
          // 判断次数
          if (this.data.count > 0) {
            return;
          }
          ability.hideLoading();
          // 销毁定时器
          this.destoryTimer(this.data.timer);
          // 提示信息
          setTimeout(() => {
            ability.showToast({
              title: "升级失败",
              icon: "error"
            })
          }, 0);
          return;
        }
        // 隐藏等待条
        ability.hideLoading();
        // 保存版本到设备信息中
        !!app.globalData.devInfo && (app.globalData.devInfo.v = v);
        // 销毁定时器
        this.destoryTimer(this.data.timer);
        // 赋值
        let _index = this.data.devInfoList.findIndex(item => item.key == "v");
        if (_index < 0) {
          return;
        }
        this.data.devInfoList[_index].value = v;
        // 设置数据
        this.setData({
          devInfoList: this.data.devInfoList
        });
        // 提示信息
        setTimeout(() => {
          ability.showToast({
            title: "升级成功",
            icon: "success"
          })
        }, 0);
      });
    }, 5000);
  },
  checkVersion (params) {
    // 数据
    let {v, sv, url} = params || {};
    // 如果没有服务器版本号
    if (sv == undefined) {
      return;
    }
    // 如果版本号小于服务器版本号
    if (v < sv) {
      wx.showModal({
        title: "",
        content: "发现新版本，是否升级",
        showCancel: true,
        confirmColor: "#576B95",
        confirmText: "升级",
        cancelText: "取消",
        cancelColor: '#000000',
        success: (res) => {
          console.log("showModal res = ", res);
          if (res.confirm) {
            // 升级
            this.upgradeGateway(app.globalData.devInfo, url, (result) => {
              if (!result) {
                ability.showToast({
                  title: "升级失败",
                  icon: "error"
                })
                return;
              }
              // 初始化定时器
              this.initTimer();
            });
          } else if (res.cancel) {}
        },
        fail: (e) => {
          console.log("showModal fail e = ", e);
        }
      });
    }
  },
  
  destoryTimer (timer) {
    bizUtil.clearTimer(timer, "interval");
  },
})