/*
 * @Author: your name
 * @Date: 2021-05-24 15:59:52
 * @LastEditTime: 2021-05-28 10:13:44
 * @LastEditors: your name
 * @Description: In User Settings Edit
 * @FilePath: \blewxwebui\miniwechat\miniprogram\device\light\devProperty\index.js
 */
import ability from '../../../utils/classDef/ability'
import bizUtil from '../../../utils/bizUtil'
import GROUPS from '../../../static/js/jsConfig/groups'
const devBehavior = require("../../../static/js/behavior/device")
const groupBehavior = require("../../../static/js/behavior/group")
const historyCommon = require("../../jsConfig/history")
var app = getApp()
Page({
  behaviors: [devBehavior, groupBehavior],
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备详情"
      }
    },
    items: [],
    devInfoList: [
      {
        title: '品类',
        value: ''
      }, {
        title: '设备id',
        value: ''
      }, {
        title: '短地址',
        value: ''
      }, {
        title: '版本号',
        value: '',
      }
    ],
    roleNum: 0,
    bleUnavailable: false,
    fromAddPage: false, // 页面从配网进入
    // supportRemote: false, // 是否支持遥控器

    devTypeStr: '',

    timer: null, // 定时器
    count: 15, // 循环15次

    isGroup: false, // 是否群组
    isAirconditionSub: false, // 是否空调内机

    // 新增房间控制放入设备中
    isRoom: false, // 是否房间控制

    // 温度单位设置
    unitArray: [{
      text: "°F",
      value: 1
    }, {
      text: "℃",
      value: 0
    }],
    showActionsheet: false, // 是否显示actionsheet

    deviceImg: "", // 设备图标
  },
  onLoad: function (options) {
    // 新增type字段用于标识后加入全屋设备 只有房间进入才需要传type lowPower:超级面板是否低功耗
    let {remote, from, airhotwind, type, lowPower} = options || {};
    // 是否支持遥控器
    this.supportRemote = (remote != 0);
    // 设备品类
    this.type = type || "";
    // 是否低功耗
    this.lowPower = lowPower;
    // 判断是否房间控制 兼容 devInfo:单个设备 groupInfo：固定群组 tgroupId：临时群组 tmpData?.tdevs:旧批量设备（5个一包）
    this.data.isRoom = app.globalData?.tmpData?.roomInfo;
    // 是否群组 默认不是群组
    let _isGroup = false;
    if (this.data.isRoom) {
      // 取得后加的默认房间群组信息
      let _defaultGroupInfo = this.getDefaultGroupInfoByType(type);
      if (!_defaultGroupInfo) {
        return ability.showToast({
          title: "数据不存在"
        })
      }
      // 不支持清除遥控器
      this.supportRemote = false;
      // 临时保存房间信息
      this.curInfo = _defaultGroupInfo;
      // 初始化设备信息
      this.initDevInfo(_defaultGroupInfo, true);
      // // 清除之前的临时数据
      // !!app.globalData?.tmpData?.roomInfo && (delete app.globalData.tmpData.roomInfo);
    } else {
      // 是否群组
      _isGroup = this.isGroupCtrl();
      // 判断设备
      if (_isGroup) {
        this.curInfo = app.globalData.groupInfo;
        // 群组设备
        let _list = this.getGroupDevInfo(this.curInfo);
        this.setProperValue("devInfoList", _list);
      } else {
        this.curInfo = app.globalData.devInfo;
        // 初始化设备信息
        this.initDevInfo(this.curInfo);
      }
    }
    
    // 同步数据
    this.setData({
      isGroup: _isGroup,
      fromAddPage: from == "add",
      isRoom: this.data.isRoom,
      deviceImg: this.curInfo?.tStr
    });
  },
  // 取得新加入的房间默认群组的数据
  getDefaultGroupInfoByType (type) {
    if (!type) {
      return
    }
    let _roomId = app.globalData.roomInfo?.id || 0;
    let _roomDefaultGroupInfo = (app.globalData.devs[_roomId])?.groups;
    if (!_roomDefaultGroupInfo) {
      return
    }
    let _filterGroups = _roomDefaultGroupInfo.filter(item => (item.gid == _roomId && item.t == type));
    if (_filterGroups.length != 1) {
      return;
    }
    return _filterGroups[0];
  },

  getAllItems () {
    return [
      {
        title: '设备名称',
        key: 'name',
        bindFunc: 'editDevName',
        value: ''
      }, {
        title: '所在房间',
        key: 'room',
        bindFunc: 'belongRoom',
        value: ''
      }, 
      // {
      //   title: '清除遥控器数据',
      //   key: 'clear',
      //   bindFunc: 'unbindRemoteCtrl',
      //   value: ''
      // }, 
      {
        title: '设备信息',
        key: 'detail',
        bindFunc: 'detailInfo',
        value: ''
      }
    ];
  },

  // 取得温控器的数据
  getStatus () {
    // 保存的设备状态
    let _allDevStatus = app.globalData.allStatus || {};
    let {d, a} = this.curInfo || {};
    // 设备状态
    return _allDevStatus[d + "_" + a] || {};
  },
  saveTemphumidityStatus (str) {
    // 保存的设备状态
    let {d, a, t} = app.globalData.devInfo || {};
    let _devTypeStr = bizUtil.getDevTypeStr(t);
    console.log("saveTemphumidityStatus _devTypeStr, str = ", _devTypeStr, str);
    if (_devTypeStr != "temphumidity") {
      return;
    }
    let _keyStr = d + "_" + a;
    // 秒秒测单位
    app.globalData.allStatus[_keyStr] = app.globalData.allStatus[_keyStr] || {};
    
    let {ht, lt, unit} = app.globalData.allStatus[_keyStr];
    let _unitStr = bizUtil.getUnitByValue(unit);
    if (_unitStr != str) {
      // 单位的值
      if (ht >= 0) {
        let {temp} = historyCommon.getTempByHistoryJson ({
          temperature: ht, 
          tempunit: unit
        }, str);
        app.globalData.allStatus[_keyStr].ht = temp;
      }
      if (lt >= 0) {
        let {temp} = historyCommon.getTempByHistoryJson ({
          temperature: lt, 
          tempunit: unit
        }, str);
        app.globalData.allStatus[_keyStr].lt = temp;
      }
    }
    // 现在的单位
    app.globalData.allStatus[_keyStr].unit = str || "";
    // 保存到缓存中
    app.setBizStorage("devStatus", app.globalData.allStatus);
  },
  
  onShow () {
    console.log("onShow");

    // 补丁 用于设备替换之后返回设备详情页面所在房间没变的情况
    if (!this.data.isRoom && !this.data.isGroup && this.curInfo?.a == app.globalData.devInfo?.a) {
      !!app.globalData.devInfo && (this.curInfo = app.globalData.devInfo);
    }

    // 设备类型
    let _devTypeStr = this.data.devTypeStr;

    console.log('进入 onShow app.globalData.roleNum = ', app.globalData.roleNum)
    // 是否支持解绑遥控器
    let _supportBind = this.supportRemote;
    let _roleNum = app.globalData.roleNum;

    let _items = this.getAllItems();
    // let _array = ;
    // 如果是房间属性，则不能修改房间
    if (this.data.isRoom) {
      // _items = _array; // _array.slice(0, 2);
      (_items.length > 0) && (_items[0].title = _items[0].title.replace("设备", "群组")); // 不能修改房间
      (_items.length > 1) && (_items[1].bindFunc = ""); // 不能修改房间
      (_items.length > 2) && (_items[2].title = "房间ID", _items[2].bindFunc = "", _items[2].value = this.curInfo?.gid); // 只显示群组id
      console.log('进入 onShow _items = ', _items);
    } else {
      // 如果是群组设备，则把设备名称改成群组名称
      if (this.data.isGroup) {

        // 群组中是否有设备支持主设备
        let _ability = this.getAbilityJsonInGroup(this.curInfo) || {};
        console.log("onLoad _ability = ", _ability);
        let {mainEnable} = _ability || {};

        _items = _items.slice(0, 2);
        (_items.length > 0) && (_items[0].title = _items[0].title.replace("设备", "群组")); // 不能修改房间
        // (_items.length > 2) && (_items[2].title = "群组ID", _items[2].bindFunc = "", _items[2].value = this.curInfo?.gid); // 只显示群组id
      
        // 群组设备管理
        _items.push({
          title: '群组设备管理',
          key: 'manage',
          bindFunc: 'jumpManage',
          value: _devTypeStr
        });
        // 是否支持主设备
        if (mainEnable) {
          // 群组主设备
          _items.push({
            title: '群组主设备',
            key: 'main',
            bindFunc: 'jumpMain',
            value: _devTypeStr
          });
        }
        // 群组详情
        _items.push({
          title: '群组ID',
          key: 'detail',
          bindFunc: '',
          value: this.curInfo?.gid
        });
      }

      // // 如果是分享权限，则没有清除遥控器数据
      // if (_roleNum == 2) {
      //   _array = _array.slice(0, 2);
      // }
      // // 如果不支持解绑遥控器且是分享者权限，则没有items
      // _items = (_supportBind) ? (_array.concat([])) : [_array[0], _array[1]];
    }

    // 判断是否网关
    if (_devTypeStr == "gateway") {
      // _items = [_array[0]];
      _items = _items.filter(item => item.key == "name" || item.key == "detail");
      // 增加连接第三方
      if (app.globalData.roleNum != 2) {
        _items.push({
          title: '连接第三方',
          key: 'third',
          bindFunc: 'jumpThird',
          value: ""
        })
      }
    } else if (["uart", "panel"].indexOf(_devTypeStr) >= 0 || _devTypeStr.indexOf("sensor") >= 0) {
      // 没有解除遥控器功能 超级面板、空调、面板、传感器
      // _items = _array.slice(0, 2);
      _items = _items.filter(item => item.key != "clear");
    } else if ("aircondition" == _devTypeStr) {
      // 没有解除遥控器功能 超级面板、空调、面板、传感器
      if (!this.data.isAirconditionSub) {
        // 网关不能修改房间
        _items = _items.filter(item => item.key == "name" || item.key == "detail");
      } else {
        _items = _items.filter(item => item.key != "clear");
      }
    }

    // 选中的房间
    let _roomId = 0;
    // 判断是否房间控制
    if (this.curInfo && this.curInfo?.gid >= 0) {
      _roomId = Number(this.curInfo?.gid) || 0;
      if (_roomId >= 193) {
        _roomId = this.findBelongRoom();
      }
    } else {

      _roomId = this.findBelongRoom();
    }
    (_items.length > 0) && (_items[0].value = this.curInfo?.n || '');
    console.log("onShow _roomId, curInfo = ", _roomId, this.curInfo, app.globalData.devInfo);
    // 房间名称
    let _roomItems = (_items || []).filter(item => item.key == "room");
    if (_roomItems.length > 0) {
      _roomItems[0].value = app.globalData.devs[_roomId]?.n || ""
    }
    // (_items.length > 1) && (_items[1].key == "room") && (_items[1].value = app.globalData.devs[_roomId]?.n || "");

    // 其他数据
    this.data.roleNum = _roleNum;
    this.data.items = _items;
    this.setData({
      items: this.data.items,
      roleNum: this.data.roleNum
    });
  },
  // 取得温控器通风和制热设备的名称显示
  // getTipByValue (valueStr) {
  //   let _tip = {};
  //   if (!valueStr) {
  //     return _tip;
  //   }
  //   let _vals = valueStr.split(",");
  //   let _configs = {
  //     air: "空调",
  //     wind: "新风",
  //     hot: "地暖"
  //   };
  //   let _tipArray = _vals.map(item => _configs[item]);
  //   let _tipLength = _tipArray.length;
  //   if (_tipLength == 1) {
  //     return _tipArray[0]
  //   } else if (_tipLength == 0) {
  //     return "";
  //   }
  //   return _tipArray.join(",")
  //   // return {
  //   //   valArray: _vals,
  //   //   tipStr: _tipArray.join(",")
  //   // }
  // },

  // 取得群组中的所有设备能力
  getAbilityJsonInGroup () {
    let _abilityJson = {};
    let {t} = this.curInfo || {};
    console.log("getAbilityJsonInGroup = ", this.curInfo);
    if (t == "light") {
      // 群组中的设备列表
      let _groupDevArray = this.getAllDevsInGroup(this.curInfo);
      console.log("getAbilityJsonInGroup _groupDevArray = ", _groupDevArray);
      // 取得设备中的所有ability
      let {versions} = this.getAbilityByDevArray(_groupDevArray);
      console.log("getAbilityJsonInGroup versions = ", versions);
      // 取得所有能力
      _abilityJson = bizUtil.getMaxAbilityByVs(versions);
      console.log("getAbilityJsonInGroup _abilityJson = ", _abilityJson);
    }
    return _abilityJson;
  },
  // 取得群组中的设备列表
  getAllDevsInGroup (groupInfo) {
    // 群组设备列表
    let _groupDevs = groupInfo?.dids || [];
    if (_groupDevs.length == 0) {
      return [];
    }
    // 取得房间下所有的d对应的详细信息
    let _didMaps = bizUtil.getDidMapInJson(app.globalData.devs);
    // 群组设备列表详细
    return _groupDevs.map(did => _didMaps[did]);
  },
  // 根据设备列表取得能力集合
  getAbilityByDevArray (devs) {
    // 被控设备集合
    let _devs = devs || [];
    // 最终集合
    let versions = [];
    // 遍历数据取得集合
    for (let index in _devs) {
      let {v} = _devs[index] || {};
      // 如果版本号v不存在，则continue
      if (v == undefined) {
        continue;
      }

      // 如果版本号一致，则continue
      if (versions.indexOf(v) >= 0) {
        continue;
      }
      // 添加版本分支集合
      versions.push(v);
    }
    return {
      versions: versions, // 版本能力集合
    };
  },

  onUnload () {
    this.destoryTimer(this.data.timer);
    // 删除保存的设备替换缓存信息
    !!app.globalData.tmpData.devInfo && (delete app.globalData.tmpData.devInfo);
    // 是否需要删除临时
    if (!app.globalData.tmpData.tmpCustomScenes) {
      return;
    }
    delete app.globalData.tmpData.tmpCustomScenes;
  },
  destoryTimer (timer) {
    bizUtil.clearTimer(timer, "interval");
  },
  setProperValue (key, val) {
    if (this.data == undefined) {
      return;
    }
    this.data[key] = val;
    this.setData({
      [key]: val
    })
  },
  // 初始化群组显示的信息
  getGroupDevInfo (groupInfo) {
    let {t, gid} = groupInfo || {};
    return [{
      title: '品类',
      value: t
    }, {
      title: '固定群组',
      value: gid
    }];
  },
  // 初始化单个显示的信息
  initDevInfo (devInfo, isRoom) {
    let _devInfo = devInfo;
    if (!_devInfo) {
      console.log("_devInfo is not exist");
      return;
    }
    // 设置设备类型
    let _devTypeStr = bizUtil.getDevTypeStr(_devInfo.t);
    this.data.devTypeStr = _devTypeStr;
    // 是否ihg设备信息
    this.isIhg = bizUtil.isIhg(_devInfo.t);
    // 是否空调内机
    let _airconditionSub = false;
    // 是否空调网关
    let _isGateway = _devTypeStr == "gateway";
    // 是否网关设备
    if (_isGateway) {
      // this.getDevVersion(_devInfo, (result) => {
      //   console.log("initDevInfo getDevVersion result = ", result);
      //   // 版本号
      //   if (!result) {
      //     // 如果原先有版本号，则显示之前的版本
      //     if (app.globalData.devInfo?.v) {
      //       return;
      //     }
      //     this.data.devInfoList[3].value = "获取失败";
      //   } else {
      //     let _version = result.v;
      //     this.data.devInfoList[3].value = _version;
      //     // 保存版本到设备信息中
      //     !!app.globalData.devInfo && (app.globalData.devInfo.v = _version);
      //     // 比较版本号
      //     this.checkVersion(result);
      //   }
      //   this.setData({
      //     devInfoList: this.data.devInfoList
      //   })
      // });
    } else if (_devTypeStr == "aircondition") {
      if (!(_devInfo?.sub)) {
        _airconditionSub = true;
      }
    }
    console.log("initDevInfo _airconditionSub = ", _airconditionSub);

    // 如果是ihg 显示
    if (this.isIhg) {
      // 显示WiFi的mac地址
      this.data.devInfoList.push({
        title: 'WiFi/mac',
        value: _devInfo?.wd || ''
      });
    }
    
    this.data.devInfoList[0].value = _devInfo.t;
    // 如果是房间
    if (isRoom) {
      this.data.devInfoList = this.data.devInfoList.slice(0, 1);
    } else {
      this.data.devInfoList[1].value = _devInfo.d;
      this.data.devInfoList[2].value = _devInfo.a;
      this.data.devInfoList[3].value = (_devInfo.v == undefined && _isGateway) ? '正在获取…' : (_devInfo.v || 0);
    }

    this.setData({
      devInfoList: this.data.devInfoList,
      devTypeStr: this.data.devTypeStr,
      isAirconditionSub: _airconditionSub
    })
  },
  // 如果是网关设备，取得网关的授权码
  getDevVersion (devInfo, callback) {
    if (!devInfo) {
      !!callback && (callback(false));
      return;
    }
    console.log("getDevVersion devInfo = ", devInfo);
    // 网关链接的集群
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    // 设备信息 ihg需要用wd去获取版本号
    let _devInfo = devInfo;
    if (this.isIhg && _devInfo?.wd) {
      _devInfo = Object.assign({}, devInfo, {d: _devInfo.wd});
    };
    // 取得网关的code
    let _result = app.globalData.blsdk.getDeviceVersion(_devInfo, _groupStr);
    if (!_result || !_result.then) {
      console.error("getDevVersion _result = ", _result);
      return;
    }
    _result.then((result) => {
      // 回调函数
      if (!callback) {
        return;
      }
      // 数据
      let _payload = result?.event?.payload;
      // 固件版本
      let _v = _payload?.version;

      // 如果没有版本号
      if (_v == undefined) {
        return callback(false);
      }

      // 服务器版本
      let _sv = _payload?.serverversion?.version;
      // 服务器升级路径
      let _url = _payload?.serverversion?.url;
      console.log("getDevVersion _result = ", _v);
      // 回调函数
      callback({
        v: _v,
        sv: _sv,
        url: _url
      });
      // console.log("getDevVersion result = ", result);
      // // let {event} = result || {};
      // let _version = result?.event?.payload?.version;
      // if (_version == undefined) {
      //   // 如果原先有版本号，则显示之前的版本
      //   if (app.globalData.devInfo?.v) {
      //     return;
      //   }
      //   this.data.devInfoList[3].value = "获取失败";
      // } else {
      //   this.data.devInfoList[3].value = _version;
      //   // 保存版本到设备信息中
      //   !!app.globalData.devInfo && (app.globalData.devInfo.v = _version);
      // }
      // this.setData({
      //   devInfoList: this.data.devInfoList
      // })
    }).catch((e) => {
      console.error("getDevVersion catch e = ", e);
      !!callback && (callback(false));
    });
  },
  upgradeGateway (devInfo, url, callback) {
    if (!devInfo) {
      !!callback && (callback(false));
      return;
    }
    console.log("upgradeGateway devInfo = ", devInfo);
    // 网关链接的集群
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    // 取得网关的code
    let _result = app.globalData.blsdk.upgradeGateway(devInfo, _groupStr, url);
    if (!_result || !_result.then) {
      console.error("getDevVersion _result = ", _result);
      return;
    }
    _result.then((result) => {
      console.log("upgradeGateway result = ", result);
      !!callback && (callback(result));
      // 初始化定时器
      // this.initTimer();
      // // let {event} = result || {};
      // let _version = result?.event?.payload?.version;
      // if (_version == undefined) {
      //   // 如果原先有版本号，则显示之前的版本
      //   if (app.globalData.devInfo?.v) {
      //     return;
      //   }
      //   this.data.devInfoList[3].value = "获取失败";
      // } else {
      //   this.data.devInfoList[3].value = _version;
      //   // 保存版本到设备信息中
      //   !!app.globalData.devInfo && (app.globalData.devInfo.v = _version);
       
      // }
      // this.setData({
      //   devInfoList: this.data.devInfoList
      // })
    }).catch((e) => {
      console.log("upgradeGateway e = ", e);
      !!callback && (callback(false));
      // // 如果原先有版本号，则显示之前的版本
      // if (app.globalData.devInfo?.v) {
      //   return;
      // }
      // this.data.devInfoList[3].value = "获取失败";
      // this.setData({
      //   devInfoList: this.data.devInfoList
      // })
    });
  },

  initTimer () {
    // 初始化次数
    this.data.count = 15;
    // 先销毁定时器
    this.destoryTimer(this.data.timer);
    // 显示定时器
    ability.showLoading({
      title: "升级中…",
      mask: true
    });
    // 初始化定时器
    this.data.timer = setInterval(() => {

      // 如果定时器被销毁
      if (!this.data.timer || this.data.count < 0) {
        return;
      }

      // 次数
      this.data.count--;
      // 获取版本号
      this.getDevVersion(app.globalData.devInfo, (result) => {
        // 版本号等
        let {v, sv} = result || {};
        if (v == undefined || v < sv) {
          // 判断次数
          if (this.data.count > 0) {
            return;
          }
          ability.hideLoading();
          // 销毁定时器
          this.destoryTimer(this.data.timer);
          // 提示信息
          setTimeout(() => {
            ability.showToast({
              title: "升级失败",
              icon: "error"
            })
          }, 0);
          return;
        }
        // 隐藏等待条
        ability.hideLoading();
        // 保存版本到设备信息中
        !!app.globalData.devInfo && (app.globalData.devInfo.v = v);
        // 赋值
        this.data.devInfoList[3].value = v;
        // 销毁定时器
        this.destoryTimer(this.data.timer);
        // 设置数据
        this.setData({
          devInfoList: this.data.devInfoList
        });
        // 提示信息
        setTimeout(() => {
          ability.showToast({
            title: "升级成功",
            icon: "success"
          })
        }, 0);
      });
    }, 5000);
  },

  checkVersion (params) {
    // 数据
    let {v, sv, url} = params || {};
    // 如果没有服务器版本号
    if (sv == undefined) {
      return;
    }
    // 如果版本号小于服务器版本号
    if (v < sv) {
      wx.showModal({
        title: "",
        content: "发现新版本，是否升级",
        showCancel: true,
        confirmColor: "#576B95",
        confirmText: "升级",
        cancelText: "取消",
        cancelColor: '#000000',
        success: (res) => {
          console.log("showModal res = ", res);
          if (res.confirm) {
            // 升级
            this.upgradeGateway(app.globalData.devInfo, url, (result) => {
              if (!result) {
                ability.showToast({
                  title: "升级失败",
                  icon: "error"
                })
                return;
              }
              // 初始化定时器
              this.initTimer();
            });
          } else if (res.cancel) {}
        },
        fail: (e) => {
          console.log("showModal fail e = ", e);
        }
      });
    }
  },

  onReady: function () {
    
  },
  // 是否群组控制
  isGroupCtrl () {
    return !!app.globalData.groupInfo && !!app.globalData.tgroupId;
  },

  findBelongRoom () {

    let _did = "";
    // 如果是固定群组，则取得固定群组的信息
    if (this.isGroupCtrl()) {
      return this.curInfo?.rid || 0;
    } else {
      _did = this.curInfo?.d;
    }

    let _rooms = app.globalData.devs;
    let selected = 0;
    for (let item in _rooms) {
      let _devs = _rooms[item].devs || [];
      for (let _dev in _devs) {
        if (_did === _devs[_dev].d) {
          selected = item;
        }
      }
    }
    return selected;
  },
  editDevName (e) {
    // if (app.globalData.roleNum == 2) {
    //   return;
    // }
    console.log('editDevName');
    let {index} = e.currentTarget.dataset;
    let _item = this.data.items[index] || {};
    let _name = _item.value || '';
    let _title = _item.title || "";
    let _pathStr = "/device/light/deviceName/index?name=" + decodeURIComponent(_name) + "&title=" + encodeURIComponent(_title);
    // // 判断是否全屋设备
    // if (this.data.isRoom) {
    //   app.globalData.tmpData = app.globalData?.tmpData || {};
    //   app.globalData.tmpData.roomInfo = this.curInfo;
    // }
    // 页面来源
    if (this.data.fromAddPage) {
      _pathStr += "&from=add";
    }
    ability.navigateTo(_pathStr)
  },
  belongRoom () {
    
    if (app.globalData.roleNum == 2) {
      return;
    }

    console.log('belongRoom');
    ability.navigateTo("/device/light/belongRoom/index?lowPower=" + (this.lowPower || 0))
  },
  delDev () {
    // 是否群组
    let _isGroup = this.isGroupCtrl();
    // 提示
    ability.showModal({
      title: "",
      content: "是否确认删除该" + (_isGroup ? "群组" : "设备") + "？",
      showCancel: true,
      confirmText: "是",
      cancelText: "否",
      cancelColor: '#000000'
    }).then(result => {
      if (!result) {
        return;
      }
      // 删除方法
      if (_isGroup) {
        this.delGroupDetail();
      } else {
        this.delDeviceDetail();
      }
    })
  },
  // 设备替换
  replaceDev () {
    console.log("replaceDev");
    // 当前设备信息存在app.globalData.devInfo
    ability.navigateTo("./replace/list/index");
  },
  // 删除群组
  delGroupDetail () {
    // 当前群组信息
    let _groupInfo = this.curInfo || {};
    let {gid, rid, dids} = _groupInfo;
    console.log("delGroupDetail dids = ", dids);
    // 如果没有数据则直接删除
    if (!dids || dids?.length == 0) {
      return this.delGroupSuccess(_groupInfo);
    }
    // 删除群组下发数据
    this.delGroupDevs(_groupInfo, dids || [], (res) => {
      console.log("delGroupDetail res = ", res);
      this.delGroupSuccess(_groupInfo);
    });
  },
  delGroupSuccess ({gid, id}) {
    let _id = id || 0;
    // 删除gid列表
    bizUtil.delGroupByGidInJson(app.globalData.devs, [gid]);
    // 清除数据
    app.globalData.groupInfo = {};
    // 保存数据
    app.saveWhenHide();
    // 提示删除成功
    this.delSuccessToast();
  },
  // 删除设备
  delDeviceDetail () {
    // 通用behaviors
    this.delDeviceByInfo(app.globalData.devInfo, () => {
      // 返回首页，重新加载
      setTimeout(() => {
        // 保存设备
        app.globalData.devInfo = {};
        app.globalData.devStatus = {};
        // 返回首页  部分手机relaunch会导致闪退
        ability.navigateBack(3);
      }, 1200);
    });
    return;

    /* let _devInfo = app.globalData.devInfo;
    if (!_devInfo) {
      return;
    }
    let {id: _id, d: _d, t: _t, a: _a} = _devInfo;
    let _devs = (app.globalData.devs[_id] || {}).devs || [];
    // 删除设备信息
    let _filter = _devs.filter(item => item.d != _d);
    console.log("delDev _devs, _id = ", _devs, _id, _filter);
    (app.globalData.devs[_id] || {}).devs = _filter;
    // 删除设备对应的群组
    console.log("delDev _devInfo = ", app.globalData.devs, _devInfo);
    bizUtil.delGroupDByDev(app.globalData.devs, _devInfo);

    // 删除设备时需要把设备情景数据也删除
    this.delSceneByDev(_devInfo);
    // 保存设备信息
    app.saveAllDevsMap();

    // 判断是否有设备状态
    let _allStatus = app.globalData.allStatus || {};
    if (_allStatus[_d + "_" + _a]) {
      delete _allStatus[_d + "_" + _a];
      // 保存数据
      app.setBizStorage("devStatus", _allStatus);
    }
    
    // 判断删除的是否网关，如果不是，则忽略
    let _devTypeStr = bizUtil.getDevTypeStr(_t);
    if (_devTypeStr == "gateway") {
      // 先判断删除的是否当前的网关，如果是，则清除
      // 取得当前的网关
      let _gatewayInfo = app.globalData.blsdk.getCurrentGateway() || {};
      console.log("delDev _gatewayInfo, _d = ", _gatewayInfo, _d);
      if (_gatewayInfo.d == _d) {
        // 如果原先的家庭只有只读权限
        if (app.globalData.roleNum != 2) {
          // 删除原先的网关数据
          app.deletePrivateData();
        }
      }

      // 找是否有下一个网关
      let _newGateway = bizUtil.getGatewayInfo(app.globalData.devs);
      console.log("_newGateway = ", _newGateway);
      app.globalData.blsdk.updateGatewayInfo(_newGateway);
    }

    // 上报数据
    app.uploadPrivateData();
    
    // 删除成功的提示
    this.delSuccessToast(); */
  },
  // 删除成功的提示
  delSuccessToast () {
    // 提示删除结果
    ability.showToast({
      title: "删除成功",
      icon: "success",
      mask: true,
      complete: () => {
        // 返回首页，重新加载
        setTimeout(() => {
          // 保存设备
          app.globalData.devInfo = {};
          app.globalData.devStatus = {};
          // 返回首页  部分手机relaunch会导致闪退
          ability.navigateBack(3);
        }, 1200);
      }
    });
  },
  // // 删除设备关联的情景信息
  // delSceneByDev (devInfo) {
  //   if (!devInfo) {
  //     return;
  //   }
  //   // 删除设备对应的场景信息
  //   bizUtil.moveDev(app.globalData.devs, devInfo, []);
  // },
  // 清除遥控器数据
  unbindRemoteCtrl () {
    
    if (app.globalData.roleNum == 2) {
      return;
    }
    // 提示是否需要清除
    wx.showModal({
      content: "你是否要清除这个设备的遥控器数据？"
    }).then((result) => {
      if (!result?.confirm) {
        return;
      }
      // 解绑
      this.unbindDetail();
    }).catch(e => {
      console.log("unbindRemoteCtrl error");
    });
  },
  unbindDetail () {
    let _addr = this.curInfo?.a;
    if (!_addr) {
      console.log("unbindRemoteCtrl _addr = ", _addr);
      return;
    }
    app.globalData.blsdk.unbindRemoteCtrl(_addr);
  },
  jumpBackSet () {
    ability.navigateTo("/device/panel/backlight/index")
  },
  jumpIhgConfig () {
    ability.showModal({
      title: "",
      content: "设备已配对，是否重新配对？",
      showCancel: true,
      confirmColor: "#576B95",
      confirmText: "确定",
      cancelText: "取消",
      cancelColor: '#000000',
    }).then(res => {
      if (!res) {
        return;
      }
      ability.navigateTo("/addPages/ihg/config/index?from=property")
    })
  },

  // setHot (e) {
  //   console.log("setHot e = ", e);
  //   ability.navigateTo("../../thermostat/setConfig/index?title=" + encodeURIComponent());
  // },
  // setWind (e) {
  //   console.log("setWind e = ", e);
  //   ability.navigateTo("../../thermostat/setConfig/index?title=" + encodeURIComponent());
  // },
  jumpThermostat (e) {
    let {index} = e.currentTarget.dataset || {};
    let {title, key, realValueStr} = this.data.items[index] || {};

    ability.navigateTo("../../thermostat/setConfig/index?title=" + encodeURIComponent(title) + "&key=" + key + "&valueStr=" + encodeURIComponent(realValueStr));
  },

  // 开关按钮点击
  switchBtnClick (e) {
    let {index, idx} = e.currentTarget.dataset;
    let _item = this.data.items[index];
    let _child = (_item?.list || {})[idx];
    if (!_child) {
      return;
    }
    let _cmd = {
      [_item.key]: _child.value
    };
    console.log("switchBtnClick _cmd = ", _cmd);
    app.globalData.blsdk.controlWithDevice(this.curInfo, _cmd);
  },
  // 插卡取电参数设置
  setParams (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.items[index];
    console.log("setParams _item = ", _item);
    ability.navigateTo("../../panel/backlight/index?delayOff=" + (_item?.valInt || 0));
  },

  // 秒秒测
  setUnit () {
    this.setActionSheetShow(true);
  },
  actionBtnClick (e) {
    let {index} = e.detail || {};
    let {value, text} = this.data.unitArray[index];
    // 保存信息
    this.saveTemphumidityStatus(text);
    // 刷新数据
    this.updateTopItemsByKey("unit", text);
    // 关闭actionsheet
    this.setActionSheetShow(false);
  },
  updateTopItemsByKey (key, value) {
    if (!key) {
      return;
    }
    let _index = this.data.items.findIndex(item => item.key == key);
    if (_index < 0) {
      return;
    }
    let _item = this.data.items[_index];
    _item.value = value;
    this.setData({
      [`items[${_index}]`]: _item
    })
  },
  setActionSheetShow (value) {
    this.setData({
      showActionsheet: value || false
    });
  },
  detailInfo () {
    // 设备详细信息
    ability.navigateTo("./detail/index?type=" + this.type);
  },
  jumpThird () {
    // 连接第三方
    ability.navigateTo("./third/index?type=" + this.type);
  },
  // 群组设备管理
  jumpManage () {
    ability.navigateTo("/groups/manage/index");
  },
  // 主设备管理
  jumpMain () {
    let _itemArray = this.data.items.filter(item => item.key == 'main');
    if (_itemArray.length == 0) {
      return;
    }
    ability.navigateTo("./main/index?title=" + encodeURIComponent(_itemArray[0]?.title || ""));
  }
})