import GROUPS from "../../../../static/js/jsConfig/groups"
const ability = require("../../../../utils/classDef/ability");
const app = getApp();
// device/light/devProperty/third/detail.js
Page({

  /**
   * 页面的初始数据
   */
  data: {

  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    let {type, title, port, address} = options;
    this.setTitle(decodeURIComponent(title || ""));
    let _list = this.getListByType(type, port || 8080, address);

    // 保存类型
    this.type = type;

    this.setData({
      list: _list
    })
  },
  setTitle (title) {
    ability.setNavigationBarTitle(title || "");
  },
  getListByType (type, port, address) {
    let _result = [];
    let _portTitle = "端口号";
    if (type == "server") {
      _result = [{
        title: _portTitle,
        placeHolder: _portTitle + "（8000-65535）",
        value: port,
        key: "port",
        type: "number"
      }];
    } else if (type == "client") {
      _result = [{
        title: _portTitle,
        placeHolder: _portTitle + "（8000-65535）",
        value: port,
        key: "port",
        type: "number"
      }, {
        title: "ip地址",
        value: address,
        key: "ip",
        type: "text"
      }]
    }
    return _result;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },

  bindReplaceInput (e) {
    let {index} = e.currentTarget.dataset;
    let {value} = e.detail;
    console.log("bindReplaceInput e = ", e);
    this.data.list[index].value = value;
  },
  getValueByType (type) {
    return type == "client" ? 2 : (type == "server" ? 1 : 0);
  },
  getDataFromList (list) {
    if (!list || list.length == 0) {
      return {};
    }
    console.log("getDataFromList list = ", list);
    let _json = {};
    for (let item of list) {
      _json[item.key] = item.value
    }
    console.log("getDataFromList _json = ", _json);
    let _obj = {
      mode: this.getValueByType(this.type),
      port: Number(_json.port) || 0,
      address: _json.ip
    }
    return _obj
  },
  isValidIP (ip) {
    var reg = /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$/
    return reg.test(ip);
  },
  saveInfo () {
    let _json = this.getDataFromList(this.data.list);
    console.log("saveInfo _json = ", _json);

    // 端口号和ip地址
    if (!_json.port) {
      return ability.showToast({
        title: "请输入端口号"
      })
    } else if (_json.port > 65535 || _json.port < 8000) {
      return ability.showToast({
        title: "端口号为8000-65535之间"
      })
    }

    if (this.type == "client") {
      if (!_json.address) {
        return ability.showToast({
          title: "请输入ip地址"
        })
      } /* else if (!this.isValidIP(_json.address)) {
        return ability.showToast({
          title: "请输入正确的ip地址"
        })
      } */
    }
    // 设备信息
    let _devInfo = app.globalData.devInfo;
    // 上报的集群域名
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    
    app.globalData.blsdk.manageUdpPrivateData({
      type: "add",
      d: _devInfo?.wd || _devInfo?.d,
      t: _devInfo?.t,
      k: _devInfo?.k,
      data: app.globalData.blsdk.base64Encode(JSON.stringify(_json))
    }, {
      host: _groupStr
    }).then(res => {
      console.log("saveInfo res = ", res);
      let _isSuccess = res?.status == 0;
      ability.showToast({
        title: _isSuccess ? "保存成功" : "保存失败"
      });
      if (!_isSuccess) {
        return;
      }
      setTimeout(() => {
        ability.navigateBack();
      }, 1000);
    }).catch(e => {
      console.log("saveInfo e = ", e);
      ability.showToast({
        title: e?.data?.msg || ("设置失败" + e?.data?.status)
      })
    });;
  }
})