// device/light/devProperty/third/index.js
/*
 * @Author: your name
 * @Date: 2021-05-24 15:59:52
 * @LastEditTime: 2021-05-28 10:13:44
 * @LastEditors: your name
 * @Description: In User Settings Edit
 * @FilePath: \blewxwebui\miniwechat\miniprogram\device\light\devProperty\index.js
 */
import ability from '../../../../utils/classDef/ability'
import bizUtil from '../../../../utils/bizUtil'
import GROUPS from "../../../../static/js/jsConfig/groups"
const devBehavior = require("../../../../static/js/behavior/device")
const groupBehavior = require("../../../../static/js/behavior/group")
// const historyCommon = require("../../../jsConfig/history")
var app = getApp()
Page({
  behaviors: [devBehavior, groupBehavior],
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备详情"
      }
    },
    list: [],
    roleNum: 0,
    bleUnavailable: false,
    showActionsheet: false, // 是否显示actionsheet
    deviceImg: "", // 设备图标
  },
  onLoad: function (options) {
    this.data.list = this.getAllItems();
  },

  getAllItems () {
    return [
      {
        title: '作为server',
        key: 'server',
        keyInt: 1,
        value: ''
      }, {
        title: '作为client',
        key: 'client',
        keyInt: 2,
        value: ''
      }
    ];
  },
  onShow () {
    console.log("onShow");
    // 取得私有数据
    this.getGatewayPrivate();

    this.setData({
      list: this.data.list
    })
  },
  onUnload () {
  },
  onReady: function () {
  },
  getGatewayPrivate () {
    // 取得网关设备私有数据
    let _devInfo = app.globalData.devInfo;
    // 上报的集群域名
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    
    app.globalData.blsdk.manageUdpPrivateData({
      type: "query",
      d: _devInfo?.wd || _devInfo?.d,
      t: _devInfo?.t,
      k: _devInfo?.k,
      // mtagList: ["*"]
    }, {
      host: _groupStr
    }).then(res => {
      console.log("getGatewayPrivate res = ", res);
      let _dataJson = ((res?.data || [])[0]?.dataList || [])[0] || {};
      this.updateDataByJson(_dataJson);
    }).catch(e => {
      console.log("getGatewayPrivate e = ", e);
      ability.showToast({
        title: e?.data?.msg || ("获取数据失败" + e?.data?.status)
      })
    });;
  },
  updateDataByJson ({data, mtag, updateTime, devqueryTime, validTime}) {
    if (mtag != "udp_service") {
      return;
    }
    // 解析base64
    let _str = app.globalData.blsdk.base64Decode(data);
    console.log("getGatewayPrivate _str = ", _str, typeof _str);
    let {mode, port, address} = !_str ? {} : JSON.parse(_str);
    console.log("getGatewayPrivate mode, port, address = ", mode, port, address);

    // 清空数据
    let _list = this.data.list.map(item => {
      item.value = "";
      delete item.port;
      delete item.address;
      return item;
    });

    let _index = _list.findIndex(item => item.keyInt == mode);
    console.log("getGatewayPrivate _index = ", _index);
    if (_index >= 0) {
      let _item = _list[_index];
      _item.port = port;
      _item.address = address;
      _item.value = (mode == _list[0]?.keyInt) ? (port || "") : ((address || "") + ":" + (port || ""));
    }
    this.setData({
      list: _list
    })
  },
  itemClick (e) {
    if (app.globalData.roleNum == 2) {
      return;
    }
    let {index} = e.currentTarget.dataset;
    let _item = this.data.list[index] || {};
    console.log("itemClick _item = ", _item);
    this.jumpThird(_item, );
  },
  jumpThird ({title, key, port, address}) {
    let _extendStr = "";
    if (key == "client") {
      _extendStr += "&port=" + (port || "");
      _extendStr += "&address=" + (address || "");
    } else {
      _extendStr += "&port=" + (port || "");
    }
    // 连接第三方
    ability.navigateTo("./detail?type=" + key + "&title=" + encodeURIComponent(title) + _extendStr);
  },
  cleanAll () {
    ability.showModal({
      title: "",
      content: "是否清空当前配置？",
      showCancel: true,
      confirmColor: "#576B95",
      confirmText: "是",
      cancelText: "否",
      cancelColor: '#000000',
    }).then(res => {
      if (!res) {
        return;
      }
      this.clearDetail();
    })
  },
  clearDetail () {
    let _devInfo = app.globalData.devInfo;
    // 上报的集群域名
    let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
    
    app.globalData.blsdk.manageUdpPrivateData({
      type: "add",
      d: _devInfo?.wd || _devInfo?.d,
      t: _devInfo?.t,
      k: _devInfo?.k,
      data: ""
    }, {
      host: _groupStr
    }).then(res => {
      console.log("cleanAll res = ", res);
      let _isSuccess = res?.status == 0;
      ability.showToast({
        title: _isSuccess ? "清除成功" : "清除失败"
      });
      if (!_isSuccess) {
        return;
      }
      // 重新获取信息
      this.getGatewayPrivate();
    }).catch(e => {
      console.log("clearDetail e = ", e);
      ability.showToast({
        title: e?.data?.msg || ("清除数据失败" + e?.data?.status)
      })
    });
  }
})