import ability from '../../../utils/classDef/ability'
import bizUtil from "../../../utils/bizUtil"
const app = getApp();
Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备名称"
      }
    },
    index: 0,
    devName: '',
    fromPage: "",
    bleUnavailable: false,

    maxLength: 16, // 最大长度
  },
  onLoad (options) {
    // 接收参数
    this.getNameByOption(options);
  },
  onUnload () {
    console.log("onUnload");
  },
  // 优先从option中获取参数
  getNameByOption (options) {
    console.log("getParamByOption options = ", options);
    let {name, from, index, title, idx} = options;
    this.data.fromPage = from || "";
    this.data.index = index;
    this.idx = idx;
    // 初始化标题
    this.initTitle(decodeURIComponent(title || ""));
    // 如果没有默认名称
    let _name = "";
    if (!!name) {
      // 初始化设备名称
      _name = this.dealDevName(decodeURIComponent(name));
    }
    this.setData({
      devName: _name,
      fromPage: this.data.fromPage,
      maxLength: (from == "gatewaytime" || from == "gatewaycycle") ? 32 : 16
    });
  },
  initTitle (title) {
    let _title = title || "设备名称";
    ability.setNavigationBarTitle(_title);
  },
  dealDevName (name) {
    let _name = name || app.globalData.devInfo.n || "";
    if (_name.length > 16) {
      _name = _name.substr(0, 16);
    }
    return _name;
  },

  clearName () {
    this.data.devName = "";
    this.setData({
      devName: ''
    })
  },

  // nameBlur () {
  // },
  nameInput (e) {
    let _name = e.detail.value;

    // 只能输入汉字 字母和数字
    _name = this.getFormatName(_name); // _name.replace(/[^\w\u4E00-\u9FA5]/g, '');
    
    // 判断是否从房间详细进入的页面
    let _fromPage = this.data.fromPage;
    // 判断长度
    if ((_fromPage == "gatewaytime" || "gatewaycycle" == _fromPage)) {
      let _result = this.getUtf8Length(_name);
      if (!_result) {
        this.setData({
          devName: _name.substr(0, 10)
        })
        return;
      }
    } else 
    if (_name.length > 16) {
      this.showToast("设备名称长度不能大于16").then((isConfirm) => {
        this.setData({
          devName: _name.substr(0, 16)
        })
      });
      return;
    }
    this.setData({
      devName: _name
    })
    console.log("nameInput _name = ", _name);
  },
  showToast (str) {
    return wx.showModal({
      showCancel: false,
      content: str || "设备名称长度不能大于16"
    });
  },
  // 计算长度
  getUtf8Length (str, showToast) {
    let _result = app.globalData.blsdk.toUTF8(str || "");
    if (_result.length == 0) {
      return false;
    } else if (_result.length > 32) { // 32
      !!showToast && (ability.showToast({
        title: "名称超长"
      }));
      return false;
    }
    return true;
  },
  getFormatName (name) {
    if (!name) {
      return "";
    }
    // 只能输入汉字 字母和数字
    return name.replace(/[^\w\u4E00-\u9FA5]/g, '');
  },
  saveName () {
    let _name = (this.data.devName || '').trim();
    _name = this.getFormatName(_name);
    // 判断是否从房间详细进入的页面
    let _fromPage = this.data.fromPage;
    if (_name.length == 0) {
      this.showToast("名称不能为空");
      return;
    } else if (_name.length > 16 && (_fromPage != "gatewaytime" && "gatewaycycle" != _fromPage)) {
      this.showToast("名称长度不能大于16");
      return;
    }
    console.log("saveName _name, _fromPage = ", _name, _fromPage);
    if (_fromPage == "gatewaytime") {
      // 校验32个长度
      if (!this.getUtf8Length(_name, true)) {
        return;
      }
      app.globalData.timerInfo.name = _name;
      return this.back();
    } else if ("gatewaycycle" == _fromPage) {
      // 校验32个长度
      if (!this.getUtf8Length(_name, true)) {
        return;
      }
      app.globalData.timerInfo.headObj.name = _name;
      return this.back();
    } else if (_fromPage == "roomDetail") {
      // 房间名称
      app.globalData.roomInfo.n = _name;
    } else {

      let _isGroup = this.isGroupCtrl();
      // 如果群组修改名称
      // if (!_isGroup) {
        // 增加判断名称是否重复 改为判断同一个房间下的设备和群组和双控名称不能重复
        let _sameArray = bizUtil.getExistNameCountByDevInJson(app.globalData.devs, _isGroup ? app.globalData.groupInfo : app.globalData.devInfo, _name);
        if (_sameArray.length > 0) {
          return ability.showToast({
            title: "名称不能重复"
          })
        }
      // } 
      // else {
      //   // 群组中是否有相同数据
      //   let _sameArray = bizUtil.getExistNameCountByDevInJson(app.globalData.devs, app.globalData.groupInfo, _name);
      //   if (_sameArray.length > 0) {
      //     return ability.showToast({
      //       title: "名称不能重复"
      //     });
      //   }
      // }

      // 判断来源页面
      if (_fromPage == "panel" || _fromPage == "powerstrip") {
        let _vGroupArray = app.globalData.devInfo?.e?.vGroups;
        if (!!_vGroupArray) {
          // 获取是否有重复的名称
          let _filterArray = _vGroupArray.filter((item, index) => (item.name == _name) && (index != this.data.index));
          if (_filterArray.length > 0) {
            return ability.showToast({
              title: "开关面板按键名称不能重复"
            })
          }
          app.globalData.devInfo.e.vGroups[this.data.index].name = _name;
        }
      } else if (_fromPage == "panelsensor") {
        console.log("saveName this.idx, this.data.index = ", this.idx, this.data.index);
        if (this.idx >= 0) {
          // 编辑vGroups
          let _vGroupArray = app.globalData.devInfo?.e?.vGroups;
          if (!_vGroupArray?.length) {
            return;
          }
          _vGroupArray[this.idx].name = _name;
        } else if (this.data.index >= 0) {
          // 修改subs
          let _subsArray = app.globalData.devInfo?.e?.subs;
          if (!_subsArray?.length) {
            return;
          }
          _subsArray[this.data.index].name = _name;
        }
      } else if (_fromPage == 'add') {
        app.globalData.devInfo.n = _name;
      } else {
        // 是否房间改名
        if (app.globalData?.tmpData?.roomInfo) {
          app.globalData.tmpData.roomInfo.n = _name;
        } 
        // 是群组改名
        else if (_isGroup) {
          app.globalData.groupInfo.n = _name;
        } else {
          app.globalData.devInfo.n = _name;
        }
        
        // 保存设备信息
        app.saveAllDevsMap();
      }
    }
    
    // 上报数据
    app.uploadPrivateData();

    this.back();
  },
  back () {
    // 返回
    ability.navigateBack();
  },
  // 是否群组控制 固定群组
  isGroupCtrl () {
    return !!app.globalData.groupInfo && !!app.globalData.tgroupId;
  },
  // // 判断名称是否重复
  // checkName (name, d) {
  //   console.log();
  //   if (!d) {
  //     return false;
  //   }
  //   for (let roomId in app.globalData.devs) {
  //     let {devs} = app.globalData.devs[roomId];
  //     if (!devs || devs.length == 0) {
  //       continue;
  //     }
  //     for (let item of devs) {
  //       if (d != item.d && name == item.n) {
  //         // _isRepeat = true;
  //         return true;
  //       }
  //     }
  //   }
  //   return false;
  // }
})
