import ability from "../../../utils/classDef/ability";
import bizUtil from '../../../utils/bizUtil';
const app = getApp();

Page({
  data: {
    // 显示列表详情
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: ""
      }
    },
    // 设备状态
    devStatus: {
      // enumIdx: -1, // 颜色下标
      // typeIdx: 0, // 默认选中的tab
    },
    // 是否群控
    isGroup: false,
    // 固定颜色
    commonColors: [],
    // 常用颜色
    fixColors: [{
      color: '#ffffff',
      text: '', // W
      className: '' // whiteEnum semibold center
    }, {
      // color: '#F7A36A'
      color: '#FF0000'
    }, {
      // color: '#F0846A'
      color: '#00FF00'
    }, {
      // color: '#CD7EFE'
      color: '#0000FF'
    }, {
      color: '#FFFF00'
    }],
    // canvas尺寸
    canvas: {
      pageX: 0, // canvas的左侧顶点位置
      pageY: 0, // canvas的左侧顶点位置
      widthRpx: 466, // rpx,
      heightRpx: 466, // rpx
      padL: 38, // 由于圆需要放到外面，所以需要增大thumb大小
      multip: 2, // rpx与px的比例，默认为2
      centerX: 0, // 中心点横坐标
      centerY: 0, // 中心点纵坐标
      r: 0, // 半径
    },
    thumb: {
      bgColor: '#0069FF',
      x: 100,
      y: 100,
      // angle: 235 // 默认在第三象限，角度
    },
    groupIds: [], // 批量控制
    OnlyCW: false, // 默认不是cw
    isOnlyRgb: false, // 默认不是只有rgb

    selectImg: {}, // 选中的按钮（需要变颜色）
    controlList: [], // 底部按钮

    // 色温配置
    cwSliders: {
      leftImg: "../../static/img/common/cDel.png",
      rightImg: "../../static/img/common/cAdd.png",
      bgImg: "../../static/img/common/temp.png",
      leftClass: "cDown",
      rightClass: "cUp",
      bgClass: "tempImg",
      width: 524, // rpx
      percent: 50, // 百分比
      minPercent: 0,
      // minVal: 0,
      // maxVal: 255,
      gradient: false, // 默认不支持滑动时调节
      labelTxt: "色温",
      unit: "K",
      minVal: 2700,
      maxVal: 6500,
    },
    // 亮度配置
    brightSliders: {
      leftImg: "../../static/img/common/bright_down.png",
      rightImg: "../../static/img/common/bright_up.png",
      leftClass: "bDown",
      rightClass: "bUp",
      width: 516, // rpx
      percent: 100, // 百分比
      labelTxt: "亮度",
      minVal: 2,
      maxVal: 127,
      minPercent: 1, // 最小百分比
      gradient: false // 默认不支持滑动时调节
    },
    onActive: "",
    offActive: "",
    rgbUp: "",
    rgbDown: "",
    bleUnavailable: false,
    scales: "none", // 适配小屏幕手机，暂时方案为 整体缩小
    abilitys: {}, // 设备控制的能力
    timer: null, // 定时器


    // 新的代码
    // 操作列表
    actionList: [{
      text: "彩光",
      handle: "setUp"
    }, {
      text: "白光",
      handle: "setDown"
    }],
    
    // 使用新的方法绘图
    // context: null
  },
  // onUnload () {
  //   this.data.context = null;
  // },
  onLoad() {
    // 使用新的方法绘图
    this.context = null;
    // 批量控制的addr列表
    this.data.groupIds = app.globalData.groupIds || [];
    // 初始化功能
    this.initDevFunctions();
    // 初始化常用颜色
    this.initColors();

    // 判断页面是否群组，如果是群组，设备列表是否为空
    let {gid, dids} = app.globalData.groupInfo || {};
    if (this.isGroupCtrl() && gid >= 0 && dids?.length == 0) {
      // 跳转页面
      return ability.navigateTo("/groups/manage/index?remote=" + 0);
    }
  },
  // 常用颜色
  initColors () {
    // 颜色数据
    let _colorArray = [];
    // 家庭id
    let _familyId = app.globalData.familyInfo?.id || 1;
    // 通用颜色数据
    let _colors = app.globalData.colors;
    if (_colors instanceof Array) {
      _colorArray = _colors.concat([]);
    } else {
      _colorArray = _colors[_familyId] || _colors?.common || [];
    }
    console.log("initColors _colorArray = ", _colorArray)
    // this.data.commonColors = app.globalData.colors || [];
    this.setData({
      commonColors: _colorArray
    })
  },
  onReady () {
    // 初始化比例
    this.initMultip();
    // 取得canvas的位置
    this.getCanvasOffset();
    // 绘制图案
    this.drawProgressbg();
    // 取得真实高度
    this.getRealContentHeight();

    // 角度
    let _lastAngle = (this.data.devStatus || {}).angle;
    let _angle = _lastAngle == undefined ? 235 : _lastAngle;
    let _color = this.data.devStatus.angleColor || '#0069FF';
    console.log("_angle = ", _angle)
    // 初始化thumb坐标信息
    this.initThumbPosition(_angle, _color);
  },
  // 取得真实的高度
  getRealContentHeight () {
    // 根据尺寸取得实际长度
    const query = wx.createSelectorQuery();

    query.select('#tabTypeContainer').boundingClientRect()
    // 判断选中的标签
    let _typeIdx = this.data.devStatus?.typeIdx || 0;
    if (_typeIdx == 1) {
      query.select('.cwContainer').boundingClientRect()
      query.select('#cwSlider').boundingClientRect()
    } else {
      query.select('#rgbContainer').boundingClientRect()
      query.select('#commonContainer').boundingClientRect()
      query.select('#fixedContainer').boundingClientRect()
    }
    query.select('#brightSlider').boundingClientRect()
    query.select('#bottomBtns').boundingClientRect()
    query.exec((res) => {
      // 计算尺寸
      let _sizeObj = this.getAllHeightFromArray(res);

      // 页面内容高度
      let _contentHeight = app.globalData.customPageSize?.contentHeight || 0;
      // console.log("getRealContentHeight res, _sizeObj, _contentHeight = ", res, _sizeObj, _contentHeight);

      let _percent = 1;
      // 如果大于页面高度 底部需要有20像素的留白
      let _realHeight = (_sizeObj.height + _sizeObj.seperator) + 30;
      if (_realHeight > _contentHeight) {
        _percent = _contentHeight / (_realHeight + _contentHeight * 0.1);
      }

      // console.log("getRealContentHeight _percent = ", _percent, _contentHeight, _realHeight);
      this.setData({
        scales: 'scale(' + _percent + ')'
      })
    });
  },
  getAllHeightFromArray (array) {
    if (!array) {
      return 0;
    }
    // 总高度
    let _height = 0;
    let _bottom = 0;
    let _seperator = 0;
    // 遍历数据
    let _length = array.length;
    let _itemPositionY = 0;
    for (let index in array) {
      let item = array[index];
      if (!item) {
        continue;
      }
      _height += item.height;
      _bottom = Math.max(item.bottom, _bottom);
      if (index > 0 && _length > 1 && index < (_length - 1)) {
        let _y = item.top - _itemPositionY;
        if (_y > 0) {
          _seperator += _y;
        }
      };
      // 位置
      _itemPositionY = (item.top + item.height);
    }
    return {
      height: _height,
      bottom: _bottom,
      seperator: _seperator
    };
  },
  // 取得canvas的位置
  getCanvasOffset () {
    // 根据尺寸取得实际长度
    const query = wx.createSelectorQuery()
    query.select('#lightBg').boundingClientRect()
    // query.select('#lightCanvas').fields({ node: true, size: true })
    // query.selectViewport().scrollOffset()
    query.exec((res) => {
      console.log("onReady res = ", res);
      if (!res) {
        return;
      }
      // 取得尺寸
      let _size = res[0] || {};
      this.data.canvas.pageX = _size.left;
      this.data.canvas.pageY = _size.top;
      this.data.canvas.width = _size.width;
      this.data.canvas.height = _size.height;
    })
  },
  initMultip () {
    this.data.canvas.multip = app.globalData.customPageSize.multip;
  },
  // 取得当前页面控制设备列表数组
  getAllCtrlDevsArray () {
    // 是否群组设备
    let {dids} = app.globalData.groupInfo || {};
    if (this.isGroupCtrl()) {
      // 固定群组
      // 取得房间下所有的d对应的详细信息
      let _didMaps = bizUtil.getDidMapInJson(app.globalData.devs);
      // 群组设备列表
      let _groupDevs = dids || [];
      // 群组设备列表详细
      return _groupDevs.map(did => _didMaps[did]);
    } else if (app.globalData.tgroupId && (app.globalData.tmpData?.tdevs)) {
      // 临时群组
      return app.globalData.tmpData?.tdevs || [];
    } else {
      let _devInfo = app.globalData.devInfo;
      if (_devInfo) {
        // 单个设备控制
        return [_devInfo];
      } else if (this.isBatchCtrl()) {
        // 5个一组的批量控制
        return app.globalData?.tmpData?.tdevs || [];
      } else {
        // 房间控制
        return this.getDevArrayByRoomIdInJson(app.globalData.devs, (app.globalData.roomInfo || {}).id)
      }
    }
  },
  // 根据房间id取得json中设备集合
  getDevArrayByRoomIdInJson (json, roomId) {
    let _devs = [];
    if (!json) {
      return _devs;
    }
    if (roomId == 0) {
      // 全屋设备
      _devs = bizUtil.getAllDevsFilter(json) || [];
    } else if (roomId % 32 == 0) {
      // 取得楼层数据
      let _devJson = bizUtil.getDevsArrayByFloor(json, bizUtil.getFloorByRoomId(roomId)) || {};
      _devs = bizUtil.getAllDevsFilter(_devJson);
    } else {
      // 全屋设备
      _devs = bizUtil.getAllDevsFilter(json, roomId) || [];
    }
    console.log("getFuncList _devs = ", _devs);
    return _devs;
  },
  // 初始化数据
  initDevFunctions () {
    // 初始化设备通用功能
    let _devStatus = {
      angleColor: '#0069FF',
      angle: 235, // 默认角度为235
      enumIdx: -1, // 颜色下标
      typeIdx: 1,
      pwr: 1,
      brightnessP: 100, // 默认保存百分比 cw
      rgbBrightnessP: 100, // 默认保存百分比 rgb
    };
    let _devInfo = app.globalData.devInfo;
    // 判断设备单个还是批量或者群组
    let {maxStatus, versions} = this.getFuncList(this.getAllCtrlDevsArray()) || {};
    // 赋值给devStatus
    _devStatus = Object.assign({}, maxStatus, _devStatus);
    console.log("last devStatus, maxStatus = ", _devStatus, maxStatus);
    // 是否rgb设备
    this.data.isOnlyRgb = this.checkOnlyRgb(_devStatus); // _devInfo ? this.isRgbByPid(app.globalData.devInfo.t) : this.checkOnlyRgb();
    this.data.OnlyCW = this.checkOnlyCW(_devStatus);
    console.log("this.data.isOnlyRgb = ", this.data.isOnlyRgb);
    // 取得上次保存的值
    let _valStatus = this.getDevStatus(true);
    console.log("initDevFunctions _valStatus = ", _valStatus);
    for (let key in _devStatus) {
      let _val = _valStatus[key];
      (_val != undefined) && (_devStatus[key] = _val);
    }

    // 保存能力集合
    this.data.abilitys = bizUtil.getMaxAbilityByVs(versions) || {};
    console.log("this.data.abilitys, versions = ", this.data.abilitys, versions);
    // 能力集合
    let {gradient, minBrightness} = this.data.abilitys;
    // 是否支持渐变
    let _gradient = this.data.abilitys.gradient;
    // 更新滑块状态
    this.data.brightSliders.gradient = _gradient;
    this.data.cwSliders.gradient = _gradient;
    console.error("minBrightness = ", minBrightness, this.data.abilitys, this.data.brightSliders);
    // 更新亮度
    !!minBrightness && (this.data.brightSliders.minVal = minBrightness.value, this.data.brightSliders.minPercent = minBrightness.percent);
    

    // 亮度真实百分比
    let _percent100 = _valStatus?.brightnessP || 100;
    let _rgbPercent100 = _valStatus?.rgbBrightnessP || 100;
    // 多保存一个设备状态用于亮度不改变
    _devStatus.brightness = bizUtil.getRealValByPercent(_percent100);
    _devStatus.rgbBrightness = bizUtil.getRealValByPercent(_rgbPercent100);
    // 更新亮度滑块的百分比
    if (_devStatus.typeIdx == 1) {
      this.data.brightSliders.percent = _percent100;
    } else {
      this.data.brightSliders.percent = _rgbPercent100;
    }
    // 保存设备状态
    app.globalData.devStatus = this.data.devStatus = _devStatus;
    // 保存色温百分比
    let _cwP = _valStatus.cwP;
    if (_cwP != undefined) {
      this.data.cwSliders.percent = _cwP;
    } else {
      (_valStatus.c != undefined) && (this.data.cwSliders.percent = this.getPercentByRealValue(((255 - _valStatus.c) || 0) / 255 * (this.data.cwSliders.maxVal - this.data.cwSliders.minVal) + this.data.cwSliders.minVal, this.data.cwSliders));
    }
    console.log("this.data.cwSliders.percent = ", this.data.cwSliders.percent, _valStatus.c, _cwP);


    // 更新状态
    this.setData({
      isOnlyRgb: this.data.isOnlyRgb,
      OnlyCW: this.data.OnlyCW,
      devStatus: this.data.devStatus,
      brightSliders: this.data.brightSliders,
      cwSliders: this.data.cwSliders
    })
  },
  // 取得滑块值的百分比
  getPercentByRealValue (realValue, obj) {
    console.log("getPercentByRealValue realValue, obj = ", realValue);
    if (!obj) {
      return 0;
    }
    let {minVal, maxVal} = obj;
    let _minVal = minVal || 0;
    let _maxVal = maxVal || 100;
    if (realValue < _minVal) {
      return _minVal;
    } else if (realValue > _maxVal) {
      return _maxVal;
    }
    // 这里 (73.25 - 2) / (127 - 2) * 100 = 56.999999999 计算器算出来是57
    let _percent = (realValue - _minVal) / (_maxVal - _minVal);
    let _pointInt = _percent * 100 - parseInt(_percent * 100);
    let _result = parseInt(_percent * 100) + ((_pointInt > 0.99) ? 1 : 0);
    console.log("_pointInt, _percent, _result = ", _pointInt, _percent, _result);
    return _result;
  },
  getFuncByPid (devStatus, pid, defaultC) {
    // 默认的色温
    let _extendJson = defaultC == undefined ? undefined : {
      c: defaultC
    };
    return bizUtil.getFuncByPid(devStatus, pid, _extendJson);
  },
  onShow () {
    // 重置选中的
    this.data.selectImg = {};
    // 批量控制的addr列表
    this.data.groupIds = app.globalData.groupIds || [];
    // 初始化设备名称
    // this.initDevName();
    // 获取设备状态
    this.setDevStatus(app.globalData.devStatus);
    // this.data.devStatus = app.globalData.devStatus;
    // this.getDevStatus(false);
    // 初始化controlList
    this.initPageByGroup();
  },
  setDevStatus (status) {
    this.data.devStatus = status || app.globalData.devStatus;
    console.log("setDevStatus status = ", status);
    this.setData({
      devStatus: this.data.devStatus
    })
  },
  initThumbPosition (angle, color) {
    // 取得角度的坐标位置
    let {x, y} = this.getPositionByAngle(angle);
    // 取得角度对应的颜色
    // this.initThumbColorByAngle(x, y);
    this.data.thumb.x = x;
    this.data.thumb.y = y;
    this.data.thumb.bgColor = color;
    console.log("initThumbPosition x, y, this.data.thumb.angle = ", x, y, this.data.thumb.angle);
    this.setData({
      thumb: this.data.thumb
    })
  },
  onUnload () {
    // 页面销毁 如果设置过百分比和最佳位置则保存设备状态
    this.saveDevStatus();
    // 保存常用颜色
    this.saveColorsByFamily();
    // 清除定时器
    this.clearTimer(this.data.timer);
    // // 清除临时group
    // app.globalData.tgroupId = undefined;
  },
  saveColorsByFamily () {
    // 家庭id
    let _familyId = app.globalData.familyInfo?.id || 1;
    // 颜色数据
    let _obj = app.globalData.colors;
    let _result = {};
    if (_obj instanceof Array) {
      _result.common = _obj.concat([]);
      _result[_familyId] = this.data.commonColors || [];
    } else {
      _result = _obj;
      _result[_familyId] = this.data.commonColors || [];
    }
    // let _array = this.data.commonColors || [];
    app.globalData.colors = _result;
    console.log("saveColorsByFamily _result = ", _result);
    // 保存到缓存中
    app.setBizStorage("colors", _result);
  },
  // 区分群控页面
  initPageByGroup () {
    let _isGroup = (app.globalData.devInfo == undefined);
    this.data.isGroup = _isGroup;
    // 初始化控制列表
    this.data.controlList = this.getControlList(_isGroup);
    
    // 初始化标题
    let _title = this.getDevName(_isGroup);
    // this.data.navObj.center.text = _title;
    ability.setNavigationBarTitle(_title);

    // 设置数据
    this.setData({
      controlList: this.data.controlList,
      navObj: this.data.navObj,
      isGroup: _isGroup
    })
  },
  // 设置选中的key
  setKeySelect (key) {
    if (!key) {
      return;
    }
    this.data.selectImg = {};
    this.data.selectImg[key] = true;
  },
  // 根据key确定是否选中
  isSelectedByKey (key) {
    if (!key) {
      return false;
    }
    return this.data.selectImg[key];
  },
  // 根据数据区分
  getControlList (isGroup) {
    // 是否选中
    let _patternSel = this.isSelectedByKey("pattern");
    let _detailSel = this.isSelectedByKey("detail");
    // 控制列表
    let _controlList = [
      {
        imgPath: "../../img/light/pattern" + (_patternSel ? '_sel' : '') + ".png",
        text: "模式",
        tap: "jumpPattern",
        className: _patternSel ? "bgF78D3F white" : "bgNone coloraaa",
        imgClassName: 'patternImg'
      }, {
        imgPath: "../../img/light/timer.png",
        text: "定时",
        tap: "jumpTimer",
        className: _detailSel ? "bgF78D3F white" : "bgNone coloraaa",
        imgClassName: 'timerImg'
      }
    ];

    // 设备状态
    let _devStatus = this.data.devStatus;
    // 批量控制
    let _isBatchCtrl = this.isBatchCtrl();
    if (isGroup) {
      if (_isBatchCtrl) {
        // 批量不需要有模式
        _controlList[0].className = "hide";
        _controlList[1].className = "hide";
        // return [];
      } else {
        console.log("getControlList = ", ((this.data.abilitys || {}).sleep), _devStatus);
        // return (_devStatus.r != undefined || (this.data.abilitys || {}).sleep) ? [_controlList[0]] : []
        return (_devStatus.r != undefined || (this.data.abilitys || {}).sleep) ? (_controlList[1].className = "hide") : (_controlList[0].className = "hide",
        _controlList[1].className = "hide")
      }
    }
    return _controlList;
  },
  getDevStatus (isFirst) {
    // 取得当前设备的状态
    let _devStatus = app.globalData.devStatus;
    // 第一次
    if (isFirst) {
      // 取得所有设备保存的状态数据
      let _allDevStatus = app.globalData.allStatus || {};
      this.data.allDevStatus = _allDevStatus;
      // console.log("getDevStatus storage _allDevStatus = ", _allDevStatus, app.globalData.devInfo, app.globalData.groupIds, this.data.groupIds);
      // 根据设备did+短地址获取设备状态
      let _dev = app.globalData.devInfo || {};
      // 如果是批量
      if (this.isBatchCtrl()) {
        console.log("batchcontrol");
        // 如果是批量
        _devStatus = _allDevStatus['batch'] || {};
      } else if (this.isAllCtrl()) {
        console.log("allcontrol");
        // 如果是全屋
        _devStatus = _allDevStatus['all'] || {};
      } else {
        console.log("singlecontrol");
        // 设备状态
        _devStatus = _allDevStatus[_dev.d + "_" + _dev.a] || {};
      }
    }
    // 取得当前设备的状态
    return _devStatus || {};
  },
  // 取得小程序缓存
  getStorageByKey (key) {
    return ability.getStorage({
      key: key
    }, true);
  },
  setStorageByKey (key, data) {
    // 保存
    ability.setStorage({
      key: key,
      data: data
    });
  },
  saveDevStatus () {
    // 保存的设备状态
    let _allDevStatus = this.data.allDevStatus || {};
    // 如果是批量
    if (this.isBatchCtrl()) {
      // 如果是批量
      _allDevStatus["batch"] = this.data.devStatus;
    } else if (this.isAllCtrl()) {
      // 如果是全屋
      _allDevStatus["all"] = this.data.devStatus;
    } else {
      let _dev = app.globalData.devInfo;
      // 设备状态
      _allDevStatus[_dev.d + "_" + _dev.a] = this.data.devStatus;
    }
    app.globalData.allStatus = _allDevStatus;
    // 保存到缓存中
    app.setBizStorage("devStatus", _allDevStatus);
  },
  // 是否群组控制
  isGroupCtrl () {
    return !!app.globalData.groupInfo && !!app.globalData.tgroupId;
  },
  getDevName (isGroup) {
    // 补丁+1
    if (this.isGroupCtrl()) {
      // 群组
      return app.globalData.groupInfo?.n || "";
    }
    // 补丁
    if (isGroup && app.globalData.tgroupId) {
      // 临时group存在
      return "批量控制"
    }
    return isGroup ? (this.data.groupIds.length > 0 ? "批量控制" : (app.globalData.roomInfo.id ? (app.globalData.roomInfo.n || '房间控制') : (app.globalData.roomInfo.n || "全屋控制"))) : (app.globalData.devInfo || {}).n;
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || ""
    })
  },
  hideLoading () {
    ability.hideLoading();
  },

  addAngle () {
    this.dealAngle(1);
  },
  setDataByKey (key, value) {
    this.data[key] = value;
    this.setData({
      [key]: value
    })
  },
  delAngle () {
    this.dealAngle(-1);
  },
  dealAngle (value, hideAction, notSend) {
    // 设置按钮
    if (!hideAction) {
      console.error("dealAngle hideAction = ", hideAction);
      this.setDataByKey(value > 0 ? "rgbUp" : "rgbDown", true);
      setTimeout(() => {
        this.setDataByKey(value > 0 ? "rgbUp" : "rgbDown", false);
      }, 100);
    }

    // 取得0-360之间的角度
    let _angle = (360 + this.data.devStatus.angle + value) % 360;
    console.log("dealAngle _angle = ", _angle);
    // 根据角度取得坐标
    let _position = this.getPositionByAngle(_angle);
    console.log("dealAngle _position = ", _position);
    this.data.thumb.x = _position.x;
    this.data.thumb.y = _position.y;
    // this.data.thumb.angle = _angle;
    // 保存角度
    this.data.devStatus.angle = _angle;
    // 取得像素
    this.getImageData(_angle, _position.x, _position.y, (rgbData, sendData) => {
      let data = this.dealRgbPanel(rgbData);
      if (!data) {
        return;
      }
      let _colorStr = '#' + data[0].toString(16).padStart(2, '0') + data[1].toString(16).padStart(2, '0') + data[2].toString(16).padStart(2, '0');
      console.log("_colorStr = ", _colorStr);
      let _enumIdx = this.data.devStatus.enumIdx;
      let _commonColors = this.data.commonColors || [];
      // 保存颜色
      if (_enumIdx >= 0 && _commonColors[_enumIdx]) {
        (_commonColors[_enumIdx] || {}).color = _colorStr;
        this.setData({
          commonColors: this.data.commonColors
        });
      }

      this.data.thumb.bgColor = 'rgb('+data[0]+','+data[1]+','+data[2] + ')';
      // 保存颜色
      this.data.devStatus.angleColor = this.data.thumb.bgColor;
      this.setData({
        thumb: this.data.thumb
      })

      // 不需要发送
      if (notSend) {
        return;
      }

      // 数据处理
      let _sendRGB = sendData || this.dealRgbSend(data);
      // 发送指令
      this.actDev({
        pwr: 1, // 固定
        brightness: 127, // 固定
        r: _sendRGB[0],
        g: _sendRGB[1],
        b: _sendRGB[2],
        c: 0xff,
        w: 0xff,
        rgbPwr: 1, // 固定
        rgbBrightness: 0 // 固定
      });
    });
  },

  // 由于色盘不准，所以处理一下获取到的颜色
  dealRgbPanel (data) {
    if (!data || data.length < 3) {
      return false;
    }
    return data;
  },
  // 发送rgb的处理
  dealRgbSend (data) {
    if (!data || data.length < 3) {
      return false;
    }
    let _r = data[0], _g = data[1], _b = data[2];
    // 增加逻辑，realR = r * 255 / (R+G+B)
    let _p = 255 / (_r + _g + _b);
    let _realR = parseInt(_r * _p);
    let _realG = parseInt(_g * _p);
    let _realB = parseInt(_b * _p);

    return [_realR, _realG, _realB];
  },

  clickOpen() {
    this.setColorIndex(-1);
    // console.log("clickOpen this.data.devStatus = ", this.data.devStatus, this.data.devStatus.brightness);
    this.onlyPwrCtrl(this.data.devStatus.brightness || 127);
  },
  clickClose(){
    this.setColorIndex(-1);
    this.onlyPwrCtrl(0);
  },
  // 只有控制触发
  onlyPwrCtrl (brightness) {
    console.log("onlyPwrCtrl brightness = ", brightness);

    // 控制参数
    let _params = {};
    // 判断开关控制的类型
    let _typeIdx = this.data.devStatus?.typeIdx || 0;
    if (_typeIdx == 0) {
      // rgb控制开关
      _params.brightness = 0;
      _params.pwr = 0;
      _params.r = 0;
      _params.g = 0;
      _params.b = 0;
      _params.c = 0xff;
      _params.w = 0xff;
      _params.rgbBrightness = brightness;
      if (brightness > 0) {
        _params.rgbPwr = 1;
      } else {
        _params.rgbPwr = 0;
      }
    } else {
      // 色温控制
      _params.brightness = brightness;
      if (brightness > 0) {
        _params.pwr = 1;
      } else {
        _params.pwr = 0;
      }
    }

    // 动画效果
    this.setClickAction(brightness);
    setTimeout(() => {
      // 动画效果
      this.setClickAction(brightness, true);
    }, 100);
    // // 判断是否批量控制
    // let _isBatchCtrl = this.isBatchCtrl();
    // if (_isBatchCtrl && brightness > 0) {
    //   _params.r = _params.g = _params.b = _params.c = _params.w = 0;
    // }
    this.actDev(_params);
  },
  setClickAction (isOpen, isReset) {
    // 动画效果
    let _obj = {};
    let _val = isReset ? '' : 'pwrActive';
    isOpen?(_obj.onActive=_val,_obj.offActive=''):(_obj.offActive=_val,_obj.onActive='');
    console.log("setClickAction _obj = ", _obj);
    this.setData(_obj);
  },
  // 根据品类取得最小功能集合
  getFuncList (devs) {
    // 取得全屋设备 (默认所有设备都在这里)
    let _roomId = (app.globalData.roomInfo || {}).id;
    let _devs = [];
    if (devs) {
      // 单个设备控制
      _devs = devs || [];
    } /* else if (!devs && app.globalData.groupIds) {
      // 批量控制

    }*/ else {
      if (_roomId == 0) {
        // 全屋设备
        _devs = bizUtil.getAllDevsFilter(app.globalData.devs) || [];
      } else if (_roomId % 32 == 0) {
        // 取得楼层数据
        let _devJson = bizUtil.getDevsArrayByFloor(app.globalData.devs, parseInt(_roomId / 32 - 1)) || {};
        console.log("getFuncList _devJson = ", _devJson);
        _devs = bizUtil.getAllDevsFilter(_devJson);
      } else {
        // 全屋设备
        _devs = bizUtil.getAllDevsFilter(app.globalData.devs, _roomId) || [];
      }
    }
    console.log("getFuncList devs, _devs = ", devs, _devs);
    // 是否批量控制
    let groupIds = app.globalData.groupIds || [];
    let _isAll = groupIds.length == 0;
    // console.log("checkOnlyRgb groupIds, _devs, devs = ", groupIds, _devs, devs, app.globalData.devs)
    // 最终集合
    let pids = [], versions = [], minStatus= {}, maxStatus = {};
    // let _minCount = 20, _maxCount = -1;
    // 遍历数据取得集合
    for (let index in _devs) {
      let _item = _devs[index];
      // 添加版本分支集合
      versions.push(_item.v);
      // 防止重复添加
      if (pids.indexOf(_item.t) >= 0) {
        continue;
      }
      if (_isAll || (!_isAll && groupIds.indexOf(_item.a) >= 0)) {
        pids.push(_item.t);
        // dids.push(_item.d);
        let _devStatus = this.getFuncByPid({}, _item.t, this.data.cwSliders.percent * 2.55);
        console.log("getFuncList _devStatus, _item.t = ", _devStatus, _item.t);
        // 添加最大值
        Object.assign(maxStatus, _devStatus);
      }
    }
    console.log("getFuncList maxStatus = ", maxStatus);
    return {
      pids: pids,
      versions: versions, // 版本能力集合
      maxStatus: maxStatus
    };
  },
  // 是否只包含rgb设备
  checkOnlyRgb (status) {
    if (!status) {
      return false;
    }
    return status.c == undefined && status.w == undefined && status.r != undefined && status.g != undefined && status.b != undefined;
  },
  checkOnlyCW (status) {
    if (!status) {
      return false;
    }
    return status.c != undefined && status.w != undefined && status.r == undefined && status.g == undefined && status.b == undefined;
  },
  // 判断是否rgb
  isRgbByPid (pid) {
    return pid == 43168;
  },
  setColorIndex (index) {
    this.data.devStatus.enumIdx = index;
    this.setData({
      devStatus: this.data.devStatus
    })
  },
  // 颜色点击
  colorEnumClick (e) {
    let _index = e.currentTarget.dataset.index;
    let _isCancel = _index == this.data.devStatus.enumIdx;
    // 更新数据
    this.setColorIndex((_index >= 10 || _isCancel) ? -1 : _index);
    if (_isCancel) {
      return;
    }

    let _item = null;
    if (_index >= 10) {
      _item = this.data.fixColors[_index - 10];
    } else {
      _item = this.data.commonColors[_index];
    }
    let _colorStr = _item.color || "";
    let _rgbStr = "";
    // 如果是rgb 以逗号分开
    if (_colorStr.indexOf("#") >= 0) {
      _rgbStr = _colorStr.split("#")[1] || "";
    } else {
      return;
    }
    // 发送数据
    let _params = {
      pwr: 1,
      brightness: 127,
      c: 0xff,
      w: 0xff,
      rgbPwr: 1,
      rgbBrightness: 0
    };
    // 特殊处理(https://www.tapd.cn/41682094/bugtrace/bugs/view/1141682094001004307)
    if (_item.color.toLowerCase() == '#ffffff') {
      _params.r = _params.g = _params.b = 0x55;
    } else {
      _params.r = parseInt("0x" + _rgbStr.substr(0, 2));
      _params.g = parseInt("0x" + _rgbStr.substr(2, 2));
      _params.b = parseInt("0x" + _rgbStr.substr(4, 2));
    }
    // 发送广播
    this.actDev(_params);
  },
  isW () {
    let _devStatus = this.data.devStatus;
    return _devStatus.r == undefined && _devStatus.c == undefined;
  },
  // 滑块百分比
  sliderChange (event) {

    // 初始化选择常用颜色
    this.setColorIndex(-1);

    let _percent = event.detail.percent;
    let _value = event.detail.value;
    // let _isMoving = event.detail.isMoving;
    // let _originValue = event.detail.originValue;
    // 区间为 5 - 127 默认为0 - 100
    // _val = 5 + parseInt(_val * 1.22);
    console.log("sliderChange _value, _originValue = ", _value, _percent);
    
    // 发送状态
    let _status = {};
    // 判断选中的tab
    if (this.data.devStatus.typeIdx == 0) {
      _status.r = _status.g = _status.b = _status.pwr = _status.brightness = 0;
      _status.c = _status.w = 0xff;
      _status.rgbBrightness = _value;
      _status.rgbPwr = 1;
      this.data.devStatus.rgbBrightnessP = _percent;
    } else {
      _status.r = _status.g = _status.b = _status.c = _status.w = _status.rgbBrightness = _status.rgbPwr = 0;
      _status.brightness = _value;
      _status.pwr = 1;
      this.data.devStatus.brightnessP = _percent;
    }
    // 增加处理 保存原始的值（精确到小数点 为了防止下次进入亮度不一致）
    // 执行 , _isMoving ? 1 : undefined
    this.actDev(_status);
  },
  // 滑块百分比
  cwSliderChange (event) {
    let {value, isMoving, percent} =  event.detail;
    console.log("sliderChange value = ", value, percent, isMoving);

    // 保存色温百分比
    this.data.devStatus.cwP = percent;

    // 色温值 0-255
    let _value = Math.round(percent * 2.55);
    console.log("cwSliderChange _value = ", _value);
    // 执行 , isMoving ? 1 : undefined
    this.actDev({
      pwr: 1,
      brightness: this.data.devStatus.brightness || 127,
      c: (255 - _value),
      w: _value
    });
  },
  // 获取是否批量控制
  isBatchCtrl () {
    return (this.data.groupIds.length > 0) && (app.globalData.devInfo == undefined || Object.keys(app.globalData.devInfo).length == 0);
  },
  // 这里是全屋控制和临时、固定群组控制
  isAllCtrl () {
    let _groupIds = app.globalData.groupIds;
    return (!_groupIds || _groupIds.length == 0) && app.globalData.devInfo == undefined
  },
  actDev (key, configJson) {
    // // 如果只有亮度调节成0，则不保存亮度的值
    // let _keyArray = Object.keys(key) || [];
    // if (_keyArray.length == 1 && key['brightness'] == 0) {
    //   // 不保存
    // } else {
    //   // 不能assign,会有cw等保存进去
    //   for (let _k in key) {
    //     if (this.data.devStatus[_k] != undefined) {
    //       this.data.devStatus[_k] = key[_k];
    //     }
    //   }
    // }
    
    // 群组id
    let _groupIds = this.data.groupIds;
    let _devInfo = app.globalData.devInfo;
    let _isBatchCtrl = this.isBatchCtrl();
    console.log("actDev _isBatchCtrl, _devInfo = ", _isBatchCtrl, !!_devInfo);
    // 判断控制方式
    // 如果有临时group 补丁
    if (app.globalData.tgroupId) {
      console.log("app.globalData.tgroupId = ", app.globalData.tgroupId);
      // 全屋或者房间控制
      app.globalData.blsdk.groupControlWithType(false, app.globalData.tgroupId, key, configJson);
    } else if (_isBatchCtrl) {
      console.log("_isBatchCtrl, _devInfo = ", _groupIds, key);
      // 批量控制
      app.globalData.blsdk.bathControlWithDeviceList(_groupIds, key, configJson);
    } else if (!_isBatchCtrl && !_devInfo) {
      // 全屋或者房间控制
      app.globalData.blsdk.groupControlWithType(false, (app.globalData.roomInfo || {}).id || 0, key, configJson);
    } else {
      app.globalData.blsdk.controlWithDevice(_devInfo, key, configJson);
    }
  },
  /************** end ***************/
  // 判断简单不重复数据是否在数组中
  isAllInArray (values, array) {
    if (!array) {
      return false;
    }
    let _typeStr = typeof values;
    if (_typeStr == "string" || _typeStr == "number") {
      return array.indexOf(values) >= 0;
    }
    return array.sort().join('').indexOf(values.sort().join('')) >= 0;
  },
  // 跳转定时页面
  jumpTimer () {
    app.globalData.tmpData.timerJson = undefined;
    ability.navigateTo("../../../timer/list/index")
  },
  // 跳转模式页面
  jumpPattern () {
    console.log("this.data.abilitys, this.data.devStatus = ", this.data.abilitys, this.data.devStatus);
    // 是否支持睡眠模式
    let _sleep = (this.data.abilitys || {}).sleep || 0;
    // 最小值
    let _brightness = (this.data.abilitys || {}).minBrightness || {};
    let _value = _brightness.value;
    // 1024
    let _cw = ((this.data.abilitys || {})['1024'] || 0);
    // cw灯的渐变跳变能力
    let _cwGradient = ((this.data.abilitys || {})['cwGradient'] || 0);
    // 传递当前亮度值
    let _brightnessV = this.data.devStatus.brightness || 127;
    // 跳转页面
    this.setColorIndex(-1);
    // 传递参数
    ability.navigateTo("../mode/index?sleep=" + _sleep + "&mode=" + Number((this.data.devStatus || {}).r != undefined) + (_value != undefined ? ("&min=" + _value) : '') + "&cw=" + _cw + "&gradient=" + _cwGradient + "&brightness=" + _brightnessV);
  },
  // 跳转设备详情页面
  jumpDetail () {
    // 初始化
    this.setColorIndex(-1);
    // 保存设备状态
    app.globalData.devStatus = this.data.devStatus || {};
    // 是否支持遥控器
    let _remote = (this.data.abilitys || {}).remote || 0;

    // 如果是群组控制，则进入群组管理页面
    if (this.isGroupCtrl()) {
      console.log("groupCtrl app.globalData.groupInfo = ", app.globalData.groupInfo);
      // 跳转页面
      return ability.navigateTo("/groups/manage/index?remote=" + _remote);
    }
    console.log("devProperty");
    // 跳转页面
    ability.navigateTo("../devProperty/index?remote=" + _remote);
  },
  drawProgressbg () {
    // 初始化尺寸
    let _configAfterDeal = this.initCanvasSize();
    Object.assign(this.data.canvas, _configAfterDeal || {});
    // 绘图
    this.drawNewDetail(this.data.canvas);

    // const query = wx.createSelectorQuery()
    // query.select('#lightCanvas')
    // .fields({ node: true, size: true })
    // .exec((res) => {
    //   const canvas = res[0].node

    //   console.log("drawProgressbg res = ", res);

    //   const ctx = canvas.getContext('2d');
    //   // 绘图
    //   this.drawOldDetail(ctx, this.data.canvas);
    // })
  },
  drawNewDetail (obj) {
    // canvas的长和宽
    let {widthRpx, heightRpx, multip, padL} = obj || {};
    let _width = (widthRpx) / multip, _height = heightRpx / multip;
    // 创建离屏 2D canvas 实例
    var canvas = wx.createOffscreenCanvas({type: '2d', width: _width, height: _height})
    // 获取 context。注意这里必须要与创建时的 type 一致
    var context = canvas.getContext('2d');

    // 等待条
    this.showLoading();

    // 创建一个图片
    const image = canvas.createImage()
    image.src = "../../img/light/bg.png" // 要加载的图片 url
    image.onload = () => {

      ability.hideLoading();

      // 把图片画到离屏 canvas 上
      // context.clearRect(0, 0, _width + padLReal * 2, _height + padLReal * 2);
      // context.drawImage(image, padLReal, padLReal, _width, _height);
      context.clearRect(0, 0, _width, _height);
      context.drawImage(image, 0, 0, _width, _height);

      // 保存绘图实例
      this.context = context;

      // 获取画完后的数据
      // const imgData = context.getImageData(90.4085588669868, 31.10787309215455, 1, 1);
      // console.log("drawProgressbg imgData = ", Array.prototype.slice.call(imgData?.data || [], 0));
      // const imgData = context.getImageData(192.8, 239.8, 1, 1);
      // console.log("drawProgressbg imgData = ", Array.prototype.slice.call(imgData?.data || [], 0));
    };
    
    return;
  },
  // 初始化canvas的尺寸
  initCanvasSize () {
    // canvas的长和宽
    let {widthRpx, heightRpx, multip, padL} = this.data.canvas || {};
    // 取得px的宽和高
    let _realWidth = parseInt((widthRpx + padL) / multip);
    let _realHeight = parseInt((heightRpx + padL) / multip);
    // 赋最小值 保证是个圆
    _realWidth = _realHeight = Math.min(_realWidth, _realHeight);
    // let _r = (widthRpx) / 2 / multip;
    let _centerX = _realWidth / 2;
    return {
      r: _centerX,
      centerX: _centerX,
      centerY: _centerX,
      padLReal: (padL / 2 / multip)
    }
  },
  // drawOldDetail (ctxs, config) {

  //   let {widthRpx, heightRpx, multip, padLReal} = config || {};
    
  //   // 使用 wx.createContext 获取绘图上下文 context
  //   var ctx = ctxs || wx.createCanvasContext('lightCanvas', this);
  //   // 清除
  //   ctx.clearRect(0, 0, width || 0, height || 0);

  //   ctx.beginPath(); // 开一条新路
  //   ctx.drawImage("device/img/light/bg.png", padLReal, padLReal, (widthRpx) / multip, (heightRpx) / multip);
  //   ctx.draw();
  //   ctx.closePath();
  // },
  touchNone () {
    return;
  },
  touchStart (e) {
    // let _position = this.getPosition(e);
    // console.log("touchStart e = ", _position);
    // 保存之前的角度，如果幅度小于1，则不获取
    let _position = this.getPosition(e);
    let {angle} = this.getPositionByX(_position);
    this.data.lastAngle = angle;
    console.log("touchStart angle, this.data.canvas = ", angle, this.data.canvas);
  },
  touchMove (e) {
    this.dealTouchRgb(e);
  },
  dealTouchRgb (e) {
    let _position = this.getPosition(e);
    let {x, y, angle} = this.getPositionByX(_position);

    // 如果角度相差小于1，则不移动
    if (Math.abs(angle - this.data.lastAngle) < 1) {
      return;
    }
    // 保存上一次的角度值
    this.data.lastAngle = angle;

    // 取得canvas的rgb
    this.getImageData(angle, x, y, (rgbData, sendData) => {
      let data = this.dealRgbPanel(rgbData);
      // console.log("getImageData data = ", data, rgbData);
      if (!data) {
        return;
      }
      this.data.thumb.bgColor = 'rgb('+data[0]+','+data[1]+','+data[2] + ')';
      // this.data.thumb.bgColor = 'rgba('+data[0]+','+data[1]+','+data[2]+','+data[3]+')';
      this.data.thumb.x = x;
      this.data.thumb.y = y;
      // this.data.thumb.angle = angle;

      this.setData({
        thumb: this.data.thumb
      })

      let _enumIdx = this.data.devStatus.enumIdx;
      let _commonColors = this.data.commonColors || [];
      console.log("_enumIdx = ", _enumIdx);
      // 保存颜色
      if (_enumIdx >= 0 && _commonColors[_enumIdx]) {
        let _colorStr = '#' + data[0].toString(16).padStart(2, '0') + data[1].toString(16).padStart(2, '0') + data[2].toString(16).padStart(2, '0');
        (_commonColors[_enumIdx] || {}).color = _colorStr;
        this.setData({
          commonColors: this.data.commonColors
        });
      }

      if (!this.data.abilitys.gradient) {
        return;
      }
      console.log("touchMove e, new = ", x, y, angle); 
      // 每隔1s发送一次
      let _time = this.data.sendTime;
      let _newTime = Date.now();
      let _sendRGB = sendData || this.dealRgbSend(data);
      // 判断批量个数
      let _lengthBatch = (this.data.groupIds || []).length;
      let _timeCount = _lengthBatch > 5 ? (Math.ceil(_lengthBatch / 5) * (200 + 30)) : 250;
      if (!_time || (_newTime - _time) > _timeCount) {
        // , 1
        this.actDev({
          pwr: 1, // 固定
          brightness: 127, // 固定
          r: _sendRGB[0],
          g: _sendRGB[1],
          b: _sendRGB[2],
          c: 0xff,
          w: 0xff,
          rgbPwr: 1, // 固定
          rgbBrightness: 0 // 固定
        }, {
          noRemote: true,
          // sendTime: 150
        })
        this.data.sendTime = _newTime;
      }
    });
  },
  touchEnd (e) {
    console.log("touchEnd");
    let _position = this.getPosition(e);
    let {x, y, angle} = this.getPositionByX(_position);
    // 保存角度
    this.data.devStatus.angle = angle;
    // 清空
    this.data.lastAngle = undefined;
    // 取得canvas的rgb
    this.getImageData(angle, x, y, (rgbData, sendData) => {
      // console.log("touchEnd getImageData rgbData = ", rgbData);
      let data = this.dealRgbPanel(rgbData);
      if (!data) {
        return;
      }
      let _colorStr = '#' + data[0].toString(16).padStart(2, '0') + data[1].toString(16).padStart(2, '0') + data[2].toString(16).padStart(2, '0');
      console.log("_colorStr = ", _colorStr);

      this.data.thumb.bgColor = 'rgb('+data[0]+','+data[1]+','+data[2] + ')';
      this.data.thumb.x = x;
      this.data.thumb.y = y;
      this.setData({
        thumb: this.data.thumb
      })

      // 保存颜色
      this.data.devStatus.angleColor = _colorStr;

      let _enumIdx = this.data.devStatus.enumIdx;
      let _commonColors = this.data.commonColors || [];
      // 保存颜色
      if (_enumIdx >= 0 && _commonColors[_enumIdx]) {
        (_commonColors[_enumIdx] || {}).color = _colorStr;
        this.setData({
          commonColors: this.data.commonColors
        });
      }
      
      let _sendRGB = sendData || this.dealRgbSend(data);
      // 发送命令
      this.actDev({
        pwr: 1, // 固定
        brightness: 127, // 固定
        r: _sendRGB[0],
        g: _sendRGB[1],
        b: _sendRGB[2],
        c: 0xff,
        w: 0xff,
        rgbPwr: 1, // 固定
        rgbBrightness: 0 // 固定
      })
    });
  },
  getRgbByAngle (angle) {
    return bizUtil.getRgbByAngle(angle);
  },
  // 取得canvas的色素
  getImageData (angle, x, y, callBack) {
    if (!this.context) {
      return !!callBack && (callBack([]));
    }
    // // 获取画完后的数据
    // var imgData = this.data.context.getImageData(90.4085588669868, 31.10787309215455, 1, 1);
    // console.log("drawProgressbg imgData = ", Array.prototype.slice.call(imgData?.data || [], 0));

    // 次数需要减去圆环到父层的距离
    let _seperator = this.data.canvas.padLReal;

    console.log("getImageData x - _seperator, _seperator, x = ", x - _seperator, _seperator, x, this.data.canvas);

    // 图片数据
    let {data} = this.context.getImageData((x - _seperator), y, 1, 1) || {};
    console.log("getImageData data, x, y = ", Array.prototype.join.call(data, ','), x, y);
    if (!data || data.length < 4) {
      return !!callBack && (callBack([]));
    }
    // 根据角度取得色值
    let _sendData = this.getRgbByAngle(angle);
    // 返回数据
    !!callBack && (callBack(data, _sendData));
    return;

    // wx.canvasGetImageData({
    //   canvasId: "lightCanvas",
    //   x: x,
    //   y: y,
    //   width: 1,
    //   height: 1,
    //   success: (res) => {
    //     let {data} = res || {};
    //     if (!data || data.length < 4) {
    //       return;
    //     }
    //     // 根据角度取得色值
    //     let _sendData = this.getRgbByAngle(angle);
    //     // 返回数据
    //     !!callBack && (callBack(data, _sendData));
    //   },
    //   fail: (res) => {
    //     console.error("getImageData res = ", res);
    //   }
    // });
  },
  getPosition (e) {
    let {changedTouches, touches} = e;
    let {pageX, pageY} = this.data.canvas;
    let _item = (changedTouches || touches)[0];
    return {
      x: ((_item.pageX - (pageX || 0)) || _item.clientX),
      y: ((_item.pageY - (pageY || 0)) || _item.clientY) 
    }
  },
  getPositionByAngle (degree) {
    let {centerX, centerY, r, padLReal, multip} = this.data.canvas;

    // 左侧需要减去圆环的一半长度，右侧需要加上圆环的一半长度
    let _r = r - padLReal - (40 / 2 / multip);

    console.log("getPositionByAngle r = ", r);
    // let {thumb} = this.data.thumb
    let x = Math.cos(degree / 180 * Math.PI) * (_r);
    let y = Math.sin(degree / 180 * Math.PI) * (_r);
    let _isRight = !(degree >= 90 && degree < 270);
    let _isDown = !(degree >= 0 && degree < 180);
    // 绘制canvas的时候需要有半个宽度的补偿值 76是thumb的宽度 先这样写吧
    let _buchang = 0; // circleWidth / 2 - (76 / 2 / this.data.canvas.multip);
    return {
      x: centerX + _buchang + Math.abs(x) * (_isRight ? 1 : -1),
      y: centerY + _buchang + Math.abs(y) * (_isDown ? 1 : -1),
    };
  },
  // 根据x,y坐标取得角度
  getAngleByPosition (x, y) {
    // 半径
    let {centerX, centerY} = this.data.canvas;
    let _isRight = x >= centerX;
    let _isDown = y >= centerY;
    // 需要减去中心点坐标
    let _realX = Math.abs(x - centerX);
    let _realY = Math.abs(y - centerY);
    // _angle大于0
    let _angle = 0;
    if (_realX == 0) {
      _angle = _isDown ? 270 : 90;
    } else {
      let _originAngle = Math.atan(_realY / _realX) * 180 / Math.PI;
      _angle = Math.abs(_originAngle);
      // tan(90+a)=tan(90-a) 忽略正负
      // tan(180+a)=tan(a)
      // tan(27+a)=tan(90-a) 忽略正负
      if (_isRight) {
        // 第四和一象限
        _angle = _isDown ? (360 - _angle) : (_angle);
      } else {
        // 第三和二象限
        _angle = _isDown ? (180 + _angle) : (180 - _angle);
      }
      // console.log("_originAngle, _angle = ", _originAngle, _angle);
    }
    return _angle;
  },
  // 根据x，y轴坐标取得x轴对应的y坐标
  getPositionByX (position) {
    // 座标
    let {x, y} = position;

    console.log("getPositionByX x, y = ", x, y);
    // 座标不能直接处理，需要减去padding再去和canvas的尺寸计算
    // 半径
    let {r, centerX, centerY, padLReal, multip} = this.data.canvas;

    // 左侧需要减去圆环的一半长度，右侧需要加上圆环的一半长度
    let _r = r - padLReal - (40 / 2 / multip);
    
    let _isRight = x >= centerX;
    let _isDown = y >= centerY;
    // 取得角度
    let _tanDegree = Math.round(this.getAngleByPosition(x, y));
    // 根据半径和角度取得实际的x和y
    let _x = _r * Math.cos(_tanDegree * Math.PI / 180);
    let _y = _r * Math.sin(_tanDegree * Math.PI / 180);
    return {
      x: centerX + Math.abs(_x) * (_isRight ? 1 : -1),
      y: centerY + Math.abs(_y) * (_isDown ? 1 : -1),
      angle: _tanDegree
    }
  },
  forbidenMove () {
    console.log("forbidenMove");
  },

  plusStart () {
    this.dealLongTapStart(false);
  },
  dealLongTapStart (isDel) {
    // 防止两个手指重复按下
    if (this.data.rgbDown || this.data.rgbUp) {
      return;
    }
    // 默认长按
    this.data.isLongTap = true;
    // 记住按下时间
    this.data.timeStamp = Date.now();
    // 按下的按钮标识
    let _updateObj = isDel ? {rgbDown: true, rgbUp: false} : {rgbUp: true, rgbDown: false};
    this.data.rgbDown = _updateObj.rgbDown;
    this.data.rgbUp = _updateObj.rgbUp;
    this.setData(_updateObj);
    // 定时器检查是长按还是短按
    setTimeout(() => {
      // 是否长按标志
      if (!this.data.isLongTap) {
        return;
      } else {
        // 初始化定时器
        this.dealLongTap();
      }
    }, 800);
  },
  // 长按事件
  dealLongTap () {
    // 清理定时器
    this.clearTimer(this.data.timer);
    // 初始化定时器
    this.data.timer = setInterval(() => {
      if (!this.data.timer) {
        return;
      }
      console.log("dealLongTap");
      this.dealAngle(!this.data.rgbUp ? -1 : 1, true);
    }, 300);
  },
  plusEnd () {
    console.log("plusEnd");
    this.dealTouchEnd(false);
  },
  dealTouchEnd (isDel) {
    // 清除定时器
    this.clearTimer(this.data.timer);
    // 恢复按钮
    let _updateObj = {rgbDown: false, rgbUp: false};
    this.setData(_updateObj);
    // 判断短按还是长按
    let _now = Date.now();
    console.log("_now - this.data.plusTime = ", _now - this.data.timeStamp);
    if ((_now - this.data.timeStamp) < 700) {
      // 是否长按标志
      this.data.isLongTap = false;
      // 认为是点击事件
      this.dealAngle(!isDel ? 1 : -1, true);
      // !!this.data.rgbUp ? (this.addAngle()) : (this.delAngle());
    } else {
      // 是否长按标志
      this.data.isLongTap = false;
    }
  },
  minusStart () {
    this.dealLongTapStart(true);
  },
  minusEnd () {
    console.log("minusEnd");
    this.dealTouchEnd(true);
  },
  clearTimer (timer) {
    bizUtil.clearTimer(timer, "interval");
  },


  // 新的代码
  typeClick (e) {
    let _index = e.currentTarget.dataset.index;
    if (_index == this.data.devStatus.typeIdx) {
      return;
    }
    // 更新选中的标签
    this.data.devStatus.typeIdx = _index;
    let {brightness, rgbBrightness, brightnessP, rgbBrightnessP} = this.data.devStatus || {};
    // 更新亮度百分比
    console.log("typeClick this.data.devStatus, _index = ", this.data.devStatus, _index);
    this.data.brightSliders.percent = (_index ? (brightnessP || (brightness / 1.27)) : (rgbBrightnessP || (rgbBrightness / 1.27))) || 100;
    this.setData({
      devStatus: this.data.devStatus,
      brightSliders: this.data.brightSliders
    })
  },

  getAllCommonParams () {
    return {
      r: 0xff,
      g: 0xff,
      b: 0xff,
      c: 0xff,
      w: 0xff
    }
  },
  // 全开
  allOpen () {
    let _params = Object.assign({
      pwr: 1,
      brightness: this.data.devStatus?.brightness || 127,
      rgbPwr: 1,
      rgbBrightness: this.data.devStatus?.rgbBrightness || 127
    }, this.getAllCommonParams());
    this.actDev(_params);
  },
  // 全关
  allClose () {
    let _params = Object.assign({
      brightness: 0,
      rgbBrightness: 0
    }, this.getAllCommonParams());
    this.actDev(_params);
  },

  jumpDevDetailPage () {
    // 跳转详情页面
    ability.navigateTo("/device/light/devProperty/index?remote=" + (this.data.abilitys?.remote || 0))
  }
})
