import {cw as CW, rgb as RGB, w as W} from "../../jsConfig/mode"
import ability from "../../../utils/classDef/ability"
import bizUtil from "../../../utils/bizUtil"
const app = getApp();
Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "模式"
      }
    },
    modeList: RGB,
    customList: [], // 情景模式
    cwList: [], // 色温模式

    selectIndex: -1,
    bleUnavailable: false,
    bleModeData: {}, // 保存的模式
    supportSleep: false,
    supportMode: true,
    minVal: -1, // 最小值

    // 1024 默认没有
    cw: 0,
    // cw灯的渐变跳变能力 默认没有
    cwGradient: 0,
    // 亮度值
    brightness: 127,
    // 是否支持cw明暗调节
    cAndcwWhite: 0, 
  },
  onLoad (options) {
    console.log("options = ", options);
    // 取得是否支持睡眠模式
    let _sleep = options.sleep || 0;
    this.data.supportSleep = _sleep == 1;
    // 是否支持渐变等模式
    this.data.supportMode = (options.mode == 1);
    // 1024灰度 这里偷懒了，之前这个字段是cw的，后面改了协议变成了1024灰度字段，这里只改了值，传的参数名称没改
    this.data.cw = Number(options.cw) || 0;
    // cw灯的渐变跳变能力
    this.data.gradient = Number(options.gradient) || 0;
    // 最小值
    this.data.minVal = ((options.min != undefined) ? parseInt(options.min) : 2);
    // 亮度值
    this.data.brightness = ((options.brightness != undefined) ? Number(options.brightness) : 127);
    this.data.cAndcwWhite = Number(options?.cAndcwWhite) || 0; 
    // 取得缓存的数据
    app.globalData.bleModes = app.getStorageByKey("modes") || {};
    // 如果不是单设备，则隐藏
    this.initCustomList();
    // 初始化模式页面
    this.initModeList();
    // 初始化色温模式
    this.initCwGradient();
  },
  initCwGradient () {
    let _t = [];
    // cw支持渐变调节
    if (!!this.data.gradient) {
      _t = CW;
    }
    if (!!this.data.cAndcwWhite) {
      // 支持明暗调节
      _t = _t.concat(W);
    }
    this.data.cwList = _t;
    this.setData({
      cwList: this.data.cwList
    })
  },
  initModeList () {
    this.setData({
      modeList: this.data.supportMode ? RGB : []
    })
  },
  initCustomList () {
    // 取得睡眠能力 !!app.globalData.devInfo && 
    let _list = (this.data.supportSleep) ? [{
      name: "睡眠",
      key: "c_wake",
      mode: {
        delay: 0,
        start: 37,
        interval: 60,
        step: -1,
        count: 37,
        cold: 55,
        warm: 200
      }
    }, {
      name: "夜灯", // "起床"
      key: "c_sleep",
      mode: {
        delay: 0,
        start: this.data.minVal >= 0 ? (parseInt(this.data.minVal) || 2) : 2, // lowBrightLimit
        interval: 60,
        step: 1,
        count: 30,
        cold: 55,
        warm: 200
      }
    }, {
      name: "工作",
      key: "c_work",
      mode: {
        delay: 0,
        start: 80,
        interval: 60,
        step: 1,
        count: 20,
        cold: 255,
        warm: 0
      }
    }, {
      name: "阅读",
      key: "c_read",
      mode: {
        delay: 0,
        start: 80,
        interval: 60,
        step: 1,
        count: 20,
        cold: 128,
        warm: 127
      }
    }, {
      name: "休闲",
      key: "c_relax",
      mode: {
        delay: 0,
        start: 50,
        interval: 60,
        step: 1,
        count: 17,
        cold: 128,
        warm: 127
      }
    }, /*{
      name: "烛光",
      key: "c_light",
      mode: {
        delay: 0,
        start: this.data.minVal >= 0 ? this.data.minVal : 30,
        interval: 60,
        step: 1,
        count: 30,
        cold: 55,
        warm: 200
      }
    } {
      name: "",
      key: "c_null"
    }*/] : [];
    console.log("_list = ", _list.length);
    this.data.customList = _list;
    this.setData({
      customList: _list
    })
  },
  // selectMode (e) {
  //   console.log('selectMode:', e);
  //   if (this.data.selectIndex === e.currentTarget.dataset.index) {
  //     console.log('相等了');
  //     ability.navigateTo("../modeSet/index");
  //   } else {
  //     this.setData({
  //       selectIndex: e.currentTarget.dataset.index
  //     })
  //   }
  // },

  onShow () {
    console.log("onShow app.globalData.bleModes = ", app.globalData.bleModes);
    // 取得配置数据
    this.data.bleModeData = app.globalData.bleModes || {};
    // 为了影响最少代码，所以在发送的时候去真实的倍数
    // 初始化数组
    // this.initModeList();
  },
  // initModeList () {
  //   for (let item of modes) {

  //   }
  // },
  // 同步取得数据
  getStorageByKey (key) {
    return ability.getStorage({
      key: key
    }, true);
  },

  itemClick (item, isCW) {
    if (!item) {
      console.error("itemClick item = ", item);
      return;
    }
    // 设备信息
    let _devInfo = app.globalData.devInfo;
    let _roomInfo = app.globalData.roomInfo;
    // 判断比例
    let _storageInfo = this.data.bleModeData[item.key];
    if (_storageInfo != undefined) {
      item.mult = _storageInfo / item.defaultTime;
    }

    // 设置是否支持1024灰度 默认不支持
    let _huidu1024 = Number(this.data.cw) || 0;
    // if (_devInfo) {
    //   _huidu1024 = Number(this.data.cw) || 0;
    // }
    item.huidu1024 = _huidu1024;

    // // 增加逻辑，如果是临时组控制
    // if (app.globalData.tgroupId) {

    //   // 取得临时组id
    //   let _tmpGroupId = app.globalData.blsdk.createTGroupId();

    //   // 如果是临时组控制
    //   if (_tmpGroupId == app.globalData.tgroupId) {
    //     app.globalData.blsdk.sceneControlWithDevice(_devInfo, app.globalData.tgroupId, item);
    //     return;
    //   }
    // }

    // 增加逻辑：如果是房间的色彩控制，需要先发送一个全关的命令
    let _isRoomControl = !_devInfo;
    if (_isRoomControl) {
      let _roomId = _roomInfo?.id || 0;

      // 如果有临时群组
      if (app.globalData.tgroupId) {
        _roomId = app.globalData.tgroupId;
      }

      // 更新发送的命令
      let _jsonData = bizUtil.getModeParamsBeforeSet(item, this.data.brightness);
      
      console.log("itemClick _jsonData, item = ", _jsonData, item);

      // 先发送全关的命令
      let _result = app.globalData.blsdk.groupControlWithType(undefined, _roomId, _jsonData, {
        noRemote: true, // 不发远程控制命令
        timestamp: 500 // 500ms
      });
      // 如果发送结果是promise的，则继续调用
      if (_result && _result.then) {
        _result.then((res) => {
          app.globalData.blsdk.sceneControlWithDevice(_devInfo, !!_devInfo ? undefined : _roomId, item);
        })
      } else {
        app.globalData.blsdk.sceneControlWithDevice(_devInfo, !!_devInfo ? undefined : _roomId, item);
      }
    } else {
      app.globalData.blsdk.sceneControlWithDevice(_devInfo, !!_devInfo ? undefined : _roomInfo.id, item);
    }
  },
  delayTap (e) {
    let _idx = e.currentTarget.dataset.index;
    let _item = this.data.customList[_idx] || {};
    let _mode = _item.mode;
    if (!_mode) {
      // 没有数据
      return;
    }
    this.setData({
      selectIndex: _idx + 100
    })
    console.log('delayTap devInfo, roomId = ', app.globalData.devInfo, (app.globalData.roomInfo || {}).id);

    if (app.globalData.tgroupId) {
      // 临时组控制
      return app.globalData.blsdk.delayCtrl(app.globalData.tgroupId, _mode);
    }

    // 判断是否群组控制还是单个设备控制
    app.globalData.blsdk.delayCtrl(app.globalData.devInfo || ((app.globalData.roomInfo || {}).id || 0), _mode);
  },
  taps (e) {
    let _idx = e.currentTarget.dataset.index;
    let _item = this.data.modeList[_idx];
    this.setData({
      selectIndex: _idx
    })
    this.itemClick(_item);
  },
  cwTaps (e) {
    let _idx = e.currentTarget.dataset.index;
    let _item = this.data.cwList[_idx];
    console.log("cwTaps _idx, _item = ", _idx, _item);
    this.data.selectIndex = Number(_idx) + 200;
    this.setData({
      selectIndex: this.data.selectIndex
    })
    this.itemClick(_item, true);
  },
  cwLongTap (e) {
    // 取得点击的模式按钮
    let _index = e.currentTarget.dataset.index;
    // 未选中，则推出
    if (this.data.selectIndex < 0 || this.data.selectIndex != (_index + 200)) {
      return;
    }
    
    let _item = this.data.cwList[_index];
    // 取得之前保存的值
    let _value = app.globalData.bleModes[_item.key];
    // 默认值
    let _val = _value != undefined ? _value : ((_item.defaultTime || 100) * (_item.mult || 0.2));
    // 颜色值
    let _cw = encodeURIComponent(JSON.stringify(_item.mode));
    // 保存设备状态
    ability.navigateTo("../modeSet/index?keystr=" + _item.key + "&val=" + _val + "&name=" + encodeURIComponent(_item.name) + "&mode=" + _cw + "&isCW=1&huidu=" + (Number(this.data.cw) || 0) + "&brightness=" + this.data.brightness);
  },
  longTap (e) {
    // 取得点击的模式按钮
    let _index = e.currentTarget.dataset.index;
    // 未选中，则推出
    if (this.data.selectIndex < 0 || this.data.selectIndex != _index) {
      return;
    }
    
    let _item = this.data.modeList[_index];
    // 取得之前保存的值
    let _value = app.globalData.bleModes[_item.key];
    // 默认值
    let _val = _value != undefined ? _value : ((_item.defaultTime || 100) * (_item.mult || 0.2));
    // 颜色值
    let _rgb = encodeURIComponent(JSON.stringify(_item.mode));
    // 保存设备状态
    ability.navigateTo("../modeSet/index?keystr=" + _item.key + "&val=" + _val + "&name=" + encodeURIComponent(_item.name) + "&mode=" + _rgb + "&huidu=" + (Number(this.data.cw) || 0) + "&brightness=" + this.data.brightness);
  }
})
