const ability = require("../../../utils/classDef/ability");
const app = getApp();
const bizUtil = require("../../../utils/bizUtil")
// device/panel/configDetail/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "面板选择"
      }
    },
    sceneList: [],
    sceneIndex: -1,
    roomChanged: false, // 是否弹出选择房间
    rooms: [],
    roomInfo: {
      id: 0, // 默认全屋
      n: '全屋'
    },
    keyIndex: 0, // 按键

    isBindSid: -1, // 是否绑定
    isBindRid: -1, // 绑定的场景房间

    // 发送时唤醒文案配置
    showSaveDialog: false,
    sendingConfig: {
      devTypeStr: 'uart' // 超级面板使用面板的低功耗弹窗提示
    }
  },

  setProperValue (key, val) {
    if (this.data == undefined) {
      return;
    }
    // this.data[key] = val;
    this.setData({
      [key]: val
    })
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    let {key, sid, rid, type, lowPower, keyStr} = options;
    this.data.keyIndex = Number(key) || 0;
    this.data.isBindSid = sid == undefined ? -1 : (Number(sid) || 0);
    this.data.isBindRid = rid == undefined ? -1 : (Number(rid) || 0);
    this.bindType = type;
    this.keyStr = keyStr || "";

    this.initRooms();
    // 根据传入的数据显示默认的房间信息
    this.initRoomInfoByData(this.data.isBindRid);
    this.initListByRoom(this.data.isBindSid, keyStr);
    // 初始化按钮
    this.initActions();
  },
  initRoomInfoByData (roomId) {
    let _roomInfo = undefined;
    if (roomId != undefined) {
      let _roomDetail = app.globalData.devs[roomId];
      if (!!_roomDetail) {
        _roomInfo = {
          id: _roomDetail.id,
          n: this.getFloorName(_roomDetail.id) + _roomDetail.n
        };
      }
    } 
    // 默认数据
    _roomInfo = _roomInfo || {
      id: 0, // 默认全屋
      n: '全屋'
    };
    // this.data.roomInfo = _roomInfo;
    this.setData({
      roomInfo: _roomInfo
    })
  },

  initActions () {
    // 所有数据
    let _allList = this.getAllActions();
    this.setProperValue("actions", this.data.isBindSid >= 0 ? _allList : [_allList[1]]);
  },
  getAllActions () {
    return [{
      name: "解绑",
      classStr: 'delBtn',
      handles: "unbindPanel"
    }, {
      name: "绑定",
      classStr: 'saveBtn',
      handles: "bindPanel"
    }]
  },

  // 初始化房间
  initRooms () {
    // 所有设备
    let _allDevs = app.globalData.devs || {};
    // 取得房间信息
    let {rooms} = bizUtil.getRoomsByDevs(_allDevs);
    // let {rooms} = bizUtil.getRoomsByDevs(_devs);
    this.data.rooms = rooms.sort((a, b)=>{
      let _floorA, _floorB = 0;
      if (a.id % 32 == 0) {
        _floorA = Math.round(a.id / 32) - 1;
      } else {
        _floorA = parseInt(a.id / 32);
      }
      if (b.id % 32 == 0) {
        _floorB = Math.round(b.id / 32) - 1;
      } else {
        _floorB = parseInt(b.id / 32);
      }
      return (_floorA * 50 + a.id % 32)-(_floorB * 50 + b.id%32);
    });
    this.setData({
      rooms: this.data.rooms
    })
  },
  initListByRoom (sid, keyStr) {
    let _roomInfo = this.data.roomInfo;
    let _roomId = _roomInfo.id || 0;
    console.log("initListByRoom keyStr = ", keyStr)
    if (keyStr == "scene") {
      this.data.sceneList = (app.globalData.devs[_roomId] || {}).scenes || [];
      // 取得选中场景
      let _sceneIndex = this.data.sceneList.map(item => item.sid).indexOf(sid);
      if (_sceneIndex >= 0) {
        this.data.sceneIndex = _sceneIndex;
      }
    } else if (keyStr == "light" || keyStr == "curtain" || keyStr == "switch") {
      let _realKey = keyStr == "switch" ? 'panel' : keyStr;
      let {devs, groups} = bizUtil.getDevsAndGroupsByRoomId(_roomId, app.globalData.devs);
      this.data.sceneList = (devs || []).filter(item => {
        let _isFilter = _realKey == "panel" ? bizUtil.isPwrAvalibleDev(item.t) : true;
        return bizUtil.getDevTypeStr(item.t) == _realKey && _isFilter;
      });
    }
    console.log("initListByRoom this.data.sceneList = ", this.data.sceneList)
    this.setData({
      sceneList: this.data.sceneList,
      sceneIndex: this.data.sceneIndex
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  selectScene (e) {
    let {index} = e.currentTarget.dataset;
    // // 判断之前是否选中
    // if (index == this.data.sceneIndex) {
    //   this.data.sceneIndex = -1;
    // } else {
    //   this.data.sceneIndex = index;
    // }
    // index == this.data.sceneIndex ? -1 : index
    this.setSceneIndex(index)
  },

  setSceneIndex (value) {
    this.setProperValue("sceneIndex", value || 0);
  },

  // 根据房间id取得楼层名称
  getFloorName (_roomId) {
    let _name = "";
    // 是否多楼层
    if ((_roomId % 32 != 0) && app.globalData.familyInfo?.floor >= 0) {
      // 多楼层
      let _floorName = app.globalData.devs[_roomId + 32 - _roomId % 32]?.n;
      _floorName && (_name = _floorName + " | ");
    }
    return _name;
  },

  chooseRoom (e) {
    let {index} = e.currentTarget.dataset;
    let _roomInfo = this.data.rooms[index || 0] || {};

    // 同一个房间
    if (this.data.roomInfo.id == _roomInfo.id) {
      return;
    }
    // 默认选择第一个
    this.data.sceneIndex = 0;

    let _roomId = _roomInfo.id;
    this.data.roomInfo.n = this.getFloorName(_roomId) + _roomInfo.n;
    this.data.roomInfo.id = _roomId;

    this.setData({
      sceneIndex: this.data.sceneIndex,
      roomInfo: this.data.roomInfo
    });
    // 隐藏
    this.hidePop();
    // 显示对应的房间信息
    this.initListByRoom(this.data.isBindSid, this.keyStr);
  },
  showPop () {
    this.hidePop(true);
  },
  closePop () {
    this.hidePop();
  },
  hidePop (isOpen) {
    this.data.roomChanged = isOpen || false;
    this.setData({
      roomChanged: this.data.roomChanged
    })
  },

  unbindPanel () {
    // 未选择场景且没有绑定过
    if (this.data.isBindSid < 0) {
      return this.back();
    }
    // 提示等待中
    this.showLoading('解绑中…');
    let _sid = this.data.isBindSid;
    let _rid = this.data.isBindRid || 0;
    let {a, ds, t} = app.globalData.devInfo || {};
    // // 判断是否耦合的设备
    // let _isUncoupleMetapad = bizUtil.isUncoupleMetapad(t);
    console.log("unbindPanel this.data.keyIndex, a = ", this.data.keyIndex, a);

    // 恢复至默认情景
    app.globalData.blsdk.resetPannelBindCommandWithShortAddr(a, this.data.keyIndex, (result) => {
      console.log("next result = ", result);
      this.hideLoading();
      let _str = "";
      if (result < 0 || result === false || result == undefined || result.errCode) {
        _str =  '解绑失败';
      } else {
        _str =  '解绑成功';
        // 数据赋值
        this.data.sceneIndex = -1;

        console.log("unbindPanel ds = ", ds);
        if (ds?.length) {
          // 非耦合
          if (bizUtil.isUncoupleMetapad(t)) {
            console.log("unbindPanel isUncoupleMetapad");
            // 非耦合设备 解绑
            app.globalData.devInfo.ds = ds.filter(item => item.key != this.data.keyIndex || item.type != this.bindType);
            console.log("unbindPanel ds = ", app.globalData.devInfo.ds);
          } else {
            // 耦合设备
            // 删除之前绑定的数据（超级面板中）
            this.delInArrayByKey(ds || [], this.data.keyIndex);
          }
        }

        setTimeout(() => {
          // 返回页面
          this.back();
        }, 1500);
      }
      ability.showToast({
        title: _str
      });
    }, bizUtil.getSceneId(_sid, _rid));
  },
  bindPanel () {
    let sceneIndex = this.data.sceneIndex;
    let str = "绑定中…";
    let {a} = app.globalData.devInfo || {};
    let _sceneInfo = this.data.sceneList[sceneIndex];
    // 如果不选择场景
    if (sceneIndex < 0) {
      return ability.showToast({
        title: "请选择要绑定的场景"
      });
    } else {
      // 提示等待中
      this.showLoading(str || '');
      let _sid = _sceneInfo.sid;
      let _rid = _sceneInfo.rid || 0;

      // 更新场景
      app.globalData.blsdk.metapadBindDev(a, this.data.keyIndex, bizUtil.getSceneId(_sid, _rid), (result) => {
        console.log("next result = ", result);
        this.hideLoading();
        let _str = "";
        if (result < 0 || result === false || result == undefined || result.errCode) {
          _str =  '绑定失败';
        } else {
          _str =  '绑定成功';
          
          this.dealAfterSave(_sceneInfo, app.globalData.devInfo);
          setTimeout(() => {
            // 返回页面
            this.back();
          }, 1500);
        }
        ability.showToast({
          title: _str
        });
      });
    }
  },
  // 解绑成功的事件
  delInArrayByKey (array, key) {
    return bizUtil.delInArrayByKey(array, key, "key");
  },
  // 绑定成功的事件
  dealAfterSave (sceneInfo, devInfo) {
    let {keyIndex} = this.data;
    console.log("dealAfterSave sceneInfo = ", sceneInfo, devInfo, keyIndex);

    devInfo.ds = devInfo?.ds || [];

    // 非耦合不删除
    if (bizUtil.isUncoupleMetapad(devInfo?.t)) {
      console.log("dealAfterSave isUncoupleMetapad ds = ", devInfo.ds);
      // 非耦合设备 删除key和type = 0(场景)
      devInfo.ds = devInfo.ds.filter(item => item.key != keyIndex || !!item.type);
      console.log("dealAfterSave ds = ", devInfo.ds);
    } else {
      // 耦合设备
      // 删除之前绑定的数据（超级面板中）
      this.delInArrayByKey(devInfo.ds, keyIndex);
    }

    // 更新的数据  超级面板绑定场景放到场景数据中
    let _updateObj = {
      sid: sceneInfo?.sid || 0,
      rid: sceneInfo?.rid || 0,
      type: 0,
      key: keyIndex,
      cmd: 0
    };
    devInfo.ds.push(_updateObj);
  },
  addMetapadToSceneInfo (panelInfo, sceneInfo, keyIndex) {
    if (!sceneInfo || !panelInfo) {
      console.error("addMetapadToSceneInfo panelInfo, sceneInfo = ", panelInfo, sceneInfo);
      return;
    }
    sceneInfo["panels"] = sceneInfo["panels"] || [];
    // 场景信息
    sceneInfo["panels"].push({
      key: keyIndex || 0,
      d: panelInfo.d
    })
  },
  showLoading (str) {
    // 判断是否低功耗，如果是低功耗则提示唤醒，如果不是低功耗，则显示对话框
    if (this.lowPower) {
      // 是否低功耗
      this.manageDialog(true);
    } else {
      ability.showLoading({
        title: str || "",
        mask: true
      });
    }
  },
  hideLoading () {
    // 判断是否低功耗，如果是低功耗则提示唤醒，如果不是低功耗，则显示对话框
    if (this.lowPower) {
      // 是否低功耗
      this.manageDialog(false);
    } else {
      ability.hideLoading();
    }
  },
  manageDialog (value) {
    this.setData({
      showSaveDialog: value || false
    })
  },
  back () {
    ability.navigateBack();
  }
})