const ability = require("../../../utils/classDef/ability");
const bizUtil = require("../../../utils/bizUtil")
const app = getApp();
// device/metapad/chooseType/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    // typeKey: "scene", // 选择的类型key
    typeList: []
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad (options) {
    console.log("onLoad options = ", options);
    let {key, cmd, sid, rid, panelKey, type, lowPower} = options || {};
    this.key = Number(key) || 0;
    this.cmd = cmd;
    this.sid = sid;
    this.rid = rid;
    this.bindType = type;
    this.panelKey = panelKey; // 绑定继电器的第几路

    this.lowPower = lowPower; // 是否低功耗

    let _list = this.initTypeList();
    this.setData({
      typeList: _list
    })
  },

  initTypeList () {
    let _allList = this.getAllList();

    let devInfo = app.globalData.devInfo || {};
    // 判断设备耦合设备还是非耦合设备 继电器都按照耦合的设备来做
    let _isUncoupled = false; // bizUtil.isUncoupleMetapad(devInfo?.t);
    // 继电器的个数等于灯的个数
    let _config = bizUtil.getMetaTypeMad();
    // 根据能力取得配置
    let _configJson = this.getConfigByAbility(devInfo || {}, _isUncoupled, _config);
    console.log("initListByVersion _configJson = ", _configJson);

    let _result = _allList.map(item => {
      item.count = (_configJson[item.key] || 0);
      // console.log("initListByVersion key, count = ", item.key, _configJson[item.key]);
      return item;
    });
    // console.log("initListByVersion _result = ", _result);

    return _result;
  },

  // 根据ability计算出支持的设备类型以及路数
  getConfigByAbility ({v, t}, isUncoupled, config) {
    // 能力集合
    let _abilityArray = bizUtil.getAllSixAbilityByV(v);
    console.log("getConfigByAbility _abilityArray, isUncoupled = ", _abilityArray, isUncoupled);
    let _result = {};
    // 超级面板的ability为后三个字节 继电器都取后三位来判断
    // if (bizUtil.isAbilityThresMetapad(t)) {
      _abilityArray = _abilityArray.slice(3);
    // }
    // 筛选出值不为0的数据
    let _filter = _abilityArray.filter(v => v > 0);
    if (_filter.length == 0) {
      // 没有配置项，返回空
      return _result;
    }
    console.log("getConfigByAbility _filter = ", _filter);
    for (let v of _filter) {
      // 高四位是类型 低四位是路数
      let _key = (v >> 4);
      let _value = ((_key == 2) ? 2 : 1) * (v & 0x0f);
      _result[_key] = _value || 0;
    }
    // 如果是某一个特殊品类的pid,则加上特殊处理
    let _isSpecial = true; // bizUtil.isPwrLightMetapad(t);
    let _resultKeyJson = {};
    if (_isSpecial) {
      // 继电器的个数等于灯的个数
      let _config = config || bizUtil.getMetaTypeMad();
      console.log("getConfigByAbility _config = ", _config);
      let _switch = -1, _lightCount = -1;
      for (let val in _config) {
        let _devTypeStr = _config[val];
        if (_devTypeStr == "light") {
          _lightCount = val;
        } else if (_devTypeStr == "switch") {
          _switch = val;
        }
        _resultKeyJson[_devTypeStr] = _result[val];
      }
      (_result[_lightCount] > 0) && (_resultKeyJson["switch"] = _result[_lightCount]);
    }
    return _resultKeyJson;
  },

  getAllList () {
    return [{
      title: "场景",
      key: "scene",
      count: 0
    }, {
      title: "灯具",
      key: "light",
      count: 0
    }, {
      title: "窗帘",
      key: "curtain",
      count: 0
    }, {
      title: "继电器开关",
      key: "switch",
      count: 0
    }]
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  selectType (e) {
    let {index} = e.currentTarget.dataset;
    let {key} = this.data.typeList[index];
    let _url = "";
    if (key == "scene") {
      // 页面路径
      _url = "../pwrBindDetail/index?key=" + this.key + "&keyStr=" + key;
    } else {
      // &hidetab=1
      _url = "/scene/addDevice/index?from=pwrmetapad&key=" + this.key + "&devTypeStr=" + key;
    }
    console.log("selectType this.sid, this.rid = ", this.sid, this.rid, this.cmd);
    if (this.sid >= 0 && this.rid >= 0) {
      _url += "&sid=" + this.sid + "&rid=" + this.rid + "&did=" + this.cmd + "&type=" + this.bindType;
      if (this.panelKey >= 0) {
        _url += "&panelKey=" + this.panelKey;
      }
    }
    console.log("selectType _url = ", _url);
    ability.redirectTo(_url + "&lowPower=" + this.lowPower)
    // ability.navigateTo(_url)
  }
})