// device/metapad/index/index.js
import ability from "../../../utils/classDef/ability"
import bizUtil from "../../../utils/bizUtil"

const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    // 非耦合配置文件
    configList: [{
      key: "",
      // type: -1, // 通用
      hidden: false, // 是否显示
      total: 0, // 总路数
      title: "",
      tip: "",
      isOpen: true,
      list: []
    }, {
      key: "scene",
      // type: 0, // 情景面板
      hidden: false, // 是否显示
      total: 0, // 总路数
      title: "智能场景",
      tip: "待添加4个场景，已添加0个",
      isOpen: true,
      list: []
      //   {
      //   title: "1路",
      //   tip: "未配置",
      //   right: true,
      //   key: 0
      // }
    }, {
      key: "light",
      // type: 1, // 灯
      title: "照明设备",
      hidden: false, // 是否显示
      total: 0, // 总路数
      tip: "",
      isOpen: true,
      list: []
    }, {
      key: "curtain",
      // type: 2, // 窗帘
      title: "窗帘设备",
      hidden: false, // 是否显示
      total: 0, // 总路数
      tip: "",
      isOpen: true,
      list: []
    }, {
      key: "aircondition",
      // type: 4,
      title: "空调设备",
      hidden: false, // 是否显示
      total: 0, // 总路数
      tip: "",
      isOpen: true,
      list: []
    }, {
      key: "switch",
      // type: 3, // 开关
      total: 0, // 总路数
      title: "开关设备",
      hidden: true, // 是否显示
      tip: "",
      isOpen: true,
      list: []
    }]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let {title} = options || {};
    // 设备信息
    let _devInfo = app.globalData.devInfo || {};
    // 初始化设备名称
    this.initDevName(decodeURIComponent(title || "") || _devInfo.n || "");
    // 设备的ability
    this.abilitys = bizUtil.getJsonByAblitys(_devInfo?.v, bizUtil.getDevTypeStr(_devInfo?.t), {t: _devInfo?.t});
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 设备信息
    let _devInfo = app.globalData.devInfo;
    // // 初始化设备名称
    // this.initDevName(_devInfo?.n || "");
    // 初始化列表数据
    this.initListByVersion(_devInfo);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 根据ability初始化面板列表数据
  initListByVersion (devInfo) {

    // 所有设备信息
    let _allDevs = app.globalData.devs;

    // 判断设备耦合设备还是非耦合设备 继电器都按照耦合的设备来做
    let _isUncoupled = false; // bizUtil.isUncoupleMetapad(devInfo?.t);

    // 根据能力取得配置
    let _configJson = this.getConfigByAbility(devInfo || {}, _isUncoupled);
    console.log("initListByVersion _configJson = ", _configJson);

    // 取得已经绑定的场景信息
    let {typeMap, keyMap} = this.getAddedInfoByDevInfo(devInfo?.ds);
    let _addedJson = {};
    console.log("initListByVersion typeMap, keyMap = ", typeMap, keyMap);
    // 取得所有did映射的设备信息
    let {devJson, sceneJson} = bizUtil.getDidMapByConfig(_allDevs, ["devs", "scenes"]);
    console.log("initListByVersion devJson = ", devJson);
    // 取得所有房间映射信息
    let {roomJson} = bizUtil.getRoomsByDevs(_allDevs);

    // 设备通用耦合的个数 默认0个
    let _coupledCount = 0;
    if (!_isUncoupled) {
      // 耦合设备取出最小值作为公共按键，且1个窗帘当作两个按键  空调的个数不算在内
      _coupledCount = this.getConfigListByConfig(_configJson);
      // 如果是耦合的数据
      _addedJson = keyMap;
    } else {
      // 非耦合
      _addedJson = typeMap;
    }
    console.log("initListByVersion _coupledCount = ", _coupledCount);

    // 遍历数据
    for (let item of this.data.configList) {
      // 选中的数据
      let {key} = item;
      // 判断是否通用的按键
      if (key == "") {
        // 如果没有最小值，则忽略
        if (_coupledCount <= 0) {
          continue;
        }
        // 通用的按键设置
        item.type = 0;
        // 通用的路数
        item.total = _coupledCount;
        
        console.log("getListByConfig _addedJson, item = ", _addedJson, item, devJson, sceneJson);
        // 如果存在配置数据
        item.list = this.getListByConfig(item, _addedJson, {devJson, sceneJson}, roomJson, 0);
        continue;
      }
      // 根据devTypeStr取得发送的key
      let type = bizUtil.getTypeByDevTypeStr(key);
      item.type = type;
      
      // 是否空调，如果是空调，则都认为是非耦合个体
      let _isAircondition = key == "aircondition";
      console.log("initListByVersion key, type = ", key, type);
      // 配置
      let _count = _configJson[type];
      if (_count == undefined || (_count == _coupledCount && !_isAircondition)) {
        item.hidden = true;
        item.list = [];
        item.total = 0;
      } else {
        item.total = _isAircondition ? _count : (_count - _coupledCount); // 总路数
        item.hidden = false;
        item.coupledCount = _coupledCount;
        // 是否空调数据，如果是，则空调不耦合
        item.isAircondition = _isAircondition;
        // 已经配置过的数据
        let _addedJson = typeMap[type] || {};

        // 是否绑定的场景
        let _isSceneType = key == "scene";
        // 绑定的个数 这里耦合设备有个bug 需要排除耦合的按键数
        let _bindedArray = Object.keys(_addedJson) || [];
        let _bindCount = _bindedArray.filter(typeVal => typeVal >= _coupledCount).length || 0;
        item.bindCount = _bindCount;
        // 更新tip
        item.tip = "待添加" + (item.total - _bindCount) + "个" + (_isSceneType ? '场景' : '设备') + ",已添加" + (_bindCount) + "个"; 

        // 如果存在配置数据
        item.list = this.getListByConfig(item, _addedJson, _isSceneType ? sceneJson : devJson, roomJson, _coupledCount);
      }
    }
    // 更新列表
    this.setProperValue("configList", this.data.configList)
  },

  // 取得耦合设备的最小值并且重置列表
  getConfigListByConfig (configJson) {
    if (!configJson) {
      return 0;
    }
    // 取出空调的按键个数，空调都按照非耦合的做
    let _json = bizUtil.getMetaTypeMad();
    let _keys = Object.keys(_json);
    let _values = Object.values(_json);
    let _index = _values.findIndex(item => item == "aircondition");
    if (_index < 0) {
      return 0;
    }
    let _keyStr = _keys[_index];

    // // 窗帘的
    // let _curtainKey = "";
    // let _curtainIndex = _values.findIndex(item => item == "curtain");
    // if (_curtainIndex < 0) {
    //   return 0;
    // }
    // _curtainKey = _keys[_curtainIndex];

    let _configJson = Object.assign({}, configJson);
    delete _configJson[_keyStr];
    // 如果是窗帘，则按键数量乘以2
    // !!_configJson[_curtainKey] && (_configJson[_curtainKey] *= 2);
    // 取得配置的最小值 这里要取出空调的值
    let _valueArray = Object.values(_configJson);
    console.log("getConfigListByConfig _valueArray = ", _valueArray);
    if (_valueArray.length <= 1) {
      return 0;
    }
    let _minVal = Math.min.apply(null, _valueArray);
    return _minVal || 0;
  },
  
  // 根据超级面板设备信息取得已经添加的场景信息
  getAddedInfoByDevInfo (ds) {
    let _len = ds?.length || 0;
    if (!ds || _len == 0) {
      return {
        typeMap: {},
        keyMap: {}
      };
    }
    let _obj = {};
    let _keyMap = {};
    for (let i = 0; i < _len; i++) {
      let _item = ds[i];
      // 场景
      let _type = _item.type || 0;
      
      // 如果不存在type字段，则解析sid 这里主要是分享过来的数据需要处理 这里其实已经不需要了
      if (_item.type == undefined) {
        // 分享过来的
        let {rid, sid, type} = app.globalData.blsdk.getDataBySceneId(_item.sid);
        _type = type;
        _item.rid = rid;
      }

      // 按键
      let _keyNum = (_item?.key || 0) & 0xff;

      // 判断设备的品类
      _obj[_type] = _obj[_type] || {};
      _obj[_type][_keyNum] = _item;
      // 取得keymap 用于区分耦合和不耦合超级面板
      _keyMap[_keyNum] = _item;
    }

    // // 场景数据保存在
    // _obj[0] = bizUtil.getBindPanelInfoByDInJson(app.globalData.devInfo?.d, app.globalData.devs);

    return {
      typeMap: _obj,
      keyMap: _keyMap
    };
  },
  // 根据配置取得路数列表
  getListByConfig ({total, key, coupledCount, isAircondition}, addedJson, didMap, roomJson, commonCount) {
    let _result = [];
    let _count = total || 0;
    if (_count == 0) {
      return _result;
    }
    // 增加数组
    for (let i = 0; i < _count; i++) {

      // 未配置或者 名称 | 房间
      let _keyNum = (i) + (Number(commonCount) || 0);
      let _obj = {
        title: ((isAircondition ? 0 : (Number(coupledCount) || 0)) + (i + 1)) + "路", // !key ? ("按键" + (i + 1)) : 
        tip: "未配置",
        right: true,
        key: _keyNum
      };
      // 判断是否绑定过
      let _bindInfo = (addedJson || {})[_keyNum];
      if (_bindInfo) {
        // 绑定过，则取得绑定的设备或者场景或者群组的名称
        // 如果是绑定群组，那么sid = 0
        // if (key == "group") {
        //   let _groupInfo = didMap[key];
        //   _groupInfo && (_obj.tip = _groupInfo?.n + " | " + roomJson[_groupInfo.rid], _obj.d = _groupInfo?.gid);
        // } else 
        // panelKey 继电器开关的第几路
        let {sid, rid, cmd, type, pwrPanelKey} = _bindInfo;
        _obj.type = Number(type) || 0;

        // 判断是否耦合 devJson, sceneJson
        if (!type) {
          let _didMap = !key ? (didMap?.sceneJson || {}) : didMap;

          let _sceneId = bizUtil.getSceneId(sid, rid, type || 0);
          // 如果绑定场景，则sid > 0
          let _sceneInfo = _didMap[_sceneId];
          _sceneInfo && (
            _obj.tip = _sceneInfo?.n + " | " + bizUtil.getRoomNameById(roomJson, _sceneInfo.rid), 
            _obj.sid = sid, _obj.rid = rid, 
            _obj.type = type
          );
        } else {
          let _didMap = !key ? (didMap?.devJson || {}) : didMap;

          // 如果绑定的设备，则cmd是短地址
          let _devInfo = _didMap[cmd];
          console.log("getListByConfig didMap, cmd = ", didMap, cmd);
          if (!!_devInfo) {
            let {name, pwrPanelKey} = this.getExtraPwrNameAndKey(_bindInfo, _devInfo);
            _obj.tip = _devInfo?.n + name + " | " + bizUtil.getRoomNameById(roomJson, _devInfo.rid || _devInfo.id), 
            _obj.sid = sid, 
            _obj.rid = rid, 
            _obj.cmd = cmd, 
            _obj.pwrPanelKey = pwrPanelKey
          };
        }

        // if (key == "scene") {
        //   let _sceneId = bizUtil.getSceneId(sid, rid, type || 0);
        //   // 如果绑定场景，则sid > 0
        //   let _sceneInfo = didMap[_sceneId];
        //   _sceneInfo && (_obj.tip = _sceneInfo?.n + " | " + bizUtil.getRoomNameById(roomJson, _sceneInfo.rid), _obj.sid = sid, _obj.rid = rid, _obj.type = type);
        // } else {
        //   // 如果绑定的设备，则cmd是短地址
        //   let _devInfo = didMap[cmd];
        //   console.log("getListByConfig didMap, cmd = ", didMap, cmd);
        //   _devInfo && (_obj.tip = _devInfo?.n + " | " + bizUtil.getRoomNameById(roomJson, _devInfo.rid || _devInfo.id), _obj.sid = sid, _obj.rid = rid, _obj.cmd = cmd);
        // }
      }
      // console.log("getListByConfig _obj = ", _obj);
      // 加入列表
      _result.push(_obj)
    }
    return _result;
  },
  getExtraPwrNameAndKey (dsItem, devInfo) {
    let {pwrPanelKey} = dsItem || {};
    console.log("getExtraPwrName pwrPanelKey = ", pwrPanelKey);
    if (pwrPanelKey == undefined || pwrPanelKey < 0) {
      return {
        name: "",
        pwrPanelKey: undefined
      };
    }
    let _panelKey = pwrPanelKey;
    console.log("getExtraPwrName devInfo = ", devInfo);
    let _vGroups = devInfo?.e?.vGroups || [];
    let _resultStr = _vGroups[_panelKey]?.name;
    console.log("getExtraPwrName _resultStr = ", _resultStr);
    return {
      name: _resultStr ? (" " + _resultStr) : "",
      pwrPanelKey: _panelKey
    }
  },
  // 根据ability计算出支持的设备类型以及路数
  getConfigByAbility ({v, t}, isUncoupled) {
    // 能力集合
    let _abilityArray = bizUtil.getAllSixAbilityByV(v);
    console.log("getConfigByAbility _abilityArray, isUncoupled = ", _abilityArray, isUncoupled);
    let _result = {};
    // 超级面板的ability为后三个字节 继电器都取后三位来判断
    // if (bizUtil.isAbilityThresMetapad(t)) {
      _abilityArray = _abilityArray.slice(3);
    // }
    // 筛选出值不为0的数据
    let _filter = _abilityArray.filter(v => v > 0);
    if (_filter.length == 0) {
      // 没有配置项，返回空
      return _result;
    }
    console.log("getConfigByAbility _filter = ", _filter);
    for (let v of _filter) {
      // 高四位是类型 低四位是路数
      let _key = (v >> 4);
      let _value = ((_key == 2) ? 2 : 1) * (v & 0x0f);
      _result[_key] = _value || 0;
    }
    // 如果是某一个特殊品类的pid,则加上特殊处理
    let _isSpecial = true; // bizUtil.isPwrLightMetapad(t);
    if (_isSpecial) {
      // 继电器的个数等于灯的个数
      let _config = bizUtil.getMetaTypeMad();
      let _switch = -1, _lightCount = -1;
      for (let val in _config) {
        let _devTypeStr = _config[val];
        if (_devTypeStr == "light") {
          _lightCount = val;
        } else if (_devTypeStr == "switch") {
          _switch = val;
        }
      }
      (_result[_lightCount] > 0) && (_result[_switch] = _result[_lightCount]);
    }
    return _result;
  },

  // 初始化设备名称
  initDevName (name) {
    ability.setNavigationBarTitle(name);
  },
  setProperValue (key, val) {
    if (!key) {
      return;
    }
    this.data[key] = val || '';
    this.setData({
      [key]: val || ""
    })
  },
  // 点击展开
  collapeClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.configList[index];
    // 设置是否展开
    _item.isOpen = !_item.isOpen;

    let _str = `configList[${index}].isOpen`;
    // 设置属性
    this.setData({
      [_str]: _item.isOpen
    })
  },
  // 条目点击
  itemClick (e) {
    let {index, idx} = e.currentTarget.dataset;
    let {list, key, type} = this.data.configList[index] || {};
    let _itemInfo = (list || [])[idx] || {};
    // 跳转到对应的页面
    console.log("itemClick _itemInfo, key = ", _itemInfo, key);

    // 是否低功耗
    let _lowPowerNum = Number(this.abilitys?.lowPower) || 0;
    let _extendStr = "&lowPower=" + _lowPowerNum;
    
    // 判断是否绑定
    // if (!key) {
      let _url = "?from=metapad&key=" + _itemInfo.key;
      if (_itemInfo.sid >= 0) {
        _url += ("&cmd=" + _itemInfo.cmd + "&sid=" + _itemInfo.sid + "&rid=" + _itemInfo.rid + "&type=" + _itemInfo.type);
        if (_itemInfo.pwrPanelKey >= 0) {
          _url += "&panelKey=" + _itemInfo.pwrPanelKey
        }
      }
      ability.navigateTo("../pwrBindType/index" + _url + _extendStr);
      return;
    // }

    // // 判断是否绑定过
    // if (key == "scene") {
    //   // 页面路径
    //   let _url = "?from=metapad&key=" + _itemInfo.key;
    //   // 判断是否绑定
    //   if (_itemInfo.sid >= 0) {
    //     _url += ("&sid=" + _itemInfo.sid + "&rid=" + _itemInfo.rid + "&type=" + _itemInfo.type);
    //   }
    //   // 跳转到场景绑定页面
    //   ability.navigateTo("/device/metapad/configDetail/index" + _url + _extendStr);
    //   // // 如果没有绑定过，则判断是否跳转选择品类页面
    //   // if (!_key) {
    //   //   ability.navigateTo("../chooseType/index" + _url);
    //   // } else {}
    // } else {
    //   // &hidetab=1
    //   let _url = "?from=metapad&key=" + _itemInfo.key + "&devTypeStr=" + key;
    //   // 判断是否绑定
    //   if (!!_itemInfo.cmd) {
    //     _url += ("&did=" + _itemInfo.cmd + "&sid=" + _itemInfo.sid + "&rid=" + _itemInfo.rid + "&type=" + _itemInfo.type);
    //     if (_itemInfo.panelKey >= 0) {
    //       _url += "&panelKey=" + panelKey
    //     }
    //   }
    //   // 跳转到设备绑定页面
    //   ability.navigateTo("/scene/addDevice/index" + _url + _extendStr);
    // }
  },
  // // 跳转详情页面
  // jumpMetaDetail () {
  //   console.log("jumpMetaDetail");
  //   // 是否低功耗
  //   let _lowPowerNum = Number(this.abilitys?.lowPower) || 0;
  //   let _extendStr = "&lowPower=" + _lowPowerNum;
  //   ability.navigateTo("/device/light/devProperty/index?remote=0" + _extendStr);
  // },

  // topClick (e) {
  //   let {index} = e.currentTarget.dataset;
  //   let {key} = this.data.topList[index] || {};
  //   if (key == "detail") {
  //     this.jumpMetaDetail();
  //   } else if (key == "backlight") {
  //     // 背光灯设置
  //     ability.navigateTo("/device/panel/backlight/index")
  //   }
  // }
})