import ability from "../../../utils/classDef/ability"
import bizUtil from "../../../utils/bizUtil"
import {Utils} from '../../../utils/util'
import GROUPS from "../../../static/js/jsConfig/groups"
const app = getApp()
const historyCommon = require("../../jsConfig/history")
Page({

  /**
   * 页面的初始数据
   */
  data: {
    dataStr: "11月11日", // 当前时间
    maxDate: 30, // 最长可以查询前30天的数据

    list: [], // 数据列表
    showContent: true, // 默认显示历史记录

    // 当前时间戳
    calendarObj: {
      datas: []
    },
    // 增加头部tab标签
    extendConfig: {
      // 房间列表
      data: [],
      selRoomId: 0, // 选中的房间 默认全屋
      handle: undefined
    }
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 默认是门磁
    this.devTypeStr = options?.devTypeStr || "doorsensor";
    // 取得当前日期
    this.data.calendarObj.datas = this.getCalendarObj();
    // 取得数据
    this.data.extendConfig.data = this.getExtendByDevType(this.devTypeStr);
    // this.data.extendConfig.handle = this.scrollClick;
    // 初始化历史数据
    this.initList();

    this.setData({
      extendConfig: this.data.extendConfig,
      calendarObj: this.data.calendarObj
    })
  },
  getExtendByDevType (devTypeStr) {
    let _result = [];
    if (devTypeStr == "panelsensor") {
      let _subs = app.globalData.devInfo?.e?.subs || [];
      _result = _subs.map((item, index) => {
        return {
          id: index,
          n: item?.name || ""
        }
      })
    }
    return _result;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  getCalendarObj () {
    let {year, month, day, hour, minute, second} = Utils.getDateObj();
    return [year, month, day];
    // return calendarObj;
  },
  initList () {
    this.getDevHistoryByDate(this.getDayStartByYYYYMMDD());
  },
  manageContent (e) {
    let {showContent, values} = e.detail;
    console.log("manageContent showContent, values = ", showContent, values);
    // 显示数据
    this.setData({
      showContent: showContent || false
    });
    // 如果有数据
    (!!values && values.length > 0) && (this.data.calendarObj.datas = values);
    // 查询数据
    this.initList();
  },
  
  // 将不同时区的时间转化为北京时间的时间戳哦
  getBeijingDate() {
    let _timestamp = new Date().getTime();
    let _minutes = Utils.getCurrentTimezone();
    let _seconds = _minutes * 60 * 1000;
    console.log("getBeijingDate _minutes = ", _minutes);
    // 本地时间 + 本地时间与格林威治时间的时间差 + GMT+8与格林威治的时间差
    let _beijingDate = new Date(_timestamp + _seconds);
    console.log("getBeijingDate _beijingDate = ", _beijingDate, _beijingDate.getHours());
    let _beijing1Date = new Date(_timestamp + _seconds + 8 * 60 * 60 * 1000);
    console.log("getBeijingDate _beijing1Date = ", _beijing1Date, _beijing1Date.getHours());
    return {
      date: _beijing1Date,
      seperatorSecond: _seconds
    };
  },
  getDevHistoryByDate (dataStr) {
    // 当前家庭信息
    let {sid, skey, groupIndex} = app.globalData.familyInfo;
    let _devInfo = app.globalData.devInfo;
    let _dateStr = dataStr; // this.getDayStartByYYYYMMDD();

    // // 这里需要转一下时区 目标时间
    // let _startTimeStr = _dateStr + "_00:00:00";
    // let _endTimeStr = _dateStr + "_23:59:59";

    let _seperatorMinute = Utils.getSeperatorMinite();
    let _startTimeTmpStr = _dateStr + " 00:00:00";
    console.log("getDevHistoryByDate _startTimeTmpStr = ", _startTimeTmpStr);
    let _startDate = new Date(new Date(_startTimeTmpStr).getTime() - _seperatorMinute * 60 * 1000);
    let _startTimeStr = Utils.formatTime(_startDate);
    console.log("getDevHistoryByDate _startTimeStr = ", _startTimeStr);
    let _endDate = new Date(_startDate.getTime() + (24 * 3600 - 1) * 1000);
    let _endTimeStr = Utils.formatTime(_endDate);
    console.log("getDevHistoryByDate _endTimeStr = ", _endTimeStr);

    console.log("getDevHistory sid, skey, app.globalData.familyInfo = ", sid, skey, app.globalData.familyInfo);
    
    // 上报的集群域名
    let _groupStr = GROUPS[Number(groupIndex) || 0]?.value || GROUPS[0].value;
    
    app.globalData.blsdk.getDevHistory({
      remoteHost: _groupStr, // "chn-ee08f451.ibroadlink.com", // 中国测试集群
      did: sid,
      token: skey,
      devInfo: _devInfo,
      timeObj: {
        start: _startTimeStr.replace(" ", "_"), 
        end: _endTimeStr.replace(" ", "_"), 
        step: 1000, 
        offset: 0
      }
    }).then(res => {
      console.log("getDevHistory res = ", res);
      let _list = this.dealResponse(res);
      _list = _list.slice(0, 1000); // 最多显示1000条
      console.log("dealResponse _list = ", _list);
      this.setData({
        list: _list,
        showContent: true
      })
    }).catch(e => {
      // 设置为空数据
      this.setData({
        list: [],
        showContent: true
      })
    });
  },
  // 取得某天的0点到23：59：59秒
  getDayStartByYYYYMMDD () {
    // return Utils.formatTime(false, {
    //   sep1: "/", // ios需要2018/10/07 11:00:00这个格式才能转
    //   sep2: " "
    // });

    let _dateArray = this.data.calendarObj?.datas || [];
    // 转成标准格式
    let _formatArray = _dateArray.map(item => (item || 0).toString().padStart(2, 0))
    return _formatArray.join("/");
  },
  // 解析数据
  dealResponse (res) {
    let {table} = res || {};
    let {cnt, did, total, values} = (table || [])[0] || {};
    console.log("dealResponse values = ", values);
    if (!values || values.length == 0) {
      return [];
    }
    let _result = [];

    // 根据occurtimev2排序
    let _sortArray = values.sort((item1, item2) => (item2?.occurtimev2 || 0) - (item1?.occurtimev2 || 0))

    for (let item of _sortArray) {
      // 数据处理
      let {occurtime, lowbattery, tamperevident, doorsensor_status} = item;
      // 新的条目
      let _item = {};

      // 原先没有增加时区的适配
      _item.time = bizUtil.getShowTimeStr(occurtime);

      // // 时间
      // _item.time = (occurtime?.split("_") || [])[1]?.slice(0, 5);

      // 显示内容
      let _tmpTip = this.getTextByDevTypeAndData(item, this.devTypeStr);
      if (!_tmpTip) {
        continue
      }
      _item.text = _tmpTip;
      console.log("dealResponse _item.text = ", _item.text);
      _result.push(_item)
    }
    return _result;
  },
  getTextByDevTypeAndData (json, devTypeStr) {
    console.log("getTextByDevTypeAndData json, devTypeStr = ", json, devTypeStr);
    return historyCommon.getTextByDevTypeAndData(json, devTypeStr)
  },

  sliderChange (e) {
    console.log("sliderChange e = ", e);
    let {id} = e.detail;
    this.data.extendConfig.selRoomId = Number(id);
    this.setData({
      [`extendConfig.selRoomId`]: Number(id)
    })
  }
})