import ability from "../../../utils/classDef/ability";
import bizUtil from '../../../utils/bizUtil';
// import DEVS from '../../../static/js/jsConfig/devs'
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    // 显示列表详情
    showDeail: false,
    // sizes
    sizes: {
      widthRpx: 466, // rpx,
      heightRpx: 466, // rpx
      topMarginT: 76, // 4键
      btmMarginT: 239
    },
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: app.globalData.devInfo?.n || ''
      }
    },
    // controlList: [], // 底部按钮
    bleUnavailable: false,
    scales: "none", // 适配小屏幕手机，暂时方案为 整体缩小

    errorMsg: "", // 故障码

    devTypeStr: "", // 设备类型
    configObj: {
      list: []
    }, // 根据设备类型获取不同的配置
    extendList: [] // 额外扩展的条目
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 保存设备类型
    this.data.devTypeStr = options?.devTypeStr;
    // 如果是sos，则额外增加扩展设置
    if (this.data.devTypeStr != "sossensor") {
      return;
    }
    this.initExtendList();
  },
  initExtendList () {
    this.data.extendList = [{
      title: "取消报警",
      type: "singleBtn",
      value: "取消"
    }];
    this.setData({
      extendList: this.data.extendList
    })
  },
  initTitle (n) {
    ability.setNavigationBarTitle(n || '');
  },
  // 根据设备品类取得配置信息
  getConfigByDevType (devType) {
    // 是否允许编辑
    let _notEdit = app.globalData.roleNum != 2;
    const config = {
      radarsensor: {
        name: "人体雷达传感器",
        key: "radarsensor",
        nameClass: "marginT15",
        img: "/device/img/bodysensor/radarsensor.png",
        imgClass: "radarsensorImg",
        list: [{
          title: '设置',
          key: "set",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/bodysensor/set.png"
        }, {
          title: '历史记录',
          key: "history",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/history.png"
        }, {
          title: '有人',
          id: 0,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/bodysensor/somebody.png"
        }, {
          title: '无人',
          id: 1,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/bodysensor/nobody.png"
        }]
      },
      bodysensor: {
        name: "人体传感器",
        key: "bodysensor",
        nameClass: "marginT15",
        img: "/device/img/bodysensor/bodysensor.png",
        imgClass: "bodysensorImg",
        list: [{
          title: '设置',
          key: "set",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/bodysensor/set.png"
        }, {
          title: '历史记录',
          key: "history",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/history.png"
        }, {
          title: '有人',
          id: 0,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/bodysensor/somebody.png"
        }, {
          title: '无人',
          id: 1,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/bodysensor/nobody.png"
        }]
      },
      doorsensor: {
        name: "门磁传感器",
        key: "doorsensor",
        nameClass: "marginT37",
        img: "/device/img/doorsensor/doorsensor.png",
        imgClass: "doorsensorImg",
        list: [{
          title: '历史记录',
          key: "history",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/history.png"
        }, {
          title: '门磁开',
          id: 0,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/doorsensor/open.png"
        }, {
          title: '门磁关',
          id: 1,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/doorsensor/close.png"
        }]
      },
      watersensor: {
        name: "水浸传感器",
        key: "watersensor",
        nameClass: "marginT37",
        img: "/device/img/watersensor/watersensor.png",
        imgClass: "watersensorImg",
        list: [{
          title: '历史记录',
          key: "history",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/history.png"
        }, {
          title: '水浸报警',
          id: 0,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/watersensor/wateralarm.png"
        }, {
          title: '水浸正常',
          id: 1,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/watersensor/waternormal.png"
        }]
      },
      sossensor: {
        name: "",
        key: "sossensor",
        nameClass: "",
        img: "/device/img/sossensor/sos.png",
        imgClass: "sossensorImg",
        list: [{
          title: '历史记录',
          key: "history",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/history.png"
        }, {
          title: '报警',
          id: 0,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/sossensor/sos_0.png"
        }, {
          title: '取消报警',
          id: 1,
          value: '未设置',
          edit: _notEdit,
          img: "/device/img/sossensor/sos_1.png"
        }]
      },
    }
    // 取得默认数据
    let _result = config[devType] || config['bodysensor'];
    // 过滤key
    let _keys = [];
    // 如果是人体传感器且不允许设置，则不显示设置
    if (!_notEdit && (_result?.key == "bodysensor" || _result?.key == "radarsensor")) {
      _keys.push("set");
    }
    // 判断是否有网关，如果没有网关，则不显示历史记录
    let {sid, skey} = app.globalData.familyInfo || {};
    if (!sid && !skey) {
      _keys.push("history");
    }
    // 可以编辑的场合才允许设置
    _result.list = _result.list.filter(item => _keys.indexOf(item.key) < 0);
    return _result; // 默认人体传感器
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 设置标题
    this.initTitle(app.globalData.devInfo?.n);
    // 初始化List
    this.initLists();
    // 查询设备快照
    this.batchqueryDevSnap(app.globalData.devInfo);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  initKeyStatusByScene (array) {
    console.log("initKeyStatusByScene array = ", JSON.stringify(array));
    let {d} = app.globalData.devInfo || {};
    let {panelScenes, sids} = bizUtil.getAllPanels(app.globalData.devs);

    console.log("initKeyStatusByScene panelScenes, sids = ", panelScenes, sids, app.globalData.devs);

    // 是否包含多楼层
    let _isFloor = false;
    if (app.globalData.familyInfo?.floor >= 0) {
      _isFloor = true;
    }

    let _allKeys = panelScenes[d];
    // 数组长度
    let _extraLen = array.filter(item => item.id < 0);
    let _length = _extraLen.length;

    console.log("initKeyStatusByScene _keys = ", _allKeys);
    if (!!_allKeys) {
      let _keys = Object.keys(_allKeys) || [];
      // 此处有个bug: 当解绑返回后由于这里没有key，所以清楚不了原先绑定的内容
      for (let key of _keys) {
        let _sceneInfo = sids[_allKeys[key]];
        let _index = Number(key);

        // 房间id
        let _roomId = Number(_sceneInfo.rid) || 0;

        // 是否多楼层
        let _name = "";
        if (_isFloor) {
          if (_roomId % 32 == 0) {
            // 房间名称
            _name = app.globalData.devs[_roomId]?.n || "";
          } else {
            // 楼层名称
            _name = app.globalData.devs[_roomId + (32 - _roomId % 32)]?.n || "";
            // 房间名称
            _name += app.globalData.devs[_roomId]?.n || "";
          }
        }
        let _realIndex = _index + _length;
        if (!array[_realIndex]) {
          console.error("initKeyStatusByScene _index, _length = ", _index, _length, array);
          continue;
        }
        array[_realIndex].value = _name + (_sceneInfo.n || '');
        array[_realIndex].sid = _sceneInfo.sid;
        array[_realIndex].rid = _roomId;
      }
    }
    return array;
  },
  // 区分群控页面
  initLists () {
    // 根据设备类型初始化传感器通用配置
    this.data.configObj = this.getConfigByDevType(this.data.devTypeStr);
    // 初始化控制列表
    let {list} = this.data.configObj;
    if (!list) {
      return;
    }

    // 数据赋值
    let _list = this.initKeyStatusByScene(list);
    // 数据处理
    this.data.configObj.list = _list || [];
    // 展示
    this.setProperValue("configObj", this.data.configObj);
    console.log("initLists this.data.configObj = ", this.data.configObj);
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || ""
    })
  },
  hideLoading () {
    ability.hideLoading();
  },
  // 同步数据到页面
  setProperValue (key, val) {
    if (this.data == undefined || val == undefined) {
      return;
    }
    this.data[key] = val;
    this.setData({
      [key]: val
    });
  },
  // 跳转设备详情页面
  jumpDetail () {
    // 跳转页面
    ability.navigateTo("../../light/devProperty/index?remote=0");
  },
  itemClick (e) {
    let {index} = e.detail;
    let {sid, rid, id, title, key} = this.data.configObj.list[index];
    console.log("itemClick key, sid, rid, id, index = ", key, sid, rid, id, index);

    // 如果是控制权限点击，则无法进入绑定页面
    if (id >= 0 && app.globalData.roleNum == 2) {
      return;
    }
    // 设备品类
    let _devTypeStr = this.data.devTypeStr; // bizUtil.getDevTypeStr(app.globalData.devInfo?.t);

    // 是否进入历史记录页面
    if (key == "history") {
      return ability.navigateTo("/device/sensor/history/index?devTypeStr=" + _devTypeStr);
    } else if (key == "set") {
      // 人体传感器设置页
      return ability.navigateTo("/device/sensor/set/index");
    }

    let _sid = sid || -1;
    let _rid = rid || 0; // 默认全开全关没有rid
    let _title = title || "";
    ability.navigateTo("/device/sensor/configDetail/index?key=" + (id) + "&sid=" + _sid + "&rid=" + _rid + "&title=" + encodeURIComponent(_title) + "&devTypeStr=" + _devTypeStr);
  },

  closeErrorPop () {
    this.setData({
      errorMsg: ""
    })
  },

  // 设备快照获取
  batchqueryDevSnap (devInfo) {
    // 当前家庭信息
    let {sid, skey} = app.globalData.familyInfo;
    let _devInfo = devInfo || {};
    app.globalData.blsdk.batchqueryDevSnap({
      // remoteHost: "chn-ee08f451.ibroadlink.com", // 中国测试集群
      did: sid,
      token: skey,
      devInfo: _devInfo
    }).then(res => {
      console.log("batchqueryDevSnap res = ", res);
      let {lowbattery} = this.dealResponse(res);
      this.setData({
        errorMsg: lowbattery ? '低电量' : ''
      });
    });
  },
  dealResponse (res) {
    let {code, data} = res || {};
    if (code != 0) {
      return {};
    }
    let {stateDna} = data[0] || {};
    let {doorsensor_status, lowbattery, online, tamperevident} = stateDna || {};
    // if (lowbattery) {
    // 是否低电量
    return {
      lowbattery: Boolean(lowbattery) || 0
    }
    // }
  },
  // 取消报警
  extendItemClick (e) {
    console.log("extendItemClick e = ", e);
    // let {index} = e.detail;
    // let {sid, rid, id, title, key} = this.data.extendList[index];
    app.globalData.blsdk.controlWithDevice(app.globalData.devInfo, [0xff, 0]);
  }
})