// device/sensor/panelSensor/index.js
import ability from "../../../utils/classDef/ability";
import bizUtil from '../../../utils/bizUtil';
// import DEVS from '../../../static/js/jsConfig/devs'
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    // 显示列表详情
    showDeail: false,
    // sizes
    sizes: {
      widthRpx: 466, // rpx,
      heightRpx: 466, // rpx
      topMarginT: 76, // 4键
      btmMarginT: 239
    },
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: app.globalData.devInfo?.n || ''
      }
    },
    // controlList: [], // 底部按钮
    bleUnavailable: false,
    scales: "none", // 适配小屏幕手机，暂时方案为 整体缩小

    errorMsg: "", // 故障码

    devTypeStr: "", // 设备类型
    configObj: {
      list: []
    }, // 根据设备类型获取不同的配置
    extendList: [] // 额外扩展的条目
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 保存设备类型
    this.data.devTypeStr = options?.devTypeStr;
    // 如果是sos，则额外增加扩展设置
    if (this.data.devTypeStr != "panelsensor") {
      return;
    }
    // 根据设备类型初始化传感器通用配置
    this.data.configObj = this.getConfigByDevType(this.data.devTypeStr);
    // 初始化控制列表
    this.setData({
      configObj: this.data.configObj
    })
  },
  getExtendList () {
    let _array = [];
    let {vGroups, subs} = app.globalData.devInfo?.e || {};
    let _subs = subs || [
      {"name": "传感器1"},
      {"name": "传感器2"},
      {"name": "传感器3"},
      {"name": "传感器4"},
    ];
    if (!subs) {
      app.globalData.devInfo.e.subs = _subs;
    }
    console.log("getExtendList vGroups, subs = ", vGroups, subs);
    for (let i in _subs) {
      let _parentIndex = i;
      let _childIndex = i * 2;
      _array.push({
        title: _subs[i]?.name || "",
        type: "",
        index: _parentIndex,
        list: [{
          title: vGroups[_childIndex]?.name || "",
          index: _childIndex
        }, {
          title: vGroups[_childIndex + 1]?.name || "",
          index: _childIndex + 1
        }]
      })
    }
    console.log("getExtendList _array = ", _array);
    return _array;
  },
  initTitle (n) {
    ability.setNavigationBarTitle(n || '');
  },
  // 根据设备品类取得配置信息
  getConfigByDevType (devType) {
    // 是否允许编辑
    let _notEdit = app.globalData.roleNum != 2;
    const config = {
      panelsensor: {
        name: "",
        key: "panelsensor",
        nameClass: "",
        img: "/device/img/panelsensor/panelsensor.png",
        imgClass: "panelsensor",
        list: [{
          title: '历史记录',
          key: "history",
          id: -1,
          value: '',
          edit: true,
          img: "/device/img/history.png"
        }]
      },
    }
    // 取得默认数据
    let _result = config[devType] || config['bodysensor'];
    // 过滤key
    let _keys = [];
    // 如果是人体传感器且不允许设置，则不显示设置
    if (!_notEdit && (_result?.key == "bodysensor" || _result?.key == "radarsensor")) {
      _keys.push("set");
    }
    // 判断是否有网关，如果没有网关，则不显示历史记录
    let {sid, skey} = app.globalData.familyInfo || {};
    if (!sid && !skey) {
      _keys.push("history");
    }
    // 可以编辑的场合才允许设置
    _result.list = _result.list.filter(item => _keys.indexOf(item.key) < 0);
    return _result; // 默认人体传感器
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 设置标题
    this.initTitle(app.globalData.devInfo?.n);
    // 初始化List
    this.initLists();
    // 查询设备快照
    // this.batchqueryDevSnap(app.globalData.devInfo);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  initKeyStatusByScene (array) {
    console.log("initKeyStatusByScene array = ", JSON.stringify(array));
    let {d} = app.globalData.devInfo || {};
    let {panelScenes, sids} = bizUtil.getAllPanels(app.globalData.devs);

    console.log("initKeyStatusByScene panelScenes, sids = ", panelScenes, sids, app.globalData.devs);

    // 是否包含多楼层
    let _isFloor = false;
    if (app.globalData.familyInfo?.floor >= 0) {
      _isFloor = true;
    }

    let _allKeys = panelScenes[d];
    // 数组长度
    let _length = 0;

    console.log("initKeyStatusByScene _keys = ", _allKeys);
    if (!!_allKeys) {
      let _keys = Object.keys(_allKeys) || [];
      // 此处有个bug: 当解绑返回后由于这里没有key，所以清楚不了原先绑定的内容
      for (let key of _keys) {
        let _sceneInfo = sids[_allKeys[key]];
        let _key = Number(key);

        // 房间id
        let _roomId = Number(_sceneInfo.rid) || 0;

        // 是否多楼层
        let _name = "";
        if (_isFloor) {
          if (_roomId % 32 == 0) {
            // 房间名称
            _name = app.globalData.devs[_roomId]?.n || "";
          } else {
            // 楼层名称
            _name = app.globalData.devs[_roomId + (32 - _roomId % 32)]?.n || "";
            // 房间名称
            _name += app.globalData.devs[_roomId]?.n || "";
          }
        }
        let _realIndex = _key + _length;
        let _index = parseInt(_realIndex / 2);
        let _idx = parseInt(_realIndex % 2);
        let child = (array[_index]?.list || [])[_idx] || {};
        child.value = _name + (_sceneInfo.n || '');
        child.sid = _sceneInfo.sid;
        child.rid = _roomId;
      }
    }
    return array;
  },
  // 区分群控页面
  initLists () {
    // 初始化
    let _extendList = this.getExtendList();
    console.log("initLists _extendList = ", _extendList);
    // 数据赋值
    let _list = this.initKeyStatusByScene(_extendList);
    console.log("initLists extendList = ", _list);
    // 展示
    this.setData({
      extendList: _list
    })
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || ""
    })
  },
  hideLoading () {
    ability.hideLoading();
  },
  // 同步数据到页面
  setProperValue (key, val) {
    if (this.data == undefined || val == undefined) {
      return;
    }
    this.data[key] = val;
    this.setData({
      [key]: val
    });
  },
  // 跳转设备详情页面
  jumpDetail () {
    // 跳转页面
    ability.navigateTo("../../light/devProperty/index?remote=0");
  },
  itemClick (e) {
    let {index} = e.detail;
    let {sid, rid, id, title, key} = this.data.configObj.list[index];
    console.log("itemClick key, sid, rid, id, index = ", key, sid, rid, id, index);

    // 如果是控制权限点击，则无法进入绑定页面
    if (id >= 0 && app.globalData.roleNum == 2) {
      return;
    }

    // 是否进入历史记录页面
    if (key == "history") {
      return ability.navigateTo("/device/sensor/history/index?devTypeStr=panelsensor");
    } else if (key == "set") {
      // 人体传感器设置页
      return ability.navigateTo("/device/sensor/set/index");
    }

    // let _sid = sid || -1;
    // let _rid = rid || 0; // 默认全开全关没有rid
    // let _title = title || "";
    // let _devTypeStr = this.data.devTypeStr; // bizUtil.getDevTypeStr(app.globalData.devInfo?.t);
    // ability.navigateTo("/device/sensor/configDetail/index?key=" + (id) + "&sid=" + _sid + "&rid=" + _rid + "&title=" + encodeURIComponent(_title) + "&devTypeStr=" + _devTypeStr);
  },

  closeErrorPop () {
    this.setData({
      errorMsg: ""
    })
  },

  // 设备快照获取
  batchqueryDevSnap (devInfo) {
    // 当前家庭信息
    let {sid, skey} = app.globalData.familyInfo;
    let _devInfo = devInfo || {};
    app.globalData.blsdk.batchqueryDevSnap({
      // remoteHost: "chn-ee08f451.ibroadlink.com", // 中国测试集群
      did: sid,
      token: skey,
      devInfo: _devInfo
    }).then(res => {
      console.log("batchqueryDevSnap res = ", res);
      let {lowbattery} = this.dealResponse(res);
      this.setData({
        errorMsg: lowbattery ? '低电量' : ''
      });
    });
  },
  dealResponse (res) {
    let {code, data} = res || {};
    if (code != 0) {
      return {};
    }
    let {stateDna} = data[0] || {};
    let {doorsensor_status, lowbattery, online, tamperevident} = stateDna || {};
    // if (lowbattery) {
    // 是否低电量
    return {
      lowbattery: Boolean(lowbattery) || 0
    }
    // }
  },
  // 取消报警
  extendItemClick (e) {
    console.log("extendItemClick e = ", e);
    // let {index} = e.detail;
    // let {sid, rid, id, title, key} = this.data.extendList[index];
    app.globalData.blsdk.controlWithDevice(app.globalData.devInfo, [0xff, 0]);
  },

  parentEditClick (e) {
    let {index} = e.currentTarget.dataset;
    // todo list
    let _item = this.data.extendList[index];
    ability.navigateTo("/device/light/deviceName/index?from=panelsensor&index=" + index + "&name=" + decodeURIComponent(_item.title));
  },
  childEditClick (e) {
    let {index, idx} = e.currentTarget.dataset;
    // todo list
    let _item = this.data.extendList[index];
    let _child = (_item?.list || [])[idx] || {};
    ability.navigateTo("/device/light/deviceName/index?from=panelsensor&index=" + index + "&idx=" + _child.index + "&name=" + decodeURIComponent(_child.title));
  },
  childClick (e) {
    let {index, idx} = e.currentTarget.dataset;
    console.log("childClick index, idx = ", index, idx);
    // 如果是控制权限点击，则无法进入绑定页面
    if (app.globalData.roleNum == 2) {
      return;
    }
    let _item = this.data.extendList[index];
    let {sid, rid, title, index: key} = (_item?.list || [])[idx] || {};
    console.log("itemClick key, sid, rid, index, title = ", key, sid, rid, index, title);
    let _sid = sid || -1;
    let _rid = rid || 0; // 默认全开全关没有rid
    let _title = title || "";
    let _devTypeStr = this.data.devTypeStr; // bizUtil.getDevTypeStr(app.globalData.devInfo?.t);
    ability.navigateTo("/device/sensor/configDetail/index?key=" + (key) + "&sid=" + _sid + "&rid=" + _rid + "&title=" + encodeURIComponent(_title) + "&devTypeStr=" + _devTypeStr); 
  }
})