const ability = require("../../../utils/classDef/ability");

const app = getApp()
// device/sensor/set/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: [{
      title: '有人保持时间',
      key: "setTimer",
      value: '',
      edit: true,
      // img: "/device/img/bodysensor/set.png"
    }],
    showRange: false, // actionsheet是否显示
    timeList: [], // actionsheet时间数
    pickerValue: 20, // 默认20s
    min: 20, // 最小时间
    max: 300 // 最大时间
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 初始化时间选择
    this.setProperValue("timeList", this.initTimeList());
    // 取得设备状态
    let {delay} = this.getDevStatus();
    console.log("onLoad delay = ", delay);
    // 更新数据
    this.updateDataByPickerValue(delay);
  },
  getDevStatus () {
    // 取得所有设备保存的状态数据
    let _allDevStatus = app.globalData.allStatus || {};
    // 根据设备did+短地址获取设备状态
    let _dev = app.globalData.devInfo || {};
    // 设备状态
    return _allDevStatus[_dev.d + "_" + _dev.a] || {
      delay: 20
    };
  },
  // 下拉选项列表
  initTimeList (max) {
    let _max = this.data.max;
    let _min = this.data.min;
    let _result = [];
    for (let i = _min; i <= _max; i++) {
      _result.push({
        text: i + "秒",
        value: i
      })
    }
    return _result;
  },

  updateDataByPickerValue (value) {
    let _value = Number(value == undefined ? 20 : value) || 0;
    console.log("updateDataByPickerValue value, _value = ", value, _value);
    let _min = this.data.min;
    let _lastVal = _value - _min;
    if (_lastVal < 0) {
      _lastVal = 0;
    }
    // 更新默认值
    this.updatePickerValue(_lastVal);
    // 更新条目数据
    this.data.list[0].value = _value + "秒";
    this.setProperValue("list", this.data.list);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // 保存雷达的延迟事件
    this.saveDevStatus();
  },
  saveDevStatus () {
    // 保存的设备状态
    let _allDevStatus = app.globalData.allStatus || {};
    let _dev = app.globalData.devInfo;
    let _value = this.data.list[0].value;
    // 设备状态
    _allDevStatus[_dev.d + "_" + _dev.a] = {
      delay: parseInt(_value)
    };
    app.globalData.allStatus = _allDevStatus;
    // 保存到缓存中
    app.setBizStorage("devStatus", _allDevStatus);
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  showPicker () {
    this.setProperValue("hidePicker", true)
  },
  hidePicker () {
    this.setProperValue("hidePicker", false)
  },
  // 同步数据到页面
  setProperValue (key, val) {
    if (this.data == undefined || val == undefined) {
      return;
    }
    this.data[key] = val;
    this.setData({
      [key]: val
    });
  },
  // rangeEvent (e) {
  //   console.log("rangeEvent e = ", e);
  //   let {value} = e.detail;
  //   this.updateDataByPickerValue(Number(value));
  // },
  updatePickerValue (value) {
    let _value = value || 0;
    console.log("updatePickerValue = ", _value);
    this.setProperValue("pickerValue", _value);
  },

  itemClick (e) {
    console.log("itemClick e = ", e);
    let {value} = e.detail;
    let _min = this.data.min;
    value = _min + Number(value) || 0;
    // let {text, value} = this.data.timeList[index] || {};
    console.log("itemClick value = ", value, typeof value);

    // this.updateDataByPickerValue(value);
    // return;

    // 等待条
    ability.showLoading({});
    
    app.globalData.blsdk.sensorTimeSet(app.globalData.devInfo, {
      timeout: value,
    }, (res) => {
      // 隐藏等待条
      ability.hideLoading();
      if (res >= 0 && typeof res == "number") {
        this.updateDataByPickerValue(value);
      } else {
        this.updateDataByPickerValue(this.data.list[0].value);
      }
    });
  }
})