// device/tvLamp/control/index.js
import ability from "../../../utils/classDef/ability";
import bizUtil from '../../../utils/bizUtil';
const app = getApp();

Page({
  data: {
    // 显示列表详情
    showDeail: false,
    // sizes
    // sizes: {
    //   widthRpx: 466, // rpx,
    //   heightRpx: 466, // rpx
    //   topMarginT: 76, // 4键
    //   btmMarginT: 239
    // },
    navObj: {
      bgClass: "bg0F212B",
      left: {
        type: "img",
        img: "/static/img/back_white.png"
      },
      center: {
        text: app.globalData.devInfo?.n || '',
        style: "white"
      }
    },
    controlList: [], // 底部按钮
    configs: {
      bgClass: "bg1A2C36",
      borderClass: "borderTop5F",
      titleColor: "white"
    },

    bleUnavailable: false,
  },
  onLoad () {
    // 设备信息
    let {n, v, t} = app.globalData.devInfo;
    // // 设置标题
    // this.setNavTitle(n);

    // 判断是否开关还是面板还是插卡取电设备
    let _devTypeStr = bizUtil.getDevTypeStr(t);
    let _isTvLamp = _devTypeStr == "tvLamp"; // 是否插卡取电设备

    this.setData({
      isTvLamp: _isTvLamp,
    });
  },
  onShow () {
    // 初始化List
    this.initLists();
  },
  // setNavTitle (n) {
  //   ability.setNavigationBarTitle(n || '');
  // },
  initKeyStatusByScene (array) {
    console.log("initKeyStatusByScene array = ", JSON.stringify(array));
    let {d, ds} = app.globalData.devInfo || {};
    // 所有设备信息
    let _allDevs = app.globalData.devs;
    let _addJson = this.getAddedInfoByDevInfo(ds);
    console.log("initKeyStatusByScene _addJson = ", _addJson);
    // 取得执行设备的群组和单个设备a或者gid map
    let _devGroupJson = bizUtil.getActionDAndGidMap(_allDevs, ["devs", "groups"]);
    console.log("initListByVersion _devGroupJson = ", _devGroupJson);
    // 取得所有房间映射信息
    let {roomJson} = bizUtil.getRoomsByDevs(_allDevs); 

    // 如果存在配置数据
    let _list = this.getListByConfig(array, _addJson, _devGroupJson, roomJson);
    
    console.log("initKeyStatusByScene _list = ", _list);

    return _list;
  },
  // 根据配置取得路数列表
  getListByConfig (list, addedJson, _devGroupJson, roomJson) {
    let _result = [];
    // 集合
    let {devs: devJson, groups: groupJson} = _devGroupJson || {};
    // 是否控制权限
    let _isOnlyCtrl = app.globalData.roleNum == 2;
    // 根据devTypeStr取得发送的key
    let type = bizUtil.getTypeByDevTypeStr("light");
    console.log("initListByVersion type, list = ", type, list);
    // 增加数组
    for (let i = 0, len = list?.length || 0; i < len; i++) {
      let _obj = list[i];
      if (!_obj) {
        console.error("obj not exist")
        continue;
      }
      // 未配置或者 名称 | 房间
      _obj.right = !_isOnlyCtrl;
      // 判断是否绑定过
      let _bindInfo = (addedJson || {})[i];
      if (_bindInfo) {
        // 绑定过，则取得绑定的设备或者场景或者群组的名称
        let {sid, rid, cmd, key, type} = _bindInfo;
        console.log("getListByConfig cmd, key, rid, type, sid = ", cmd, key, rid, type, sid)
        // 如果绑定的设备，则cmd是短地址 如果是群组，cmd是gid
        let _isGroup = ((cmd + "").length) <= 3;
        let _info = _isGroup ? groupJson[cmd] : devJson[sid];
        if (!_info) {
          console.error("_info not exist _isGroup, rid, sid = ", _isGroup, rid, sid)
          continue;
        }
        if (_isGroup) {
          // 群组
          _obj.groupInfo = _info;
        } else {
          // 单个设备
          _obj.devInfo = _info;
        }
        _obj.type = type;
        _obj.value = _info?.n + " | " + bizUtil.getRoomNameById(roomJson, _info.rid || _info.id);
      }
      // 加入列表
      _result.push(_obj)
    }
    return _result;
  },
  // 根据超级面板设备信息取得已经添加的场景信息
  getAddedInfoByDevInfo (ds) {
    let _len = ds?.length || 0;
    if (!ds || _len == 0) {
      return {};
    }
    let _obj = {};
    for (let i = 0; i < _len; i++) {
      let _item = ds[i];
      _obj[_item.key || 0] = _item;
    }
    return _obj;
  },
  onUnload () {
    // 页面销毁 如果设置过百分比和最佳位置则保存设备状态
    this.saveDevStatus();
    // 关闭蓝牙监听器
    !!app.globalData.blsdk && (app.globalData.blsdk.destory());
  },
  saveDevStatus () {
  },
  // 区分群控页面
  initLists () {
    // 是否插卡取电设备
    let _isTvLamp = this.data.isTvLamp;
    if (_isTvLamp) {
      // 取得底部的列表
      let _list = this.getTvLampList();
      // 初始化数据
      let _controlList = this.initKeyStatusByScene(_list, "light");
      // 根据初始化之后的数据增加一个标题条目
      let _resultList = this.addExtendItemByBindCount(_controlList);
      this.setData({
        controlList: _resultList
      })
    }
  },
  // 增加额外的标题条目
  addExtendItemByBindCount (array) {
    if (!array) {
      return [];
    }
    console.log("addExtendItemByBindCount array = ", array);
    // 取得已经绑定的数据
    let _allCount = array.length;
    let _bindCount = array.filter(item => item.type >= 0).length;
    // 添加标题条目 放到第一栏
    array.unshift({
      specialType: true, // 这个是特殊显示
      imgStr: "/device/img/tvLamp/tipIcon.png",
      title: '照明设备',
      tip: `待配置${_allCount - _bindCount}个设备，已添加${_bindCount}个`
    });
    return array;
  },
  // 电视氛围灯
  getTvLampList () {
    let _notEdit = app.globalData.roleNum == 2;
    return [{
      title: '声音律动',
      id: 0,
      value: '默认配置',
      edit: !_notEdit
    }, {
      title: '全屏光影律动',
      id: 1,
      value: '默认配置',
      edit: !_notEdit
    }, {
      title: '上屏幕光影律动 ',
      id: 2,
      value: '默认配置',
      edit: !_notEdit
    }, {
      title: '下屏幕光影律动',
      id: 3,
      value: '默认配置',
      edit: !_notEdit
    }, {
      title: '左侧光影律动',
      id: 4,
      value: '默认配置',
      edit: !_notEdit
    }, {
      title: '右侧光影律动 ',
      id: 5,
      value: '默认配置',
      edit: !_notEdit
    }]
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || ""
    })
  },
  hideLoading () {
    ability.hideLoading();
  },
  // 跳转设备详情页面
  jumpDetail () {
    // 跳转页面
    ability.navigateTo("../../light/devProperty/index?remote=0");
  },
  itemClick (e) {
    // 如果是编辑权限，则不进入
    if (app.globalData.roleNum == 2) {
      return;
    }
    let _devInfo = app.globalData.devInfo;
    let {index} = e.detail;
    let _item = this.data.controlList[index];
    console.log("itemClick _item, index = ", _item, index);
    // 电视氛围灯绑定照明类型 这里index包含了一个头
    let _url = "/scene/addDevice/index?from=tvlamp&hidetab=1&key=" + (index - 1) + "&devTypeStr=light";
    // 判断是否绑定
    if (_item.groupInfo) {
      // 绑定群组
      _url += ("&did=" + _item.groupInfo?.gid);
    } else if (_item.devInfo) {
      // 绑定设备
      _url += ("&did=" + _item.devInfo?.d);
    }
    // 跳转到设备绑定页面
    ability.navigateTo(_url);

    // ability.navigateTo("/device/panel/configDetail/index?key=" + (_realKey) + "&sid=" + _sid + "&rid=" + _rid + "&title=" + encodeURIComponent(_title));
  },
  actDev (cmdArray) {
    let _devInfo = app.globalData.devInfo;
    app.globalData.blsdk.controlWithDevice(_devInfo, cmdArray);
  },
})
