// miniprogram/device/uart/control/index.js
import ability from "../../../utils/classDef/ability";
import {Utils} from "../../../utils/util"
const app = getApp();

Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: ""
      }
    },
    
    groupIds: [], // 批量控制

    dataStr: "", // 发送的16禁止数据
    receiveStr: "", // 接收的16进制数据
    
    bleUnavailable: false,

    groupId: 0, // 房间id
  },
  onLoad() {
  },
  onReady () {
  },
  onShow () {
    // 批量控制的addr列表
    this.data.groupIds = app.globalData.groupIds || [];
    // 初始化页面标题
    this.initPageTitle();
  },
  
  onUnload () {
  },
  // 区分群控页面
  initPageTitle () {
    let _isGroup = (app.globalData.devInfo == undefined);
    // 初始化标题
    ability.setNavigationBarTitle(this.getDevName(_isGroup));
  },
  getDevName (isGroup) {
    return isGroup ? (this.data.groupIds.length > 0 ? "批量控制" : (app.globalData.roomInfo.id ? '房间控制' : "全屋控制")) : (app.globalData.devInfo || {}).n;
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || ""
    })
  },
  hideLoading () {
    ability.hideLoading();
  },

  actDev (key, addr, isGroup, callback) {
    // 短地址
    let _addr = addr || 0;
    // 长度限制
    let _isUart = false;
    if (!!(key instanceof Array)) {
      _isUart = true;
    }

    // 首先判断蓝牙是否可用
    let _status = app.globalData.blsdk.isBleAvailable();
    // 获取蓝牙状态是否可用
    if (!_status) {
      ability.showBleFail();
      !!callback && (callback(-1));
      return;
    }
    // 清空数据
    this.setData({
      receiveStr: ""
    })

    // let _lengthPerPackage = 16;
    // let _cmdLength = 95; // key?.length || 0;
    // let _secondMultip = Math.ceil(_cmdLength / _lengthPerPackage);
    // let _seconds = _secondMultip * 350; // 周期
    
    this.data.receives = []; // 接收到的数据
    // let _configs = undefined;
    // // 阶段，每隔阶段发送不同的数据
    // let _step = 1;
    // 发包和接收包分别独立
    // app.globalData.blsdk.startBleReceiveService({
    //   callback: (res) => {
    //     // console.log("actDev timestamp = ", Date.now() / 1000);
    //     console.error("startBleReceiveService res = ", res, typeof res);

    //     this.data.receives.push(res);
    //     let _len = this.data.receives.length;

    //     // 接收参数的回调
    //     // console.error("uartCtrlWithRes res, _len, _secondMultip = ", res, _len, _secondMultip);
        
    //     if (_step == 1) {
    //       // step=1的第一个包是从1开始，_lengthPerPackage个长度
    //       if (res[2] % _lengthPerPackage == 1) {
    //         let _index = parseInt(res[2] / _lengthPerPackage);
    //         _configs[_index] = 1;
    //       }
    //     }
        
    //     if (_step == 1 && _len == _secondMultip) {
    //       _step = 2;
    //       // 停止发送广播命令
    //       app.globalData.blsdk.stopAdvertising();
    //       // 清除上一次缓存的数据
    //       app.globalData.blsdk.clearConfigCache();
    //     } 
    //     // else if (_step == 2 && res[2] == 2) {
    //     //   _step = 3;
    //     //   // 停止发送广播命令
    //     //   app.globalData.blsdk.stopAdvertising();
    //     // }
    //   },
    //   devAddr: _addr,
    //   intervalFunction: () => {
    //     // if (_step == 1) {
    //       let _cmds = this.createArray(0, 90);
    //       let _cmdLength = _cmds.length; // key?.length || 0;
    //       _secondMultip = Math.ceil(_cmdLength / _lengthPerPackage);
    //       _configs = _configs || new Array(_secondMultip).fill(0);
    //       // 定时器的回调
    //       app.globalData.blsdk.uartCtrlNoRes(_addr, _cmds, {
    //         count: _lengthPerPackage,
    //         perPackageSet: _configs,
    //         isGroupCtrl: isGroup || false
    //       });
    //     // } else if (_step == 2) {
    //     //   let _cmds = this.createArray(101, 191);
    //     //   let _cmdLength = _cmds.length; // key?.length || 0;
    //     //   _secondMultip = Math.ceil(_cmdLength / _lengthPerPackage);
    //     //   _configs = _configs || new Array(_secondMultip).fill(0);
    //     //   // 定时器的回调
    //     //   app.globalData.blsdk.uartCtrlNoRes(_addr, _cmds, {
    //     //     count: _lengthPerPackage,
    //     //     perPackageSet: _configs
    //     //   });
    //     // } else if (_step == 3) {
    //     //   // 定时器的回调
    //     //   app.globalData.blsdk.uartCtrlNoRes(_addr, this.createArray(2, 92), {
    //     //     count: _lengthPerPackage
    //     //   });
    //     // }
    //   },
    //   seconds: _seconds,
    //   noFilter: _secondMultip > 1,
    // });
    // return;
    
    // 有返回的控制命令
    app.globalData.blsdk.uartCtrlWithRes(_addr, key, (res) => {
      console.error("uartCtrlWithRes res = ", res);
      this.setData({
        receiveStr: (res || "").toString()
      });
      !!callback && (callback(0));
    }, {
      isGroupCtrl: isGroup || false,
      magicArray: app.globalData?.companyInfo?.magicArray
    });
  },
  uartCtrlNoRes () {
    // 取得发送数据
    let _sendArray = this.getSendArray();
    if (!_sendArray) {
      return;
    }
    // 短地址
    let {a} = app.globalData.devInfo || {};
    // 有返回的控制命令
    app.globalData.blsdk.uartCtrlNoRes(a, _sendArray, {
      magicArray: app.globalData?.companyInfo?.magicArray
    });
  },
  createArray (startIndex, endIndex) {
    let _startIndex = startIndex || 0;
    let _endIndex = endIndex || 100;
    let _array = [];
    for (let i = _startIndex; i < _endIndex; i++) {
      _array.push(i + 1);
    }
    return _array;
  },
  /************** end ***************/

  onBlur(e) {
    this.dealInputChange(e.detail.value);
  },
  onChange(e) {
    this.dealInputChange(e.detail.value);
  },
  dealInputChange (value) {
    let _value = (value || '').toLowerCase();
    console.log("onChange = ", _value);
    let dataStr = _value.replace(/[^\dabcdef]/g,'');
    this.setData({
      dataStr
    })
  },
  onGroupChange (e) {
    this.setData({
      groupId: e.detail.value
    })
  },
  getSendArray () {
    let _dataStr = this.data.dataStr || "";
    let _len = _dataStr.length;
    console.log("sendCtrl = ", _dataStr);
    if (_len % 2 != 0) {
      console.log("长度需要2的倍数");
      ability.showToast({
        title: '长度需要2的倍数'
      })
      return false;
    }
    return Utils.hexStrToArray(_dataStr);
  },
  sendCtrl () {
    let _sendArray = this.getSendArray();
    if (!_sendArray) {
      return;
    }
    ability.showLoading({});
    let _devInfo = app.globalData.devInfo;
    this.actDev(_sendArray, _devInfo?.a, false, (res) => {
      ability.hideLoading();
    });
  },
  allCtrl () {
    let _dataStr = this.data.dataStr || "";
    let _len = _dataStr.length;
    console.log("sendCtrl = ", _dataStr);
    if (_len % 2 != 0) {
      console.log("长度需要2的倍数");
      return ability.showToast({
        title: '长度需要2的倍数'
      })
    }
    // ability.showLoading({});
    // , (res) => {
    //   ability.hideLoading();
    // }
    this.actDev(Utils.hexStrToArray(_dataStr), 0, false);
  },
  groupCtrl () {
    let _dataStr = this.data.dataStr || "";
    let _len = _dataStr.length;
    console.log("sendCtrl = ", _dataStr);
    if (_len % 2 != 0) {
      console.log("长度需要2的倍数");
      return ability.showToast({
        title: '长度需要2的倍数'
      });
    }
    let _groupId = this.data.groupId || 0;
    if (_groupId == 0) {
      this.allCtrl();
    } else {
      this.actDev(Utils.hexStrToArray(_dataStr), _groupId, true);
    }
  },
  stopCtrl () {
    app.globalData.blsdk.stopReceiveAndAdvertising();
  }
})
