// device/virtualPwrPanel/list/index.js
const ability = require("../../../utils/classDef/ability");
const app = getApp();
const bizUtil = require("../../../utils/bizUtil");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "场景详情"
      }
    },
    list: [
      {
        title: "按键同步名称",
        bindtap: "editName",
        tip: ""
      }, {
        title: "所在房间",
        bindtap: "editRoom",
        tip: ""
      }
    ],
    panelList: [],
    actions: [],
    roleNum: app.globalData.roleNum, // 角色

    // 取得所有设备对应的信息d: xxx
    allDJson: {}
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    let {edit} = options || {};
    this.isEdit = edit >= 0; // 是否编辑
    let _roleNum = app.globalData.roleNum;
    console.log("onLoad _roleNum = ", _roleNum);
    // 初始化所有的设备d对应的设备信息
    this.data.allDJson = this.initDToJson();
    // 根据type动态设置按钮
    let _bottomBtns = this.getActionByEdit(this.isEdit);

    this.setData({
      roleNum: _roleNum,
      actions: _bottomBtns
    })
  },

  // 设备d作为key的map对象
  initDToJson () {
    // 取得房间下的所有面板信息
    let _allDevInfo = bizUtil.getAllDevsFilter(app.globalData.devs);
    let _panelJson = bizUtil.arrayToJsonByKey(_allDevInfo, true, 'd');
    console.log("initDToJson _panelJson = ", _panelJson);
    return _panelJson;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 初始化数据
    this.initData();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // 新创建的按键同步
    if (app.globalData.devInfo && app.globalData.devInfo.isNew) {
      // 新的按键同步只有点击完成加入到房间列表中
      this.delSyncDetail(true);
    }

    // 保存设备信息
    app.saveAllDevsMap();
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  getActionByEdit (isEdit) {
    console.log("getActionByType isEdit = ", isEdit);
    let _actions = this.getAllActionList();
    if (!isEdit) {
      _actions = _actions.slice(1);
      _actions[0].classStr = _actions[0].classStr.replace("marginL49", "");
    }
    console.log("getActionByType _actions = ", _actions);
    return _actions;
  },

  getAllActionList () {
    let _action = [{
      n: '删除同步',
      classStr: 'delBtn',
      handle: 'delSync'
    }, {
      n: '完成',
      classStr: 'saveBtn marginL49',
      handle: 'completes'
    }];
    return _action;
  },

  initData () {
    console.log("initData devInfo = ", app.globalData.devInfo)
    // 初始化场景信息
    let {n, t, id, e} = app.globalData.devInfo || {};
    // 当前房间下的所有信息
    let _roomAllInfo = app.globalData.devs[id || 0] || {};
    // 赋值
    this.data.list[0].tip = n || "";
    this.data.list[1].tip = _roomAllInfo.n;
    
    // 初始化页面标题
    ability.setNavigationBarTitle("按键同步")
    // ability.setNavigationBarTitle(n || "添加同步")

    // 绑定的设备
    let _panelList = this.getPanelsByArray(e, this.data.allDJson);
    
    this.setData({
      list: this.data.list,
      panelList: _panelList
    })
  },
  // 根据房间id取得所有支持默认场景的照明设备
  getDevByRoomIdSupportDefaultScene (roomId, configs) {
    // 设备集合
    let _devs = [];
    // 如果房间id为全屋，则加入所有的照明设备
    if (roomId == 0) {
      _devs = bizUtil.getAllDevsFilter(app.globalData.devs);
    }
    // 如果房间id为楼层，则加入楼层下的所有照明设备
    else if (roomId % 32 == 0) {
      let _floorJson = bizUtil.getAllDevsByFloor(app.globalData.devs, bizUtil.getFloorByRoomId(roomId), false);
      _devs = bizUtil.getAllDevsFilter(_floorJson);
    }
    // 如果房间id为单个房间，则加入房间下的所有照明设备
    else {
      _devs = app.globalData.devs[roomId]?.devs || [];
    }
    // 是否有照明
    let _hasLight = configs?.light;
    // 是否有窗帘
    let _hasCurtain = configs?.curtain;
    if (!_hasLight && !_hasCurtain) {
      return _devs;
    }
    return _devs.filter(item => {
      let _result = false;
      // 是否有照明设备
      if (_hasLight) {
        let _exist = (bizUtil.getSupportSceneInfoByV(item.v) == 0 && bizUtil.getDevTypeStr(item.t) == "light");
        if (_exist) {
          return true;
        }
      }
      if (_hasCurtain) {
        let _exist = (bizUtil.getDevTypeStr(item.t) == "curtain");
        if (_exist) {
          return true;
        }
      }
      return _result;
    });
    // // 是否需要版本号校验
    // if (vCheck != undefined) {
    //   // 取得列表中支持默认场景的数据
    //   return _devs.filter(item=>(bizUtil.getSupportSceneInfoByV(item.v) == 0) && bizUtil.getDevTypeStr(item.t) == devTypeStr);
    // } else {
    //   // 取得列表中支持默认场景的数据
    //   return _devs.filter(item=>bizUtil.getDevTypeStr(item.t) == devTypeStr);
    // }
  },
  getCmds (devs, isDefault) {
    if (!devs || devs.length == 0) {
      return [];
    }
    let _result = [];

    console.log("getCmds devs = ", devs);

    for (let item of devs) {
      let {d, t, cmd, tip, tStr} = item || {};

      // 如果有数据，则优先使用数据
      let _devInfo = this.data.allDJson[d] || item || {};
      let {a, t: realT, v, n} = _devInfo;

      // 如果是默认场景支持的设备
      if (isDefault) {
        cmd = "default";
        tip = "默认";
      }

      // 取得自定义执行设备的icon
      let _tStr = tStr || bizUtil.getDevImgByT(_devInfo) || 'light';
      

      // 取得每个设备的最小亮度值
      console.log("getCmds cmd, tip = ", cmd, tip);
      
      _result.push({
        a: a,
        d: d,
        n: n || d || '',
        t: realT,
        img: _tStr,
        tip: tip || bizUtil.getTipByStatus(cmd, realT), // this.getTipByStatus(cmd, t),
        cmd: cmd,
        v: v // 需要带上版本号，需要判断ability
      })
    }
    return _result;
  },

  getPanelsByArray (eJson, panelJson) {
    let {bindDevices} = eJson || {};
    if (!bindDevices || bindDevices.length == 0) {
      return [];
    }
    console.log("getPanelsByArray eJson = ", eJson);
    let _panelJson = panelJson || {};
    let _results = [];
    for (let idx in bindDevices) {
      let {d, key} = bindDevices[idx];
      let _devInfo = _panelJson[d];
      if (!_devInfo) {
        continue;
      }
      // 设备类型
      let _t = _devInfo.t;

      // 取得触发设备的icon
      let _tStr = _devInfo.tStr || bizUtil.getDevImgByT(_devInfo);

      // 设备类型动态显示图片
      let _devStr = bizUtil.getDevTypeStr(_t);
      console.log("getPanelsByArray _panelJson, _devInfo = ", _panelJson, _devInfo);
      let _key = Number(key);
      _results.push({
        d: _devInfo.d,
        n: _devInfo.n || '',
        img: '/static/img/common/' + _tStr + '.png',
        tip: bizUtil.getTipByDevTyeStr(_t, _key, _devInfo.e),
        id: _key // 按键的mask
      })
    }
    return _results;
  },

  delSync () {
    console.log("delSync this.data.roleNum = ", this.data.roleNum);
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    // 很奇怪的问题  使用ability调用showModal不提示了
    ability.showModal({
      title: "确认删除此同步？",
      content: "删除同步后，与其相关的配置将不可用",
      showCancel: true,
      confirmText: "确定",
      confirmColor: "#E02020",
      cancelText: "取消",
      cancelColor: '#000000'
    }).then(result => {
      console.error("delSync result = ", result);
      result && (this.delSyncDetail());
    })
  },
  delSyncDetail (noLoading) {
    // 发送数据
    let _devInfo = app.globalData.devInfo;
    console.error("delSyncDetail _devInfo = ", _devInfo);
    !noLoading && (ability.showLoading({}));
    // 删除场景
    app.globalData.blsdk.unbindDeviceWithAddr(0, _devInfo?.a, noLoading ? undefined : (result) => {
      ability.hideLoading()
      console.error("delScene result = ", result);
      if ((result && result.errCode) || result != 0) {
        return this.setShowCustomToast('error', '删除失败');
      }
      // 删除之后
      this.delPwrPanelInfo(_devInfo);
      // 提示删除成功 (!result && result != 0) ? '删除失败' : 
      this.setShowCustomToast('success', '删除成功');
      // 延迟返回
      this.delayBack();
    });
  },
  // 删除双控面板
  delPwrPanelInfo (devInfo) {
    if (!devInfo) {
      return;
    }
    let {id, d} = devInfo;
    let {devs} = app.globalData.devs[id] || [];
    if (!devs || devs.length == 0) {
      return;
    }
    app.globalData.devs[id].devs = devs.filter(item => item.d != d);
  },
  // 设置是否显示自定义对话框
  setShowCustomToast (icon, str) {
    ability.showToast({
      title: str || "",
      icon: icon
    })
  },
  delayBack () {
    setTimeout(() => {
      // 返回上一页
      this.back();
  }, 1000)
  },
  getSceneIndexBySid (array, sid) {
    if (!array || !sid) {
        return -1;
    }
    for (let index in array) {
        let _item = array[index];
        if (_item.sid == sid) {
            return index;
        }
    }
    return -1;
  },
  back () {
    ability.navigateBack();
  },
  addPanel () {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    ability.navigateTo("/scene/panel/index?from=pwrAvalible")
  },

  // 面板选择页面
  itemClick (e) {
    if (this.data.roleNum == 2) {
      return;
    }
    let {index} = e.currentTarget.dataset;
    let _item = this.data.panelList[index];
    console.log("itemClick _item = ", _item);
    // 设置当前的面板
    let _d = (_item.d || "");
    app.globalData.panelInfo = (this.data.allDJson || {})[_d];
    console.log("itemClick app.globalData.panelInfo = ", app.globalData.panelInfo);
    // 默认的按键 按键从0开始
    let _panelId = _item.id;
    _panelId = _panelId != undefined ? _panelId : 0;
    // 跳转页面 传入编辑的按键下标
    ability.navigateTo("/scene/panelDetail/index?edit=" + _panelId + "&from=pwrAvalible");
  },

  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    });
  },
  hideLoading () {
    ability.hideLoading();
  },
  
  editName () {
    if (this.data.roleNum == 2) {
      return
    }
    // 初始化场景信息
    let {n} = app.globalData.devInfo || {};
    console.log("editName sceneInfo = ", app.globalData.devInfo);
    // 名称编辑
    ability.navigateTo('/device/light/deviceName/index?name=' + encodeURIComponent(n || "") + '&from=virtualName');
  },
  // 完成按钮点击
  completes () {

    if (app.globalData.devInfo && app.globalData.devInfo.isNew) {
      delete app.globalData.devInfo.isNew;
      // 新的按键同步只有点击完成加入到房间列表中
      app.globalData.devs[0].devs.push(app.globalData.devInfo);
    }

    // 返回上一页
    this.back();
  },

  // 所在房间
  editRoom () {
    ability.navigateTo("../../light/belongRoom/index")
  }
})