import ability from "../../utils/classDef/ability"
import bizUtil from "../../utils/bizUtil"
import GROUPS from "../../static/js/jsConfig/groups"
const app = getApp()

var familyBehavior = require("../../static/js/behavior/family")
Page({
  behaviors: [familyBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "家庭管理"
      }
    },
    items: [],
    // 初始化默认房间信息
    familyIndex: 0,
    familyInfo: {},
    // 房间数据显示
    details: [],
    statusHeight: 0,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 初始化保存的数据
    let _familyIdx = options.index || 0;
    this.data.familyIndex = _familyIdx;
    this.data.familyInfo = this.getAllFamilys()[_familyIdx] || {};
    // this.setData({
    //   familyInfo: this.data.familyInfo
    // })
  },

  getAllFamilys () {
    return app.globalData.familys || [];
  },
  // 初始化备份还原按键的高度
  initPageStatus () {
    let {statusHeight, multip} = app.globalData.customPageSize || {};
    this.data.statusHeight = (statusHeight || 0) * (multip || 0);
    console.log("initPageStatus this.data.statusHeight = ", this.data.statusHeight);
    this.setData({
      statusHeight: this.data.statusHeight
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    // 取得状态栏高度
    this.initPageStatus();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 初始化房间数据统计
    this.initDetails();
    // 初始化房间、场景、设备数量
    // this.initFamilyCounts();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 初始化家庭中的统计数
  initDetails () {
    // 家庭配置数据
    let _familyInfo = this.data.familyInfo || {};
    // 取得家庭详细数据
    let _familyDetail = this.getFamilyDetail();
    // 初始化家庭中的统计数
    let _details = this.getAllDetails(_familyDetail);
    // 初始化 家庭名称等条目信息
    let _items = this.getAllItems(_familyInfo);
    // 判断当前房间是否开启多楼层
    if (_familyInfo.floor >= 0) {
      this.data.details = _details;
      this.data.items = _items;
    } else {
      this.data.details = _details.slice(1);
      this.data.items = [_items[0], _items[2],_items[3]];
    }
    this.setData({
      details: this.data.details,
      items: this.data.items,
      familyInfo: this.data.familyInfo
    })
  },
  getAllDetails (json) {
    // 取得家庭详细数
    // 取得各个数据的个数
    let {devs, scenes, rooms, floors} = this.getFamilyDetailCount(json);
    return [{
      n: "楼层",
      key: "floors",
      count: floors
    }, {
      n: "房间",
      key: "rooms",
      count: rooms
    }, {
      n: "场景",
      key: "scenes",
      count: scenes
    }, {
      n: "设备",
      key: "devs",
      count: devs
    }];
  },
  getAllItems (familyInfo) {
    return [{
      title: "家庭名称",
      tip: familyInfo?.n,
      bindtap: "nameClick"
    }, {
      title: "楼层管理",
      bindtap: "floorClick"
    }, {
      title: "房间管理",
      bindtap: "roomClick"
    }, {
      title: "所在地区",
      tip: GROUPS[familyInfo?.groupIndex || 0]?.text,
      // bindtap: "toThirdVoice"
    }]
  },
  nameClick (e) {
    let index = this.data.familyIndex || 0;
    let _familys = this.getAllFamilys();
    let _item = _familys[index];
    ability.navigateTo('/family/name/index?index=' + index + "&name=" + encodeURIComponent(_item.n || ''))
  },
  floorClick () {
    // 当前房间id
    let _id = this.data.familyInfo?.id;
    ability.navigateTo("/floor/list/index?familyId=" + _id);
  },
  roomClick (e) {
    let index = this.data.familyIndex || 0;
    let _familys = this.getAllFamilys();
    let _item = _familys[index];
    ability.navigateTo("/minePages/roomManage/index?index=" + index + "&familyId=" + _item.id);
  },
  // 初始化房间、场景、设备数量
  getFamilyDetail() {
    // 选中家庭id
    let {id} = this.data.familyInfo;
    // 根据家庭id取得所有家庭数据
    let _familyDetail = app.globalData.allFamilysMap[id];
    if (!_familyDetail) {
      return {};
    }
    return _familyDetail;
  },
  // 取得所有数据
  getFamilyDetailCount (json) {
    let _result = {devs: 0, scenes: 0, rooms: 0, floors: 0};
    if (!json) {
      return _result;
    }
    // 遍历所有数据
    for (let roomId in json) {
      
      if (roomId % 32 != 0) {
        // 房间个数+1
        _result.rooms++;
      } else if (roomId > 0) {
        // 楼层个数+1
        _result.floors++;
      }
      
      // 房间内数据
      let _roomInfo = json[roomId] || {};

      // 设备数
      _result.devs += (_roomInfo.devs?.length || 0);
      // 场景数
      _result.scenes += (_roomInfo.scenes?.length || 0);
    }
    return _result;
  },
  // 删除家庭
  showDeleteModal (e) {
    console.log("showDeleteModal");
    let index = this.data.familyIndex || 0;
    let _familys = this.getAllFamilys() || [];
    // 判断是否最后一个，如果是，则提示用户清空家庭还是
    if (_familys.length == 1) {
      return wx.showModal({
        title: "确定删除家庭吗？",
        content: "当前家庭为最后一个家庭，点击删除会清除当前家庭所有数据",
        showCancel: true,
        confirmText: "确定",
        cancelText: "取消",
        cancelColor: '#000000'
      }).then(result => {
        if (!result?.confirm) {
          return;
        }
        this.deleteFamily(index, true);
        ability.navigateBack();
      })
    }
    // 删除家庭
    let _familyInfo = _familys[index];
    let _n = (_familyInfo.n || '');
    // 如果家庭名称太长，则省略成16个长度
    _n = (_n.length > 16) ? _n.substr(0, 16) : _n;
    // 删除家庭
    wx.showModal({
      title: "",
      content: "是否删除家庭【" + _n + '】?',
      showCancel: true,
      confirmText: "是",
      cancelText: "否",
      cancelColor: '#000000'
    }).then(result => {
      if (!result?.confirm) {
        return;
      }
      this.deleteFamily(index);
      ability.navigateBack();
    })
  },
  deleteFamily (index, clearAll) {
    // 家庭列表
    let _familys = this.getAllFamilys() || [];
    let _familyInfo = _familys[index] || {};

    // 删除对应的家庭id下的所有设备信息
    delete app.globalData.allFamilysMap[_familyInfo.id];

    if (!!clearAll) {
      // 清空该家庭下的所有数据
      let _newFamilyInfo = this.getResetFamilys();
      let _allFamilys = [_newFamilyInfo];
      return this.clearAll(_allFamilys);
    }

    // 判断删除房间是否当前房间，如果是的话，则默认选择第一个
    let _isCurrent = _familyInfo.id == app.globalData.familyInfo?.id;
    // 删除家庭
    _familys.splice(index, 1);
    // 非当前家庭，则忽略
    if (!_isCurrent) {
      // 保存数据
      return app.saveWhenHide();
    }
    // 如果原先的家庭只有只读权限
    if (app.globalData.roleNum != 2) {
      // 删除之前的网关
      app.deletePrivateData();
    }

    // 默认选择第一个家庭
    let _currentFamily = _familys[0];
    // 更新家庭数据
    app.globalData.familyInfo = _currentFamily;
    // 更新角色
    app.globalData.roleNum = _currentFamily.roleNum || 0;
    // 更新控制密钥
    app.globalData.blsdk.updateBleCode(_currentFamily.bleCode);
    app.globalData.blsdk.updateSeq(_currentFamily.seq);
    
    // 更新
    if (app.globalData.roleNum == 2) {
      app.globalData.blsdk.updateCtrlTimestamp(_currentFamily.devTimestamp || 0);
    } else {
      app.globalData.blsdk.updateCtrlTimestamp(0);
    }
    
    // 设备信息更新
    app.globalData.devs = app.globalData.allFamilysMap[_currentFamily.id];

    // 增加默认数据
    bizUtil.addDefaultGroupByDevs(app.globalData.devs);

    // 查找当前家庭有无网关设备
    let _newGateway = bizUtil.getGatewayInfo(app.globalData.devs);
    app.globalData.blsdk.updateGatewayInfo(_newGateway);
    // 关闭远程
    app.globalData.blsdk.clseRemoteDebug();
    // 远程调试关闭
    app.globalData.familyInfo.isRemote = false;

    // 保存数据
    app.saveWhenHide();
  },
})