// family/name/index.js
import ability from "../../utils/classDef/ability";
import bizUtil from "../../utils/bizUtil"
import GROUPS from "../../static/js/jsConfig/groups"
const app = getApp()
var tabBehavior = require('../../static/js/behavior/tab')
Page({

  behaviors: [tabBehavior],

  /**
   * 页面的初始数据
   */
  data: {
    index: -1, // 家庭修改的下表，如果新增，则为-1
    name: '',
    groupIndex: 0, // 默认选择第0个集群

    isAdd: true, // 默认是新增
    groups: GROUPS
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 设置家庭下标
    // this.data.index = Number(options);
    // 根据下标初始化标题
    this.initTitleByType(options);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // 保存数据
    app.saveWhenHide();
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 根据type初始化页面标题
  initTitleByType ({index, name}) {
    let _str = "";
    if (index >= 0) {
      _str = '家庭名称修改';
      // 更新名称
      this.initEditName(decodeURIComponent(name));
      // 新增
      this.data.isAdd = false;
    } else {
      _str = '创建家庭';
      // 新增
      this.data.isAdd = true;
    }
    this.data.index = Number(index);
    // 设置标题
    ability.setNavigationBarTitle(_str);
    // 设置是否显示集群
    this.setData({
      isAdd: this.data.isAdd
    })
  },
  initEditName (name) {
    this.data.name = name || '';
    this.setData({
      name: this.data.name
    })
  },
  
  clearName () {
    this.data.name = "";
    this.setData({
      name: ''
    })
  },

  nameInput (e) {
    let _name = e.detail.value;
    if (_name.length > 16) {
      this.showToast("家庭名称长度不能大于16").then((isConfirm) => {
        this.setData({
          devName: _name.substr(0, 16)
        })
      });
      return;
    }
    this.data.name = _name;
    console.log("nameInput _name = ", _name);
  },
  showToast (str) {
    return wx.showModal({
      showCancel: false,
      content: str
    });
  },
  // 根据名称和id取得名称相同的家庭个数
  getSameNameCountInArrayByNameAndId (array, name, id) {
    if (!array) {
      return;
    }
    // console.log("getSameNameCountInArrayByNameAndId array, name, id = ", array, name, id);
    // id == undefined ||  && (id != item.id)
    let _exists = array.filter(item => (item.id != id || id == undefined) && (item.n == name));
    // console.log("getSameNameCountInArrayByNameAndId _exists = ", _exists);
    return _exists.length;
  },

  saveName () {
    let _newName = this.data.name;
    // 判断是否为空
    if (!_newName) {
      return ability.showToast({
        title: "名称不能为空"
      });
    }
    // 房间列表
    let _familys = app.globalData.familys || [];
    // 编辑还是新增家庭
    let _index = this.data.index;
    let _isEditFamily = _index >= 0;
    // 检查是否重名
    let _existCount = this.getSameNameCountInArrayByNameAndId(_familys, _newName, _isEditFamily ? (_familys[_index]?.id) : undefined);
    console.log("saveName _existCount = ", _existCount, _familys, _index);
    if (_existCount > 0) {
      return ability.showToast({
        title: "家庭名称不能为重复"
      });
    }
    if (_isEditFamily) {
      let _familyInfo = _familys[_index];
      if (!_familyInfo) {
        return;
      }
      // 编辑
      _familyInfo.n = _newName;
    } else {
      let _bleCode = app.globalData.blsdk.getNewBleCode();
      let _seq = app.globalData.blsdk.getNextSeq();
      // 取得新的家庭数据
      let _newFamilyInfo = bizUtil.getOriginFamilyInfo(_bleCode, _seq);
      // 取得家庭id
      let _id = bizUtil.getIdByArray(_familys, 'id');
      _newFamilyInfo.id = _id;
      _newFamilyInfo.n = _newName;
      // 加入家庭列表
      _familys.push(_newFamilyInfo);
      
      // 取得空家庭下的所有数据
      let _originRoom = bizUtil.getOriginRooms();
      let _emptyFamily = bizUtil.initDevByRooms({}, _originRoom, true);

      // 根据家庭的id增加对应的数据
      app.globalData.allFamilysMap[_id] = _emptyFamily;

      // 切换到新家庭
      this.familyChangeDetail(app.globalData.familys.length - 1);
    }
    // 返回上一页
    ability.navigateBack();
  },

  groupClick (e) {
    let {index} = e.currentTarget.dataset;
    // let _item = this.data.groups[index];
    this.data.groupIndex = index;
    this.setData({
      groupIndex: this.data.groupIndex
    })
  }
})