// family/name/index.js
import ability from "../../utils/classDef/ability";
import bizUtil from "../../utils/bizUtil"
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    roomId: -1, // 房间id，如果新增，则为-1
    name: '',

    // 房间id
    familyId: undefined
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 根据下标初始化标题
    this.initTitleByType(options);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  // 根据type初始化页面标题
  initTitleByType ({roomId, name, familyId}) {
    let _str = "";
    if (roomId >= 0) {
      _str = '楼层名称修改';
      // 更新名称
      this.initEditName(decodeURIComponent(name));
    } else {
      _str = '创建楼层';
    }
    // 家庭id
    this.data.familyId = familyId;
    // 房间id
    this.data.roomId = Number(roomId);
    console.log("initTitleByType this.data.roomId = ", this.data.roomId);
    ability.setNavigationBarTitle(_str);
  },
  initEditName (name) {
    this.data.name = name || '';
    this.setData({
      name: this.data.name
    })
  },
  
  clearName () {
    this.data.name = "";
    this.setData({
      name: ''
    })
  },

  nameInput (e) {
    let _name = e.detail.value;
    if (_name.length > 16) {
      this.showToast("家庭名称长度不能大于16").then((isConfirm) => {
        this.setData({
          devName: _name.substr(0, 16)
        })
      });
      return;
    }
    this.data.name = _name;
    console.log("nameInput _name = ", _name);
  },
  showToast (str) {
    return wx.showModal({
      showCancel: false,
      content: str
    });
  },

  // 根据家庭id取得数据
  getAllDevsByFamilyId () {
    let _familyId = this.data.familyId;
    let _devs = undefined;
    if (_familyId >= 0) {
      _devs = app.globalData.allFamilysMap[_familyId];
    }
    return _devs || app.globalData.devs;
  },

  checkName (name, roomId) {

    // 根据家庭id取得设备数据
    let _allFamilyDevs = this.getAllDevsByFamilyId();

    let _names = bizUtil.getFloorNames(_allFamilyDevs);
    let _filter = _names.filter(item=>(item.n==name&&roomId!=item.id));
    return _filter.length;
  },

  saveName () {
    let _newName = this.data.name;
    // 判断是否为空
    if (!_newName) {
      ability.showToast({
        title: "名称不能为空"
      })
      return;
    }

    // 编辑还是新增家庭
    let _roomId = this.data.roomId;

    // 判断是否重复
    let _exist = this.checkName(_newName, _roomId);
    if (_exist) {
      return ability.showToast({
        title: "名称已存在，请重新编辑"
      })
    }
    // 根据家庭id取得设备数据
    let _allFamilyDevs = this.getAllDevsByFamilyId();
    // 判断
    if (_roomId >= 0 && _allFamilyDevs[_roomId]) {
      // 编辑
      _allFamilyDevs[_roomId].n = this.data.name;
    } else {}
    // 返回上一页
    ability.navigateBack();
  }
})