// groups/name/index.js
import ability from '../../utils/classDef/ability'
import bizUtil from "../../utils/bizUtil"
const app = getApp();
Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备名称"
      }
    },
    index: 0,
    devName: '',
    fromPage: "",
    bleUnavailable: false
  },
  onLoad (options) {
    // 接收参数
    this.getNameByOption(options);
  },
  // 优先从option中获取参数
  getNameByOption (options) {
    console.log("getParamByOption options = ", options);
    let {name, fromPage, index} = options;
    this.data.fromPage = fromPage;
    this.data.index = index;
    // 初始化标题
    this.initTitleByFrom(this.data.fromPage);
    if (!name) {
      return;
    }
    // 初始化设备名称
    this.initDevName(decodeURIComponent(name));
  },
  initTitleByFrom (fromPage) {
    let _str = "";
    if (fromPage == "addGroup") {
      _str = "创建群组";
    } else {

    }
    console.log("initTitleByFrom _str = ", _str);
    ability.setNavigationBarTitle(_str)
  },
  initDevName (name) {
    let _name = name || "";
    if (_name.length > 16) {
      _name = _name.substr(0, 16);
    }
    this.data.devName = _name;
    this.setData({
      devName: this.data.devName
    })
  },

  clearName () {
    this.data.devName = "";
    this.setData({
      devName: ''
    })
  },

  nameInput (e) {
    let _name = e.detail.value;

    // 只能输入汉字 字母和数字
    _name = _name.replace(/[^\w\u4E00-\u9FA5]/g, '');
    
    // 判断长度
    if (_name.length > 16) {
      this.showToast("设备名称长度不能大于16").then((isConfirm) => {
        this.setData({
          devName: _name.substr(0, 16)
        })
      });
      return;
    }
    this.data.devName = _name;
    this.setData({
      devName: this.data.devName
    })
    console.log("nameInput _name = ", _name);
  },
  showToast (str) {
    return wx.showModal({
      showCancel: false,
      content: str || "设备名称长度不能大于16"
    });
  },
  saveName () {

    let _name = (this.data.devName || '').trim();
    if (_name.length == 0) {
      this.showToast("名称不能为空");
      return;
    } else if (_name.length > 16) {
      this.showToast("名称长度不能大于16");
      return;
    }

    // 群组中是否有相同数据
    let _saveArray = bizUtil.getExistNameCountByDevInJson(app.globalData.devs, { gid: 0}, _name);
    console.log("editName _saveArray = ", _saveArray);
    if (_saveArray.length > 0) {
      return ability.showToast({
        title: "名称不能重复"
      });
    }
    
    // 跳转到批量选择页面
    return ability.redirectTo("/pages/batch/index?from=groupcreate&type=light&title=" + encodeURIComponent(_name) + "&rid=" + (app.globalData.roomInfo?.id || 0))
  },
  // 判断名称是否重复
  checkName (name, d) {
    console.log();
    if (!d) {
      return false;
    }
    for (let roomId in app.globalData.devs) {
      let {devs} = app.globalData.devs[roomId];
      if (!devs || devs.length == 0) {
        continue;
      }
      for (let item of devs) {
        if (d != item.d && name == item.n) {
          // _isRepeat = true;
          return true;
        }
      }
    }
    return false;
  }
})
