// minePages/backup/accountDetail/index.js
const app = getApp();
const ability = require("../../../utils/classDef/ability");
const accountBehavior = require("../../js/behavior/account")
Page({
  behaviors: [accountBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    topItems: [],
    // 底部按钮
    bottomBtns: [{
      text: "退出登录",
      className: "delBtn",
      handle: "logout",
      key: "logout"
    }],
    isLogined: true, // 默认已经登陆
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    let _userInfo = app.globalData.userInfo || {};
    // 取得编辑的类型
    this.loginType = this.checkLoginType(_userInfo?.nickname);
    // 初始化头部
    this.initTopItemsByType(this.loginType, _userInfo);
  },
  initTopItemsByType (type, userInfo) {
    let _items = this.getAllItems(type, userInfo);
    // 判断是否登陆
    let _isLogined = userInfo?.userid && userInfo?.loginsession;
    if (!_isLogined) {
      _items = _items.slice(0, 1);
    }
    // 判断是否登陆
    this.setData({
      topItems: _items,
      isLogined: !!_isLogined
    })
  },
  getAllItems (type, {nickname, brandname}) {
    return [
    //   {
    //   title: "用户名",
    //   value: brandname || "",
    //   edit: true,
    //   key: "brandname"
    // }, 
    {
      title: type == "email" ? "邮箱" : "手机",
      value: nickname || "",
      edit: false,
      key: "phoneEmail"
    }, {
      title: "修改密码",
      value: "",
      edit: true,
      key: "password"
    }, {
      title: "账号注销",
      value: "",
      edit: true,
      key: "logoff"
    }];
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  topItemClick (e) {
    let {index} = e?.detail || {};
    let {title, value, key} = this.data.topItems[index];
    // name, from, index, title
    if (key == "logoff") {
      ability.navigateTo("../logoff/index?title=" + encodeURIComponent(title));
    } else if (key == "password") {
      ability.navigateTo("../register/index?type=changepassword&title=" + encodeURIComponent(title));
    } else if (key == "brandname") {
      ability.navigateTo("/device/light/deviceName/index?from=accountdetail&title=" + encodeURIComponent(value));
    }
  },
  // 退出登陆
  logout () {
    this.saveUserInfo({});
    // 返回上一页
    setTimeout(() => {
      this.back();
    }, 1000);
  },
  back () {
    ability.navigateBack();
  }
})