// minePages/backup/forget/index.js
import bizUtil from "../../../utils/bizUtil"
import ability from "../../../utils/classDef/ability"
// import {Utils} from "../../../utils/util"

const app = getApp()
const shareBehavior = require("../../js/behavior/share")
Page({
  behaviors: [shareBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    type: "", // 备份还是还原
    timeStr: "", // 时间
    bottomBtnName: "", // 底部按钮名称
    isAllSelected: false, // 是否全选
    itemList: [], // 内容列表

    queryComplete: false, // 是否发现完毕

    selectIndex: -1, // 选中的下标
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    let {type} = options || {};
    this.initDataByType(type);
  },

  initDataByType (type, isEmptyData) {
    console.log("initDataByType type = ", type);
    // this.type = type; // backup/download 备份和还原
    this.setData({
      type: type,
      queryComplete: false
    });
    // 初始化标题
    this.initNavTitle(type);
    // 初始化条目
    this.initItemListByType(type, isEmptyData);
    // 根据上一步的数据判断是否全选
    this.initAllSelectedByList(this.data.itemList);
  },

  initAllSelectedByList (list) {
    let _allSelected = this.getAllSelected(list || []);
    this.setData({
      isAllSelected: _allSelected
    })
  },

  // 取得是否全选
  getAllSelected (list) {
    // 取得是否全部选中
    let _selectItems = this.getSelectedIds(list);
    let _selectItemsLen = _selectItems.length;
    console.log("getAllSelected _selectItemsLen = ", _selectItemsLen, list?.length);
    if (_selectItemsLen == list?.length && _selectItemsLen > 0) {
      // 全部选中
      return true;
    } else {
      // 全选未选中
      return false;
    }
  },

  initNavTitle (type) {
    let _title = type == "backup" ? "云端备份" : "云端还原";
    ability.setNavigationBarTitle(_title);
  },

  initItemListByType (type, isEmptyData) {
    // 更新的数据
    let _updateObj = {};
    if (type == "backup") {
      // _updateObj.itemList = (app.globalData.familys || []).concat([]);
      console.log("initItemListByType isEmptyData = ", isEmptyData);
      _updateObj.bottomBtnName = "立即备份";
      // // 这里不能显示当前时间
      // _updateObj.timeStr = Utils.formatTime(undefined, {
      //   sep1: "/",
      //   sep3: ":"
      // });
      // 获取已备份数据 用于显示备份时间
      if (isEmptyData) {
        this.initDownLoadDataByList([]);
        this.setData({
          queryComplete: true
        });
      } else {
        this.downloadAllFamily(type);
      }
    } else {
      _updateObj.bottomBtnName = "立即还原";
      // 获取已备份数据
      this.downloadAllFamily(type);
    }
    this.setData(_updateObj)
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    // 默认全选
    this.dealAllChecked(true);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },

  // 全选按钮点击
  allCheckClick () {
    let _isAllSelect = this.data.isAllSelected;
    this.dealAllChecked(!_isAllSelect);
  },
  dealAllChecked (value) {
    console.log("dealAllChecked value = ", value);

    let _currentVal = value || false;
    this.data.itemList.map(item => {
      item.selected = _currentVal;
      return item;
    })
    console.log("dealAllChecked this.data.itemList = ", this.data.itemList);
    this.setData({
      isAllSelected: _currentVal,
      itemList: this.data.itemList
    })
  },
  // 是否选中框
  itemSelClick (e) {
    // let _itemList = this.data.itemList || [];
    let {index} = e.currentTarget.dataset;
    // let _item = _itemList[index] || {};
    // _item.selected = !_item.selected;
    // // 取得是否全部选中
    // this.data.isAllSelected = this.getAllSelected(_itemList);

    // let _selectItems = this.getSelectedIds(_itemList);
    // let _selectItemsLen = _selectItems.length;
    // console.log("itemSelClick _selectItemsLen = ", _selectItemsLen, _itemList.length);
    // if (_selectItemsLen == _itemList.length && _selectItemsLen > 0) {
    //   // 全部选中
    //   this.data.isAllSelected = true;
    // } else {
    //   // 全选未选中
    //   this.data.isAllSelected = false;
    // }
    // let _updateList = `itemList[${index}].selected`;
    this.setData({
      // isAllSelected: this.data.isAllSelected,
      // [_updateList]: _item.selected,
      selectIndex: index
    })
  },

  // 取得选中的条目
  getSelectedIds (itemArray) {
    if (!itemArray) {
      return [];
    }
    let _filters = itemArray.filter(item => item.selected);
    return _filters;
  },
  // 取得选中的条目
  getSelectedIndexArray (itemArray) {
    let _result = [];
    if (!itemArray) {
      return _result;
    }
    for (let i = 0, len = itemArray.length; i < len; i++) {
      let item = itemArray[i];
      if (item.selected) {
        _result.push(i);
      }
    }
    return _result;
  },
  
  // 底部按钮点击
  bottomBtnClick () {
    let _type = this.data.type;
    // 判断页面类型
    if (_type == "backup") {

      // 最后的数据


      // // 备份成功页面内 res < 0 备份失败
      // let _extendStr = (1 < 0) ? ("&imgKey=fail&type=3") : ("&imgKey=success&type=2");
      // ability.navigateTo("../../toastPage/index?count=-1" + _extendStr);
      // return;

      // 备份
      this.backupAllFamily((res) => {
        setTimeout(() => {
          // 不返回上一个页面
          // this.back(1);
          // 刷新数据
          this.downloadAllFamily(false, () => {
            // 取得第一条数据
            let _data = this.data.itemList[0];
            let _len = _data?.tip?.length || 0;
            _data.tip = _data?.tip?.substring(0, _len - 3) || "";
            _data.tip = _data.tip.replaceAll("-", "/");
            console.log("_data.tip = ", _data.tip);
            // 备份成功页面内 res < 0 备份失败
            let _extendStr = (res < 0) ? ("&imgKey=fail&type=3") : ("&imgKey=success&type=2");
            ability.navigateTo("../../toastPage/index?count=5" + _extendStr + "&extend=" + encodeURIComponent(JSON.stringify(_data)));
          });
        }, 500);
      });
    } else if (_type == "download") {
      if (this.data.selectIndex < 0) {
        return ability.showToast({
          title: "请选择要还原的数据"
        })
      }
      // 还原
      this.downloadModal();
    }
  },
  downloadModal () {
    ability.showModal({
      title: "",
      content: "还原将会覆盖本地所有数据，是否还原？",
      showCancel: true,
      confirmColor: "#576B95",
      confirmText: "确定",
      cancelText: "取消",
      cancelColor: '#000000',
    }).then(res => {
      // 还原选中数据
      console.log("downloadModal res = ", res);
      if (!res) {
        return;
      }
      // 取得选中的数据
      let _indeList = this.getSelectedIndexArray(this.data.itemList);
      // console.log("downloadModal this.data.itemList = ", this.data.itemList);
      console.log("downloadModal _indeList = ", _indeList, this.downloadArray);
      let _item = this.downloadArray[this.data.selectIndex];
      console.log("downloadModal _item = ", _item);
      // 先解base64
      let _decodeBase64Str = app.globalData.blsdk.base64Decode(_item.data);
      console.log("downloadModal _decodeBase64Str = ", _decodeBase64Str, typeof _decodeBase64Str);
      let _decodeBase64Array = JSON.parse(_decodeBase64Str);
      console.log("downloadModal _decodeBase64Array = ", _decodeBase64Array, typeof _decodeBase64Array);

      // 解析base64的数据
      let _array = this.getListByDownloadData(_decodeBase64Array);
      let _indexArray = _array.map((item, index) => index);
      console.log("downloadModal _array = ", _array);
      this.dealDownloadData(_indexArray, _array);
      // 提示成功 1s后返回
      ability.showToast({
        title: "还原成功",
        icon: "success"
      });
      setTimeout(() => {
        this.back();
      }, 1000);
    })
  },
  // 处理需要还原的数据
  dealDownloadData (indexArray, dataArray) {
    console.log("dealDownloadData array = ", indexArray, dataArray);
    if (!indexArray || !dataArray || indexArray.length == 0) {
      return ability.showToast({
        title: "请选择需要还原的数据"
      });
    }
    let _familyInfo = {}; // 当前家庭信息
    let _allFamilysMap = {}; // 家庭信息集合
    let _familys = []; // 家庭列表
    let _gatewayInfo = {};
    for (let i = 0, len = indexArray.length; i < len; i++) {
      let _index = Number(indexArray[i]) || 0;
      let {_devs, _newFamilyObj, gatewayInfo} = dataArray[_index] || {};
      if (!_devs || !_newFamilyObj) {
        continue;
      }
      _newFamilyObj.id = (i + 1);
      _familys.push(_newFamilyObj);
      _allFamilysMap[_newFamilyObj.id] = _devs;
      // 当前家庭 默认第一个
      if (i == 0) {
        _familyInfo = _newFamilyObj;
        _gatewayInfo = gatewayInfo || {};
      }
    }
    // 设备状态
    let _allDevStatus = {}; 
    app.globalData.allStatus = _allDevStatus;
    // 如果有网关设备，则设置
    !!(_gatewayInfo) && (app.globalData.blsdk.updateGatewayInfo(_gatewayInfo));
    // 更新家庭数据 , gatewayInfo: _gatewayInfo
    app.updateSDKByFamilyConfig({familyInfo: _familyInfo});
    // 保存所有家庭数据
    app.globalData.familys = _familys;
    // 保存家庭id对应的设备数据
    app.globalData.allFamilysMap = _allFamilysMap;
    // 所有设备信息
    app.globalData.devs = _allFamilysMap[_familyInfo?.id] || {};
    // 增加默认的群组
    bizUtil.addDefaultGroupByDevs(app.globalData.devs);
    // 保存设备状态
    app.setBizStorage("devStatus", _allDevStatus);
    // 保存信息
    app.saveWhenHide();
  },
  // 取得base64集合数组
  getBackUpData() {
    // 取得数据集合
    let _base64Array = [];
    // 取得选中的家庭id
    let _selectedFamilys = app.globalData.familys; // this.getSelectedIds(this.data.itemList);
    if (_selectedFamilys.length == 0) {
      return _base64Array;
    }
    // 所有家庭数据
    let _allFamilysMap = app.globalData.allFamilysMap || {};
    for (let item of _selectedFamilys) {
      let _allDevs = _allFamilysMap[item?.id];
      if (!_allDevs) {
        continue;
      }
      _base64Array.push(this.getWxData(false, {
        devs: _allDevs,
        family: item,
        roleNum: item?.roleNum,
        needDefaultScene: true, // 需要备份默认场景
        shareTime: item?.devTimestamp
      }));
    }
    return _base64Array;
  },
  // 备份按钮点击
  backupAllFamily (callback) {
    // 取得mtag
    let _mtagArray = this.data.itemList.map(item => item.mtag);
    let _mtag = this.getMtagByMtagArray(_mtagArray);
    if (!_mtag) {
      ability.showModal({
        title: "",
        content: "最多备份5个,超出将覆盖最早的数据。是否备份？",
        showCancel: true,
        // confirmColor: "#576B95",
        confirmText: "备份",
        cancelText: "取消",
        // cancelColor: '#000000',
      }).then(res => {
        if (!res) {
          return;
        }
        // 最后一个备份数据
        let _len = this.data.itemList.length;
        // 备份
        this.backupAllFamilyDetail(callback, this.data.itemList[_len - 1]?.mtag);
      })
      // ability.showToast({
      //   title: "最多备份5个数据"
      // })
      return;
    } else {
      this.backupAllFamilyDetail(callback, _mtag);
    }
  },
  backupAllFamilyDetail (callback, mtag) {
    // 等待条
    this.showLoading("数据备份中…")
    // 取得base64数据
    let _base64Array = this.getBackUpData();
    console.log("backupAllFamily _base64Array = ", _base64Array);
    if (_base64Array.length == 0) {
      // 等待条
      ability.hideLoading();
      // 提示
      return ability.showToast({
        title: "请选择需要备份的数据"
      })
    }
    // 备份
    let _base64Str = app.globalData.blsdk.base64Encode(JSON.stringify(_base64Array));
    console.log("backupAllFamily _base64Str = ", _base64Str);
    
    // 备份
    this.backups(false, _base64Str, callback, mtag);
    // // 解析base64
    // let _base64DecodeStr = app.globalData.blsdk.base64Decode(_base64Str);
    // console.log("downloads _base64String = ", _base64DecodeStr);
  },
  // 还原家庭数据
  downloadAllFamily (type, callback) {
    // this.downloads(false, (res, updateTime) => {
    this.downloads(!!callback, (res, updateTime) => {
      console.log("downloadAllFamily res = ", res);
      // // 更新时间 备份5个
      // this.updateTimeStr(bizUtil.getTotalFormatByTimeStr(updateTime));
      // console.log("downloadAllFamily updateTime = ", updateTime);
      // // if (type == "backup") {
      // //   ability.hideLoading();
      // //   return;
      // // }

      // 如果没有数据
      if (!res || res.length == 0) {
        // 发现结束
        this.setData({
          queryComplete: true
        });
        // 如果需要回调
        !!callback && (callback());
        return this.showEmptyModal();
      }
      // 取得数据列表
      this.initDownLoadDataByList(res);
      // 发现结束
      this.setData({
        queryComplete: true
      });
      // 如果需要回调
      !!callback && (callback());
    });
  },
  // 更新updateTime
  updateTimeStr (timeStr) {
    this.setData({
      timeStr: timeStr || ""
    })
  },
  // 提示空数据
  showEmptyModal () {
    ability.showModal({
      title: "",
      content: "暂无备份数据，是否去备份？",
      showCancel: true,
      // confirmColor: param.confirmColor || "#576B95",
      confirmText: "去备份",
      // cancelText: param.cancelText || "取消",
      // cancelColor: param.cancelColor || '#000000',
    }).then(res => {
      if (!res) {
        this.back();
        return;
      }
      // 备份数据
      this.backupAllFamily(() => {
        this.initDataByType(this.data.type);
      });
      // this.initDataByType("backup", true);
    })
  },
  getListByDownloadData (res) {
    let _result = [];
    if (!!res && res.length > 0) {
      for (let base64Str of res) {
        let _obj = this.dealBase64Str(base64Str, true);
        if (!_obj) {
          continue;
        }
        _result.push(_obj)
      }
    }
    return _result;
  },
  getItemListByDownload (array) {
    let _result = [];
    if (!!array && array.length > 0) {
      for (let obj of array) {
        let _obj = obj["_newFamilyObj"];
        if (!_obj) {
          continue;
        }
        _result.push(_obj)
      }
    }
    return _result;
  },
  // 获取数据列表
  initDownLoadDataByList (res) {
    console.log("initDownLoadDataByList res = ", res);
    // // 保存下载的数据
    // this.downloadArray = this.getListByDownloadData(res);
    // // 取得需要渲染的列表
    // this.data.itemList = this.getItemListByDownload(this.downloadArray);

    this.downloadArray = res || [];
    console.log("initDownLoadDataByList this.downloadArray = ", this.downloadArray);
    // 取得需要渲染的列表
    this.data.itemList = this.downloadArray.map((item, index) => {
      return {
        tip: bizUtil.getTotalFormatByTimeStr(item?.updatatime || ""),
        n: this.getMtagName(item.mtag, index),
        mtag: item.mtag
      }
    });
    // 排序
    this.data.itemList = this.data.itemList.sort((a, b) => a.mtag - b.mtag);

    // 默认全选
    this.dealAllChecked(true);

    this.setData({
      itemList: this.data.itemList
    });
  },
  back () {
    ability.navigateBack();
  },

  // radioClick (e) {
  //   let {index} = e.currentTarget.dataset;
  //   console.log("radioClick index = ", index);

  //   this.setData({
      
  //   })
  // }
})