import bizUtil from "../../../utils/bizUtil"
const ability = require("../../../utils/classDef/ability");

const app = getApp();
const accountBehavior = require("../../js/behavior/account")
// minePages/backup/register/index.js
Page({
  behaviors: [accountBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    // 注册信息
    registObj: {
      phoneEmail: "",
      code: "",
      password: "",
      rePassword: ""
    },
    loginType: 0, // 默认邮箱注册
    // 验证码倒计时定时器
    timer: null,
    count: 0,
    type: "regist", // 默认注册 忘记密码forget、注册regist、修改密码changepassword、注销logoff等等
    btnName: "注册"
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    console.log("onLoad options = ", options);
    let {title, type, phoneEmail} = options || {};
    let _title = decodeURIComponent(title || "");
    let _defaultPhoneEmail = decodeURIComponent(phoneEmail || "");
    this.data.registObj.phoneEmail = _defaultPhoneEmail || "";
    // 设置标题
    this.setNavTitle(_title);
    // 根据type设置底部按钮名称
    let _btnName = _title; // this.getNameByType(type);
    // 初始化默认数据
    this.getDefaultDataByType(type);
    // 设置类型
    this.setData({
      registObj: this.data.registObj,
      type: type,
      btnName: _btnName
    })
  },

  getDefaultDataByType (type) {
    if (type == "logoff" || type == "changepassword") {
      let {userid, nickname, phone, email} = app.globalData.userInfo;
      // 注销
      this.data.registObj.phoneEmail = nickname;
      this.setData({
        registObj: this.data.registObj
      })
    }
  },

  setNavTitle (str) {
    ability.setNavigationBarTitle(str || "")
  },
  getNameByType (type) {
    let _result = "";
    if (!type) {
      return _result
    }
    // 默认注册 忘记密码forget、注册regist、修改密码changepassword、注销logoff等等
    switch (type) {
      case "forget":
        _result = "忘记密码";
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {
    // 清理定时器
    bizUtil.clearTimer(this.data.timer, "interval");
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },
  // 开始定时器
  startTimer () {
    // if (this.data.timer) {
    //   console.log("startTimer this.data.timer = ", this.data.timer)
    //   return;
    // }
    // 清除定时器
    bizUtil.clearTimer(this.data.timer);
    // 设置数据
    this.setProperValueByKey("count", 60);
    // 定时器
    this.data.timer = setInterval(() => {
      let _count = this.data.count - 1;
      if (!this.data.timer) {
        return;
      }
      if (_count <= 0) {
        _count = 0;
        // 清除定时器
        bizUtil.clearTimer(this.data.timer);
      }
      // 更新数据
      this.setProperValueByKey("count", _count)
    }, 1000);
  },
  // 设置并更新属性
  setProperValueByKey (key, val, noUpdate) {
    if (this.data == undefined) {
      return;
    }
    this.data[key] = val;

    // 不需要更新
    if (noUpdate) {
      return;
    }

    this.setData({
      [key]: val
    })
  },
  // 发送验证码
  sendCode () {
    // 判断是否在发送中
    if (this.data.count > 0) {
      return;
    }
    // 清除定时器
    bizUtil.clearTimer(this.data.timer);
    // 提示类型
    let _tipStr = "邮箱或手机号码";
    // 手机号码
    let {phoneEmail} = this.data.registObj;
    if (phoneEmail.length == 0) {
      return this.showToastMsg("请输入" + _tipStr);
    }
    // 取得注册类型
    let _type = this.checkLoginType(phoneEmail);
    if (!_type) {
      return this.showToastMsg(_tipStr + "格式不正确");
    }
    // 发送数据
    let _obj = {
      type: _type,
      [_type]: phoneEmail,
      apiKey: "registSendCode"
    };
    // 如果是注销
    let _pageType = this.data.type;
    if (_pageType == "logoff" || _pageType == "changepassword" || _pageType == "forget") {
      // 注销
      let {userid, loginsession} = app.globalData.userInfo || {};
      _obj.userid = userid;
      _obj.loginsession = loginsession;
      if (_pageType == "logoff") {
        _obj.apiKey = "newdestroycode";
      } else if (_pageType == "changepassword" || _pageType == "forget") {
        _obj.apiKey = "retrivecode";
      }
    }
    app.globalData.blsdk.sendAccountCode(_obj).then(res => {
      let {error, msg} = res || {};
      if (error == 0) {
        this.showToastMsg("发送验证码成功", "success");
        // 开始定时器计数
        this.startTimer();
      } else {
        console.log("sendCode res = ", res);
        this.showToastMsg(this.dealErrorMsg(error) || msg || "发送验证码失败", "error")
      }
    }).catch(e => {
      console.log("sendCode e = ", e);
      this.showToastMsg("发送验证码失败", "error")
    })
  },
  // 注册按钮点击
  registAccount () {
    // 注册信息
    let {phoneEmail, code, password, rePassword} = this.data.registObj;
    console.log("registAccount this.data.registObj = ", this.data.registObj);
    // 全部不能为空
    if (!phoneEmail || !code || !password || !rePassword) {
      return this.showToastMsg("输入内容不能为空");
    } else if (password != rePassword) {
      return this.showToastMsg("密码和确认密码必须一致");
    } else if (password.length < 6 || password.length > 18) {
      return this.showToastMsg("密码为6-18位");
    } else if (!this.checkPassword(password)) {
      return this.showToastMsg("密码包含数字和字母");
    }
    // 取得提示类型
    let _type = this.checkLoginType(phoneEmail);
    // 校验内容
    console.log("registAccount _type, phoneEmail = ", _type, phoneEmail);
    if (!_type) {
      return this.showToastMsg("邮箱/手机号码格式不正确");
    }
    // 取得注册类型
    let _registerObj = {
      code: code,
      password: password,
      type: _type,
      apiKey: "register"
    };
    _registerObj[_type] = phoneEmail;
    console.log("registAccount _registerObj = ", _registerObj);
    app.globalData.blsdk.registerAccount(_registerObj).then(res => {
      console.log("registAccount res = ", res);
      let {status, error, msg} = res || {};
      if (status == 0) {
        // 注册成功
        this.showToastMsg("注册成功", "success");
        setTimeout(() => {
          this.back(2);
        }, 1000);
        // 保存用户信息
        this.saveUserInfo(res, {
          phoneEmail: phoneEmail
        });
      } else {
        this.showToastMsg(this.dealErrorMsg(error) || msg || "注册失败", "error");
      }
    }).catch(e => {
      console.error("registAccount e = ", e);
      this.showToastMsg("注册失败", "error");
    });
  },
  back (num) {
    ability.navigateBack(num || 1);
  },
  showToastMsg (msg, icon) {
    let _toastObj = {
      title: msg || ""
    };
    !!icon && (_toastObj.icon = icon);
    ability.showToast(_toastObj);
  },
  phoneChange (e) {
    this.setRegistObj("phoneEmail", e.detail.value.trim());
  },
  codeChange (e) {
    this.setRegistObj("code", e.detail.value);
  },
  passwordChange (e) {
    let _val = e.detail.value;
    if (_val > 18) {
      _val = _val.substring(0, 18);
    }
    this.setRegistObj("password", _val);
  },
  rePasswordChange (e) {
    let _val = e.detail.value;
    if (_val > 18) {
      _val = _val.substring(0, 18);
    }
    this.setRegistObj("rePassword", _val);
  },
  setRegistObj (key, value) {
    this.data.registObj[key] = value;
    this.setProperValueByKey("registObj", this.data.registObj);
  },
  // 根据类型校验数据
  checkDataByType (type, value) {
    let _method = type == "email" ? "checkEmail" : "checkMobile";
    return this[_method](value);
  },
  // type: "regist", // 默认注册 忘记密码forget、注册regist、修改密码changepassword、注销logoff等等
  bottomBtnClick () {
    let _type = this.data.type;
    // 底部按钮点击
    if (_type == "logoff") {
      // 注销账号
      this.logoffAccount();
    } else if (_type == "changepassword" || _type == "forget") {
      // 修改信息
      this.modifyInfo();
    } else {
      // 默认注册账号
      this.registAccount();
    }
  },  
  checkContent () {
    let _msg = "";
    // 注册信息
    let {phoneEmail, code, password, rePassword} = this.data.registObj;
    let _type = this.data.type;
    let _isLogoff = _type == "logoff";
    console.log("checkContent this.data.registObj = ", this.data.registObj);
    // 全部不能为空
    if (_isLogoff) {
      // 注销只需要判断手机邮箱和验证码
      if (!phoneEmail || !code) {
        _msg = "输入内容不能为空";
      }
    } else {
      if (!phoneEmail || !code || !password || !rePassword) {
        _msg = "输入内容不能为空";
      } else if (password != rePassword) {
        _msg = "密码和确认密码必须一致";
      } else if (password.length < 6 || password.length > 18) {
        _msg = "密码为6-18位";
      } else if (!this.checkPassword(password)) {
        _msg = "密码包含数字和字母";
        // return this.showToastMsg("密码必须包含数字和字母");
      }
    }
    // 有消息则提示
    if (_msg) {
      this.showToastMsg(_msg);
    }
    return _msg;
  },
  // 注销账号
  logoffAccount () {
    // 先校验内容是否输入
    let _toastMsg = this.checkContent();
    if (_toastMsg) {
      return;
    }
    // 用户信息
    let {userid, loginsession} = app.globalData.userInfo || {};
    // 输入信息
    let {phoneEmail, code} = this.data.registObj;
    let _type = this.checkLoginType(phoneEmail);
    app.globalData.blsdk.logoffAccount({
      code: code,
      type: _type,
      [_type]: phoneEmail,
      userid: userid,
      loginsession: loginsession,
      apiKey: "destroy"
    }).then(res => {
      console.log("logoffAccount res = ", res);
      let {status, error, msg} = res || {};
      if (status == 0) {
        // 注册成功
        this.showToastMsg("注销成功", "success");
        setTimeout(() => {
          this.back(2);
        }, 1000);
        // 保存用户信息
        this.saveUserInfo({});
      } else {
        this.showToastMsg(this.dealErrorMsg(error) || msg || "注销失败", "error");
      }
    }).catch(e => {
      console.error("logoffAccount e = ", e);
      this.showToastMsg("注销失败", "error");
    });
  },
  // 修改密码
  modifyInfo () {
    // 先校验内容是否输入
    let _toastMsg = this.checkContent();
    if (_toastMsg) {
      return;
    }
    // 用户信息
    let {userid, loginsession} = app.globalData.userInfo || {};
    // 输入信息
    let {phoneEmail, code, password} = this.data.registObj;
    let _type = this.checkLoginType(phoneEmail);
    app.globalData.blsdk.modifyInfoByCode({
      code: code,
      type: _type,
      [_type]: phoneEmail,
      newpassword: password,
      userid: userid,
      loginsession: loginsession,
      apiKey: "retrivepwd"
    }).then(res => {
      console.log("modifyInfo res = ", res);
      let {status, error, msg} = res || {};
      if (status == 0 && error == 0) {
        // 注册成功
        this.showToastMsg("修改密码成功", "success");
        setTimeout(() => {
          this.back(2);
        }, 1000);
        // 保存用户信息
        this.saveUserInfo(res, {
          phoneEmail: phoneEmail
        });
      } else {
        this.showToastMsg(this.dealErrorMsg(error) || msg || "修改密码失败", "error");
      }
    }).catch(e => {
      console.error("logoffAccount e = ", e);
      this.showToastMsg("修改密码失败", "error");
    });
  }
})