const ability = require("../../../utils/classDef/ability");

// minePages/deviceShare/lastTime/index.js
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    items: [{
      title: "永久",
      value: 1
    }],
    days: [1],
    hours: [1],
    minutes: [1],
    current: [0, 23, 59]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 接收参数
    let {timestamp, key} = options || {};
    // 取得传递过来的时分秒参数
    this.timeStamp = timestamp || 0;
    // key
    this.key = key || "";
  },
  getDataByTimestamp (timestamp) {
    if (timestamp == undefined || timestamp == 0) {
      return [0, 23, 59];
    }
    if (timestamp < 60) {
      return [0, 0, 0]
    }
    let _day = parseInt(timestamp / (24 * 3600)) || 0;
    let _h = parseInt((timestamp - _day * 24 * 3600) / 3600) || 0;
    let _m = parseInt((timestamp - _day * 24 * 3600 - _h * 3600) / 60) || 0;
    return [_day, _h, _m];
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    // 如果有时间戳，则不是永久
    let _timestamp = this.timeStamp;
    if (_timestamp > 0) {
      this.updateLimitVal(0);
    }
    // 把时间戳转成天 小时 分钟
    let _data = this.getDataByTimestamp(_timestamp);
    // 初始化天数，小时和分钟数据
    this.initTimes(_data);
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  initTimes (data) {
    // 初始化天数
    this.data.days = this.getArray(0, 30);
    // 初始化小时
    this.data.hours = this.getArray(0, 24);
    // 初始化分钟
    this.data.minutes = this.getArray(0, 60);
    // 默认选择的数据
    this.initCurrentDate(data);

    this.setData({
      days: this.data.days,
      hours: this.data.hours,
      minutes: this.data.minutes
    })
  },
  initCurrentDate (value) {
    // 这里必须要用延迟
    setTimeout(() => {
      console.log("initCurrentDate value = ", value)
      this.setData({
        current: value || [0, 23, 59],
      })
    }, 0);
  },
  getArray (min = 0, max = 60) {
    let _array = [];
    for (let i = min; i < max; i++) {
      _array.push(i);
    }
    return _array
  },

  // 永久分享按钮改变事件
  switchLimit (e) {
    this.updateLimitVal(e.detail.value);
  },

  updateLimitVal (value) {
    // let _value = e.detail.value;
    this.data.items[0].value = value || 0;
    this.setData({
      items: this.data.items
    })
  },

  bindChange (e) {
    let _vals = e.detail.value;
    console.log("bindChange _vals = ", _vals);

    // // 如果时长选择了0 0 0，则提示用户不可用选择
    // let _current = this.data.current;
    // if (_current[0] == 0 && _current[1] == 0) {
    //   // 需要更新默认的分钟数
    // }

    this.data.current = _vals || [];
    // 如果永久选中，则取消永久的选中
    this.updateLimitVal(0);
  },

  save () {
    // 判断当前选择的是永久还是具体时间
    let _isNoLimit = this.data.items[0].value || 0;
    let _qrTime = 0;
    if (_isNoLimit) {
      // 选中
      _qrTime = 0;
    } else {
      // 未选中时取得时间戳
      let _current = this.data.current || [];
      let _curTimestamp = _current[0] * 24 * 3600 + _current[1] * 3600 + _current[2] * 60;
      // let _timestamp = (_curTimestamp ? _curTimestamp : 1);
      _qrTime = _curTimestamp;

      // // 最大时长
      // let _maxTimestamp = app.globalData.tmpData?.maxQrTime || 2592000;

      console.log("save _qrTime = ", _qrTime);
      // 如果选中0时0分0秒，则提示
      if (!_qrTime) {
        return ability.showToast({
          title: "请设置分享时长"
        });
      } 
      // else if (_qrTime > _maxTimestamp) {
      //   let _str = this.getStrByTimestamp(_maxTimestamp);
      //   if (_str) {
      //     return ability.showToast({
      //       title: "最大分享时长为" + _str
      //     });
      //   }
      // }
    }
    // 保存总的时间戳
    let _key = this.key || "qrTime";
    app.globalData.tmpData[_key] = _qrTime;
    // 返回上一个页面
    ability.navigateBack();
  },
  getStrByTimestamp (timestamp) {
    if (timestamp == undefined || timestamp == 0) {
      return "";
    }
    if (timestamp < 60) {
      return "0"
    }
    let _day = parseInt(timestamp / (24 * 3600));
    let _h = parseInt((timestamp - _day * 24 * 3600) / 3600);
    let _m = parseInt((timestamp - _day * 24 * 3600 - _h * 3600) / 60);
    let _str = "";
    (_day) && (_str += _day + '天');
    (_h) && (_str += _h + '小时');
    (_m) && (_str += _m + '分钟');
    return _str;
  },
})