// minePages/deviceShare/shareSocket/chooseDev/index.js
import ability from '../../../../utils/classDef/ability'
import bizUtil from '../../../../utils/bizUtil'
// 引入protoBuf类
// import protoBuf from "../../../../utils/protobuf/protoUtil"
// import GROUPS from "../../../../static/js/jsConfig/groups"
import {aesUtil} from "../../../../utils/classDef/util"
import {Utils} from "../../../../utils/util"
import shareBehavior from "../../../js/behavior/share"
import CryptoJS from "../../../../utils/classDef/crypto-js"
const app = getApp();
Page({
  behaviors: [shareBehavior],
  /**
   * 页面的初始数据
   */
  data: {
    roomId: 0,
    devs: [], // 场景列表
    selects: {}, // 选择的数据

    currentSteps: 6, // 同步智慧面板的当前步骤，默认未开始

    // 设备列表
    actions: [{
      handles: "back",
      classStr: "delBtn",
      text: "上一步"
    }, {
      handles: "transferInfo",
      classStr: "colorF78D3F borderF78D3F marginL50",
      text: "完成"
    }]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 上一步选择的房间
    let _roomId = options.roomId || 0;
    this.data.roomId = _roomId;
    // 取得场景数据
    let _allDevs = [];
    if (_roomId == 0) {
      // 所有设备
      _allDevs = bizUtil.getAllDevsFilter(app.globalData.devs) || [];
    } else if (_roomId % 32 == 0) {
      // 取得楼层数据
      let _devJson = bizUtil.getDevsArrayByFloor(app.globalData.devs, parseInt(_roomId / 32 - 1)) || {};
      _allDevs = bizUtil.getAllDevsFilter(_devJson);
    } else {
      _allDevs = (app.globalData.devs[_roomId] || {}).devs || [];
    }
    // 分类数据
    let _allObjs = bizUtil.getAllPidByArray(_allDevs);

    // 面板需要处理成情景面板和开关面板
    let _allPanels = _allObjs.panel || [];
    if (_allPanels.length > 0) {
      let _pwrPanels = [], _panels = [];
      for (let item of _allPanels) {
        if (bizUtil.isPwrAvalibleDev(item.t)) {
          _pwrPanels.push(item)
        } else {
          _panels.push(item)
        }
      }
      _allObjs.pwrPanels = _pwrPanels;
      _allObjs.panels = _panels;
    }

    // 遍历数据，加上数据的品类显示
    let _result = [];
    for (let key in _allObjs) {
      // 遍历数据
      let _tmpDevs = _allObjs[key] || [];
      if (_tmpDevs.length == 0 || key == "panel") {
        continue;
      }
      let _obj = {
        key: key,
        list: _tmpDevs
      }
      // 暂时支持窗帘和照明设备
      if (key == "light") {
        _obj.n = "照明";
      } else if (key == "curtain") {
        _obj.n = "窗帘";
      } else if (key == "pwrPanels") {
        _obj.n = "开关面板";
      } else if (key == "panels") {
        _obj.n = "情景面板";
      } else if (key == "fanLight") {
        _obj.n = "风扇灯";
      } else if (key == "gateway") {
        _obj.n = "网关";
      } else if (key == "doorsensor") {
        _obj.n = "门磁";
      } else if (key == "bodysensor") {
        _obj.n = "人体传感器";
      } else if (key == "watersensor") {
        _obj.n = "水浸传感器";
      }
      _result.push(_obj)
    }

    this.data.devs = _result || [];
    this.setData({
      devs: this.data.devs
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    if (!app.globalData.socket) {
      return;
    }
    ability.closeSocket(app.globalData.socket);
    app.globalData.socket = null;
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  chooseDev (e) {
    let {index, keyidx} = e.currentTarget.dataset;
    console.log("chooseDev index, keyIdx = ", index, keyidx, e.currentTarget.dataset);
    let {list} = this.data.devs[keyidx] || {};

    let {d} = (list || [])[index] || {};
    if (!d) {
      return;
    }
    console.log("chooseDev d = ", d);
    // 是否存在数据
    if (this.data.selects[d]) {
      delete this.data.selects[d];
    } else {
      this.data.selects[d] = d;
    }
    this.setData({
      selects: this.data.selects
    })
  },
  transferInfo () {
    // 如果没有选择，则不能进入下一步
    let _devs = Object.keys(this.data.selects) || [];
    // if (_devs.length == 0) {
    //   return ability.showToast({
    //     title: "请至少选择一个设备"
    //   })
    // }
    app.globalData.screenInfo = app.globalData.screenInfo || {};
    app.globalData.screenInfo.devs = _devs;
    // 开始同步数据
    this.getAllData(app.globalData.screenInfo);
  },
  getAllData (screenInfo) {
    let _familyInfo = app.globalData.familyInfo || {};
    let _roleNum = this.data.roleNum == undefined ? _familyInfo.roleNum : this.data.roleNum;
    // 获取小程序数据的字符串
    let _allData = this.getWxData(screenInfo, {
      devs: app.globalData.devs,
      family: _familyInfo,
      needDefaultScene: true,
      roleNum: _roleNum,
      shareTime: app.globalData.tmpData.qrTime
    });
    if (_allData == undefined) {
      return;
    }
    // 生成二维码
    this.transferDetail(_allData);
  },
  // 二维码
  transferDetail (base64Str) {
    if (!base64Str) {
      return;
    }
    // 取得私钥
    let {iv, key} = this.getPrivateKey();

    // 保持和app统一 暂时不分包
    let _shareStr = JSON.stringify({
      "data": base64Str || "",
      "msgid": app.globalData.screenInfo?.mac + "" + parseInt(Date.now()),
      "total":1,
      "index":0
    });
    // _shareStr = '{"data":"VC6ee93e4l4exuRc8haLW8a3W+uxi+Um3pBpzDpTT\/BtA0vzfMl61kvT\/my7h\/Ag45aeWPbT7k67pdEt2bph61Q6TvG7i9Ij35lD8DoEa26ONGPVfDoep25UHfVuBkPwOgRLxWQ\/T+pvGE33cAJC3nE8d\/Zs08ZtubfU\/GpVStT05nncThR3oT0GGaJvBkv8alVK9F0McvBwB1XybRhP80QZcchvB55599H6a2YCGPZOnKvGRjhZyDtVS6Y4B0v0ZgIY9m43Qc1qGErqaAVV8GkUX8xcLnrmWNP+bLuzyO5MXxirMGkIpztYHps\/WhebMVAd9Fx2euZzPnPcXxRrLNmcnmrE0sJNu6rBIseZSe5PXxirMGkIpztYHps9QwiwMVtLzR4yUcFtGEnqbnxgpzZYVvw7ARmnZgEa6jdUCas\/UhetMF1VpzFb","msgid":"2418C69B1C1C1638758085","total":1,"index":0}';

    let _data2 = aesUtil.aesEncrypt(_shareStr, CryptoJS.enc.Hex.parse(key), CryptoJS.enc.Hex.parse(iv), {
      padding: "Pkcs7"
    });
    console.log("transferDetail _data2 = ", _data2, iv, key);
    
    // 等待条
    ability.showLoading({
      title: "同步中…"
    });

    // 数据加上之后发送
    this.sendData(_data2);

    // 往后做个延迟处理
    setTimeout(() => {
      // 如果当前状态还是处于授权状态，则提示失败
      if (this.data.currentSteps != 6) {
        return;
      }
      // 去掉等待条
      ability.hideLoading();
      // 提示信息
      ability.showToast({
        title: "同步失败",
        icon: "error"
      })
    }, 8000);
  },
  getCharFromStr (str) {
    let _str = str || '';
    let _result = [];
    for (let i = 0, len = _str.length; i < len; i++) {
      _result.push(_str.codePointAt(i));
    }
    return _result;
  },
  getPrivateKey () {
    // 缓存的86屏数据
    let _sceneInfo = app.globalData.screenInfo || {};
    // 加密数据
    let _data = CryptoJS.SHA256("fastcon ble" + (_sceneInfo.bleCode || "") + (_sceneInfo.mac || ""));
    let _str = CryptoJS.enc.Hex.stringify(_data);
    console.log("getPrivateKey _str = ", _str, _sceneInfo);
    // 取得前16字节作为iv，后16作为key
    let _hexIv = _str.substr(0, 32);
    let _hexKey = _str.substr(32, 32);
    return {
      iv: _hexIv,
      key: _hexKey
    }
  },
  sendData (str) {
    // 创建udp socket监听
    let _socket = app.globalData.socket;
    // 设置可选头数据
    let _optionHeadData = "";
    // 取得协议头
    let _headerArrays = this.getProbeHeader(6, (_optionHeadData.length / 2));
    console.log("_headerArrays = ", Utils.ab2hex(_headerArrays));
    // 取得payload数据
    let _payload = str; // this.getPayload();
    // 加上payload数据
    _headerArrays = _headerArrays.concat(Utils.hexStrToArray(_payload))
    // 取得checksum
    let _checkSumHex = this.getCheckSumHex(_headerArrays);
    _headerArrays[8] = Number("0x" + _checkSumHex.slice(2));
    _headerArrays[9] = Number("0x" + _checkSumHex.slice(0, 2));
    console.log("_headerArrays = ", Utils.ab2hex(_headerArrays), _checkSumHex, _headerArrays, str);

    let _address = app.globalData.screenInfo?.ip || "255.255.255.255";
    let _buffer = new Uint8Array(_headerArrays).buffer;
    // 发送数据
    var sendSocket = () => {
      ability.sendSocket(_socket, {
        address: _address,
        port: 51812,
        message: _buffer
      });
    };
    // 发送数据
    sendSocket();
    // 1s后再次发送数据
    setTimeout(sendSocket, 1000);

    ability.onMessageSocket(_socket, this.data.onMessage = (res) => {
      console.log("onMessageSocket res = ", res);
      let _array = Array.prototype.slice.call(new Uint8Array(res.message), 0);

      // 取得前12个字节的数据
      let _magic = _array.slice(0, 4);
      let _msgtype = _array.slice(4, 6);
      // let _seq = _array.slice(6, 8);
      // let _checksum = _array.slice(8, 10);
      // let _optlen = _array.slice(10, 11);
      // let _version = _array.slice(11, 12);

      // 如果magic不一致，则退出
      let _magicStr = Utils.ab2hex(_magic);
      if (_magicStr != "a5a55a5a") {
        console.error("_magicStr = ", _magicStr);
        return;
      }

      // 判断数据是否要解析
      let _msgTypeStr = _msgtype[0];
      if (_msgTypeStr < 3) {
        return;
      }

      console.log("_msgTypeStr = ", _msgTypeStr);
      if (_msgTypeStr == 7) {

        // 如果接收过，则不继续处理
        if (this.data.currentSteps >= 7) {
          return;
        }

        // 当前状态
        this.data.currentSteps = 7;

        // 去掉等待条
        ability.hideLoading();

        // 取消监听时间
        ability.offMessage(app.globalData.socket, this.data.onMessage);
        ability.offError(app.globalData.socket, this.data.onError);
        // 提示同步成功
        ability.showToast({
          title: "同步成功",
          icon: "success"
        });
        // 跳转下一页
        setTimeout(() => {
          this.navigateBack(3);
        }, 1500);
      }
    });
    ability.onErrorSocket(_socket, this.data.onError = (res) => {
      console.log("onError res = ", res);
      ability.showToast({
        title: res?.errMsg || JSON.stringify(res || "")
      })
    });
  },
  getProbeHeader (msgtype, optlen) {
    // 固定头 hex 4个字节
    let _result = [0xA5, 0xA5, 0x5A, 0x5A];
    // msgtype 2个字节
    let _msgTypeStr = (msgtype || '0').toString(16).padStart(4, 0);
    _result.push(Number(_msgTypeStr.slice(2, 4)) || 0);
    _result.push(Number(_msgTypeStr.slice(0, 2)) || 0);
    // Sequenece  2个字节
    let _seq = "c7b6"; // app.globalData.blsdk.getNextSeq();
    // _seq = _seq.toString(16).padStart(4, 0);
    _result.push(Number("0x" + _seq.slice(2, 4)) || 0);
    _result.push(Number("0x" + _seq.slice(0, 2)) || 0);
    console.log("_seq = ", _seq);
    // checksum  2个字节
    let _checkSum = [0, 0];
    _result.push(_checkSum[1]);
    _result.push(_checkSum[0]);
    // 可选头 optlen 1个字节
    let _optlen = optlen || 0;
    _result.push(_optlen);
    // 协议版本 1个字节 version
    let _version = 0;
    _result.push(_version);

    return _result; /* {
      magic: "5A5AA5A5", // 
      msgtype: _msgTypeStr, // hex 2个字节
      seq: _seq, // hex 2个字节
      checksum: "0000",  // hex 2个字节
      optlen: (optlen || 0).toString(16).padStart(2, 0), // 可选头部的长度，当前为0 1字节
      version: "00" // 1字节
    }*/
  },
  getCheckSumHex (data) {
    let _result = 0xbeaf;
    // 判断类型
    if (!data) {
      return _result;
    } else if (typeof data == "string") {
      // 16进制的算法
      _result += bizUtil.getSumByHexStr(data);
    } else if (data instanceof Object) {
      let _vals = Object.values(data);
      for (let item of _vals) {
        if (typeof item == "string") {
          // 16进制的算法
          _result += bizUtil.getSumByHexStr(item);
        } else if (typeof item == "number") {
          _result += item;
        }
      }
    } else if (data instanceof Array) {
      for (let item of data) {
        if (typeof item == "string") {
          // 16进制的算法
          _result += bizUtil.getSumByHexStr(item);
        } else if (typeof item == "number") {
          _result += item;
        }
      }
    }
    // 返回两个字节的数据
    let _resultStr = _result.toString(16).padStart(4, 0);
    return _resultStr.slice(-4); // 从后面开始往前数4个长度
  },
  back () {
    this.navigateBack();
  },
  navigateBack (num) {
    ability.navigateBack(num || 1);
  }
})