// minePages/deviceShare/shareSocket/chooseRoom/index.js
import ability from '../../../../utils/classDef/ability'
import bizUtil from '../../../../utils/bizUtil'
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    rooms: [],
    roomNames: [],
    selectRoomIdx: 0, // 默认选择全屋
    roomId: 0, // 默认的房间id

    // 设备列表
    actions: [{
      handles: "back",
      classStr: "delBtn",
      text: "上一步"
    }, {
      handles: "next",
      classStr: "colorF78D3F borderF78D3F marginL50",
      text: "下一步"
    }]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 初始化房间
    this.initRooms();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 初始化房间
  initRooms () {
    
    // let _devs = app.globalData.devs || {};

    // 所有设备
    let _allDevs = app.globalData.devs || {};
    // 当前楼层
    let _floor = app.globalData.familyInfo?.floor || 0;
    // 根据多楼层取得数据
    let _devs = bizUtil.getDevsByFloor(_allDevs, _floor);


    let {rooms} = bizUtil.getRoomsByDevs(_devs);
    let _rooms = rooms || [];
    this.data.rooms = _rooms;
    // 取得房间列表
    let _roomNames = [];
    for (let index in _rooms) {
      let item = _rooms[index];

      // 默认的房间id
      if (item.id == this.data.roomId) {
        this.data.selectRoomIdx = index;
      }
 
      _roomNames.push(item.n);
    }
    this.data.roomNames = _roomNames;
    this.setData({
      roomNames: this.data.roomNames,
      rooms: this.data.rooms,
      selectRoomIdx: this.data.selectRoomIdx
    })
  },
  bindPickerChange (e) {
    let _value = e.detail.value;
    console.log('picker发送选择改变，携带值为', _value);
    this.data.selectRoomIdx = _value;
    let _item = this.data.rooms[_value];
    this.data.roomId = _item.id; // 选中的房间id
    this.setData({
      selectRoomIdx: this.data.selectRoomIdx
    })
  },
  chooseRoom (e) {
    let {index} = e.currentTarget.dataset;
    this.data.selectRoomId = this.data.rooms[index]?.id || 0;
    this.setData({
      selectRoomId: this.data.selectRoomId
    })
  },
  next () {
    // 如果没有选择，则不能进入下一步
    let _roomId = this.data.roomId;
    if (_roomId < 0) {
      return ability.showToast({
        title: "请选择房间"
      })
    }
    app.globalData.screenInfo = app.globalData.screenInfo || {};
    app.globalData.screenInfo.roomId = _roomId;
    ability.navigateTo("../chooseScene/index?roomId=" + _roomId)
  },
  back () {
    ability.navigateBack();
  }
})