import ERRORMSG from "../../../static/js/jsConfig/errorcode"
import bizUtil from "../../../utils/bizUtil"
var app = getApp();
module.exports = Behavior({
  // behaviors: [],
  // data: {
  // },
  // pageLifetimes: {
  //   show (options) {
  //   }
  // },
  // ready () {
  // },
  methods: {
    // 判断是邮箱登录还是手机登陆
    checkLoginType (value) {
      let _typeStr = "";
      if (!value) {
        return _typeStr;
      }
      if (this.checkEmail(value)) {
        return "email";
      }
      if (this.checkMobile(value)) {
        return "phone";
      }
      return _typeStr;
    },
    // 验证邮箱的规则
    checkEmail (value) {
      //  验证邮箱的正则表达式
      const regEmail = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
      console.log("checkEmail value = ", value);
      return regEmail.test(value);
    },
    // 验证手机号的规则
    checkMobile (value) {
      //  验证手机号的正则表达式
      // const regMobile = /^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/
      const regMobile = /^1[3456789]\d{9}$/;//使用此正则即可
      return regMobile.test(value);
    },
    saveUserInfo (userInfo, config) {
      if (!userInfo) {
        return;
      }
      let {phoneEmail} = config || {};
      // 保存用户信息
      console.log("saveUserInfo userInfo = ", userInfo);
      // , nickname
      let {userid, loginsession, phone, email, countrycode} = userInfo;
      // 用户信息
      app.globalData.userInfo = {
        userid,
        loginsession,
        nickname: phone || email || phoneEmail, // nickname || 
        phone,
        email,
        countrycode,
        brandname: app.globalData.userInfo?.brandname || ""
      };
      console.log("saveUserInfo app.globalData.userInfo = ", app.globalData.userInfo);
      // 设置缓存
      app.setBizStorage("userInfo", app.globalData.userInfo);
    },
    dealErrorMsg (errorCode) {
      if (errorCode == -1012) {
        // 退出账号登陆
        app.resetUserInfo();
      }
      return bizUtil.dealErrorMsg(errorCode, ERRORMSG);
    },
    // 密码复杂度校验
    checkPassword (password) {
      var pwdRegex = new RegExp('(?=.*[0-9])(?=.*[a-zA-Z]).{6,18}');
      return pwdRegex.test(password || "");
    }
  }
})