import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil"

var app = getApp();
module.exports = Behavior({
  // behaviors: [tabsBehavior],
  data: {
  },
  pageLifetimes: {
    show (options) {
    }
  },
  ready () {
  },
  methods: {
    showToast (str, icon) {
      ability.showToast({
        title: str || "",
        icon: icon
      })
    },
    showLoading (str) {
      ability.showLoading({
        title: str
      })
    },
    back () {
      ability.navigateBack();
    },

    deleteRoom (json, roomInfo, callback) {
      if (!roomInfo || !json) {
        return;
      }
      let {id, n} = roomInfo;
      // 提示是否删除
      ability.showModal({
        title: "",
        content: "删除房间会删除该房间下的场景，请确认是否删除【" + (n || '') + "】",
        showCancel: true,
        confirmColor: "#E02020"
      }).then(res => {
        // 取消长按
        this.data.isLongTap = false;
        if (!res) {
          return;
        }
        // 删除房间方法
        this.deleteRoomDetail(json, id, callback);
      })
    },
    deleteRoomDetail (json, rid, callback) {
      if (rid == undefined || !json) {
        return;
      }
  
      // 删除房间接口
      bizUtil.deleteRoom(rid, json);
  
      // 保存所有设备
      app.saveWhenHide();
      // 数据上报
      app.uploadPrivateData();
      // 回调
      callback && (callback());
    },
  }
})