import ability from "../../../utils/classDef/ability";
import {Utils} from "../../../utils/util"
// 引入protoBuf类
import protoBuf from "../../../utils/protobuf/protoUtil"
import bizUtil from "../../../utils/bizUtil"
import GROUPS from '../../../static/js/jsConfig/groups'
import ERRORMSG from "../../../static/js/jsConfig/errorcode"

var app = getApp();
var tabsBehavior = require("../../../static/js/behavior/tab")
module.exports = Behavior({
  behaviors: [tabsBehavior],
  data: {
  },
  // pageLifetimes: {
  //   show (options) {
  //   }
  // },
  // ready () {
  // },
  methods: {
    showToast (str, icon) {
      ability.showToast({
        title: str || "",
        icon: icon
      })
    },
    showLoading (str) {
      ability.showLoading({
        title: str
      })
    },
    // 取得分享的数据集合
    getWxData (screenInfo, config) {
      let {devs, family, roleNum, needDefaultScene, shareTime} = config || {};
      console.log("getWxData needDefaultScene = ", needDefaultScene);
      // 先获取数据
      let _devData = this.data.devData || this.getDevData(screenInfo, devs || app.globalData.devs, {
        needDefaultScene: needDefaultScene || false
      });
      console.log("getWxData _devData = ", _devData);
      return this.encodeData(_devData, family || app.globalData.familyInfo, roleNum, shareTime);
    },
    getDevData (screenInfo, allDevs, configObj) {
      let {needDefaultScene} = configObj || {};
      console.log("getDevData needDefaultScene = ", needDefaultScene);
      // 选中房间的长度
      let _is86Share = !!screenInfo;
      // 选中的房间id 如果大于等于0，则说明是分享86屏进入
      let _selectId = [], _dids = [], _sids = [];
      // 判断是否有场景信息
      if (_is86Share) {
        let {roomId, devs, scenes} = screenInfo; // devs did的数组 scenes sid的数组
        // 分享86屏数据
        _selectId = typeof roomId == "object" ? roomId : [roomId];
        _dids = devs || [];
        _sids = scenes || [];
      }

      console.log("getDevData screenInfo = ", screenInfo, _dids, _sids, _selectId);

      // 原始数据 json格式的
      let _devJson = allDevs || {};
      // 所有场景信息
      let _allScenes = bizUtil.getAllPanels(_devJson);
      // 按照要求整合的数据
      let _saveArray = [];
      for (let roomId in _devJson) {
        let _id = Number(roomId);
        let _roomDevs = _devJson[_id] || {};

        // 是否有房间被选中 默认未选中
        let _roomSelect = 1;
        if (_is86Share) {
          _roomSelect = Number(_selectId.indexOf(_id) >= 0);
        }
        
        let _devArray = (_roomDevs.devs || []); // 设备
        let _sceneArray = _roomDevs.scenes || []; // 场景
        let _groupArray = _roomDevs.groups || []; // 群组
        let _item = {
          "id": _id, // 房间id
          se: _roomSelect // 房间选择
        };
        // 判断房间名称是否有变化，如果没有，则不传
        // 12-07 所有房间都传
        _item.n = _roomDevs.n;
        // !!this.nameChanged(_roomDevs, _originRoomJson) && (_item.n = _roomDevs.n);
        
        // 判断房间是否选中 此时为86屏分享功能，需要传递楼层和全屋的数据
        if (_is86Share && !_roomSelect) {
          // 86屏未选中也需要传递楼层和全屋的场景
          if (_id % 32 == 0) {
            // 判断是否有场景
            _item.scenes = this.getScenes(_sceneArray, _id, {
              roomSel: _item.se,
              sceneSel: _sids,
              is86Share: _is86Share,
              needDefaultScene: needDefaultScene || false // 传默认场景
            });
          } else {
            _item.scenes = [];
          }
          // 86屏分享如果没有选中房间则不传群组和设备
          _item.devs = [];
          _item.groups = [];
          _saveArray.push(_item);
          continue;
        }

        // 判断是否有场景
        _item.scenes = this.getScenes(_sceneArray, _id, {
          roomSel: _item.se,
          sceneSel: _sids,
          is86Share: _is86Share,
          needDefaultScene: needDefaultScene || false
        });

        // 群组信息
        _item.groups = this.getGroupByRoomId(_groupArray, _id, _is86Share);
  
        // 判断名称是否有改变且设备大于0
        if (_item.n || _devArray.length > 0 || _sceneArray.length > 0) {
          _item.devs = this.getDevItem(_devArray, _id, _allScenes, {
            roomSel: _item.se,
            devSel: _dids,
            is86Share: _is86Share
          });
          // console.error("_item.devs = ", _item.devs);
        } else {
          continue;
        }
        _saveArray.push(_item);
      }
      return _saveArray;
    },
    encodeData (devArray, familyInfo, roleNum, shareTime) {
      // 取得bleCode
      let _bleCode = familyInfo?.bleCode || app.globalData.blsdk.getBleCode();
      console.log("_bleCode = ", _bleCode)
      if (!_bleCode || _bleCode.length == 0) {
        console.error("bleCode is empty");
        ability.showToast({
          title: "控制密钥为空，请充值后重新配对设备",
        })
        return;
      }
  
      // 当前家庭信息
      let _familyInfo = familyInfo || {};
  
      // 保存的数据
      var _json = {
        "t": parseInt(Date.now() / 1000),
        "n": _familyInfo.n || '',
        "k": Utils.ab2hex(_bleCode), // 控制密钥
        "rs": devArray || [],
        "v": app.globalData.companyInfo?.qrVersion,
        "ct": 0 // 15 * 60 // 15分钟有效
      };
      // 分享权限 默认为2
      let _roleNum = (roleNum == undefined) ? (familyInfo?.roleNum || 0) : (roleNum || 0); // this.data.roleNum;
      // let _roleNum = this.data.items[0].value || 0;
      if (_roleNum < 2) {
        _json.p = 1; // 管理权限
      } else {
        _json.p = 0; // 控制权限
      }
      // 设备有效时间戳
      let _time = shareTime; // app.globalData.tmpData.qrTime; // (this.data.time || '').split(":");
      // console.log("_time = ", _time);
      // if (_time.length >= 2) {
      console.log("_time = ", _time);
      if (_time != undefined && _time != 0) {
        _json.dt = _time; // Number(_time) + _json.t;
      } else {
        _json.dt = 0;
      }
      // 该家庭的连接的集群
      let _host = (GROUPS[_familyInfo.groupIndex] || GROUPS[0]).value;
      // 如果存在群组信息，则加入二维码传递
      _json.sr = _host || GROUPS[0].value;

      // 增加两个参数
      _json.sid = _familyInfo.sid || "";
      _json.skey = _familyInfo.skey || "";

      // buffer
      console.log("created _json, _roleNum = ", _json, _roleNum);
      let _encodeBuffer = protoBuf.createShareDataBean(_json);
  
      // 加密
      let _encode = app.globalData.blsdk.headDecode(_encodeBuffer);
      // base64
      let _base64 = ability.arrayBufferToBase64(_encode);
      console.log("_base64 = ", _base64);
      return _base64;
    },
    getGroupByRoomId (groupArray, roomId, is86Share) {
      if (!groupArray || groupArray.length == 0) {
        return [];
      }
      // 取得群组类型映射表
      let _groupMap = bizUtil.getMetaTypeMad();
      // 赋值
      let _result = [];
      for (let i = 0, len = groupArray.length; i < len; i++) {
        let {dids, gid, rid, id, n, t, bledevtype, ig, se} = groupArray[i] || {};
        
        // 分享的群组数据
        let _groupShareObj = {
          gid: gid,
          rid: rid || id || 0,
          t: bizUtil.getTypeByDevTypeStr(t, _groupMap), // _groupMap[t],
          n: n,
          dids: dids || [],
          // se: Number(se) || 0, // 默认都选中 同步给86屏幕使用
          ig: ig == undefined ? 0 : (Number(ig) || 0), // 默认都选中 同步给86屏幕使用
        }
        _groupShareObj.ignoreflag = Boolean(_groupShareObj.ig); // 86屏分享用true/false
        // // 判断是否默认场景 这里暂时没有把gid= t << 8 + rid
        // if (bledevtype == "GROUP") {
        //   _groupShareObj.gid = 
        // }
        // 加入数据
        _result.push(_groupShareObj);
      }
      return _result;
    },
    getScenes (origins, roomId, configs) {
      if (!origins || origins.length == 0) {
        return [];
      }

      // 传递数据
      let {roomSel, sceneSel, is86Share, needDefaultScene} = configs || {};

      console.log("getScenes origins = ", origins, is86Share);

      // 数据处理
      let _array = [];
      let _orCount = 0;
      for (let item of origins) {
        let {sid, rid, t, n, i, cmd, or, b, ig} = item;

        // console.log("getScenes roomId, t, sid = ", roomId, t, sid);
  
        // 因为加上了数据上报，所以需要加上默认场景
        if (!is86Share && !needDefaultScene && t >= 3) {
          continue;
        }

        // 是否选中 默认和房间保持一致
        let _isSelectScene = roomSel;
        if (is86Share) {
          // 86屏分享且房间选中的时候才选中
          _isSelectScene = roomSel ? Number(sceneSel?.indexOf(sid) >= 0) : false;
        }
  
        let _rid = (rid == undefined) ? roomId : rid;
        let _ignoreflag = ig == undefined ? 0 : (Number(ig) || 0);
        _array.push({
          sid: bizUtil.getSceneId(sid, _rid),
          rid: Number(_rid),
          t: t,
          n: n,
          b: b,
          i: bizUtil.wxToAppSceneI(i || 1),
          // cmd: _cmdStr, // 屏蔽了批量，所以不用传
          or: or || _orCount,
          se: Number(_isSelectScene), // 默认都选中
          ig: _ignoreflag, // 默认都选中 同步给86屏幕使用 云端私有数据用
          ignoreflag: Boolean(_ignoreflag)  // 86屏分享用true/false
        });
        _orCount += 1;
      }
      return _array;
    },
    getDevItem (array, roomId, allScenes, configs) {
      let {panelScenes, devScenes} = allScenes || {};

      // 分享数据
      let {roomSel, devSel, is86Share} = configs || {};

      console.log("getDevItem array, configs, allScenes = ", array, configs, allScenes);

      let _array = array || [];
      let _saveArray = [];
      for (let i = 0, len = _array.length; i < len; i++) {
        let _tmpDevInfo = _array[i] || {};
        let {n, t, a, d, v, e: eJson, k, sub, wd, ig} = _tmpDevInfo;
  
        // 防止房间id为空的情况
        _tmpDevInfo.id = roomId || 0;

        // 是否选中 默认和房间保持一致
        let _isSelectDev = roomSel;
        if (is86Share) {
          // 86屏分享且房间选中的时候才选中
          _isSelectDev = roomSel ? Number(devSel?.indexOf(d) >= 0) : false;
          // 如果86屏分享没有选中设备，则不传
          if (!_isSelectDev) {
            continue;
          }
        }
        
        let _newObj = {
          // "n": _item.n, // 设备名称
          t: t, // 设备类型
          a: a, // 设备短地址
          d: d, // 设备did
          or: _saveArray.length || 1, // 从1开始
          se: Number(_isSelectDev), // 默认都选中 同步给86屏幕使用
          ig: ig == undefined ? 0 : (Number(ig) || 0), // 默认都选中 同步给86屏幕使用
        };
        _newObj.ignoreflag = Boolean(_newObj.ig); // 86屏用true/false
        // 如果有wd
        !!wd && (_newObj.wd = wd);
        // 保存版本号
        !!v && (_newObj.v = v);
        // // 保存自定义场景信息
        // !!_item.ds && (_newObj.ds = _item.ds);
        // 如果设备名称为默认名称，则不发送名称
        // 12-07 改成都传
        _newObj.n = n;
        // 是否有sub数据
        if (sub >= 0) {
          _newObj.sub = sub;
        }
        // let _defaultName = app.globalData.blsdk.getDevDefaultName(t, d);
        // if (_defaultName != n) {
        //   _newObj.n = n;
        // }

        // 按键名称或者传感器名称
        let _dealEJson = this.getJsonByExtend(eJson, t) || {};
        if (!!_dealEJson && Object.keys(_dealEJson).length > 0) {
          _newObj.e = JSON.stringify(_dealEJson);
        }
        
        // 设备类型
        let _devTypeStr = bizUtil.getDevTypeStr(t);
        // 是否有场景信息
        let _ds = [];
        
        // 群组和超级面板设备
        console.error("getDevItem _devTypeStr = ", _devTypeStr);
        if (_devTypeStr == "uart" || _devTypeStr == "tvLamp") {
          _ds = this.getMetaPadDs(_tmpDevInfo, _devTypeStr);
        } else if (bizUtil.isActionDev(t) || _devTypeStr == 'gateway') {
          console.error("getDevItem isActionDev or gateway");
          // 这里场景可以增加循环场景，所以在这里处理
          let _isGateway = _devTypeStr == 'gateway';
          if (_isGateway) {
            _newObj.k = k;
          } else if (_devTypeStr == "panel" && bizUtil.isPwrAvalibleDev(t)) {
            // 取得设备的能力集合 是否支持背光能力
            let _vJson = this.getAbilityByV(v, t) || {};
            console.error("getDevItem panel metapadEnable _vJson = ", _vJson);
            if (_vJson.metapadEnable) {
              let _tmpDs = this.getMetaPadDs(_tmpDevInfo, _devTypeStr);
              console.error("getDevItem panel metapadEnable _tmpDs = ", _tmpDs);
              _ds = _ds.concat(_tmpDs);
            }
          }

          // 执行设备
          let _devScenes = devScenes[d] || []; // 自定义的设备信息
          for (let index in _devScenes) {
            let _tmpItem = _devScenes[index];
            if (!_tmpItem) {
              continue;
            }
            let {sid, key, tip} = _tmpItem;
            let _cmd = _tmpItem.cmd;
            // 为了兼容iOS分享，“current ”就是当前， “exception”就是不执行
            if (_cmd === undefined || _cmd === "") {
              _cmd = 'exception';
            } else if (_cmd && _cmd.length == 0) {
              _cmd = 'current';
            } else {
              if ((_cmd instanceof Array)) {
                _cmd = Utils.ab2hex(_cmd);
              }
            }
            // console.error("_cmd = ", _cmd, _tmpItem);

            // 如果是网关
            if (_isGateway) {
              _ds.push({
                sid: sid,
                cmd: tip || "",
                key: (_cmd.length == 4) ? (parseInt("0x" + _cmd.substr(2, 2))) : 0
              });
            } else {
              _ds.push({
                sid: sid,
                cmd: _cmd,
                key
              });
            }
          }
          // _ds = _devScenes;
        } else if (bizUtil.isPanelDev(t)) {
          // 触发设备
          let _keyScenes = panelScenes[d]; // 面板的信息
          console.log("_keyScenes = ", _keyScenes);
          if (!!_keyScenes) {
            let _keys = Object.keys(_keyScenes);
            let _vals = Object.values(_keyScenes);
            for (let index in _keys) {
              _ds.push({
                sid: Number(_vals[index]) || 0,
                key: Number(_keys[index]) || 0
              })
            }
          }
        }
        _newObj.ds = (_ds || ''); // .join(",");
        // 设置开关的自定义命令信息
        _saveArray.push(_newObj)
      }
      return _saveArray;
    },
    getAbilityByV (v, t) {
      // 是否支持背光
      let _json = bizUtil.getJsonByAblitys(v, "panel", {t});
      return _json || {};
    },
    getMetaPadDs (tmpDevInfo, devTypeStr) {
      let _ds = [];
      let _tmpDevInfo = tmpDevInfo || {};
      let {n, t, a, d, v, e: eJson, k, sub, wd, ig, ds} = _tmpDevInfo;
      // 超级面板与透传公用一个pid
      let _uartDs = ds || [];
      // 是否非耦合设备 如果是支持超级面板的继电器则默认都是耦合设备
      let _isUnCouple = devTypeStr == "panel" ? false : bizUtil.isUncoupleMetapad(t);
      for (let item of _uartDs) {
        // pwrPanelKey是绑定的开关面板的按键
        let {sid, rid, type, cmd, key, pwrPanelKey} = item;
        console.log("getDevItem sid, rid, type, cmd, key = ", sid, rid, type, cmd, key);
        // 特殊处理
        if (pwrPanelKey >= 0) {
          // 非耦合设备 绑定继电器开关
          _ds.push({
            sid: bizUtil.getSceneId(sid, rid || 0, type || 0),
            // 面板设备绑定的按键序号 耦合和之前一致，非耦合高8位type+低八位key
            key: (_isUnCouple ? ((type || 0) << 8) : 0) + Number(key) || 0,
            // 该场景设备执行命令  xxx|hexcmd byte4开始
            cmd: (cmd || "") + "|" + Utils.ab2hex([1 << pwrPanelKey])
          })
        } 
        else if (_isUnCouple) {
          // 非耦合设备
          _ds.push({
            sid: bizUtil.getSceneId(sid, rid || 0, type || 0),
            // 面板设备绑定的按键序号 耦合和之前一致，非耦合高8位type+低八位key
            key: ((type || 0) << 8) + Number(key) || 0,
            // 该场景设备执行命令  xxx|hexcmd byte4开始
            cmd: (cmd || "")
          })
        }
        else if (rid === undefined && type == undefined) {
          _ds.push({
            sid: sid,
            key: Number(key) || 0,
            cmd: cmd || ""
          })
        } else {
          _ds.push({
            sid: bizUtil.getSceneId(sid, rid, type),
            key: Number(key),
            cmd: cmd || ""
          })
        }
      }
      return _ds;
    },
    // 取得发送的extend信息 即e
    getJsonByExtend (eJson, t) {
      let _result = {};
      if (!eJson) {
        return _result;
      }
      // 按键名称
      if (eJson?.vGroups) {
        _result.vGroups = eJson.vGroups;
      }
      // 传感器面板
      if (eJson?.subs) {
        _result.subs = eJson.subs;
      }
      // 窗帘限位
      if (eJson?.curtainLimit) {
        _result.curtainLimit = eJson.curtainLimit;
      }
      // 双控
      if (eJson?.bindDevices) {
        let _list = this.dealBindDevices(eJson.bindDevices, t);
        if (!!_list) {
          _result.bindDevices = _list;
        }
      }
      // 炫彩
      if (eJson?.lightDazzle) {
        _result.lightDazzle = eJson.lightDazzle;
      }
      // 主设备
      if (eJson?.group) {
        _result.group = eJson.group;
      }
      return _result;
    },
    // 双控设备did, 目前是按照d保存的 为了前后统一
    dealBindDevices (bindDevices, t) {
      let _devTypeStr = bizUtil.getDevTypeStr(t);
      if (_devTypeStr != "virtualPanel") {
        return;
      }
      if (!bindDevices) {
        return [];
      }
      // 只有virtualPanel才能绑定开关面板 才有双控
      let _result = [];
      for (let item of bindDevices) {
        let {d, key} = item;
        _result.push({
          key,
          did: d
        });
      }
      return _result;
    },
    // 判断房间是否变化
    nameChanged (roomInfo, originRoomJson) {
      if (!originRoomJson || !roomInfo) {
        return false;
      }
      let _id = roomInfo.id;
      return roomInfo.n != (originRoomJson[_id] || {}).n;
    },
    // 取得所有的mtag
    getAllMtags () {
      return ["ble_families", "ble_families_1", "ble_families_2", "ble_families_3", "ble_families_4"];
    },
    // 取得mtag名称
    getMtagName (mtag, index) {
      if (!mtag) {
        return "";
      }

      // 如果有index，则按照index大小排序
      if (index != undefined) {
        return "备份" + ((Number(index) || 0) + 1);
      }

      let _index = this.getAllMtags().indexOf(mtag);
      if (_index < 0) {
        return "";
      }
      return "备份" + (_index + 1);
    },
    // 根据mtag列表取得不在列表中的数据
    getMtagByMtagArray (mtagArray) {
      let _mtags = this.getAllMtags();
      if (!mtagArray || mtagArray.length == 0) {
        return _mtags[0];
      }
      for (let mtag of _mtags) {
        if (mtagArray.indexOf(mtag) >= 0) {
          continue;
        }
        return mtag;
      }
      return "";
    },
    // 根据当前存在的私有数据个数取得mtag
    getMtagByCount (count) {
      let _mtags = this.getAllMtags();
      if (count >= 1) {
        return _mtags[count];
      }
      return _mtags[0];
    },
    getMtagByParams (mtag) {
      if (typeof mtag == "string") {
        return mtag;
      } else if (mtag instanceof(Array)) {
        return this.getMtagByMtagArray(mtag);
      }
      return "";
    },
    // 备份
    backups (loading, dataArray, callback, mtag) {
      // // 默认需要loading
      // !loading && (this.showLoading("数据备份中…"));

      // 取得mtag的值
      let _mtag = this.getMtagByParams(mtag);
      // 上报的集群域名
      let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
      
      let {userid, loginsession} = app.globalData.userInfo || {};
      app.globalData.blsdk.managePrivacy({
        action: "upsert", 
        userid: userid, 
        loginsession: loginsession,
        data: dataArray,
        mtag: _mtag,
        remoteHost: _groupStr
      }).then(res => {
        // 默认需要loading
        !loading && (ability.hideLoading());
        console.log("backups res = ", res);
        this.showToast("备份成功", "success");
        // 返回上一页
        !!callback && (callback(0));
        // setTimeout(() => {
        //   this.back(needback);
        // }, 1000);
      }).catch(e => {
        ability.hideLoading();
        console.log("backups e = ", e);
        let _str = this.dealErrorMsg(e?.data?.status || e?.data?.error) || "备份失败";
        this.showToast(_str, "none");
        // 回调失败
        !!callback && (callback(-1));
      });
    },
    // 还原
    downloads (loading, callback) {
      // 默认需要loading
      !loading && (this.showLoading("获取数据中"));
      // 上报的集群域名
      let _groupStr = GROUPS[Number(app.globalData.familyInfo?.groupIndex) || 0]?.value || GROUPS[0].value;
      
      let {userid, loginsession} = app.globalData.userInfo || {};
      app.globalData.blsdk.managePrivacy({
        action: "query",
        userid: userid,
        loginsession: loginsession,
        mtag: this.getAllMtags(),
        remoteHost: _groupStr
      }).then(res => {
        console.log("downloads res = ", res);
        
        // 判断是否成功
        if (res.status == 0) {
          let _data = res.data;
          // 如果不存在备份数据的场合
          if (!_data || _data.length == 0) {
            !!callback && (callback([], ""));
            // 默认需要loading
            !loading && (ability.hideLoading());
            return;
          }
          // let {data, updatetime} = this.getDataByRes(_data);
          // // 解析base64
          // let _base64DecodeStr = app.globalData.blsdk.base64Decode(data || "");
          // let _array = JSON.parse(_base64DecodeStr);
          // !!callback && (callback(_array, updatetime));
          !!callback && (callback(_data));
          // 默认需要loading
          !loading && (ability.hideLoading());
        } else {
          // 默认需要loading
          !loading && (ability.hideLoading());
          this.showToast(this.dealErrorMsg(res?.status || res?.error) || "获取数据失败", "none");
        }
      }).catch(e => {
        ability.hideLoading();
        console.error("downloads e = ", e);
        let _str = this.dealErrorMsg(e?.data?.status || e?.data?.error) || "获取数据失败";
        this.showToast(_str, "none");
      });
    },
    getDataByRes (data) {
      let _result = [];
      if (!data || data.length == 0) {
        return _result;
      }
      return data[0] || {};
    },
    back (needback) {
      if (!needback) {
        return;
      }
      setTimeout(() => {
        ability.navigateBack();
      }, 1200);
    },
    dealErrorMsg (errorCode) {
      if (errorCode == -1012) {
        // 退出账号登陆
        app.resetUserInfo();
      }
      return bizUtil.dealErrorMsg(errorCode, ERRORMSG);
    },
  }
})