// miniprogram/pages/personCenter/index.js
import ability from "../../utils/classDef/ability";
import bizUtil from "../../utils/bizUtil";
import GROUPS from '../../static/js/jsConfig/groups'
// const customComponent = require("../../static/js/baseClass/component")
const CustomPage = require("../../static/js/baseClass/page");
var tabBehavior = require('../../static/js/behavior/tab');
var familyBehavior = require('../../static/js/behavior/family');
// 获取应用实例
var app = getApp()
new CustomPage ({
  behaviors: [tabBehavior, familyBehavior], // , shareBehavior
  data: {
    // 顶部条
    topConfig: {
      bgClass: "topMineViewBg",
      navObj: {
        center: {
          text: app.globalData.companyInfo.wxName
        }
      },
      // 内容头部的配置
      topObj: {
        left: {
          // textHander: this.familyClick, // 家庭按钮点击
          img: "../../static/img/mineicon.png",
          imgClass: 'mineImg',
          text: '', // bizUtil.getDefaultTip().tip,
          tip: '',
          hander: undefined,
          titleClass: 'color333 font48 semibold',
          tipClass: 'color666 font26',
          bottomIcon: true
        }
      }
    },
    myPageList: [],
    // userInfo: app.globalData.userInfo || {},
    bleUnavailable: false,
    // version: app.globalData.companyInfo.version,
    timer: null, // 倒计时定时器

    showActionsheet: false, // 是否显示actionsheet
    groups: GROUPS,
    roleNum: app.globalData.roleNum, // 用户权限

    // 备份还原功能
    statusHeight: 0,
    showBackupsheet: false, // 是否显示弹框
    acts: [{
      text: "云端备份",
      value: 0,
      tap: "backupClick"
    }, {
      text: "云端还原",
      value: 1,
      tap: "downloadClick"
    }
    // , {
    //   text: "退出登陆",
    //   value: 2,
    //   tap: "logout"
    // }
    ],
    cloudUserInfo: undefined // 云端用户信息
  },
  onLoad () {
    // 初始化家庭点击的事件
    this.initTopBtom();
    // 初始化备份还原按键的高度
    this.initPageStatus();
  },
  onShow () {
    // let _setting = wx.getSystemSetting();
    // 刷新方法
    this.initShowMethod();
  },
  // onTabItemTap () {
  // },
  // 刷新页面调用的方法
  initShowMethod () {
    // // 判断是否有登陆数据
    // this.initByUserInfo(app.globalData.userInfo);
    // 初始化列表
    this.initData();
    // 初始化家庭名称
    this.initTopText();
  },
  // 初始化备份还原按键的高度
  initPageStatus () {
    let {statusHeight, multip} = app.globalData.customPageSize || {};
    this.data.statusHeight = (statusHeight || 0) * (multip || 0);
    console.log("initPageStatus this.data.statusHeight = ", this.data.statusHeight);
    this.setData({
      statusHeight: this.data.statusHeight
    })
  },
  getLastContent () {
    if (app.globalData.roleNum == 2) {
      let _time = app.getAvalibleTime();
      console.log("getLastContent _time = ", _time);
      if (_time == 'always') {
        // 清除定时器
        this.destroyTimer(this.data.timer);
        // 永久权限
        return '设备可用时长：永久';
      } else if (_time == 'admin') {
        // 清除定时器
        this.destroyTimer(this.data.timer);
        // 管理权限
        return '';
      } else if (_time < 0) {
        // 清除定时器
        this.destroyTimer(this.data.timer);
        return "该分享已过期";
      }
      let _day = parseInt(_time / 3600 / 24);
      return ("设备可用时长： " + (_day > 0 ? (_day + "天") : '') + parseInt(_time / 3600 % 24) + "小时" + parseInt(_time % 3600 / 60) + "分钟"); //  + parseInt(_time % 60) + "秒")
    }
    return "";
  },
  updateSeconds () {
    // 增加清空当前设备的处理
    let _text = this.getLastContent();
    if (_text == '') {
      return;
    }
    // let _len = this.data.myPageList.length;
    let _updateStr = `myPageList[4].title`;
    this.setData({
      [_updateStr]: _text
    });
  },
  initTimer () {
    if (this.data.timer) {
      this.destroyTimer(this.data.timer);
    }
    this.data.timer = setInterval(() => {
      this.updateSeconds();
    }, 1000);
  },
  destroyTimer (timer) {
    bizUtil.clearTimer(timer, "interval");
  },
  // 动态显示家庭名称
  initTopText () {
    this.data.topConfig.topObj.left.text = app.globalData.familyInfo?.n || ''; // tip;
    console.log("initTopText app.globalData.userInfo = ", app.globalData.userInfo);
    
    // 是否有用户信息
    let {userid, loginsession, nickname, phone, email, brandname} = app.globalData.userInfo || {};
    console.log("initTopText userid, nickname, brandname = ", userid, nickname, brandname);
    // || brandname
    if (userid) {
      this.data.topConfig.topObj.left.tip = " ";
      this.data.topConfig.topObj.left.nickname = nickname || phone || email || brandname || " ";
    } else {
      delete this.data.topConfig.topObj.left.nickname;
      this.data.topConfig.topObj.left.tip = "欢迎来到你的全屋智能";
    }
    
    this.setData({
      topConfig: this.data.topConfig
    });
  },
  // 初始化顶部左右侧点击
  initTopBtom () {
    // 初始化
    this.data.topConfig.topObj.left.textHander = this.familyClick; // 家庭按钮点击
    // this.data.topConfig.topObj.left.hander = this.iconClick;
    // this.data.topConfig.topObj.right.hander = this.topRightClick;
    this.setData({
      topConfig: this.data.topConfig
    });
  },
  // iconClick () {
  //   // 顶部左侧头像点击
  //   bizUtil.iconClick(app.globalData.userInfo || {});
  // },
  getCurrentGroupName () {
    // 当前的host名称
    let _familyInfo = app.globalData.familyInfo || {};
    let _curIdx = _familyInfo.groupIndex || 0;
    console.log("getCurrentGroupName _curIdx = ", _curIdx);
    return (this.data.groups[_curIdx] || this.data.groups[0])?.text;
  },
  // 数据内容
  initPageList () {
    // // 家庭总设备数量
    // let _tmpArray = bizUtil.getAllDevsFilter(app.globalData.devs, undefined, 'devs') || [];

    return [
      {
        title: "语音等第三方服务",
        imgKey: 'voice',
        bindtap: "toThirdVoice"
      },
      {
        title: "家庭分享",
        imgKey: 'share',
        bindtap: "toDeviceShare",
        tip: "二维码"
      }, {
        title: "数据同步",
        imgKey: 'sync',
        bindtap: "toSync",
        tip: ""
      }, /*{
        title: "恢复到初始状态",
        iconPath: "../../static/img/mine/reset.png",
        bindtap: "toReset"
      }, */ /*{
        title: "房间管理",
        imgKey: 'room',
        bindtap: "toRoomSet",
        tip: this.getRoomCount() + "个房间"
      },
      {
        title: "集群",
        imgKey: 'group',
        // bindtap: app.globalData.roleNum == 2 ? undefined : "toGroupSet",
        tip: this.getCurrentGroupName() // groups[_groupIndex < 0 ? 0 : _groupIndex].text
      },
      {
        title: "家庭总设备数量",
        imgKey: 'count',
        // bindtap: "",
        tip: (_tmpArray?.length || 0) + "个设备"
      },*/
      // 消息中心小程序没有做
      {
        title: "反馈与帮助",
        imgKey: 'help',
        bindtap: "toHelp"
      }, 
      {
        title: "设置",
        imgKey: 'set',
        // bindtap: "",
        tip: "",
        bindtap: "toSet",
      }
    ];
  },
  getRoomCount () {
    return Object.keys(app.globalData.devs || {}).length;
  },
  initData () {
    console.log("app.globalData.roleNum = ", app.globalData.roleNum)
    let _roleNum = app.globalData.roleNum;
    this.data.roleNum = _roleNum;
    // 取得原始数组
    let _list = this.initPageList();
    // 分享者 反馈和房间管理权限
    if (_roleNum == 2) {
      // this.data.myPageList = _list; _list[0], 
      this.data.myPageList = _list.filter(item => item.imgKey != "share" && item.imgKey != "sync"); // [_list[1], _list[3], _list[4]];
      // 初始化倒计时定时器
      // this.initTimer();
      console.log("this.data.myPageList = ", this.data.myPageList);
    } else {
      this.data.myPageList = _list;
    }
    this.setData({
      myPageList: this.data.myPageList,
      tip: bizUtil.getDefaultTip().tip,
      roleNum: this.data.roleNum
    })
  },
  // 设备分享页面
  toDeviceShare() {
    console.log('toDeviceShare');

    let _array = this.data.myPageList.filter(item => item.imgKey == 'share');
    if (_array.length == 0) {
      return;
    }

    ability.navigateTo("../../minePages/deviceShare/index?title=" + encodeURIComponent(_array[0]?.title || ""));
  },
  // 数据同步
  toDeviceSync () {
    ability.navigateTo("../../minePages/deviceShare/index");
  },
  // 语音等第三方服务
  toThirdVoice () {
    let _array = this.data.myPageList.filter(item => item.imgKey == 'voice');
    if (_array.length == 0) {
      return;
    }
    // 清除设备信息
    app.globalData.devInfo = {};
    // ability.navigateTo("/minePages/thirdVoice/index")
    ability.navigateTo("/device/gateway/thirdparty/index?from=mine&title=" + encodeURIComponent(_array[0]?.title || ""))
  },
  // 帮助页面
  toHelp() {
    console.log("help");
    ability.navigateTo("/minePages/help/index")
    // wx.navigateTo({
    //   url: '/minePages/help/index'
    // })
  },
  // 恢复到初始状态
  toReset() {
    console.log("toReset");
    wx.navigateTo({
      url: '/minePages/reset/index'
    })
  },
  // 退出登陆
  logout () {
    // 用户信息清除
    app.resetUserInfo();
    // app.globalData.userInfo = {};
    // 刷新状态
    this.initTopText();
    // // 初始化设备信息
    // app.setBizStorage("userInfo", {});
  },

  // 房间管理页面
  toRoomSet (e) {
    ability.navigateTo("../../minePages/roomManage/index")
  },
  
  clearResetToast () {
    // 跳转系统蓝牙设置页
    // wx.openSystemBluetoothSetting({
    //   success (res) {
    //       console.log("onShow res = ", res)
    //     }
    // })
    // return;
    ability.showModal({
      title: "",
      content: "是否清空当前家庭数据",
      showCancel: true
    }).then(res => {
      console.log("clearResetToast res = ", res);
      if (!res) {
        return;
      }
      this.clearFamilyInfo();
    })
  },

  toGroupSet () {
    // 如果没有权限，则不弹出
    if (app.globalData.roleNum == 2) {
      return;
    }
    this.manageActionSheet(true);
  },
  actionBtnClick (e) {
    let {index} = e.detail || {};
    if (index == app.globalData.familyInfo?.groupIndex) {
      return;
    }
    
    // 家庭信息
    let _familyInfo = app.globalData.familyInfo || {};
    // 更新当前集群信息
    _familyInfo.groupIndex = index;
    let {value, text} = this.data.groups[index];
    // 更新当前集群信息
    app.globalData.blsdk.updateCtrlHost(value);
    // 关闭actionsheet
    this.close();
    // 更新集群信息
    this.initData();
  },
  close: function () {
    this.manageActionSheet(false);
  },
  manageActionSheet (value) {
    this.setData({
      showActionsheet: value || false
    });
  },

  backDownClick () {
    // 判断是否有账号登陆
    if (this.checkUserInfo()) {
      console.log("UserInfo exist");
      // 显示actionsheet
      this.setProperValueByKey("showBackupsheet", true);
    } else {
      console.log("jumpBackup");
      this.jumpBackup();
    }
  },
  // 跳转备份/还原页面
  jumpBackup (index, tap) {
    ability.navigateTo("/minePages/backup/index?index=" + (index || 0) + "&tapKey=" + tap);
  },
  backupItemClick (e) {
    let {index} = e.detail || {};
    let {value, text, tap} = this.data.acts[index];
    console.log("backupItemClick this.data.acts, index = ", this.data.acts, index);

    // 是否有登陆
    let _data = this.checkUserInfo();
    if (!_data) {
      // 跳转登陆页面
      this.jumpBackup(index, tap);
    } else {
      // 调用方法
      this[tap]();
    }
    // 关闭actionsheet
    this.setProperValueByKey("showBackupsheet", false);
  },
  checkUserInfo () {
    let _userInfo = app.globalData.userInfo || {};
    return !!_userInfo.userid && !!_userInfo.loginsession;
  },
  editAccount () {
    // 判断是否有用户信息
    if (!this.checkUserInfo()) {
      this.jumpBackup();
      return;
    }
    ability.navigateTo("../../minePages/backup/accountDetail/index")
  },
  // 备份数据点击
  backupClick () {
    ability.navigateTo("../../minePages/backup/list/index?type=backup")
  },
  // 还原数据点击
  downloadClick () {
    ability.navigateTo("../../minePages/backup/list/index?type=download")
  },
  // 数据同步
  toSync (e) {
    let {index} = e.currentTarget.dataset;
    let {title} = this.data.myPageList[index] || {};
    ability.navigateTo("/minePages/sync/index?title=" + encodeURIComponent(title))
  },
  // 关于页面
  toSet (e) {
    let {index} = e.currentTarget.dataset;
    let {title} = this.data.myPageList[index] || {};
    ability.navigateTo("/minePages/set/index?title=" + encodeURIComponent(title))
  }
})