// pages/scene/index.js
import ability from "../../utils/classDef/ability";
import bizUtil from "../../utils/bizUtil"
// const customComponent = require("../../static/js/baseClass/component")
// 获取应用实例
var app = getApp()
var tabBehavior = require('../../static/js/behavior/tab')
const CustomPage = require("../../static/js/baseClass/page")
// new customComponent({
new CustomPage({
  behaviors: [tabBehavior],
  data: {
    // 顶部条
    topConfig: {
      navObj: {
        center: {
          text: app.globalData.companyInfo.wxName
        }
      },
      // 内容头部的配置
      topObj: {
        left: {
          // textHander: this.familyClick, // 家庭按钮点击
          text: '',
          hander: undefined,
          titleClass: 'color333 font48 semibold',
          tipClass: 'color666 font26',
          tip: '欢迎来到你的全屋智能',
          bottomIcon: true
        }
      }
    },
    // 是否主设备
    roleNum: 0,
    // 房间列表
    rooms: {
      data: [],
      selRoomId: 0, // 选中的房间 默认全屋
      selRoomIndex: 0, // 默认选择第0个
      handle: undefined
    },
    roomJson: {}, 

    batchCount: 0,
    selectData: {}, // key: 设备id, value:addr
    enableRefresh: false,
    bleUnavailable: false,
    allOpen: false,
    allClose: false,
    // 情景信息
    scenes: [],
    sceneCount: 0, // 场景个数

    showAddDialog: false, // 默认隐藏
    sceneConfig: {}, // 用于缓存房间下是否都不支持

    // roleNum: 0 // 默认权限
    isFloor: false // 是否支持多楼层
  },
  onLoad () {
    // 初始化scrollview点击事件
    this.initScrollView();
  },
  onShow () {
    // 刷新方法
    this.initShowMethod();
  },
  // 初始化
  initShowMethod () {
    // 初始化房间json
    this.initRoomJsonByFloorAndAllDevs();
    // 判断用户状态 取得上次保存的数据
    this.initDataByRole(app.globalData.roleNum);
  },
  // 禁止下拉
  customEvent () {
    console.log("customEvent");
    ability.stopPullDownRefresh();
    this.setData({
      enableRefresh: false
    })
  },
  // 初始化scrollview点击事件
  initScrollView () {
    this.data.rooms.handle = (index, id) => {
      console.log("initScrollView handle index = ", index);
      this.scrollClick(id)
    }
    this.setData({
      rooms: this.data.rooms
    });
  },
  sliderChange (e) {
    let {index, id} = e.detail || {};
    console.log("sliderChange index, id = ", index, id);
    this.scrollClick(id)
  },
  // 更新房间信息
  updateRoomInfo (roomData, roomId) {
    // 保存选中的房间 这里有个bug 不能按照序号来
    let _roomData = roomData || [];
    let _findIndex = _roomData.findIndex(item => item.id == roomId);
    app.globalData.roomInfo = (_findIndex >= 0) ? _roomData[_findIndex] : _roomData[0];

    // 临时保存下标
    this.data.rooms.selRoomIndex = _findIndex;
  },
  // 点击scrollview事件
  scrollClick (id) {
    console.log("scene scrollClick id = ", id);

    // 有个bug
    this.updateRoomInfo(this.data.rooms?.data, id);
    // // 保存选中的房间 这里有个bug 不能按照序号来
    // let _roomData = this.data.rooms?.data || [];
    // let _filters = _roomData.filter(item=>item.id==id);
    // app.globalData.roomInfo = _filters[0] || _roomData[0] || {};
    // console.log("app.globalData.roomInfo = ", app.globalData.roomInfo);

    // // 保存选中的房间
    // app.globalData.roomInfo = this.data.rooms?.data?.[id] || {};
    // console.log("app.globalData.roomInfo = ", app.globalData.roomInfo);

    // 选中的房间id
    let _roomId = parseInt(id);
    let _devs = app.globalData.devs;
    this.data.rooms.selRoomId = _roomId;
    let _item = _devs[_roomId || 0] || {};
    let _scenes = _item.scenes || [];
    // 根据or排序
    _scenes = bizUtil.sortArrayByKey(_scenes, "or");
    console.log("scrollClick _scenes = ", _scenes);

    // 暂时屏蔽全屋下所有场景
    // if (_item.id == 0) {
    //   // 场景去重
    //   let {scenes} = bizUtil.getAllDevsBySort(_devs, _devs, 'scenes');
    //   _scenes = scenes;
    // }
    // // 场景个数
    // this.data.sceneCount = _scenes.length;
    // // 显示全部的场景
    // _scenes = bizUtil.setBgAndIcon(_scenes);
    // // 只显示6个 场景icon和bg赋值
    // _scenes = bizUtil.setBgAndIcon(_scenes.slice(0, 6));
    // this.data.scenes = _scenes; // 根据房间id取得景信息
    // 设置房间选择
    this.setData({
      rooms: this.data.rooms,
      scenes: _scenes,
      sceneCount: _scenes?.length || 0
    })
  },
  getDevsCount (devs) {
    let count = 0;
    let _devs = devs || {};
    for (let key in _devs) {
      let _item = _devs[key];
      count += ((_item.devs || []).length);
    }
    return count;
  },
  // 初始化数据
  initDataByRole (roleNum) {
    // 取得是否主设备还是分享设备
    let _roleNum = (roleNum == undefined) ? app.globalData.roleNum : roleNum;
    this.data.roleNum = _roleNum;
    // 新视觉去除
    let {tip, imgStr} = bizUtil.getDefaultTip();
    this.data.topConfig.topObj.left.img = `../../static/img/${imgStr}.png`;
    // 从时间提示改成家庭选择
    this.data.topConfig.topObj.left.text = app.globalData.familyInfo?.n || ''; // tip;
    this.data.topConfig.topObj.left.textHander = this.familyClick; // 家庭按钮点击

    // 是否支持楼层
    let _supportFloor = this.initSupportFloor();
    let _floorName = "";
    if (_supportFloor) {
      _floorName = this.getCurFloor();
    }
    this.data.topConfig.topObj.left.supportFloor = _supportFloor;
    this.data.topConfig.topObj.left.floorName = _floorName;

    // 是否支持楼层
    this.data.isFloor = _supportFloor;
    
    // 初始化
    this.scrollClick(this.data.rooms.selRoomId);
    // // 是否全部为空
    // let _devLength = this.getDevsCount(app.globalData.devs);
    // console.log("_devLength = ", _devLength);
    // this.data.isEmpty = _devLength == 0;
    console.log("_roleNum = ", _roleNum);
    // 分享设备 未登录的时候和没有设置角色的时候不显示右侧
    let _img = "";
    let _hander = undefined;
    if (_roleNum == 2) {
      _img = "../../static/img/devList/scan.png";
      _hander = (() => {this.scanCode();});
    } else {
      _img = "../../static/img/devList/add.png";
      _hander = (() => {this.showAddDialog();});
    }
    // 这里需要判断right可能为undefined
    this.data.topConfig.topObj.right = this.data.topConfig.topObj.right || {};
    this.data.topConfig.topObj.right.img = _img;
    this.data.topConfig.topObj.right.hander = _hander;
    // 初始化
    // this.scrollClick(this.data.rooms.selRoomId);
    // 设置用户角色
    this.setData({
      isFloor: this.data.isFloor,
      roleNum: _roleNum || 0,
      topConfig: this.data.topConfig
    })
  },
  refesh (e) {
    console.log("refresh e = ", e)
  },
  loadMore (e) {
    console.log("loadMore e = ", e)
  },
  refreshStop (e) {
    console.log("refreshStop e = ", e)
  },
  refreshAbort (e) {
    console.log("refreshAbort e = ", e)
    // 重新查询数据
    // to do list
  },
  dragEnd (e) {
    console.log("dragEnd e = ", e)
  },
  refreshed (e) {
    console.log("refreshed e = ", e)
  },

  /***************** 设备控制相关 ***************/
  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    })
  },
  hideLoading () {
    ability.hideLoading();
  },

  // 灯泡全开
  allOpen () {
    this.setDataByKey("allOpen", true);
    let _brightness = (app.globalData.allStatus['all'] || {}).brightness || 127;
    let _params = {
      pwr: 1,
      brightness: _brightness
    };
    console.log("_params = ", _params);
    this.setControl(_params, undefined, 3);
  },
  allPause () {
    // this.setControl("pause")
    this.setControl("pause");
  },
  setDataByKey (key, value) {
    this.setData({
      [key]: value
    });
    setTimeout(() => {
      this.setData({
        [key]: !value
      });
    }, 100);
  },
  // 灯泡全关
  allClose () {
    this.setDataByKey("allClose", true);
    // this.setControl("down")
    this.setControl({
      brightness: 0
    }, undefined, 3);
  },
  actDev (key, e, ctrlType) {
    console.log("actDev e = ", e);
    let _itemIdx = e.currentTarget.dataset.itemindex;
    //保存当前数据
    let _deviceInfo = this.data.devList[_itemIdx];
    console.log("actDev key, e = ", key, _deviceInfo, _itemIdx, e.currentTarget.dataset);
    // 判断是否有缓存数据
    let _status = app.globalData.allStatus[_deviceInfo.d + "_" + _deviceInfo.a] || {};
    // 发送的参数
    let _keyStr = key;
    // 设备类型
    let _devTypeStr = bizUtil.getDevTypeStr(_deviceInfo.t);
    // 非窗帘
    if (_devTypeStr != "curtain" && (typeof _keyStr == 'string')) {
      if (_keyStr == 'down') {
        _keyStr = {
          pwr: 0,
          brightness: 0
        };
      } else { // if (_keyStr == 'up') 
        _keyStr = {
          pwr: 1,
          brightness: _status.brightness || 127
        };
      }
      let _text = 'devList['+ _itemIdx +'].pwrIdx';
      this.setData({
        [_text]: _keyStr.pwr || _keyStr.brightness
      })
      console.log("actDev _keyStr = ", _keyStr);
      setTimeout(() => {
        this.setData({
          [_text]: -1
        });
      }, 100);
    }
    // 控制命令
    this.setControl(_keyStr, _deviceInfo, ctrlType);
  },
  setControl (keyStr, deviceInfo, ctrlType) {
    // 房间信息
    let _roomInfo = {};
    // 是否单个设备控制
    if (!deviceInfo) {
      // 取得房间信息
      let {selRoomId} = this.data.rooms;
      console.log("selRoomId, data = ", selRoomId);
      _roomInfo = this.data.roomJson[selRoomId] || {};
      // 基于房间的控制
      app.globalData.blsdk.groupControlWithType(0, _roomInfo.id, keyStr);
    } else {
      app.globalData.blsdk.controlWithDevice(deviceInfo, keyStr);
    }
  },
  roomManage () {
    ability.navigateTo("/minePages/roomManage/index")
  },

  unable () {
    console.log("unable");
    this.data.bleUnavailable = false;
    this.setData({
      bleUnavailable: false
    })
  },
  jumpScene () {
    ability.navigateTo("/scene/list/index")
  },
  // 根据房间id取得下面所有的照明设备
  getDevsByRoomId (roomId) {

  },
  // 场景执行
  sceneClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.scenes[index];
    console.log("sceneClick index, _item = ", index, _item);

    // 发送之前先check是否都不支持默认场景 是否没有绑定过设备
    // let _rid = (_item.rid == undefined) ? (app.globalData.roomInfo || {}).id || 0 : (Number(_item.rid) || 0);
    // 加入的设备
    // let _devs = _item.devs || [];
    /*if (_item.t >= 3 && this.supportDefaultScene(_rid, _devs)) {
      wx.showModal({
        title: "未绑定默认场景",
        content: "部分设备未绑定默认场景，需手动配置",
        showCancel: true,
        confirmText: "详情",
        confirmColor: "#F78D3F",
        cancelText: "取消",
        cancelColor: '#000000'
      }).then(result => {
        // 判断是否点击详情
        let _confirm = result?.confirm;
        if (_confirm) {
          // 保存当前场景
          app.globalData.sceneInfo = _item;
          // 去配置，进入输入WiFi密码页面
          ability.navigateTo('../unsupportDev/index');
        } else {
          // 设置弹窗过
          this.setTipedDataByRoomId(_rid);
        }
      })
      return;
    }*/

    // // 修复场景为空时，增加跳转场景编辑页面
    // if (!_item.cmd && _item.devs == undefined && _item.panels == undefined) {
    //   // 跳转到编辑页面
    //   this.editScene(e);
    //   return;
    // }
    
    let _roomId = _item.rid || this.data.rooms.selRoomId;
    let _sid = _item.sid;
    if (_item.t == 0) {
      app.globalData.blsdk.groupControlWithType(0, _roomId, _item.cmd);
    } else {
      let _result = app.globalData.blsdk.roomSceneControlWithSceneId((_roomId << 16) + _sid);
      if (!_result || !_result.then) {
        return;
      }
      _result.then(() => {
        ability.showToast({
          title: "执行成功",
          icon: "success"
        });
      })
    }
  },

  // 设置数据不需要提示
  setTipedDataByRoomId (roomId) {
    if (roomId == undefined) {
      return;
    }
    if (roomId == 0) {
      // 设置当前所有数据都提示过
      for (let rid in app.globalData.devs) {
        // 设置当前房间所有数据都提示过
        let _devs = app.globalData.devs[rid]?.devs || [];
        let _filter = _devs.filter(item=>item.SD < 0);
        bizUtil.setArrayItem(_filter, ['SD'], [undefined]);
      }
    } else {
      // 设置当前房间所有数据都提示过
      let _devs = app.globalData.devs[roomId]?.devs || [];
      let _filter = _devs.filter(item=>item.SD < 0);
      bizUtil.setArrayItem(_filter, ['SD'], [undefined]);
    }
  },

  editScene (e) {
    // 场景编辑
    let {index} = e.currentTarget.dataset;
    let _item = this.data.scenes[index];
    console.log("editScene _item = ", _item);
    // 如果没有编辑过，则进入场景详情页面
    // if (_item.t == 3) {
    //   // 进入添加场景页面 新增场景
    //   app.globalData.sceneInfo = _item;
    //   ability.navigateTo("/scene/addScene/index")
    // } else {
      // _item.mode = "edit";
      // 进入添加场景页面 新增场景
      app.globalData.sceneInfo = _item;
      ability.navigateTo("/scene/sceneDetail/index")
    // }
  },
  // 根据版本号设置是否需要判断是否支持默认场景
  supportDefaultScene (roomId, actionDevs) {
    let _roomId = roomId || 0; // (app.globalData.roomInfo || {}).id || 0;
    let _roomDevs = [];
    // 如果房间id=0
    if (roomId == 0) {
      _roomDevs = bizUtil.getAllDevsFilter(app.globalData.devs);
    } else if (roomId % 32 == 0) {
      let _floorJson = bizUtil.getAllDevsByFloor(app.globalData.devs, bizUtil.getFloorByRoomId(roomId), false);
      _roomDevs = bizUtil.getAllDevsFilter(_floorJson);
    } else {
      _roomDevs = app.globalData.devs[_roomId].devs || [];
    }
    // 取得该家庭下的所有灯
    let {light} = bizUtil.getAllPidByArray(_roomDevs);
    // 遍历数据是否支持版本号
    let _filter = light.filter(item=>(item.SD < 0));

    if (_filter.length > 0) {
      return true;
    }
    return false;
  },

  swipeChange (e) {
    let {current, source} = e.detail;
    console.log("swipeChage current, source = ", current, source);
    if (source != "touch") {
      return;
    }
    let _selectedId = this.data.rooms.data[current].id;
    console.log("swipeChage _selectedId = ", _selectedId);
    this.data.rooms.selRoomId = _selectedId;
    this.data.rooms.selRoomIndex = current;

    this.scrollClick(_selectedId)

    this.setData({
      rooms: this.data.rooms
    })
  }
})
