// pages/unsupportDev/index.js
import ability from '../../utils/classDef/ability'
import bizUtil from '../../utils/bizUtil'

const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    bleUnavailable: false,
    supports: [], // 支持的设备
    unSupports: [], // 不支持的设备
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 场景信息
    let {rid, devs} = app.globalData.sceneInfo;
    // 把场景中的设备列表转成json的数据
    let _actionDJson = bizUtil.arrayToJsonByKey(devs, true, 'd');
    // 取得版本号不支持场景或者默认场景的数据
    let dataJson = this.supportDefaultScene(rid, _actionDJson);
    // 筛选出不在执行设备中的数据
    this.data.supports = dataJson.unAdds;
    this.data.unSupports = dataJson.unSupports;
    this.setData({
      supports: this.data.supports,
      unSupports: this.data.unSupports
    })
    // 设置数据都为弹出过
    this.setTipedDataByRoomId(rid);
  },

  // 根据版本号设置是否需要判断是否支持默认场景
  supportDefaultScene (roomId, actionDJson) {
    let _roomId = roomId || 0; // (app.globalData.roomInfo || {}).id || 0;
    let _roomDevs = [];
    let _actionDJson = actionDJson || {};
    // 如果房间id=0
    if (roomId == 0) {
      _roomDevs = bizUtil.getAllDevsFilter(app.globalData.devs);
    } else {
      _roomDevs = app.globalData.devs[_roomId].devs || [];
    }
    // 取得该家庭下的所有灯
    let _lightArray = bizUtil.getAllPidByArray(_roomDevs).light || [];
    // 不支持默认场景的设备d
    let _unAdds = [/*{
      n: '1111'
    }, {
      n: '222'
    }, {
      n: '3'
    }, {
      n: '4'
    }, {
      n: '5'
    }, {
      n: '6'
    }, {
      n: '7'
    }, {
      n: '8'
    }*/];
    let _unSupports = [/*{
      n: '1111'
    }, {
      n: '222'
    }, {
      n: '3'
    }, {
      n: '4'
    }, {
      n: '5'
    }, {
      n: '6'
    }, {
      n: '7'
    }, {
      n: '8'
    }*/];
    // 遍历数据是否支持版本号
    for (let item of _lightArray) {

      // 如果设备在场景执行设备中，则忽略
      if (_actionDJson[item.d]) {
        continue;
      }

      let _sd = item.SD;
      // 判断是否支持
      if (_sd == -2) {
        // 不支持场景
        _unSupports.push(item);
      } else if (_sd == -1) {
        // 不支持默认场景
        _unAdds.push(item);
      }
    }
    return {
      unSupports: _unSupports,
      unAdds: _unAdds
    }
  },

  // 设置数据不需要提示
  setTipedDataByRoomId (roomId) {
    if (roomId == undefined) {
      return;
    }
    if (roomId == 0) {
      // 设置当前所有数据都提示过
      for (let rid in app.globalData.devs) {
        // 设置当前房间所有数据都提示过
        let _devs = app.globalData.devs[rid]?.devs || [];
        let _filter = _devs.filter(item=>item.SD < 0);
        bizUtil.setArrayItem(_filter, ['SD'], [undefined]);
      }
    } else {
      // 设置当前房间所有数据都提示过
      let _devs = app.globalData.devs[roomId]?.devs || [];
      let _filter = _devs.filter(item=>item.SD < 0);
      bizUtil.setArrayItem(_filter, ['SD'], [undefined]);
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 去设置
  goSetting () {
    // 进入场景详情页面
    ability.redirectTo("/scene/sceneDetail/index")
  }
})