// scene/addDevice/index.js
const ability = require("../../utils/classDef/ability")
const app = getApp();
const bizUtil = require("../../utils/bizUtil")

Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备选择"
      }
    },
    actionList: [],
    did: "",
    roomChanged: false, // 是否弹出选择房间
    rooms: [],
    roomInfo: {
      id: 0, // 默认全屋
      n: '全屋'
    },

    roomJson: {}, // 所有房间json
    isFloor: false, // 是否多楼层

    // from: "", // 页面来源
    devTypeStr: "", // 是否需要进行展示设备的筛查
    // type: 0, // 发送的数据
    key: 0, // 按键序号

    bottomBts: [{ // 默认按钮
      name: "下一步",
      handles: "next",
      classStr: "colorF78D3F"
    }],
    tabs: [], // tab选择设备还是群组
    tabIndex: 0, // 默认选择第0个
    // 分组的设备列表
    groupItemObj: {
      light: {
        text: "照明",
        key: "light",
        selecteds: [],
        list: []
      },
      curtain: {
        text: "窗帘",
        key: "curtain",
        selecteds: [],
        list: []
      },
      // aircondition: {
      //   text: "空调",
      //   key: "aircondition",
      //   selecteds: [],
      //   list: []
      // }
    },
    groupItemSelected: {}, // 分组设备选中的数据

    hidetab: false, // 是否需要隐藏tab

    // 发送时唤醒文案配置
    showSaveDialog: false,
    sendingConfig: {
      devTypeStr: 'uart' // 超级面板使用面板的低功耗弹窗提示
    }
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    // panelKey 超级面板绑定场景开关第几路
    let {from, devTypeStr, key, did, hidetab, rid, sid, panelKey, type: metaType, lowPower} = options || {};
    // 是否需要取出群组的选择
    let _hidetab = (hidetab == 1) || (!!devTypeStr && (devTypeStr != "light" && devTypeStr != "curtain"));
    // 页面来源赋值
    this.from = from;
    this.key = Number(key || 0);
    this.data.did = did || "";
    // panelKey 超级面板绑定场景开关第几路
    this.bindPwrKey = panelKey;
    this.data.devTypeStr = devTypeStr;
    this.metaType = metaType;
    
    // 是否低功耗
    this.lowPower = lowPower;

    // 所有数据集合
    let _allDevs = app.globalData.devs || {};
    // 初始化roomJSON和多楼层信息
    let _allRoomJson = this.getAllRoomJsonByDevs(_allDevs);
    // 初始化房间信息
    let _roomId = (app.globalData.roomInfo || {}).id;
    if (_roomId != this.data.roomInfo.id && _roomId != undefined) {
      let _roomInfo = _allDevs[_roomId] || _allDevs[0];
      this.data.roomInfo.id = _roomInfo.id;
      this.data.roomInfo.n = _roomInfo.n;
    }

    // 是否多楼层
    let _floorIndex = app.globalData.familyInfo?.floor;
    let _isFloor = _floorIndex >= 0;
    // 根据多楼层取得房间列表
    let _roomList = this.getRoomsByFloorAndDevs(_floorIndex, app.globalData.devs);
    // 根据名称初始化底部按钮
    let _bottomBtns = this.getBottomBtsByFrom(from, this.data.did, devTypeStr);
    // 初始化顶部tab
    let _tabs = this.getAllTabs();

    this.setData({
      bottomBts: _bottomBtns, // 底部按钮
      did: this.data.did, // 选中的设备
      devTypeStr: devTypeStr || "",
      isFloor: _isFloor,
      rooms: _roomList,
      roomInfo: this.data.roomInfo,
      roomJson: _allRoomJson,
      tabs: _tabs,
      hidetab: _hidetab
    })
  },
  getAllTabs () {
    return [{
      text: "设备",
      key: "device"
    }, {
      text: "群组", // 设备
      key: "group"
    }/*, {
      text: "场景",
      key: "scene"
    }*/];
  },
  // 页面来源
  getBottomBtsByFrom (fromStr, did, devTypeStr) {
    let _result = [];
    // 页面来源赋值
    if (fromStr == "metapad" || fromStr == "pwrmetapad") {
      _result = [/*{
        name: "解绑",
        handles: "unbindDevice",
        classStr: 'delBtn',
      }, */{
        name: devTypeStr == "switch" ? "下一步" : "绑定",
        handles: "next",
        classStr: 'colorF78D3F borderF78D3F',
      }];
    } else if (fromStr == "tvlamp") {
      _result = [{
        name: "解绑",
        handles: "unbindDevice",
        classStr: 'delBtn',
      }, {
        name: "绑定",
        handles: "next",
        classStr: 'colorF78D3F borderF78D3F marginL49',
      }];
      // 如果没有绑定 
      if (did === "") {
        // 如果没有did则不绑定设备
        _result = _result.slice(1);
        _result[0].classStr = _result[0].classStr.replace("marginL49", "")
      }
    } else {
      _result = [{ // 默认按钮
        name: "下一步",
        handles: "next",
        classStr: "colorF78D3F borderF78D3F"
      }];
    }
    return _result;
  },
  setProperValue (key, val) {
    if (this.data == undefined) {
      return;
    }
    this.data[key] = val;
    this.setData({
      [key]: val
    })
  },
  getAllRoomJsonByDevs (devs) {
    // 取得多楼层的json数据
    let {roomJson} = bizUtil.getRoomsByDevs(devs || {});
    return roomJson;
  },
  // 初始化房间
  getRoomsByFloorAndDevs (floor, allDevs) {
    // 所有设备
    let _allDevs = allDevs || {};
    // 当前楼层
    let _floor = floor || 0;
    // 根据多楼层取得数据
    let _devs = bizUtil.getDevsByFloor(_allDevs, _floor);

    let {rooms} = bizUtil.getRoomsByDevs(_devs);
    return rooms;
  },
  getActionDevsByRoomId (roomId) {
    let _roomId = roomId || 0;
    let _result = {};
    if (_roomId == 0) {
      // 如果是全屋 取得所有设备
      let _devs = app.globalData.devs || {};
      let {rooms} = bizUtil.getRoomsByDevs(_devs);
      _result = bizUtil.getAllDevsBySort(rooms, _devs);
    } else if (_roomId % 32 == 0) {
      // 楼层数据
      let _data = this.data.rooms || [];
      _data = _data.filter(item=>((item?.id || 0) % 32 > 0));
      console.log("scrollClick _data = ", _data);
      // 如果是全屋 取得所有设备
      _result = bizUtil.getAllDevsBySort(_data, app.globalData.devs);
    } else {
      _result = app.globalData.devs[_roomId] || {}; 
    }
    return _result;
  },
  // 空调网关设备特殊处理 名称根据网关排序 排序后跟内机设备
  getAircondition () {

  },

  // 版本号
  getRealVersionByV (v) {
    if (!v) {
      return 0;
    }
    return v.split(".").reverse()[0];
  },

  // 根据房间初始化设备列表
  initListByRoom (roomId, tabIndex) {
    let _roomId = roomId || 0;
    // 根据房间信息取得设备列表和群组信息
    let {devs, groups} = this.getActionDevsByRoomId(_roomId);
    console.log("initListByRoom roomId, devs, groups = ", roomId, devs, groups);
    // 设备列表信息
    let _devShowArray = devs || [];
    // 群组信息
    let _groupShowArray = groups || [];

    // 需要更新的数据内容
    let _updateJson = {};
    // 最终的设备列表数据
    let _resultArray = [];
    // 判断选择类型
    if (tabIndex == 1) {
      // 选择群组
      let _allArray = bizUtil.getDevsOrGroupsByRoomId(_roomId, app.globalData.devs, "groups");
      
      // 超级面板进入
      let _isFromMetapad = (this.from == "metapad" || this.from == "pwrmetapad");

      // 如果是从场景中进入,则加上默认的房间群组,否则去掉默认的房间群组
      if (this.from == undefined || _isFromMetapad) {
        _resultArray = _allArray; // _allArray.filter(item => !bizUtil.isAllRoomCtrl(item));
      } else {
        _resultArray = _allArray.filter(item => !bizUtil.isAllRoomCtrl(item));
      }
      // _resultArray = _allArray.filter(item => !bizUtil.isAllRoomCtrl(item));
      // 排序
      _resultArray = bizUtil.sortArrayByKey(_resultArray, "gid");
      console.log("initListByRoom _resultArray = ", _resultArray);
      // 分组
      let _pidJson = bizUtil.getAllPidByArray(_resultArray);
      let _groupItemObj = this.data.groupItemObj;
      for (let key in _groupItemObj) {
        // 如果从超级面板进入，需要进行设备品类的过滤
        if (_isFromMetapad && this.data.devTypeStr) {
          if (key != this.data.devTypeStr) {
            continue;
          }
        }
        _groupItemObj[key].list = _pidJson[key];
      }
      console.log("initListByRoom _groupItemObj = ", _groupItemObj, _pidJson);
      _updateJson.groupItemObj = _groupItemObj;

      // 增加房间显示
      if (_updateJson.groupItemObj) {
        // 是否支持楼层
        let _isFloor = app.globalData.familyInfo.floor >= 0;
        for (let key in _updateJson.groupItemObj) {
          let {list} = _updateJson.groupItemObj[key] || {};
          if (!list || list.length == 0) {
            continue;
          }
          // 增加房间显示
          for (let item of list) {
            item.tip = bizUtil.getRoomName(item, app.globalData.devs, _isFloor);
          }
        }
      }
    } else {
      // 最终的设备列表数据
      let _resultArray = [];
      // 如果传递了设备类型参数，则只显示对应的类型和群组
      let _devTypeStr = this.data.devTypeStr;
      console.log("initListByRoom _devTypeStr = ", _devTypeStr);
      if (_devTypeStr) {
        
        // 数据数据，取得执行的设备
        let _devTypeJson = bizUtil.getAllPidByArray(_devShowArray);
        let _array = [];
        // 如果是开关面板
        if (_devTypeStr == "switch") {
          // 超级面板绑定继电器面板时，需要判断版本号 >= 18
          _array = _devTypeJson["panel"] || [];
          _array = _array.filter(item => bizUtil.isPwrAvalibleDev(item.t) && (this.getRealVersionByV(item.v) >= 18));
        } else {
          _array = _devTypeJson[_devTypeStr] || [];
          // 如果是空调，则加上温控器 + 空调
          if (_devTypeStr == "aircondition") {
            _array = _array.concat(_devTypeJson["thermostat"] || []);
          }
        }
        _array = bizUtil.sortArrayByChar(_array, "n");

        // 超级面板进入设备和群组已经通过tab区分，所以这里不需要获取群组的数组
        if (this.from == "metapad" || this.from == "pwrmetapad") {
          // 增加功能，取出256以下短地址的设备
          // _resultArray = _array;
          _resultArray = _array.filter(item => item.a == undefined || item.a < 256);
        } else {
          // 取得对应的群组
          let _typeGroupJson = bizUtil.arrayToJsonByKey(_groupShowArray, false, "t");
          // 显示的列表
          _resultArray = bizUtil.sortArrayByKey((_typeGroupJson[_devTypeStr] || []), 'gid').concat(_array);
        }
        console.log("initListByRoom _resultArray = ", _resultArray)
      } else {

        // 数据数据，取得执行的设备
        let {light, curtain, panel, fan, aircondition: showAirconditions, coathanger, thermostat: showThermostat, gateway, powerstrip, powerPlug} = bizUtil.getAllPidByArray(_devShowArray);
        // 去除该场景中加过的设备
        let {devs: _existDevs, t, groups} = app.globalData.sceneInfo || {};

        // 取得场景中每个设备的场景id 这里空调内机已经包含在主机中
        let _devSceneJson = bizUtil.getAllSceneDevJson(app.globalData.devs);

        // 此处需要去除默认场景的默认设置
        if (t >= 3) {
          // 目前只支持灯泡的默认场景设置，所以只需要去除灯泡支持默认场景的设备即可
          light = bizUtil.getDefaultSceneBySceneType(light, (app.globalData.roomInfo || {}).id);
          console.log("initListByRoom light = ", light);
        }

        console.log("initListByRoom coathanger = ", coathanger);
        // 设备列表 // 加入排插
        let _devList = light.concat(curtain || []).concat(fan || []).concat(coathanger || []).concat(powerstrip || []);
        console.log("initListByRoom _devList = ", _devList);
        // 判断每个设备已经存在的场景个数 目前只需要判断灯泡和窗帘
        for (let devInfo of _devList) {
          let {v, d, t} = devInfo;
          // 取得每个设备最大的场景个数
          let {sceneLen} = bizUtil.getJsonByAblitys(v, bizUtil.getDevTypeStr(t), {t});
          // 判断是否场景已满
          let _count = _devSceneJson[d]?.length || 0;
          // 数据之和
          devInfo.rt = _count >= (sceneLen || 0); // _count + "/" + (sceneLen || 0);
        }
        // 显示的温控器
        let _showThermostatArray = showThermostat || [];
        // 温控器最大16个场景，静态
        for (let thermostatInfo of _showThermostatArray) {
          let {d} = thermostatInfo || {};
          // 取得每个设备最大的场景个数
          let sceneLen = 16;
          // 判断是否场景已满
          let _count = _devSceneJson[d]?.length || 0;
          // 数据之和
          thermostatInfo.rt = _count >= (sceneLen || 0);
        }

        // 增加判断设备是否支持场景
        let _filterDevs = _devList.filter(item=> bizUtil.getJsonByAblitys(item.v || '', bizUtil.getDevTypeStr(item.t), {t: item.t}).scene);
        // 继电器面板
        let _filterPanel = panel.filter(item => bizUtil.isPwrAvalibleDev(item.t));
        // 已经存在的设备从列表中去除
        let _uniqueDevs = this.fitlerDevsBySceneInfo(_filterDevs.concat(_filterPanel).concat(_showThermostatArray), _existDevs);
        // 所有设备
        // _resultArray = _uniqueDevs; // _uniqueDevs.concat(_filterPanel);
        _resultArray = bizUtil.sortArrayByChar(_uniqueDevs, "n");

        // 取得所有家庭数据中空调的设备列表 需要特殊处理
        let _familyAllDevs = bizUtil.getAllDevsFilter(app.globalData.devs);
        let {aircondition, thermostat} = bizUtil.getAllPidByArray(_familyAllDevs);
        console.log("aircondition = ", aircondition);
        // 空调主机和内机的集合
        let {parents, subDMap} = bizUtil.getAirconditionMap(aircondition);
        console.log("parents, subDMap = ", parents, subDMap);
        // 空调字典 主机d对应rt
        let _airRtMapByD = {};
        // 遍历所有空调网关 取得空调设备已经存在的场景个数
        for (let devInfo of parents) {
          let {v, d, t} = devInfo;
          // 取得每个设备最大的场景个数
          let {sceneLen} = bizUtil.getJsonByAblitys(v, bizUtil.getDevTypeStr(t), {t});

          // 取得网关场景个数以及网关所有内机个数
          // 判断是否场景已满
          let _count = _devSceneJson[d]?.length || 0;
          // 设置内机的sub个数rt
          let _subArrays = subDMap[d] || [];
          for (let subDev of _subArrays) {
            _count += (_devSceneJson[subDev?.d]?.length || 0);
          }
          // 数据之和
          let _isRT = _count >= (sceneLen || 0);
          // 设置空调主机的map
          _airRtMapByD[d] = _isRT;
        }
        // 设置列表中的rt
        for (let item of showAirconditions) {
          let {d} = item || {};
          if (!d) {
            continue;
          }
          let _rt = _airRtMapByD[d.split("_")[0]];
          item.rt = _rt;
        }
        // 空调去重
        let _uniqueAirs = this.fitlerDevsBySceneInfo(showAirconditions, _existDevs);
        console.log("initListByRoom _resultArray, _uniqueAirs = ", _resultArray, _uniqueAirs);
        _resultArray = _resultArray.concat(_uniqueAirs);

        // 如果场景添加设备进入，则允许用户添加循环场景 但是需要排除ihg
        if (!this.from) {
          // 过滤蓝牙网关
          console.log("initListByRoom gateway = ", gateway);
          // 去除255网关过滤 && (item?.a < 255)
          let _bleTmpGateways = gateway.filter(item => !bizUtil.isIhg(item?.t) && (item?.a > 0));
          let _bleGateways = this.fitlerDevsBySceneInfo(_bleTmpGateways, _existDevs);
          console.log("initListByRoom _bleGateways = ", _bleGateways);
          for (let devInfo of _bleGateways) {
            let {v, d} = devInfo;
            // 取得每个设备最大的场景个数 网关默认10个
            let sceneLen = 10;
            // 判断是否场景已满
            let _count = _devSceneJson[d]?.length || 0;
            // 数据之和
            devInfo.rt = _count >= (sceneLen || 0);
          }
          _resultArray = _resultArray.concat(_bleGateways);

          // // 加入排插
          // _resultArray = powerstrip.concat(powerstrip || []);
        }

        // // 先判断是否有群组信息，有则过滤
        // let _existGroups = groups || [];
        // let _existGids = _existGroups.map(item => item.gid);
        // console.log("initListByRoom _existGids, _groupShowArray = ", _existGids, _groupShowArray);
        // let _filterGroups = _groupShowArray.filter(item => {
        //   item.id = item.id || item.rid || 0; // 保证有id字段
        //   return _existGids.indexOf(item.gid) < 0;
        // })
        // console.log("initListByRoom _filterGroups, _resultArray = ", _filterGroups, _resultArray);
        // _resultArray = _filterGroups.concat(_resultArray);
      }

      // 如果_resultArray存在id为空的情况
      for (let item of _resultArray) {
        if (item.id >= 0) {
          continue;
        }
        item.id = item.gid || item.rid || 0;
      }

      // 如果是超级面板进入则排除255以上的设备
      if (this.from == "metapad" || this.from == "pwrmetapad") {
        _resultArray = _resultArray.filter(item => (item.a < 255) || (!item.a));
      }
      // 更新列表
      _updateJson.actionList = _resultArray;
    }
    // 更新下标
    _updateJson.tabIndex = tabIndex || 0;
    this.setData(_updateJson);
  },

  // 设备去重  其中空调逻辑需要特殊处理一下： 空调网关选择之后不能选择空调内机
  fitlerDevsBySceneInfo (allArray, existArray) {
    if (!allArray || allArray.length == 0) {
      return [];
    } else if (!existArray || existArray.length == 0) {
      return allArray;
    }
    // 去重的设备d集合 这里需要处理空调网关和空调内机的逻辑
    // let _tmps = existArray.map(item => item.d);
    let _existDArray = []; // 存在的真实d集合
    let _existAirGateway = []; // 如果存在子设备，则去除网关
    for (let item of existArray) {
      let _d = item?.d || "";
      _existDArray.push(_d);

      // 这里判断如果是空调内机则需要去除空调网关的数据
      let _didArray = _d.split("_");
      let _didStart = _didArray[0];
      if (_didArray.length > 1 && _existAirGateway.indexOf(_didStart) < 0) {
        // 空调网关子设备
        _existAirGateway.push(_didArray[0]);
      }
    }
    
    // 网关和已经存在的设备集合
    let _allDArray = _existDArray.concat(_existAirGateway);
    console.log("fitlerDevsBySceneInfo allArray, _existDArray, _existAirGateway = ", allArray, _existDArray, _existAirGateway);
    // return allArray.filter(item => _tmps.indexOf(item.d) < 0)
    return allArray.filter(item => {
      let _d = item?.d || "";
      
      // 先判断是否包含相同的did
      let _isExist = _allDArray.indexOf(_d) >= 0;
      if (_isExist) {
        return false;
      }

      // 这里判断如果是空调内机则需要去除空调网关的数据
      let _didArray = _d.split("_");
      // let _isSubAir = _d.indexOf("_") >= 0;
      if (_didArray.length > 1) {
        // 空调网关子设备
        return _existDArray.indexOf(_didArray[0]) < 0;
      }
      return true;
    });
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 初始化设备列表
    this.initListByRoom(this.data.roomInfo?.id, this.data.tabIndex);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // app.globalData.devInfo = 
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  selectDev (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.actionList[index];
    console.log("selectDev _item = ", _item);
    // 是否来自超级面板的绑定
    if (this.from != "metapad" && this.from != "pwrmetapad" && this.from != "tvlamp") {
      // 如果选择，则提示
      if (_item.rt) {
        ability.showToast({
          title: "该设备场景已满"
        })
        return;
      } else {
        let _devTypeStr = bizUtil.getDevTypeStr(_item.t);
        // 如果是窗帘，判断是否设置了上下限位
        if (_devTypeStr == "curtain") {
          let {up, down} = bizUtil.getCurtainLimitConfig(_item);
          if (!up || !down) {
            // 提示没有设置上下限位
            return ability.showModal({
              title: "",
              content: "请设置窗帘限位，窗帘比例以及场景控制，才会生效",
              showCancel: true,
              confirmText: "去设置",
              confirmColor: "#F78D3F",
              cancelText: "取消",
              cancelColor: '#000000'
            }).then((res) => {
              if (!res) {
                return;
              }
              // 设置设备信息
              app.globalData.devInfo = _item;
              // 跳转设置页面
              ability.navigateTo("/device/curtain/funcSetting/index?from=sceneAddDevice");
              // ability.navigateTo("/device/curtain/bestLocation/index?from=sceneAddDevice");
            })
          }
        }
      }
    }

    // 选中数据
    this.setProperValue("did", _item.gid || _item.d || 0);
  },

  chooseRoom (e) {
    let {rid} = e.currentTarget.dataset;
    let _roomInfo = app.globalData.devs[rid || 0];
    this.data.roomInfo.n = _roomInfo.n;
    this.data.roomInfo.id = _roomInfo.id;
    this.setProperValue("roomInfo", this.data.roomInfo);
    // 隐藏
    this.hidePop();
    // 显示对应的房间信息
    this.initListByRoom(this.data.roomInfo?.id, this.data.tabIndex);
  },
  showPop () {
    this.hidePop(true);
  },
  closePop () {
    this.hidePop();
  },
  hidePop (isOpen) {
    this.setProperValue("roomChanged", isOpen || false);
  },

  // 群组选中的数据
  getGroupedSelectArrayByConfig (configJson) {
    let _configJson = configJson || {};
    let _resultArray = [];
    for (let key in _configJson) {
      let {selecteds, list} = _configJson[key] || {};
      if (list?.length > 0 && selecteds?.length > 0) {
        for (let index of selecteds) {
          !!list[index] && (_resultArray.push(list[index]));
        }
      }
    }
    return _resultArray;
  },

  // 群组的下一步点击
  groupNext () {
    let _selectArray = this.getGroupedSelectArrayByConfig(this.data.groupItemObj);
    console.log("groupNext _selectArray = ", _selectArray);
    if (_selectArray.length == 0) {
      return ability.showToast({
        title: "请选择群组"
      });
    }

    // 取出选中的第一个数据
    let _selectGroupInfo = _selectArray[0] || {};

    // 如果是超级面板绑定群组，则进入绑定页面
    if (this.from == "metapad" || this.from == "pwrmetapad") {
      // 超级面板绑定群组
      this.bindDevice(_selectGroupInfo);
      return;
    }

    // 保存设备信息
    app.globalData.devInfo = _selectGroupInfo;
    // 跳转页面
    this.jumpPageByPid(_selectGroupInfo.t);
  },

  // 取得选中的设备数据
  getSelectItemInfo (list, did) {
    let _did = did;
    let _filterDevs = (list || []).filter(item => (item.d == _did || item.gid == _did));
    if (_did == undefined || _filterDevs.length == 0) {
      ability.showToast({
        title: "请选择设备或群组"
      });
      return undefined;
    }
    // 选中的设备信息
    return _filterDevs[0];
  },

  // 下一步
  next () {

    // 是否群组点击的下一步
    if (this.data.tabIndex == 1) {
      // 群组的下一步按钮
      return this.groupNext();
    }

    // 选中的设备信息
    let item = this.getSelectItemInfo(this.data.actionList, this.data.did);
    console.log("next item = ", item);
    if (!item) {
      return;
    }

    // 如果是从超级面板中进入
    if (this.from == "metapad" || this.from == "pwrmetapad" || this.from == "tvlamp") {
      if (this.data.devTypeStr == "switch" && (this.from == "metapad" || this.from == "pwrmetapad")) {
        // return this.jumpPageByPid(item);
        app.globalData.panelInfo = item;
        console.log("next item, app.globalData.devInfo = ", item, app.globalData.devInfo);
        // 这里只能支持单个设备的绑定，不支持群组和房间
        return ability.redirectTo("/scene/panelDetail/index?from=" + this.from + "&edit=" + (this.bindPwrKey || 0) + "&metaKey=" + this.key + "&sidSDK=" + bizUtil.getSceneId(item.a, item.id, this.metaType || 3) + "&lowPower=" + this.lowPower);
      }
      return this.bindDevice(item);
    }

    // 保存设备信息
    app.globalData.devInfo = item;

    // 跳转页面
    this.jumpPageByPid(item.t);
  },
  jumpPageByPid (pid) {
    let _devTypeStr = bizUtil.getDevTypeStr(pid);
    // 如果是继电器设备，则跳转另一个页面
    if (bizUtil.isPwrAvalibleDev(pid) || _devTypeStr == "powerstrip") {
      let _extendStr = _devTypeStr == "powerstrip" ? "?hideTab=1" : "";
      return ability.redirectTo("/scene/pwrAvalible/index" + _extendStr)
    }
    if (_devTypeStr == "aircondition" || _devTypeStr == "thermostat") {
      return ability.redirectTo("/scene/aircondition/index")
    } else if (_devTypeStr == "coathanger") {
      // 晾衣架
      return ability.redirectTo("/scene/coathanger/index")
    } else if (_devTypeStr == "gateway") {
      // 网关 循环场景
      return ability.redirectTo("/device/gateway/timer/list/index?title=" + encodeURIComponent(app.globalData.devInfo?.n) + "&type=cycle&from=scene")
    }
    // 跳转页面
    ability.redirectTo("/scene/status/index")
  },

  showLoading (str) {
    if (this.lowPower) {
      this.manageDialog(true);
    } else {
      ability.showLoading({
        title: str || "",
        mask: true
      });
    }
  },
  hideLoading () {
    if (this.lowPower) {
      this.manageDialog();
    } else {
      ability.hideLoading();
    }
  },
  manageDialog (value) {
    this.setData({
      showSaveDialog: value || false
    })
  },
  // 设备解绑 目前在电视氛围灯中用到
  unbindDevice () {
    let str = "解绑中…";
    // 超级面板信息
    let _metapadInfo = app.globalData.devInfo || {};
    console.log("unbindDevice _metapadInfo = ", _metapadInfo);

    // 获取到绑定信息
    let _dsArray = (_metapadInfo.ds || []).filter(item => item.key == this.key);
    if (_dsArray.length == 0) {
      return;
    }
    let {cmd, key, sid, rid, type} = _dsArray[0] || {};
    console.log("unbindDevice sid, rid = ", sid, rid);  

    // 场景id 设备房间id + 设备类型 + 设备短地址
    let _sceneId = bizUtil.getSceneId(sid, rid, type);
    console.log("unbindDevice sid, rid, type = ", sid, rid, type);
    
    // 提示等待中
    this.showLoading(str || '');
    // 解绑电视氛围灯
    app.globalData.blsdk.metapadUnBindDev(_metapadInfo.a, key, _sceneId, (result) => {
      console.log("unbindDevice result = ", result);
      this.hideLoading();
      let _str = "";
      if (result < 0 || result === false || result == undefined || result.errCode) {
        _str = '解绑失败';
      } else {
        _str = '解绑成功';
        // 根据按键删除之前绑定的设备
        bizUtil.delInArrayByKey(_metapadInfo.ds, this.key, "key");
        setTimeout(() => {
          this.back();
        }, 1500);
      }
      ability.showToast({
        title: _str
      });
    });
  },
  // 超级面板的绑定
  bindDevice (devInfo) {
    let str = "绑定中…";

    // 超级面板信息
    let _metapadInfo = app.globalData.devInfo || {};

    // 是否超级面板绑定窗帘
    let _isCoupleMetapadCurtain = (this.from == "metapad" || this.from == "pwrmetapad") && this.data.devTypeStr == "curtain" && !bizUtil.isUncoupleMetapad(_metapadInfo?.t);

    console.log("bindDevice _metapadInfo, devInfo = ", _metapadInfo, devInfo);
    // 绑定按键的第几路
    let _bindKeyVal = this.key;
    // 非耦合如果选中窗帘，则按键需要/2作为绑定，且绑定开关两路。例如5路选中，则绑定按键3，按键4
    if (_isCoupleMetapadCurtain) {
      _bindKeyVal = parseInt(_bindKeyVal / 2);
    }
    console.log("bindDevice _bindKeyVal = ", this.key, _bindKeyVal);

    // 提示等待中
    this.showLoading(str || '');
    // 场景id 设备房间id + 设备类型 + 设备短地址
    let _sceneId = 0;
    // 取得发送的数据
    let _sendType = bizUtil.getTypeByDevTypeStr(this.data.devTypeStr);
    // 判断选中的是群组还是单个设备
    let _isGroupBind = (devInfo?.gid >= 0);
    if (_isGroupBind) {
      let {gid} = devInfo || {};
      // 群组
      _sceneId = bizUtil.getSceneId(0, gid, _sendType);
    } else {
      let {a, id} = devInfo || {};
      console.log("bindDevice devInfo = ", devInfo);
      // 单个设备
      _sceneId = bizUtil.getSceneId(a, id, _sendType);
    }
    console.log("bindDevice _sceneId, _sendType = ", _sceneId, _sendType);

    // 更新场景
    app.globalData.blsdk.metapadBindDev(_metapadInfo.a, _bindKeyVal, _sceneId, (result) => {
      console.log("next result = ", result);
      this.hideLoading();
      let _str = "";
      if (result < 0 || result === false || result == undefined || result.errCode) {
        _str = '绑定失败';
      } else {
        _str = '绑定成功';
        // 加入数据
        this.dealAfterSave({
          metapadInfo: _metapadInfo, 
          devInfo: devInfo, 
          isGroupBind: _isGroupBind, 
          sendType: _sendType,
          isCoupleMetapadCurtain: _isCoupleMetapadCurtain,
          bindKeyVal: _bindKeyVal,
          // originKey: this.key
        });
        setTimeout(() => {
          this.back();
        }, 1500);
      }
      ability.showToast({
        title: _str
      });
    }, {
      // 设备类型
      devType: _sendType
    });
  },
  dealAfterSave ({metapadInfo, devInfo, isGroupBind, sendType, isUnbind, isCoupleMetapadCurtain, bindKeyVal}) {
    if (!metapadInfo || (!devInfo && !isUnbind) || bindKeyVal == undefined) {
      return;
    }
    // // 新的数据
    // let _key = bindKeyVal;
    // 超级面板数据
    metapadInfo.ds = metapadInfo?.ds || [];
    console.log("dealAfterSave metapadInfo, bindKeyVal = ", metapadInfo, bindKeyVal);

    // 根据按键删除之前绑定的设备
    let _startIndex = bindKeyVal;

    // 是否非耦合的超级面板
    let _isUncoupleMetapad = bizUtil.isUncoupleMetapad(metapadInfo?.t);
    if (_isUncoupleMetapad) {
      // 非耦合设备
      metapadInfo.ds = metapadInfo.ds.filter(item => item.key != _startIndex || item.type != sendType);
    } else {
      // 耦合设备
      if (isCoupleMetapadCurtain) {
        _startIndex = bindKeyVal * 2;
        // 耦合设备删除两个
        bizUtil.delInArrayByKey(metapadInfo.ds, _startIndex, "key");
        bizUtil.delInArrayByKey(metapadInfo.ds, _startIndex + 1, "key");
      } else {
        bizUtil.delInArrayByKey(metapadInfo.ds, _startIndex, "key");
      }
    }
    
    console.log("dealAfterSave metapadInfo = ", metapadInfo);
    console.log("dealAfterSave devInfo = ", devInfo);
    // 如果是解绑则返回
    if (isUnbind) {
      return;
    }
    // 加入数据
    let _sid = (isGroupBind ? 0 : devInfo.a);
    let _rid = isGroupBind ? (devInfo.gid || devInfo.rid || 0) : devInfo.id;
    let _cmd = isGroupBind ? (devInfo.gid + "") : devInfo.d; // 如果是设备，则是短地址，如果是群组则为0
    metapadInfo.ds.push({
      sid: _sid,
      rid: _rid,
      type: sendType || 0, // 发送的品类 数值
      key: _startIndex, // 第几路
      cmd: _cmd 
    });
    // 如果是耦合设备
    if (isCoupleMetapadCurtain) {
      metapadInfo.ds.push({
        sid: _sid,
        rid: _rid,
        type: sendType || 0, // 发送的品类 数值
        key: _startIndex + 1, // 第几路
        cmd: _cmd  // 如果是设备，则是短地址，如果是群组则为0
      });
    }
  },
  back () {
    ability.navigateBack();
  },

  tabClick (e) {
    let {index} = e.currentTarget.dataset;
    // 初始化数据
    this.initListByRoom(this.data.roomInfo?.id, index);
  },
  groupClick (e) {
    let {index, pIndex} = e.detail;
    console.log("groupClick e = ", e);
    let _groupItemObj = this.data.groupItemObj || {};
    let _currentKeyObj = _groupItemObj[pIndex] || {};
    let _currentKeySelects = _currentKeyObj.selecteds || [];
    let _selectedLen = _currentKeySelects.length; // 当前是否选中 因为现在只能单选，所以只需要判断长度

    // 清空选项 保证只有一项被选中
    for (let key in _groupItemObj) {
      _groupItemObj[key].selecteds = [];
    }
    // 确保只能有一个被选中
    if (_selectedLen > 0 && _currentKeySelects[0] == index) {
      _currentKeyObj.selecteds = [];
      // delete _currentKeyObj.selecteds[index];
    } else {
      _currentKeyObj.selecteds = [index];
    }
    console.log("groupClick _currentKeyObj, _groupItemObj = ", _currentKeyObj, _groupItemObj);
    // let _key = `groupItemObj.${pIndex}.list[${index}].selected`;
    this.setData({
      groupItemObj: _groupItemObj
    })
  }
})