// scene/addScene/index.js
const ability = require("../../utils/classDef/ability")
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "创建场景"
      }
    },
    // list: [
    //   {
    //     title: "场景名称",
    //     bindtap: "toHelp",
    //     tip: "阅读"
    //   }, {
    //     title: "所在房间",
    //     bindtap: "toDeviceShare",
    //     tip: "全屋"
    //   }, {
    //     title: "风格",
    //     bindtap: "toRoomSet",
    //     tip: "",
    //     img: '../../static/img/devList/scene/read.png'
    //   }
    // ],
    selectTabId: 2, // 默认选中的tab
    batchs: [
      {
        title: '当前设备状态',
        type: 2
      }, {
        title: '自定义',
        type: 1
      }/*, {
        title: '照明批量',
        type: 0
      }*/
    ],
    sceneName: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {

  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    // 初始化场景名称
    this.initSceneName();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  initSceneName () {
    let _name = app.globalData.sceneInfo?.n || '';
    console.log("initSceneName _name = ", _name);
    this.data.sceneName = _name;
    this.setData({
      sceneName: this.data.sceneName
    })
  },

  itemClick (e) {
    let {type} = e.currentTarget.dataset;
    console.log("devClick item.type = ", type);
    this.setSelectTabId(type);
  },
  setSelectTabId (type) {
    this.data.selectTabId = type || 0;
    this.setData({
      selectTabId: this.data.selectTabId
    })
  },

  clearName () {
    this.data.sceneName = '';
    this.setData({
      sceneName: ''
    })
  },

  showToast (str) {
    return ability.showToast({
      title: str || ''
    })
  },

  nameInput (e) {
    let _name = e.detail.value;
    if (_name.length > 16) {
      this.showToast("设备名称长度不能大于16");
      _name = _name.substr(0, 16);
      this.setData({
        sceneName: _name
      });
    }
    this.data.sceneName = _name;
    console.log("nameInput _name = ", _name);
  },
  
  next () {
    // 判断是否输入名称
    let _sceneName = this.data.sceneName || '';
    let _length = _sceneName.length;
    if (_length == 0) {
      return this.showToast("场景名称不能为空");
    } else if (_length > 16) {
      return this.showToast("场景名称最大长度为16");
    }
    // 进入添加场景页面 新增场景
    let _sceneInfo = app.globalData.sceneInfo || {};
    _sceneInfo.n = _sceneName;

    // // 判断如果是默认的空场景，则更新type
    // if (_sceneInfo.t == 3) {
    //   _sceneInfo.t = this.data.selectTabId + 3;
    // } else {
      _sceneInfo.t = this.data.selectTabId;
      let _sceneArray = app.globalData.devs[_sceneInfo.rid || 0].scenes || [];
      // 如果选择的是自定义的，则图标改成自定义图标
      if (_sceneInfo.t == 1) {
        _sceneInfo.i = "icon_scene_custom";
      }
      // 如果没有超出，则加入到场景列表中
      _sceneArray.push(_sceneInfo);
    // }
    
    // let _id = this.getSceneId(_sceneArray);
    // if (_id < 0) {
    //   ability.showToast({
    //     title: '已达到最大场景值，无法再增加'
    //   })
    //   return;
    // }
    
    // 页面跳转
    ability.redirectTo("/scene/sceneDetail/index");
  }
})