// scene/coathanger/index.js
import {Utils} from '../../utils/util'
const ability = require("../../utils/classDef/ability")
const app = getApp();
const bizUtil = require("../../utils/bizUtil");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "设备状态"
      }
    },
    topList: [], // 头部列表
    bottomList: [], // 升降列表
    sceneInfo: {},
    status: {},
    devName: '', // 设备名称

    showCustomToast: false, // 是否显示自定义的提示框
    customToastConfig: {}, // 自定义提示框配置信息

    // 按钮 根据编辑状态动态显示
    actions: [],

    types: [],  // 顶部选项条
    currentType: 0,

    devType: 'light', // 默认灯泡设备

    // 非唤醒的提示
    showLoadingDialog: false,
    loadingConfig: {
      forward: false
    },
    // 定时器
    timer: null,
    // 上一个修改房间方法是否过期
    lastAvalible: false,
    // 修改房间的方法
    // modifyFunc: undefined,

    // isGroup: false // 是否群组编辑
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let {index} = options || {};
    // 是否编辑状态
    this.editIndex = (index == undefined) ? -1 : Number(index);
    console.log("onLoad this.editIndex = ", this.editIndex);
    // 是否群组编辑
    this.isGroup = this.initIsGroup();
    // 初始化状态 如果群组，则返回数组
    let _tabArray = this.isGroup ? [] : (this.initTabByAbility());
    // 初始化设备品类
    this.data.devType = (this.initDevType());
    // 初始化开关列表
    let _topList = this.initTopList();
    // 取得上标 晾衣架暂时默认为0
    let _currentType = this.data.currentType; // this.getSelectTabIndex(); 
    // 底部按钮特殊处理
    let _actions = this.getActionsByCurrentType(_currentType);
    // 初始化数据
    this.data.status = this.initDevStatus();
    // 初始化设备状态
    let _bottomList = this.getStatusListByStatus(this.data.status);

    this.setData({
      topList: _topList,
      devType: this.data.devType,
      // isGroup: this.isGroup, // 是否群组场景
      types: _tabArray,
      bottomList: _bottomList,
      devName: app.globalData.devInfo?.n || "",
      actions: _actions,
      status: this.data.status
    });
  },
  // 是否群组编辑
  initIsGroup () {
    return app.globalData.devInfo?.gid >= 0;
  },
  initTabByAbility () {
    let _devInfo = app.globalData.devInfo;
    console.log("initTabByAbility _devInfo = ", _devInfo);
    let _v = _devInfo.v || ""; // 取得版本信息

    let _support = false; // 默认不支持
    // 如果版本信息不为空
    if (_v.length > 0) {
      // 版本号信息
      let _json = bizUtil.getJsonByAblitys(_v, bizUtil.getDevTypeStr(_devInfo?.t), {t: _devInfo?.t});
      _support = _json?.sceneException;
    }

    let _types = this.getAllTypes(_support);
    if (_v == undefined && _devInfo.gid > 0) {
      _types = this.data.types.slice(0, 1); // 群组暂时只支持自定义状态
    }
    return _types;
  },
  getAllTypes (support) {
    let _array = [{
      name: "设备状态设置"
    }, {
      name: "保存当前状态"
    }];
    if (support) {
      _array.push({
        name: "不执行场景"
      });
    }
    return _array;
  },
  // 初始化设备品类
  initDevType () {
    // 取得设备品类
    let _devTypeKey = bizUtil.getDevTypeStr(app.globalData.devInfo?.t);
    console.log("initDevType _devTypeKey = ", _devTypeKey, app.globalData.devInfo.t);
    return _devTypeKey;
  },
  initTopList () {
    return [{
      name: '照明',
      key: "lamp",
      value: 0
    }, {
      name: '风干',
      key: "fan",
      value: 0
    }, {
      name: '烘干',
      key: "dry",
      value: 0
    }, {
      name: '消毒',
      key: "disinfect",
      value: 0
    }];
  },
  getAllActions () {
    return [{
      n: '删除',
      classStr: 'delBtn',
      handle: 'delDev'
    }, {
      n: '保存',
      classStr: 'saveBtn marginL49',
      handle: 'saveInfo'
    }]
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    // this.initCurrentType();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // 清除数据
    this.resetGroupSceneTimer();
    // 停止刚播和接收
    app.globalData.blsdk.destory();
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 上标
  getSelectTabIndex () {
    // 自定义时需要
    let _devInfo = app.globalData.devInfo || {};
    let _devStatus = _devInfo.cmd;

    // 取得当前选择的type
    let _currentType = this.getCurrentType(_devStatus);
    return _currentType;
  },

  // 根据
  initDevStatus () {
    // 自定义时需要
    let _devInfo = app.globalData.devInfo || {};
    let _devStatus = _devInfo.cmd;
    let _devTypeStr = this.data.devType;
    // 设备能力集合
    let _status = bizUtil.getFuncByPid({}, _devInfo.t); // 默认数据
    console.log("initDataByDevType _status = ", JSON.stringify(_status), _devStatus, _devTypeStr);

    // 如果status是二进制控制命令，则转成对应的json数据 这里其实只有灯泡和窗帘才进入
    if (!!_devStatus && _devStatus.pwr == undefined) {
      if (typeof _devStatus == "string") {
        // string
        _status = bizUtil.getJsonByCmdAndType(Utils.hexStrToArray(_devStatus), _devTypeStr);
      } else {
        // 数组
        _status = bizUtil.getJsonByCmdAndType(_devStatus, _devTypeStr);
      }
    }
    console.log("initDataByDevType _status = ", JSON.stringify(_status), typeof _status);
    // this.data.status = _status;
    return _status;
  },

  getCurrentType (cmd) {
    console.log("getCurrentType cmd, this.editIndex = ", cmd, this.editIndex);
    // 新增时默认返回自定义
    if (this.editIndex < 0) {
      return 0;
    }

    let _num = 0;
    if (cmd === '' || cmd === undefined) {
      _num = 2;
    } else if (cmd && cmd.length == 0) {
      _num = 1;
    } else {
      _num = 0;
    }
    let _len = this.data.types?.length || 0;
    if (_num >= _len) {
      // 如果长度大于等于默认的下标
      _num = 0;
    }
    return _num;
  },

  getStatusListByStatus (status) {
    let _array = this.getAllStatusList(status);
    return _array;
  },
  getAllStatusList () {
    return [{
      name: '全升',
      key: 'up',
      value: 0
    }, {
      name: '全降',
      key: 'down',
      value: 1
    },{
      name: '不执行',
      key: 'noUpDown',
      value: 3
    }];
  },

  // 不动作
  /*customNoAction () {
    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _sceneInfo = app.globalData.sceneInfo || {}; // 场景信息

    // 非删除
    this.data.isDelete = false;
    // 显示等待条
    this.showLoading("正在设置中…");

    let _sid = _sceneInfo.sid, _rid = _sceneInfo.rid || 0;
    app.globalData.blsdk.customSceneAction(_devInfo.a, (_rid << 16) + _sid, (result) => {
      console.error("save result = ", result);
      // 是否失效
      if (this.data.lastAvalible) {
        console.log("outdate");
        return;
      }
      
      // 初始化定时器
      this.destoryTimer();
      // 隐藏等待条
      this.hideLoading();

      if (result < 0 || result === false || result == undefined || result.errCode) {
        // this.setShowCustomToast(true, 'error', '设置失败', true);
        this.setShowCustomToast(true, 'error', '设置失败');
      } else {
        // this.setShowCustomToast(true, 'success', '设置成功', true);
        this.setShowCustomToast(true, 'success', '设置成功');

        setTimeout(this.dealAfterSend, 1000);
      }
    })
  },
  // 当前状态
  currentStatus () {
    // 保存当前状态
    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _sceneInfo = app.globalData.sceneInfo || {}; // 场景信息
    // 提示等待中
    this.setShowCustomToast(true, 'loading', '设置中…', 20000);

    // // 显示等待条
    // this.showLoading("正在设置中…");
 
    let _sid = _sceneInfo.sid, _rid = _sceneInfo.rid || 0;
    console.log("currentStatus _sid, _rid = ", _sid, _rid);
    app.globalData.blsdk.roomSceneAddWithDeviceAddr(_devInfo.a, (_rid << 16) + _sid, (result) => {
      console.error("save result = ", result);

      // // 是否失效
      // if (this.data.lastAvalible) {
      //   console.log("outdate");
      //   return;
      // }
      
      // // 初始化定时器
      // this.destoryTimer();
      // // 隐藏等待条
      // this.hideLoading();

      if (result < 0 || result === false || result == undefined || result.errCode) {
        // this.setShowCustomToast(true, 'error', '设置失败', true);
        this.setShowCustomToast(true, 'error', '设置失败');
      } else {
        // this.setShowCustomToast(true, 'success', '设置成功', true);
        this.setShowCustomToast(true, 'success', '设置成功');
        
        setTimeout(this.dealAfterSend, 1000);
      }
    })
  },*/

  // 取得自定义设备状态的json数据
  getStatusJson () {
    // 设备状态
    let _status = this.data.status || {};
    // 加入设备品类
    _status.devTypeStr = bizUtil.getDevTypeStr(app.globalData.devInfo?.t);
    return _status;
  },

  // 保存群组的场景
  saveSceneGroupInfo () {
    // 取得自定义命令集合
    let _status = this.getStatusJson();
    // 场景信息
    let _sceneInfo = app.globalData.sceneInfo || {};
    // 群组信息
    let _groupInfo = app.globalData.devInfo || {};

    // 根据群组信息取得支持和不支持的设备列表
    let {supports, unsupports} = this.getGroupSceneConfig(_groupInfo, app.globalData.devs);
    console.log("saveSceneGroupInfo supports, unsupports = ", supports, unsupports);
    let _supportsLen = supports.length, _unsupportsLen = unsupports.length;
    if (_supportsLen == 0 && _unsupportsLen == 0) {
      return ability.showToast({
        title: "当前为空群组"
      });
    } else if (_unsupportsLen == 0) {
      this.showLoading("发送中…", true);
      // 所有设备都支持场景群组
      this.sendAllSupportSceneGroup({
        sceneInfo: _sceneInfo,
        groupInfo: _groupInfo,
        status: _status
      }, (res) => {
        ability.hideLoading();
        // 返回数据
        if (res != 0) {
          return;
        }
        // 后续处理
        this.dealAfterSendGroup(supports);
        // 返回页面
        setTimeout(this.back, 500);
      });
    } else {
      this.showLoading("发送中…", true);
      // 只发送自定义的设备
      let _sendArray = unsupports.concat([]);
      // 发送自定义和群组的设备
      if (_supportsLen > 0) {
        // 支持群组场景编辑
        _sendArray.push(_groupInfo);
      }
      console.log("saveSceneGroupInfo _sendArray = ", _sendArray);
      // 发送数据
      this.dealBeforeSend({
        array: _sendArray,
        sceneIdSDK: bizUtil.getSceneId(_sceneInfo?.sid, _sceneInfo?.rid),
        status: _status,
        sceneInfo: _sceneInfo,
        groupInfo: _groupInfo
      }, (res) => {
        ability.hideLoading();
        // 分别把数据加入到场景中
        if (res < 0) {
          return;
        }
        // 加入数据
        this.dealAfterSendGroup(supports.concat(unsupports));
        // 返回页面
        setTimeout(this.back, 500);
      })
    }
  },
  // 清除定时器和发送数据
  resetGroupSceneTimer () {
    this.sendCount = 0; // 发送起始
    bizUtil.clearTimer(this.intervalTimer, "interval");
  },
  // 不支持群组场景的一条条发送 或者不支持设备与支持群组场景的一条条发送
  dealBeforeSend (config, callback) {
    // 配置的数据
    let {array, sceneIdSDK, status, sceneInfo, groupInfo} = config || {};
    if (!array || array.length == 0 || !status) {
      !!callback && (callback(0));
      return;
    }
    // 发送之前初始化
    this.resetGroupSceneTimer();
    // 开启定时器
    this.intervalTimer = setInterval(() => {
      // 判断当前蓝牙状态，如果没有开启，则退出
      if (!app.globalData.blsdk.isBleAvailable()) {
        // 发送之前初始化
        this.resetGroupSceneTimer();
        !!callback && (callback(-1));
        return;
      }
      // 如果发送完成
      if (this.sendCount >= array.length) {
        // 发送之前初始化
        this.resetGroupSceneTimer();
        // 没有数据表示发送完成
        !!callback && (callback(0));
        return;
      }
      let _info = array[this.sendCount];
      if (!_info) {
        // 没有数据表示发送完成
        this.sendCount++;
        return;
      }
      // 判断发送单个设备还是群组
      if (_info?.gid > 0) {
        console.log("dealBeforeSend group _info = ", _info);
        this.sendAllSupportSceneGroup(config);
      } else {
        // 取得设备状态 根据rgbcw的能力来动态调整
        let _realStatus = bizUtil.getCmdJsonByT(status, _info?.t);
        console.log("dealBeforeSend device _info, _realStatus = ", _info, _realStatus);
        app.globalData.blsdk.sceneManageCtrl({
          // 这里可能是短地址可能是设备信息
          deviceInfo: _info,
          a: _info?.a,
          roomId: sceneInfo?.rid || 0,
          command: {
            actType: 0,
            sid: sceneInfo?.sid || 0,
            cmd: _realStatus
          },
          noRemote: true
        });
      }
      // 发送+1
      this.sendCount++;
    }, 400);
  },
  // 都支持群组场景的场合
  sendAllSupportSceneGroup ({sceneInfo, groupInfo, status}, callback) {
    // 发送的参数
    let _paramObj = {
      sceneInfo: sceneInfo,
      groupId: groupInfo?.gid,
      cmd: status,
      actType: 0, // 添加/更新情景 1 - 删除情景 2-修改面板默认情景 3-情景例外 4-超级面板
      pid: bizUtil.getSendPidByType(groupInfo?.t)
    };
    // 群组的场景不需要等待返回，需要多发几次
    app.globalData.blsdk.sendGroupScene(_paramObj, (res) => {
      !!callback && (callback(res));
      // // 返回数据
      // if (res != 0) {
      //   return;
      // }
      // // 后续处理
      // this.dealAfterSendGroup(_paramObj);
    });
  },
  // 取得场景中不支持的数据
  getGroupSceneConfig (groupInfo, allDevs) {
    let _result = {
      supports: [],
      unsupports: []
    };
    let {dids} = groupInfo || {};
    if (!dids || dids.length == 0) {
      return _result;
    }
    // 取得所有的设备信息
    let _dMap = bizUtil.getDidMapInJson(allDevs);
    for (let d of dids) {
      let _obj = _dMap[d];
      if (!_obj) {
        continue;
      }
      // 是否支持组的场景编辑
      let {groupScene} = bizUtil.getJsonByAblitys(_obj?.v, bizUtil.getDevTypeStr(_obj?.t), {t: _obj?.t});
      if (!!groupScene) {
        _result.supports.push(_obj);
      } else {
        _result.unsupports.push(_obj);
      }
    }
    return _result;
  },
  dealAfterSendGroup (devArray) {
    // 取得所有的
    if (!devArray || devArray.length == 0) {
      return;
    }
    // 添加设备到场景中
    for (let item of devArray) {
      if (!item) {
        continue;
      }
      this.addDevIntoScenes(item);
    }
  },

  // 自定义设备状态
  saveInfo () {

    // 如果是场景，则发送场景数据
    if (this.isGroup) {
      return this.saveSceneGroupInfo();
    }

    // 根据当前选择的类型进行不同处理
    let _currentIndex = this.data.currentType;
    if (_currentIndex == 2) {
      // 不执行场景
      return this.back();
      // return this.customNoAction();
    } else if (_currentIndex == 1) {
      // 保存当前状态
      return this.back();
      // return this.currentStatus();
    }

    // 更新状态
    this.data.lastAvalible = false;

    // 取得自定义命令集合
    let _status = this.getStatusJson(); 
    console.log("saveInfo status = ", _status);

    // 非删除
    this.data.isDelete = false;
    // 显示等待条
    this.showLoading("正在设置中…");

    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _sceneInfo = app.globalData.sceneInfo || {}; // 场景信息
    let _sid = _sceneInfo.sid, _rid = _sceneInfo.rid || 0;
    app.globalData.blsdk.roomSceneAddWithCommand(_devInfo, (_rid << 16) + _sid, _status, (result) => {
      console.error("save result = ", result);
      // 是否失效
      if (this.data.lastAvalible) {
        console.log("outdate");
        return;
      }
      
      // 初始化定时器
      this.destoryTimer();
      // 隐藏等待条
      this.hideLoading();

      if (result < 0 || result === false || result == undefined || result.errCode) {
        // this.setShowCustomToast(true, 'error', '设置失败', true);
        this.setShowCustomToast(true, 'error', '设置失败');
      } else {
        // this.setShowCustomToast(true, 'success', '设置成功', true);
        this.setShowCustomToast(true, 'success', '设置成功');
        // 当前状态status = {}
        setTimeout(this.dealAfterSend, 1000);
      }
    })
  },
  dealAfterSend () {

    // 是否删除
    if (this.data.isDelete) {
      // 取得所有设备
      let _devs = app.globalData.sceneInfo?.devs || [];
      // 取得下表
      let _index = this.editIndex;
      // 删除设备
      _devs.splice(_index, 1);
      // 返回按钮
      setTimeout(this.back, 1000);
      // 重置
      this.data.isDelete = false;
      return;
    }

    // 设备添加
    this.addDevIntoScenes(app.globalData.devInfo);
    
    // console.log("_sceneInfo.devs = ", _sceneInfo.devs);
    // 返回上一页
    this.back();
  },

  // 添加执行设备到场景中
  addDevIntoScenes (devInfo) {
    if (!devInfo) {
      return;
    }
    let _devInfo = devInfo; // 选择的设备
    let _sceneInfo = app.globalData.sceneInfo || {}; // 场景信息
    let _status = this.getStatusByIndex(this.data.currentType); // 根据选择的
    console.log("dealAfterSend _status = ", _status, this.data.devType);
    // 把json的数据转string
    let _statusStr = '';
    if (_status == undefined) {
      _statusStr = '';
    } else {
      _statusStr = app.globalData.blsdk.getCmdBySceneInfo(_status, this.data.devType);
    }
    let _tip = bizUtil.getTipByStatus(_statusStr, _devInfo.t);
    console.log("dealAfterSend = ", _statusStr, _tip, _sceneInfo, _devInfo.v, this.editIndex);
    // 防止不存在数据
    _sceneInfo.devs = _sceneInfo.devs || [];

    // 判断数组中是否有包含设备d的
    let _filter = this.indexInArrayByKey(_sceneInfo.devs, "d", _devInfo?.d);
    // if (_filter >= 0) {
    // }

    // 编辑的数据
    let _index = this.editIndex;
    if (_filter < 0 && (_index < 0 || (_index >= 0 && _devInfo?.cmd == "default"))) {
      _sceneInfo.devs.push({
        v: _devInfo.v,
        d: _devInfo.d,
        t: _devInfo.t,
        cmd: _statusStr,
        tip: _tip,
        bp: _status?.brightnessP || undefined
      });
    } else {
      (_sceneInfo.devs[_index] || {}).tip = _tip;
      (_sceneInfo.devs[_index] || {}).cmd = _statusStr;
      (_sceneInfo.devs[_index] || {}).bp = _status?.brightnessP || undefined;
      !!_devInfo.v && ((_sceneInfo.devs[_index] || {}).v = _devInfo.v);
      !!_devInfo.t && ((_sceneInfo.devs[_index] || {}).t = _devInfo.t);
    }
  },
  indexInArrayByKey (array, key, value) {
    if (!array || array.length == 0) {
      return -1;
    } else if (!key) {
      return -1;
    }
    return array.findIndex(item => item[key] == value);
  },

  back () {
    // 返回上一页
    ability.navigateBack();
  },

  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    let {key, value} = this.data.bottomList[index];
    // 如果点击的是白光
    if ("noUpDown" == key || value < 0) {
      // this.data.status.updown = 3;
    } else {
      // 发送命令
      this.actDev({
        [key]: value
      });
    }
    // 设置数据
    this.data.status.updown = Number(value) || 0;
    this.setData({
      status: this.data.status
    })
  },
  actDev (key) {

    // 灯之外的设备不发送控制命令
    return;

    if (!key) {
      return;
    }
    // 不能assign,会有cw等保存进去
    for (let _k in key) {
      this.data.status[_k] = key[_k];
    }
    console.log("actDev app.globalData.devInfo, key = ", app.globalData.devInfo, key);
    if (this.isGroup) {
      app.globalData.blsdk.groupControlWithType(false, app.globalData.devInfo?.gid, key);
    } else {
      app.globalData.blsdk.controlWithDevice(app.globalData.devInfo, key, {
        noStop: false, // 晾衣架需要主动停止发包
        timestamp: 1000
      });
    }
  },

  // 设置是否显示自定义对话框
  setShowCustomToast (value, type, str, duration) {
    // console.log("setShowCustomToast ability = ", ability);
    if (!value) {
      ability.hideToast();
      // ability.hideLoading()
    } else {
      let _config = {
        title: str || '',
        icon: type || '',
        duration: duration || 1500
      };
      ability.showToast(_config);
    }
  },

  // 删除场景下已经绑定的设备
  roomSceneDeleteWithDeviceAddr (callback) {
    let _devInfo = app.globalData.devInfo;
    let {rid, sid} = app.globalData.sceneInfo;
    // console.log("app.globalData.sceneInfo status = ", app.globalData.sceneInfo, _devInfo)
    app.globalData.blsdk.roomSceneDeleteWithDeviceAddr(_devInfo.a, (rid << 16) + sid, callback)
  },

  // 删除场景下绑定的执行设备
  delDev () {
    // 很奇怪的问题  使用ability调用showModal不提示了
    wx.showModal({
      title: "",
      content: "是否删除该场景下的设备"
    }).then((res) => {
      if (!res || !res.confirm) { return; }
      
      // 显示loading
      this.showLoading();
      // 删除
      this.data.isDelete = true;
      
      // 删除设备
      this.roomSceneDeleteWithDeviceAddr((result) => {
        // 是否失效
        if (this.data.lastAvalible) {
          return;
        }
        
        // 初始化定时器
        this.destoryTimer();
        // 隐藏等待条
        this.hideLoading();

        console.error("delDev result = ", result);
        let _isSuccess = result >= 0;
        // 成功
        // setTimeout(() => {
        //   ability.showToast({
        //     title: _isSuccess ? '删除成功' : "删除失败请重试",
        //     icon: _isSuccess ? 'success' : 'error'
        //   });
        // }, 0);
        // 如果失败，则不处理后续
        if (!_isSuccess) {
          this.setShowCustomToast(true, 'error', '删除失败');
          return;
        }
        this.dealAfterSend();
        // this.setShowCustomToast(true, 'success', '删除成功');
        // // 取得所有设备
        // let _devs = app.globalData.sceneInfo?.devs || [];
        // // 取得下表
        // let _index = this.editIndex;
        // // 删除设备
        // _devs.splice(_index, 1);
        // // 返回按钮
        // setTimeout(this.back, 1500);
      });
    })
  },
  // showModal () {
  //   // 提示是否需要删除
  //   return ability.showModal({
  //     title: "",
  //     content: "是否删除改场景下的设备"
  //   })
  // },

  // 设备执行类型设置
  typeItemClick (e) {
    // 设置选中的值
    let {index} = e.currentTarget.dataset;
    let _currentType = index || 0;

    // 底部按钮特殊处理
    let _actions = this.getActionsByCurrentType(_currentType);
    console.log("typeItemClick _actions = ", _actions);

    this.setData({
      currentType: _currentType,
      actions: _actions
    });
  },

  // 特殊处理底部按钮
  getActionsByCurrentType (currentType) {
    // 所有按钮
    let _actions = this.getAllActions() || [];
    // 设置按钮文字
    // let _actionLen = _actions.length;
    let _currentType = currentType || 0; // this.data.currentType;
    if (this.editIndex < 0) {
      // 新增时
      if (_currentType >= 1) {
        _actions = [];
      } else {
        _actions = [_actions[1]];
      }
    } else {
      // 编辑时
      if (_currentType >= 1) {
        _actions[1].n = "返回";
        _actions[1].classStr = "finishBtn marginL49";
      }
      // 默认设备不能删除
      let _isDefault = app.globalData.devInfo?.cmd == "default";
      if (_isDefault) {
        _actions = _actions.filter(item => item.handle != "delDev");
      }
    }
    return _actions;
    // this.data.actions = _actions;
    // this.setData({
    //   actions: this.data.actions
    // })
  },

  // 根据不同的index取得不同的默认数据
  getStatusByIndex (index) {
    let _index = (index == undefined) ? this.data.currentType : index;
    if (_index == 1) {
      return {};
    } else if (_index == 2) {
      return undefined;
    } else {
      return this.data.status; 
    }
  },

  manageLoadingDialog (val) {
    this.data.showLoadingDialog = val || false;
    this.setData({
      showLoadingDialog: this.data.showLoadingDialog
    })
  },
  showLoading (str, isDefaultLoading) {

    // 如果是需要唤醒的设备
    if (this.data.devType == 'light' && !isDefaultLoading) {
      this.manageLoadingDialog(true);
      // 初始化定时器
      this.initTimer();
    } else {
      ability.showLoading({
        title: str || "",
        mask: true
      });
    }
  },
  hideLoading () {
    if (this.data.showLoadingDialog) {
      this.manageLoadingDialog(false);

      // 取消进一步提示
      this.data.loadingConfig.forward = false;
      this.setData({
        loadingConfig: this.data.loadingConfig
      })
      return;
    }

    ability.hideLoading();
  },
  initTimer () {
    // 先清除定时器
    this.destoryTimer();
    // 初始化定时器
    this.data.timer = setTimeout(() => {
      // 如果定时器还存在，则退出
      if (!this.data.timer) {
        return;
      }
      // 进一步提示
      this.data.loadingConfig.forward = true;
      this.setData({
        loadingConfig: this.data.loadingConfig
      })
    }, 5000);
  },
  destoryTimer (timer) {
    let _timer = timer || this.data.timer;
    if (!_timer) {
      return
    }
    clearTimeout(_timer);
    _timer = null;
  },
  // 对话框
  dialogClick (e) {
    let {data} = e.detail || {};
    // 是否显示对话框
    let _showLoadingDialog = false;
    if (data == 'retry') {
      // 重试按钮点击 不做
      // // 上一个修改房间方法是否过期
      // this.data.lastAvalible = true;
      // // 修改房间的方法
      // modifyFunc: undefined
    } else if (data == 'cancel') {
      // // 未响应
      // _showLoadingDialog = true;
      // 停掉之前的数据
      app.globalData.blsdk.destory();
      // 去掉接受的参数
      this.data.lastAvalible = true;
    } else if (data == 'confirm') {
      // 设置成功之后
      this.dealAfterSend();
      // 停掉之前的数据
      app.globalData.blsdk.destory();
      // 去掉接受的参数
      this.data.lastAvalible = true;
    }
    // 是否展示
    this.manageLoadingDialog(_showLoadingDialog);
    // 数据提示
    this.data.loadingConfig.forward = false;
    // this.data.showLoadingDialog = _showLoadingDialog;
    this.setData({
      // showLoadingDialog: this.data.showLoadingDialog,
      loadingConfig: this.data.loadingConfig
    })
  },

  topItemClick (e) {
    console.log("topItemClick e = ", e);
    let {index} = e.currentTarget.dataset;
    let {value} = e.detail;
    let {key} = this.data.topList[index];
    console.log("topItemClick key = ", key);
    // 发送控制命令
    this.actDev({
      [key]: Number(value)
    });
  }
})