import ability from '../../utils/classDef/ability'
const app = getApp();
Page({
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "名称修改"
      }
    },
    devName: '',
    fromPage: ""
  },
  onLoad (options) {
    // 接收参数
    let _name = this.getNameByOption(options);
   // 初始化设备名称
   this.initDevName(_name);
  },
  // 优先从option中获取参数
  getNameByOption (options) {
    console.log("getParamByOption options = ", options);
    let {name, from} = options;
    this.data.fromPage = from;
    if (!name) {
      return;
    }
    return decodeURIComponent(name);
  },
  initDevName (name) {
    let _name = name || app.globalData.devInfo.n || "";
    if (_name.length > 10) {
      _name = _name.substr(0, 10);
    }
    this.data.devName = _name;
    this.setData({
      devName: this.data.devName
    })
  },

  nameInput (e) {
    let _name = e.detail.value;

    // 只能输入汉字 字母和数字
    _name = _name.replace(/[^\w\u4E00-\u9FA5]/g, '');

    if (_name.length > 16) {
      this.showToast("设备名称长度不能大于16").then((isConfirm) => {
        this.setData({
          devName: _name.substr(0, 16)
        })
      });
      return;
    }
    this.data.devName = _name;
    this.setData({
      devName: this.data.devName
    })
    console.log("nameInput _name = ", _name);
  },
  showToast (str) {
    return wx.showModal({
      showCancel: false,
      content: str || "名称长度不能大于16"
    });
  },
  saveStorage (roomInfo, name) {
    if (!roomInfo) {
      return;
    }
    let _roomId = roomInfo.id || 0;
    // 保存名称
    roomInfo.n = name;
    app.globalData.devs[_roomId].n = name;
    
    console.error("curtain saveStorage");
    // 保存设备信息
    app.saveAllDevsMap();
    // app.setBizStorage("devs", app.globalData.devs);
  },
  saveName () {
    let _name = this.data.devName || '';
    if (_name.length == 0) {
      this.showToast("名称不能为空");
      return;
    } else if (_name.length > 16) {
      this.showToast("名称长度不能大于16");
      return;
    }

    console.log("saveName _name = ", _name);
    // 判断是否从房间详细进入的页面
    let _fromPage = this.data.fromPage;
    if (_fromPage == "roomDetail") {
      // app.globalData.roomInfo.n = _name;
      // 保存
      this.saveStorage(app.globalData.roomInfo, _name);
    } else if (_fromPage == "sceneName") {

      // 房间下的场景名称不能重复
      let _roomId = app.globalData.sceneInfo.rid || 0;
      // 当前的场景sid
      let _sid = app.globalData.sceneInfo.sid;
      // 取得房间下所有的场景
      let _scenes = (app.globalData.devs[_roomId] || {}).scenes || [];
      let _existSameName = _scenes.filter((item)=>(item.n == _name && item.sid != _sid));
      // 如果有相同的房间
      if (_existSameName.length > 0) {
        return ability.showToast({
          title: "房间内场景名称重复",
          // icon: "error"
        });
      }
      
      app.globalData.sceneInfo.n = _name;
    } else {
      app.globalData.devInfo.n = _name;
      console.error("curtain saveName");
      // 保存设备信息
      app.saveAllDevsMap();
      // app.setBizStorage("devs", app.globalData.devs);
    }

    // 上报数据
    app.uploadPrivateData();

    // 返回
    ability.navigateBack();
  },
  clearName () {
    this.data.devName = "";
    this.setData({
      devName: ""
    })
  }
})
