// scene/list/index.js
import ability from '../../utils/classDef/ability'
import bizUtil from '../../utils/bizUtil'
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "全部场景(6)"
      }
    },
    fixScenes: [],
    // customScenes: [],
    roomInfo: {
      id: 0, // 默认全屋
      n: '全屋'
    },
    // currentRoom: 0, // 默认全屋
    isManage: false, // 默认未选择管理
    roomChanged: false, // 修改房间
    rooms: [], // 房间列表
    roleNum: app.globalData.roleNum // 角色
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.data.roleNum = app.globalData.roleNum // 角色
    // 初始化选择的房间
    let _roomInfo = app.globalData.roomInfo;
    if (_roomInfo && _roomInfo.id >= 0) {
      this.data.roomInfo = _roomInfo;
      this.setData({
        roomInfo: this.data.roomInfo,
        roleNum: this.data.roleNum
      })
    }
    this.initRooms();
  },

  fileterSameScene (array) {
    let _result = [], json = {};
    if (!array || array.length == 0) {
      return [];
    }
    for (let item of array) {
      let _sid = item.sid;
      if (json[_sid] != undefined) {
        continue;
      }
      json[_sid] = true;
      _result.push(item);
    }
    return _result;
  },
  
  initScene () {
    let _devs = app.globalData.devs || {};
    let _roomId = this.data.roomInfo.id || 0;

    // // 如果房间id为全屋，则获取所有的场景
    // let _tmpArray = bizUtil.getAllDevsFilter(_devs, _roomId ? _roomId : undefined, 'scenes');
    // let _allScenes = this.fileterSameScene(_tmpArray);
    // 暂时屏蔽显示所有场景
    let _tmpArray = bizUtil.getAllDevsFilter(_devs, _roomId || 0, 'scenes');
    let _allScenes = this.fileterSameScene(_tmpArray);

    // // 测试数据
    // _allScenes = [];
    // for (let i = 0; i < 25; i++) {
    //   _allScenes.push({
    //     mode: 'add',
    //     rid: 1,
    //     i: 1, // icon下表
    //     b: 1, // 背景⾊下表
    //     sid: i,
    //     devs: [], // 自定义设备列表
    //     panels: [] // 面板列表
    //   })
    // };

    // 由于默认的全开全关每个房间都有，需要排除
    // let _scene = bizUtil.setBgAndIcon(_allScenes); // 分配图片和背景
    let _scene = _allScenes; // 分配图片和背景
    console.log("initScene _scene = ", _scene);

    // 设置标题
    ability.setNavigationBarTitle(`全部场景(${_scene.length})`);
    
    // 给每个场景加上房间号的显示
    for (let item of _scene) {
      item.tip = (_devs[item.rid || 0]?.n || "");
    }

    // 根据or排序
    this.data.fixScenes = _scene.sort((a, b) => {
      return a.or - b.or;
    });

    this.setData({
      fixScenes: this.data.fixScenes
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.initScene();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 初始化房间
  initRooms () {
    let _devs = app.globalData.devs || {};
    let {rooms} = bizUtil.getRoomsByDevs(_devs);
    console.log("initRooms rooms = ", rooms);
    this.data.rooms = rooms;
    this.setData({
      rooms: rooms
    })
  },

  // 创建场景
  addScene () {
    this.jumpManage();
  },
  jumpManage () {
    let _roomId = this.data.roomInfo.id || 0;
    let _devs = app.globalData.devs;

    _devs[_roomId].scenes = _devs[_roomId].scenes || [];
    let _scenes = _devs[_roomId].scenes; // [];
    // // 如果房间id为全屋，则获取所有的场景
    // if (_roomId != 0) {
    //   _scenes = bizUtil.getAllDevsFilter(_devs, undefined, 'scenes');
    // } else {
    //   _scenes = this.data.fixScenes;
    // }

    // id 
    let _sceneId = bizUtil.getIdByArray(_scenes, "sid", 17, 256);
    if (_sceneId < 0) {
      ability.showToast({
        title: "自定义场景最大个数为239"
      });
      return;
    }
    console.log("jumpManage _sceneId = ", _sceneId);
    // 取得场景中的最大场景id
    let _maxSid = bizUtil.getMaxValByKey(_scenes, 'or')
    // 背景颜色
    let _b = ((_sceneId % 9) || 0) + 1; // 1 - 9
    // 取得场景下的自定义个数
    let _defaultArrays = _scenes.filter(item=>(item.t>=3));
    let _nameIndex = _scenes.length - _defaultArrays.length;
    // let _i = _sceneId % 16; // 1 - 15
    // 进入添加场景页面 新增场景
    app.globalData.sceneInfo = {
      t: 1, // 自定义场景
      n: '自定义场景' + (_nameIndex + 1), // 空名称
      // mode: 'add',
      rid: _roomId,
      i: "icon_scene_custom", // 自定义
      // i: (_i ? _i : 1).toString(), // icon下表
      b: _b, // 背景⾊下表
      // icon: bizUtil.getSceneIcon(_sceneId),
      // bg: bizUtil.getSceneBg(_sceneId),
      sid: _sceneId,
      devs: [], // 自定义设备列表
      // panels: [], // 面板列表
      or: _maxSid + 1 // 场景在房间下的排序
    };
    // 加入场景列表
    _devs[_roomId].scenes.push(app.globalData.sceneInfo);
    // 页面跳转
    ability.redirectTo("/scene/sceneDetail/index");
    // ability.navigateTo("/scene/addScene/index")
  },

  chooseRoom (e) {
    let {index} = e.currentTarget.dataset;
    let _roomInfo = this.data.rooms[index || 0];
    this.data.roomInfo.n = _roomInfo.n;
    this.data.roomInfo.id = _roomInfo.id;
    this.setData({
      roomInfo: this.data.roomInfo
    });
    // 隐藏
    this.managePop();
    // 初始化场景列表
    this.initScene();
  },
  showPop () {
    this.managePop(true);
  },
  hidePop () {
    this.managePop(false);
  },
  managePop (val) {
    this.data.roomChanged = val || false;
    this.setData({
      roomChanged: this.data.roomChanged
    })
  },
  itemClick (e) {
    let _index = e.detail.index;
    let _item = this.data.fixScenes[_index];
    _item.mode = "edit";
    // 进入添加场景页面 新增场景
    app.globalData.sceneInfo = _item;
    ability.navigateTo("/scene/sceneDetail/index")
  },
  actionClick (e, actionType) {
    let _index = e.detail.index;
    let _item = this.data.fixScenes[_index];
    // 是否删除
    !!actionType && (_item.mode = actionType);
    console.log("sliderChange _index = ", _index, this.data.roomInfo.id, _item);
    // console.log("itemClick _index = ", _index);
    // 执行场景
    // app.globalData.blsdk.sceneCtrl(this.data.roomInfo.id, _item);
    let _roomId = _item.rid || this.data.roomInfo.id;
    let _sid = _item.sid;
    if (_item.t == 0) {
      app.globalData.blsdk.groupControlWithType(0, _roomId, _item.cmd);
    } else {
      app.globalData.blsdk.roomSceneControlWithSceneId((_roomId << 16) + _sid);
    }
  },
  jumpSort () {
    // 当前房间id
    let _roomId = this.data.roomInfo.id;
    // 跳转到排序页面
    ability.navigateTo('/scene/sort/index?roomId=' + _roomId)
  }
})