// const ability = require("../../utils/classDef/ability")
import ability from "../../utils/classDef/ability"
import bizUtil from "../../utils/bizUtil"
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    // navObj: {
    //   left: {
    //     type: "img"
    //   },
    //   center: {
    //     text: (app.globalData.panelInfo || {}).n || '按键选择'
    //   }
    // },
    panelList: [],
    selectId: 0,

    // isEdit: false, // 是否面板的编辑
    oldPanelId: -1,

    // devTypeStr: "panel", // 设备类型

    // 弹窗的引导
    showSaveDialog: false, // 是否显示保存后的对话框
    sendingConfig: {
      devTypeStr: 'panel'
    },

    // 按钮列表
    actions: [],

    listTip: "" // 列表左上角的提示
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    // 编辑的
    let {from, edit: _editId, metaKey, sidSDK, lowPower} = options || {};
    let _panelInfo = this.getCurPanelInfo();
    // 设置标题
    this.setNavTitle(_panelInfo.n || '按键选择');
    // 页面来源
    this.from = from || "";
    // 编辑的设备id
    // if (this.from == "metapad" && metaKey >= 0) {
    //   this.editId = Math.log2(_editId);
    // } else {
      this.editId = _editId;
    // }
    console.log("onLoad this.editId = ", this.editId);
    this.metaKey = metaKey;
    this.sidSDK = sidSDK;
    // 初始化设备类型
    let _devTypeStr = this.getDevTypeStr();
    console.log("onLoad _devTypeStr = ", _devTypeStr);
    this.data.sendingConfig.devTypeStr = _devTypeStr;

    // 设备的ability
    if (lowPower == undefined) {
      let {lowPower} = bizUtil.getJsonByAblitys(_panelInfo?.v, _devTypeStr, {t: _panelInfo?.t});
      this.lowPower = lowPower;
    } else {
      this.lowPower = Number(lowPower) || 0;
    }

    // 初始化面板页面的按键列表
    this.data.panelList = this.getPanelKeyList(_editId, _panelInfo, _devTypeStr, from);
    // 初始化默认的按键
    let _oldSelectId = (_editId >= 0) ? _editId : -1;
    this.data.oldPanelId = _oldSelectId; 
    this.data.selectId = _oldSelectId;
    // 初始化按钮列表
    this.data.actions = this.getActions(_editId, from);
    // 初始化列表左上角
    this.data.listTip = _devTypeStr == "uart" ? "选择路数" : "选择按键";
    
    this.setData({
      sendingConfig: this.data.sendingConfig,
      panelList: this.data.panelList,
      selectId: this.data.selectId,
      actions: this.data.actions,
      listTip: this.data.listTip
    })
  },
  setNavTitle (str) {
    // 设置标题
    ability.setNavigationBarTitle(str || "");
  },
  getCurPanelInfo () {
    return app.globalData.panelInfo || {}
  },

  getAllActions () {
    return [{
      n: '删除',
      classStr: 'red delBtn',
      handle: "unbindScene"
    }, {
      n: '保存',
      classStr: 'saveBtn marginL49',
      handle: "save"
    }]
  },
  getActions (panelId, fromStr) {
    let _list = this.getAllActions();
    // 判断是否编辑
    if ((fromStr == "metapad" || fromStr == "pwrmetapad") || panelId < 0 || panelId == undefined) {
      // 新增
      _list = _list.slice(1);
      _list[0].classStr = _list[0].classStr.replace("marginL49", "");
    }
    return _list;
  },

  getDeviceTypeNum () {
    return this.getCurPanelInfo()?.t;
  },

  getDevTypeStr () {
    let _t = this.getDeviceTypeNum();
    let _devTypeStr = bizUtil.getDevTypeStr(_t);

    return _devTypeStr;
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    app.saveAllDevsMap();
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
  },

  // 根据品类取得按键列表
  getConfigListByDevType (_devTypeStr, {t, v, e}) {
    let _keys = [];
    if (_devTypeStr == "panel" ) {
      // 面板的按钮
      let _num = bizUtil.getPanelKeysByPid(t);
      let _vGroups = e?.vGroups;
      _keys = bizUtil.getPanelVGroups(_num, {
        extendId: true,
        defaultNames: (_vGroups && (_vGroups instanceof Array)) ? (_vGroups.map(item => item.name)) : ""
      });
    } else if (_devTypeStr == 'doorsensor') {
      _keys = [{
        name: "门磁开",
        id: 0
      }, {
        name: "门磁关",
        id: 1
      }];
    } else if (_devTypeStr == 'bodysensor' || _devTypeStr == 'radarsensor') {
      _keys = [{
        name: "有人",
        id: 0
      }, {
        name: "无人",
        id: 1
      }];
    } else if (_devTypeStr == 'watersensor') {
      _keys = [{
        name: "水浸报警",
        id: 0
      }, {
        name: "水浸正常",
        id: 1
      }];
    } else if (_devTypeStr == 'uart') {
      // 根据版本号取得能力集合
      let _abilityArray = bizUtil.getAllSixAbilityByV(v);
      // 根据能力取得配置
      let _configJson = this.getConfigByAbility(_abilityArray, t);
      console.log("initListByVersion _configJson = ", _configJson);
      // 面板的按钮
      _keys = bizUtil.getPanelVGroups(_configJson['0'] || 0, {
        extendId: true,
        isGroup: true
      });
    } else if (_devTypeStr == 'temphumidity') {
      _keys = [{
        name: "高温",
        id: 0
      }, {
        name: "低温",
        id: 1
      }, {
        name: "高湿",
        id: 2
      }, {
        name: "低湿",
        id: 3
      }];
    } else if (_devTypeStr == 'panelsensor') {
      _keys = this.getPanelsensorList();
    } else if (_devTypeStr == 'sossensor') {
      _keys = [{
        name: "报警",
        id: 0
      }, {
        name: "取消报警",
        id: 1
      }];
    } else if (_devTypeStr == 'powerPlug') {
      _keys = [{
        name: "有卡",
        id: 1
      }, {
        name: "无卡",
        id: 0
      }];
    }
    return _keys;
  },

  getPanelKeyList (editId, panelInfo, devTypeStr) {
    // 当前面板信息
    let _panelInfo = this.getCurPanelInfo();
    // 列表
    let _keys = this.getConfigListByDevType(devTypeStr, _panelInfo);
    console.log("getPanelKeyList devTypeStr, panelInfo = ", devTypeStr, panelInfo);
    
    // 取得该设备在所有场景中的数据
    let _existDataStr = "";
    // 如果从双控进来则都能绑定
    if (!this.isFromPwrAvalable()) {
      let _existData = this.getExistByD(_panelInfo?.d);
      console.log("getPanelKeyList _existData = ", _existData);
      _existDataStr = _existData.join(",");
    }

    console.log("getPanelKeyList _existDataStr, devTypeStr, _keys = ", _existDataStr, devTypeStr, _keys);
    
    // 去除存在的数据
    let _filters = [];
    for (let item of _keys) {
      let _id = item.id + '';
      // 如果id等于传入的编辑的id，则不处理
      if (editId != undefined && (editId == _id)) {
        _filters.push(item);
        continue;
      }

      // 如果存在别的场景都绑定的情况，则不上报
      if (_existDataStr.indexOf(_id) >= 0) {
        // sos报警器
        // 插卡取电设备支持覆盖
        // if ()
        continue;
      }
      _filters.push(item);
    }
    
    return _filters;
  },

  getPanelsensorList () {
    let _array = [];
    let _panelInfo = this.getCurPanelInfo();
    let {vGroups, subs} = _panelInfo?.e || {};
    let _subs = subs || [
      {"name": "传感器1"},
      {"name": "传感器2"},
      {"name": "传感器3"},
      {"name": "传感器4"},
    ];
    if (!subs) {
      _panelInfo.e = _panelInfo.e || {};
      _panelInfo.e.subs = _subs;
    }
    console.log("getExtendList vGroups, subs = ", vGroups, subs);
    for (let i in _subs) {
      let _parentIndex = i;
      let _childIndex = i * 2;
      _array.push({
        list: [{
          title: _subs[i]?.name || "",
          index: -2 // -1的话默认是未选中
        }, {
          title: vGroups[_childIndex]?.name || "",
          index: _childIndex
        }, {
          title: vGroups[_childIndex + 1]?.name || "",
          index: _childIndex + 1
        }]
      })
    }
    console.log("getExtendList _array = ", _array);
    return _array;
  },

  // 根据ability计算出支持的设备类型以及路数
  getConfigByAbility (array, t) {
    let _result = {};
    let _array = array || [];
    console.log("getConfigByAbility _array = ", _array)
    if (bizUtil.isAbilityThresMetapad(t)) {
      // 只有三个ability
      _array = _array.slice(3);
    }
    console.log("getConfigByAbility _array = ", _array)
    // 筛选出值不为0的数据
    let _filter = array.filter(v=> v > 0);
    if (_filter.length == 0) {
      // 没有配置项，返回空
      return _result;
    }
    
    for (let v of _filter) {
      // 高四位是类型 低四位是路数
      _result[(v >> 4)] = (v & 0x0f);
    }
    return _result;
  },

  // 取得设备在场景中的所有绑定数据
  getExistByD (_d) {
    console.log("getExistByD _d = ", _d);
    if (!_d) {
      return [];
    }
    let _result = [];
    let _ds = 'panels';
    let _allDevs = app.globalData.devs || {};
    for (let roomId in _allDevs) {
      let _scenes = _allDevs[roomId]?.scenes || [];
      if (_scenes.length == 0) {
        continue;
      }
      for (let sceneInfo of _scenes) {
        let _dArray = sceneInfo[_ds] || [];
        if (_dArray.length == 0) {
          continue;
        }
        console.log("getExistByD _dArray = ", _dArray, sceneInfo);
        for (let index in _dArray) {
          let {d, key} = _dArray[index] || {}; // 这里目前只存了d和key
          if (d != _d) {
            continue;
          }
          _result.push(key);
        }
      }
    }
    return _result;
  },

  setShowSaveDialog (value) {

    // 如果是低功耗，优先显示
    if (this.lowPower) {
      // 唤醒文案
      return this.setData({
        showSaveDialog: value || false
      });
    }

    // 如果是从双控进入
    if (this.isFromPwrAvalable() || ((this.from == "metapad" || this.from == "pwrmetapad") && !!this.metaKey) || this.lowPower == 0) {
      if (value) {
        ability.showLoading({});
      } else {
        ability.hideLoading();
      }
      return;
    }

    // 设备品类
    let _t = this.getDeviceTypeNum();
    // 如果是超级面板，则不需要唤醒文案
    let _devTypeStr = this.data.sendingConfig?.devTypeStr;
    console.log("setShowSaveDialog _devTypeStr = ", _devTypeStr);
    if (_devTypeStr == "uart" || _devTypeStr == "panelsensor" || _devTypeStr == "powerPlug" || _devTypeStr == "radarsensor" || bizUtil.isNormalPanel(_t)) {
      value ? ability.showLoading({}) : ability.hideLoading();
      return;
    }

    // 唤醒文案
    this.setData({
      showSaveDialog: value || false
    })
  },

  // 解除绑定
  unbindScene () {
    // 显示对话框
    this.setShowSaveDialog(true);
    // 面板信息
    let _panelInfo = this.getCurPanelInfo();

    // 如果是双控，则解绑双控
    if (this.isFromPwrAvalable()) {
      this.pwrAvalibleVirtualUnbind(_panelInfo);
      return;
    }
    
    // 场景信息
    let _sceneInfo = app.globalData.sceneInfo;
    let _rid = _sceneInfo.rid || 0;
    let _sid = _sceneInfo.sid || 0;
    app.globalData.blsdk.resetPannelBindCommandWithShortAddr(_panelInfo.a, this.data.selectId, (result) => {
      // 显示对话框
      this.setShowSaveDialog(); 
      // 判断数据
      console.error("save result = ", result);
      if (result < 0 || result === false || result == undefined || result.errCode) {
        ability.showToast({
          title: "解绑失败",
          icon: 'error'
        })
        return;
      } else {
        ability.showToast({
          title: "解绑成功",
          icon: 'success'
        })
        // 保存设备信息
        this.saveInfo(_panelInfo, _sceneInfo, -1);
        // 返回
        setTimeout(this.back, 1500);
      }
    }, (_rid << 16) + _sid);
  },
  // 绑定
  save () {
    // 如果没有选中的则提示选择
    let _selectId = this.data.selectId;
    if (_selectId < 0) {
      // 提示
      ability.showToast({
        title: "请选择按键"
      });
      return;
    }
    // 显示对话框
    this.setShowSaveDialog(true); 
    // 面板信息
    let _panelInfo = this.getCurPanelInfo();
    // 场景信息
    let _sceneInfo = app.globalData.sceneInfo;

    let _rid = _sceneInfo?.rid || 0;
    let _sid = _sceneInfo?.sid || 0;

    this.bindByteType((_rid << 16) + _sid, _selectId, _panelInfo, _sceneInfo);
  },
  bindByteType (sidSDK, keyId, panelInfo, sceneInfo) {
    console.log("bindByteType sidSDK, keyId, panelInfo, sceneInfo = ", sidSDK, keyId, panelInfo, sceneInfo, this.metaKey);
    // 如果页面来源是双控，则走另一个命令
    if (this.isFromPwrAvalable()) {
      this.pwrAvalibleVirtualBind(keyId, panelInfo);
      return;
    }
    // 如果页面是来自于超级面板绑定
    if ((this.from == "metapad" || this.from == "pwrmetapad") && this.metaKey >= 0) {
      this.metapadBind(this.sidSDK, this.metaKey, app.globalData.devInfo, sceneInfo, (Number(keyId) || 0));
      // this.pwrAvalibleVirtualBind(keyId, panelInfo);
      return;
    }
    // 判断类型
    let _devTypeStr = bizUtil.getDevTypeStr(panelInfo?.t);
    // 如果页面是来自于超级面板绑定
    if (_devTypeStr == "uart") {
      this.metapadBind(sidSDK, keyId, panelInfo, sceneInfo);
    } else {
      this.panelBind(sidSDK, keyId, panelInfo, sceneInfo);
    }
  },
  panelBind (sidSDK, keyId, panelInfo, sceneInfo) {
    app.globalData.blsdk.roomSceneAddWithPannelAddr(panelInfo?.a, keyId, sidSDK, (result) => {
      // 绑定回调
      this.bindComplete(result, panelInfo, sceneInfo, keyId);
    });
  },
  metapadBind (sidSDK, panelId, panelInfo, sceneInfo, keyId) {
    // 更新场景 panelId = 按键类型 << 4 + 按键编号
    // let _type = (sidSDK >> 8) & 0xff; 
    // (_type || 0) + ( << 4)
    app.globalData.blsdk.metapadBindDev(panelInfo?.a, (Number(panelId) || 0), sidSDK, (result) => {
      // 绑定回调
      if ((this.from == "metapad" || this.from == "pwrmetapad") && this.metaKey >= 0) {
        // 绑定开关面板
        this.bindComplete(result, () => {
          this.saveMetapadPwrInfo(panelInfo, Number(panelId), keyId);
        })
      } else {
        this.bindComplete(result, panelInfo, sceneInfo, panelId, keyId);
      }
    }, {
      keyId: keyId >= 0 ? (1 << keyId) : undefined
    });
  },
  saveMetapadPwrInfo (devInfo, newKeyId, pwrKeyId) {
    if (!devInfo) {
      return;
    }
    console.log("saveMetapadPwrInfo devInfo, newKeyId, pwrKeyId = ", devInfo, newKeyId, pwrKeyId);

    let oldKeyId = this.data.oldPanelId;
    let {roomId, type, sid} = bizUtil.getJsonBySidSDK(this.sidSDK);
    console.log("saveMetapadPwrInfo newKeyId, oldKeyId = ", newKeyId, oldKeyId);

    // 是否非耦合设备
    let _isUncoupleMetapad = bizUtil.isUncoupleMetapad(devInfo?.t);
    let _type = _isUncoupleMetapad ? type : undefined;
    console.log("saveMetapadPwrInfo _type = ", _type);
    // 如果是删除，则返回，如果不是删除，则加入新的绑定数据
    if (newKeyId >= 0) {
      // 超级面板数据保存在自身的ds中 删除绑定的按键
      devInfo.ds = this.getMetapadInfoByDAndKey(devInfo, newKeyId, _type);
      console.log("saveMetapadPwrInfo EDIT devInfo.ds = ", devInfo.ds);
      // // 完全新增
      // if (newKeyId < 0) {
      //   return;
      // }
    } else {
      // // 超级面板数据保存在自身的ds中
      // devInfo.ds = this.getMetapadInfoByDAndKey(devInfo, newKeyId, _type);
      // console.log("saveMetapadPwrInfo ADD devInfo.ds = ", devInfo.ds);
    }
    // 加入设备数据中
    devInfo.ds.push({
      sid: sid || 0,
      rid: roomId || 0,
      type: type || 0,
      key: Number(newKeyId), // 超级面板的key
      cmd: app.globalData.panelInfo?.d, // 设备d
      pwrPanelKey: pwrKeyId // 继电器的第几路
    })
  },
  // 双控绑定
  pwrAvalibleVirtualBind (keyId, panelInfo) {
    let _devInfo = app.globalData.devInfo || {};
    app.globalData.blsdk.bindDeviceWithAddr(panelInfo.a, keyId, _devInfo, (result) => {
      this.bindComplete(result, panelInfo, undefined, keyId);
    });
  },
  // 双控解除绑定
  pwrAvalibleVirtualUnbind (panelInfo) {
    let _devInfo = app.globalData.devInfo || {};
    console.log("pwrAvalibleVirtualUnbind _devInfo, panelInfo = ", _devInfo, panelInfo);
    app.globalData.blsdk.unbindDeviceWithAddr(panelInfo.a, _devInfo.a, (result) => {
      console.log("pwrAvalibleVirtualUnbind result = ", result);
      this.bindComplete(result, panelInfo, _devInfo, -1);
    });
  },
  // devKey 超级面板绑定是增加继电器的路数绑定
  bindComplete (result, panelInfo, sceneInfo, keyId, devKey) {
    // 显示对话框
    this.setShowSaveDialog();
    // 判断数据
    console.error("save result = ", result);
    if (result < 0 || result === false || result == undefined || result.errCode) {
      ability.showToast({
        title: "请求超时,请靠近设备,确认设备是否上电"
      })
      return;
    } else {
      ability.showToast({
        title: "成功",
        icon: 'success'
      })

      // 如果是回调
      if ("function" == typeof panelInfo) {
        !!panelInfo && (panelInfo());
      } else {
        // 保存设备信息
        this.saveInfo(panelInfo, sceneInfo, keyId, devKey);
      }
      
      // 返回
      setTimeout(this.back, 1500);
    }
  },
  getAllIndex (allStr, str) {
    let _result = [];
    if (!allStr) {
      return _result;
    }
    let _allStr = allStr;
    let _isFinish = false;
    while (!_isFinish) {
      let _index = _allStr.indexOf(str);
      if (_index < 0) {
        _isFinish = true;
        return _result;
      } else {
        _result.push(_index);
        _allStr = _allStr.slice(_index + 1);
      }
    }
    return _result;
  },
  // 根据d和key删除超级面板ds中绑定的数据
  getMetapadInfoByDAndKey (panelInfo, key, type) {
    let {ds, t} = panelInfo || {};
    if (!ds || key == undefined) {
      return ds || [];
    }
    let _result = [];
    // 是否非耦合设备
    // let _isUncoupleMetapad = bizUtil.isUncoupleMetapad(t);
    // let _type = _isUncoupleMetapad ? type : undefined;
    for (let i = ds.length - 1; i >= 0; i--) {
      let _item = ds[i];
      if (_item.key != key) {
        _result.push(_item);
      } else {
        if (type == undefined) {
          continue;
        }
        // 是否耦合设备
        if (type != _item.type) {
          _result.push(_item);
        }
      }
    }
    return _result;
  },
  saveMetapadInfo (panelInfo, sceneInfo, newKeyId, oldKeyId, devKeyId) {
    if (!panelInfo) {
      return;
    }
    console.log("saveMetapadInfo newKeyId, oldKeyId = ", newKeyId, oldKeyId);
    // 如果是删除，则返回，如果不是删除，则加入新的绑定数据
    if (oldKeyId >= 0) {
      // 超级面板数据保存在自身的ds中
      panelInfo.ds = this.getMetapadInfoByDAndKey(panelInfo, oldKeyId);
      // 完全新增
      if (newKeyId < 0) {
        return;
      }
    }
    // 超级面板数据保存在自身的ds中
    panelInfo.ds = this.getMetapadInfoByDAndKey(panelInfo, newKeyId);
    // 加入设备数据中
    panelInfo.ds.push({
      sid: sceneInfo?.sid || 0,
      rid: sceneInfo?.rid || 0,
      type: 0,
      key: newKeyId,
      cmd: 0,
      panelKey: devKeyId // 超级面板绑定继电器的第几路
    })
  },
  saveInfo (panelInfo, sceneInfo, keyId, devKey) {

    // 是否从双控进入
    if (this.isFromPwrAvalable()) {
      this.savePwrAvalibleInfo(panelInfo, keyId);
      return;
    }

    // 判断是编辑还是新建时保存
    let _oldPanelId = this.data.oldPanelId;
    console.log("_oldPanelId = ", _oldPanelId);
    // 判断是超级面板还是正常面板设备绑定
    let _devTypeStr = bizUtil.getDevTypeStr(panelInfo?.t);
    if (_devTypeStr == "uart" || this.from == "metapad" || this.from == "pwrmetapad") {
      return this.saveMetapadInfo(panelInfo, sceneInfo, keyId, _oldPanelId, devKey);
    }

    sceneInfo["panels"] = sceneInfo["panels"] || [];
    if (_oldPanelId >= 0) {
      // 取得当前设备
      let _curD = panelInfo?.d;
      let _curK = this.data.oldPanelId;
      console.log("_curK, _curD = ", _curK, _curD);
      // 删除场景中存在的面板数据
      bizUtil.delPanelInScene(sceneInfo["panels"], _curD, _curK);
    }
    // 是否解绑按键
    if (keyId < 0) {
      return;
    }
    // 场景信息
    sceneInfo["panels"].push({
      key: this.data.selectId,
      d: panelInfo.d
    })
  },
  savePwrAvalibleInfo (panelInfo, keyId) {
    let _devInfo = app.globalData.devInfo || {};
    _devInfo.e = _devInfo.e || {};
    _devInfo.e.bindDevices = _devInfo.e.bindDevices || [];
    if (keyId < 0) {
      // 解绑设备
      let _bindDevices = _devInfo.e.bindDevices;
      if (_bindDevices.length == 0) {
        return;
      }
      let _newArray = _bindDevices.filter(item => item.d != panelInfo.d);
      app.globalData.devInfo.e.bindDevices = _newArray;
    } else {
      // 绑定或者编辑设备
      if (this.editId >= 0) {
        // 编辑
        let _bindDevices = _devInfo.e.bindDevices;
        if (_bindDevices.length == 0) {
          return;
        }
        let _newArray = _bindDevices.filter(item => (item.d == panelInfo.d) && (this.editId == item.key));
        if (_newArray.length < 0) {
          return;
        }
        _newArray[0].key = Number(keyId) || 0;
      } else {
        // 新增 这里需要注意 分享时需要写成did app未统一
        _devInfo.e.bindDevices.push({
          d: panelInfo.d,
          key: Number(keyId) || 0
        })
      }
    }
  },
  panelItemClick (e) {
    let {index, idx} = e.currentTarget.dataset;
    let _item = this.data.panelList[index] || {};
    let _child = _item.list[idx];
    if (_child?.index < 0 || _child?.index == undefined) {
      return;
    }
    this.setData({
      selectId: _child.index
    })
  },
  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.panelList[index] || {};
    this.data.selectId = _item.id || 0;
    this.setData({
      selectId: this.data.selectId
    })
  },
  back () {
    // 返回上一页
    ability.navigateBack();
  },

  // 是否从双控进入
  isFromPwrAvalable () {
    return this.from == "pwrAvalible"
  },

  // 超级面板的绑定
  bindDevice (devInfo) {
    let str = "绑定中…";

    // 超级面板信息
    let _metapadInfo = app.globalData.devInfo || {};

    // 是否超级面板绑定窗帘
    let _isCoupleMetapadCurtain = (this.from == "metapad" || this.from == "pwrmetapad") && this.data.devTypeStr == "curtain" && !bizUtil.isUncoupleMetapad(_metapadInfo?.t);

    console.log("bindDevice _metapadInfo, devInfo = ", _metapadInfo, devInfo);
    // 绑定按键的第几路
    let _bindKeyVal = this.key;
    // 非耦合如果选中窗帘，则按键需要/2作为绑定，且绑定开关两路。例如5路选中，则绑定按键3，按键4
    if (_isCoupleMetapadCurtain) {
      _bindKeyVal = parseInt(_bindKeyVal / 2);
    }
    console.log("bindDevice _bindKeyVal = ", this.key, _bindKeyVal);

    // 提示等待中
    this.showLoading(str || '');
    // 场景id 设备房间id + 设备类型 + 设备短地址
    let _sceneId = 0;
    // 取得发送的数据
    let _sendType = bizUtil.getTypeByDevTypeStr(this.data.devTypeStr);
    // 判断选中的是群组还是单个设备
    let _isGroupBind = (devInfo?.gid >= 0);
    if (_isGroupBind) {
      let {gid} = devInfo || {};
      // 群组
      _sceneId = bizUtil.getSceneId(0, gid, _sendType);
    } else {
      let {a, id} = devInfo || {};
      console.log("bindDevice devInfo = ", devInfo);
      // 单个设备
      _sceneId = bizUtil.getSceneId(a, id, _sendType);
    }
    console.log("bindDevice _sceneId, _sendType = ", _sceneId, _sendType);

    // 更新场景
    app.globalData.blsdk.metapadBindDev(_metapadInfo.a, _bindKeyVal, _sceneId, (result) => {
      console.log("next result = ", result);
      this.hideLoading();
      let _str = "";
      if (result < 0 || result === false || result == undefined || result.errCode) {
        _str = '绑定失败';
      } else {
        _str = '绑定成功';
        // 加入数据
        this.dealAfterSave({
          metapadInfo: _metapadInfo, 
          devInfo: devInfo, 
          isGroupBind: _isGroupBind, 
          sendType: _sendType,
          isCoupleMetapadCurtain: _isCoupleMetapadCurtain,
          bindKeyVal: _bindKeyVal
        });
        setTimeout(() => {
          this.back();
        }, 1500);
      }
      ability.showToast({
        title: _str
      });
    }, {
      // 设备类型
      devType: _sendType
    });
  },
  dealAfterSave ({metapadInfo, devInfo, isGroupBind, sendType, isUnbind, isCoupleMetapadCurtain, bindKeyVal}) {
    if (!metapadInfo || (!devInfo && !isUnbind) || bindKeyVal == undefined) {
      return;
    }
    // // 新的数据
    // let _key = bindKeyVal;
    // 超级面板数据
    metapadInfo.ds = metapadInfo?.ds || [];
    console.log("dealAfterSave metapadInfo = ", metapadInfo);

    // 根据按键删除之前绑定的设备
    bizUtil.delInArrayByKey(metapadInfo.ds, bindKeyVal, "key");
    if (isCoupleMetapadCurtain && (bindKeyVal % 2 == 0)) {
      // 耦合设备删除两个
      bizUtil.delInArrayByKey(metapadInfo.ds, bindKeyVal + 1, "key");
    }
    console.log("dealAfterSave metapadInfo = ", metapadInfo);
    console.log("dealAfterSave devInfo = ", devInfo);
    // 如果是解绑则返回
    if (isUnbind) {
      return;
    }
    // 加入数据
    let _sid = (isGroupBind ? 0 : devInfo.a);
    let _rid = isGroupBind ? (devInfo.gid || devInfo.rid || 0) : devInfo.id;
    let _cmd = isGroupBind ? (devInfo.gid + "") : devInfo.d; // 如果是设备，则是短地址，如果是群组则为0
    metapadInfo.ds.push({
      sid: _sid,
      rid: _rid,
      type: sendType || 0, // 发送的品类 数值
      key: bindKeyVal, // 第几路
      cmd: _cmd 
    });
    // 如果是耦合设备
    if (isCoupleMetapadCurtain && (bindKeyVal % 2 == 0)) {
      metapadInfo.ds.push({
        sid: _sid,
        rid: _rid,
        type: sendType || 0, // 发送的品类 数值
        key: bindKeyVal + 1, // 第几路
        cmd: _cmd  // 如果是设备，则是短地址，如果是群组则为0
      });
    }
  },
})