const ability = require("../../utils/classDef/ability")
const app = getApp();
const bizUtil = require("../../utils/bizUtil");
const { Utils } = require("../../utils/util");
// scene/pwrAvalible/index.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: (app.globalData.panelInfo || {}).n || '按键选择'
      }
    },
    panelList: [],
    selectIds: [0,0,0,0,0,0,0,0], // 按键是否选中列表
    pwrs: [0,0,0,0,0,0,0,0], // 开关是否选中列表
    showSaveDialog: false, // 是否显示保存后的对话框

    // isEdit: false, // 是否面板的编辑
    oldPanelId: -1,
    
    isPwrAvalible: true, // 默认是继电器面板
    devTypeStr: "panel", // 默认是面板 
    isEditIndex: -1, // 是否编辑设备

    // 按钮列表
    actions: [],

    // 三个状态 当前 设备状态 例外
    types: [],
    currentType: 0,

    // 总开关
    // allCtrls: [0, 0],
    allList: [{
      n: '总开关',
      id: -1,
      value: 0,
      selected: 1 // 默认选中
    }],

    devName: "", // 设备名称
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("onLoad options = ", options);
    let {hideTab, index: _index, pwrVal} = options;
    // 根据pid取得品类名称
    let _devTypeStr = bizUtil.getDevTypeStr(app.globalData.devInfo?.t);
    this.data.devTypeStr = _devTypeStr;
    
    // 是否编辑页面
    // let _index = options.index;
    this.data.isEditIndex = _index == undefined ? -1 : Number(_index);
    // 初始化设备能力
    this.initTabByAbility(hideTab);
    // 如果是继电器面板设备
    if (_devTypeStr == 'powerstrip') {
      this.data.allList[0].value = Number(pwrVal) || 0;
    }
    //  || _devTypeStr == 'powerstrip'
    else if (_devTypeStr == 'panel') {
      // 初始化面板页面的按键列表
      this.initPanelKeyList(_devTypeStr);

      // // 列表的长度
      // let _len = this.data.panelList?.length || 0;
      // // 初始化选中的下标
      // this.data.selectIds = new Array(_len).fill(0); // 按键是否选中列表
      // this.data.pwrs = new Array(_len).fill(0); // 开关是否选中列表

      // 初始化默认数据
      if (_index >= 0) {
        let _cmdArray = (app.globalData.sceneInfo?.devs || [])[_index].cmd;
        if (typeof _cmdArray == "string") {
          _cmdArray = Utils.hexStrToArray(_cmdArray);
        }
        // 初始化当前
        this.initCurTypes(_cmdArray);
        // 初始化默认值
        (_cmdArray?.length > 0) && (this.initDefaultVal(_cmdArray));
      } else {
      }
    } else {

    }
    
    let _devName = app.globalData.devInfo?.n || app.globalData.panelInfo?.n || '';
    // 初始化按钮列表 智能插排需要
    let _actions = this.getActionListById(_devTypeStr == 'powerstrip' ? pwrVal : this.data.isEditIndex);
    this.setData({
      devTypeStr: _devTypeStr,
      actions: _actions,
      allList: this.data.allList,
      devName: _devName
    });
    
    // 设置标题
    ability.setNavigationBarTitle(app.globalData.devInfo?.n || '');
  },

  initDefaultVal (_cmdArray) {
    // 初始化默认的按键
    let _data = this.getPanelSelects(_cmdArray);
    console.log("onLoad panel _data = ", _data);
    let _defaults = [];
    let _pwrs = [];
    if (!!_data) {
      _defaults = _data.selectIds;
      _pwrs = _data.pwrs;
    }
    // 设置值
    this.setDefaultValue(_defaults, _pwrs);
  },

  // 初始化默认选择的页面
  setDefaultValue (defaultIds, pwrs) {
    let _defaultIds = defaultIds || [];
    let _pwrs = pwrs || [];
    if (_defaultIds.length == 0 || _pwrs.length == 0) {
      return;
    }
    let _minLen = this.data.panelList?.length || 0;
    if (_defaultIds < _minLen) {
      _defaultIds = new Array(_minLen).fill(0);
    }
    if (_pwrs < _minLen) {
      _pwrs = new Array(_minLen).fill(0);
    }
    this.data.selectIds = _defaultIds;
    this.data.pwrs = _pwrs;
    this.setData({
      selectIds: this.data.selectIds,
      pwrs: this.data.pwrs
    })
  },

  initTabByAbility (hideTab) {
    // 是否隐藏
    if (hideTab > 0) {
      this.data.types = [];
    } else {
      let _devInfo = app.globalData.devInfo;
      console.log("initTabByAbility _devInfo = ", _devInfo);
      let _v = _devInfo.v || ""; // 取得版本号

      let _support = false; // 默认不支持
      if (_v.length > 0) {
        // 版本号信息
        let _json = bizUtil.getJsonByAblitys(_v, bizUtil.getDevTypeStr(_devInfo.t), {t: _devInfo.t});
        _support = _json?.sceneException; // ((_v.split(".")[2] || 0) >> 8) & 0x02; // 第2个ability里面的BIT1
      }
      this.data.types = this.getAllTypes(_support);
    }
    this.setData({
      types: this.data.types
    })
  },
  getAllTypes (support) {
    let _array = [{
      name: "设备状态设置"
    }, {
      name: "保存当前状态"
    }];
    if (support) {
      _array.push({
        name: "不执行场景"
      });
    }
    return _array;
  },

  initCurTypes (cmdArray) {
    // 取得当前选择的type
    let _currentType = 0;
    if ((cmdArray === '' || cmdArray === undefined)) {
      _currentType = this.data.types.length >= 3 ? 2 : 0;
    } else if (cmdArray.length == 0) {
      _currentType = 1;
    } else {
      _currentType = 0;
    }
    console.log("initData _currentType = ", _currentType);
    this.data.currentType = _currentType;
    this.setData({
      currentType: this.data.currentType
    })
  },

  getAllActions () {
    return [{
      n: '删除',
      classStr: 'red delBtn',
      handle: "unbindScene"
    }, {
      n: '保存',
      classStr: 'saveBtn marginL49',
      handle: "save"
    }]
  },

  getActionListById (panelId) {
    let _list = this.getAllActions();
    console.log("getActionListById panelId = ", panelId);
    // 判断是否编辑
    if (panelId >= 0) {
      // 编辑
    } else {
      // 新增
      _list = _list.slice(1);
      _list[0].classStr = _list[0].classStr.replace("marginL49", "");
    }
    return _list;
  },
  initActions (panelId) {
    this.setData({
      actions: this.getActionListById(panelId)
    })
  },

  // 取得继电器面板按位与的数据
  getPanelSelects (cmds) {
    if (!cmds || cmds.length == 0) {
      return false;
    }
    let _byte0 = cmds[0] || 0;
    let _byte1 = cmds[1] || 0;
    // 按位转成2进制并补0
    return {
      selectIds: _byte0.toString(2).padStart(8, 0).split("").reverse().map(i=>parseInt(i)),
      pwrs: _byte1.toString(2).padStart(8, 0).split("").reverse().map(i=>parseInt(i))
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // app.saveAllDevsMap();
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  initPanelKeyList (devTypeStr) {
    // 增加全开全关的选项
    if (devTypeStr == "powerstrip") {
      // _keys.push({
      //   n: '总开关',
      //   id: -1,
      //   value: 0
      // });
      this.data.panelList = [];
    } else {
      let _devInfo = app.globalData.devInfo || {};
      let _pid = _devInfo.t;
      let _num = bizUtil.getPanelKeysByPid(_pid, devTypeStr);
      console.log("initPanelKeyList _num, _pid = ", _num, _pid);

      // 取得默认的长度
      let _defaultNames = _devInfo.e?.vGroups || [];
      console.log("getControlList _defaultNames = ", _defaultNames);
      // 如果为空
      if (_defaultNames.length == 0) {
        _defaultNames = bizUtil.getPanelVGroups(_num);
        app.globalData.devInfo.e = {
          vGroups: _defaultNames
        }
      }
      // // 默认的值
      // let _defaultVals = defaultVals || [];
      // 取得按键名称
      let _keys = [];
      for (let i = 0; i < _num; i++) {
        _keys.push({
          n: _defaultNames[i]?.name || '',
          id: i,
          value: i
        })
      }
      this.data.panelList = _keys;
    }
    
    console.log("initPanelKeyList this.data.panelList = ", this.data.panelList);
    this.setData({
      panelList: this.data.panelList
    })
  },

  setShowSaveDialog (value) {
    this.data.showSaveDialog = value || false;
    this.setData({
      showSaveDialog: this.data.showSaveDialog
    })
  },
  setPanelSceneInfo (roomId, did, sceneInfo, key) {
    let _panels = app.globalData.devs[roomId].panels || [];
    let _index = this.getPanelByD(_panels, did);
    if (_index < 0) {
      return false;
    }
    _panels[_index].ds = _panels[_index].ds || [];
    _panels[_index].push({
      sid: sceneInfo.sid,
      rid: sceneInfo.rid,
      t: sceneInfo.t,
      key: key
    })
  },
  getPanelByD (array, did) {
    let _index = -1;
    if (!array || array.length == 0) {
      return _index;
    }
    for (let index of array) {
      let _item = array[index];
      if (_item.d == did) {
        return index;
      }
    }
    return _index;
  },

  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    });
  },
  hideLoading () {
    ability.hideLoading();
  },

  save () {

    // 如果是其他的类型点击，则返回
    let _curType = this.data.currentType;
    if (_curType != 0) {
      // 返回上一页
      return this.back();
    }

    // 场景信息
    let _sceneInfo = app.globalData.sceneInfo;
    let _devInfo = app.globalData.devInfo || {}; // 选择的设备

    // 命令数据
    let _cmd = [];
    // 是否总开关选中
    if (this.data.devTypeStr == 'powerstrip') {
      // 插排 插座
      let {value} = this.data.allList[0] || {};
      _cmd = [0xff, value ? 0xff : 0];
    } else {
      // 开关面板
      console.log("save this.data.selectIds, this.data.pwrs = ", this.data.selectIds, this.data.pwrs);

      // 命令串
      let _byte = Number('0b' + (this.data.selectIds.reverse().join('')));
      let _pwrValue = Number('0b' + (this.data.pwrs.reverse().join('')));
      _cmd = [_byte || 0, _pwrValue || 0];
      console.log("save _cmd = ", _cmd);

      // 如果未选择，则提示
      if (_byte == 0) {
        ability.showToast({
          title: '请选择执行按键'
        });
        return;
      }
    }
    console.log("save _cmd = ", _cmd);

    // return this.dealAfterSend(_cmd);
    
    // 提示等待中
    this.showLoading('设置中…');

    // console.log("_byte = ", _byte, this.data.selectIds);
    // return;

    let _sid = _sceneInfo.sid, _rid = _sceneInfo.rid || 0;
    app.globalData.blsdk.roomSceneAddWithCommand(_devInfo, (_rid << 16) + _sid, _cmd, (result) => {
      console.error("save result = ", result);
      this.hideLoading();
      if (result < 0 || result === false || result == undefined || result.errCode) {
        // this.setShowCustomToast(true, 'error', '设置失败', true);
        return ability.showToast({
          title: "设置失败",
          icon: "error"
        });
      }
      // this.setShowCustomToast(true, 'success', '设置成功', true);
      ability.showToast({
        title: "设置成功",
        icon: "success"
      });
      // 当前状态status = {}
      setTimeout(() => {
        this.dealAfterSend(_cmd);
      }, 1500);
    })
  },

  dealAfterSend (cmd) {
    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _sceneInfo = app.globalData.sceneInfo || {}; // 场景信息
    let _status = this.getStatusByIndex(this.data.currentType, cmd); // 根据选择的
    // 把json的数据转string
    let _tip = bizUtil.getTipByStatus(_status, _devInfo.t);
    console.log("dealAfterSend _sceneInfo, cmd, this.data.isEditIndex = ", _tip, _sceneInfo, cmd, this.data.isEditIndex);
    // 防止不存在数据
    _sceneInfo.devs = _sceneInfo.devs || [];
    if (this.data.isEditIndex < 0) {
      _sceneInfo.devs.push({
        a: _devInfo.a,
        d: _devInfo.d,
        n: _devInfo.n,
        t: _devInfo.t,
        roomId: _devInfo.id,
        cmd: _status,
        tip: _tip
      })
    } else {
      let _index = this.data.isEditIndex;
      if (_index >= 0) {
        (_sceneInfo.devs[_index] || {}).tip = _tip;
        (_sceneInfo.devs[_index] || {}).cmd = _status;
        // (_sceneInfo.devs[_index] || {}).t = _devInfo.t;
      }
    }
    // 返回上一页
    this.back();
  },

  // 删除场景下绑定的执行设备
  unbindScene () {
    // 很奇怪的问题  使用ability调用showModal不提示了
    wx.showModal({
      title: "",
      content: "是否删除该场景下的按键"
    }).then((res) => {
      if (!res || !res.confirm) { return; }
      setTimeout(() => {
        ability.showToast({
          title: "删除中",
          icon: "loading",
          duration: 19000
        })
      }, 0);
      
      // 删除设备
      this.roomSceneDeleteWithDeviceAddr((result) => {
        console.error("delDev result = ", result);
        let _isSuccess = result >= 0;
        // 成功
        setTimeout(() => {
          ability.showToast({
            title: _isSuccess ? '删除成功' : "删除失败",
            icon: _isSuccess ? 'success' : 'error'
          });
        }, 0);
        // 如果失败，则不处理后续
        if (!_isSuccess) {
          return;
        }
        // 取得所有设备
        let _devs = app.globalData.sceneInfo?.devs || [];
        // 取得下标
        let _index = this.data.isEditIndex;
        // 删除设备
        _devs.splice(_index, 1);
        // 返回按钮
        setTimeout(this.back, 1500);
      });
    })
  },
  // 删除场景下已经绑定的设备
  roomSceneDeleteWithDeviceAddr (callback) {
    let _devInfo = app.globalData.devInfo;
    let {rid, sid} = app.globalData.sceneInfo;
    // console.log("app.globalData.sceneInfo status = ", app.globalData.sceneInfo, _devInfo)
    //  resetPannelBindCommandWithShortAddr
    app.globalData.blsdk.roomSceneDeleteWithDeviceAddr(_devInfo.a, (rid << 16) + sid, callback)
  },

  getAllIndex (allStr, str) {
    let _result = [];
    if (!allStr) {
      return _result;
    }
    let _allStr = allStr;
    let _isFinish = false;
    while (!_isFinish) {
      let _index = _allStr.indexOf(str);
      if (_index < 0) {
        _isFinish = true;
        return _result;
      } else {
        _result.push(_index);
        _allStr = _allStr.slice(_index + 1);
      }
    }
    return _result;
  },
  allItemClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.allList[index];
    let _value = _item.selected || 0;
    let _nowVal = Number(!_value);
    console.log("allItemClick _nowVal, _item = ", _nowVal, _item);

    this.data.allList[0].selected = _nowVal;
    this.setData({
      allList: this.data.allList
    })
  },
  allSwitchChange (e) {
    let _val = e.detail.value;
    let {index} = e.currentTarget.dataset;
    console.log("allSwitchChange _val, index = ", _val, index);
    this.data.allList[index].value = Number(_val);
    this.setData({
      allList: this.data.allList
    })
  },
  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.panelList[index];
    let _value = this.data.selectIds[index] || 0;
    let _nowVal = Number(!_value);
    console.log("itemClick _nowVal, _item = ", _nowVal, _item);

    this.data.selectIds[index] = _nowVal;

    // 如果不勾选，则按键也不勾选
    if (!_nowVal) {
      this.data.pwrs[index] = 0;
    }

    this.setData({
      selectIds: this.data.selectIds,
      pwrs: this.data.pwrs
    })
  },
  switchChange (e) {
    let _val = e.detail.value;
    let {index} = e.currentTarget.dataset;

    // 如果未选中按键，则不可选择
    if (!this.data.selectIds[index]) {
      return;
    }

    console.log("switchChange e = ", e);
    let _value = Number(_val);
    this.data.pwrs[index] = _value;
    let _str = `pwrs[${index}]`;
    this.setData({
      [_str]: _value
    });

    // 发送控制命令
    this.sendCtrl(index, _value ? 'open' : 'close');
  },

  // 发送控制命令
  sendCtrl (index, keyStr) {
    console.log("funcClick index = ", index);
    // 判断发送的数据
    if (keyStr == "open") {
      // todo list 第一个字节为panelId, 第二个字节为开关
      this.actDev([1 << index, 1 << index]);
    } else if (keyStr == "close") {
      // todo list
      this.actDev([1 << index, 0]);
    }
  },
  actDev (cmdKey) {
    // let _devInfo = app.globalData.devInfo;
    // app.globalData.blsdk.controlWithDevice(_devInfo, cmdKey);
  },

  back () {
    // 返回上一页
    ability.navigateBack();
  },
  // 设备执行类型设置
  typeItemClick (e) {
    // 设置选中的值
    let {index} = e.currentTarget.dataset;
    this.data.currentType = index || 0;

    // 如果选择的是当前状态或者不执行场景，则不需要保存按钮
    let _list = this.getActionListById(this.data.isEditIndex);
    if (index >= 1 && _list.length > 1) {
      _list = _list.slice(0, 1);
    }

    this.setData({
      currentType: this.data.currentType,
      actions: _list
    });
  },
  currentStatus () {
    // 保存当前状态
    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _sceneInfo = app.globalData.sceneInfo || {}; // 场景信息


    // return this.dealAfterSend();

    // 提示等待中
    this.setShowCustomToast(true, 'loading', '设置中…', 20000);
 
    let _sid = _sceneInfo.sid, _rid = _sceneInfo.rid || 0;
    console.log("currentStatus _sid, _rid = ", _sid, _rid);
    app.globalData.blsdk.roomSceneAddWithDeviceAddr(_devInfo.a, (_rid << 16) + _sid, (result) => {
      console.error("save result = ", result);
      if (result < 0 || result === false || result == undefined || result.errCode) {
        this.setShowCustomToast(true, 'error', '设置失败');
      } else {
        this.setShowCustomToast(true, 'success', '设置成功');
        
        setTimeout(this.dealAfterSend, 1500);
      }
    })
  },
  // 不动作
  customNoAction () {
    let _devInfo = app.globalData.devInfo || {}; // 选择的设备
    let _sceneInfo = app.globalData.sceneInfo || {}; // 场景信息

    // return this.dealAfterSend();

    // 提示等待中
    this.setShowCustomToast(true, 'loading', '设置中…', 20000);

    let _sid = _sceneInfo.sid, _rid = _sceneInfo.rid || 0;
    app.globalData.blsdk.customSceneAction(_devInfo.a, (_rid << 16) + _sid, (result) => {
      console.error("save result = ", result);
      if (result < 0 || result === false || result == undefined || result.errCode) {
        // this.setShowCustomToast(true, 'error', '设置失败', true);
        this.setShowCustomToast(true, 'error', '设置失败');
      } else {
        // this.setShowCustomToast(true, 'success', '设置成功', true);
        this.setShowCustomToast(true, 'success', '设置成功');

        setTimeout(this.dealAfterSend, 1500);
        // setTimeout(this.back, 1500);
      }
    })
  },
  // 设置是否显示自定义对话框
  setShowCustomToast (value, type, str, duration) {
    console.log("setShowCustomToast ability = ", ability);
    if (!value) {
      ability.hideToast()
      // ability.hideLoading()
    } else {
      let _config = {
        title: str || '',
        icon: type || '',
        duration: duration || 1500
      };
      ability.showToast(_config);
    }
  },
  // 根据不同的index取得不同的默认数据
  getStatusByIndex (index, cmd) {
    let _index = (index == undefined) ? this.data.currentType : index;
    if (_index == 1) {
      return [];
    } else if (_index == 2) {
      return "";
    } else {
      return cmd; 
    }
  }
})