// scene/addScene/index.js
const ability = require("../../utils/classDef/ability");
const app = getApp();
const bizUtil = require("../../utils/bizUtil");
Page({

  /**
   * 页面的初始数据
   */
  data: {
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "场景详情"
      }
    },
    list: [
      {
        title: "场景名称",
        bindtap: "editName",
        tip: ""
      }, {
        title: "所在房间",
        // bindtap: "toDeviceShare",
        tip: ""
      }, {
        title: "风格",
        bindtap: "toRoomSet",
        tip: "",
        img: ''
      }
    ],
    devList: [],
    panelList: [],
    actions: [],
    // 亮度配置
    brightSliders: {
      leftImg: "../../static/img/common/bright_down.png",
      rightImg: "../../static/img/common/bright_up.png",
      leftClass: "bDown",
      rightClass: "bUp",
      width: 516, // rpx
      percent: 100, // 百分比
      labelTxt: "亮度",
      minVal: 2,
      maxVal: 127,
      minPercent: 1, // 最小百分比
      gradient: false // 默认不支持滑动时调节
    },
    batchs: [],
    type: 0, // 0:全屋，1:⾃定义，2:当前状态 3: 默认场景-未编辑 4: 默认场景-自定义 5: 默认场景-当前状态
    extendStr: '',
    tabConfig: {
      index: 0,
      value: -1,
      titles: [{
        n: 'RGB'
      }, {
        n: '色温'
      }],
      // 色温配置
      tabs: [{
        bgImg: "../../static/img/common/rgb.png",
        bgClass: "cwImg",
        width: 616, // rpx
        percent: 50, // 百分比
        minPercent: 0,
        minVal: 0,
        maxVal: 360,
        gradient: false // 默认不支持滑动时调节
      }, {
        bgImg: "../../static/img/common/temp.png",
        leftClass: "cDown",
        rightClass: "cUp",
        bgClass: "cwImg",
        width: 616, // rpx
        percent: 50, // 百分比
        minPercent: 0,
        minVal: 0,
        maxVal: 255,
        gradient: false // 默认不支持滑动时调节
      }]
    },

    iconChoose: false, // 弹出icon选择
    iconSelIdx: 0, // 选择的icon下标
    icons: [],
    roleNum: app.globalData.roleNum, // 角色

    status: {}, // 设备状态
    showCustomToast: false, // 是否显示自定义的提示框
    customToastConfig: {}, // 自定义提示框配置信息

    // panelJson: {}, // 面板json
    isDefaultScene: false, // 默认为非默认场景

    // 取得所有设备对应的信息d: xxx
    allDJson: {}
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log("roleNum = ", app.globalData.roleNum)
    this.data.roleNum = app.globalData.roleNum;
    this.setData({
      roleNum: this.data.roleNum
    })
    // 初始化所有的设备d对应的设备信息
    this.initDToJson();
    // 根据type动态设置按钮
    this.initActionByType(app.globalData.sceneInfo || {});
    // 初始化风格icon
    this.initIcons();
    // 初始化下标
    this.initIconIdx();
  },

  // 设备d作为key的map对象
  initDToJson () {
    // 取得房间下的所有面板信息
    let _allDevInfo = bizUtil.getAllDevsFilter(app.globalData.devs);
    let _panelJson = bizUtil.arrayToJsonByKey(_allDevInfo, true, 'd');

    console.log("initDToJson _panelJson = ", _panelJson);

    this.data.allDJson = _panelJson;
  },

  getAllBatchs () {
    return [{
      title: '开关',
      value: 0,
      img: '../img/pwr_1.png',
      unSel: '../img/pwr_0.png',
      imgClass: 'pwrImg'
    }, {
      title: '是否调整当前参数',
      value: 0,
      img: '../../static/img/common/selected.png',
      unSel: '../../static/img/common/unselect.png',
      imgClass: 'selectImg'
    }];
  },

  initIcons () {
    this.data.icons = this.getIcons();
    this.setData({
      icons: this.data.icons
    })
  },
  getIcons () {
    let _array = [];
    for (let i = 0; i < 15; i++) {
      _array.push({
        icon: bizUtil.getSceneIcon(i + 1)
      })
    }
    return _array;
  },

  initIconIdx () {
    this.data.iconSelIdx = (app.globalData.sceneInfo.i || 1) - 1;
    this.setData({
      iconSelIdx: this.data.iconSelIdx
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    console.log("onShow = ", app.globalData.devInfo, app.globalData.sceneInfo, app.globalData.roomInfo);
    // 初始化数据
    this.initData();
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // 新创建的按键同步
    if (app.globalData.sceneInfo && app.globalData.sceneInfo.isNew) {
      // 新的按键同步只有点击完成加入到房间列表中
      this.delSceneDetail(true);
    }

    app.saveAllDevsMap();
    // app.setBizStorage("devs", app.globalData.devs)
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  initActionByType (sceneInfo) {
    let {t: type, isNew} = sceneInfo || {};
    console.log("initActionByType type = ", type);
    let _actions = this.getActionByType(type, isNew);
    console.log("initActionByType _actions = ", _actions);
    this.data.isDefaultScene = type >= 3;
    this.data.actions = _actions;
    this.setData({
      actions: this.data.actions,
      isDefaultScene: this.data.isDefaultScene
    })
  },

  getActionByType (type, isNew) {
    // 如果是3，则显示完成，如果是4和5，则显示清空，如果是其他，显示删除
    let _action = [{
      n: '删除场景',
      classStr: 'delBtn',
      handle: 'delScene'
    }, {
      n: '完成',
      classStr: 'saveBtn marginL49',
      handle: 'completes'
    }];
    // 根据type动态显示按钮
    if (type >= 3) {
      _action[0].n = "恢复默认";
    } else if (isNew) {
      _action = _action.filter(item => item.handle == "completes");
      if (_action.length > 0) {
        _action[0].classStr = _action[0].classStr.replace("marginL49", "");
      }
    }
    return _action;
  },

  initData () {
    console.log("app.globalData.sceneInfo sceneDetail = ", app.globalData.sceneInfo)
    // 初始化场景信息
    let {n, t, rid, cmd, i, devs, panels, sid} = app.globalData.sceneInfo || {};
    // 当前房间下的所有信息
    let _roomAllInfo = app.globalData.devs[rid || 0] || {};
    // 赋值
    this.data.list[0].tip = n || "";
    this.data.list[1].tip = _roomAllInfo.n;
    this.data.list[2].img = bizUtil.getSceneIcon(i || 1);
    // 初始化标题
    this.data.extendStr = this.getExtendStrByType(t);

    console.log("initData mode, t = ", t, devs)
    // 自定义设备
    if (t == 1 || t >= 3) {
      // 执行的设备
      this.data.devList = this.getCmds(devs || []);
      console.log("initData this.data.devList = ", this.data.devList);
    }

    // 默认场景
    if (t >= 3) {
      /*** start 默认场景增加所有支持默认场景的灯泡设备 ***/
      let _config = {
        light: true, // 默认支持灯泡
      };

      /*** seq=4或者7的默认场景，需要加上窗帘 ***/
      if (sid == 4 || sid == 7) {
        // 观影或者睡眠
        _config.curtain = true;
        // // 取得窗帘设备
        // let _curtains = this.getDevByRoomIdSupportDefaultScene(rid, "curtain", false); // 所有支持默认场景的灯泡设备
        // this.data.devList =
      }
      /*** end ***/
      // 默认场景增加所有支持默认场景的灯泡设备
      let _devs = this.getDevByRoomIdSupportDefaultScene(rid, _config); // 所有支持默认场景的灯泡设备
      console.log("initData _devs, this.data.devList = ", _devs, this.data.devList);

      // 数组转did
      let _dArray = this.data.devList.map(item => item.d);
      // 去重
      let _filterDevs = _devs.filter(item => _dArray.indexOf(item.d) < 0);
      // 转成需要的数据
      let _lastDetaultDevs = this.getCmds(_filterDevs, true);
      this.data.devList = (this.data.devList || []).concat(_lastDetaultDevs || []); // 去重
      /*** end ***/
    }

    // 所有类面板按键集合
    let _panels = panels || [];

    // 面板设备
    this.data.panelList = this.getPanelsByArray(_panels, this.data.allDJson);
    
    // 取得超级面板下绑定的场景数据
    let _metapadArray = [];
    let _obj = bizUtil.getAllSceneInMetapadByJsonAndSid(app.globalData.devs, bizUtil.getSceneId(sid, rid));
    console.log("getAllSceneInMetapadByJsonAndSid _obj = ", _obj);
    let _values = Object.values(_obj);
    if (_values.length > 0) {
      for (let dKeyJson of _values) {
        let _array = Object.values(dKeyJson);
        if (_array.length == 0) {
          continue;
        }
        _metapadArray = _metapadArray.concat(_array);
      }
    }
    console.log("getAllSceneInMetapadByJsonAndSid _metapadArray = ", _metapadArray);
    this.data.panelList = this.data.panelList.concat(_metapadArray);
    
    this.setData({
      list: this.data.list,
      type: t,
      extendStr: this.data.extendStr,
      devList: this.data.devList,
      panelList: this.data.panelList
    })
  },
  // 根据房间id取得所有支持默认场景的照明设备
  getDevByRoomIdSupportDefaultScene (roomId, configs) {
    // 设备集合
    let _devs = [];
    // 如果房间id为全屋，则加入所有的照明设备
    if (roomId == 0) {
      _devs = bizUtil.getAllDevsFilter(app.globalData.devs);
    }
    // 如果房间id为楼层，则加入楼层下的所有照明设备
    else if (roomId % 32 == 0) {
      let _floorJson = bizUtil.getAllDevsByFloor(app.globalData.devs, bizUtil.getFloorByRoomId(roomId), false);
      _devs = bizUtil.getAllDevsFilter(_floorJson);
    }
    // 如果房间id为单个房间，则加入房间下的所有照明设备
    else {
      _devs = app.globalData.devs[roomId]?.devs || [];
    }
    // 是否有照明
    let _hasLight = configs?.light;
    // 是否有窗帘
    let _hasCurtain = configs?.curtain;
    if (!_hasLight && !_hasCurtain) {
      return _devs;
    }
    return _devs.filter(item => {
      let _result = false;
      // 是否有照明设备
      if (_hasLight) {
        let _exist = (bizUtil.getSupportSceneInfoByV(item.v) == 0 && bizUtil.getDevTypeStr(item.t) == "light");
        if (_exist) {
          return true;
        }
      }
      if (_hasCurtain) {
        let _exist = (bizUtil.getDevTypeStr(item.t) == "curtain");
        if (_exist) {
          return true;
        }
      }
      return _result;
    });
    // // 是否需要版本号校验
    // if (vCheck != undefined) {
    //   // 取得列表中支持默认场景的数据
    //   return _devs.filter(item=>(bizUtil.getSupportSceneInfoByV(item.v) == 0) && bizUtil.getDevTypeStr(item.t) == devTypeStr);
    // } else {
    //   // 取得列表中支持默认场景的数据
    //   return _devs.filter(item=>bizUtil.getDevTypeStr(item.t) == devTypeStr);
    // }
  },
  getCmds (devs, isDefault) {
    if (!devs || devs.length == 0) {
      return [];
    }
    let _result = [];

    console.log("getCmds devs, this.data.allDJson = ", devs, this.data.allDJson);

    for (let i in devs) {
      let item = devs[i];
      let {d, t, cmd, tip, tStr} = item || {};

      // 如果有数据，则优先使用数据 || item || {}
      let _devInfo = this.data.allDJson[d];

      // 如果设备不在全屋设备中，则删除
      if (!_devInfo) {
        devs.splice(i, 1);
        continue;
      }

      let {a, t: realT, v, n, tStr: devTStr} = _devInfo;

      // 如果不是网关，且cmd不是空或者current,则

      // 如果是默认场景支持的设备
      if (isDefault) {
        cmd = "default";
        tip = "默认";
      }

      // 取得自定义执行设备的icon
      let _tStr = tStr || devTStr || bizUtil.getDevImgByT(_devInfo) || '';
      

      // 取得每个设备的最小亮度值
      console.log("getCmds cmd, tip = ", cmd, tip, item);
      
      _result.push({
        a: a,
        d: d,
        n: n || d || '',
        t: realT,
        tStr: _tStr,
        tip: tip || bizUtil.getTipByStatus(cmd, realT), // this.getTipByStatus(cmd, t),
        cmd: cmd,
        v: v // 需要带上版本号，需要判断ability
      })
    }
    return _result;
  },

  getPanelsByArray (panelArray, panelJson) {
    // let _panelJson = bizUtil.arrayToJsonByKey(array || [], true, 'd');
    console.log("getPanelsByArray panelArray, panelJson = ", panelArray, panelJson);
    // let _panelIds = panelIds || [];
    let _panelJson = panelJson || {};
    let _results = [];
    for (let idx in panelArray) {
      let {d, key} = panelArray[idx];
      let _devInfo = _panelJson[d];
      if (!_devInfo) {
        _devInfo = { n: d};
      }
      // 设备类型
      let _t = _devInfo.t;

      // 取得触发设备的icon
      let _tStr = _devInfo.tStr || bizUtil.getDevImgByT(_devInfo) || 'light';

      // 设备类型动态显示图片
      let _devStr = bizUtil.getDevTypeStr(_t);
      console.log("getPanelsByArray _panelJson, _devInfo = ", _panelJson, _devInfo);
      let _key = Number(key);
      _results.push({
        d: _devInfo.d,
        n: _devInfo.n || '',
        img: '../../static/img/common/' + _tStr + '.png',
        tip: bizUtil.getTipByDevTyeStr(_devStr, _key, _devInfo.e), // ('按键' + (_key + 1))
        id: _key
      })
    }
    console.log("getPanelsByArray _results = ", _results);
    return _results;
  },

  getExtendStrByType (type) {
    switch (type) {
      case 1:
      case 4:
        return '执行的设备';
      case 2:
      case 5:
        return '执行的设备';
      default: 
        return '执行的设备(照明批量)';
    }
  },

  devClick (e) {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    let {index} = e.currentTarget.dataset;
    let item = this.data.devList[index];
    console.log("devClick item = ", item);
    // 保存设备信息
    app.globalData.devInfo = item;
    // 判断设备类型
    let _devTypeStr = bizUtil.getDevTypeStr(app.globalData.devInfo?.t);
    if (_devTypeStr == "panel") {
      return ability.navigateTo("/scene/pwrAvalible/index?index=" + index);
    } else if (_devTypeStr == "aircondition" || _devTypeStr == "thermostat") {
      return ability.navigateTo("/scene/aircondition/index?index=" + index);
    } else if (_devTypeStr == "coathanger") {
      return ability.navigateTo("/scene/coathanger/index?index=" + index);
    } else if (_devTypeStr == "gateway") {
      let _allMap = bizUtil.getDidMapInJson(app.globalData.devs);
      console.log("devClick _allMap = ", _allMap);
      // 保存设备信息
      app.globalData.devInfo = _allMap[item?.d];
      if (!app.globalData.devInfo) {
        ability.showToast({
          title: "设备信息不存在"
        })
        return;
      }
      return ability.navigateTo("/device/gateway/timer/list/index?index=" + index + "&idx=" + ((item?.cmd || [])[1] || 0) + "&from=scene&type=cycle&title=" + encodeURIComponent(app.globalData.devInfo?.n || ""));
    } else if (_devTypeStr == "powerstrip") {
      let _extendStr = "?index=" + index + "&hideTab=1&pwrVal=" + Number((item?.cmd || [])[1]) || 0;
      return ability.navigateTo("/scene/pwrAvalible/index" + _extendStr)
    } 
    // 跳转页面
    ability.navigateTo("/scene/status/index?index=" + index);
  },

  // showModal () {
  //   // 提示是否需要删除
  //   return ability.showModal({
  //     title: "",
  //     content: "是否删除改场景"
  //   })
  // },

  delScene () {
    console.log("delScene this.data.roleNum = ", this.data.roleNum);
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    // setTimeout(() => {
    let _title = this.data.actions[0]?.n || '';
    // 很奇怪的问题  使用ability调用showModal不提示了
    ability.showModal({
      title: "",
      content: "是否" + _title + "?",
      showCancel: true,
      confirmText: "确定",
      cancelText: "取消",
      cancelColor: '#000000'
    }).then(result => {
      console.error("delScene result = ", result);
      if (!result) {
        return;
      }
      this.delSceneDetail();
    })
    // }, 0);
  },
  delSceneDetail (noLoading) {
    // 发送数据
    let _sceneInfo = app.globalData.sceneInfo;
    console.error("delScene _sceneInfo, noLoading = ", _sceneInfo, noLoading);
    let _roomId = _sceneInfo.rid || 0;
    let _sid = _sceneInfo.sid;

    // 是否清空场景
    let _t = _sceneInfo.t;
    if (_t >= 3) {
      // 清空默认场景的数据
      app.globalData.blsdk.roomSceneDeleteWithDeviceAddr(0, (_roomId << 16) + _sid, (result) => {
        console.error("delScene result = ", result);
        if (result && result.errCode) {
          return this.setShowCustomToast(true, 'error', '清空失败', true);
        }
        // 删除自定义执行设备的功能
        app.globalData.sceneInfo.devs = [];
        // 提示删除成功 (!result && result != 0) ? '删除失败' : 
        this.setShowCustomToast(true, 'success', '清空成功', true);
        // 延迟返回
        this.delayBack();
      });
      return;
    }
    
    // 删除场景
    app.globalData.blsdk.roomSceneDeleteWithSceneId((_roomId << 16) + _sid, noLoading ? undefined : (result) => {
      console.error("roomSceneDeleteWithSceneId result = ", result);
      if (result && result.errCode) {
        return this.setShowCustomToast(true, 'error', '删除失败', true);
      }
      // 删除之后
      this.delSceneInfo();
      // 提示删除成功 (!result && result != 0) ? '删除失败' : 
      this.setShowCustomToast(true, 'success', '删除成功', true);
      // 延迟返回
      this.delayBack();
    });
  },
  // 设置是否显示自定义对话框
  setShowCustomToast (value, type, str, autoHide) {
    this.data.showCustomToast = value || false;
    this.setData({
      showCustomToast: this.data.showCustomToast,
      customToastConfig: {
        type: type || 'success',
        text: str || ''
      }
    })
    if (!autoHide) {
      return;
    }
    setTimeout(() => {
      this.setShowCustomToast(false);
    }, 1200);
  },
  // 删除场景
  delSceneInfo () {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    // 场景数据
    let {sid, rid} = app.globalData.sceneInfo;
    let _roomId = rid || 0;
    let _scenes = (app.globalData.devs[_roomId] || {}).scenes || [];
    let _index = this.getSceneIndexBySid(_scenes, sid); // _scenes.indexOf(_sceneInfo);
    console.error("delSceneInfo _index = ", _index);

    // 删除超级面板中绑定的场景id
    bizUtil.delMetapadInfoBySceneId(app.globalData.devs, [bizUtil.getSceneId(sid, rid)]);

    // 判断是否清空场景还是删除场景
    (_index >= 0) && (_scenes.splice(_index, 1));
  },
  delayBack () {
    setTimeout(() => {
      // 返回上一页
      this.back();
  }, 1500)
  },
  getSceneIndexBySid (array, sid) {
    if (!array || !sid) {
        return -1;
    }
    for (let index in array) {
        let _item = array[index];
        if (_item.sid == sid) {
            return index;
        }
    }
    return -1;
  },
  back () {
    ability.navigateBack();
  },
  addDevice () {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    ability.navigateTo("/scene/addDevice/index")
  },
  addPanel () {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    ability.navigateTo("/scene/panel/index")
  },

  // 面板选择页面
  panelSelect (e) {
    if (app.globalData.roleNum == 2) {
      return;
    }
    let {index} = e.currentTarget.dataset;
    let _item = this.data.panelList[index];
    console.log("panelSelect _item = ", _item);
    // 设置当前的面板
    let _d = (_item.d || "");
    app.globalData.panelInfo = (this.data.allDJson || {})[_d];
    console.log("panelSelect app.globalData.panelInfo = ", app.globalData.panelInfo);
    // 默认的按键 按键从0开始
    console.log("panelSelect _item.tip = ", _item.tip);
    let _panelId = _item.id; // (_item.tip || '').replace("按键", '');
    console.log("panelSelect _panelId = ", _panelId, _item);
    _panelId = _panelId != undefined ? _panelId : 0;
    console.log("edit _panelId = ", _panelId);

    // 扩展
    let _extendStr = "";
    // 设备品类
    let _devTypeStr = bizUtil.getDevTypeStr(app.globalData.panelInfo?.t);
    if (_devTypeStr == "sossensor") {
      _extendStr = "&lowPower=0";
    }

    // 跳转页面 传入编辑的按键下标
    ability.navigateTo("/scene/panelDetail/index?edit=" + _panelId + _extendStr);
  },

  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    });
  },
  hideLoading () {
    ability.hideLoading();
  },

  currentStatus () {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      ability.showToast({
        title: "当前只有控制权限"
      })
      return;
    }
    // 如果有自定义的场景数据，则提示清除对话框
    if (this.data.devList.length > 0) {
      wx.showModal({
        title: "",
        content: "确定要覆盖该场景执行设备的设置吗？",
        showCancel: true,
        confirmText: "确定",
        cancelText: "取消",
        cancelColor: '#000000'
      }).then(result => {
        result?.confirm && (this.sendCurrentStatus(true));
      })
    } else {
      this.sendCurrentStatus();
    }
  },
  sendCurrentStatus (clearCustom) {
    // 等待条
    this.showLoading("发送中");
    // 场景数据
    let _sceneInfo = app.globalData.sceneInfo;
    _sceneInfo.cmd = [];
    // 保存当前设备状态
    let _roomId = _sceneInfo.rid || 0;
    let _sid = _sceneInfo.sid;
    console.error("currentStatus _sid, _roomId = ", _sid, _roomId, (_roomId << 16) + _sid);
    app.globalData.blsdk.roomSceneAddWithDeviceAddr(0, (_roomId << 16) + _sid, (result) => {
      console.error("currentStatus result = ", result);
      // 等待条
      this.hideLoading();

      // 加入显示
      this.addDevsByCurrentStatus(_roomId);
    });
  },
  // 取得原先执行设备中的空调设备, 保存当前状态时不清楚空调设备的状态
  getSaveDevsInOldActions (array) {
    if (!array || array.length == 0) {
      return  [];
    }
    return array.filter(item => {
      let _type = bizUtil.getDevTypeStr(item?.t);
      return (_type == "aircondition") || (_type == "thermostat");
    });
  },
  // 根据当前状态的房间把设备设备拉到执行列表中
  addDevsByCurrentStatus (roomId) {
    // 根据房间取得所有支持自定义的设备
    let _devs = bizUtil.getDevsOrGroupsByRoomId(roomId, app.globalData.devs);
    console.log("addDevsByCurrentStatus _devs = ", _devs);
    // 取得窗帘和灯泡设备
    let {light, curtain, panel} = bizUtil.getAllPidByArray(_devs);
    let _pwrPanelArray = (panel || []).filter(item => bizUtil.isPwrAvalibleDev(item?.t));
    // 取得所有d为主键的场景个数
    let _devSceneJson = bizUtil.getAllSceneDevJson(app.globalData.devs);
    console.log("addDevsByCurrentStatus _devSceneJson = ", _devSceneJson);
    // 取得最终的支持自定义设备 保留之前的空调设备
    let _result = this.getSaveDevsInOldActions(this.data.devList) || [];
    // 遍历数据
    let _allSupportDevs = (light || []).concat(curtain || []).concat(_pwrPanelArray);
    for (let item of _allSupportDevs) {
      let {sceneLen, scene} = bizUtil.getJsonByAblitys(item.v, bizUtil.getDevTypeStr(item.t), {t: item.t}) || {}; // 支持的场景总个数
      let _nowLen = _devSceneJson[item.d]?.length || 0; // 当前个数

      console.log("addDevsByCurrentStatus !scene, _nowLen, sceneLen = ", !scene, _nowLen, sceneLen);
      if (!scene || _nowLen >= sceneLen) {
        continue;
      }
      // 取得自定义执行设备的icon
      let _tStr = item.tStr || bizUtil.getDevImgByT(item) || 'light';
      console.log("addDevsByCurrentStatus item, _tStr = ", item, _tStr);
      // return !!scene && (_nowLen < sceneLen); // 如果个数小于最大个数，暂不判断是否支持自定义设备
      _result.push({
        a: item.a,
        tStr: _tStr,
        v: item.v,
        n: item.n, // 因为要根据名称排序，所以这里增加了n
        d: item.d,
        t: item.t,
        cmd: [],
        tip: "当前状态"
      });
    }
    // 根据字母排序
    let _array = bizUtil.sortArrayByChar(_result, "n");
    console.log("addDevsByCurrentStatus _array = ", _array);
    // 加入显示
    app.globalData.sceneInfo.devs = _array;
    // 更新数据
    // this.data.devList = _array;
    this.setData({
      devList: _array
    });
  },

  // 是否默认场景
  isDefaultScene () {
    let _sceneInfo = app.globalData.sceneInfo || {};
    return _sceneInfo.t >= 3;
  },

  toRoomSet () {
    if (this.data.roleNum == 2) {
      return;
    }

    // 判断是否默认场景
    if (this.isDefaultScene()) {
      return;
    }

    this.setIconChoose(true);
  },
  chooseIcon (e) {
    let {index} = e.currentTarget.dataset;
    let _item = this.data.icons[index];
    let _icon = _item.icon || '';
    // app.globalData.sceneInfo.icon = _icon;
    app.globalData.sceneInfo.i = (index + 1).toString();
    this.setIconChoose(false);
    // 更新视图
    this.data.list[2].img = _icon;
    let _str = 'list[2].img';
    this.setData({
      [_str]: _icon
    })
    // 更新下表
    this.initIconIdx();
  },
  hidePop () {
    this.setIconChoose();
  },
  setIconChoose (isShow) {
    this.data.iconChoose = isShow || false;
    this.setData({
      iconChoose: this.data.iconChoose
    })
  },
  // tabChange (e) {
  //   let {index, percent} = e.detail;
  //   console.log("tabChange index, percent = ", index, percent);
  //   this.data.tabConfig.index = index;
  //   let _obj = this.data.tabConfig.tabs[index];
  //   _obj.percent = percent;
  //   // this.data.tabConfig.index = _value;
  //   // console.log("tabChange index, _value = ", index, _value);
  //   // let _str = "tabConfig.index";
  //   // 更新的数据
  //   // let _updateObj = {[_str]: index};
  //   this.setData({
  //     tabConfig: this.data.tabConfig
  //   });

  //   let _sendObj = {
  //     pwr: 1,
  //     brightness: this.data.status.brightness || 127
  //   };
  //   if (index == 1) {
  //     let _value = bizUtil.getRealValByPercent(percent, _obj);
  //     _sendObj.c = (255 - _value);
  //     _sendObj.w = _value;
  //   } else {
  //     let _array = bizUtil.getRgbByAngle(percent / 100 * 360) || [];
  //     _sendObj.r = _array[0];
  //     _sendObj.g = _array[1];
  //     _sendObj.b = _array[2];
  //   }
  //   // 发送控制命令
  //   this.actDev(_sendObj)
  // },
  itemClick (e) {
    let {index} = e.currentTarget.dataset;
    console.log("itemClick index = ", index);
    if (index == 0) {
      console.log("itemClick index = ", index);
      return;
    }
    let _value = this.data.batchs[1].value;
    let _newVal = Number(!_value);
    this.data.batchs[1].value = _newVal;
    let _str = 'batchs[1].value';
    this.setData({
      [_str]: _newVal
    })
  },
  // rightClick (e) {
  //   let {index} = e.currentTarget.dataset;
  //   if (index == 1) {
  //     this.itemClick(e);
  //     return;
  //   }
  //   let _value = this.data.batchs[0].value;
  //   let _newVal = Number(!_value);
  //   this.data.batchs[0].value = _newVal;
  //   // 如果设置为关，则不可以调节参数
  //   this.initBatchsByVal(_newVal);
  //   // 发送开关命令
  //   let _sendObj = {};
  //   if (!_newVal) {
  //     _sendObj.brightness = 0;
  //   } else {
  //     _sendObj.pwr = 1;
  //     _sendObj.brightness = this.data.status.brightness || 127;
  //   }
  //   this.actDev(_sendObj);
  // },
  editName () {
    if (this.data.roleNum == 2) {
      return
    }
    
    // 判断是否默认场景
    if (this.isDefaultScene()) {
      return;
    }
    // 初始化场景信息
    let {n} = app.globalData.sceneInfo || {};
    // 名称编辑
    ability.navigateTo('/scene/editName/index?name=' + encodeURIComponent(n) + '&from=sceneName');
  },
  // 完成按钮点击
  completes () {
    // 场景信息
    let {t, isNew, rid} = app.globalData.sceneInfo || {};
    console.log("completes app.globalData.sceneInfo = ", app.globalData.sceneInfo);

    if (isNew) {
      delete app.globalData.sceneInfo.isNew;
      // 新的场景只有点击完成加入到房间列表中
      app.globalData.devs[rid || 0].scenes.push(app.globalData.sceneInfo);
    }


    // 如果场景为批量照明，则下发并保存
    if (t == 0) {
      return this.saveBatchScene();
    } else {
      // 返回上一页
      this.back();
    }
  },
  saveBatchScene () {
    let _sceneInfo = app.globalData.sceneInfo;
    console.log("saveBatchScene _sceneInfo = ", _sceneInfo);
    let _cmdJson = this.getBatchCmd();
    console.log("saveBatchScene _cmdJson = ", _cmdJson);
    _sceneInfo.cmd = app.globalData.blsdk.getCmdBySceneInfo(_cmdJson);
    // 返回上一页
    this.back();
  },
  getBatchCmd () {
    // 取得照明批量的设备信息
    let _batchs = this.data.batchs || [];
    console.log("getBatchCmd _batchs = ", _batchs);
    if (_batchs.length == 0 || !_batchs[0].value || !_batchs[1].value) {
      // 关闭
      return { pwr: _batchs[0].value || 0};
    }
    // 打开
    let _result = {pwr: 1};
    // 是否需要编辑参数
    if (!_batchs[1].value) {
      return _result;
    }
    // 亮度
    _result.brightness = this.data.status.brightness || 127; // 亮度
    // RGB还是色温
    let {index, value, tabs} = this.data.tabConfig;
    let _value = value;
    let _percent = tabs[index].percent;
    if (index == 0) {
      // RGB
      _result.c = _result.w = 0;
      let _array = bizUtil.getRgbByAngle(_percent / 100 * 360) || [];
      _result.r = _array[0];
      _result.g = _array[1];
      _result.b = _array[2];
    } else {
      if (value < 0) {
        _value = (bizUtil.getRealValByPercent(_percent, tabs[index]));
      }
      // 色温
      _result.r = _result.g = _result.b = 0;
      _result.w = parseInt(_value);
      _result.w = 255 - _result.w;
    }
    console.log("getBatchCmd _result = ", _result);
    return _result;
  },
  // // 滑块百分比
  // sliderChange (event) {
  //   let _value = event.detail.value;
  //   this.data.status.brightness = _value;
  //   // 执行
  //   this.actDev({
  //     brightness: _value
  //   });
  // },
  // actDev (key) {
  //   let _roomId = app.globalData.sceneInfo.rid || 0;
  //   // let _devInfo = app.globalData.devInfo;
  //   // let _isBatchCtrl = true;
  //   // // 判断控制方式
  //   // if (_isBatchCtrl) {
  //   // // 批量控制
  //   // app.globalData.blsdk.bathControlWithDeviceList(_groupIds, key);
  //   // } else if (!_isBatchCtrl) {
  //     // 全屋或者房间控制
  //     app.globalData.blsdk.groupControlWithType(false, _roomId, key);
  //   /*} else {
  //     app.globalData.blsdk.controlWithDevice(_devInfo, key);
  //   }*/
  // },
})