// scene/sort/index.js
import bizUtil from '../../utils/bizUtil'
// 获取应用实例
var app = getApp()
// 引用文件
const ability = require('../../utils/classDef/ability.js')
Page({
  data: {
    //渲染的列表数据
    scanResult: {},
    dataList: [],
    //是否显示loadmore
    loadMoreShow: 0,
    //懒加载状态，用于异步不遮罩查询列表时，多次滑到底部
    isBottomLoading: false,

    //是否显示遮罩层
    isSearchViewShow: false,
    // 顶部条
    navObj: {
      left: {
        type: "img"
      },
      center: {
        text: "场景管理",
        type: ''
      },
      right: {
        text: ''
      }
    },
    bleUnavailable: false,
    // 拖拽的配置
    config: {
      unable: false,
      height: 100 / app.globalData.customPageSize.multip
    },
    roomId: 0,
    idCollections: [] // 排序的id集合
  },
  onLoad (options) {
    // 房间id
    let _roomId = Number(options.roomId || 0);
    this.data.roomId = _roomId;
  },
  onUnload() {
    this.saveInfo();
  },
  saveInfo () {
    // 保存设备信息
    app.saveAllDevsMap();
    // app.setBizStorage("devs", app.globalData.devs);
    // console.log("saveInfo = ", this.data.dataList, app.globalData.devs);
  },
  onShow: function () {
    // 初始化房间列表数据
    this.initRoomsByDevs();
  },

  initRoomsByDevs () {
    let _devs = app.globalData.devs || {};
    let _roomId = this.data.roomId;
    // 如果房间id为全屋，则获取所有的场景
    let _scenes = [];
    // if (_roomId == 0) {
    //     // 全屋
    //     _scenes = (bizUtil.getAllDevsBySort(_devs, _devs, 'scenes')).scenes || [];
    // } else {
        _scenes = bizUtil.getAllDevsFilter(_devs, _roomId, 'scenes');
    // }
    // let _scenes = bizUtil.getAllDevsFilter(_devs, _roomId ? _roomId : undefined, 'scenes');
    // 设置img属性并把每隔场景的sort搜集起来
    let _ids = [];
    for (let index in _scenes) {
      let item = _scenes[index];
      // 如果是默认场景，则不需要删除按钮
      if (item.t >= 3) {
        item.img = undefined;
      } else {
        item.img = '/static/img/common/delete.png';
      }
      // 房间id
      // item.id = item.sid;
      // 默认场景不能排序
      item.unable = item.t >= 3;
      // 加入
      _ids.push(item.or || (item.sid));
    }
    this.data.dataList = _scenes;
    this.data.idCollections = _ids.sort();
    // this.data.dataList = bizUtil.setArrayItem(_scenes, ['img'], []);
    console.log("initRoomsByDevs this.data.dataList = ", this.data.dataList);
    // 设置的数据
    let _setObj = {
      dataList: this.data.dataList
    };
    // 如果条数小于2，则不显示排序
    if (this.data.dataList.length < 2) {
      this.data.config.unable = true;
      _setObj.config = this.data.config;
    }
    this.setData(_setObj)
  },

  //下拉刷新
  refesh() {
    console.log("下拉刷新");
    // 停止下拉刷新
    wx.stopPullDownRefresh();
  },

  scrolltoupper () {
    console.log("scrolltoupper");
  },

  //懒加载
  loadMore() {
  },
  showLoading (str) {
    ability.showLoading({
      title: str || "",
      mask: true
    })
  },
  hideLoading () {
    ability.hideLoading();
  },

  isDevExist (devInfo) {
    let _devs = app.globalData.devs || [];
    let _filters = _devs.filter((item) => {
      return item.d == devInfo.d;
    })
    return !!_filters.length;
  },

  //查询数据
  onPullDownRefresh() {
  },
  goBack () {
    // 返回
    ability.navigateBack(2);
  },

  moveChange (e) {
    console.log("moveChange e = ", e);
  },
  touchEnd (e) {
    console.log("touchEnd e = ", e);
  },

  // 拖拽结束事件
  dragEnds (e) {
    // 点击的下标
    let _data = e.detail.data;
    console.log("dragEnds _data = ", _data);
    // 设置sort属性
    // let _newSort = bizUtil.setArrayItem(_data, ['sort'], ['index']);
    this.initRooms(_data);
  },

  initRooms (array) {
    if (!array) {
      return;
    }
    let _roomId = Number(this.data.roomId);
    // 如果房间id为空
    // if (_roomId == 0) {
    //   // 排列全部的场景
    //   let _result = {};
    //   for (let index in array) {
    //     let _item = array[index];
    //     _item.or = this.data.idCollections[index];
    //     let _rid = _item.rid || 0;
    //     console.log("_item.rid = ", _rid);
    //     _result[_rid] = _result[_rid] || [];
    //     _result[_rid].push(_item);
    //   }
    //   for (let roomId in app.globalData.devs) {
    //     let _obj = app.globalData.devs[roomId];
    //     console.log("_obj = ", _obj, roomId);
    //     _obj.scenes = _result[roomId] || [];
    //   }
    // } else {
      for (let index in array) {
        let _item = array[index];
        _item.or = this.data.idCollections[index];
      }
      // 保存本地房间列表数据
      this.data.dataList = array;
      app.globalData.devs[_roomId].scenes = array;
    // }
  },
  imgClick (e) {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    // 删除场景
    let {index} = e.detail;
    let _item = this.data.dataList[index];
    // 删除
    this.showModal().then((res) => {
      if (!res) { return; }
      this.delScene(_item);
    });
  },
  delScene (sceneInfo) {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    // 发送数据
    let _sceneInfo = sceneInfo;
    console.error("delScene _sceneInfo = ", _sceneInfo);
    // 保存当前设备状态
    let _roomId = _sceneInfo.rid || 0;
    let _sid = _sceneInfo.sid;
    app.globalData.blsdk.roomSceneDeleteWithSceneId((_roomId << 16) + _sid, (result) => {
      console.error("currentStatus result = ", result);
      let _errCode = result?.errCode;
      if (_errCode != undefined) {
        // 提示删除失败
        return ability.showToast({
          title: "删除失败", // 提示信息
          icon: "error"
        });
      }
      // 删除之后
      this.delSceneInfo(_sceneInfo);
    });
  },

  showModal () {
    // 提示是否需要删除
    return wx.showModal({
      title: "",
      content: "是否删除改场景"
    })
  },
  // 删除场景
  delSceneInfo (sceneInfo) {
    // 如果是分享角色
    if (this.data.roleNum == 2) {
      return;
    }
    // 场景数据
    let _sceneInfo = sceneInfo;
    let _roomId = _sceneInfo.rid || 0;
    let _scenes = (app.globalData.devs[_roomId] || {}).scenes || [];
    let _index = _scenes.indexOf(_sceneInfo);
    console.error("delSceneInfo _index = ", _index);
    (_index >= 0) && (_scenes.splice(_index, 1));

    // 初始化房间列表数据
    this.initRoomsByDevs();
  },


  itemClick (e) {
    // console.log("itemClick e, data = ", e);
    // // 点击的下标
    // let _index = e.detail.index;
    // // 保存房间信息
    // app.globalData.roomInfo = this.data.dataList[_index];
    // // 保存房间信息
    // ability.redirectTo("../../minePages/roomDetail/index?index="+_index)
  }
})