import ability from "../../../utils/classDef/ability"
const _commonFuncs = ["setProperValueByKey", "showToastByStr", "getJsonByKeyAndVal"];

class BaseClass {
  constructor (obj, type) {

    // 添加公共数据
    obj['data'] = this.addPublicData(obj['data']);

    // 添加公共方法
    this.addPublicFn(obj, type);
  }
  // 添加公共属性
  addPublicData (data) {
    let _data = data || {};
    // 添加ble使能
    _data.bleUnavailable = false;
    // 添加页面的多语言
    // _data.pageText = {};
    return _data;
  }
  // 添加公共方法
  addPublicFn (obj, type) {
    _commonFuncs.forEach(fn => {
      // console.log("addPublicFn type = ", type, fn);
      if(type == 'page') {
        obj[fn] = this[fn];
      } else if (type == 'component') {
        !!obj['methods'] && (obj['methods'][fn] = this[fn]);
      }
    })
  }

  // 设置并更新属性
  setProperValueByKey (key, val, noUpdate) {
    if (this.data == undefined) {
      return;
    }

    // 判断是否批量更新
    let updataObj = this.getJsonByKeyAndVal({}, key, val);
    
    // 不需要更新
    if (noUpdate) {
      Object.assign(this.data, updataObj);
      this.data[key] = val;
      return;
    }

    this.setData(updataObj);
  }
  getJsonByKeyAndVal (obj, key, val) {
    // 判断是否批量更新
    let updataObj = obj || {};
    if (key instanceof Array) {
      for (let i in key) {
        let _k = key[i];
        let _v = val[i];
        this.getJsonByKeyAndVal(updataObj, _k, _v);
        // updataObj[_k] = _v;
      }
    } else if (key != undefined && val != undefined) {
      updataObj[key] = val;
    }
    return updataObj;
  }
  // 显示等待条
  showToastByStr (str) {
    ability.showToast({
      title: str || "",
      mask: true // 默认都需要遮罩
    })
  }
}
 
module.exports = BaseClass