import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil"

var app = getApp();
module.exports = Behavior({
  // behaviors: [],
  // data: {
  // },
  // pageLifetimes: {
  //   show (options) {
  //   }
  // },
  // ready () {
  // },
  methods: {
    // 批量删除设备
    delSingleDevice (devInfo, _devs, _allStatus, isCurrentFaimly, config) {
      console.log("delSingleDevice devInfo = ", devInfo);
      // 单个设备信息
      let {t, sub, d} = devInfo || {};
      // 设备类型
      let _devTypeStr = bizUtil.getDevTypeStr(t);
      // 删除设备列表中的设备
      this.delDevInDevs(_devs, devInfo);
      
      // 判断删除的是否网关，如果不是，则忽略
      if (_devTypeStr == "aircondition" && sub > 0) {
        // 所有设备集合
        let _allDevs = bizUtil.getAllDevsFilter(_devs);
        // 取得空调网关子设备列表
        let _subs = bizUtil.getAirconditionsByDev(_allDevs, devInfo);
        // 空调网关设备
        let _ds = [d];
        _ds = _ds.concat(_subs.map(item => item.d));
        console.log("_subs, _ds = ", _subs, _ds);
        let _allAirconditions = _subs.push(devInfo);
        for (let dev of _subs) {
          // 删除设备列表中的设备
          this.delDevInDevs(_devs, dev);
        }
        // 判断是否有设备状态
        this.delDevStatus(_allStatus, _allAirconditions);
        // 删除设备及子设备场景
        console.log("delSingleDevice _devs, _ds = ", _devs, _ds);
        this.delSceneByDev(_devs, _ds, {
          "devs": true, // 执行设备
          // "panels": true // 触发设备
        });
      } else {
        // 删除群组
        bizUtil.delGroupDByDev(_devs, devInfo);
        if (!config?.delSceneDev) {
          // 删除设备时需要把设备情景数据也删除
          this.delSceneByDev(_devs, devInfo);
        }
        // 判断是否有设备状态
        this.delDevStatus(_allStatus, devInfo);
        // 是否删除当前家庭的网关
        if (_devTypeStr == "gateway" && isCurrentFaimly) {
          this.delGatewayInfo(devInfo?.d, _devs);
        } else if (bizUtil.isPwrAvalibleDev(t)) {
          // 删除开关面板的时候需要删除里面绑定的设备
          this.delVirtualByDevInfo(devInfo, _devs);
        }
      }
    },
    // 删除双控下的设备
    delVirtualByDevInfo (devInfo, devJson) {
      if (!devJson || !devInfo) {
        return;
      }
      let {d} = devInfo;
      for (let rid in devJson) {
        let {devs} = devJson[rid] || {};
        let {virtualPanel} = bizUtil.getAllPidByArray(devs);
        if (!virtualPanel || virtualPanel.length == 0) {
          continue;
        }
        for (let panelInfo of virtualPanel) {
          let {bindDevices} = panelInfo?.e || {};
          if (!bindDevices) {
            continue;
          }
          panelInfo.e.bindDevices = bindDevices.filter(item => item.d != d);
        }
      }
    },
    // 判断家庭是否当前的家庭
    isCurrentFaimlyByInfo (familyInfo) {
      let _familyInfo = familyInfo || {};
      return _familyInfo.id == app.globalData.familyInfo?.id;
    },
    // 删除设备
    delDeviceByInfo (devInfo, callback, allDevs, familyInfo, config) {
      if (!devInfo) {
        !!callback && (callback());
        return;
      }

      // 总信息集合
      let _devs = allDevs || app.globalData.devs || {};
      let _allStatus = app.globalData.allStatus || {};
      let _familyInfo = familyInfo || app.globalData.familyInfo || {};
      let _isCurrentFaimly = this.isCurrentFaimlyByInfo(_familyInfo); // 是否当前家庭

      // 判断是单个删除还是批量删除
      if (devInfo instanceof Array) {
        for (let dev of devInfo) {
          this.delSingleDevice(dev, _devs, _allStatus, _isCurrentFaimly, config);
        }
      } else {
        this.delSingleDevice(devInfo, _devs, _allStatus, _isCurrentFaimly, config);
      }
      // 判断是否有默认群组
      bizUtil.addDefaultGroupByDevs(_devs);

      // 保存数据
      app.setBizStorage("devStatus", _allStatus);
      // 保存设备信息
      app.saveAllDevsMap();
      // 上报数据
      app.uploadPrivateData(undefined, _devs, _familyInfo);
      // 删除成功的提示
      this.delSuccessToast(callback);
    },
    // 根据设备信息删除单个设备
    delDevInDevs (devs, devInfo) {
      let {id: _id, d: _d} = devInfo;
      let _devs = (devs[_id] || {}).devs || [];
      // 删除设备信息
      let _filter = _devs.filter(item => item.d != _d);
      (devs[_id] || {}).devs = _filter;
    },
    // 删除网关额外新增
    delGatewayInfo (gatewayD, allDevs) {
      // 如果不是当前家庭，则不处理后续
      // 取得当前的网关
      let _gatewayInfo = app.globalData.blsdk.getCurrentGateway() || {};
      if (_gatewayInfo.d == gatewayD) {
        // 找是否有下一个网关
        let _newGateway = bizUtil.getGatewayInfo(allDevs);
        app.globalData.blsdk.updateGatewayInfo(_newGateway);
      //   // 如果原先的家庭只有只读权限
      //   if (app.globalData.roleNum != 2) {
      //     // 上报私有数据
      //     app.uploadPrivateData();
      //   }
      }
    },
    // 删除成功的提示
    delSuccessToast (callback) {
      // 提示删除结果
      ability.showToast({
        title: "删除成功",
        icon: "success",
        mask: true,
        complete: () => {
          // 如果有回调
          if (callback) {
            return callback();
          }
          // 返回首页，重新加载
          setTimeout(() => {
            // 保存设备
            app.globalData.devInfo = {};
            app.globalData.devStatus = {};
            // 返回首页  部分手机relaunch会导致闪退
            ability.navigateBack(3);
          }, 1200);
        }
      })  
    },
    // 删除设备关联的情景信息
    delSceneByDev (devs, devInfo, config) {
      if (!devInfo) {
        console.error("delSceneByDev devInfo is empty");
        return;
      }
      console.log("delSceneByDev devInfo = ", devInfo);
      if (devInfo instanceof Array) {
        // 删除场景下的设备
        return bizUtil.moveDev(devs, {
          t: Object.keys(config || {}),
          d: devInfo
        }, []);
      }
      // 删除设备对应的场景信息
      bizUtil.moveDev(devs, devInfo, []);
    },
    // 删除设备临时状态
    delDevStatus (allStatus, devInfo) {
      // 判断是否有设备状态
      let _allStatus = allStatus || {};

      if (devInfo instanceof Array) {
        for (let dev of devInfo) {
          this.delStatusDetail(_allStatus, dev);
        }
      } else {
        this.delStatusDetail(_allStatus, devInfo);
      }
      return _allStatus;
    },
    delStatusDetail (allStatus, devInfo) {
      let {d, a} = devInfo;
      let _key = d + "_" + a;
      if (!allStatus[_key]) {
        return;
      }
      delete allStatus[_key];
    }
  }
})