import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil"

const COLORS = require('../jsConfig/colors.js');
var app = getApp();
module.exports = Behavior({
  // behaviors: [],
  // data: {
  // },
  // pageLifetimes: {
  //   show (options) {
  //   }
  // },
  // ready () {
  // },
  methods: {
    // 取得原始的家庭数据
    getResetFamilys () {
      let _bleCode = app.globalData.blsdk.getNewBleCode();
      let _seq = app.globalData.blsdk.getNextSeq();
      return bizUtil.getOriginFamilyInfo(_bleCode, _seq);
      // return {
      //   id: 1,
      //   n: '我的家庭',
      //   bleCode: app.globalData.blsdk.getNewBleCode(),
      //   seq: app.globalData.blsdk.getNextSeq(),
      //   groupIndex: 0, // 默认第一个集群
      //   floor: -1, // 不支持多楼层
      //   roleNum: 0, // 管理员权限
      //   devTimestamp: 0, // 超时时间
      //   sid: "", // 数据上报相关
      //   skey: "", // 数据上报相关
      //   addr1: 1,
      //   addr2: 257
      // };
    },

    // 清除全部家庭
    clearAll (allFamilys) {
      // 复位
      app.globalData.blsdk.resetAll();
      // 清除所有数据
      let _newRoom = bizUtil.getOriginRooms();
      console.log("resetAll rooms = ", _newRoom);
      let _initDevs = this.getDevList(_newRoom);
      app.globalData.devs = _initDevs;

      // 家庭数据
      let _allFamilys = allFamilys || [];
      if (_allFamilys.length == 0) {
        console.error("empty family is forbidden");
        return;
      }

      app.globalData.familys = _allFamilys;
      app.globalData.familyInfo = _allFamilys[0];
      app.globalData.allFamilysMap = {
        [app.globalData.familyInfo.id]: app.globalData.devs
      };
      // 保存缓存数据等
      this.saveDataByResetFamily(app.globalData.familyInfo);
      // 关闭远程
      app.globalData.blsdk.clseRemoteDebug();
      // 远程调试关闭
      app.globalData.familyInfo.isRemote = false;
      
      // 保存家庭相关数据
      app.saveWhenHide();
      // 清空家庭后的提示
      this.showClearFamilyToast();
    },
    // 清空家庭或者删除家庭时保存缓存数据用
    saveDataByResetFamily (familyInfo) {
      // 保存数据
      let {n, bleCode, seq, groupIndex, floor, roleNum, devTimestamp, sid, skey, addr1, addr2} = familyInfo || {};
      // 如果角色是分享者，则更新过期时间
      app.globalData.blsdk.updateCtrlTimestamp(devTimestamp || 0);
      // 更新短地址
      app.globalData.blsdk.updateAddr(addr1 || 1);
      app.globalData.blsdk.updateAddr2(addr2 || 257);
      // 更新bleCode
      app.globalData.blsdk.updateBleCode(bleCode);
      // 重置网关数据
      app.globalData.blsdk.updateGatewayInfo();
      // 更新集群信息 第二个参数是设置默认集群
      app.globalData.blsdk.updateCtrlHost("", true);
      // 清除主用户还是分享用户
      app.globalData.roleNum = roleNum || 0;
      app.globalData.colors = COLORS;
      // 缓存数据
      app.setBizStorage('devStatus', {});
      app.setBizStorage('colors', COLORS);
      app.setBizStorage('modes', {});
    },
    // 清除全部家庭的弹窗
    showClearFamilyToast (callback) {
      // 提示
      ability.showToast({
        title: "清理完成",
        duration: 1000,
        icon: "success",
        mask: true,
        complete: () => {
          // 刷新数据
          ability.showToast({
            title: "数据已清空"
          });
          // 回调函数
          !!callback && (callback());
        }
      })
    },
    // 取得原始房间数据
    getDevList (array) {
      if (!array) {
        return {};
      }
      let _result = {};
      for (let item of array) {
        item.devs = [];
        item.scenes = bizUtil.getDefaultScenes(item.id); // 默认情景
        item.groups = [];
        _result[item.id] = item;
      }
      return _result;
    },
    // 清除单个家庭数据
    clearFamilyInfo () {
      // 清除网关私有数据
      if (app.globalData.roleNum != 2) {
        // 查找当前家庭有无网关设备
        let _newGateway = bizUtil.getGatewayInfo(app.globalData.devs);
        if (!!_newGateway) {
          app.deletePrivateData(_newGateway);
        }
      }
      // 复位
      app.globalData.blsdk.resetAll();
      // 清除所有数据
      let _newRoom = bizUtil.getOriginRooms();
      console.log("resetAll rooms = ", _newRoom);
      let _initDevs = this.getDevList(_newRoom);
      app.globalData.devs = _initDevs;

      // 旧的家庭id
      let _familyId = app.globalData.familyInfo?.id || 1;

      app.globalData.allFamilysMap[_familyId] = app.globalData.devs;

      // 清除主用户还是分享用户
      let _newFamilyInfo = this.getResetFamilys();
      _newFamilyInfo.id = _familyId; // 保留之前的家庭id
      
      app.globalData.familyInfo = _newFamilyInfo;
      // 保存缓存数据等
      this.saveDataByResetFamily(app.globalData.familyInfo);
      // app.globalData.familyInfo.roleNum = 0;
      // app.globalData.familyInfo.devTimestamp = 0;
      // app.globalData.familyInfo.bleCode = app.globalData.blsdk.getBleCode();
      // app.globalData.familyInfo.floor = -1;
      // app.globalData.familyInfo.seq = app.globalData.blsdk.getNextSeq();
      // app.globalData.familyInfo.groupIndex = 0; // 默认中国集群
  
      // 保存
      app.saveWhenHide();

      // 提示
      this.showClearFamilyToast(() => {
        setTimeout(() => {
          ability.reLaunch();
        }, 1200)
      });
    },
    // 根据家庭信息清除家庭数据
    deleteFamilyByIndexInFamilys (index, familys) {
      // todo list
    }
  }
})