import ability from "../../../utils/classDef/ability";
import bizUtil from "../../../utils/bizUtil";

var app = getApp();
module.exports = Behavior({
  // behaviors: [tabsBehavior],
  // data: {
  // },
  // pageLifetimes: {
  //   show (options) {
  //   }
  // },
  // ready () {
  // },
  methods: {
    showToast (str, icon) {
      ability.showToast({
        title: str || "",
        icon: icon
      })
    },
    showLoading (str) {
      ability.showLoading({
        title: str
      })
    },
    // 根据did取得所有设备详细
    getDevInfoByDids (dids, json) {
      // 取得房间下所有的d对应的详细信息
      let _didMaps = bizUtil.getDidMapInJson(json || {});
      // 群组设备列表
      let _groupDevs = dids || [];
      // 群组设备列表详细
      let _groupDevList = _groupDevs.map(did => _didMaps[did]);
      console.log("initGroupDevs _groupDevList = ", _groupDevList);
      return _groupDevList;
    },
    // 创建群组
    createFixedGroup (devs) {
      console.log("createFixedGroup devs = ", devs);
      // 取得家庭下所有的固定群组列表
      let _groups = bizUtil.getAllDevsFilter(app.globalData.devs, undefined, "groups");
      console.log("createFixedGroup _groups = ", _groups);
      let _id = bizUtil.getIdByArray(_groups, "gid", 193, 253);
      if (_id < 0) {
        return ability.showToast({
          title: "固定群组已满，请删除后再试"
        });
      }
      // 房间id
      let _roomId = this.data.roomInfo?.id || 0; // app.globalData.roomInfo?.id || 0;
      let _groupInfo = {
        gid: _id,
        id: _roomId,
        t: this.data.type || "light", // _type, // 默认照明
        n: this.data.title,
        dids: []
      };
      // 根据设备数组发送固定组数据
      this.fixedGroupSendByDevs(_groupInfo, devs, [], (dids) => {
        // 设备集合
        _groupInfo.dids = dids || [];
        app.globalData.devs[_roomId].groups = app.globalData.devs[_roomId]?.groups || [];
        // 加入显示
        app.globalData.devs[_roomId].groups.push(_groupInfo);
        // 保存
        app.saveAllDevsMap();
        // 提示创建成功
        ability.showToast({
          title: "创建群组成功",
          icon: "success"
        });
        setTimeout(() => {
          this.back();
          // ability.navigateBack();
        }, 1200);
      });
    },
    // 添加群组中的设备
    fixedGroupSendByDevs (groupInfo, devs, extendDids, callback, config) {
      if (!devs || devs.length == 0) {
        return this.back();
      }
      let _newDids = devs.map(item=>item.d);
      // 加入到群组中显示
      let _allDids = (extendDids || []).concat(_newDids);
      // 去重
      let _allDidsByFilter = Array.from(new Set(_allDids));
      // 新数据
      let _allNewDevs = this.getDevInfoByDids(_allDidsByFilter, this.getRoomAllDevs());
      console.log("fixedGroupSendByDevs _allNewDevs = ", _allNewDevs);
      // 下发数据
      this.setGroupDevsByNewDevs(groupInfo, _allNewDevs, (result) => {
        console.log("fixedGroupSendByDevs result = ", result);

        // 保存群组did集合
        groupInfo.dids = _allDidsByFilter;

        !!callback && (callback(_allDidsByFilter));
      }, config);
    },
    // 根据数组取得删除和不删除的设备集合
    getGroupDevsJsonByDel (array, delDids) {
      let _result = {
        dels: [],
        news: []
      };
      if (!array || array.length == 0) {
        return _result;
      }
      if (!delDids || delDids.length == 0) {
        _result.news = array;
        return _result;
      }
      for (let dev of array) {
        let {d} = dev;
        if (delDids.indexOf(d) >= 0) {
          _result.dels.push(dev);
        } else {
          _result.news.push(dev);
        }
      }
      return _result;
    },
    // 删除群组设备
    delGroupDevs (groupInfo, delDids, callback) {
      let {gid, dids} = groupInfo || {};
      if (!gid) {
        return;
      }
      // 之前群组的did集合
      let _dids = dids || [];
      // 旧的设备集合列表
      let _allOldDids = this.getDevInfoByDids(_dids, this.getRoomAllDevs());
      // 需要删除的设备列表
      let {news, dels} = this.getGroupDevsJsonByDel(_allOldDids, delDids);
      // 配置信息
      let _configs = {
        // noRemote: true, // 无远程
        delAs: dels.map(item => item.a) // 删除的设备
      };
      // 下发数据
      this.setGroupDevsByNewDevs(groupInfo, _allOldDids, (res) => {
        console.log("fixedGroupSendByDevs res = ", res);
        // 保存群组did集合
        let _ds = news.map(item => item.d);
        groupInfo.dids = _ds;

        !!callback && (callback(_ds));
      }, _configs);
    },
    // 发送群组数据
    setGroupDevsByNewDevs (groupInfo, newDevs, callback, config) {
      let {gid, dids} = groupInfo || {};
      if (!gid) {
        return;
      }
      // 显示等待条
      ability.showLoading({});
      // 配置信息
      let _configs = config || {};
      _configs.noRemote = true; // 无远程
      console.log("setGroupDevsByNewDevs newDevs, _configs = ", newDevs, _configs);
      // 下发数据
      app.globalData.blsdk.fixedGroupCtrl(gid, newDevs, _configs, (res) => {
        console.log("setGroupDevsByNewDevs res = ", res);
        // 隐藏等待条
        ability.hideLoading();
        // 判断是否发送成功
        if (res != 0) {
          return ability.showToast({
            title: "下发数据失败"
          });
        } else {
          // 跳转页面
          !!callback && (callback(res));
        }
      });
    },
    // 取得所有的数据
    getRoomAllDevs () {
      return this.data.allDevs || app.globalData.devs;
    },
    back () {
      ability.navigateBack();
    }
    // // 删除群组中的设备
    // delGroupDev (groupInfo, newDevs, callback) {
    //   if (!groupInfo || !newDevs) {
    //     console.error("delGroupDev groupInfo, newDevs = ", groupInfo, newDevs);
    //     return;
    //   }
    //   // 是否删除全部的设备
    //   let _isDelAll = newDevs.length == 0;
    //   if (_isDelAll) {
    //     // 删除全部设备
    //   } else {

    //   }
    //   // 删除的d集合
    //   let _newDs = newDevs.map(item=>item.d);
    //   console.log("delGroupDev _newDs = ", _newDs);
    //   // 下发数据
    //   this.setGroupDevsByNewDevs(groupInfo, newDevs, () => {
    //     // 赋值
    //     groupInfo.dids = _newDs;
    //     // 回调
    //     !!callback && (callback());
    //   });
    // },
    // // 取得删除的群组新数据
    // getGroupNewDid (groupInfo, delDevs) {
    //   // 数组
    //   let _array = groupInfo?.dids || [];
    //   // 删除的d集合
    //   let _delDs = (delDevs || []).map(item=>item.d);
    //   // 删除后的数据
    //   return _array.filter(d=>_delDs.indexOf(d)<0);
    // },
    // // 删除群组中的设备
    // delGroupDev (devs) {
    //   if (!devs) {
    //     return this.back();
    //   }
    //   // 数组
    //   let _array = app.globalData.groupInfo?.dids || [];
    //   // 删除的d集合
    //   let _delDs = devs.map(item=>item.d);
    //   // 删除后的数据
    //   let _newDs = _array.filter(d=>_delDs.indexOf(d)<0);
      
    //   // 是否为空
    //   let _isEmpty = _newDs.length == 0;

    //   ability.showModal({
    //     title: "",
    //     content: "确定从群组中移除选择设备？",
    //     showCancel: true,
    //     confirmText: "确定",
    //     confirmColor: "#F78D3F",
    //     cancelText: "取消",
    //     cancelColor: '#000000'
    //   }).then(result => {
    //     // let _confirm = result?.confirm;
    //     // if (!_confirm) {
    //     //   return;
    //     // }
    //     // 删除
    //     this.delGroupDevDetail(_isEmpty ? _delDs : _newDs, _isEmpty);
    //   })
    // },
    // delGroupDevDetail (newDs, isEmpty) {
    //   let _newDs = newDs || [];
    //   // 取得所有的设备信息
    //   let _allDevs = this.getDevInfoByDids(_newDs, this.data.allDevs);
    //   console.log("delGroupDevDetail newDs = ", newDs);

    //   // 下发数据
    //   this.setGroupDevsByNewDevs(app.globalData.groupInfo, _allDevs, () => {
    //     // 赋值
    //     app.globalData.groupInfo.dids = isEmpty ? [] : _newDs;
    //     // 保存数据
    //     app.saveWhenHide();
    //     // 返回上一页
    //     !!this.back && (this.back());
    //   }, {
    //     isDelete: true
    //   });
    // },
  }
})