import CryptoJS from "../../../utils/classDef/crypto-js"
module.exports = {

  // 生成小程序的uuid
  createWxUuid () {
    var s = [];
    var hexDigits = "0123456789abcdef";
    for (var i = 0; i < 36; i++) {
      s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
    }
    s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
    s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
    s[8] = s[13] = s[18] = s[23] = "-";
    let uuid = s.join("").replace("-", "");
    // 最终的uuid需要去掉3个-
    return uuid.replaceAll("-", "")
  },
  // 创建无网关的uuidtoken
  createUuidtokenByUuid (uuidStr, random6, timestamp) {
    const shaConstStr = "Kh&1akdk*sdrA";
    let _random6 = random6 || this.getRandom6();
    let _timestamp = timestamp || this.getSecTimestamp();
    let shaStr = _random6 + shaConstStr;
    console.log("createUuidtokenByUuid shaStr = ", shaStr);
    let keyIvBytes = this.sha256Str(shaStr);
    console.log("createUuidtokenByUuid keyIvBytes = ", keyIvBytes, _random6, _timestamp, uuidStr);
    let _key = keyIvBytes.substr(0, 32);
    let _iv = keyIvBytes.substr(32, 32);
    let _src = (uuidStr || this.createWxUuid()) + "/" + _random6 + "/" + _timestamp;
    console.log("createUuidtokenByUuid _key, _iv, _src = ", _key, _iv, _src);
    // aes + base64
    let _aesSrc = this.encrypt(_src, this.hex(_key), this.hex(_iv));
    console.log("createUuidtokenByUuid _aesSrc = ", _aesSrc);
    // "01+random6+hash(src)+AES(src)"
    return "01" + _random6 + this.sha256Str(_src) + _aesSrc;
  },
  // 取得时间戳
  getSecTimestamp () {
    let _timestamp = Date.now() / 1000;
    return Math.round(_timestamp);
  },
  // 随机6个长度的字符串
  getRandom6 () {
    let chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'];
    let nums = "";
    for (var i = 0; i < 6; i++) {
      var id = parseInt(Math.random() * 61);
      nums += chars[id];
    }
    return nums;
  },

  sha256Str (str) {
    // sha256
    let _sha256Str = CryptoJS.SHA256(str || "").toString();
    return _sha256Str;
  },
  encrypt (word, keyHex, ivHex, config) {
    let _keyHex = keyHex || "";
    let _ivHex = ivHex || "";
  
    // 是否切换加密方式
    let _mode = "", _padding = "";
    if (config) {
      !!config.mode && (_mode = config.mode);
      !!config.padding && (_padding = config.padding);
    }
    // padding: "Pkcs7"
    _mode = _mode || "CBC";
    _padding = _padding || "ZeroPadding";
  
    let encrypted = CryptoJS.AES.encrypt(word, _keyHex, { iv: _ivHex, mode: CryptoJS.mode[_mode], padding: CryptoJS.pad[_padding] });
    // 转base64
    let encryptedHexStr = CryptoJS.enc.Base64.stringify(encrypted.ciphertext);
    return encryptedHexStr.toString();
    // 转string
    // return encrypted.ciphertext.toString();
  },
  hexEncrypt (hexStr, config) {
    let _key = undefined, _iv = undefined;
    if (config) {
      config.key && (_key = hex(config.key))
      config.iv && (_iv = hex(config.iv))
    }
    return encrypt(hex(hexStr), _key, _iv, config);
  },
  hex (str) {
    return CryptoJS?.enc?.Hex?.parse(str);
  },
  // 数据编码
  base64Encode (str) {
    let _str = str || "";
    // CryptoJS.enc.Utf8.parse(_str).toString(CryptoJS.enc.Base64);
    // CryptoJS.enc.Base64.stringify(CryptoJS.enc.Utf8.parse(_str));
    return CryptoJS.enc.Utf8.parse(_str).toString(CryptoJS.enc.Base64)
    // return Base64.encode(str);
  }
}