import ability from "../../../utils/classDef/ability";
import {Utils} from "../../../utils/util"
// , marginTop
import {Tabs} from "../jsConfig/tabbar"
// 引入protoBuf类
import protoBuf from "../../../utils/protobuf/protoUtil"
import bizUtil from "../../../utils/bizUtil"
import GROUPS from '../jsConfig/groups'

// 引入wx uuid生成
import noGatewayMethod from '../../../static/js/behavior/noGatewayFamilyId'

var app = getApp();
module.exports = Behavior({
  behaviors: [],
  data: {
    tabs: Tabs,
    // marginTop: marginTop,

    // 家庭数据
    showFamilyPop: false,
    top: 0,

    // 楼层数据
    showFloorPop: false
  },
  pageLifetimes: {
    show (options) {
      // console.log("behavior show app = ", app, options, this);
      // console.log("tabbar.js tabs = ", Tabs, Utils);
      this.initTabByRoute();
    }
  },
  ready () {
    // 初始化高度
    this.initFamilyTop();
  },
  methods: {
    // 根据当前的路由初始化tabs
    initTabByRoute () {
      let _routeStr = this.getRoute();
      if (!Tabs) {
        return;
      }
      // console.log('[my-behavior] tabClick index = ', _routeStr, tabs.tabs, Utils)
      let _index = Utils.getIndexByKey(_routeStr, Tabs);
      // console.log('[my-behavior] _index = ', _index)
      // 初始化
      this.initTabSelect(_index);
    },
    // 初始化选中的tab
    initTabSelect: function (index) {
      if (index < 0) {
        return;
      }
      let _index = parseInt(index);
      // console.log('[my-behavior] initTabSelect index = ', _index)
      if (typeof this.getTabBar === 'function' && this.getTabBar()) {
        let _tabs = this.getTabBar();
        _tabs && (_tabs.setData({
          selected: _index || 0
        }))
      }
    },
    // 取得当前的路由
    getRoute () {
      return this.route;
    },
    initFamilyTop () {
      // 取得家庭弹出层的高度
      let {statusHeight, navHeight, multip} = app.globalData.customPageSize;
      this.data.top = (statusHeight * multip + navHeight) || 0;
      // console.log("initFamilyTop = ", statusHeight, navHeight, wx.getMenuButtonBoundingClientRect().height, multip);
      this.setData({
        top: this.data.top
      })
    },
    closePop () {
      this.manageProper(false, "showFamilyPop");
      this.manageProper(false, "showFloorPop");
    },
    familyClick () {
      console.log("familyClick behavior");

      this.manageProper(true, "showFamilyPop");
    },
    manageProper (value, key) {
      if (!key) {
        return;
      }
      let _value = value || false;
      this.data[key] = _value;
      this.setData({
        [key]: _value
      })
    },
    floorClick () {
      console.log("floorClick behavior");
      this.manageProper(true, "showFloorPop");
      // this.data.showFloorPop = true;
      // this.setData({
      //   showFloorPop: this.data.showFloorPop
      // })
    },
    familyManage () {
      ability.navigateTo('/family/list/index');

      // 关闭弹出层
      this.closePop();
    },
    floorManage () {
      ability.navigateTo('/floor/list/index');
    },

    // 楼层选择
    floorChange (e) {
      let {index, id} = e.detail;
      console.log("floorChange index = ", index);
      let _floor = parseInt(id / 32) - 1;
      let _oldFloor = app.globalData.familyInfo?.floor;
      if (_oldFloor == _floor) {
        console.log("floorChange _oldFloor, _floor = ", _oldFloor, _floor);
        return;
      }
      // 更新楼层信息
      app.globalData.familyInfo = app.globalData.familyInfo || {};
      app.globalData.familyInfo.floor = _floor;
      // 设置默认的房间为全屋
      let _defaultRoomInfo = (this.data?.rooms || [])[0];
      console.log("floorChange _defaultRoomInfo = ", _defaultRoomInfo, this.data?.rooms);
      !!_defaultRoomInfo && (app.globalData.roomInfo = _defaultRoomInfo);
      // 调用更新方法
      !!this.initShowMethod && (this.initShowMethod());
      // 关闭弹出层
      this.closePop();
    },

    showAddDialog () {
      this.manageAddDialog(true);
    },
    hideAddDialog () {
      this.manageAddDialog(false);
    },
    manageAddDialog (value) {
      this.data.showAddDialog = value || false;
      this.setData({
        showAddDialog: this.data.showAddDialog
      })
    },
    // 添加设备
    addDeviceClick (e) {
      console.log("addDeviceClick e = ", e);
      let {index} = e.detail;
      if (index == 0) {
        // 添加设备
        this.addDevice();
      } else if (index == 1) {
        // 添加场景
        this.addScene();
      } else if (index == 2) {
        // 保存设备信息
        app.saveWhenHide();
        // 清除定时器 不查询
        if (this.statusTimer) {
          bizUtil.clearTimer(this.statusTimer, 'interval');
        }
        // 扫码
        this.scanCode();
        // // 添加面板同步
        // ability.showToast({
        //   title: '别急，还没做好'
        // })
      } else if (index == 3) {
        // 清除定时器 不查询
        if (this.statusTimer) {
          bizUtil.clearTimer(this.statusTimer, 'interval');
        }
        // 创建群组
        this.createGroups();
      }
      // 隐藏
      this.hideAddDialog();
    },
    // 添加设备
    addDevice () {
      // 判断是否远程调试，如果是，则不判断蓝牙状态是否可用
      if (!app.globalData.familyInfo.isRemote) {
        let _status = app.globalData.blsdk.isBleAvailable();
        // 获取蓝牙状态是否可用
        if (!_status) {
          ability.showBleFail();
          return;
        }
      }
      // 清除定时器 不查询
      if (this.statusTimer) {
        bizUtil.clearTimer(this.statusTimer, 'interval');
      }
      // 进入本地发现设备页面
      app.globalData.devInfo = undefined;
      ability.navigateTo("/addPages/addTip/index")
    },
    // 添加场景
    addScene () {
      let _roomId = app.globalData.roomInfo.id || 0;
      let _devs = app.globalData.devs;

      _devs[_roomId].scenes = _devs[_roomId].scenes || [];
      let _scenes = _devs[_roomId].scenes; // [];

      let _startIndex = 17;

      // id 
      let _sceneId = bizUtil.getIdByArray(_scenes, "sid", _startIndex, 256);
      if (_sceneId < 0) {
        ability.showToast({
          title: "自定义场景最大个数为239"
        });
        return;
      }

      console.log("jumpManage _sceneId = ", _sceneId);
      // 取得场景中的最大场景id
      let _maxSid = bizUtil.getMaxValByKey(_scenes, 'or')
      // 背景颜色
      let _b = ((_sceneId % 9) || 0) + 1; // 1 - 9
      // 取得场景下的自定义个数
      let _nameIndex = _sceneId - _startIndex;
      // 进入添加场景页面 新增场景
      app.globalData.sceneInfo = {
        t: 1, // 自定义场景
        n: '自定义场景' + (_nameIndex + 1), // 空名称
        // mode: 'add',
        rid: _roomId,
        i: "icon_scene_custom", // 自定义
        // i: (_i ? _i : 1).toString(), // icon下表
        b: _b, // 背景⾊下表
        // icon: bizUtil.getSceneIcon(_sceneId),
        // bg: bizUtil.getSceneBg(_sceneId),
        sid: _sceneId,
        devs: [], // 自定义设备列表
        // panels: [], // 面板列表
        or: _maxSid + 1, // 场景在房间下的排序
        isNew: true // 是否新增
      };
      // 加入场景列表
      // _devs[_roomId].scenes.push(app.globalData.sceneInfo);

      // 清除定时器 不查询
      if (this.statusTimer) {
        bizUtil.clearTimer(this.statusTimer, 'interval');
      }

      // 页面跳转
      ability.navigateTo("/scene/sceneDetail/index");

      // app.globalData.sceneInfo = undefined;
      // ability.navigateTo("/scene/list/index")
    },
    // 创建群组
    createGroups () {
      ability.navigateTo("/groups/name/index?fromPage=addGroup")
    },
    // 家庭选择
    familyChange (e) {
      let {index} = e.detail;
      console.log("familyChange index = ", index);
      // 变更家庭通用方法
      this.familyChangeDetail(index);
      // 调用更新方法
      !!this.initShowMethod && (this.initShowMethod());

      // 关闭家庭显示页面
      this.data.showFamilyPop = false;
      // 刷新当前页面显示的数据
      this.data.topConfig.topObj.left.text = app.globalData.familyInfo?.n || ''; // tip;
      this.setData({
        topConfig: this.data.topConfig,
        showFamilyPop: this.data.showFamilyPop
      })
    },
    familyChangeDetail (index) {
      let _item = app.globalData.familys[index] || app.globalData.familys[0];
      let _oldFamilyId = app.globalData.familyInfo.id;
      if (_item.id == _oldFamilyId) {
        console.log("save family _item = ", _item, app.globalData.familyInfo);
        return;
      }
      console.log("family now _item = ", _item);
      // 保存之前的seq和权限
      let _oldSeq = app.globalData.blsdk.getNextSeq();
      app.globalData.familyInfo.seq = _oldSeq;
      if (app.globalData.familyInfo?.roleNum == undefined) {
        app.globalData.familyInfo.roleNum = 0;
      }
      // 如果没有控制密钥，则生成控制密钥
      if (!_item.bleCode) {
        _item.bleCode = app.globalData.blsdk.getNewBleCode();
      }
      if (_item.seq == undefined) {
        _item.seq = _oldSeq;
      }
      if (_item.roleNum == undefined) {
        _item.roleNum = 0; // 默认为0
      }
      if (_item.groupIndex == undefined) {
        _item.groupIndex = 0; // 默认为0
      }
      if (_item.floor == undefined) {
        _item.floor = -1; // 默认不支持楼层
      }
      if (_item.sid == undefined) {
        _item.skey = ""; // 默认为""
      }
      if (_item.skey == undefined) {
        _item.skey = ""; // 默认为""
      }
      if (!_item.addr1) {
        _item.addr1 = 1;
      }
      if (!_item.addr2) {
        _item.addr2 = 257;
      }
      // 默认关闭远程调试
      _item.isRemote = false;
      // 关闭远程
      app.globalData.blsdk.clseRemoteDebug();
      // 远程调试关闭
      app.globalData.familyInfo.isRemote = false;
      // 家庭的uuid
      _item.uuid = _item.uuid || noGatewayMethod.createWxUuid();
      // 更新控制密钥
      app.globalData.blsdk.updateBleCode(_item.bleCode);
      app.globalData.blsdk.updateSeq(_item.seq);
      // 更新短地址
      app.globalData.blsdk.updateAddr(_item.addr1);
      app.globalData.blsdk.updateAddr2(_item.addr2);
      // 更新家庭数据
      app.globalData.familyInfo = _item;
      // 设备信息更新
      app.globalData.devs = (app.globalData.allFamilysMap[_item.id]) || {};
      // 这里有个需求：修改当前家庭时需要把房间置为全屋
      app.globalData.roomInfo = {
        id: 0,
        n: app.globalData.devs[0]?.n || "全屋"
      };
      // 更新角色
      app.globalData.roleNum = _item.roleNum;
      // 如果角色是分享者，则更新过期时间
      if (app.globalData.roleNum == 2) {
        app.globalData.blsdk.updateCtrlTimestamp(_item.devTimestamp || 0);
      } else {
        app.globalData.blsdk.updateCtrlTimestamp(0);
      }
      console.log("app.globalData.roleNum = ", app.globalData.roleNum);
      // 更新当前集群信息
      let _groupIdx = _item.groupIndex || 0;
      app.globalData.blsdk.updateCtrlHost(GROUPS[_groupIdx]?.value || GROUPS[0].value);
      console.log("familyChange app.globalData.familyInfo = ", app.globalData.familyInfo, app.globalData.devs);

      // 是否有网关设备
      let _gatewayInfo = undefined;
      for (let tmpRoomId in app.globalData.devs) {
        let item = app.globalData.devs[tmpRoomId];
        if (!item || !item.devs || item.devs.length == 0) {
          continue;
        }
        // 遍历设备数组
        for (let devInfo of item.devs) {
          // 房间id
          devInfo.id = devInfo.id || Number(tmpRoomId) || 0;
          // 取第一个网关设备
          if (!_gatewayInfo) {
            // 是否网关设备
            let _isGatewayDev = bizUtil.isGatewayDev(devInfo.t);
            // 不是网关设备则继续
            if (!_isGatewayDev) {
              continue;
            }
            _gatewayInfo = devInfo;
          }
        }
      }

      // 增加默认数据
      bizUtil.addDefaultGroupByDevs(app.globalData.devs);

      // 如果有网关设备，则设置
      app.globalData.blsdk.updateGatewayInfo(_gatewayInfo);
    },

    scanCode () {
      ability.scanCode({
        succCall: (res) => {
          // 成功回调
          console.log("scan code res = ", res);
          // 数据处理
          this.scanCodeDetail((res || {}).result);
        },
        failCall: (e) => {
          ability.showToast({
            title: "扫码失败",
            icon: "error"
          })
        }
      })
    },
    scanCodeDetail (base64Str) {
      if (!base64Str) {
        return;
      }
      try {
        console.log("scanCodeDetail base64Str1 = ", base64Str);

        // 扫码进入时 从微信扫码时进入 这里是个promise
        if (typeof base64Str != "string" && base64Str.then) {
          return this.dealPromiseScanData(base64Str);
        }

        // 反解分享数据
        let _base64Str = decodeURIComponent(base64Str || '');
        // 提取出参数前的数据
        let _checkResult = app.initShareStr(_base64Str);
        if (_checkResult === true) {
          // 提示扫码信息
          console.error("scanCodeDetail _checkResult = ", _checkResult);
          // 继续扫码
          setTimeout(() => {
            this.scanCode();
          }, 2000);
          return;
        }
        if (!_checkResult) {
          console.error("scanCodeDetail _checkResult = ", _checkResult);
          return;
        }
        // 这里需要兼容本地二维码扫码和线上二维码扫码
        if (_checkResult.then) {
          // 从小程序扫描二维码
          this.dealPromiseScanData(_checkResult);
        } else if (typeof _checkResult == "string") {
          console.log("scanCodeDetail base64Str2 = ", _base64Str);
          // 本地扫码处理结果
          this.dealBase64Str(_checkResult);
        } else {
          console.error("scanCodeDetail _checkResult = ", _checkResult);
          setTimeout(() => {
            ability.showToast({
              title: "无效二维码"
            })
          }, 0);
        }
      } catch(e) {
        console.log("e = ", e);
        // 关闭等待条
        this.hideLoading();
        // 提示信息
        ability.showToast({
          title: "不符合规范的二维码"
        })
      }
    },

    // promise返回的处理
    dealPromiseScanData (promiseObj) {
      if (!promiseObj || !promiseObj.then) {
        return;
      }
      promiseObj.then(res => {
        console.log("scanCodeDetail res = ", res);
        let _dataList = ((res?.data || [])[0]?.dataList || []);
        if (_dataList.length == 0) {
          return ability.showToast({
            title: "二维码已过期"
          });
        }
        // 云端扫码处理结果
        this.dealBase64Str(_dataList[0]?.data);
      }).catch(e => {
        console.error("scanCodeDetail e = ", e);
        return setTimeout(() => {
          ability.showToast({
            title: "无效二维码"
          })
        }, 0);
      });
    },

    // 取得扫码之后完整的二维码数据
    dealBase64Str (base64Str, noSave) {
      let _base64Str = base64Str || "";
      console.log("dealBase64Str base64Str2 = ", _base64Str, typeof _base64Str);
      // 先base64解密
      let _arrayBuffer = ability.base64ToArrayBuffer(_base64Str);
      console.log("dealBase64Str _arrayBuffer = ", _arrayBuffer);
      if (_arrayBuffer == undefined) {
        // 这里86屏分享有上报私有数据的问题
        throw new Error("dealBase64Str");
        return;
      }
      
      // 使用0x5E, 0x36, 0x7B, 0xC4反解数据
      let _constQrcode = [0x5E, 0x36, 0x7B, 0xC4];
      // 解析之后的字符串转array
      let _buffer = new Uint8Array(_arrayBuffer);
      // 按位异或
      let _decodeArray = [];
      for(let i = 0, len = _buffer.length; i < len; i++) {
        _decodeArray[i] = _buffer[i] ^ _constQrcode[i & 0x3];
      }
      console.log("_decodeArray = ", _decodeArray)

      // Uint8Array
      let _u8arr = new Uint8Array(_decodeArray);
      // protobuf解析
      // AwesomeMessage.decode(buffer)
      let _protoData = protoBuf.getShareDataBean().decode(_u8arr);
      console.log("_strProto = ", _protoData, typeof _protoData);

      // 初始化数据
      let _scanResult = this.initDataByScan(_protoData);
      if (!_scanResult) {
        return;
      }
      // 如果不需要保存数据
      if (noSave) {
        return _scanResult;
      }
      // 数据处理
      this.saveFamilyData(_scanResult);
    },

    // 取得集群的index
    getGroupIndexByValue (value) {
      if (!GROUPS || !value) {
        return 0;
      }
      // 取得传递的集群信息
      let _selectGroupIdx = GROUPS.findIndex(item => item.value == value);
      return _selectGroupIdx < 0 ? 0 : _selectGroupIdx;
    },

    // 判断二维码的大版本号
    compareVersion (v, currentVersion) {
      if (v && currentVersion) {
        let _currentBigVersion = Number(currentVersion.split(".")[0]);
        let _shareBigVersion = Number(v.split(".")[0]);
        console.log("compareVersion currentVersion, _shareBigVersion = ", _currentBigVersion, _shareBigVersion);
        if (_shareBigVersion > _currentBigVersion) {
          wx.showModal({
            title: '',
            content: "不同大版本之间的二维码不能分享",
            showCancel: false
          });
          return false;
        }
      }
      return true;
    },
    checkMaxCount (devAndGroupCount) {
      if (devAndGroupCount > 1000) {
        ability.showToast({
          title: "设备个数过多，请在APP上使用"
        });
        return false;
      }
      return true;
    },
    checkAvalibleTime (t, ct) {
      // 优先判断时间是否超过10分钟
      if (!!ct && !this.checkTimestamp(t + ct)) {
        console.error("scanData.t is outtime scanData = ", t, ct)
        return false;
      }
      return true;
    },

    // 根据扫码后的数据初始化（覆盖之前的数据）
    initDataByScan (scanData) {
      if (!scanData) {
        console.log("scanData is not exist");
        return;
      }
      // k: 广播控制密钥 名称: n rs:设备列表 v:版本号
      let {k, n, rs, t, v, ct, dt, p, sr, sid, skey} = scanData;

      // 当前版本号
      let _currentVersion = app.globalData.companyInfo?.qrVersion;
      console.log("initDataByScan _currentVersion, v = ", _currentVersion, v);
      // 判断版本号：目前支持4096的设备不允许跨大版本号分享
      if (!this.compareVersion(v, _currentVersion)) {
        return;
      }
      
      // // 优先判断时间是否超过10分钟
      // if (!this.checkAvalibleTime(t, ct)) {
      //   return;
      // }

      // console.log("initDataByScan rs, k = ", rs, k);
      // return;

      // 扫码到的设备列表,先获取到所有设备列表，然后进行按照房间分类
      let {devJson, devScenes, devAndGroupCount, gatewayInfo, floorIndex, hasDefaultScene} = this.list2Devs(rs);

      // 判断最大设备数
      if (!this.checkMaxCount(devAndGroupCount)) {
        return;
      }

      console.log("initDataByScan devJson, devScenes = ", devJson, devScenes);
      // return;

      // 家庭数据
      let _devs = devJson || {};
      // 兼容app 手动增加默认场景 混乱的代码

      // 添加默认场景
      if (!hasDefaultScene) {
        for (let roomId in _devs) {
          // 兼容全屋和多楼层数据
          let _roomId = roomId % 32;
          // 默认场景
          let SCENES = bizUtil.getScensConfig();
          let _defaultScene = SCENES[_roomId];
          if (!_defaultScene) {
            // 没有默认场景的房间不需要加默认场景
            continue;
          }
          // 默认场景把rid更新
          let _newDefaultScene = _defaultScene.map(item => {
            item.rid = roomId;
            item.devs = [];
            item.panels = [];
            return item;
          });
          // 加上默认场景
          _devs[roomId].scenes = _newDefaultScene.concat(_devs[roomId].scenes || []);
        }
      }

      // 兼容app分享的设备中的场景数据 前提 所有的场景都已经加载完毕
      for (let _tmpDsInfo of devScenes) {
        let {a, d, t, v, sid: sidSDK, key, cmd, id} = _tmpDsInfo;

        // // 此处有个bug： iOS分享过来如果key=0,则没有数据
        // let _key = key || 0;
        // _tmpDsInfo.key = _tmpDsInfo.key || 0;

        let {rid, sid, type} = this.dealSid(sidSDK);

        // 先找到是否有该场景id对应的场景
        let _roomInfo = _devs[rid];
        if (!_roomInfo) {
          continue;
        }
        let scenes = _roomInfo.scenes;
        if (!scenes || scenes.length == 0) {
          console.error("scenes is empty rid = ", rid);
          continue;
        }
        // 取得场景
        let _sceneIdx = bizUtil.getIndexByKeyInArray(scenes, sid, 'sid');
        if (_sceneIdx < 0) {
          console.error("_sceneInfo sid = ", sid);
          continue;
        }
        let _sceneInfo = scenes[_sceneIdx];
        // 是否类面板设备还是执行设备
        let _devTypeStr = bizUtil.getDevTypeStr(t);
        let _isPwrAvalibleDev = bizUtil.isPwrAvalibleDev(t);
        // 这里增加一个设备品类的判断：开关面板
        if (bizUtil.isPanelDev(_devTypeStr) && !_isPwrAvalibleDev) {
          // 类面板设备
          _sceneInfo["panels"].push(bizUtil.addScenePanelInfo(d, key));
        } else if (_isPwrAvalibleDev || bizUtil.isActionDev(_devTypeStr) || _devTypeStr == "gateway") {
          
          let _item = { a, d, t, v, cmd, tip: ""};
          if (_devTypeStr == "gateway") {
            _item.cmd = [0, Number(key || 0)];
            _item.tip = cmd;
          } else {
            // 非网关的时候判断是否字符串，且是否为空或者current,否则转为array
            if (typeof cmd == "string" && cmd != "" && cmd != "current") {
              _item.cmd = Utils.hexStrToArray(cmd);
            }
          }
          _sceneInfo.devs.push(_item);
        }
      }

      // seq可以不变
      let _seq = app.globalData.blsdk.getNextSeq();
      let _oldBleCode = app.globalData.blsdk.getBleCode();

      // 家庭数据
      let _oldFamilyObj = app.globalData.familyInfo || {};
      _oldFamilyObj.id = _oldFamilyObj.id || 0;
      _oldFamilyObj.n = _oldFamilyObj.n || '我的家庭';
      _oldFamilyObj.bleCode = _oldFamilyObj.bleCode || _oldBleCode;
      _oldFamilyObj.seq = _seq;
      _oldFamilyObj.roleNum = _oldFamilyObj.roleNum || 0;
      _oldFamilyObj.devTimestamp = _oldFamilyObj.devTimestamp || 0;
      _oldFamilyObj.groupIndex = _oldFamilyObj.groupIndex || 0;
      _oldFamilyObj.floor = _oldFamilyObj.floor || 0;
      _oldFamilyObj.sid = _oldFamilyObj.sid || "";
      _oldFamilyObj.skey = _oldFamilyObj.skey || "";
      _oldFamilyObj.addr1 = _oldFamilyObj.addr1 || 1;
      _oldFamilyObj.addr2 = _oldFamilyObj.addr2 || 257;

      // 设置加密密钥
      let _bleCode = Utils.hexStrToArray(k);

      // 用户角色 p = 1 管理权限，其他为控制权限
      let _p = p % 2 || 0;
      let _roleNum = (_p <= 1) ? 1 : 2;

      // 取得集群下标
      let _selectGroupIdx = this.getGroupIndexByValue(sr);
      console.log("_selectGroupIdx = ", _selectGroupIdx);
      // 家庭数据
      let _newFamilyObj = {
        n: n || '我的家庭',
        bleCode: _bleCode,
        seq: _seq,
        roleNum: _roleNum,
        devTimestamp: dt,
        groupIndex: _selectGroupIdx,
        floor: floorIndex,
        sid: sid || "",
        skey: skey || "",
        addr1: 1,
        addr2: 257,
        // 默认关闭远程调试
        isRemote: false,
        // 家庭的uuid
        uuid: noGatewayMethod.createWxUuid()
      };
      return {
        _newFamilyObj,
        _oldFamilyObj,
        _devs,
        gatewayInfo
      }
    },
    // 保存数据
    saveFamilyData ({_newFamilyObj, _oldFamilyObj, _devs, gatewayInfo}) {
      // 所有家庭数据
      let _allFaimilys = app.globalData.familys || [];
      // 判断是否不同的家庭但是相同的控制密钥
      let _familyIndex = this.isSameFamily(_newFamilyObj.bleCode, _allFaimilys);
      console.error("_familyIndex = ", _familyIndex);
      if (_familyIndex >= 0) {
        let _existFamily = _allFaimilys[_familyIndex];
        _newFamilyObj.id = _existFamily.id;
        // 这里的数据需要是全的
        _allFaimilys[_familyIndex] = _newFamilyObj;
      } else {
        if (_allFaimilys.length == 0) {
          // 加入老的家庭数据
          _allFaimilys.push(_oldFamilyObj);
        } else {
          // 保存原来家庭数据
          app.globalData.allFamilysMap[_oldFamilyObj.id] = (app.globalData.allFamilysMap[_oldFamilyObj.id] || {});
        }
        // 家庭id获取
        _newFamilyObj.id = bizUtil.getIdByArray(_allFaimilys, 'id'), // 这是我自己定义的区间1-255
        _allFaimilys.push(_newFamilyObj);
      }

      console.log("initDataByScan _newFamilyObj?.bleCode = ", _newFamilyObj?.bleCode);
      
      // 增加默认场景
      bizUtil.addDefaultGroupByDevs(_devs);
      
      // 新家庭数据保存
      app.globalData.allFamilysMap[_newFamilyObj.id] = _devs;
      // 当前楼层数据
      app.globalData.devs = _devs;

      // 角色权限
      app.globalData.roleNum = _newFamilyObj.roleNum;
      // 家庭信息
      app.globalData.familyInfo = _newFamilyObj;
      
      // 如果有网关设备，则设置
      !!gatewayInfo && (app.globalData.blsdk.updateGatewayInfo(gatewayInfo));
      // 更新控制时长
      let _ctrlTime = (_newFamilyObj?.roleNum == 2) ? (_newFamilyObj?.devTimestamp) : 0;
      app.globalData.blsdk.updateCtrlTimestamp(_ctrlTime || 0);
      // 更新控制密钥
      app.globalData.blsdk.updateBleCode(_newFamilyObj?.bleCode);
      // 更新当前集群信息
      app.globalData.blsdk.updateCtrlHost(GROUPS[_newFamilyObj.groupIndex || 0]?.value || GROUPS[0].value);
      // 更新短地址
      app.globalData.blsdk.updateAddr(_newFamilyObj.addr1);
      app.globalData.blsdk.updateAddr2(_newFamilyObj.addr2);
      // 关闭远程
      app.globalData.blsdk.clseRemoteDebug();
      // 远程调试关闭
      app.globalData.familyInfo.isRemote = false;
      // 根据设备信息重新设置房间数据
      !!this.initShowMethod && (this.initShowMethod());
      // 保存
      app.saveWhenHide();
      
      // 提示扫码完成
      setTimeout(() => {
        ability.showToast({
          title: "成功",
          icon: "success",
          duration: 2000
        })
      }, 0);
    },
    // 遍历所有家庭数据，判断控制密钥是否相同
    isSameFamily (bleCodeArray, familys) {
      if (!familys) {
        return -1;
      }
      let _bleCodeStr = (bleCodeArray || []).join("");
      console.error("isSameFamily bleCode, app.globalData.familys = ", bleCodeArray, familys);
      for (let i in familys) {
        let item = familys[i] || {};
        if ((item.bleCode || "").join('') == _bleCodeStr) {
          return i;
        }
      }
      return -1;
    },
    // 把扫码到的设备对应到所有房屋信息中
    jsonToAllRoom (devJson, isOld) {
      if (!devJson) {
        return {};
      }
      // 设置数据
      for (let index in devJson) {
        let _item = devJson[index];
        if (!_item) {
          continue;
        }
        _item.devs = _item.devs || [];
        _item.scenes = _item.scenes || [];
        _item.groups = _item.groups || [];
        // 保存房间名称
        _item.n = _item.n || "";
      }
      return devJson;
    },
    // 判断是否超过30s
    checkTimestamp (seconds) {
      // 动态有效时间与当前时间比较
      let _now = Date.now() / 1000;
      if (seconds < _now) {
        wx.showModal({
          title: '',
          content: "二维码过期",
          showCancel: false
        })
        return false;
      }
      return true;
    },
    // 对于自定义的场景处理
    dealExtentScene (devs, extentScene) {
      let {light, panel} = extentScene || {};
      if (!light && !panel) {
        return;
      }
      for (let roomId in devs) {
        let {scenes} = devs[roomId];
        if (!scenes || scenes.length == 0) {
          continue;
        }
        for (let sceneInfo in scenes) {
          let {t, sid} = sceneInfo;
          let _panelScene = panel[sid];
          if (!!_panelScene) {
            // 如果有自定义面板信息
            sceneInfo["panels"] = _panelScene["panels"] || [];
          }
          // 只有自定义的场景才有自定义设备信息
          if (t != 1) {
            continue;
          }
          if (!!light[sid]) {
            // 如果有自定义设备信息
            sceneInfo.devs = light[sid];
          }
        }
      }
    },
    getAbilityByV (v, t) {
      // 是否支持背光
      let _json = bizUtil.getJsonByAblitys(v, "panel", {t});
      return _json || {};
    },
    // 二维码数据转设备列表
    list2Devs (list) {
      let _list = list || [];
      // 计算数据个数
      let _devAndGroupCount = 0;
      // 默认房间
      let _configRoomJson = bizUtil.arrayToJsonByKey(bizUtil.getOriginRooms(), true);
      // 是否存在网关设备
      let _gatewayInfo = undefined;
      // 是否有房间名称变更
      // let _needUpdateRoom = false;
      // 所有数据 去重用 防止列表中有多个设备
      let _existDevJson = {};
      // 房间的json数据
      let _devs = {};
      // 所有设备的场景信息  面板绑定的按键和照明自定义
      let _devScene = [];
      // 是否包含默认的场景 默认不包含
      let _hasDefaultScene = false;
      // 是否支持多楼层 默认不支持
      let _floorIndex = -1;
      for (let i = 0, len = _list.length; i < len; i++) {
        let item = _list[i] || {};
        let devs = item.devs, scenes = item.scenes, id = item.id;

        // ios传过来可能存在id不存在
        let _id = id || 0; // 房间id
        item.id = _id;

        // 是否支持多楼层
        if (_floorIndex < 0 && _id > 0 && _id % 32 == 0) {
          _floorIndex = bizUtil.getFloorByRoomId(_id);
        }

        // 如果名称不存在，则默认名称
        let _roomInfo = _configRoomJson[_id] || {};
        !item.n && (item.n = _roomInfo.n);
        
        // 设备集合的处理
        let _devInfos = []; // 设备集合
        if (!!devs) {
          for (let obj of devs) {
            let {d, t, n, ds, e, a, k, v, sub, se, oa, or, wd, ig} = obj;

            // 取第一个网关设备
            if (!_gatewayInfo) {
              // 是否网关设备
              let _isGatewayDev = bizUtil.isGatewayDev(t);
              // 不是网关设备则继续
              if (!!_isGatewayDev) {
                _gatewayInfo = obj;
              }
            }
  
            // 设备去重
            if (_existDevJson[d]) {
              continue;
            }
            _existDevJson[d] = true;
            // 是否有扩展信息
            let _e = e;
            if (e) {
              _e = JSON.parse(e);
            }
            
            let _ds = ds || [];
            // 判断是否超级面板数据，超级面板数据存在ds中 后续增加氛围灯
            let _devTypeStr = bizUtil.getDevTypeStr(t);
            let _isUart = (_devTypeStr == "uart" || _devTypeStr == "tvLamp");
            // 保存设备的场景
            if (!_isUart) {
              for (let item of _ds) {
                _devScene.push({
                  a,
                  t,
                  d,
                  v,
                  sid: item.sid,
                  cmd: item.cmd,
                  key: item.key || 0,
                })
              }
            }
            
            // 带保存的设备数据
            let _devInfo = {
              d, t, 
              n: n || "",
              e: this.dealEJson(_e), a, k, v,
              id: _id,
              se, oa, or, ig
            };
            
            // 电视氛围灯 // 透传设备 3.1加上
            if (_devTypeStr == "tvLamp" || _isUart) {
              _devInfo.ds = this.getTVLampDs(_ds);
            } else if (bizUtil.isPwrAvalibleDev(t) && _ds.length > 0) {
              // 判断ability,如果支持超级面板，则增加缓存信息
              let _vJson = this.getAbilityByV(v, t) || {};
              if (_vJson.metapadEnable) {
                _devInfo.ds = this.getTVLampDs(_ds);
              }
            }
            // // 透传设备
            // else if (_isUart) {
            //   _devInfo.ds = _ds;
            // }

            // 网关设备
            if (sub > 0) {
              _devInfo.sub = sub;
            }
            // ihg网关设备
            if (!!wd) {
              _devInfo.wd = wd;
            }
            _devInfos.push(_devInfo)
          }
          // 设备个数
          _devAndGroupCount += (devs.length || 0);
        }
        
        // 遍历场景
        let _scenes = [];
        if (!!scenes) {
          // 分享场景的处理
          for (let sceneInfo of scenes) {
            let {sid: sidSDK, i, b, n, t, or, ig} = sceneInfo || {};
            // 当前有6个默认场景，所以去除6之下的数据
            let {sid, rid} = this.dealSid(sidSDK || 0);
            
            // sid 6以下的是默认场景
            // if (sid < 6) {
            //   continue;
            // }
            // t == 3的是默认设备
            if (t == 3 && !_hasDefaultScene) {
              _hasDefaultScene = true;
              // continue;
            }

            // 如果b是1-10，则需要取余 非自定义图片
            let _b = 0;
            if (Number(b) == b) {
              _b = 1 + (b || 0) % 10;
            }
            _scenes.push({
              n: n || "",
              sid: sid,
              rid: Number(rid) || 0,
              i: bizUtil.appToWXSceneI(i),
              b: _b,
              devs: [],
              panels: [],
              t: t,
              or: or,
              ig: ig
            })
          }
        }
        // 固定群组的处理
        let _groups = item.groups || [];
        for (let groupInfo of _groups) {
          // 群组类型
          groupInfo.t = bizUtil.getDevTypeStrByType(groupInfo.t);
          // 默认分享的gid < 255
          groupInfo.gid = (groupInfo.gid || 0) & 0xff;
          // 如果gid小于193，则是默认群组
          if (groupInfo.gid < 193) {
            groupInfo.bledevtype = "GROUP";
          }
        }
        _groups = _groups.filter(group => (group?.rid || 0) == item.id);

        // 群组个数
        _devAndGroupCount += (item.groups?.length || 0);

        let _roomName = item.n || "";
        // 保存房间
        _devs[_id] = {
          groups: _groups,
          scenes: _scenes,
          devs: _devInfos,
          id: _id,
          n: _roomName
        };
      }
      // console.log("list2Devs _devScene = ", JSON.stringify(_devScene));
      // console.log("list2Devs _devs = ", JSON.stringify(_devs));
      return {
        devJson: _devs,
        devScenes: _devScene,
        devAndGroupCount: _devAndGroupCount,
        gatewayInfo: _gatewayInfo, // 发现的第一个网关设备
        floorIndex: _floorIndex,
        hasDefaultScene: _hasDefaultScene
      };
    },
    // 取得蓝牙氛围灯的数组
    getTVLampDs (array) {
      if (!array) {
        return [];
      }
      let _array = [];
      array.forEach(item => {
        let {cmd, key, sid: sidSDK} = item || {};
        let {roomId, type, sid} = bizUtil.getJsonBySidSDK(sidSDK);
        let _obj = {
          sid,
          rid: roomId,
          type
        };
        // 如果是绑定的开关面板
        if (cmd && cmd.indexOf("|") >= 0) {
          let _array = cmd.split("|");
          _obj.cmd = _array[0];
          _obj.key = key & 0xff;
          _obj.pwrPanelKey = Math.log2(Number(_array[1])) || 0;
        } else {
          _obj.cmd = cmd;
          _obj.key = key;
        }
        _array.push(_obj)
      })
      return _array
    },
    // app与小程序保存的双控主键不一致，app是did,小程序是d
    dealEJson (ejson) {
      if (!ejson) {
        return;
      }
      let {bindDevices} = ejson;
      if (!bindDevices || bindDevices.length == 0) {
        return ejson;
      }
      let _result = [];
      for (let item of bindDevices) {
        _result.push({
          d: item.did,
          key: Number(item.key) || 0
        })
      }
      ejson.bindDevices = _result;
      return ejson;
    },
    // sid的处理
    dealSid (sid) {
      return app.globalData.blsdk.getDataBySceneId(sid);
      // let _result = {
      //   rid: 0,
      //   sid: 0
      // };
      // if (!sid) {
      //   return _result;
      // }
      // let _sidInt = Number(sid);
      // _result.rid = (_sidInt >> 16) & 0xff;
      // _result.sid = _sidInt & 0xff;
      // return _result;
    },
    // 是否支持多楼层
    initSupportFloor () {
      return app.globalData.familyInfo.floor >= 0;
    },
    // 取得当前楼层名称
    getCurFloor () {
      let _floor = app.globalData.familyInfo?.floor;
      let _devsJson = app.globalData.devs;
      console.log("getCurFloor _floor = ", _floor);
      let _name = bizUtil.getFloorName(_devsJson, _floor);
      return _name;
    },
    // 根据楼层和所有数据初始化房间列表
    initRoomJsonByFloorAndAllDevs () {
      // 所有设备
      let _allDevs = app.globalData.devs || {};
      // 所有房间列表和json数据
      let {rooms, roomJson} = bizUtil.getRoomsByDevs(_allDevs);
      // console.log("initRoomJsonByFloorAndAllDevs rooms, roomJson, _allDevs = ", rooms, roomJson, _allDevs);
      
      // 当前楼层
      let _floor = app.globalData.familyInfo?.floor;
      _floor = _floor == undefined ? -1 : _floor;

      // 当前楼层下的房间列表
      let _filterTmpRooms = rooms.filter(item => bizUtil.filterRoomByFloor(item, _floor, true));

      // 这里先把全屋和楼层排在全面，后面的房间才按照sort排序
      let _allAndFloorRooms = _filterTmpRooms.filter(item => (item.id || 0) % 32 == 0);
      let _otherRooms = _filterTmpRooms.filter(item => (item.id || 0) % 32 != 0);

      // 房间数据
      let _allAndFloors = bizUtil.sortArrayByKeyInFloorRoom(_allAndFloorRooms, "id");
      // rooms根据sort排序
      let _others = bizUtil.sortArrayByKeyInFloorRoom(_otherRooms, "sort");

      let _filterRooms = _allAndFloors.concat(_others);

      // 默认选中的房间
      if (_filterRooms && _filterRooms.length > 0) {
        let {id} = app.globalData.roomInfo || {};
        // 设置选中的值
        let _filters = _filterRooms.filter(item => item.id == id);
        if (_filters.length == 0) {
          this.data.rooms.selRoomId = 0;
        } else {
          this.data.rooms.selRoomId = id || 0;
        }
      }
      console.log("initRoomJsonByFloorAndAllDevs _filterRooms, roomJson = ", _filterRooms, roomJson);

      this.data.rooms.data = _filterRooms;
      this.setData({
        roomJson: roomJson,
        rooms: this.data.rooms
      })
    },
  }
})