// timer/detail/index.js
import bizUtil from '../../utils/bizUtil'
import ability from '../../utils/classDef/ability'
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    items: [{
      title: "灯（开关）",
      value: 1
    }, {
      title: "重复",
      value: 1
    }],
    // days: [],
    hours: [],
    minutes: [],
    current: [],

    index: 0 // 编辑的下标
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 编辑的下标
    this.data.index = Number(options.index) || 0;
    // 真实数据
    let _jsonInfo = app.globalData.tmpData?.timerJson || {};
    console.log("onLoad this.data.index = ", this.data.index, _jsonInfo);
    let _info = _jsonInfo.schedInfoList[this.data.index];
    // 取得传递过来的时分秒参数
    // let _timestamp = options.timestamp || 0;
    // if (_timestamp > 0) {
      this.data.items[0].value = _info.onoff;
      this.data.items[1].value = _info.repeat;
      this.setData({
        items: this.data.items
      })
    // }
    // 把时间戳转成天 小时 分钟
    // let _data = this.getDataByTimestamp(_timestamp);
    // 初始化天数，小时和分钟数据
    this.initTimes([_info.hour, _info.min]);
  },

  getDataByTimestamp (timestamp) {
    if (timestamp == undefined || timestamp == 0) {
      return [23, 59];
    }
    if (timestamp < 60) {
      return [0, 0]
    }
    // let _day = parseInt(timestamp / (24 * 3600)) || 0;
    let _h = parseInt((timestamp - _day * 24 * 3600) / 3600) || 0;
    let _m = parseInt((timestamp - _day * 24 * 3600 - _h * 3600) / 60) || 0;
    // _day, 
    return [_h, _m];
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  initTimes (data) {
    // 初始化天数
    // this.data.days = this.getArray(0, 31);
    // 初始化小时
    this.data.hours = this.getArray(0, 24);
    // 初始化分钟
    this.data.minutes = this.getArray(0, 60);
    // 默认选择的数据
    this.initCurrentDate(data);

    this.setData({
      // days: this.data.days,
      hours: this.data.hours,
      minutes: this.data.minutes
    })
  },
  initCurrentDate (value) {
    // 这里必须要用延迟
    setTimeout(() => {
      this.setData({
        current: value || [23, 59],
      });
    }, 0);
  },
  getArray (min = 0, max = 60) {
    let _array = [];
    for (let i = min; i < max; i++) {
      _array.push(i);
    }
    return _array
  },

  // 永久分享按钮改变事件
  switchLimit (e) {
    let _val = e.detail.value;
    let _index = e.currentTarget.dataset?.index || 0;
    this.updateLimitVal(_val, _index);
  },

  updateLimitVal (value, index) {
    // let _value = e.detail.value;
    this.data.items[index || 0].value = value || 0;
    this.setData({
      items: this.data.items
    })
  },

  bindChange (e) {
    let _vals = e.detail.value;
    console.log("bindChange _vals = ", _vals);

    // // 如果时长选择了0 0 0，则提示用户不可用选择
    // let _current = this.data.current;
    // if (_current[0] == 0 && _current[1] == 0) {
    //   // 需要更新默认的分钟数
    // }

    this.data.current = _vals || [];
    // 如果永久选中，则取消永久的选中
    // this.updateLimitVal(0);
  },

  save () {
    // let _qrTime = 0;
    // 未选中时取得时间戳
    let _current = this.data.current || [];
    // let _curTimestamp = _current.join(":");// _current[0] * 3600 + _current[1] * 60;
    // let _timestamp = (_curTimestamp ? _curTimestamp : 1);
    // _qrTime = _timestamp;
    // 等待条
    ability.showLoading({});
    // 取得当前时间
    let _localTimeJson = app.globalData.blsdk.getLocalTime();
    // 保存总的时间戳
    let _timeJson = app.globalData.tmpData.timerJson || {};
    let _list = _timeJson.schedInfoList.concat([]);
    Object.assign(_list[this.data.index], {
      repeat: Number(this.data.items[1].value),// 是否重复
      onoff: Number(this.data.items[0].value),// 开关灯
      hour: Number(_current[0]) || 0,
      min: Number(_current[1]) || 0,
      enable: 1, // 生效
    });
    // lctimer
    let _lctime = Object.assign({}, _timeJson.lctime, {
      hour: _localTimeJson.hour,
      min: _localTimeJson.min,
      week: _localTimeJson.day
    });
    console.log("save _lctime, _list = ", JSON.stringify(_lctime), JSON.stringify(_list));
    // 发送数据
    let _result = app.globalData.blsdk.setTimeListByDevInfo(app.globalData.devInfo, _list, _lctime);
    if (!_result || !_result.then) {
      // 等待条
      ability.hideLoading();
      return;
    }
    _result.then(e => {
      // 等待条
      ability.hideLoading();
      ability.showToast({
        title: "保存成功",
        icon: "success"
      })
      // app.globalData.tmpData.timerJson?.schedInfoList
      // 更新数据
      app.globalData.tmpData.timerJson.schedInfoList = _list;
      app.globalData.tmpData.timerJson.lctime = _lctime;
      // 延迟返回
      setTimeout(this.back, 1200);
    });
  },
  back () {
    // 返回上一个页面
    ability.navigateBack();
  }
})