// timer/list/index.js
import bizUtil from '../../utils/bizUtil'
import ability from '../../utils/classDef/ability'
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: [],
    timerJson: {}, // 取得的定时数据

    isUnload: false, // 是否已经退出该页面，定时列表获取有个延迟，防止退出后N秒后弹出定时获取失败

    roleNum: 0 // 角色
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // 取得定时数据
    this.data.roleNum = Number(options?.roleNum) || 0
    // this.getTimerList(true);
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 未退出页面
    this.data.isUnload = false;
    console.log("onShow app.globalData.tmpData.timerJson = ", app.globalData.tmpData.timerJson);
    // 如果没有定时数据，则获取
    if (!app.globalData.tmpData.timerJson) {
      // 取得定时数据
      this.getTimerList(true);
    } else {
      // 渲染
      this.initListByTimerJson(app.globalData.tmpData.timerJson);
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    // 退出页面
    this.data.isUnload = true;
    // this.destoryTmpData();
  },

  // 删除数据
  destoryTmpData () {
    app.globalData.tmpData.timerJson = undefined;
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  actionClick (e) {

    // 如果是控制权限，则只能查看
    if (this.data.roleNum == 2) {
      return ability.showToast({
        title: "当前权限只能查看"
      })
    }

    let {index} = e.detail;
    // 取得当前时间
    let _localTimeJson = app.globalData.blsdk.getLocalTime();
    // 保存总的时间戳
    let _timeJson = app.globalData.tmpData.timerJson || {};
    // 取得数据
    let _list = _timeJson.schedInfoList.concat([]);
    _list[index].enable = !_list[index].enable;
    // lctimer
    let _lctime = Object.assign({}, _timeJson.lctime, {
      hour: _localTimeJson.hour,
      min: _localTimeJson.min,
      week: _localTimeJson.day
    })
    // 发送数据
    let _result = app.globalData.blsdk.setTimeListByDevInfo(app.globalData.devInfo, _list, _lctime);
    if (!_result || !_result.then) {
      return;
    }
    _result.then(e => {
      // 更新数据
      app.globalData.tmpData.timerJson.schedInfoList = _list;
      app.globalData.tmpData.timerJson.lctime = _lctime;
      this.initListByTimerJson(app.globalData.tmpData.timerJson);
    });
  },
  itemClick (e) {

    // 如果是控制权限，则只能查看
    if (this.data.roleNum == 2) {
      return ability.showToast({
        title: "当前权限只能查看"
      })
    }

    // 下标
    let {index} = e.detail;
    // 跳转页面
    ability.navigateTo('../detail/index?index=' + index);
  },

  // 获取定时数据接口
  getTimerList (showLoading) {

    // 显示等待条
    !!showLoading && (ability.showLoading({}));

    app.globalData.blsdk.getTimeListByDevInfo(app.globalData.devInfo, (res) => {
      console.log("getTimerList res = ", res);

      // 如果退出了页面后面就不走
      if (this.data.isUnload) {
        return;
      }

      // 显示等待条
      !!showLoading && (ability.hideLoading());
      // 数据
      let {array, json} = res || {};
      if (!json) {
        !!showLoading && (ability.showToast({
          title: "定时获取失败"
        }));
        return;
      }
      // 赋值数据
      this.initListByTimerJson(app.globalData.tmpData.timerJson = json);
    })
  },
  initListByTimerJson (json) {
    // 保存定时数据
    let {schedInfoList} = json || {};

    console.log("initListByTimerJson schedInfoList = ", schedInfoList, json);

    // 列表数据
    if (!schedInfoList || schedInfoList.length == 0) {
      return;
    }
    let _result = [];
    // 赋值
    for (let i = 0, len = schedInfoList.length; i < len; i++) {
      let _obj = schedInfoList[i];
      _result.push({
        n: bizUtil.padStart(_obj.hour + "", 2) + ":" + bizUtil.padStart(_obj.min + "", 2),
        tip: (_obj.repeat ? '重复' : "单次") + " " + (_obj.onoff ? '开灯' : "关灯"),
        status: _obj.enable || 0
      })
    }
    // 更新数据
    this.setProperValue("list", _result);
  },
  setProperValue (key, value) {
    this.data[key] = value;
    this.setData({
      [key]: value || ""
    })
  }
})