module.exports = {
  curtain: {
    common: [43499], // 窗帘（通用需要手动设置行程）
    dream: [44113], // 梦幻帘 不需要主动设置限位
    open: [44111], // 开合帘 不需要主动设置限位
    role: [44112], // 卷帘
    arrays: [43096, 43499, 44113, 44111, 44112]
  },
  light: {
    // default: 43050,
    kw: [43049],
    krgbcw: [43050, 43956, 44235], // 43956 启明 44235:xiru0919
    kcw: [43051, 43957], // 43957 启明
    krgb: [43168],
    krgbw: [43169],
    kcwrgb: [43709], // 色温灯 + RGB辅灯
    kwcodewarm: [43745],
    xuancai: [], // 根据ability
    sixLight: [44235],
    arrays: [43049, 43050, 43051, 43168, 43169, 43709, 43754, 43745, 43759, 43956, 43957] // 43754负离子灯  43745调光调色灯 43759负离子调光灯
  },
  panel: {
    eight: [43734, 43733],
    six: [43459, 43461],
    three: [43462, 43463],
    four: [43472, 43473, 43680],
    two: [43474],
    one: [43525],
    // 是否继电器开关 43680 王老师添加
    pwrAvalible: [43525, 43462, 43463, 43474, 43680],
    // 非低功耗面板（低功耗需要唤醒） 43734 八键面板
    normal: [43473, 43461, 43734],
    // 所有面板集合
    arrays: [43459, 43461, 43462, 43463, 43472, 43473, 43474, 43525, 43680, 43733, 43734]
  },
  fanLight: {
    arrays: [43531] // 43531最早和ysl调试的 
  },
  gateway: {
    // ihg 有线和无线
    ihg: [10058],
    arrays: [43500, 10058]
  },
  uart: {
    // 超级面板 能力需要取后三个字节 是否需要唤醒根据ability
    abilityThree: [44199],
    // 继电器和灯的绑定数量是一样的 且是耦合设备
    pwrLight: [44199],
    // 非耦合 遥控器 设备 其他是耦合 44211且所有的版本都是ability
    uncouple: [44211],
    arrays: [43518, 43527, 43974, 44199, 44211] // 43518与超级面板共用一个固件版本，根据ability是否为零区分。如果为零，则是透传设备；否则为超级面板。
  },
  doorsensor: {
    arrays: [43505]
  },
  bodysensor: {
    arrays: [43516]
  },
  watersensor: {
    arrays: [43791]
  },
  aircondition: {
    // sub: [], // 子设备列表 当前无
    // host: [43756, 20010, 20933], // 空调主机列表
    // 所有设备列表
    arrays: [43756, 20010, 20933] // 20010, 20933 谢佳林
  },
  // 雷达传感器和人体传感器一样，只是一个强电，一个电池弱电  雷达不需要唤醒
  radarsensor: {
    // // 强电
    // electric: [43808],
    // // 弱电归属于bodysensor
    // weak: [43516],
    arrays: [43808]
  },
  // 温控器
  thermostat: {
    arrays: [43919]
  },
  // 风扇
  fan: {
    arrays: [44049] // 44049 新增风扇
  },
  // 双控设备品类
  virtualPanel: {
    arrays: [44063]
  },
  // 晾衣架
  coathanger: {
    arrays: [44007]
  },
  // 插卡取电设备 不需要唤醒
  powerPlug: {
    arrays: [43992]
  },
  // 电视氛围灯控制器 不需要唤醒
  tvLamp: {
    arrays: [43990]
  },
  // 温湿度计（秒秒测）
  temphumidity: {
    arrays: [43951] // 44274 beacon的温湿度计，小程序未支持
  },
  // 摄像头
  camera: {
    // 觅睿摄像头 44082
    arrays: [44082]
  },
  // 排插
  powerstrip: {
    six: [44166],
    five: [44165],
    four: [44164],
    three: [44167],
    two: [44180],
    one: [44181],
    arrays: [44166, 44165, 44164, 44167, 44180, 44181]
  },
  // sos 不需要唤醒
  sossensor: {
    // SOS报警器
    arrays: [44207] 
  },
  // 四键传感器情景面板（干接点蓝牙控制盒） 不需要唤醒
  panelsensor: {
    arrays: [44209]
  },
  // 通用电机
  commonMotor: {
    array: [44243]
  },

  // 根据品类取得名称
  getNameByPid (pid) {
    switch (pid) {
      case 43049:
        return '白灯'
      case 43050:
      case 43168:
      case 43169:
      case 43956:
        return '彩灯'
      case 43051:
      case 43957:
        return '色温灯'
      case 43709:
        return '彩光灯'
      case 43745:
        return '调光调色灯'  
      case 43096:
      case 43499:
        return '窗帘'
      case 43459:
      case 43461:
        return '六键情景面板'
      case 43734:
      case 43733:
        return '八键情景面板'
      case 43462:
      case 43463:
        return '三键开关面板'
      case 43472:
      case 43473:
        return '四键情景面板'
      case 43680:
        return '四键开关面板'
      case 43474:
        return '二键开关面板'
      case 43525:
        return '一键开关面板'
      case 43531:
        return '风扇灯'
      case 43500:
        return '网关'
      case 43505:
        return '门磁'
      case 43516:
        return '人体传感器'
      case 43808:
        return '雷达人体传感器'
      case 43754:
      case 43759:
        return '负离子调光灯'
      case 43518:
      case 43974:
      case 44199:
      case 43527:
      case 44211:
        return '超级面板'
      case 43791:
        return '水浸传感器'
      case 43756:
        return '中央空调网关'
      case 20933:
        return '柜机'
      case 20010:
        return '挂机'
      case 43919:
        return '温控器'
      case 44025: // 炫彩灯带pid
        return '炫彩灯带'
      case 10058: // ihg
        return 'IHG '
      case 44049: // 风扇
        return "风扇"
      case 44007: // 晾衣架
        return "晾衣架"
      case 43951: // 温湿度传感器
        return "温湿度计"
      case 43990: // 电视氛围灯控制器
        return "电视氛围灯控制器"
      case 44166:
      case 44165:
      case 44164:
      case 44167:
      case 44180:
        return '智能插排'
      case 44181:
        return '智能插座'
      case 44207:
        return 'SOS报警器'
      case 44209:
        return '干节点控制盒'
      case 44243:
        return "通用电机"
      case 44113:
        return "梦幻帘"
      case 44111: 
        return "开合帘"
      case 44112:
        return "卷帘"
      case 44235:
        return "六角灯"
      case 43992:
        return "插卡取电"
      default:
        return ''
    }
  },
}