module.exports = {
  "options": {
    "java_package": "com.broadlink.ble.fastcon.light",
    "java_outer_classname": "ShareDataModel"
  },
  "nested": {
    "ShareDataBean": {
      "fields": {
        "n": {
          "type": "string",
          "id": 1
        },
        "k": {
          "type": "string",
          "id": 2
        },
        "t": {
          "type": "uint32",
          "id": 3
        },
        "rs": {
          "rule": "repeated",
          "type": "RsBean",
          "id": 4
        },
        "v": {
          "type": "string",
          "id": 5
        },
        "ct": {
          "type": "uint32",
          "id": 6
        },
        "dt": {
          "type": "uint32",
          "id": 7
        },
        "p": {
          "type": "uint32",
          "id": 8
        },
        "sr": {
          "type": "string",
          "id": 9
        },
        "sid": {
          "type": "string",
          "id": 10
        },
        "skey": {
          "type": "string",
          "id": 11
        }
      }
    },
    "RsBean": {
      "fields": {
        "id": {
          "type": "uint32",
          "id": 1
        },
        "n": {
          "type": "string",
          "id": 2
        },
        "devs": {
          "rule": "repeated",
          "type": "DevsBean",
          "id": 3
        },
        "scenes": {
          "rule": "repeated",
          "type": "RSceneBean",
          "id": 4
        },
        "se": {
          "type": "uint32",
          "id": 5
        },
        "groups": {
          "rule": "repeated",
          "type": "GroupBean",
          "id": 6
        }
      }
    },
    "DevsBean": {
      "fields": {
        "n": {
          "type": "string",
          "id": 1
        },
        "t": {
          "type": "uint32",
          "id": 2
        },
        "a": {
          "type": "uint32",
          "id": 3
        },
        "d": {
          "type": "string",
          "id": 4
        },
        "oa": {
          "type": "uint32",
          "id": 5
        },
        "or": {
          "type": "uint32",
          "id": 6
        },
        "v": {
          "type": "string",
          "id": 7
        },
        "ds": {
          "rule": "repeated",
          "type": "DSceneBean",
          "id": 8
        },
        "k": {
          "type": "string",
          "id": 9
        },
        "e": {
          "type": "string",
          "id": 10
        },
        "se": {
          "type": "uint32",
          "id": 11
        },
        "sub": {
          "type": "uint32",
          "id": 12
        },
        "wd": {
          "type": "string",
          "id": 13
        },
        "ig": {
          "type": "uint32",
          "id": 14
        }
      }
    },
    "DSceneBean": {
      "fields": {
        "sid": {
          "type": "uint32",
          "id": 1
        },
        "key": {
          "type": "int32", // 此处网关空调是-1 所以需要用int32
          "id": 2
        },
        "cmd": {
          "type": "string",
          "id": 3
        }
      }
    },
    "RSceneBean": {
      "fields": {
        "sid": {
          "type": "uint32",
          "id": 1
        },
        "rid": {
          "type": "uint32",
          "id": 2
        },
        "t": {
          "type": "uint32",
          "id": 3
        },
        "n": {
          "type": "string",
          "id": 4
        },
        "i": {
          "type": "string",
          "id": 5
        },
        "b": {
          "type": "uint32",
          "id": 6
        },
        "cmd": {
          "type": "string",
          "id": 7
        },
        "or": {
          "type": "uint32",
          "id": 8
        },
        "se": {
          "type": "uint32",
          "id": 9
        },
        "ig": {
          "type": "uint32",
          "id": 10
        }
      }
    },
    "GroupBean": {
      "fields": {
        "gid": {
          "type": "uint32",
          "id": 1
        },
        "rid": {
          "type": "uint32",
          "id": 2
        },
        "t": {
          "type": "uint32",
          "id": 3
        },
        "n": {
          "type": "string",
          "id": 4
        },
        "dids": {
          "rule": "repeated",
          "type": "string",
          "id": 5
        },
        "ig": {
          "type": "uint32",
          "id": 6
        }
      }
    }
  }
};